/* BudgieMenu.c generated by valac 0.56.3, the Vala compiler
 * generated from BudgieMenu.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2022 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "budgiemenuapplet.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "plugin.h"
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <libpeas/peas.h>

enum  {
	BUDGIE_MENU_0_PROPERTY,
	BUDGIE_MENU_NUM_PROPERTIES
};
static GParamSpec* budgie_menu_properties[BUDGIE_MENU_NUM_PROPERTIES];
enum  {
	BUDGIE_MENU_SETTINGS_0_PROPERTY,
	BUDGIE_MENU_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* budgie_menu_settings_properties[BUDGIE_MENU_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	BUDGIE_MENU_APPLET_0_PROPERTY,
	BUDGIE_MENU_APPLET_UUID_PROPERTY,
	BUDGIE_MENU_APPLET_NUM_PROPERTIES
};
static GParamSpec* budgie_menu_applet_properties[BUDGIE_MENU_APPLET_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _BudgieMenuSettingsPrivate {
	GtkSwitch* switch_menu_label;
	GtkSwitch* switch_menu_compact;
	GtkSwitch* switch_menu_headers;
	GtkSwitch* switch_menu_categories_hover;
	GtkEntry* entry_label;
	GtkEntry* entry_icon_pick;
	GtkButton* button_icon_pick;
	GSettings* settings;
};

struct _BudgieMenuAppletPrivate {
	GtkImage* img;
	GtkLabel* label;
	BudgiePanelPosition panel_position;
	gint pixel_size;
	BudgiePopoverManager* manager;
	gchar* _uuid;
};

static gpointer budgie_menu_parent_class = NULL;
static BudgiePluginIface * budgie_menu_budgie_plugin_parent_iface = NULL;
static GType budgie_menu_type_id = 0;
static gint BudgieMenuSettings_private_offset;
static gpointer budgie_menu_settings_parent_class = NULL;
static GType budgie_menu_settings_type_id = 0;
static gint BudgieMenuApplet_private_offset;
static gpointer budgie_menu_applet_parent_class = NULL;
static GType budgie_menu_applet_type_id = 0;

static BudgieApplet* budgie_menu_real_get_panel_widget (BudgiePlugin* base,
                                                 const gchar* uuid);
static void budgie_menu_settings_on_pick_click (BudgieMenuSettings* self);
static void _budgie_menu_settings_on_pick_click_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void budgie_menu_settings_finalize (GObject * obj);
static GtkWidget* budgie_menu_applet_real_get_settings_ui (BudgieApplet* base);
static gboolean budgie_menu_applet_real_supports_settings (BudgieApplet* base);
static void _budgie_menu_applet_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                                 const gchar* key,
                                                                 gpointer self);
static gboolean __lambda17_ (BudgieMenuApplet* self,
                      GdkEventButton* e);
static gboolean ___lambda17__gtk_widget_button_press_event (GtkWidget* _sender,
                                                     GdkEventButton* event,
                                                     gpointer self);
static void __lambda18_ (BudgieMenuApplet* self,
                  gint p,
                  gint i,
                  gint s);
static void ___lambda18__budgie_applet_panel_size_changed (BudgieApplet* _sender,
                                                    gint panel_size,
                                                    gint icon_size,
                                                    gint small_icon_size,
                                                    gpointer self);
static gboolean __lambda19_ (BudgieMenuApplet* self,
                      GdkEventKey* e);
static gboolean ___lambda19__gtk_widget_key_release_event (GtkWidget* _sender,
                                                    GdkEventKey* event,
                                                    gpointer self);
static void budgie_menu_applet_real_panel_position_changed (BudgieApplet* base,
                                                     BudgiePanelPosition position);
static void budgie_menu_applet_real_invoke_action (BudgieApplet* base,
                                            BudgiePanelAction action);
static void budgie_menu_applet_real_update_popovers (BudgieApplet* base,
                                              BudgiePopoverManager* manager);
static void budgie_menu_applet_finalize (GObject * obj);
static void _vala_budgie_menu_applet_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_budgie_menu_applet_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
GType category_button_register_type (GTypeModule * module);
GType menu_button_register_type (GTypeModule * module);
GType budgie_menu_window_register_type (GTypeModule * module);
GType icon_chooser_register_type (GTypeModule * module);

static BudgieApplet*
budgie_menu_real_get_panel_widget (BudgiePlugin* base,
                                   const gchar* uuid)
{
	BudgieMenu * self;
	BudgieMenuApplet* _tmp0_;
	BudgieApplet* result;
#line 13 "../src/applets/budgie-menu/BudgieMenu.vala"
	self = (BudgieMenu*) base;
#line 13 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 14 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp0_ = budgie_menu_applet_new (uuid);
#line 14 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_object_ref_sink (_tmp0_);
#line 14 "../src/applets/budgie-menu/BudgieMenu.vala"
	result = (BudgieApplet*) _tmp0_;
#line 14 "../src/applets/budgie-menu/BudgieMenu.vala"
	return result;
#line 147 "BudgieMenu.c"
}

BudgieMenu*
budgie_menu_construct (GType object_type)
{
	BudgieMenu * self = NULL;
#line 12 "../src/applets/budgie-menu/BudgieMenu.vala"
	self = (BudgieMenu*) g_object_new (object_type, NULL);
#line 12 "../src/applets/budgie-menu/BudgieMenu.vala"
	return self;
#line 158 "BudgieMenu.c"
}

BudgieMenu*
budgie_menu_new (void)
{
#line 12 "../src/applets/budgie-menu/BudgieMenu.vala"
	return budgie_menu_construct (TYPE_BUDGIE_MENU);
#line 166 "BudgieMenu.c"
}

static void
budgie_menu_class_init (BudgieMenuClass * klass,
                        gpointer klass_data)
{
#line 12 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_parent_class = g_type_class_peek_parent (klass);
#line 175 "BudgieMenu.c"
}

static void
budgie_menu_budgie_plugin_interface_init (BudgiePluginIface * iface,
                                          gpointer iface_data)
{
#line 12 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_budgie_plugin_parent_iface = g_type_interface_peek_parent (iface);
#line 12 "../src/applets/budgie-menu/BudgieMenu.vala"
	iface->get_panel_widget = (BudgieApplet* (*) (BudgiePlugin*, const gchar*)) budgie_menu_real_get_panel_widget;
#line 186 "BudgieMenu.c"
}

static void
budgie_menu_instance_init (BudgieMenu * self,
                           gpointer klass)
{
}

GType
budgie_menu_get_type (void)
{
	return budgie_menu_type_id;
}

GType
budgie_menu_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieMenu), 0, (GInstanceInitFunc) budgie_menu_instance_init, NULL };
	static const GInterfaceInfo budgie_plugin_info = { (GInterfaceInitFunc) budgie_menu_budgie_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	budgie_menu_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "BudgieMenu", &g_define_type_info, 0);
	g_type_module_add_interface (module, budgie_menu_type_id, budgie_plugin_get_type (), &budgie_plugin_info);
	return budgie_menu_type_id;
}

static inline gpointer
budgie_menu_settings_get_instance_private (BudgieMenuSettings* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieMenuSettings_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 44 "../src/applets/budgie-menu/BudgieMenu.vala"
	return self ? g_object_ref (self) : NULL;
#line 222 "BudgieMenu.c"
}

static void
_budgie_menu_settings_on_pick_click_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 52 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_settings_on_pick_click ((BudgieMenuSettings*) self);
#line 231 "BudgieMenu.c"
}

BudgieMenuSettings*
budgie_menu_settings_construct (GType object_type,
                                GSettings* settings)
{
	BudgieMenuSettings * self = NULL;
	GSettings* _tmp0_;
	GtkSwitch* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	GtkSwitch* _tmp4_;
	GtkEntry* _tmp5_;
	GtkEntry* _tmp6_;
	GtkButton* _tmp7_;
#line 43 "../src/applets/budgie-menu/BudgieMenu.vala"
	self = (BudgieMenuSettings*) g_object_new (object_type, NULL);
#line 44 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 44 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (self->priv->settings);
#line 44 "../src/applets/budgie-menu/BudgieMenu.vala"
	self->priv->settings = _tmp0_;
#line 45 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp1_ = self->priv->switch_menu_label;
#line 45 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_settings_bind (settings, "enable-menu-label", (GObject*) _tmp1_, "active", G_SETTINGS_BIND_DEFAULT);
#line 46 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp2_ = self->priv->switch_menu_compact;
#line 46 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_settings_bind (settings, "menu-compact", (GObject*) _tmp2_, "active", G_SETTINGS_BIND_DEFAULT);
#line 47 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp3_ = self->priv->switch_menu_headers;
#line 47 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_settings_bind (settings, "menu-headers", (GObject*) _tmp3_, "active", G_SETTINGS_BIND_DEFAULT);
#line 48 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp4_ = self->priv->switch_menu_categories_hover;
#line 48 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_settings_bind (settings, "menu-categories-hover", (GObject*) _tmp4_, "active", G_SETTINGS_BIND_DEFAULT);
#line 49 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp5_ = self->priv->entry_label;
#line 49 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_settings_bind (settings, "menu-label", (GObject*) _tmp5_, "text", G_SETTINGS_BIND_DEFAULT);
#line 50 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp6_ = self->priv->entry_icon_pick;
#line 50 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_settings_bind (settings, "menu-icon", (GObject*) _tmp6_, "text", G_SETTINGS_BIND_DEFAULT);
#line 52 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp7_ = self->priv->button_icon_pick;
#line 52 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_signal_connect_object (_tmp7_, "clicked", (GCallback) _budgie_menu_settings_on_pick_click_gtk_button_clicked, self, 0);
#line 43 "../src/applets/budgie-menu/BudgieMenu.vala"
	return self;
#line 285 "BudgieMenu.c"
}

BudgieMenuSettings*
budgie_menu_settings_new (GSettings* settings)
{
#line 43 "../src/applets/budgie-menu/BudgieMenu.vala"
	return budgie_menu_settings_construct (TYPE_BUDGIE_MENU_SETTINGS, settings);
#line 293 "BudgieMenu.c"
}

/**
 * Handle the icon picker
 */
static void
budgie_menu_settings_on_pick_click (BudgieMenuSettings* self)
{
	IconChooser* chooser = NULL;
	GtkWidget* _tmp0_;
	IconChooser* _tmp1_;
	gchar* response = NULL;
	IconChooser* _tmp2_;
	gchar* _tmp3_;
	IconChooser* _tmp4_;
	const gchar* _tmp5_;
#line 58 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 59 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp1_ = icon_chooser_new (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL);
#line 59 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_object_ref_sink (_tmp1_);
#line 59 "../src/applets/budgie-menu/BudgieMenu.vala"
	chooser = _tmp1_;
#line 60 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp2_ = chooser;
#line 60 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp3_ = icon_chooser_run (_tmp2_);
#line 60 "../src/applets/budgie-menu/BudgieMenu.vala"
	response = _tmp3_;
#line 61 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp4_ = chooser;
#line 61 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp4_);
#line 62 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp5_ = response;
#line 62 "../src/applets/budgie-menu/BudgieMenu.vala"
	if (_tmp5_ != NULL) {
#line 334 "BudgieMenu.c"
		GtkEntry* _tmp6_;
		const gchar* _tmp7_;
#line 63 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp6_ = self->priv->entry_icon_pick;
#line 63 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp7_ = response;
#line 63 "../src/applets/budgie-menu/BudgieMenu.vala"
		gtk_entry_set_text (_tmp6_, _tmp7_);
#line 343 "BudgieMenu.c"
	}
#line 58 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_free0 (response);
#line 58 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (chooser);
#line 349 "BudgieMenu.c"
}

static void
budgie_menu_settings_class_init (BudgieMenuSettingsClass * klass,
                                 gpointer klass_data)
{
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_settings_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_type_class_adjust_private_offset (klass, &BudgieMenuSettings_private_offset);
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_menu_settings_finalize;
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/solus-project/budgie-menu/settings.ui");
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "switch_menu_label", FALSE, BudgieMenuSettings_private_offset + G_STRUCT_OFFSET (BudgieMenuSettingsPrivate, switch_menu_label));
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "switch_menu_compact", FALSE, BudgieMenuSettings_private_offset + G_STRUCT_OFFSET (BudgieMenuSettingsPrivate, switch_menu_compact));
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "switch_menu_headers", FALSE, BudgieMenuSettings_private_offset + G_STRUCT_OFFSET (BudgieMenuSettingsPrivate, switch_menu_headers));
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "switch_menu_categories_hover", FALSE, BudgieMenuSettings_private_offset + G_STRUCT_OFFSET (BudgieMenuSettingsPrivate, switch_menu_categories_hover));
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "entry_label", FALSE, BudgieMenuSettings_private_offset + G_STRUCT_OFFSET (BudgieMenuSettingsPrivate, entry_label));
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "entry_icon_pick", FALSE, BudgieMenuSettings_private_offset + G_STRUCT_OFFSET (BudgieMenuSettingsPrivate, entry_icon_pick));
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_icon_pick", FALSE, BudgieMenuSettings_private_offset + G_STRUCT_OFFSET (BudgieMenuSettingsPrivate, button_icon_pick));
#line 378 "BudgieMenu.c"
}

static void
budgie_menu_settings_instance_init (BudgieMenuSettings * self,
                                    gpointer klass)
{
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	self->priv = budgie_menu_settings_get_instance_private (self);
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 389 "BudgieMenu.c"
}

static void
budgie_menu_settings_finalize (GObject * obj)
{
	BudgieMenuSettings * self;
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BUDGIE_MENU_SETTINGS, BudgieMenuSettings);
#line 41 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (self->priv->settings);
#line 19 "../src/applets/budgie-menu/BudgieMenu.vala"
	G_OBJECT_CLASS (budgie_menu_settings_parent_class)->finalize (obj);
#line 402 "BudgieMenu.c"
}

GType
budgie_menu_settings_get_type (void)
{
	return budgie_menu_settings_type_id;
}

GType
budgie_menu_settings_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieMenuSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_menu_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieMenuSettings), 0, (GInstanceInitFunc) budgie_menu_settings_instance_init, NULL };
	budgie_menu_settings_type_id = g_type_module_register_type (module, gtk_grid_get_type (), "BudgieMenuSettings", &g_define_type_info, 0);
	BudgieMenuSettings_private_offset = sizeof (BudgieMenuSettingsPrivate);
	return budgie_menu_settings_type_id;
}

static inline gpointer
budgie_menu_applet_get_instance_private (BudgieMenuApplet* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieMenuApplet_private_offset);
}

static GtkWidget*
budgie_menu_applet_real_get_settings_ui (BudgieApplet* base)
{
	BudgieMenuApplet * self;
	const gchar* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	BudgieMenuSettings* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* result;
#line 81 "../src/applets/budgie-menu/BudgieMenu.vala"
	self = (BudgieMenuApplet*) base;
#line 82 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp0_ = self->priv->_uuid;
#line 82 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp1_ = budgie_applet_get_applet_settings ((BudgieApplet*) self, _tmp0_);
#line 82 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp2_ = _tmp1_;
#line 82 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp3_ = budgie_menu_settings_new (_tmp2_);
#line 82 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_object_ref_sink (_tmp3_);
#line 82 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp4_ = (GtkWidget*) _tmp3_;
#line 82 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (_tmp2_);
#line 82 "../src/applets/budgie-menu/BudgieMenu.vala"
	result = _tmp4_;
#line 82 "../src/applets/budgie-menu/BudgieMenu.vala"
	return result;
#line 456 "BudgieMenu.c"
}

static gboolean
budgie_menu_applet_real_supports_settings (BudgieApplet* base)
{
	BudgieMenuApplet * self;
	gboolean result;
#line 85 "../src/applets/budgie-menu/BudgieMenu.vala"
	self = (BudgieMenuApplet*) base;
#line 86 "../src/applets/budgie-menu/BudgieMenu.vala"
	result = TRUE;
#line 86 "../src/applets/budgie-menu/BudgieMenu.vala"
	return result;
#line 470 "BudgieMenu.c"
}

static void
_budgie_menu_applet_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                            const gchar* key,
                                                            gpointer self)
{
#line 97 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_applet_on_settings_changed ((BudgieMenuApplet*) self, key);
#line 480 "BudgieMenu.c"
}

static gboolean
__lambda17_ (BudgieMenuApplet* self,
             GdkEventButton* e)
{
	BudgieMenuWindow* _tmp0_;
	gboolean result;
#line 120 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 121 "../src/applets/budgie-menu/BudgieMenu.vala"
	if (e->button != ((guint) 1)) {
#line 122 "../src/applets/budgie-menu/BudgieMenu.vala"
		result = GDK_EVENT_PROPAGATE;
#line 122 "../src/applets/budgie-menu/BudgieMenu.vala"
		return result;
#line 497 "BudgieMenu.c"
	}
#line 124 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp0_ = self->popover;
#line 124 "../src/applets/budgie-menu/BudgieMenu.vala"
	if (gtk_widget_get_visible ((GtkWidget*) _tmp0_)) {
#line 503 "BudgieMenu.c"
		BudgieMenuWindow* _tmp1_;
#line 125 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp1_ = self->popover;
#line 125 "../src/applets/budgie-menu/BudgieMenu.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 509 "BudgieMenu.c"
	} else {
		BudgieMenuWindow* _tmp2_;
		GtkWidget* _tmp3_;
		BudgiePopoverManager* _tmp4_;
		GtkToggleButton* _tmp5_;
#line 127 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp2_ = self->popover;
#line 127 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp3_ = gtk_bin_get_child ((GtkBin*) _tmp2_);
#line 127 "../src/applets/budgie-menu/BudgieMenu.vala"
		gtk_widget_show_all (_tmp3_);
#line 128 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp4_ = self->priv->manager;
#line 128 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp5_ = self->widget;
#line 128 "../src/applets/budgie-menu/BudgieMenu.vala"
		budgie_popover_manager_show_popover (_tmp4_, (GtkWidget*) _tmp5_);
#line 527 "BudgieMenu.c"
	}
#line 130 "../src/applets/budgie-menu/BudgieMenu.vala"
	result = GDK_EVENT_STOP;
#line 130 "../src/applets/budgie-menu/BudgieMenu.vala"
	return result;
#line 533 "BudgieMenu.c"
}

static gboolean
___lambda17__gtk_widget_button_press_event (GtkWidget* _sender,
                                            GdkEventButton* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda17_ ((BudgieMenuApplet*) self, event);
#line 120 "../src/applets/budgie-menu/BudgieMenu.vala"
	return result;
#line 545 "BudgieMenu.c"
}

static void
__lambda18_ (BudgieMenuApplet* self,
             gint p,
             gint i,
             gint s)
{
#line 148 "../src/applets/budgie-menu/BudgieMenu.vala"
	if (self->priv->pixel_size != i) {
#line 149 "../src/applets/budgie-menu/BudgieMenu.vala"
		self->priv->pixel_size = (gint) i;
#line 150 "../src/applets/budgie-menu/BudgieMenu.vala"
		budgie_menu_applet_on_settings_changed (self, "menu-icon");
#line 560 "BudgieMenu.c"
	}
}

static void
___lambda18__budgie_applet_panel_size_changed (BudgieApplet* _sender,
                                               gint panel_size,
                                               gint icon_size,
                                               gint small_icon_size,
                                               gpointer self)
{
#line 147 "../src/applets/budgie-menu/BudgieMenu.vala"
	__lambda18_ ((BudgieMenuApplet*) self, panel_size, icon_size, small_icon_size);
#line 573 "BudgieMenu.c"
}

static gboolean
__lambda19_ (BudgieMenuApplet* self,
             GdkEventKey* e)
{
	gboolean result;
#line 154 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 155 "../src/applets/budgie-menu/BudgieMenu.vala"
	if (e->keyval == GDK_KEY_Escape) {
#line 585 "BudgieMenu.c"
		BudgieMenuWindow* _tmp0_;
#line 156 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp0_ = self->popover;
#line 156 "../src/applets/budgie-menu/BudgieMenu.vala"
		gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 591 "BudgieMenu.c"
	}
#line 158 "../src/applets/budgie-menu/BudgieMenu.vala"
	result = GDK_EVENT_PROPAGATE;
#line 158 "../src/applets/budgie-menu/BudgieMenu.vala"
	return result;
#line 597 "BudgieMenu.c"
}

static gboolean
___lambda19__gtk_widget_key_release_event (GtkWidget* _sender,
                                           GdkEventKey* event,
                                           gpointer self)
{
	gboolean result;
	result = __lambda19_ ((BudgieMenuApplet*) self, event);
#line 154 "../src/applets/budgie-menu/BudgieMenu.vala"
	return result;
#line 609 "BudgieMenu.c"
}

BudgieMenuApplet*
budgie_menu_applet_construct (GType object_type,
                              const gchar* uuid)
{
	BudgieMenuApplet * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkToggleButton* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkBox* layout = NULL;
	GtkBox* _tmp7_;
	GtkImage* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkToggleButton* _tmp12_;
	GtkStyleContext* st = NULL;
	GtkToggleButton* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkStyleContext* _tmp15_;
	GSettings* _tmp16_;
	GtkToggleButton* _tmp17_;
	BudgieMenuWindow* _tmp18_;
	BudgieMenuWindow* _tmp19_;
	GtkToggleButton* _tmp20_;
	GtkToggleButton* _tmp21_;
	BudgieMenuWindow* _tmp22_;
	GtkWidget* _tmp23_;
	GtkToggleButton* _tmp24_;
	BudgieMenuWindow* _tmp25_;
#line 89 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 90 "../src/applets/budgie-menu/BudgieMenu.vala"
	self = (BudgieMenuApplet*) g_object_new (object_type, "uuid", uuid, NULL);
#line 92 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_applet_set_settings_schema ((BudgieApplet*) self, "com.solus-project.budgie-menu");
#line 93 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_applet_set_settings_prefix ((BudgieApplet*) self, "/com/solus-project/budgie-panel/instance/budgie-menu");
#line 95 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp0_ = budgie_applet_get_applet_settings ((BudgieApplet*) self, uuid);
#line 95 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (self->settings);
#line 95 "../src/applets/budgie-menu/BudgieMenu.vala"
	self->settings = _tmp0_;
#line 97 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp1_ = self->settings;
#line 97 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_signal_connect_object (_tmp1_, "changed", (GCallback) _budgie_menu_applet_on_settings_changed_g_settings_changed, self, 0);
#line 99 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp2_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 99 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_object_ref_sink (_tmp2_);
#line 99 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (self->widget);
#line 99 "../src/applets/budgie-menu/BudgieMenu.vala"
	self->widget = _tmp2_;
#line 100 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp3_ = self->widget;
#line 100 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_button_set_relief ((GtkButton*) _tmp3_, GTK_RELIEF_NONE);
#line 101 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name ("view-grid-symbolic", (GtkIconSize) GTK_ICON_SIZE_INVALID);
#line 101 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_object_ref_sink (_tmp4_);
#line 101 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (self->priv->img);
#line 101 "../src/applets/budgie-menu/BudgieMenu.vala"
	self->priv->img = _tmp4_;
#line 102 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp5_ = self->priv->img;
#line 102 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_image_set_pixel_size (_tmp5_, self->priv->pixel_size);
#line 103 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp6_ = self->priv->img;
#line 103 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp6_, TRUE);
#line 105 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp7_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 105 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_object_ref_sink (_tmp7_);
#line 105 "../src/applets/budgie-menu/BudgieMenu.vala"
	layout = _tmp7_;
#line 106 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp8_ = self->priv->img;
#line 106 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_box_pack_start (layout, (GtkWidget*) _tmp8_, TRUE, TRUE, (guint) 0);
#line 107 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new ("");
#line 107 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_object_ref_sink (_tmp9_);
#line 107 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (self->priv->label);
#line 107 "../src/applets/budgie-menu/BudgieMenu.vala"
	self->priv->label = _tmp9_;
#line 108 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp10_ = self->priv->label;
#line 108 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_START);
#line 109 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp11_ = self->priv->label;
#line 109 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_box_pack_start (layout, (GtkWidget*) _tmp11_, TRUE, TRUE, (guint) 3);
#line 111 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp12_ = self->widget;
#line 111 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) layout);
#line 114 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp13_ = self->widget;
#line 114 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
#line 114 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp15_ = _g_object_ref0 (_tmp14_);
#line 114 "../src/applets/budgie-menu/BudgieMenu.vala"
	st = _tmp15_;
#line 115 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_style_context_add_class (st, "budgie-menu-launcher");
#line 116 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_style_context_add_class (st, "panel-button");
#line 117 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp16_ = self->settings;
#line 117 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp17_ = self->widget;
#line 117 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp18_ = budgie_menu_window_new (_tmp16_, (GtkWidget*) _tmp17_);
#line 117 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_object_ref_sink (_tmp18_);
#line 117 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (self->popover);
#line 117 "../src/applets/budgie-menu/BudgieMenu.vala"
	self->popover = _tmp18_;
#line 118 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp19_ = self->popover;
#line 118 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp20_ = self->widget;
#line 118 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp19_, "visible", (GObject*) _tmp20_, "active", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 120 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp21_ = self->widget;
#line 120 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_signal_connect_object ((GtkWidget*) _tmp21_, "button-press-event", (GCallback) ___lambda17__gtk_widget_button_press_event, self, 0);
#line 133 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp22_ = self->popover;
#line 133 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp23_ = gtk_bin_get_child ((GtkBin*) _tmp22_);
#line 133 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_show_all (_tmp23_);
#line 135 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_object_set ((BudgieApplet*) self, "supported-actions", BUDGIE_PANEL_ACTION_MENU, NULL);
#line 137 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp24_ = self->widget;
#line 137 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp24_);
#line 138 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 139 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_set_valign ((GtkWidget*) layout, GTK_ALIGN_CENTER);
#line 140 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 141 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 142 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_applet_on_settings_changed (self, "enable-menu-label");
#line 143 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_applet_on_settings_changed (self, "menu-icon");
#line 144 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_applet_on_settings_changed (self, "menu-label");
#line 147 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_signal_connect_object ((BudgieApplet*) self, "panel-size-changed", (GCallback) ___lambda18__budgie_applet_panel_size_changed, self, 0);
#line 154 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp25_ = self->popover;
#line 154 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_signal_connect_object ((GtkWidget*) _tmp25_, "key-release-event", (GCallback) ___lambda19__gtk_widget_key_release_event, self, 0);
#line 89 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (st);
#line 89 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (layout);
#line 89 "../src/applets/budgie-menu/BudgieMenu.vala"
	return self;
#line 793 "BudgieMenu.c"
}

BudgieMenuApplet*
budgie_menu_applet_new (const gchar* uuid)
{
#line 89 "../src/applets/budgie-menu/BudgieMenu.vala"
	return budgie_menu_applet_construct (TYPE_BUDGIE_MENU_APPLET, uuid);
#line 801 "BudgieMenu.c"
}

static void
budgie_menu_applet_real_panel_position_changed (BudgieApplet* base,
                                                BudgiePanelPosition position)
{
	BudgieMenuApplet * self;
	gboolean _tmp0_ = FALSE;
	gboolean vertical = FALSE;
	gint _tmp1_ = 0;
	gint margin = 0;
	GtkLabel* _tmp2_;
#line 162 "../src/applets/budgie-menu/BudgieMenu.vala"
	self = (BudgieMenuApplet*) base;
#line 163 "../src/applets/budgie-menu/BudgieMenu.vala"
	self->priv->panel_position = position;
#line 164 "../src/applets/budgie-menu/BudgieMenu.vala"
	if (position == BUDGIE_PANEL_POSITION_LEFT) {
#line 164 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp0_ = TRUE;
#line 822 "BudgieMenu.c"
	} else {
#line 164 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp0_ = position == BUDGIE_PANEL_POSITION_RIGHT;
#line 826 "BudgieMenu.c"
	}
#line 164 "../src/applets/budgie-menu/BudgieMenu.vala"
	vertical = _tmp0_;
#line 165 "../src/applets/budgie-menu/BudgieMenu.vala"
	if (vertical) {
#line 165 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp1_ = 0;
#line 834 "BudgieMenu.c"
	} else {
#line 165 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp1_ = 3;
#line 838 "BudgieMenu.c"
	}
#line 165 "../src/applets/budgie-menu/BudgieMenu.vala"
	margin = _tmp1_;
#line 166 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp2_ = self->priv->label;
#line 166 "../src/applets/budgie-menu/BudgieMenu.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp2_, margin);
#line 167 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_applet_on_settings_changed (self, "enable-menu-label");
#line 848 "BudgieMenu.c"
}

static void
budgie_menu_applet_real_invoke_action (BudgieApplet* base,
                                       BudgiePanelAction action)
{
	BudgieMenuApplet * self;
#line 170 "../src/applets/budgie-menu/BudgieMenu.vala"
	self = (BudgieMenuApplet*) base;
#line 171 "../src/applets/budgie-menu/BudgieMenu.vala"
	if ((action & BUDGIE_PANEL_ACTION_MENU) != 0) {
#line 860 "BudgieMenu.c"
		BudgieMenuWindow* _tmp0_;
#line 172 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp0_ = self->popover;
#line 172 "../src/applets/budgie-menu/BudgieMenu.vala"
		if (gtk_widget_get_visible ((GtkWidget*) _tmp0_)) {
#line 866 "BudgieMenu.c"
			BudgieMenuWindow* _tmp1_;
#line 173 "../src/applets/budgie-menu/BudgieMenu.vala"
			_tmp1_ = self->popover;
#line 173 "../src/applets/budgie-menu/BudgieMenu.vala"
			gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 872 "BudgieMenu.c"
		} else {
			BudgieMenuWindow* _tmp2_;
			GtkWidget* _tmp3_;
			BudgiePopoverManager* _tmp4_;
			GtkToggleButton* _tmp5_;
#line 175 "../src/applets/budgie-menu/BudgieMenu.vala"
			_tmp2_ = self->popover;
#line 175 "../src/applets/budgie-menu/BudgieMenu.vala"
			_tmp3_ = gtk_bin_get_child ((GtkBin*) _tmp2_);
#line 175 "../src/applets/budgie-menu/BudgieMenu.vala"
			gtk_widget_show_all (_tmp3_);
#line 176 "../src/applets/budgie-menu/BudgieMenu.vala"
			_tmp4_ = self->priv->manager;
#line 176 "../src/applets/budgie-menu/BudgieMenu.vala"
			_tmp5_ = self->widget;
#line 176 "../src/applets/budgie-menu/BudgieMenu.vala"
			budgie_popover_manager_show_popover (_tmp4_, (GtkWidget*) _tmp5_);
#line 890 "BudgieMenu.c"
		}
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 911 "BudgieMenu.c"
}

void
budgie_menu_applet_on_settings_changed (BudgieMenuApplet* self,
                                        const gchar* key)
{
	gboolean should_show = FALSE;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 184 "../src/applets/budgie-menu/BudgieMenu.vala"
	static GQuark _tmp1_label0 = 0;
#line 184 "../src/applets/budgie-menu/BudgieMenu.vala"
	static GQuark _tmp1_label1 = 0;
#line 184 "../src/applets/budgie-menu/BudgieMenu.vala"
	static GQuark _tmp1_label2 = 0;
#line 927 "BudgieMenu.c"
	GError* _inner_error0_ = NULL;
#line 181 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_return_if_fail (self != NULL);
#line 181 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_return_if_fail (key != NULL);
#line 182 "../src/applets/budgie-menu/BudgieMenu.vala"
	should_show = TRUE;
#line 184 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp0_ = key;
#line 184 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 184 "../src/applets/budgie-menu/BudgieMenu.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("menu-icon")))) {
#line 184 "../src/applets/budgie-menu/BudgieMenu.vala"
		switch (0) {
#line 943 "BudgieMenu.c"
			default:
			{
				gchar* icon = NULL;
				GSettings* _tmp3_;
				gchar* _tmp4_;
				const gchar* _tmp5_;
				GtkImage* _tmp18_;
				GtkImage* _tmp19_;
#line 186 "../src/applets/budgie-menu/BudgieMenu.vala"
				_tmp3_ = self->settings;
#line 186 "../src/applets/budgie-menu/BudgieMenu.vala"
				_tmp4_ = g_settings_get_string (_tmp3_, key);
#line 186 "../src/applets/budgie-menu/BudgieMenu.vala"
				icon = _tmp4_;
#line 187 "../src/applets/budgie-menu/BudgieMenu.vala"
				_tmp5_ = icon;
#line 187 "../src/applets/budgie-menu/BudgieMenu.vala"
				if (string_contains (_tmp5_, "/")) {
#line 962 "BudgieMenu.c"
					{
						GdkPixbuf* pixbuf = NULL;
						const gchar* _tmp6_;
						GdkPixbuf* _tmp7_;
						GtkImage* _tmp8_;
						GdkPixbuf* _tmp9_;
						GdkPixbuf* _tmp10_;
						GdkPixbuf* _tmp11_;
#line 189 "../src/applets/budgie-menu/BudgieMenu.vala"
						_tmp6_ = icon;
#line 189 "../src/applets/budgie-menu/BudgieMenu.vala"
						_tmp7_ = gdk_pixbuf_new_from_file (_tmp6_, &_inner_error0_);
#line 189 "../src/applets/budgie-menu/BudgieMenu.vala"
						pixbuf = _tmp7_;
#line 189 "../src/applets/budgie-menu/BudgieMenu.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 979 "BudgieMenu.c"
							goto __catch0_g_error;
						}
#line 190 "../src/applets/budgie-menu/BudgieMenu.vala"
						_tmp8_ = self->priv->img;
#line 190 "../src/applets/budgie-menu/BudgieMenu.vala"
						_tmp9_ = pixbuf;
#line 190 "../src/applets/budgie-menu/BudgieMenu.vala"
						_tmp10_ = gdk_pixbuf_scale_simple (_tmp9_, self->priv->pixel_size, self->priv->pixel_size, GDK_INTERP_BILINEAR);
#line 190 "../src/applets/budgie-menu/BudgieMenu.vala"
						_tmp11_ = _tmp10_;
#line 190 "../src/applets/budgie-menu/BudgieMenu.vala"
						gtk_image_set_from_pixbuf (_tmp8_, _tmp11_);
#line 190 "../src/applets/budgie-menu/BudgieMenu.vala"
						_g_object_unref0 (_tmp11_);
#line 188 "../src/applets/budgie-menu/BudgieMenu.vala"
						_g_object_unref0 (pixbuf);
#line 996 "BudgieMenu.c"
					}
					goto __finally0;
					__catch0_g_error:
					{
						GError* e = NULL;
						GError* _tmp12_;
						const gchar* _tmp13_;
						GtkImage* _tmp14_;
#line 188 "../src/applets/budgie-menu/BudgieMenu.vala"
						e = _inner_error0_;
#line 188 "../src/applets/budgie-menu/BudgieMenu.vala"
						_inner_error0_ = NULL;
#line 192 "../src/applets/budgie-menu/BudgieMenu.vala"
						_tmp12_ = e;
#line 192 "../src/applets/budgie-menu/BudgieMenu.vala"
						_tmp13_ = _tmp12_->message;
#line 192 "../src/applets/budgie-menu/BudgieMenu.vala"
						g_warning ("BudgieMenu.vala:192: Failed to update Budgie Menu applet icon: %s", _tmp13_);
#line 193 "../src/applets/budgie-menu/BudgieMenu.vala"
						_tmp14_ = self->priv->img;
#line 193 "../src/applets/budgie-menu/BudgieMenu.vala"
						gtk_image_set_from_icon_name (_tmp14_, "view-grid-symbolic", (GtkIconSize) GTK_ICON_SIZE_INVALID);
#line 188 "../src/applets/budgie-menu/BudgieMenu.vala"
						_g_error_free0 (e);
#line 1021 "BudgieMenu.c"
					}
					__finally0:
#line 188 "../src/applets/budgie-menu/BudgieMenu.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "../src/applets/budgie-menu/BudgieMenu.vala"
						_g_free0 (icon);
#line 188 "../src/applets/budgie-menu/BudgieMenu.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 188 "../src/applets/budgie-menu/BudgieMenu.vala"
						g_clear_error (&_inner_error0_);
#line 188 "../src/applets/budgie-menu/BudgieMenu.vala"
						return;
#line 1034 "BudgieMenu.c"
					}
				} else {
					const gchar* _tmp15_;
#line 195 "../src/applets/budgie-menu/BudgieMenu.vala"
					_tmp15_ = icon;
#line 195 "../src/applets/budgie-menu/BudgieMenu.vala"
					if (g_strcmp0 (_tmp15_, "") == 0) {
#line 196 "../src/applets/budgie-menu/BudgieMenu.vala"
						should_show = FALSE;
#line 1044 "BudgieMenu.c"
					} else {
						GtkImage* _tmp16_;
						const gchar* _tmp17_;
#line 198 "../src/applets/budgie-menu/BudgieMenu.vala"
						_tmp16_ = self->priv->img;
#line 198 "../src/applets/budgie-menu/BudgieMenu.vala"
						_tmp17_ = icon;
#line 198 "../src/applets/budgie-menu/BudgieMenu.vala"
						gtk_image_set_from_icon_name (_tmp16_, _tmp17_, (GtkIconSize) GTK_ICON_SIZE_INVALID);
#line 1054 "BudgieMenu.c"
					}
				}
#line 200 "../src/applets/budgie-menu/BudgieMenu.vala"
				_tmp18_ = self->priv->img;
#line 200 "../src/applets/budgie-menu/BudgieMenu.vala"
				gtk_image_set_pixel_size (_tmp18_, self->priv->pixel_size);
#line 201 "../src/applets/budgie-menu/BudgieMenu.vala"
				_tmp19_ = self->priv->img;
#line 201 "../src/applets/budgie-menu/BudgieMenu.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp19_, should_show);
#line 202 "../src/applets/budgie-menu/BudgieMenu.vala"
				_g_free0 (icon);
#line 202 "../src/applets/budgie-menu/BudgieMenu.vala"
				break;
#line 1069 "BudgieMenu.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("menu-label")))) {
#line 184 "../src/applets/budgie-menu/BudgieMenu.vala"
		switch (0) {
#line 1075 "BudgieMenu.c"
			default:
			{
				GtkLabel* _tmp20_;
				GSettings* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
#line 204 "../src/applets/budgie-menu/BudgieMenu.vala"
				_tmp20_ = self->priv->label;
#line 204 "../src/applets/budgie-menu/BudgieMenu.vala"
				_tmp21_ = self->settings;
#line 204 "../src/applets/budgie-menu/BudgieMenu.vala"
				_tmp22_ = g_settings_get_string (_tmp21_, key);
#line 204 "../src/applets/budgie-menu/BudgieMenu.vala"
				_tmp23_ = _tmp22_;
#line 204 "../src/applets/budgie-menu/BudgieMenu.vala"
				gtk_label_set_label (_tmp20_, _tmp23_);
#line 204 "../src/applets/budgie-menu/BudgieMenu.vala"
				_g_free0 (_tmp23_);
#line 205 "../src/applets/budgie-menu/BudgieMenu.vala"
				break;
#line 1096 "BudgieMenu.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("enable-menu-label")))) {
#line 184 "../src/applets/budgie-menu/BudgieMenu.vala"
		switch (0) {
#line 1102 "BudgieMenu.c"
			default:
			{
				gboolean _tmp24_ = FALSE;
				gboolean _tmp25_ = FALSE;
				gboolean visible = FALSE;
				GtkLabel* _tmp27_;
#line 207 "../src/applets/budgie-menu/BudgieMenu.vala"
				if (self->priv->panel_position == BUDGIE_PANEL_POSITION_TOP) {
#line 207 "../src/applets/budgie-menu/BudgieMenu.vala"
					_tmp25_ = TRUE;
#line 1113 "BudgieMenu.c"
				} else {
#line 208 "../src/applets/budgie-menu/BudgieMenu.vala"
					_tmp25_ = self->priv->panel_position == BUDGIE_PANEL_POSITION_BOTTOM;
#line 1117 "BudgieMenu.c"
				}
#line 207 "../src/applets/budgie-menu/BudgieMenu.vala"
				if (_tmp25_) {
#line 1121 "BudgieMenu.c"
					GSettings* _tmp26_;
#line 209 "../src/applets/budgie-menu/BudgieMenu.vala"
					_tmp26_ = self->settings;
#line 209 "../src/applets/budgie-menu/BudgieMenu.vala"
					_tmp24_ = g_settings_get_boolean (_tmp26_, key);
#line 1127 "BudgieMenu.c"
				} else {
#line 207 "../src/applets/budgie-menu/BudgieMenu.vala"
					_tmp24_ = FALSE;
#line 1131 "BudgieMenu.c"
				}
#line 207 "../src/applets/budgie-menu/BudgieMenu.vala"
				visible = _tmp24_;
#line 210 "../src/applets/budgie-menu/BudgieMenu.vala"
				_tmp27_ = self->priv->label;
#line 210 "../src/applets/budgie-menu/BudgieMenu.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp27_, visible);
#line 211 "../src/applets/budgie-menu/BudgieMenu.vala"
				break;
#line 1141 "BudgieMenu.c"
			}
		}
	} else {
#line 184 "../src/applets/budgie-menu/BudgieMenu.vala"
		switch (0) {
#line 1147 "BudgieMenu.c"
			default:
			{
#line 213 "../src/applets/budgie-menu/BudgieMenu.vala"
				break;
#line 1152 "BudgieMenu.c"
			}
		}
	}
}

static void
budgie_menu_applet_real_update_popovers (BudgieApplet* base,
                                         BudgiePopoverManager* manager)
{
	BudgieMenuApplet * self;
	GtkToggleButton* _tmp0_;
	BudgieMenuWindow* _tmp1_;
#line 217 "../src/applets/budgie-menu/BudgieMenu.vala"
	self = (BudgieMenuApplet*) base;
#line 218 "../src/applets/budgie-menu/BudgieMenu.vala"
	self->priv->manager = manager;
#line 219 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp0_ = self->widget;
#line 219 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp1_ = self->popover;
#line 219 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_popover_manager_register_popover (manager, (GtkWidget*) _tmp0_, (BudgiePopover*) _tmp1_);
#line 1175 "BudgieMenu.c"
}

const gchar*
budgie_menu_applet_get_uuid (BudgieMenuApplet* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 79 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp0_ = self->priv->_uuid;
#line 79 "../src/applets/budgie-menu/BudgieMenu.vala"
	result = _tmp0_;
#line 79 "../src/applets/budgie-menu/BudgieMenu.vala"
	return result;
#line 1191 "BudgieMenu.c"
}

void
budgie_menu_applet_set_uuid (BudgieMenuApplet* self,
                             const gchar* value)
{
	gchar* old_value;
#line 79 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/applets/budgie-menu/BudgieMenu.vala"
	old_value = budgie_menu_applet_get_uuid (self);
#line 79 "../src/applets/budgie-menu/BudgieMenu.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1205 "BudgieMenu.c"
		gchar* _tmp0_;
#line 79 "../src/applets/budgie-menu/BudgieMenu.vala"
		_tmp0_ = g_strdup (value);
#line 79 "../src/applets/budgie-menu/BudgieMenu.vala"
		_g_free0 (self->priv->_uuid);
#line 79 "../src/applets/budgie-menu/BudgieMenu.vala"
		self->priv->_uuid = _tmp0_;
#line 79 "../src/applets/budgie-menu/BudgieMenu.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_menu_applet_properties[BUDGIE_MENU_APPLET_UUID_PROPERTY]);
#line 1215 "BudgieMenu.c"
	}
}

static void
budgie_menu_applet_class_init (BudgieMenuAppletClass * klass,
                               gpointer klass_data)
{
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_applet_parent_class = g_type_class_peek_parent (klass);
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_type_class_adjust_private_offset (klass, &BudgieMenuApplet_private_offset);
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	((BudgieAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (BudgieApplet*)) budgie_menu_applet_real_get_settings_ui;
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	((BudgieAppletClass *) klass)->supports_settings = (gboolean (*) (BudgieApplet*)) budgie_menu_applet_real_supports_settings;
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	((BudgieAppletClass *) klass)->panel_position_changed = (void (*) (BudgieApplet*, BudgiePanelPosition)) budgie_menu_applet_real_panel_position_changed;
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	((BudgieAppletClass *) klass)->invoke_action = (void (*) (BudgieApplet*, BudgiePanelAction)) budgie_menu_applet_real_invoke_action;
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	((BudgieAppletClass *) klass)->update_popovers = (void (*) (BudgieApplet*, BudgiePopoverManager*)) budgie_menu_applet_real_update_popovers;
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_budgie_menu_applet_get_property;
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_budgie_menu_applet_set_property;
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_menu_applet_finalize;
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_MENU_APPLET_UUID_PROPERTY, budgie_menu_applet_properties[BUDGIE_MENU_APPLET_UUID_PROPERTY] = g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1245 "BudgieMenu.c"
}

static void
budgie_menu_applet_instance_init (BudgieMenuApplet * self,
                                  gpointer klass)
{
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	self->priv = budgie_menu_applet_get_instance_private (self);
#line 74 "../src/applets/budgie-menu/BudgieMenu.vala"
	self->priv->panel_position = BUDGIE_PANEL_POSITION_BOTTOM;
#line 75 "../src/applets/budgie-menu/BudgieMenu.vala"
	self->priv->pixel_size = 32;
#line 77 "../src/applets/budgie-menu/BudgieMenu.vala"
	self->priv->manager = NULL;
#line 1260 "BudgieMenu.c"
}

static void
budgie_menu_applet_finalize (GObject * obj)
{
	BudgieMenuApplet * self;
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BUDGIE_MENU_APPLET, BudgieMenuApplet);
#line 69 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (self->widget);
#line 70 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (self->popover);
#line 71 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (self->settings);
#line 72 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (self->priv->img);
#line 73 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (self->priv->label);
#line 79 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_free0 (self->priv->_uuid);
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	G_OBJECT_CLASS (budgie_menu_applet_parent_class)->finalize (obj);
#line 1283 "BudgieMenu.c"
}

GType
budgie_menu_applet_get_type (void)
{
	return budgie_menu_applet_type_id;
}

GType
budgie_menu_applet_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieMenuAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_menu_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieMenuApplet), 0, (GInstanceInitFunc) budgie_menu_applet_instance_init, NULL };
	budgie_menu_applet_type_id = g_type_module_register_type (module, budgie_applet_get_type (), "BudgieMenuApplet", &g_define_type_info, 0);
	BudgieMenuApplet_private_offset = sizeof (BudgieMenuAppletPrivate);
	return budgie_menu_applet_type_id;
}

static void
_vala_budgie_menu_applet_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	BudgieMenuApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BUDGIE_MENU_APPLET, BudgieMenuApplet);
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	switch (property_id) {
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
		case BUDGIE_MENU_APPLET_UUID_PROPERTY:
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
		g_value_set_string (value, budgie_menu_applet_get_uuid (self));
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
		break;
#line 1317 "BudgieMenu.c"
		default:
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
		break;
#line 1323 "BudgieMenu.c"
	}
}

static void
_vala_budgie_menu_applet_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	BudgieMenuApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BUDGIE_MENU_APPLET, BudgieMenuApplet);
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
	switch (property_id) {
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
		case BUDGIE_MENU_APPLET_UUID_PROPERTY:
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
		budgie_menu_applet_set_uuid (self, g_value_get_string (value));
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
		break;
#line 1343 "BudgieMenu.c"
		default:
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 68 "../src/applets/budgie-menu/BudgieMenu.vala"
		break;
#line 1349 "BudgieMenu.c"
	}
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* objmodule = NULL;
	PeasObjectModule* _tmp0_;
#line 224 "../src/applets/budgie-menu/BudgieMenu.vala"
	g_return_if_fail (module != NULL);
#line 224 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_register_type (module);
#line 224 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_settings_register_type (module);
#line 224 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_applet_register_type (module);
#line 224 "../src/applets/budgie-menu/BudgieMenu.vala"
	category_button_register_type (module);
#line 224 "../src/applets/budgie-menu/BudgieMenu.vala"
	menu_button_register_type (module);
#line 224 "../src/applets/budgie-menu/BudgieMenu.vala"
	budgie_menu_window_register_type (module);
#line 224 "../src/applets/budgie-menu/BudgieMenu.vala"
	icon_chooser_register_type (module);
#line 226 "../src/applets/budgie-menu/BudgieMenu.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
#line 226 "../src/applets/budgie-menu/BudgieMenu.vala"
	objmodule = _tmp0_;
#line 227 "../src/applets/budgie-menu/BudgieMenu.vala"
	peas_object_module_register_extension_type (objmodule, budgie_plugin_get_type (), TYPE_BUDGIE_MENU);
#line 224 "../src/applets/budgie-menu/BudgieMenu.vala"
	_g_object_unref0 (objmodule);
#line 1382 "BudgieMenu.c"
}

