/* ClockApplet.c generated by valac 0.56.3, the Vala compiler
 * generated from ClockApplet.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2014-2022 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "clockapplet.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "plugin.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <gio/gdesktopappinfo.h>
#include <libpeas/peas.h>

#define CLOCK_SETTINGS_SCHEMA "com.solus-project.clock"
#define GNOME_SETTINGS_SCHEMA "org.gnome.desktop.interface"

enum  {
	CLOCK_PLUGIN_0_PROPERTY,
	CLOCK_PLUGIN_NUM_PROPERTIES
};
static GParamSpec* clock_plugin_properties[CLOCK_PLUGIN_NUM_PROPERTIES];
enum  {
	CLOCK_APPLET_0_PROPERTY,
	CLOCK_APPLET_UUID_PROPERTY,
	CLOCK_APPLET_NUM_PROPERTIES
};
static GParamSpec* clock_applet_properties[CLOCK_APPLET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	CLOCK_SETTINGS_0_PROPERTY,
	CLOCK_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* clock_settings_properties[CLOCK_SETTINGS_NUM_PROPERTIES];

struct _ClockAppletPrivate {
	GDateTime* time;
	BudgiePopover* popover;
	GAppInfo* calprov;
	GtkButton* cal_button;
	GtkOrientation orient;
	BudgiePopoverManager* manager;
	gboolean clock_show_date;
	gboolean clock_show_seconds;
	gboolean clock_use_24_hour_time;
	gboolean clock_use_custom_format;
	gboolean clock_use_custom_timezone;
	gchar* clock_custom_format;
	GTimeZone* clock_timezone;
	gchar* _uuid;
};

struct _ClockSettingsPrivate {
	GtkSwitch* show_date;
	GtkSwitch* show_seconds;
	GtkSwitch* use_24_hour_time;
	GtkSwitch* use_custom_format;
	GtkEntry* custom_format;
	GtkSwitch* use_custom_timezone;
	GtkEntry* custom_timezone;
};

static gpointer clock_plugin_parent_class = NULL;
static BudgiePluginIface * clock_plugin_budgie_plugin_parent_iface = NULL;
static GType clock_plugin_type_id = 0;
static gint ClockApplet_private_offset;
static gpointer clock_applet_parent_class = NULL;
static GType clock_applet_type_id = 0;
static gint ClockSettings_private_offset;
static gpointer clock_settings_parent_class = NULL;
static GType clock_settings_type_id = 0;

static BudgieApplet* clock_plugin_real_get_panel_widget (BudgiePlugin* base,
                                                  const gchar* uuid);
static GtkButton* clock_applet_new_plain_button (ClockApplet* self,
                                          const gchar* label_str);
static void clock_applet_real_panel_position_changed (BudgieApplet* base,
                                               BudgiePanelPosition position);
static void clock_applet_on_date_activate (ClockApplet* self);
static void _clock_applet_on_date_activate_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void clock_applet_on_cal_activate (ClockApplet* self);
static void _clock_applet_on_cal_activate_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static gboolean __lambda4_ (ClockApplet* self,
                     GdkEventButton* e);
static gboolean ___lambda4__gtk_widget_button_press_event (GtkWidget* _sender,
                                                    GdkEventButton* event,
                                                    gpointer self);
static void clock_applet_update_setting (ClockApplet* self,
                                  const gchar* schema,
                                  const gchar* key);
static gboolean _clock_applet_update_clock_gsource_func (gpointer self);
static void __lambda5_ (ClockApplet* self,
                 const gchar* key);
static void ___lambda5__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static void __lambda6_ (ClockApplet* self,
                 const gchar* key);
static void ___lambda6__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static void clock_applet_update_cal (ClockApplet* self);
static void _clock_applet_update_cal_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                          gpointer self);
static void clock_applet_real_update_popovers (BudgieApplet* base,
                                        BudgiePopoverManager* manager);
static gboolean clock_applet_real_supports_settings (BudgieApplet* base);
static GtkWidget* clock_applet_real_get_settings_ui (BudgieApplet* base);
static void clock_applet_finalize (GObject * obj);
static void _vala_clock_applet_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_clock_applet_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static gboolean __lambda7_ (GValue* value,
                     GVariant* variant,
                     void* user_data);
static gboolean ___lambda7__gsettings_bind_get_mapping (GValue* value,
                                                 GVariant* variant,
                                                 void* user_data);
static GVariant* __lambda8_ (GValue* value,
                      const GVariantType* expected_type,
                      void* user_data);
static GVariant* ___lambda8__gsettings_bind_set_mapping (GValue* value,
                                                  const GVariantType* expected_type,
                                                  void* user_data);
static void clock_settings_updateSensitve (ClockSettings* self);
static void _clock_settings_updateSensitve_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void clock_settings_finalize (GObject * obj);

static BudgieApplet*
clock_plugin_real_get_panel_widget (BudgiePlugin* base,
                                    const gchar* uuid)
{
	ClockPlugin * self;
	ClockApplet* _tmp0_;
	BudgieApplet* result;
#line 13 "../src/applets/clock/ClockApplet.vala"
	self = (ClockPlugin*) base;
#line 13 "../src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 14 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = clock_applet_new (uuid);
#line 14 "../src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp0_);
#line 14 "../src/applets/clock/ClockApplet.vala"
	result = (BudgieApplet*) _tmp0_;
#line 14 "../src/applets/clock/ClockApplet.vala"
	return result;
#line 175 "ClockApplet.c"
}

ClockPlugin*
clock_plugin_construct (GType object_type)
{
	ClockPlugin * self = NULL;
#line 12 "../src/applets/clock/ClockApplet.vala"
	self = (ClockPlugin*) g_object_new (object_type, NULL);
#line 12 "../src/applets/clock/ClockApplet.vala"
	return self;
#line 186 "ClockApplet.c"
}

ClockPlugin*
clock_plugin_new (void)
{
#line 12 "../src/applets/clock/ClockApplet.vala"
	return clock_plugin_construct (TYPE_CLOCK_PLUGIN);
#line 194 "ClockApplet.c"
}

static void
clock_plugin_class_init (ClockPluginClass * klass,
                         gpointer klass_data)
{
#line 12 "../src/applets/clock/ClockApplet.vala"
	clock_plugin_parent_class = g_type_class_peek_parent (klass);
#line 203 "ClockApplet.c"
}

static void
clock_plugin_budgie_plugin_interface_init (BudgiePluginIface * iface,
                                           gpointer iface_data)
{
#line 12 "../src/applets/clock/ClockApplet.vala"
	clock_plugin_budgie_plugin_parent_iface = g_type_interface_peek_parent (iface);
#line 12 "../src/applets/clock/ClockApplet.vala"
	iface->get_panel_widget = (BudgieApplet* (*) (BudgiePlugin*, const gchar*)) clock_plugin_real_get_panel_widget;
#line 214 "ClockApplet.c"
}

static void
clock_plugin_instance_init (ClockPlugin * self,
                            gpointer klass)
{
}

GType
clock_plugin_get_type (void)
{
	return clock_plugin_type_id;
}

GType
clock_plugin_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClockPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClockPlugin), 0, (GInstanceInitFunc) clock_plugin_instance_init, NULL };
	static const GInterfaceInfo budgie_plugin_info = { (GInterfaceInitFunc) clock_plugin_budgie_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	clock_plugin_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "ClockPlugin", &g_define_type_info, 0);
	g_type_module_add_interface (module, clock_plugin_type_id, budgie_plugin_get_type (), &budgie_plugin_info);
	return clock_plugin_type_id;
}

static inline gpointer
clock_applet_get_instance_private (ClockApplet* self)
{
	return G_STRUCT_MEMBER_P (self, ClockApplet_private_offset);
}

static GtkButton*
clock_applet_new_plain_button (ClockApplet* self,
                               const gchar* label_str)
{
	GtkButton* ret = NULL;
	GtkButton* _tmp0_;
	GtkWidget* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkButton* result;
#line 52 "../src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (label_str != NULL, NULL);
#line 53 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_with_label (label_str);
#line 53 "../src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp0_);
#line 53 "../src/applets/clock/ClockApplet.vala"
	ret = _tmp0_;
#line 54 "../src/applets/clock/ClockApplet.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) ret);
#line 54 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_halign (_tmp1_, GTK_ALIGN_START);
#line 55 "../src/applets/clock/ClockApplet.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) ret);
#line 55 "../src/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp2_, GTK_STYLE_CLASS_FLAT);
#line 56 "../src/applets/clock/ClockApplet.vala"
	result = ret;
#line 56 "../src/applets/clock/ClockApplet.vala"
	return result;
#line 276 "ClockApplet.c"
}

static void
clock_applet_real_panel_position_changed (BudgieApplet* base,
                                          BudgiePanelPosition position)
{
	ClockApplet * self;
	gboolean _tmp0_ = FALSE;
	GtkLabel* _tmp5_;
	GtkBox* _tmp6_;
#line 60 "../src/applets/clock/ClockApplet.vala"
	self = (ClockApplet*) base;
#line 61 "../src/applets/clock/ClockApplet.vala"
	if (position == BUDGIE_PANEL_POSITION_LEFT) {
#line 61 "../src/applets/clock/ClockApplet.vala"
		_tmp0_ = TRUE;
#line 293 "ClockApplet.c"
	} else {
#line 61 "../src/applets/clock/ClockApplet.vala"
		_tmp0_ = position == BUDGIE_PANEL_POSITION_RIGHT;
#line 297 "ClockApplet.c"
	}
#line 61 "../src/applets/clock/ClockApplet.vala"
	if (_tmp0_) {
#line 301 "ClockApplet.c"
		GtkLabel* _tmp1_;
		GtkLabel* _tmp2_;
#line 62 "../src/applets/clock/ClockApplet.vala"
		self->priv->orient = GTK_ORIENTATION_VERTICAL;
#line 63 "../src/applets/clock/ClockApplet.vala"
		_tmp1_ = self->clock_label;
#line 63 "../src/applets/clock/ClockApplet.vala"
		gtk_label_set_line_wrap (_tmp1_, TRUE);
#line 64 "../src/applets/clock/ClockApplet.vala"
		_tmp2_ = self->clock_label;
#line 64 "../src/applets/clock/ClockApplet.vala"
		gtk_label_set_max_width_chars (_tmp2_, 1);
#line 314 "ClockApplet.c"
	} else {
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
#line 66 "../src/applets/clock/ClockApplet.vala"
		self->priv->orient = GTK_ORIENTATION_HORIZONTAL;
#line 67 "../src/applets/clock/ClockApplet.vala"
		_tmp3_ = self->clock_label;
#line 67 "../src/applets/clock/ClockApplet.vala"
		gtk_label_set_line_wrap (_tmp3_, FALSE);
#line 68 "../src/applets/clock/ClockApplet.vala"
		_tmp4_ = self->clock_label;
#line 68 "../src/applets/clock/ClockApplet.vala"
		gtk_label_set_max_width_chars (_tmp4_, -1);
#line 328 "ClockApplet.c"
	}
#line 70 "../src/applets/clock/ClockApplet.vala"
	_tmp5_ = self->seconds_label;
#line 70 "../src/applets/clock/ClockApplet.vala"
	gtk_label_set_text (_tmp5_, "");
#line 71 "../src/applets/clock/ClockApplet.vala"
	_tmp6_ = self->layout;
#line 71 "../src/applets/clock/ClockApplet.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp6_, self->priv->orient);
#line 72 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_clock (self);
#line 340 "ClockApplet.c"
}

static void
_clock_applet_on_date_activate_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 127 "../src/applets/clock/ClockApplet.vala"
	clock_applet_on_date_activate ((ClockApplet*) self);
#line 349 "ClockApplet.c"
}

static void
_clock_applet_on_cal_activate_gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 128 "../src/applets/clock/ClockApplet.vala"
	clock_applet_on_cal_activate ((ClockApplet*) self);
#line 358 "ClockApplet.c"
}

static gboolean
__lambda4_ (ClockApplet* self,
            GdkEventButton* e)
{
	BudgiePopover* _tmp0_;
	gboolean result;
#line 135 "../src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 136 "../src/applets/clock/ClockApplet.vala"
	if (e->button != ((guint) 1)) {
#line 137 "../src/applets/clock/ClockApplet.vala"
		result = GDK_EVENT_PROPAGATE;
#line 137 "../src/applets/clock/ClockApplet.vala"
		return result;
#line 375 "ClockApplet.c"
	}
#line 139 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->popover;
#line 139 "../src/applets/clock/ClockApplet.vala"
	if (gtk_widget_get_visible ((GtkWidget*) _tmp0_)) {
#line 381 "ClockApplet.c"
		BudgiePopover* _tmp1_;
#line 140 "../src/applets/clock/ClockApplet.vala"
		_tmp1_ = self->priv->popover;
#line 140 "../src/applets/clock/ClockApplet.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 387 "ClockApplet.c"
	} else {
		BudgiePopoverManager* _tmp2_;
		GtkEventBox* _tmp3_;
#line 142 "../src/applets/clock/ClockApplet.vala"
		_tmp2_ = self->priv->manager;
#line 142 "../src/applets/clock/ClockApplet.vala"
		_tmp3_ = self->widget;
#line 142 "../src/applets/clock/ClockApplet.vala"
		budgie_popover_manager_show_popover (_tmp2_, (GtkWidget*) _tmp3_);
#line 397 "ClockApplet.c"
	}
#line 144 "../src/applets/clock/ClockApplet.vala"
	result = GDK_EVENT_STOP;
#line 144 "../src/applets/clock/ClockApplet.vala"
	return result;
#line 403 "ClockApplet.c"
}

static gboolean
___lambda4__gtk_widget_button_press_event (GtkWidget* _sender,
                                           GdkEventButton* event,
                                           gpointer self)
{
	gboolean result;
	result = __lambda4_ ((ClockApplet*) self, event);
#line 135 "../src/applets/clock/ClockApplet.vala"
	return result;
#line 415 "ClockApplet.c"
}

static gboolean
_clock_applet_update_clock_gsource_func (gpointer self)
{
	gboolean result;
	result = clock_applet_update_clock ((ClockApplet*) self);
#line 159 "../src/applets/clock/ClockApplet.vala"
	return result;
#line 425 "ClockApplet.c"
}

static void
__lambda5_ (ClockApplet* self,
            const gchar* key)
{
#line 161 "../src/applets/clock/ClockApplet.vala"
	g_return_if_fail (key != NULL);
#line 162 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, key);
#line 163 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_clock (self);
#line 438 "ClockApplet.c"
}

static void
___lambda5__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
#line 161 "../src/applets/clock/ClockApplet.vala"
	__lambda5_ ((ClockApplet*) self, key);
#line 448 "ClockApplet.c"
}

static void
__lambda6_ (ClockApplet* self,
            const gchar* key)
{
#line 165 "../src/applets/clock/ClockApplet.vala"
	g_return_if_fail (key != NULL);
#line 166 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, GNOME_SETTINGS_SCHEMA, key);
#line 167 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_clock (self);
#line 461 "ClockApplet.c"
}

static void
___lambda6__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
#line 165 "../src/applets/clock/ClockApplet.vala"
	__lambda6_ ((ClockApplet*) self, key);
#line 471 "ClockApplet.c"
}

static void
_clock_applet_update_cal_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                     gpointer self)
{
#line 173 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_cal ((ClockApplet*) self);
#line 480 "ClockApplet.c"
}

ClockApplet*
clock_applet_construct (GType object_type,
                        const gchar* uuid)
{
	ClockApplet * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkEventBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkEventBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkBox* _tmp9_;
	GtkLabel* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkBox* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkBox* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkStyleContext* _tmp28_;
	GtkEventBox* _tmp29_;
	BudgiePopover* _tmp30_;
	GtkStack* stack = NULL;
	GtkStack* _tmp31_;
	GtkStyleContext* _tmp32_;
	BudgiePopover* _tmp33_;
	GtkBox* menu = NULL;
	GtkBox* _tmp34_;
	GtkButton* time_button = NULL;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkButton* _tmp37_;
	GtkButton* _tmp38_;
	GtkEventBox* _tmp39_;
	GtkLabel* _tmp40_;
	GtkLabel* _tmp41_;
	GSettings* _tmp42_;
	GSettings* _tmp43_;
	GAppInfo* _tmp44_;
	GAppInfoMonitor* monitor = NULL;
	GAppInfoMonitor* _tmp45_;
	GtkButton* _tmp46_;
	GAppInfo* _tmp47_;
	GtkButton* _tmp48_;
	GtkEventBox* _tmp49_;
	BudgiePopover* _tmp50_;
	GtkWidget* _tmp51_;
#line 75 "../src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 76 "../src/applets/clock/ClockApplet.vala"
	self = (ClockApplet*) g_object_new (object_type, "uuid", uuid, NULL);
#line 78 "../src/applets/clock/ClockApplet.vala"
	budgie_applet_set_settings_schema ((BudgieApplet*) self, CLOCK_SETTINGS_SCHEMA);
#line 79 "../src/applets/clock/ClockApplet.vala"
	budgie_applet_set_settings_prefix ((BudgieApplet*) self, "/com/solus-project/clock/instance/clock");
#line 81 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = budgie_applet_get_applet_settings ((BudgieApplet*) self, uuid);
#line 81 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->settings);
#line 81 "../src/applets/clock/ClockApplet.vala"
	self->settings = _tmp0_;
#line 82 "../src/applets/clock/ClockApplet.vala"
	_tmp1_ = g_settings_new (GNOME_SETTINGS_SCHEMA);
#line 82 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->gnome_settings);
#line 82 "../src/applets/clock/ClockApplet.vala"
	self->gnome_settings = _tmp1_;
#line 84 "../src/applets/clock/ClockApplet.vala"
	_tmp2_ = (GtkEventBox*) gtk_event_box_new ();
#line 84 "../src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp2_);
#line 84 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->widget);
#line 84 "../src/applets/clock/ClockApplet.vala"
	self->widget = _tmp2_;
#line 85 "../src/applets/clock/ClockApplet.vala"
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 2);
#line 85 "../src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp3_);
#line 85 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->layout);
#line 85 "../src/applets/clock/ClockApplet.vala"
	self->layout = _tmp3_;
#line 86 "../src/applets/clock/ClockApplet.vala"
	_tmp4_ = self->widget;
#line 86 "../src/applets/clock/ClockApplet.vala"
	_tmp5_ = self->layout;
#line 86 "../src/applets/clock/ClockApplet.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 88 "../src/applets/clock/ClockApplet.vala"
	_tmp6_ = (GtkLabel*) gtk_label_new ("");
#line 88 "../src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp6_);
#line 88 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->clock_label);
#line 88 "../src/applets/clock/ClockApplet.vala"
	self->clock_label = _tmp6_;
#line 89 "../src/applets/clock/ClockApplet.vala"
	_tmp7_ = self->clock_label;
#line 89 "../src/applets/clock/ClockApplet.vala"
	gtk_label_set_line_wrap (_tmp7_, TRUE);
#line 90 "../src/applets/clock/ClockApplet.vala"
	_tmp8_ = self->clock_label;
#line 90 "../src/applets/clock/ClockApplet.vala"
	gtk_label_set_justify (_tmp8_, GTK_JUSTIFY_CENTER);
#line 91 "../src/applets/clock/ClockApplet.vala"
	_tmp9_ = self->layout;
#line 91 "../src/applets/clock/ClockApplet.vala"
	_tmp10_ = self->clock_label;
#line 91 "../src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp9_, (GtkWidget*) _tmp10_, FALSE, FALSE, (guint) 0);
#line 92 "../src/applets/clock/ClockApplet.vala"
	_tmp11_ = self->layout;
#line 92 "../src/applets/clock/ClockApplet.vala"
	g_object_set ((GtkWidget*) _tmp11_, "margin", 0, NULL);
#line 93 "../src/applets/clock/ClockApplet.vala"
	_tmp12_ = self->layout;
#line 93 "../src/applets/clock/ClockApplet.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp12_, (guint) 0);
#line 95 "../src/applets/clock/ClockApplet.vala"
	_tmp13_ = (GtkLabel*) gtk_label_new ("");
#line 95 "../src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp13_);
#line 95 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->seconds_label);
#line 95 "../src/applets/clock/ClockApplet.vala"
	self->seconds_label = _tmp13_;
#line 96 "../src/applets/clock/ClockApplet.vala"
	_tmp14_ = self->seconds_label;
#line 96 "../src/applets/clock/ClockApplet.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 96 "../src/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp15_, "dim-label");
#line 97 "../src/applets/clock/ClockApplet.vala"
	_tmp16_ = self->layout;
#line 97 "../src/applets/clock/ClockApplet.vala"
	_tmp17_ = self->seconds_label;
#line 97 "../src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp16_, (GtkWidget*) _tmp17_, FALSE, FALSE, (guint) 0);
#line 98 "../src/applets/clock/ClockApplet.vala"
	_tmp18_ = self->seconds_label;
#line 98 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp18_, TRUE);
#line 99 "../src/applets/clock/ClockApplet.vala"
	_tmp19_ = self->seconds_label;
#line 99 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp19_);
#line 101 "../src/applets/clock/ClockApplet.vala"
	_tmp20_ = (GtkLabel*) gtk_label_new ("");
#line 101 "../src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp20_);
#line 101 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->date_label);
#line 101 "../src/applets/clock/ClockApplet.vala"
	self->date_label = _tmp20_;
#line 102 "../src/applets/clock/ClockApplet.vala"
	_tmp21_ = self->layout;
#line 102 "../src/applets/clock/ClockApplet.vala"
	_tmp22_ = self->date_label;
#line 102 "../src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp21_, (GtkWidget*) _tmp22_, FALSE, FALSE, (guint) 0);
#line 103 "../src/applets/clock/ClockApplet.vala"
	_tmp23_ = self->date_label;
#line 103 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp23_, TRUE);
#line 104 "../src/applets/clock/ClockApplet.vala"
	_tmp24_ = self->date_label;
#line 104 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp24_);
#line 106 "../src/applets/clock/ClockApplet.vala"
	_tmp25_ = self->clock_label;
#line 106 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp25_, GTK_ALIGN_CENTER);
#line 107 "../src/applets/clock/ClockApplet.vala"
	_tmp26_ = self->seconds_label;
#line 107 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp26_, GTK_ALIGN_CENTER);
#line 108 "../src/applets/clock/ClockApplet.vala"
	_tmp27_ = self->date_label;
#line 108 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp27_, GTK_ALIGN_CENTER);
#line 110 "../src/applets/clock/ClockApplet.vala"
	_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 110 "../src/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp28_, "budgie-clock-applet");
#line 113 "../src/applets/clock/ClockApplet.vala"
	_tmp29_ = self->widget;
#line 113 "../src/applets/clock/ClockApplet.vala"
	_tmp30_ = (BudgiePopover*) budgie_popover_new ((GtkWidget*) _tmp29_);
#line 113 "../src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp30_);
#line 113 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->popover);
#line 113 "../src/applets/clock/ClockApplet.vala"
	self->priv->popover = _tmp30_;
#line 115 "../src/applets/clock/ClockApplet.vala"
	_tmp31_ = (GtkStack*) gtk_stack_new ();
#line 115 "../src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp31_);
#line 115 "../src/applets/clock/ClockApplet.vala"
	stack = _tmp31_;
#line 116 "../src/applets/clock/ClockApplet.vala"
	_tmp32_ = gtk_widget_get_style_context ((GtkWidget*) stack);
#line 116 "../src/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp32_, "clock-applet-stack");
#line 118 "../src/applets/clock/ClockApplet.vala"
	_tmp33_ = self->priv->popover;
#line 118 "../src/applets/clock/ClockApplet.vala"
	gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) stack);
#line 119 "../src/applets/clock/ClockApplet.vala"
	gtk_stack_set_homogeneous (stack, TRUE);
#line 120 "../src/applets/clock/ClockApplet.vala"
	gtk_stack_set_transition_type (stack, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
#line 122 "../src/applets/clock/ClockApplet.vala"
	_tmp34_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 1);
#line 122 "../src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp34_);
#line 122 "../src/applets/clock/ClockApplet.vala"
	menu = _tmp34_;
#line 123 "../src/applets/clock/ClockApplet.vala"
	gtk_container_set_border_width ((GtkContainer*) menu, (guint) 6);
#line 125 "../src/applets/clock/ClockApplet.vala"
	_tmp35_ = clock_applet_new_plain_button (self, _ ("System time and date settings"));
#line 125 "../src/applets/clock/ClockApplet.vala"
	time_button = _tmp35_;
#line 126 "../src/applets/clock/ClockApplet.vala"
	_tmp36_ = clock_applet_new_plain_button (self, _ ("Calendar"));
#line 126 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->cal_button);
#line 126 "../src/applets/clock/ClockApplet.vala"
	self->priv->cal_button = _tmp36_;
#line 127 "../src/applets/clock/ClockApplet.vala"
	g_signal_connect_object (time_button, "clicked", (GCallback) _clock_applet_on_date_activate_gtk_button_clicked, self, 0);
#line 128 "../src/applets/clock/ClockApplet.vala"
	_tmp37_ = self->priv->cal_button;
#line 128 "../src/applets/clock/ClockApplet.vala"
	g_signal_connect_object (_tmp37_, "clicked", (GCallback) _clock_applet_on_cal_activate_gtk_button_clicked, self, 0);
#line 130 "../src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (menu, (GtkWidget*) time_button, FALSE, FALSE, (guint) 0);
#line 131 "../src/applets/clock/ClockApplet.vala"
	_tmp38_ = self->priv->cal_button;
#line 131 "../src/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (menu, (GtkWidget*) _tmp38_, FALSE, FALSE, (guint) 0);
#line 133 "../src/applets/clock/ClockApplet.vala"
	gtk_container_add ((GtkContainer*) stack, (GtkWidget*) menu);
#line 135 "../src/applets/clock/ClockApplet.vala"
	_tmp39_ = self->widget;
#line 135 "../src/applets/clock/ClockApplet.vala"
	g_signal_connect_object ((GtkWidget*) _tmp39_, "button-press-event", (GCallback) ___lambda4__gtk_widget_button_press_event, self, 0);
#line 148 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, "show-date");
#line 149 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, "show-seconds");
#line 150 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, GNOME_SETTINGS_SCHEMA, "clock-format");
#line 151 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, "use-custom-format");
#line 152 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, "custom-format");
#line 153 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, "use-custom-timezone");
#line 154 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, "custom-timezone");
#line 156 "../src/applets/clock/ClockApplet.vala"
	_tmp40_ = self->date_label;
#line 156 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp40_, self->priv->clock_show_date);
#line 157 "../src/applets/clock/ClockApplet.vala"
	_tmp41_ = self->seconds_label;
#line 157 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp41_, self->priv->clock_show_seconds);
#line 159 "../src/applets/clock/ClockApplet.vala"
	g_timeout_add_seconds_full (G_PRIORITY_LOW, (guint) 1, _clock_applet_update_clock_gsource_func, g_object_ref (self), g_object_unref);
#line 161 "../src/applets/clock/ClockApplet.vala"
	_tmp42_ = self->settings;
#line 161 "../src/applets/clock/ClockApplet.vala"
	g_signal_connect_object (_tmp42_, "changed", (GCallback) ___lambda5__g_settings_changed, self, 0);
#line 165 "../src/applets/clock/ClockApplet.vala"
	_tmp43_ = self->gnome_settings;
#line 165 "../src/applets/clock/ClockApplet.vala"
	g_signal_connect_object (_tmp43_, "changed", (GCallback) ___lambda6__g_settings_changed, self, 0);
#line 170 "../src/applets/clock/ClockApplet.vala"
	_tmp44_ = g_app_info_get_default_for_type (CALENDAR_MIME, FALSE);
#line 170 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->calprov);
#line 170 "../src/applets/clock/ClockApplet.vala"
	self->priv->calprov = _tmp44_;
#line 172 "../src/applets/clock/ClockApplet.vala"
	_tmp45_ = g_app_info_monitor_get ();
#line 172 "../src/applets/clock/ClockApplet.vala"
	monitor = _tmp45_;
#line 173 "../src/applets/clock/ClockApplet.vala"
	g_signal_connect_object (monitor, "changed", (GCallback) _clock_applet_update_cal_g_app_info_monitor_changed, self, 0);
#line 175 "../src/applets/clock/ClockApplet.vala"
	_tmp46_ = self->priv->cal_button;
#line 175 "../src/applets/clock/ClockApplet.vala"
	_tmp47_ = self->priv->calprov;
#line 175 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp46_, _tmp47_ != NULL);
#line 176 "../src/applets/clock/ClockApplet.vala"
	_tmp48_ = self->priv->cal_button;
#line 176 "../src/applets/clock/ClockApplet.vala"
	g_signal_connect_object (_tmp48_, "clicked", (GCallback) _clock_applet_on_cal_activate_gtk_button_clicked, self, 0);
#line 178 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_cal (self);
#line 180 "../src/applets/clock/ClockApplet.vala"
	_tmp49_ = self->widget;
#line 180 "../src/applets/clock/ClockApplet.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp49_);
#line 182 "../src/applets/clock/ClockApplet.vala"
	_tmp50_ = self->priv->popover;
#line 182 "../src/applets/clock/ClockApplet.vala"
	_tmp51_ = gtk_bin_get_child ((GtkBin*) _tmp50_);
#line 182 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_show_all (_tmp51_);
#line 184 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 75 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (monitor);
#line 75 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (time_button);
#line 75 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (menu);
#line 75 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (stack);
#line 75 "../src/applets/clock/ClockApplet.vala"
	return self;
#line 824 "ClockApplet.c"
}

ClockApplet*
clock_applet_new (const gchar* uuid)
{
#line 75 "../src/applets/clock/ClockApplet.vala"
	return clock_applet_construct (TYPE_CLOCK_APPLET, uuid);
#line 832 "ClockApplet.c"
}

static void
clock_applet_update_cal (ClockApplet* self)
{
	GAppInfo* _tmp0_;
	GtkButton* _tmp1_;
	GAppInfo* _tmp2_;
#line 187 "../src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = g_app_info_get_default_for_type (CALENDAR_MIME, FALSE);
#line 188 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->calprov);
#line 188 "../src/applets/clock/ClockApplet.vala"
	self->priv->calprov = _tmp0_;
#line 189 "../src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->cal_button;
#line 189 "../src/applets/clock/ClockApplet.vala"
	_tmp2_ = self->priv->calprov;
#line 189 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, _tmp2_ != NULL);
#line 855 "ClockApplet.c"
}

static void
clock_applet_on_date_activate (ClockApplet* self)
{
	BudgiePopover* _tmp0_;
	GDesktopAppInfo* app_info = NULL;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 192 "../src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->popover;
#line 193 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 194 "../src/applets/clock/ClockApplet.vala"
	_tmp1_ = g_desktop_app_info_new ("budgie-datetime-panel.desktop");
#line 194 "../src/applets/clock/ClockApplet.vala"
	app_info = _tmp1_;
#line 196 "../src/applets/clock/ClockApplet.vala"
	_tmp2_ = app_info;
#line 196 "../src/applets/clock/ClockApplet.vala"
	if (_tmp2_ == NULL) {
#line 197 "../src/applets/clock/ClockApplet.vala"
		_g_object_unref0 (app_info);
#line 197 "../src/applets/clock/ClockApplet.vala"
		return;
#line 884 "ClockApplet.c"
	}
	{
		GDesktopAppInfo* _tmp3_;
#line 200 "../src/applets/clock/ClockApplet.vala"
		_tmp3_ = app_info;
#line 200 "../src/applets/clock/ClockApplet.vala"
		g_app_info_launch ((GAppInfo*) _tmp3_, NULL, NULL, &_inner_error0_);
#line 200 "../src/applets/clock/ClockApplet.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 894 "ClockApplet.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 199 "../src/applets/clock/ClockApplet.vala"
		e = _inner_error0_;
#line 199 "../src/applets/clock/ClockApplet.vala"
		_inner_error0_ = NULL;
#line 202 "../src/applets/clock/ClockApplet.vala"
		_tmp4_ = e;
#line 202 "../src/applets/clock/ClockApplet.vala"
		_tmp5_ = _tmp4_->message;
#line 202 "../src/applets/clock/ClockApplet.vala"
		g_message ("ClockApplet.vala:202: Unable to launch budgie-datetime-panel.desktop: " \
"%s", _tmp5_);
#line 199 "../src/applets/clock/ClockApplet.vala"
		_g_error_free0 (e);
#line 916 "ClockApplet.c"
	}
	__finally0:
#line 199 "../src/applets/clock/ClockApplet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../src/applets/clock/ClockApplet.vala"
		_g_object_unref0 (app_info);
#line 199 "../src/applets/clock/ClockApplet.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 199 "../src/applets/clock/ClockApplet.vala"
		g_clear_error (&_inner_error0_);
#line 199 "../src/applets/clock/ClockApplet.vala"
		return;
#line 929 "ClockApplet.c"
	}
#line 192 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (app_info);
#line 933 "ClockApplet.c"
}

static void
clock_applet_on_cal_activate (ClockApplet* self)
{
	BudgiePopover* _tmp0_;
	GAppInfo* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 206 "../src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->popover;
#line 207 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 209 "../src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->calprov;
#line 209 "../src/applets/clock/ClockApplet.vala"
	if (_tmp1_ == NULL) {
#line 210 "../src/applets/clock/ClockApplet.vala"
		return;
#line 954 "ClockApplet.c"
	}
	{
		GAppInfo* _tmp2_;
#line 213 "../src/applets/clock/ClockApplet.vala"
		_tmp2_ = self->priv->calprov;
#line 213 "../src/applets/clock/ClockApplet.vala"
		g_app_info_launch (_tmp2_, NULL, NULL, &_inner_error0_);
#line 213 "../src/applets/clock/ClockApplet.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 964 "ClockApplet.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GAppInfo* _tmp3_;
		const gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 212 "../src/applets/clock/ClockApplet.vala"
		e = _inner_error0_;
#line 212 "../src/applets/clock/ClockApplet.vala"
		_inner_error0_ = NULL;
#line 215 "../src/applets/clock/ClockApplet.vala"
		_tmp3_ = self->priv->calprov;
#line 215 "../src/applets/clock/ClockApplet.vala"
		_tmp4_ = g_app_info_get_name (_tmp3_);
#line 215 "../src/applets/clock/ClockApplet.vala"
		_tmp5_ = e;
#line 215 "../src/applets/clock/ClockApplet.vala"
		_tmp6_ = _tmp5_->message;
#line 215 "../src/applets/clock/ClockApplet.vala"
		g_message ("ClockApplet.vala:215: Unable to launch %s: %s", _tmp4_, _tmp6_);
#line 212 "../src/applets/clock/ClockApplet.vala"
		_g_error_free0 (e);
#line 992 "ClockApplet.c"
	}
	__finally0:
#line 212 "../src/applets/clock/ClockApplet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 212 "../src/applets/clock/ClockApplet.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 212 "../src/applets/clock/ClockApplet.vala"
		g_clear_error (&_inner_error0_);
#line 212 "../src/applets/clock/ClockApplet.vala"
		return;
#line 1003 "ClockApplet.c"
	}
}

static void
clock_applet_real_update_popovers (BudgieApplet* base,
                                   BudgiePopoverManager* manager)
{
	ClockApplet * self;
	GtkEventBox* _tmp0_;
	BudgiePopover* _tmp1_;
#line 219 "../src/applets/clock/ClockApplet.vala"
	self = (ClockApplet*) base;
#line 220 "../src/applets/clock/ClockApplet.vala"
	self->priv->manager = manager;
#line 221 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->widget;
#line 221 "../src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->popover;
#line 221 "../src/applets/clock/ClockApplet.vala"
	budgie_popover_manager_register_popover (manager, (GtkWidget*) _tmp0_, _tmp1_);
#line 1024 "ClockApplet.c"
}

static GTimeZone*
vala_g_time_zone_new_identifier (const gchar* identifier,
                                 GError** error)
{
	GTimeZone* self;
	GError* _inner_error0_ = NULL;
#line 3342 "glib-2.0.vapi"
	self = (GTimeZone*) g_time_zone_new_identifier (identifier);
#line 3343 "glib-2.0.vapi"
	if (((GTimeZone*) self) == NULL) {
#line 1037 "ClockApplet.c"
		GError* _tmp0_;
#line 3344 "glib-2.0.vapi"
		_tmp0_ = g_error_new_literal (G_CONVERT_ERROR, G_CONVERT_ERROR_ILLEGAL_SEQUENCE, "Invalid identifier argument");
#line 3344 "glib-2.0.vapi"
		_inner_error0_ = _tmp0_;
#line 3344 "glib-2.0.vapi"
		g_propagate_error (error, _inner_error0_);
#line 3344 "glib-2.0.vapi"
		_g_time_zone_unref0 (self);
#line 3344 "glib-2.0.vapi"
		return NULL;
#line 1049 "ClockApplet.c"
	}
#line 3341 "glib-2.0.vapi"
	return self;
#line 1053 "ClockApplet.c"
}

static void
clock_applet_update_setting (ClockApplet* self,
                             const gchar* schema,
                             const gchar* key)
{
	GError* _inner_error0_ = NULL;
#line 224 "../src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 224 "../src/applets/clock/ClockApplet.vala"
	g_return_if_fail (schema != NULL);
#line 224 "../src/applets/clock/ClockApplet.vala"
	g_return_if_fail (key != NULL);
#line 225 "../src/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (schema, CLOCK_SETTINGS_SCHEMA) == 0) {
#line 1070 "ClockApplet.c"
		const gchar* _tmp0_;
		GQuark _tmp2_ = 0U;
#line 226 "../src/applets/clock/ClockApplet.vala"
		static GQuark _tmp1_label0 = 0;
#line 226 "../src/applets/clock/ClockApplet.vala"
		static GQuark _tmp1_label1 = 0;
#line 226 "../src/applets/clock/ClockApplet.vala"
		static GQuark _tmp1_label2 = 0;
#line 226 "../src/applets/clock/ClockApplet.vala"
		static GQuark _tmp1_label3 = 0;
#line 226 "../src/applets/clock/ClockApplet.vala"
		static GQuark _tmp1_label4 = 0;
#line 226 "../src/applets/clock/ClockApplet.vala"
		static GQuark _tmp1_label5 = 0;
#line 226 "../src/applets/clock/ClockApplet.vala"
		_tmp0_ = key;
#line 226 "../src/applets/clock/ClockApplet.vala"
		_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 226 "../src/applets/clock/ClockApplet.vala"
		if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("show-date")))) {
#line 226 "../src/applets/clock/ClockApplet.vala"
			switch (0) {
#line 1093 "ClockApplet.c"
				default:
				{
					GSettings* _tmp3_;
					GtkLabel* _tmp4_;
#line 228 "../src/applets/clock/ClockApplet.vala"
					_tmp3_ = self->settings;
#line 228 "../src/applets/clock/ClockApplet.vala"
					self->priv->clock_show_date = g_settings_get_boolean (_tmp3_, key);
#line 229 "../src/applets/clock/ClockApplet.vala"
					_tmp4_ = self->date_label;
#line 229 "../src/applets/clock/ClockApplet.vala"
					gtk_widget_set_visible ((GtkWidget*) _tmp4_, self->priv->clock_show_date);
#line 230 "../src/applets/clock/ClockApplet.vala"
					break;
#line 1108 "ClockApplet.c"
				}
			}
		} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("show-seconds")))) {
#line 226 "../src/applets/clock/ClockApplet.vala"
			switch (0) {
#line 1114 "ClockApplet.c"
				default:
				{
					GSettings* _tmp5_;
					GtkLabel* _tmp6_;
#line 232 "../src/applets/clock/ClockApplet.vala"
					_tmp5_ = self->settings;
#line 232 "../src/applets/clock/ClockApplet.vala"
					self->priv->clock_show_seconds = g_settings_get_boolean (_tmp5_, key);
#line 233 "../src/applets/clock/ClockApplet.vala"
					_tmp6_ = self->seconds_label;
#line 233 "../src/applets/clock/ClockApplet.vala"
					gtk_widget_set_visible ((GtkWidget*) _tmp6_, self->priv->clock_show_seconds);
#line 234 "../src/applets/clock/ClockApplet.vala"
					break;
#line 1129 "ClockApplet.c"
				}
			}
		} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("use-custom-format")))) {
#line 226 "../src/applets/clock/ClockApplet.vala"
			switch (0) {
#line 1135 "ClockApplet.c"
				default:
				{
					GSettings* _tmp7_;
#line 236 "../src/applets/clock/ClockApplet.vala"
					_tmp7_ = self->settings;
#line 236 "../src/applets/clock/ClockApplet.vala"
					self->priv->clock_use_custom_format = g_settings_get_boolean (_tmp7_, key);
#line 237 "../src/applets/clock/ClockApplet.vala"
					if (self->priv->clock_use_custom_format) {
#line 1145 "ClockApplet.c"
						GtkLabel* _tmp8_;
						GtkLabel* _tmp9_;
#line 238 "../src/applets/clock/ClockApplet.vala"
						_tmp8_ = self->date_label;
#line 238 "../src/applets/clock/ClockApplet.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp8_, FALSE);
#line 239 "../src/applets/clock/ClockApplet.vala"
						_tmp9_ = self->seconds_label;
#line 239 "../src/applets/clock/ClockApplet.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 1156 "ClockApplet.c"
					} else {
						GtkLabel* _tmp10_;
						GtkLabel* _tmp11_;
#line 241 "../src/applets/clock/ClockApplet.vala"
						_tmp10_ = self->date_label;
#line 241 "../src/applets/clock/ClockApplet.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp10_, self->priv->clock_show_date);
#line 242 "../src/applets/clock/ClockApplet.vala"
						_tmp11_ = self->seconds_label;
#line 242 "../src/applets/clock/ClockApplet.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp11_, self->priv->clock_show_seconds);
#line 1168 "ClockApplet.c"
					}
#line 244 "../src/applets/clock/ClockApplet.vala"
					break;
#line 1172 "ClockApplet.c"
				}
			}
		} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("custom-format")))) {
#line 226 "../src/applets/clock/ClockApplet.vala"
			switch (0) {
#line 1178 "ClockApplet.c"
				default:
				{
					GSettings* _tmp12_;
					gchar* _tmp13_;
#line 246 "../src/applets/clock/ClockApplet.vala"
					_tmp12_ = self->settings;
#line 246 "../src/applets/clock/ClockApplet.vala"
					_tmp13_ = g_settings_get_string (_tmp12_, key);
#line 246 "../src/applets/clock/ClockApplet.vala"
					_g_free0 (self->priv->clock_custom_format);
#line 246 "../src/applets/clock/ClockApplet.vala"
					self->priv->clock_custom_format = _tmp13_;
#line 247 "../src/applets/clock/ClockApplet.vala"
					break;
#line 1193 "ClockApplet.c"
				}
			}
		} else if ((_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("use-custom-timezone")))) || (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("custom-timezone"))))) {
#line 226 "../src/applets/clock/ClockApplet.vala"
			switch (0) {
#line 1199 "ClockApplet.c"
				default:
				{
					GSettings* _tmp14_;
#line 250 "../src/applets/clock/ClockApplet.vala"
					_tmp14_ = self->settings;
#line 250 "../src/applets/clock/ClockApplet.vala"
					self->priv->clock_use_custom_timezone = g_settings_get_boolean (_tmp14_, "use-custom-timezone");
#line 251 "../src/applets/clock/ClockApplet.vala"
					if (self->priv->clock_use_custom_timezone) {
#line 1209 "ClockApplet.c"
						gchar* custom_tz = NULL;
						GSettings* _tmp15_;
						gchar* _tmp16_;
#line 252 "../src/applets/clock/ClockApplet.vala"
						_tmp15_ = self->settings;
#line 252 "../src/applets/clock/ClockApplet.vala"
						_tmp16_ = g_settings_get_string (_tmp15_, "custom-timezone");
#line 252 "../src/applets/clock/ClockApplet.vala"
						custom_tz = _tmp16_;
#line 1219 "ClockApplet.c"
						{
							GTimeZone* _tmp17_ = NULL;
							const gchar* _tmp18_;
							GTimeZone* _tmp19_;
							GTimeZone* _tmp20_;
#line 254 "../src/applets/clock/ClockApplet.vala"
							_tmp18_ = custom_tz;
#line 254 "../src/applets/clock/ClockApplet.vala"
							_tmp19_ = vala_g_time_zone_new_identifier (_tmp18_, &_inner_error0_);
#line 254 "../src/applets/clock/ClockApplet.vala"
							_tmp17_ = _tmp19_;
#line 254 "../src/applets/clock/ClockApplet.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1233 "ClockApplet.c"
								goto __catch0_g_error;
							}
#line 254 "../src/applets/clock/ClockApplet.vala"
							_tmp20_ = _tmp17_;
#line 254 "../src/applets/clock/ClockApplet.vala"
							_tmp17_ = NULL;
#line 254 "../src/applets/clock/ClockApplet.vala"
							_g_time_zone_unref0 (self->priv->clock_timezone);
#line 254 "../src/applets/clock/ClockApplet.vala"
							self->priv->clock_timezone = _tmp20_;
#line 253 "../src/applets/clock/ClockApplet.vala"
							_g_time_zone_unref0 (_tmp17_);
#line 1246 "ClockApplet.c"
						}
						goto __finally0;
						__catch0_g_error:
						{
							const gchar* _tmp21_;
							GTimeZone* _tmp22_;
#line 253 "../src/applets/clock/ClockApplet.vala"
							g_clear_error (&_inner_error0_);
#line 256 "../src/applets/clock/ClockApplet.vala"
							_tmp21_ = custom_tz;
#line 256 "../src/applets/clock/ClockApplet.vala"
							g_warning ("ClockApplet.vala:256: Clock applet: Failed to set time zone from ident" \
"ifier %s. Using UTC instead.", _tmp21_);
#line 257 "../src/applets/clock/ClockApplet.vala"
							_tmp22_ = g_time_zone_new_utc ();
#line 257 "../src/applets/clock/ClockApplet.vala"
							_g_time_zone_unref0 (self->priv->clock_timezone);
#line 257 "../src/applets/clock/ClockApplet.vala"
							self->priv->clock_timezone = _tmp22_;
#line 1265 "ClockApplet.c"
						}
						__finally0:
#line 253 "../src/applets/clock/ClockApplet.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 253 "../src/applets/clock/ClockApplet.vala"
							_g_free0 (custom_tz);
#line 253 "../src/applets/clock/ClockApplet.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 253 "../src/applets/clock/ClockApplet.vala"
							g_clear_error (&_inner_error0_);
#line 253 "../src/applets/clock/ClockApplet.vala"
							return;
#line 1278 "ClockApplet.c"
						}
#line 251 "../src/applets/clock/ClockApplet.vala"
						_g_free0 (custom_tz);
#line 1282 "ClockApplet.c"
					} else {
						GTimeZone* _tmp23_;
#line 260 "../src/applets/clock/ClockApplet.vala"
						_tmp23_ = g_time_zone_new_local ();
#line 260 "../src/applets/clock/ClockApplet.vala"
						_g_time_zone_unref0 (self->priv->clock_timezone);
#line 260 "../src/applets/clock/ClockApplet.vala"
						self->priv->clock_timezone = _tmp23_;
#line 1291 "ClockApplet.c"
					}
#line 262 "../src/applets/clock/ClockApplet.vala"
					break;
#line 1295 "ClockApplet.c"
				}
			}
		}
#line 264 "../src/applets/clock/ClockApplet.vala"
		return;
#line 1301 "ClockApplet.c"
	}
#line 266 "../src/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (schema, GNOME_SETTINGS_SCHEMA) == 0) {
#line 1305 "ClockApplet.c"
		const gchar* _tmp24_;
		GQuark _tmp26_ = 0U;
#line 267 "../src/applets/clock/ClockApplet.vala"
		static GQuark _tmp25_label0 = 0;
#line 267 "../src/applets/clock/ClockApplet.vala"
		_tmp24_ = key;
#line 267 "../src/applets/clock/ClockApplet.vala"
		_tmp26_ = (NULL == _tmp24_) ? 0 : g_quark_from_string (_tmp24_);
#line 267 "../src/applets/clock/ClockApplet.vala"
		if (_tmp26_ == ((0 != _tmp25_label0) ? _tmp25_label0 : (_tmp25_label0 = g_quark_from_static_string ("clock-format")))) {
#line 267 "../src/applets/clock/ClockApplet.vala"
			switch (0) {
#line 1318 "ClockApplet.c"
				default:
				{
					GSettings* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
#line 269 "../src/applets/clock/ClockApplet.vala"
					_tmp27_ = self->gnome_settings;
#line 269 "../src/applets/clock/ClockApplet.vala"
					_tmp28_ = g_settings_get_string (_tmp27_, "clock-format");
#line 269 "../src/applets/clock/ClockApplet.vala"
					_tmp29_ = _tmp28_;
#line 269 "../src/applets/clock/ClockApplet.vala"
					self->priv->clock_use_24_hour_time = g_strcmp0 (_tmp29_, "24h") == 0;
#line 269 "../src/applets/clock/ClockApplet.vala"
					_g_free0 (_tmp29_);
#line 270 "../src/applets/clock/ClockApplet.vala"
					break;
#line 1336 "ClockApplet.c"
				}
			}
		}
#line 272 "../src/applets/clock/ClockApplet.vala"
		return;
#line 1342 "ClockApplet.c"
	}
}

/**
 * Update the date if necessary
 */
void
clock_applet_update_date (ClockApplet* self)
{
	gboolean _tmp0_ = FALSE;
	gchar* ftime = NULL;
	gchar* old = NULL;
	GtkLabel* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* ctime = NULL;
	GDateTime* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GtkLabel* _tmp11_;
	const gchar* _tmp12_;
#line 280 "../src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 281 "../src/applets/clock/ClockApplet.vala"
	if (!self->priv->clock_show_date) {
#line 281 "../src/applets/clock/ClockApplet.vala"
		_tmp0_ = TRUE;
#line 1372 "ClockApplet.c"
	} else {
#line 281 "../src/applets/clock/ClockApplet.vala"
		_tmp0_ = self->priv->clock_use_custom_format;
#line 1376 "ClockApplet.c"
	}
#line 281 "../src/applets/clock/ClockApplet.vala"
	if (_tmp0_) {
#line 282 "../src/applets/clock/ClockApplet.vala"
		return;
#line 1382 "ClockApplet.c"
	}
#line 285 "../src/applets/clock/ClockApplet.vala"
	if (self->priv->orient == GTK_ORIENTATION_HORIZONTAL) {
#line 1386 "ClockApplet.c"
		gchar* _tmp1_;
#line 286 "../src/applets/clock/ClockApplet.vala"
		_tmp1_ = g_strdup ("%x");
#line 286 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 286 "../src/applets/clock/ClockApplet.vala"
		ftime = _tmp1_;
#line 1394 "ClockApplet.c"
	} else {
		gchar* _tmp2_;
#line 288 "../src/applets/clock/ClockApplet.vala"
		_tmp2_ = g_strdup ("<small>%b %d</small>");
#line 288 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 288 "../src/applets/clock/ClockApplet.vala"
		ftime = _tmp2_;
#line 1403 "ClockApplet.c"
	}
#line 292 "../src/applets/clock/ClockApplet.vala"
	_tmp3_ = self->date_label;
#line 292 "../src/applets/clock/ClockApplet.vala"
	_tmp4_ = gtk_label_get_label (_tmp3_);
#line 292 "../src/applets/clock/ClockApplet.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 292 "../src/applets/clock/ClockApplet.vala"
	old = _tmp5_;
#line 293 "../src/applets/clock/ClockApplet.vala"
	_tmp6_ = self->priv->time;
#line 293 "../src/applets/clock/ClockApplet.vala"
	_tmp7_ = ftime;
#line 293 "../src/applets/clock/ClockApplet.vala"
	_tmp8_ = g_date_time_format (_tmp6_, _tmp7_);
#line 293 "../src/applets/clock/ClockApplet.vala"
	ctime = _tmp8_;
#line 294 "../src/applets/clock/ClockApplet.vala"
	_tmp9_ = old;
#line 294 "../src/applets/clock/ClockApplet.vala"
	_tmp10_ = ctime;
#line 294 "../src/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (_tmp9_, _tmp10_) == 0) {
#line 295 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (ctime);
#line 295 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (old);
#line 295 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 295 "../src/applets/clock/ClockApplet.vala"
		return;
#line 1435 "ClockApplet.c"
	}
#line 297 "../src/applets/clock/ClockApplet.vala"
	_tmp11_ = self->date_label;
#line 297 "../src/applets/clock/ClockApplet.vala"
	_tmp12_ = ctime;
#line 297 "../src/applets/clock/ClockApplet.vala"
	gtk_label_set_markup (_tmp11_, _tmp12_);
#line 280 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (ctime);
#line 280 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (old);
#line 280 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (ftime);
#line 1449 "ClockApplet.c"
}

/**
 * Update the seconds if necessary
 */
void
clock_applet_update_seconds (ClockApplet* self)
{
	gboolean _tmp0_ = FALSE;
	gchar* ftime = NULL;
	gchar* old = NULL;
	GtkLabel* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* ctime = NULL;
	GDateTime* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GtkLabel* _tmp11_;
	const gchar* _tmp12_;
#line 303 "../src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 304 "../src/applets/clock/ClockApplet.vala"
	if (!self->priv->clock_show_seconds) {
#line 304 "../src/applets/clock/ClockApplet.vala"
		_tmp0_ = TRUE;
#line 1478 "ClockApplet.c"
	} else {
#line 304 "../src/applets/clock/ClockApplet.vala"
		_tmp0_ = self->priv->clock_use_custom_format;
#line 1482 "ClockApplet.c"
	}
#line 304 "../src/applets/clock/ClockApplet.vala"
	if (_tmp0_) {
#line 305 "../src/applets/clock/ClockApplet.vala"
		return;
#line 1488 "ClockApplet.c"
	}
#line 308 "../src/applets/clock/ClockApplet.vala"
	if (self->priv->orient == GTK_ORIENTATION_HORIZONTAL) {
#line 1492 "ClockApplet.c"
		gchar* _tmp1_;
#line 309 "../src/applets/clock/ClockApplet.vala"
		_tmp1_ = g_strdup ("");
#line 309 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 309 "../src/applets/clock/ClockApplet.vala"
		ftime = _tmp1_;
#line 1500 "ClockApplet.c"
	} else {
		gchar* _tmp2_;
#line 311 "../src/applets/clock/ClockApplet.vala"
		_tmp2_ = g_strdup ("<big>%S</big>");
#line 311 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 311 "../src/applets/clock/ClockApplet.vala"
		ftime = _tmp2_;
#line 1509 "ClockApplet.c"
	}
#line 315 "../src/applets/clock/ClockApplet.vala"
	_tmp3_ = self->seconds_label;
#line 315 "../src/applets/clock/ClockApplet.vala"
	_tmp4_ = gtk_label_get_label (_tmp3_);
#line 315 "../src/applets/clock/ClockApplet.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 315 "../src/applets/clock/ClockApplet.vala"
	old = _tmp5_;
#line 316 "../src/applets/clock/ClockApplet.vala"
	_tmp6_ = self->priv->time;
#line 316 "../src/applets/clock/ClockApplet.vala"
	_tmp7_ = ftime;
#line 316 "../src/applets/clock/ClockApplet.vala"
	_tmp8_ = g_date_time_format (_tmp6_, _tmp7_);
#line 316 "../src/applets/clock/ClockApplet.vala"
	ctime = _tmp8_;
#line 317 "../src/applets/clock/ClockApplet.vala"
	_tmp9_ = old;
#line 317 "../src/applets/clock/ClockApplet.vala"
	_tmp10_ = ctime;
#line 317 "../src/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (_tmp9_, _tmp10_) == 0) {
#line 318 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (ctime);
#line 318 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (old);
#line 318 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 318 "../src/applets/clock/ClockApplet.vala"
		return;
#line 1541 "ClockApplet.c"
	}
#line 321 "../src/applets/clock/ClockApplet.vala"
	_tmp11_ = self->seconds_label;
#line 321 "../src/applets/clock/ClockApplet.vala"
	_tmp12_ = ctime;
#line 321 "../src/applets/clock/ClockApplet.vala"
	gtk_label_set_markup (_tmp11_, _tmp12_);
#line 303 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (ctime);
#line 303 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (old);
#line 303 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (ftime);
#line 1555 "ClockApplet.c"
}

/**
 * This is called once every second, updating the time
 */
static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 1579 "ClockApplet.c"
}

gboolean
clock_applet_update_clock (ClockApplet* self)
{
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	gchar* format = NULL;
	gchar* old = NULL;
	GtkLabel* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* ctime = NULL;
	GDateTime* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* ftime = NULL;
	gchar* formatted = NULL;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	GtkLabel* _tmp28_;
	const gchar* _tmp29_;
	gboolean result;
#line 327 "../src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 328 "../src/applets/clock/ClockApplet.vala"
	if (!self->priv->clock_use_custom_timezone) {
#line 1613 "ClockApplet.c"
		GTimeZone* _tmp0_;
#line 329 "../src/applets/clock/ClockApplet.vala"
		_tmp0_ = g_time_zone_new_local ();
#line 329 "../src/applets/clock/ClockApplet.vala"
		_g_time_zone_unref0 (self->priv->clock_timezone);
#line 329 "../src/applets/clock/ClockApplet.vala"
		self->priv->clock_timezone = _tmp0_;
#line 1621 "ClockApplet.c"
	}
#line 331 "../src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->clock_timezone;
#line 331 "../src/applets/clock/ClockApplet.vala"
	_tmp2_ = g_date_time_new_now (_tmp1_);
#line 331 "../src/applets/clock/ClockApplet.vala"
	_g_date_time_unref0 (self->priv->time);
#line 331 "../src/applets/clock/ClockApplet.vala"
	self->priv->time = _tmp2_;
#line 334 "../src/applets/clock/ClockApplet.vala"
	if (!self->priv->clock_use_custom_format) {
#line 1633 "ClockApplet.c"
		const gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
#line 335 "../src/applets/clock/ClockApplet.vala"
		if (self->priv->clock_use_24_hour_time) {
#line 335 "../src/applets/clock/ClockApplet.vala"
			_tmp3_ = "%H:%M";
#line 1641 "ClockApplet.c"
		} else {
#line 335 "../src/applets/clock/ClockApplet.vala"
			_tmp3_ = "%l:%M";
#line 1645 "ClockApplet.c"
		}
#line 335 "../src/applets/clock/ClockApplet.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 335 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (format);
#line 335 "../src/applets/clock/ClockApplet.vala"
		format = _tmp4_;
#line 337 "../src/applets/clock/ClockApplet.vala"
		if (self->priv->orient == GTK_ORIENTATION_HORIZONTAL) {
#line 337 "../src/applets/clock/ClockApplet.vala"
			_tmp5_ = self->priv->clock_show_seconds;
#line 1657 "ClockApplet.c"
		} else {
#line 337 "../src/applets/clock/ClockApplet.vala"
			_tmp5_ = FALSE;
#line 1661 "ClockApplet.c"
		}
#line 337 "../src/applets/clock/ClockApplet.vala"
		if (_tmp5_) {
#line 1665 "ClockApplet.c"
			const gchar* _tmp6_;
			gchar* _tmp7_;
#line 338 "../src/applets/clock/ClockApplet.vala"
			_tmp6_ = format;
#line 338 "../src/applets/clock/ClockApplet.vala"
			_tmp7_ = g_strconcat (_tmp6_, ":%S", NULL);
#line 338 "../src/applets/clock/ClockApplet.vala"
			_g_free0 (format);
#line 338 "../src/applets/clock/ClockApplet.vala"
			format = _tmp7_;
#line 1676 "ClockApplet.c"
		}
#line 341 "../src/applets/clock/ClockApplet.vala"
		if (!self->priv->clock_use_24_hour_time) {
#line 1680 "ClockApplet.c"
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 342 "../src/applets/clock/ClockApplet.vala"
			_tmp8_ = format;
#line 342 "../src/applets/clock/ClockApplet.vala"
			_tmp9_ = g_strconcat (_tmp8_, " %p", NULL);
#line 342 "../src/applets/clock/ClockApplet.vala"
			_g_free0 (format);
#line 342 "../src/applets/clock/ClockApplet.vala"
			format = _tmp9_;
#line 1691 "ClockApplet.c"
		}
	} else {
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 345 "../src/applets/clock/ClockApplet.vala"
		_tmp10_ = self->priv->clock_custom_format;
#line 345 "../src/applets/clock/ClockApplet.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 345 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (format);
#line 345 "../src/applets/clock/ClockApplet.vala"
		format = _tmp11_;
#line 1704 "ClockApplet.c"
	}
#line 348 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_date (self);
#line 349 "../src/applets/clock/ClockApplet.vala"
	clock_applet_update_seconds (self);
#line 352 "../src/applets/clock/ClockApplet.vala"
	_tmp12_ = self->clock_label;
#line 352 "../src/applets/clock/ClockApplet.vala"
	_tmp13_ = gtk_label_get_label (_tmp12_);
#line 352 "../src/applets/clock/ClockApplet.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 352 "../src/applets/clock/ClockApplet.vala"
	old = _tmp14_;
#line 353 "../src/applets/clock/ClockApplet.vala"
	_tmp15_ = self->priv->time;
#line 353 "../src/applets/clock/ClockApplet.vala"
	_tmp16_ = format;
#line 353 "../src/applets/clock/ClockApplet.vala"
	_tmp17_ = g_date_time_format (_tmp15_, _tmp16_);
#line 353 "../src/applets/clock/ClockApplet.vala"
	_tmp18_ = _tmp17_;
#line 353 "../src/applets/clock/ClockApplet.vala"
	_tmp19_ = string_strip (_tmp18_);
#line 353 "../src/applets/clock/ClockApplet.vala"
	_tmp20_ = _tmp19_;
#line 353 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (_tmp18_);
#line 353 "../src/applets/clock/ClockApplet.vala"
	ctime = _tmp20_;
#line 356 "../src/applets/clock/ClockApplet.vala"
	if (self->priv->orient == GTK_ORIENTATION_HORIZONTAL) {
#line 1736 "ClockApplet.c"
		gchar* _tmp21_;
#line 357 "../src/applets/clock/ClockApplet.vala"
		_tmp21_ = g_strdup ("%s");
#line 357 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 357 "../src/applets/clock/ClockApplet.vala"
		ftime = _tmp21_;
#line 1744 "ClockApplet.c"
	} else {
		gchar* _tmp22_;
#line 359 "../src/applets/clock/ClockApplet.vala"
		_tmp22_ = g_strdup ("<small>%s</small>");
#line 359 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 359 "../src/applets/clock/ClockApplet.vala"
		ftime = _tmp22_;
#line 1753 "ClockApplet.c"
	}
#line 362 "../src/applets/clock/ClockApplet.vala"
	_tmp23_ = ftime;
#line 362 "../src/applets/clock/ClockApplet.vala"
	_tmp24_ = ctime;
#line 362 "../src/applets/clock/ClockApplet.vala"
	_tmp25_ = g_strdup_printf (_tmp23_, _tmp24_);
#line 362 "../src/applets/clock/ClockApplet.vala"
	formatted = _tmp25_;
#line 363 "../src/applets/clock/ClockApplet.vala"
	_tmp26_ = old;
#line 363 "../src/applets/clock/ClockApplet.vala"
	_tmp27_ = formatted;
#line 363 "../src/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (_tmp26_, _tmp27_) == 0) {
#line 364 "../src/applets/clock/ClockApplet.vala"
		result = TRUE;
#line 364 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (formatted);
#line 364 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 364 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (ctime);
#line 364 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (old);
#line 364 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (format);
#line 364 "../src/applets/clock/ClockApplet.vala"
		return result;
#line 1783 "ClockApplet.c"
	}
#line 367 "../src/applets/clock/ClockApplet.vala"
	_tmp28_ = self->clock_label;
#line 367 "../src/applets/clock/ClockApplet.vala"
	_tmp29_ = formatted;
#line 367 "../src/applets/clock/ClockApplet.vala"
	gtk_label_set_markup (_tmp28_, _tmp29_);
#line 368 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 370 "../src/applets/clock/ClockApplet.vala"
	result = TRUE;
#line 370 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (formatted);
#line 370 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (ftime);
#line 370 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (ctime);
#line 370 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (old);
#line 370 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (format);
#line 370 "../src/applets/clock/ClockApplet.vala"
	return result;
#line 1807 "ClockApplet.c"
}

static gboolean
clock_applet_real_supports_settings (BudgieApplet* base)
{
	ClockApplet * self;
	gboolean result;
#line 373 "../src/applets/clock/ClockApplet.vala"
	self = (ClockApplet*) base;
#line 374 "../src/applets/clock/ClockApplet.vala"
	result = TRUE;
#line 374 "../src/applets/clock/ClockApplet.vala"
	return result;
#line 1821 "ClockApplet.c"
}

static GtkWidget*
clock_applet_real_get_settings_ui (BudgieApplet* base)
{
	ClockApplet * self;
	const gchar* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	ClockSettings* _tmp5_;
	GtkWidget* _tmp6_;
	GtkWidget* result;
#line 377 "../src/applets/clock/ClockApplet.vala"
	self = (ClockApplet*) base;
#line 378 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->_uuid;
#line 378 "../src/applets/clock/ClockApplet.vala"
	_tmp1_ = budgie_applet_get_applet_settings ((BudgieApplet*) self, _tmp0_);
#line 378 "../src/applets/clock/ClockApplet.vala"
	_tmp2_ = _tmp1_;
#line 378 "../src/applets/clock/ClockApplet.vala"
	_tmp3_ = g_settings_new (GNOME_SETTINGS_SCHEMA);
#line 378 "../src/applets/clock/ClockApplet.vala"
	_tmp4_ = _tmp3_;
#line 378 "../src/applets/clock/ClockApplet.vala"
	_tmp5_ = clock_settings_new (_tmp2_, _tmp4_);
#line 378 "../src/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp5_);
#line 378 "../src/applets/clock/ClockApplet.vala"
	_tmp6_ = (GtkWidget*) _tmp5_;
#line 378 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (_tmp4_);
#line 378 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (_tmp2_);
#line 378 "../src/applets/clock/ClockApplet.vala"
	result = _tmp6_;
#line 378 "../src/applets/clock/ClockApplet.vala"
	return result;
#line 1862 "ClockApplet.c"
}

const gchar*
clock_applet_get_uuid (ClockApplet* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->_uuid;
#line 50 "../src/applets/clock/ClockApplet.vala"
	result = _tmp0_;
#line 50 "../src/applets/clock/ClockApplet.vala"
	return result;
#line 1878 "ClockApplet.c"
}

void
clock_applet_set_uuid (ClockApplet* self,
                       const gchar* value)
{
	gchar* old_value;
#line 50 "../src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/applets/clock/ClockApplet.vala"
	old_value = clock_applet_get_uuid (self);
#line 50 "../src/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1892 "ClockApplet.c"
		gchar* _tmp0_;
#line 50 "../src/applets/clock/ClockApplet.vala"
		_tmp0_ = g_strdup (value);
#line 50 "../src/applets/clock/ClockApplet.vala"
		_g_free0 (self->priv->_uuid);
#line 50 "../src/applets/clock/ClockApplet.vala"
		self->priv->_uuid = _tmp0_;
#line 50 "../src/applets/clock/ClockApplet.vala"
		g_object_notify_by_pspec ((GObject *) self, clock_applet_properties[CLOCK_APPLET_UUID_PROPERTY]);
#line 1902 "ClockApplet.c"
	}
}

static void
clock_applet_class_init (ClockAppletClass * klass,
                         gpointer klass_data)
{
#line 22 "../src/applets/clock/ClockApplet.vala"
	clock_applet_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/applets/clock/ClockApplet.vala"
	g_type_class_adjust_private_offset (klass, &ClockApplet_private_offset);
#line 22 "../src/applets/clock/ClockApplet.vala"
	((BudgieAppletClass *) klass)->panel_position_changed = (void (*) (BudgieApplet*, BudgiePanelPosition)) clock_applet_real_panel_position_changed;
#line 22 "../src/applets/clock/ClockApplet.vala"
	((BudgieAppletClass *) klass)->update_popovers = (void (*) (BudgieApplet*, BudgiePopoverManager*)) clock_applet_real_update_popovers;
#line 22 "../src/applets/clock/ClockApplet.vala"
	((BudgieAppletClass *) klass)->supports_settings = (gboolean (*) (BudgieApplet*)) clock_applet_real_supports_settings;
#line 22 "../src/applets/clock/ClockApplet.vala"
	((BudgieAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (BudgieApplet*)) clock_applet_real_get_settings_ui;
#line 22 "../src/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_clock_applet_get_property;
#line 22 "../src/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_clock_applet_set_property;
#line 22 "../src/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (klass)->finalize = clock_applet_finalize;
#line 22 "../src/applets/clock/ClockApplet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_APPLET_UUID_PROPERTY, clock_applet_properties[CLOCK_APPLET_UUID_PROPERTY] = g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1930 "ClockApplet.c"
}

static void
clock_applet_instance_init (ClockApplet * self,
                            gpointer klass)
{
#line 22 "../src/applets/clock/ClockApplet.vala"
	self->priv = clock_applet_get_instance_private (self);
#line 34 "../src/applets/clock/ClockApplet.vala"
	self->priv->popover = NULL;
#line 35 "../src/applets/clock/ClockApplet.vala"
	self->priv->calprov = NULL;
#line 38 "../src/applets/clock/ClockApplet.vala"
	self->priv->orient = GTK_ORIENTATION_HORIZONTAL;
#line 40 "../src/applets/clock/ClockApplet.vala"
	self->priv->manager = NULL;
#line 1947 "ClockApplet.c"
}

static void
clock_applet_finalize (GObject * obj)
{
	ClockApplet * self;
#line 22 "../src/applets/clock/ClockApplet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOCK_APPLET, ClockApplet);
#line 23 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->widget);
#line 24 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->layout);
#line 25 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->clock_label);
#line 26 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->date_label);
#line 27 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->seconds_label);
#line 29 "../src/applets/clock/ClockApplet.vala"
	_g_date_time_unref0 (self->priv->time);
#line 31 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->settings);
#line 32 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->gnome_settings);
#line 34 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->popover);
#line 35 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->calprov);
#line 36 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->cal_button);
#line 47 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (self->priv->clock_custom_format);
#line 48 "../src/applets/clock/ClockApplet.vala"
	_g_time_zone_unref0 (self->priv->clock_timezone);
#line 50 "../src/applets/clock/ClockApplet.vala"
	_g_free0 (self->priv->_uuid);
#line 22 "../src/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (clock_applet_parent_class)->finalize (obj);
#line 1986 "ClockApplet.c"
}

GType
clock_applet_get_type (void)
{
	return clock_applet_type_id;
}

GType
clock_applet_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClockAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClockApplet), 0, (GInstanceInitFunc) clock_applet_instance_init, NULL };
	clock_applet_type_id = g_type_module_register_type (module, budgie_applet_get_type (), "ClockApplet", &g_define_type_info, 0);
	ClockApplet_private_offset = sizeof (ClockAppletPrivate);
	return clock_applet_type_id;
}

static void
_vala_clock_applet_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ClockApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOCK_APPLET, ClockApplet);
#line 22 "../src/applets/clock/ClockApplet.vala"
	switch (property_id) {
#line 22 "../src/applets/clock/ClockApplet.vala"
		case CLOCK_APPLET_UUID_PROPERTY:
#line 22 "../src/applets/clock/ClockApplet.vala"
		g_value_set_string (value, clock_applet_get_uuid (self));
#line 22 "../src/applets/clock/ClockApplet.vala"
		break;
#line 2020 "ClockApplet.c"
		default:
#line 22 "../src/applets/clock/ClockApplet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/applets/clock/ClockApplet.vala"
		break;
#line 2026 "ClockApplet.c"
	}
}

static void
_vala_clock_applet_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ClockApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOCK_APPLET, ClockApplet);
#line 22 "../src/applets/clock/ClockApplet.vala"
	switch (property_id) {
#line 22 "../src/applets/clock/ClockApplet.vala"
		case CLOCK_APPLET_UUID_PROPERTY:
#line 22 "../src/applets/clock/ClockApplet.vala"
		clock_applet_set_uuid (self, g_value_get_string (value));
#line 22 "../src/applets/clock/ClockApplet.vala"
		break;
#line 2046 "ClockApplet.c"
		default:
#line 22 "../src/applets/clock/ClockApplet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/applets/clock/ClockApplet.vala"
		break;
#line 2052 "ClockApplet.c"
	}
}

static inline gpointer
clock_settings_get_instance_private (ClockSettings* self)
{
	return G_STRUCT_MEMBER_P (self, ClockSettings_private_offset);
}

static gboolean
__lambda7_ (GValue* value,
            GVariant* variant,
            void* user_data)
{
	const gchar* _tmp0_;
	gboolean result;
#line 410 "../src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 410 "../src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (variant != NULL, FALSE);
#line 411 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = g_variant_get_string (variant, NULL);
#line 411 "../src/applets/clock/ClockApplet.vala"
	g_value_set_boolean (value, g_strcmp0 (_tmp0_, "24h") == 0);
#line 412 "../src/applets/clock/ClockApplet.vala"
	result = TRUE;
#line 412 "../src/applets/clock/ClockApplet.vala"
	return result;
#line 2081 "ClockApplet.c"
}

static gboolean
___lambda7__gsettings_bind_get_mapping (GValue* value,
                                        GVariant* variant,
                                        void* user_data)
{
	gboolean result;
	result = __lambda7_ (value, variant, user_data);
#line 410 "../src/applets/clock/ClockApplet.vala"
	return result;
#line 2093 "ClockApplet.c"
}

static GVariant*
__lambda8_ (GValue* value,
            const GVariantType* expected_type,
            void* user_data)
{
	GVariant* _tmp1_;
	GVariant* result;
#line 413 "../src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 413 "../src/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (expected_type != NULL, NULL);
#line 414 "../src/applets/clock/ClockApplet.vala"
	if (g_value_get_boolean (value)) {
#line 2109 "ClockApplet.c"
		GVariant* _tmp0_;
#line 415 "../src/applets/clock/ClockApplet.vala"
		_tmp0_ = g_variant_new ("s", "24h", NULL);
#line 415 "../src/applets/clock/ClockApplet.vala"
		g_variant_ref_sink (_tmp0_);
#line 415 "../src/applets/clock/ClockApplet.vala"
		result = _tmp0_;
#line 415 "../src/applets/clock/ClockApplet.vala"
		return result;
#line 2119 "ClockApplet.c"
	}
#line 417 "../src/applets/clock/ClockApplet.vala"
	_tmp1_ = g_variant_new ("s", "12h", NULL);
#line 417 "../src/applets/clock/ClockApplet.vala"
	g_variant_ref_sink (_tmp1_);
#line 417 "../src/applets/clock/ClockApplet.vala"
	result = _tmp1_;
#line 417 "../src/applets/clock/ClockApplet.vala"
	return result;
#line 2129 "ClockApplet.c"
}

static GVariant*
___lambda8__gsettings_bind_set_mapping (GValue* value,
                                        const GVariantType* expected_type,
                                        void* user_data)
{
	GVariant* result;
	result = __lambda8_ (value, expected_type, user_data);
#line 410 "../src/applets/clock/ClockApplet.vala"
	return result;
#line 2141 "ClockApplet.c"
}

static void
_clock_settings_updateSensitve_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 424 "../src/applets/clock/ClockApplet.vala"
	clock_settings_updateSensitve ((ClockSettings*) self);
#line 2151 "ClockApplet.c"
}

ClockSettings*
clock_settings_construct (GType object_type,
                          GSettings* settings,
                          GSettings* gnome_settings)
{
	ClockSettings * self = NULL;
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	GtkEntry* _tmp4_;
	GtkSwitch* _tmp5_;
	GtkEntry* _tmp6_;
	GtkSwitch* _tmp7_;
	GtkSwitch* _tmp8_;
#line 407 "../src/applets/clock/ClockApplet.vala"
	self = (ClockSettings*) g_object_new (object_type, NULL);
#line 408 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->show_date;
#line 408 "../src/applets/clock/ClockApplet.vala"
	g_settings_bind (settings, "show-date", (GObject*) _tmp0_, "active", G_SETTINGS_BIND_DEFAULT);
#line 409 "../src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->show_seconds;
#line 409 "../src/applets/clock/ClockApplet.vala"
	g_settings_bind (settings, "show-seconds", (GObject*) _tmp1_, "active", G_SETTINGS_BIND_DEFAULT);
#line 410 "../src/applets/clock/ClockApplet.vala"
	_tmp2_ = self->priv->use_24_hour_time;
#line 410 "../src/applets/clock/ClockApplet.vala"
	g_settings_bind_with_mapping (gnome_settings, "clock-format", (GObject*) _tmp2_, "active", G_SETTINGS_BIND_DEFAULT, ___lambda7__gsettings_bind_get_mapping, ___lambda8__gsettings_bind_set_mapping, NULL, NULL);
#line 419 "../src/applets/clock/ClockApplet.vala"
	_tmp3_ = self->priv->use_custom_format;
#line 419 "../src/applets/clock/ClockApplet.vala"
	g_settings_bind (settings, "use-custom-format", (GObject*) _tmp3_, "active", G_SETTINGS_BIND_DEFAULT);
#line 420 "../src/applets/clock/ClockApplet.vala"
	_tmp4_ = self->priv->custom_format;
#line 420 "../src/applets/clock/ClockApplet.vala"
	g_settings_bind (settings, "custom-format", (GObject*) _tmp4_, "text", G_SETTINGS_BIND_DEFAULT);
#line 421 "../src/applets/clock/ClockApplet.vala"
	_tmp5_ = self->priv->use_custom_timezone;
#line 421 "../src/applets/clock/ClockApplet.vala"
	g_settings_bind (settings, "use-custom-timezone", (GObject*) _tmp5_, "active", G_SETTINGS_BIND_DEFAULT);
#line 422 "../src/applets/clock/ClockApplet.vala"
	_tmp6_ = self->priv->custom_timezone;
#line 422 "../src/applets/clock/ClockApplet.vala"
	g_settings_bind (settings, "custom-timezone", (GObject*) _tmp6_, "text", G_SETTINGS_BIND_DEFAULT);
#line 424 "../src/applets/clock/ClockApplet.vala"
	_tmp7_ = self->priv->use_custom_format;
#line 424 "../src/applets/clock/ClockApplet.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::active", (GCallback) _clock_settings_updateSensitve_g_object_notify, self, 0);
#line 425 "../src/applets/clock/ClockApplet.vala"
	_tmp8_ = self->priv->use_custom_timezone;
#line 425 "../src/applets/clock/ClockApplet.vala"
	g_signal_connect_object ((GObject*) _tmp8_, "notify::active", (GCallback) _clock_settings_updateSensitve_g_object_notify, self, 0);
#line 427 "../src/applets/clock/ClockApplet.vala"
	clock_settings_updateSensitve (self);
#line 407 "../src/applets/clock/ClockApplet.vala"
	return self;
#line 2211 "ClockApplet.c"
}

ClockSettings*
clock_settings_new (GSettings* settings,
                    GSettings* gnome_settings)
{
#line 407 "../src/applets/clock/ClockApplet.vala"
	return clock_settings_construct (TYPE_CLOCK_SETTINGS, settings, gnome_settings);
#line 2220 "ClockApplet.c"
}

static void
clock_settings_updateSensitve (ClockSettings* self)
{
	gboolean useCustomFormat = FALSE;
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	GtkEntry* _tmp4_;
	GtkEntry* _tmp5_;
	GtkSwitch* _tmp6_;
#line 430 "../src/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 431 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->use_custom_format;
#line 431 "../src/applets/clock/ClockApplet.vala"
	useCustomFormat = gtk_switch_get_active (_tmp0_);
#line 432 "../src/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->show_date;
#line 432 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, !useCustomFormat);
#line 433 "../src/applets/clock/ClockApplet.vala"
	_tmp2_ = self->priv->show_seconds;
#line 433 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, !useCustomFormat);
#line 434 "../src/applets/clock/ClockApplet.vala"
	_tmp3_ = self->priv->use_24_hour_time;
#line 434 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, !useCustomFormat);
#line 435 "../src/applets/clock/ClockApplet.vala"
	_tmp4_ = self->priv->custom_format;
#line 435 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, useCustomFormat);
#line 437 "../src/applets/clock/ClockApplet.vala"
	_tmp5_ = self->priv->custom_timezone;
#line 437 "../src/applets/clock/ClockApplet.vala"
	_tmp6_ = self->priv->use_custom_timezone;
#line 437 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, gtk_switch_get_active (_tmp6_));
#line 2262 "ClockApplet.c"
}

static void
clock_settings_class_init (ClockSettingsClass * klass,
                           gpointer klass_data)
{
#line 384 "../src/applets/clock/ClockApplet.vala"
	clock_settings_parent_class = g_type_class_peek_parent (klass);
#line 384 "../src/applets/clock/ClockApplet.vala"
	g_type_class_adjust_private_offset (klass, &ClockSettings_private_offset);
#line 384 "../src/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (klass)->finalize = clock_settings_finalize;
#line 384 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/solus-project/clock/settings.ui");
#line 384 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_date", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, show_date));
#line 384 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_seconds", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, show_seconds));
#line 384 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "use_24_hour_time", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, use_24_hour_time));
#line 384 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "use_custom_format", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, use_custom_format));
#line 384 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_format", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, custom_format));
#line 384 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "use_custom_timezone", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, use_custom_timezone));
#line 384 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_timezone", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, custom_timezone));
#line 2291 "ClockApplet.c"
}

static void
clock_settings_instance_init (ClockSettings * self,
                              gpointer klass)
{
#line 384 "../src/applets/clock/ClockApplet.vala"
	self->priv = clock_settings_get_instance_private (self);
#line 384 "../src/applets/clock/ClockApplet.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2302 "ClockApplet.c"
}

static void
clock_settings_finalize (GObject * obj)
{
	ClockSettings * self;
#line 384 "../src/applets/clock/ClockApplet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOCK_SETTINGS, ClockSettings);
#line 384 "../src/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (clock_settings_parent_class)->finalize (obj);
#line 2313 "ClockApplet.c"
}

GType
clock_settings_get_type (void)
{
	return clock_settings_type_id;
}

GType
clock_settings_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClockSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClockSettings), 0, (GInstanceInitFunc) clock_settings_instance_init, NULL };
	clock_settings_type_id = g_type_module_register_type (module, gtk_grid_get_type (), "ClockSettings", &g_define_type_info, 0);
	ClockSettings_private_offset = sizeof (ClockSettingsPrivate);
	return clock_settings_type_id;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 445 "../src/applets/clock/ClockApplet.vala"
	return self ? g_object_ref (self) : NULL;
#line 2336 "ClockApplet.c"
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* objmodule = NULL;
	PeasObjectModule* _tmp0_;
#line 443 "../src/applets/clock/ClockApplet.vala"
	g_return_if_fail (module != NULL);
#line 443 "../src/applets/clock/ClockApplet.vala"
	clock_plugin_register_type (module);
#line 443 "../src/applets/clock/ClockApplet.vala"
	clock_applet_register_type (module);
#line 443 "../src/applets/clock/ClockApplet.vala"
	clock_settings_register_type (module);
#line 445 "../src/applets/clock/ClockApplet.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
#line 445 "../src/applets/clock/ClockApplet.vala"
	objmodule = _tmp0_;
#line 446 "../src/applets/clock/ClockApplet.vala"
	peas_object_module_register_extension_type (objmodule, budgie_plugin_get_type (), TYPE_CLOCK_PLUGIN);
#line 443 "../src/applets/clock/ClockApplet.vala"
	_g_object_unref0 (objmodule);
#line 2360 "ClockApplet.c"
}

