/* IndicatorWindow.c generated by valac 0.56.3, the Vala compiler
 * generated from IndicatorWindow.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2017-2022 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "plugin.h"
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gdesktopappinfo.h>
#include "nightlightapplet.h"

#define NIGHT_LIGHT_TYPE_INDICATOR_WINDOW (night_light_indicator_window_get_type ())
#define NIGHT_LIGHT_INDICATOR_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NIGHT_LIGHT_TYPE_INDICATOR_WINDOW, NightLightIndicatorWindow))
#define NIGHT_LIGHT_INDICATOR_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NIGHT_LIGHT_TYPE_INDICATOR_WINDOW, NightLightIndicatorWindowClass))
#define NIGHT_LIGHT_IS_INDICATOR_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NIGHT_LIGHT_TYPE_INDICATOR_WINDOW))
#define NIGHT_LIGHT_IS_INDICATOR_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NIGHT_LIGHT_TYPE_INDICATOR_WINDOW))
#define NIGHT_LIGHT_INDICATOR_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NIGHT_LIGHT_TYPE_INDICATOR_WINDOW, NightLightIndicatorWindowClass))

typedef struct _NightLightIndicatorWindow NightLightIndicatorWindow;
typedef struct _NightLightIndicatorWindowClass NightLightIndicatorWindowClass;
typedef struct _NightLightIndicatorWindowPrivate NightLightIndicatorWindowPrivate;
enum  {
	NIGHT_LIGHT_INDICATOR_WINDOW_0_PROPERTY,
	NIGHT_LIGHT_INDICATOR_WINDOW_NUM_PROPERTIES
};
static GParamSpec* night_light_indicator_window_properties[NIGHT_LIGHT_INDICATOR_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NightLightIndicatorWindow {
	BudgiePopover parent_instance;
	NightLightIndicatorWindowPrivate * priv;
};

struct _NightLightIndicatorWindowClass {
	BudgiePopoverClass parent_class;
};

struct _NightLightIndicatorWindowPrivate {
	GtkSwitch* nightlight_switch;
	GtkGrid* item_grid;
	GtkSpinButton* temperature_spinbutton;
	GtkComboBoxText* schedule_combobox;
	GSettings* settings;
};

static gint NightLightIndicatorWindow_private_offset;
static gpointer night_light_indicator_window_parent_class = NULL;
static GType night_light_indicator_window_type_id = 0;

GType night_light_indicator_window_register_type (GTypeModule * module);
VALA_EXTERN GType night_light_indicator_window_get_type (void) G_GNUC_CONST ;
VALA_EXTERN NightLightIndicatorWindow* night_light_indicator_window_new (GtkWidget* window_parent);
VALA_EXTERN NightLightIndicatorWindow* night_light_indicator_window_construct (GType object_type,
                                                                   GtkWidget* window_parent);
static void __lambda4_ (NightLightIndicatorWindow* self);
static void ___lambda4__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
VALA_EXTERN void night_light_indicator_window_toggle_nightlight (NightLightIndicatorWindow* self);
static void night_light_indicator_window_schedule_mode_changed (NightLightIndicatorWindow* self);
static void _night_light_indicator_window_schedule_mode_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                                gpointer self);
static void night_light_indicator_window_open_settings (NightLightIndicatorWindow* self);
static void _night_light_indicator_window_open_settings_gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self);
static void night_light_indicator_window_finalize (GObject * obj);

static inline gpointer
night_light_indicator_window_get_instance_private (NightLightIndicatorWindow* self)
{
	return G_STRUCT_MEMBER_P (self, NightLightIndicatorWindow_private_offset);
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 96 "IndicatorWindow.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 104 "IndicatorWindow.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 113 "IndicatorWindow.c"
	}
}

static void
__lambda4_ (NightLightIndicatorWindow* self)
{
	GtkComboBoxText* _tmp0_;
	GSettings* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 39 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp0_ = self->priv->schedule_combobox;
#line 39 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp1_ = self->priv->settings;
#line 39 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp2_ = bool_to_string (g_settings_get_boolean (_tmp1_, "night-light-schedule-automatic"));
#line 39 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp3_ = _tmp2_;
#line 39 "../src/applets/night-light/IndicatorWindow.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp0_, _tmp3_);
#line 39 "../src/applets/night-light/IndicatorWindow.vala"
	_g_free0 (_tmp3_);
#line 136 "IndicatorWindow.c"
}

static void
___lambda4__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
#line 38 "../src/applets/night-light/IndicatorWindow.vala"
	__lambda4_ ((NightLightIndicatorWindow*) self);
#line 146 "IndicatorWindow.c"
}

NightLightIndicatorWindow*
night_light_indicator_window_construct (GType object_type,
                                        GtkWidget* window_parent)
{
	NightLightIndicatorWindow * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkSwitch* _tmp2_;
	GSettings* _tmp3_;
	GtkGrid* _tmp4_;
	GSettings* _tmp5_;
	GtkSpinButton* _tmp6_;
	GSettings* _tmp7_;
	GtkComboBoxText* _tmp8_;
	GSettings* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
#line 30 "../src/applets/night-light/IndicatorWindow.vala"
	self = (NightLightIndicatorWindow*) g_object_new (object_type, "relative-to", window_parent, NULL);
#line 32 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp0_ = g_settings_new ("org.gnome.settings-daemon.plugins.color");
#line 32 "../src/applets/night-light/IndicatorWindow.vala"
	_g_object_unref0 (self->priv->settings);
#line 32 "../src/applets/night-light/IndicatorWindow.vala"
	self->priv->settings = _tmp0_;
#line 34 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp1_ = self->priv->settings;
#line 34 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp2_ = self->priv->nightlight_switch;
#line 34 "../src/applets/night-light/IndicatorWindow.vala"
	g_settings_bind (_tmp1_, "night-light-enabled", (GObject*) _tmp2_, "active", G_SETTINGS_BIND_DEFAULT);
#line 35 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp3_ = self->priv->settings;
#line 35 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp4_ = self->priv->item_grid;
#line 35 "../src/applets/night-light/IndicatorWindow.vala"
	g_settings_bind (_tmp3_, "night-light-enabled", (GObject*) _tmp4_, "sensitive", G_SETTINGS_BIND_DEFAULT);
#line 36 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp5_ = self->priv->settings;
#line 36 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp6_ = self->priv->temperature_spinbutton;
#line 36 "../src/applets/night-light/IndicatorWindow.vala"
	g_settings_bind (_tmp5_, "night-light-temperature", (GObject*) _tmp6_, "value", G_SETTINGS_BIND_DEFAULT);
#line 38 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp7_ = self->priv->settings;
#line 38 "../src/applets/night-light/IndicatorWindow.vala"
	g_signal_connect_object (_tmp7_, "changed::night-light-schedule-automatic", (GCallback) ___lambda4__g_settings_changed, self, 0);
#line 42 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp8_ = self->priv->schedule_combobox;
#line 42 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp9_ = self->priv->settings;
#line 42 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp10_ = bool_to_string (g_settings_get_boolean (_tmp9_, "night-light-schedule-automatic"));
#line 42 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp11_ = _tmp10_;
#line 42 "../src/applets/night-light/IndicatorWindow.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp8_, _tmp11_);
#line 42 "../src/applets/night-light/IndicatorWindow.vala"
	_g_free0 (_tmp11_);
#line 29 "../src/applets/night-light/IndicatorWindow.vala"
	return self;
#line 210 "IndicatorWindow.c"
}

NightLightIndicatorWindow*
night_light_indicator_window_new (GtkWidget* window_parent)
{
#line 29 "../src/applets/night-light/IndicatorWindow.vala"
	return night_light_indicator_window_construct (NIGHT_LIGHT_TYPE_INDICATOR_WINDOW, window_parent);
#line 218 "IndicatorWindow.c"
}

void
night_light_indicator_window_toggle_nightlight (NightLightIndicatorWindow* self)
{
	gboolean enabled = FALSE;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 45 "../src/applets/night-light/IndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp0_ = self->priv->settings;
#line 46 "../src/applets/night-light/IndicatorWindow.vala"
	enabled = g_settings_get_boolean (_tmp0_, "night-light-enabled");
#line 47 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp1_ = self->priv->settings;
#line 47 "../src/applets/night-light/IndicatorWindow.vala"
	g_settings_set_boolean (_tmp1_, "night-light-enabled", !enabled);
#line 237 "IndicatorWindow.c"
}

static gboolean
bool_parse (const gchar* str)
{
	gboolean result;
#line 44 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 45 "glib-2.0.vapi"
	if (g_strcmp0 (str, "true") == 0) {
#line 46 "glib-2.0.vapi"
		result = TRUE;
#line 46 "glib-2.0.vapi"
		return result;
#line 252 "IndicatorWindow.c"
	} else {
#line 48 "glib-2.0.vapi"
		result = FALSE;
#line 48 "glib-2.0.vapi"
		return result;
#line 258 "IndicatorWindow.c"
	}
}

static void
night_light_indicator_window_schedule_mode_changed (NightLightIndicatorWindow* self)
{
	GSettings* _tmp0_;
	GtkComboBoxText* _tmp1_;
	const gchar* _tmp2_;
#line 51 "../src/applets/night-light/IndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp0_ = self->priv->settings;
#line 52 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp1_ = self->priv->schedule_combobox;
#line 52 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp2_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp1_);
#line 52 "../src/applets/night-light/IndicatorWindow.vala"
	g_settings_set_boolean (_tmp0_, "night-light-schedule-automatic", bool_parse (_tmp2_));
#line 278 "IndicatorWindow.c"
}

static void
_night_light_indicator_window_schedule_mode_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                           gpointer self)
{
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	night_light_indicator_window_schedule_mode_changed ((NightLightIndicatorWindow*) self);
#line 287 "IndicatorWindow.c"
}

static void
night_light_indicator_window_open_settings (NightLightIndicatorWindow* self)
{
	GDesktopAppInfo* app_info = NULL;
	GDesktopAppInfo* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 56 "../src/applets/night-light/IndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp0_ = g_desktop_app_info_new ("budgie-display-panel.desktop");
#line 57 "../src/applets/night-light/IndicatorWindow.vala"
	app_info = _tmp0_;
#line 59 "../src/applets/night-light/IndicatorWindow.vala"
	_tmp1_ = app_info;
#line 59 "../src/applets/night-light/IndicatorWindow.vala"
	if (_tmp1_ == NULL) {
#line 60 "../src/applets/night-light/IndicatorWindow.vala"
		_g_object_unref0 (app_info);
#line 60 "../src/applets/night-light/IndicatorWindow.vala"
		return;
#line 311 "IndicatorWindow.c"
	}
	{
		GDesktopAppInfo* _tmp2_;
#line 64 "../src/applets/night-light/IndicatorWindow.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 65 "../src/applets/night-light/IndicatorWindow.vala"
		_tmp2_ = app_info;
#line 65 "../src/applets/night-light/IndicatorWindow.vala"
		g_app_info_launch ((GAppInfo*) _tmp2_, NULL, NULL, &_inner_error0_);
#line 65 "../src/applets/night-light/IndicatorWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 323 "IndicatorWindow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 63 "../src/applets/night-light/IndicatorWindow.vala"
		e = _inner_error0_;
#line 63 "../src/applets/night-light/IndicatorWindow.vala"
		_inner_error0_ = NULL;
#line 67 "../src/applets/night-light/IndicatorWindow.vala"
		_tmp3_ = e;
#line 67 "../src/applets/night-light/IndicatorWindow.vala"
		_tmp4_ = _tmp3_->message;
#line 67 "../src/applets/night-light/IndicatorWindow.vala"
		g_message ("IndicatorWindow.vala:67: Unable to launch budgie-display-panel.desktop" \
": %s", _tmp4_);
#line 63 "../src/applets/night-light/IndicatorWindow.vala"
		_g_error_free0 (e);
#line 345 "IndicatorWindow.c"
	}
	__finally0:
#line 63 "../src/applets/night-light/IndicatorWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 63 "../src/applets/night-light/IndicatorWindow.vala"
		_g_object_unref0 (app_info);
#line 63 "../src/applets/night-light/IndicatorWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 63 "../src/applets/night-light/IndicatorWindow.vala"
		g_clear_error (&_inner_error0_);
#line 63 "../src/applets/night-light/IndicatorWindow.vala"
		return;
#line 358 "IndicatorWindow.c"
	}
#line 56 "../src/applets/night-light/IndicatorWindow.vala"
	_g_object_unref0 (app_info);
#line 362 "IndicatorWindow.c"
}

static void
_night_light_indicator_window_open_settings_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self)
{
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	night_light_indicator_window_open_settings ((NightLightIndicatorWindow*) self);
#line 371 "IndicatorWindow.c"
}

static void
night_light_indicator_window_class_init (NightLightIndicatorWindowClass * klass,
                                         gpointer klass_data)
{
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	night_light_indicator_window_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	g_type_class_adjust_private_offset (klass, &NightLightIndicatorWindow_private_offset);
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = night_light_indicator_window_finalize;
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/budgie-desktop/night-light/indicator_window.ui");
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "nightlight_switch", FALSE, NightLightIndicatorWindow_private_offset + G_STRUCT_OFFSET (NightLightIndicatorWindowPrivate, nightlight_switch));
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "item_grid", FALSE, NightLightIndicatorWindow_private_offset + G_STRUCT_OFFSET (NightLightIndicatorWindowPrivate, item_grid));
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "temperature_spinbutton", FALSE, NightLightIndicatorWindow_private_offset + G_STRUCT_OFFSET (NightLightIndicatorWindowPrivate, temperature_spinbutton));
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "schedule_combobox", FALSE, NightLightIndicatorWindow_private_offset + G_STRUCT_OFFSET (NightLightIndicatorWindowPrivate, schedule_combobox));
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "schedule_mode_changed", G_CALLBACK(_night_light_indicator_window_schedule_mode_changed_gtk_combo_box_changed));
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "open_settings", G_CALLBACK(_night_light_indicator_window_open_settings_gtk_button_clicked));
#line 398 "IndicatorWindow.c"
}

static void
night_light_indicator_window_instance_init (NightLightIndicatorWindow * self,
                                            gpointer klass)
{
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	self->priv = night_light_indicator_window_get_instance_private (self);
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 409 "IndicatorWindow.c"
}

static void
night_light_indicator_window_finalize (GObject * obj)
{
	NightLightIndicatorWindow * self;
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NIGHT_LIGHT_TYPE_INDICATOR_WINDOW, NightLightIndicatorWindow);
#line 27 "../src/applets/night-light/IndicatorWindow.vala"
	_g_object_unref0 (self->priv->settings);
#line 14 "../src/applets/night-light/IndicatorWindow.vala"
	G_OBJECT_CLASS (night_light_indicator_window_parent_class)->finalize (obj);
#line 422 "IndicatorWindow.c"
}

GType
night_light_indicator_window_get_type (void)
{
	return night_light_indicator_window_type_id;
}

GType
night_light_indicator_window_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NightLightIndicatorWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) night_light_indicator_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NightLightIndicatorWindow), 0, (GInstanceInitFunc) night_light_indicator_window_instance_init, NULL };
	night_light_indicator_window_type_id = g_type_module_register_type (module, budgie_popover_get_type (), "NightLightIndicatorWindow", &g_define_type_info, 0);
	NightLightIndicatorWindow_private_offset = sizeof (NightLightIndicatorWindowPrivate);
	return night_light_indicator_window_type_id;
}

