/* PlacesIndicator.c generated by valac 0.56.3, the Vala compiler
 * generated from PlacesIndicator.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2022 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "placesindicator.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "plugin.h"
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <libpeas/peas.h>

enum  {
	PLACES_INDICATOR_0_PROPERTY,
	PLACES_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* places_indicator_properties[PLACES_INDICATOR_NUM_PROPERTIES];
enum  {
	PLACES_INDICATOR_SETTINGS_0_PROPERTY,
	PLACES_INDICATOR_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* places_indicator_settings_properties[PLACES_INDICATOR_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	PLACES_INDICATOR_APPLET_0_PROPERTY,
	PLACES_INDICATOR_APPLET_UUID_PROPERTY,
	PLACES_INDICATOR_APPLET_NUM_PROPERTIES
};
static GParamSpec* places_indicator_applet_properties[PLACES_INDICATOR_APPLET_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PlacesIndicatorSettingsPrivate {
	GtkSwitch* switch_label;
	GtkSwitch* switch_places;
	GtkSwitch* switch_expand_places;
	GtkSwitch* switch_drives;
	GtkSwitch* switch_networks;
	GSettings* settings;
};

struct _PlacesIndicatorAppletPrivate {
	GtkEventBox* ebox;
	PlacesIndicatorWindow* popover;
	GtkLabel* label;
	GtkImage* image;
	BudgiePanelPosition panel_position;
	BudgiePopoverManager* manager;
	GSettings* settings;
	gchar* _uuid;
};

static gpointer places_indicator_parent_class = NULL;
static BudgiePluginIface * places_indicator_budgie_plugin_parent_iface = NULL;
static GType places_indicator_type_id = 0;
static gint PlacesIndicatorSettings_private_offset;
static gpointer places_indicator_settings_parent_class = NULL;
static GType places_indicator_settings_type_id = 0;
static gint PlacesIndicatorApplet_private_offset;
static gpointer places_indicator_applet_parent_class = NULL;
static GType places_indicator_applet_type_id = 0;

static BudgieApplet* places_indicator_real_get_panel_widget (BudgiePlugin* base,
                                                      const gchar* uuid);
static void places_indicator_settings_finalize (GObject * obj);
static GtkWidget* places_indicator_applet_real_get_settings_ui (BudgieApplet* base);
static gboolean places_indicator_applet_real_supports_settings (BudgieApplet* base);
static void _places_indicator_applet_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                                      const gchar* key,
                                                                      gpointer self);
static gboolean __lambda13_ (PlacesIndicatorApplet* self,
                      GdkEventButton* e);
static gboolean ___lambda13__gtk_widget_button_press_event (GtkWidget* _sender,
                                                     GdkEventButton* event,
                                                     gpointer self);
static void places_indicator_applet_real_panel_position_changed (BudgieApplet* base,
                                                          BudgiePanelPosition position);
static void places_indicator_applet_real_invoke_action (BudgieApplet* base,
                                                 BudgiePanelAction action);
static void places_indicator_applet_real_update_popovers (BudgieApplet* base,
                                                   BudgiePopoverManager* manager);
static void places_indicator_applet_finalize (GObject * obj);
static void _vala_places_indicator_applet_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_places_indicator_applet_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
GType places_indicator_window_register_type (GTypeModule * module);
GType message_revealer_register_type (GTypeModule * module);
GType places_section_register_type (GTypeModule * module);
GType list_item_register_type (GTypeModule * module);
GType volume_item_register_type (GTypeModule * module);
GType mount_item_register_type (GTypeModule * module);
GType place_item_register_type (GTypeModule * module);
GType mount_helper_register_type (GTypeModule * module);

static BudgieApplet*
places_indicator_real_get_panel_widget (BudgiePlugin* base,
                                        const gchar* uuid)
{
	PlacesIndicator * self;
	PlacesIndicatorApplet* _tmp0_;
	BudgieApplet* result;
#line 13 "../src/applets/places-indicator/PlacesIndicator.vala"
	self = (PlacesIndicator*) base;
#line 13 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 14 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp0_ = places_indicator_applet_new (uuid);
#line 14 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_object_ref_sink (_tmp0_);
#line 14 "../src/applets/places-indicator/PlacesIndicator.vala"
	result = (BudgieApplet*) _tmp0_;
#line 14 "../src/applets/places-indicator/PlacesIndicator.vala"
	return result;
#line 133 "PlacesIndicator.c"
}

PlacesIndicator*
places_indicator_construct (GType object_type)
{
	PlacesIndicator * self = NULL;
#line 12 "../src/applets/places-indicator/PlacesIndicator.vala"
	self = (PlacesIndicator*) g_object_new (object_type, NULL);
#line 12 "../src/applets/places-indicator/PlacesIndicator.vala"
	return self;
#line 144 "PlacesIndicator.c"
}

PlacesIndicator*
places_indicator_new (void)
{
#line 12 "../src/applets/places-indicator/PlacesIndicator.vala"
	return places_indicator_construct (TYPE_PLACES_INDICATOR);
#line 152 "PlacesIndicator.c"
}

static void
places_indicator_class_init (PlacesIndicatorClass * klass,
                             gpointer klass_data)
{
#line 12 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_parent_class = g_type_class_peek_parent (klass);
#line 161 "PlacesIndicator.c"
}

static void
places_indicator_budgie_plugin_interface_init (BudgiePluginIface * iface,
                                               gpointer iface_data)
{
#line 12 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_budgie_plugin_parent_iface = g_type_interface_peek_parent (iface);
#line 12 "../src/applets/places-indicator/PlacesIndicator.vala"
	iface->get_panel_widget = (BudgieApplet* (*) (BudgiePlugin*, const gchar*)) places_indicator_real_get_panel_widget;
#line 172 "PlacesIndicator.c"
}

static void
places_indicator_instance_init (PlacesIndicator * self,
                                gpointer klass)
{
}

GType
places_indicator_get_type (void)
{
	return places_indicator_type_id;
}

GType
places_indicator_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlacesIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) places_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlacesIndicator), 0, (GInstanceInitFunc) places_indicator_instance_init, NULL };
	static const GInterfaceInfo budgie_plugin_info = { (GInterfaceInitFunc) places_indicator_budgie_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	places_indicator_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "PlacesIndicator", &g_define_type_info, 0);
	g_type_module_add_interface (module, places_indicator_type_id, budgie_plugin_get_type (), &budgie_plugin_info);
	return places_indicator_type_id;
}

static inline gpointer
places_indicator_settings_get_instance_private (PlacesIndicatorSettings* self)
{
	return G_STRUCT_MEMBER_P (self, PlacesIndicatorSettings_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "../src/applets/places-indicator/PlacesIndicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 208 "PlacesIndicator.c"
}

PlacesIndicatorSettings*
places_indicator_settings_construct (GType object_type,
                                     GSettings* settings)
{
	PlacesIndicatorSettings * self = NULL;
	GSettings* _tmp0_;
	GtkSwitch* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	GtkSwitch* _tmp4_;
	GtkSwitch* _tmp5_;
#line 37 "../src/applets/places-indicator/PlacesIndicator.vala"
	self = (PlacesIndicatorSettings*) g_object_new (object_type, NULL);
#line 38 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 38 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (self->priv->settings);
#line 38 "../src/applets/places-indicator/PlacesIndicator.vala"
	self->priv->settings = _tmp0_;
#line 39 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp1_ = self->priv->switch_label;
#line 39 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_settings_bind (settings, "show-label", (GObject*) _tmp1_, "active", G_SETTINGS_BIND_DEFAULT);
#line 40 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp2_ = self->priv->switch_expand_places;
#line 40 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_settings_bind (settings, "expand-places", (GObject*) _tmp2_, "active", G_SETTINGS_BIND_DEFAULT);
#line 41 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp3_ = self->priv->switch_places;
#line 41 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_settings_bind (settings, "show-places", (GObject*) _tmp3_, "active", G_SETTINGS_BIND_DEFAULT);
#line 42 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp4_ = self->priv->switch_drives;
#line 42 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_settings_bind (settings, "show-drives", (GObject*) _tmp4_, "active", G_SETTINGS_BIND_DEFAULT);
#line 43 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp5_ = self->priv->switch_networks;
#line 43 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_settings_bind (settings, "show-networks", (GObject*) _tmp5_, "active", G_SETTINGS_BIND_DEFAULT);
#line 37 "../src/applets/places-indicator/PlacesIndicator.vala"
	return self;
#line 252 "PlacesIndicator.c"
}

PlacesIndicatorSettings*
places_indicator_settings_new (GSettings* settings)
{
#line 37 "../src/applets/places-indicator/PlacesIndicator.vala"
	return places_indicator_settings_construct (TYPE_PLACES_INDICATOR_SETTINGS, settings);
#line 260 "PlacesIndicator.c"
}

static void
places_indicator_settings_class_init (PlacesIndicatorSettingsClass * klass,
                                      gpointer klass_data)
{
#line 19 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_settings_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_type_class_adjust_private_offset (klass, &PlacesIndicatorSettings_private_offset);
#line 19 "../src/applets/places-indicator/PlacesIndicator.vala"
	G_OBJECT_CLASS (klass)->finalize = places_indicator_settings_finalize;
#line 19 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/solus-project/places-indicator/settings.ui");
#line 19 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "switch_label", FALSE, PlacesIndicatorSettings_private_offset + G_STRUCT_OFFSET (PlacesIndicatorSettingsPrivate, switch_label));
#line 19 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "switch_places", FALSE, PlacesIndicatorSettings_private_offset + G_STRUCT_OFFSET (PlacesIndicatorSettingsPrivate, switch_places));
#line 19 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "switch_expand_places", FALSE, PlacesIndicatorSettings_private_offset + G_STRUCT_OFFSET (PlacesIndicatorSettingsPrivate, switch_expand_places));
#line 19 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "switch_drives", FALSE, PlacesIndicatorSettings_private_offset + G_STRUCT_OFFSET (PlacesIndicatorSettingsPrivate, switch_drives));
#line 19 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "switch_networks", FALSE, PlacesIndicatorSettings_private_offset + G_STRUCT_OFFSET (PlacesIndicatorSettingsPrivate, switch_networks));
#line 285 "PlacesIndicator.c"
}

static void
places_indicator_settings_instance_init (PlacesIndicatorSettings * self,
                                         gpointer klass)
{
#line 19 "../src/applets/places-indicator/PlacesIndicator.vala"
	self->priv = places_indicator_settings_get_instance_private (self);
#line 19 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 296 "PlacesIndicator.c"
}

static void
places_indicator_settings_finalize (GObject * obj)
{
	PlacesIndicatorSettings * self;
#line 19 "../src/applets/places-indicator/PlacesIndicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PLACES_INDICATOR_SETTINGS, PlacesIndicatorSettings);
#line 35 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (self->priv->settings);
#line 19 "../src/applets/places-indicator/PlacesIndicator.vala"
	G_OBJECT_CLASS (places_indicator_settings_parent_class)->finalize (obj);
#line 309 "PlacesIndicator.c"
}

GType
places_indicator_settings_get_type (void)
{
	return places_indicator_settings_type_id;
}

GType
places_indicator_settings_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlacesIndicatorSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) places_indicator_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlacesIndicatorSettings), 0, (GInstanceInitFunc) places_indicator_settings_instance_init, NULL };
	places_indicator_settings_type_id = g_type_module_register_type (module, gtk_grid_get_type (), "PlacesIndicatorSettings", &g_define_type_info, 0);
	PlacesIndicatorSettings_private_offset = sizeof (PlacesIndicatorSettingsPrivate);
	return places_indicator_settings_type_id;
}

static inline gpointer
places_indicator_applet_get_instance_private (PlacesIndicatorApplet* self)
{
	return G_STRUCT_MEMBER_P (self, PlacesIndicatorApplet_private_offset);
}

static GtkWidget*
places_indicator_applet_real_get_settings_ui (BudgieApplet* base)
{
	PlacesIndicatorApplet * self;
	const gchar* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	PlacesIndicatorSettings* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* result;
#line 58 "../src/applets/places-indicator/PlacesIndicator.vala"
	self = (PlacesIndicatorApplet*) base;
#line 59 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp0_ = self->priv->_uuid;
#line 59 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp1_ = budgie_applet_get_applet_settings ((BudgieApplet*) self, _tmp0_);
#line 59 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp2_ = _tmp1_;
#line 59 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp3_ = places_indicator_settings_new (_tmp2_);
#line 59 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_object_ref_sink (_tmp3_);
#line 59 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp4_ = (GtkWidget*) _tmp3_;
#line 59 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (_tmp2_);
#line 59 "../src/applets/places-indicator/PlacesIndicator.vala"
	result = _tmp4_;
#line 59 "../src/applets/places-indicator/PlacesIndicator.vala"
	return result;
#line 363 "PlacesIndicator.c"
}

static gboolean
places_indicator_applet_real_supports_settings (BudgieApplet* base)
{
	PlacesIndicatorApplet * self;
	gboolean result;
#line 62 "../src/applets/places-indicator/PlacesIndicator.vala"
	self = (PlacesIndicatorApplet*) base;
#line 63 "../src/applets/places-indicator/PlacesIndicator.vala"
	result = TRUE;
#line 63 "../src/applets/places-indicator/PlacesIndicator.vala"
	return result;
#line 377 "PlacesIndicator.c"
}

static void
_places_indicator_applet_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                                 const gchar* key,
                                                                 gpointer self)
{
#line 73 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_applet_on_settings_changed ((PlacesIndicatorApplet*) self, key);
#line 387 "PlacesIndicator.c"
}

static gboolean
__lambda13_ (PlacesIndicatorApplet* self,
             GdkEventButton* e)
{
	gboolean result;
#line 86 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 87 "../src/applets/places-indicator/PlacesIndicator.vala"
	if (e->button != ((guint) 1)) {
#line 88 "../src/applets/places-indicator/PlacesIndicator.vala"
		result = GDK_EVENT_PROPAGATE;
#line 88 "../src/applets/places-indicator/PlacesIndicator.vala"
		return result;
#line 403 "PlacesIndicator.c"
	}
#line 90 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_applet_toggle_popover (self);
#line 91 "../src/applets/places-indicator/PlacesIndicator.vala"
	result = GDK_EVENT_STOP;
#line 91 "../src/applets/places-indicator/PlacesIndicator.vala"
	return result;
#line 411 "PlacesIndicator.c"
}

static gboolean
___lambda13__gtk_widget_button_press_event (GtkWidget* _sender,
                                            GdkEventButton* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda13_ ((PlacesIndicatorApplet*) self, event);
#line 86 "../src/applets/places-indicator/PlacesIndicator.vala"
	return result;
#line 423 "PlacesIndicator.c"
}

PlacesIndicatorApplet*
places_indicator_applet_construct (GType object_type,
                                   const gchar* uuid)
{
	PlacesIndicatorApplet * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkEventBox* _tmp2_;
	GtkBox* layout = NULL;
	GtkBox* _tmp3_;
	GtkEventBox* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkImage* _tmp10_;
	PlacesIndicatorWindow* _tmp11_;
	GtkEventBox* _tmp12_;
	PlacesIndicatorWindow* _tmp13_;
	GtkWidget* _tmp14_;
	GtkEventBox* _tmp15_;
#line 66 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 67 "../src/applets/places-indicator/PlacesIndicator.vala"
	self = (PlacesIndicatorApplet*) g_object_new (object_type, "uuid", uuid, NULL);
#line 69 "../src/applets/places-indicator/PlacesIndicator.vala"
	budgie_applet_set_settings_schema ((BudgieApplet*) self, "com.solus-project.places-indicator");
#line 70 "../src/applets/places-indicator/PlacesIndicator.vala"
	budgie_applet_set_settings_prefix ((BudgieApplet*) self, "/com/solus-project/budgie-panel/instance/places-indicator");
#line 72 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp0_ = budgie_applet_get_applet_settings ((BudgieApplet*) self, uuid);
#line 72 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (self->priv->settings);
#line 72 "../src/applets/places-indicator/PlacesIndicator.vala"
	self->priv->settings = _tmp0_;
#line 73 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp1_ = self->priv->settings;
#line 73 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_signal_connect_object (_tmp1_, "changed", (GCallback) _places_indicator_applet_on_settings_changed_g_settings_changed, self, 0);
#line 75 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp2_ = (GtkEventBox*) gtk_event_box_new ();
#line 75 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_object_ref_sink (_tmp2_);
#line 75 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (self->priv->ebox);
#line 75 "../src/applets/places-indicator/PlacesIndicator.vala"
	self->priv->ebox = _tmp2_;
#line 76 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 76 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_object_ref_sink (_tmp3_);
#line 76 "../src/applets/places-indicator/PlacesIndicator.vala"
	layout = _tmp3_;
#line 77 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp4_ = self->priv->ebox;
#line 77 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) layout);
#line 78 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("folder-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 78 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_object_ref_sink (_tmp5_);
#line 78 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (self->priv->image);
#line 78 "../src/applets/places-indicator/PlacesIndicator.vala"
	self->priv->image = _tmp5_;
#line 79 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp6_ = self->priv->image;
#line 79 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_box_pack_start (layout, (GtkWidget*) _tmp6_, TRUE, TRUE, (guint) 3);
#line 80 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new (_ ("Places"));
#line 80 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_object_ref_sink (_tmp7_);
#line 80 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (self->priv->label);
#line 80 "../src/applets/places-indicator/PlacesIndicator.vala"
	self->priv->label = _tmp7_;
#line 81 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp8_ = self->priv->label;
#line 81 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_START);
#line 82 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp9_ = self->priv->label;
#line 82 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_box_pack_start (layout, (GtkWidget*) _tmp9_, TRUE, TRUE, (guint) 3);
#line 84 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp10_ = self->priv->image;
#line 84 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp11_ = places_indicator_window_new ((GtkWidget*) _tmp10_);
#line 84 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_object_ref_sink (_tmp11_);
#line 84 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (self->priv->popover);
#line 84 "../src/applets/places-indicator/PlacesIndicator.vala"
	self->priv->popover = _tmp11_;
#line 86 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp12_ = self->priv->ebox;
#line 86 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_signal_connect_object ((GtkWidget*) _tmp12_, "button-press-event", (GCallback) ___lambda13__gtk_widget_button_press_event, self, 0);
#line 94 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp13_ = self->priv->popover;
#line 94 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp14_ = gtk_bin_get_child ((GtkBin*) _tmp13_);
#line 94 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_widget_show_all (_tmp14_);
#line 96 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp15_ = self->priv->ebox;
#line 96 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp15_);
#line 97 "../src/applets/places-indicator/PlacesIndicator.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 99 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_applet_on_settings_changed (self, "show-label");
#line 100 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_applet_on_settings_changed (self, "expand-places");
#line 101 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_applet_on_settings_changed (self, "show-places");
#line 102 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_applet_on_settings_changed (self, "show-drives");
#line 103 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_applet_on_settings_changed (self, "show-networks");
#line 66 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (layout);
#line 66 "../src/applets/places-indicator/PlacesIndicator.vala"
	return self;
#line 552 "PlacesIndicator.c"
}

PlacesIndicatorApplet*
places_indicator_applet_new (const gchar* uuid)
{
#line 66 "../src/applets/places-indicator/PlacesIndicator.vala"
	return places_indicator_applet_construct (TYPE_PLACES_INDICATOR_APPLET, uuid);
#line 560 "PlacesIndicator.c"
}

static void
places_indicator_applet_real_panel_position_changed (BudgieApplet* base,
                                                     BudgiePanelPosition position)
{
	PlacesIndicatorApplet * self;
#line 106 "../src/applets/places-indicator/PlacesIndicator.vala"
	self = (PlacesIndicatorApplet*) base;
#line 107 "../src/applets/places-indicator/PlacesIndicator.vala"
	self->priv->panel_position = position;
#line 108 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_applet_on_settings_changed (self, "show-label");
#line 574 "PlacesIndicator.c"
}

void
places_indicator_applet_toggle_popover (PlacesIndicatorApplet* self)
{
	PlacesIndicatorWindow* _tmp0_;
#line 111 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_return_if_fail (self != NULL);
#line 112 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp0_ = self->priv->popover;
#line 112 "../src/applets/places-indicator/PlacesIndicator.vala"
	if (gtk_widget_get_visible ((GtkWidget*) _tmp0_)) {
#line 587 "PlacesIndicator.c"
		PlacesIndicatorWindow* _tmp1_;
#line 113 "../src/applets/places-indicator/PlacesIndicator.vala"
		_tmp1_ = self->priv->popover;
#line 113 "../src/applets/places-indicator/PlacesIndicator.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 593 "PlacesIndicator.c"
	} else {
		PlacesIndicatorWindow* _tmp2_;
		GtkWidget* _tmp3_;
		BudgiePopoverManager* _tmp4_;
		GtkEventBox* _tmp5_;
#line 115 "../src/applets/places-indicator/PlacesIndicator.vala"
		_tmp2_ = self->priv->popover;
#line 115 "../src/applets/places-indicator/PlacesIndicator.vala"
		_tmp3_ = gtk_bin_get_child ((GtkBin*) _tmp2_);
#line 115 "../src/applets/places-indicator/PlacesIndicator.vala"
		gtk_widget_show_all (_tmp3_);
#line 116 "../src/applets/places-indicator/PlacesIndicator.vala"
		_tmp4_ = self->priv->manager;
#line 116 "../src/applets/places-indicator/PlacesIndicator.vala"
		_tmp5_ = self->priv->ebox;
#line 116 "../src/applets/places-indicator/PlacesIndicator.vala"
		budgie_popover_manager_show_popover (_tmp4_, (GtkWidget*) _tmp5_);
#line 611 "PlacesIndicator.c"
	}
}

static void
places_indicator_applet_real_invoke_action (BudgieApplet* base,
                                            BudgiePanelAction action)
{
	PlacesIndicatorApplet * self;
#line 120 "../src/applets/places-indicator/PlacesIndicator.vala"
	self = (PlacesIndicatorApplet*) base;
#line 121 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_applet_toggle_popover (self);
#line 624 "PlacesIndicator.c"
}

static void
places_indicator_applet_real_update_popovers (BudgieApplet* base,
                                              BudgiePopoverManager* manager)
{
	PlacesIndicatorApplet * self;
	GtkEventBox* _tmp0_;
	PlacesIndicatorWindow* _tmp1_;
#line 124 "../src/applets/places-indicator/PlacesIndicator.vala"
	self = (PlacesIndicatorApplet*) base;
#line 125 "../src/applets/places-indicator/PlacesIndicator.vala"
	self->priv->manager = manager;
#line 126 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp0_ = self->priv->ebox;
#line 126 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp1_ = self->priv->popover;
#line 126 "../src/applets/places-indicator/PlacesIndicator.vala"
	budgie_popover_manager_register_popover (manager, (GtkWidget*) _tmp0_, (BudgiePopover*) _tmp1_);
#line 644 "PlacesIndicator.c"
}

void
places_indicator_applet_on_settings_changed (PlacesIndicatorApplet* self,
                                             const gchar* key)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
	static GQuark _tmp1_label0 = 0;
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
	static GQuark _tmp1_label1 = 0;
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
	static GQuark _tmp1_label2 = 0;
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
	static GQuark _tmp1_label3 = 0;
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
	static GQuark _tmp1_label4 = 0;
#line 129 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_return_if_fail (key != NULL);
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp0_ = key;
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("show-label")))) {
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
		switch (0) {
#line 675 "PlacesIndicator.c"
			default:
			{
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
				gboolean visible = FALSE;
				GtkLabel* _tmp6_;
#line 132 "../src/applets/places-indicator/PlacesIndicator.vala"
				if (self->priv->panel_position == BUDGIE_PANEL_POSITION_TOP) {
#line 132 "../src/applets/places-indicator/PlacesIndicator.vala"
					_tmp4_ = TRUE;
#line 686 "PlacesIndicator.c"
				} else {
#line 133 "../src/applets/places-indicator/PlacesIndicator.vala"
					_tmp4_ = self->priv->panel_position == BUDGIE_PANEL_POSITION_BOTTOM;
#line 690 "PlacesIndicator.c"
				}
#line 132 "../src/applets/places-indicator/PlacesIndicator.vala"
				if (_tmp4_) {
#line 694 "PlacesIndicator.c"
					GSettings* _tmp5_;
#line 134 "../src/applets/places-indicator/PlacesIndicator.vala"
					_tmp5_ = self->priv->settings;
#line 134 "../src/applets/places-indicator/PlacesIndicator.vala"
					_tmp3_ = g_settings_get_boolean (_tmp5_, key);
#line 700 "PlacesIndicator.c"
				} else {
#line 132 "../src/applets/places-indicator/PlacesIndicator.vala"
					_tmp3_ = FALSE;
#line 704 "PlacesIndicator.c"
				}
#line 132 "../src/applets/places-indicator/PlacesIndicator.vala"
				visible = _tmp3_;
#line 135 "../src/applets/places-indicator/PlacesIndicator.vala"
				_tmp6_ = self->priv->label;
#line 135 "../src/applets/places-indicator/PlacesIndicator.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp6_, visible);
#line 136 "../src/applets/places-indicator/PlacesIndicator.vala"
				break;
#line 714 "PlacesIndicator.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("expand-places")))) {
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
		switch (0) {
#line 720 "PlacesIndicator.c"
			default:
			{
				PlacesIndicatorWindow* _tmp7_;
				GSettings* _tmp8_;
#line 138 "../src/applets/places-indicator/PlacesIndicator.vala"
				_tmp7_ = self->priv->popover;
#line 138 "../src/applets/places-indicator/PlacesIndicator.vala"
				_tmp8_ = self->priv->settings;
#line 138 "../src/applets/places-indicator/PlacesIndicator.vala"
				places_indicator_window_set_expand_places (_tmp7_, g_settings_get_boolean (_tmp8_, key));
#line 139 "../src/applets/places-indicator/PlacesIndicator.vala"
				break;
#line 733 "PlacesIndicator.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("show-places")))) {
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
		switch (0) {
#line 739 "PlacesIndicator.c"
			default:
			{
				PlacesIndicatorWindow* _tmp9_;
				GSettings* _tmp10_;
#line 141 "../src/applets/places-indicator/PlacesIndicator.vala"
				_tmp9_ = self->priv->popover;
#line 141 "../src/applets/places-indicator/PlacesIndicator.vala"
				_tmp10_ = self->priv->settings;
#line 141 "../src/applets/places-indicator/PlacesIndicator.vala"
				places_indicator_window_set_show_places (_tmp9_, g_settings_get_boolean (_tmp10_, key));
#line 142 "../src/applets/places-indicator/PlacesIndicator.vala"
				break;
#line 752 "PlacesIndicator.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("show-drives")))) {
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
		switch (0) {
#line 758 "PlacesIndicator.c"
			default:
			{
				PlacesIndicatorWindow* _tmp11_;
				GSettings* _tmp12_;
#line 144 "../src/applets/places-indicator/PlacesIndicator.vala"
				_tmp11_ = self->priv->popover;
#line 144 "../src/applets/places-indicator/PlacesIndicator.vala"
				_tmp12_ = self->priv->settings;
#line 144 "../src/applets/places-indicator/PlacesIndicator.vala"
				places_indicator_window_set_show_drives (_tmp11_, g_settings_get_boolean (_tmp12_, key));
#line 145 "../src/applets/places-indicator/PlacesIndicator.vala"
				break;
#line 771 "PlacesIndicator.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("show-networks")))) {
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
		switch (0) {
#line 777 "PlacesIndicator.c"
			default:
			{
				PlacesIndicatorWindow* _tmp13_;
				GSettings* _tmp14_;
#line 147 "../src/applets/places-indicator/PlacesIndicator.vala"
				_tmp13_ = self->priv->popover;
#line 147 "../src/applets/places-indicator/PlacesIndicator.vala"
				_tmp14_ = self->priv->settings;
#line 147 "../src/applets/places-indicator/PlacesIndicator.vala"
				places_indicator_window_set_show_networks (_tmp13_, g_settings_get_boolean (_tmp14_, key));
#line 148 "../src/applets/places-indicator/PlacesIndicator.vala"
				break;
#line 790 "PlacesIndicator.c"
			}
		}
	} else {
#line 130 "../src/applets/places-indicator/PlacesIndicator.vala"
		switch (0) {
#line 796 "PlacesIndicator.c"
			default:
			{
#line 150 "../src/applets/places-indicator/PlacesIndicator.vala"
				break;
#line 801 "PlacesIndicator.c"
			}
		}
	}
}

const gchar*
places_indicator_applet_get_uuid (PlacesIndicatorApplet* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 56 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp0_ = self->priv->_uuid;
#line 56 "../src/applets/places-indicator/PlacesIndicator.vala"
	result = _tmp0_;
#line 56 "../src/applets/places-indicator/PlacesIndicator.vala"
	return result;
#line 820 "PlacesIndicator.c"
}

void
places_indicator_applet_set_uuid (PlacesIndicatorApplet* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 56 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/applets/places-indicator/PlacesIndicator.vala"
	old_value = places_indicator_applet_get_uuid (self);
#line 56 "../src/applets/places-indicator/PlacesIndicator.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 834 "PlacesIndicator.c"
		gchar* _tmp0_;
#line 56 "../src/applets/places-indicator/PlacesIndicator.vala"
		_tmp0_ = g_strdup (value);
#line 56 "../src/applets/places-indicator/PlacesIndicator.vala"
		_g_free0 (self->priv->_uuid);
#line 56 "../src/applets/places-indicator/PlacesIndicator.vala"
		self->priv->_uuid = _tmp0_;
#line 56 "../src/applets/places-indicator/PlacesIndicator.vala"
		g_object_notify_by_pspec ((GObject *) self, places_indicator_applet_properties[PLACES_INDICATOR_APPLET_UUID_PROPERTY]);
#line 844 "PlacesIndicator.c"
	}
}

static void
places_indicator_applet_class_init (PlacesIndicatorAppletClass * klass,
                                    gpointer klass_data)
{
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_applet_parent_class = g_type_class_peek_parent (klass);
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_type_class_adjust_private_offset (klass, &PlacesIndicatorApplet_private_offset);
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	((BudgieAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (BudgieApplet*)) places_indicator_applet_real_get_settings_ui;
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	((BudgieAppletClass *) klass)->supports_settings = (gboolean (*) (BudgieApplet*)) places_indicator_applet_real_supports_settings;
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	((BudgieAppletClass *) klass)->panel_position_changed = (void (*) (BudgieApplet*, BudgiePanelPosition)) places_indicator_applet_real_panel_position_changed;
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	((BudgieAppletClass *) klass)->invoke_action = (void (*) (BudgieApplet*, BudgiePanelAction)) places_indicator_applet_real_invoke_action;
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	((BudgieAppletClass *) klass)->update_popovers = (void (*) (BudgieApplet*, BudgiePopoverManager*)) places_indicator_applet_real_update_popovers;
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_places_indicator_applet_get_property;
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_places_indicator_applet_set_property;
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	G_OBJECT_CLASS (klass)->finalize = places_indicator_applet_finalize;
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLACES_INDICATOR_APPLET_UUID_PROPERTY, places_indicator_applet_properties[PLACES_INDICATOR_APPLET_UUID_PROPERTY] = g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 874 "PlacesIndicator.c"
}

static void
places_indicator_applet_instance_init (PlacesIndicatorApplet * self,
                                       gpointer klass)
{
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	self->priv = places_indicator_applet_get_instance_private (self);
#line 52 "../src/applets/places-indicator/PlacesIndicator.vala"
	self->priv->panel_position = BUDGIE_PANEL_POSITION_BOTTOM;
#line 54 "../src/applets/places-indicator/PlacesIndicator.vala"
	self->priv->manager = NULL;
#line 887 "PlacesIndicator.c"
}

static void
places_indicator_applet_finalize (GObject * obj)
{
	PlacesIndicatorApplet * self;
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PLACES_INDICATOR_APPLET, PlacesIndicatorApplet);
#line 48 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (self->priv->ebox);
#line 49 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (self->priv->popover);
#line 50 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (self->priv->label);
#line 51 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (self->priv->image);
#line 55 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (self->priv->settings);
#line 56 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_free0 (self->priv->_uuid);
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	G_OBJECT_CLASS (places_indicator_applet_parent_class)->finalize (obj);
#line 910 "PlacesIndicator.c"
}

GType
places_indicator_applet_get_type (void)
{
	return places_indicator_applet_type_id;
}

GType
places_indicator_applet_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlacesIndicatorAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) places_indicator_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlacesIndicatorApplet), 0, (GInstanceInitFunc) places_indicator_applet_instance_init, NULL };
	places_indicator_applet_type_id = g_type_module_register_type (module, budgie_applet_get_type (), "PlacesIndicatorApplet", &g_define_type_info, 0);
	PlacesIndicatorApplet_private_offset = sizeof (PlacesIndicatorAppletPrivate);
	return places_indicator_applet_type_id;
}

static void
_vala_places_indicator_applet_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	PlacesIndicatorApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PLACES_INDICATOR_APPLET, PlacesIndicatorApplet);
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	switch (property_id) {
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
		case PLACES_INDICATOR_APPLET_UUID_PROPERTY:
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
		g_value_set_string (value, places_indicator_applet_get_uuid (self));
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
		break;
#line 944 "PlacesIndicator.c"
		default:
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
		break;
#line 950 "PlacesIndicator.c"
	}
}

static void
_vala_places_indicator_applet_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	PlacesIndicatorApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PLACES_INDICATOR_APPLET, PlacesIndicatorApplet);
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
	switch (property_id) {
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
		case PLACES_INDICATOR_APPLET_UUID_PROPERTY:
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
		places_indicator_applet_set_uuid (self, g_value_get_string (value));
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
		break;
#line 970 "PlacesIndicator.c"
		default:
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 47 "../src/applets/places-indicator/PlacesIndicator.vala"
		break;
#line 976 "PlacesIndicator.c"
	}
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* objmodule = NULL;
	PeasObjectModule* _tmp0_;
#line 156 "../src/applets/places-indicator/PlacesIndicator.vala"
	g_return_if_fail (module != NULL);
#line 156 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_register_type (module);
#line 156 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_settings_register_type (module);
#line 156 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_applet_register_type (module);
#line 156 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_indicator_window_register_type (module);
#line 156 "../src/applets/places-indicator/PlacesIndicator.vala"
	message_revealer_register_type (module);
#line 156 "../src/applets/places-indicator/PlacesIndicator.vala"
	places_section_register_type (module);
#line 156 "../src/applets/places-indicator/PlacesIndicator.vala"
	list_item_register_type (module);
#line 156 "../src/applets/places-indicator/PlacesIndicator.vala"
	volume_item_register_type (module);
#line 156 "../src/applets/places-indicator/PlacesIndicator.vala"
	mount_item_register_type (module);
#line 156 "../src/applets/places-indicator/PlacesIndicator.vala"
	place_item_register_type (module);
#line 156 "../src/applets/places-indicator/PlacesIndicator.vala"
	mount_helper_register_type (module);
#line 158 "../src/applets/places-indicator/PlacesIndicator.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
#line 158 "../src/applets/places-indicator/PlacesIndicator.vala"
	objmodule = _tmp0_;
#line 159 "../src/applets/places-indicator/PlacesIndicator.vala"
	peas_object_module_register_extension_type (objmodule, budgie_plugin_get_type (), TYPE_PLACES_INDICATOR);
#line 156 "../src/applets/places-indicator/PlacesIndicator.vala"
	_g_object_unref0 (objmodule);
#line 1017 "PlacesIndicator.c"
}

