/* PowerIndicator.c generated by valac 0.56.3, the Vala compiler
 * generated from PowerIndicator.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2022 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "statusapplet.h"
#include <upower.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <float.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include "plugin.h"
#include <gio/gdesktopappinfo.h>

enum  {
	BATTERY_ICON_0_PROPERTY,
	BATTERY_ICON_BATTERY_PROPERTY,
	BATTERY_ICON_LABEL_VISIBLE_PROPERTY,
	BATTERY_ICON_NUM_PROPERTIES
};
static GParamSpec* battery_icon_properties[BATTERY_ICON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	POWER_INDICATOR_0_PROPERTY,
	POWER_INDICATOR_CLIENT_PROPERTY,
	POWER_INDICATOR_LABEL_VISIBLE_PROPERTY,
	POWER_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* power_indicator_properties[POWER_INDICATOR_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))

struct _BatteryIconPrivate {
	UpDevice* _battery;
	gboolean changing;
	gboolean emitted_warning;
	GtkImage* image;
	GtkLabel* percent_label;
};

struct _PowerIndicatorPrivate {
	GtkBox* widget;
	UpClient* _client;
	GHashTable* devices;
	gboolean _label_visible;
	GtkCheckButton* check_percent;
	GSettings* battery_settings;
};

static gint BatteryIcon_private_offset;
static gpointer battery_icon_parent_class = NULL;
static GType battery_icon_type_id = 0;
static gint PowerIndicator_private_offset;
static gpointer power_indicator_parent_class = NULL;
static GType power_indicator_type_id = 0;

static void battery_icon_on_battery_change (BatteryIcon* self,
                                     GObject* o,
                                     GParamSpec* sp);
static void _battery_icon_on_battery_change_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void battery_icon_finalize (GObject * obj);
static void _vala_battery_icon_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_battery_icon_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void power_indicator_update_labels (PowerIndicator* self);
static void _power_indicator_update_labels_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void power_indicator_open_power_settings (PowerIndicator* self);
static void _power_indicator_open_power_settings_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void power_indicator_sync_devices (PowerIndicator* self);
static void power_indicator_on_device_added (PowerIndicator* self,
                                      UpDevice* device);
static void _power_indicator_on_device_added_up__client_device_added (UpClient* _sender,
                                                               UpDevice* device,
                                                               gpointer self);
static void power_indicator_on_device_removed (PowerIndicator* self,
                                        const gchar* object_path);
static void _power_indicator_on_device_removed_up__client_device_removed (UpClient* _sender,
                                                                   const gchar* object_path,
                                                                   gpointer self);
static void power_indicator_toggle_show (PowerIndicator* self);
static gboolean power_indicator_is_interesting (PowerIndicator* self,
                                         UpDevice* device);
static void __lambda10_ (PowerIndicator* self,
                  UpDevice* device);
static void ___lambda10__gfunc (gconstpointer data,
                         gpointer self);
static void power_indicator_finalize (GObject * obj);
static void _vala_power_indicator_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_power_indicator_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
battery_icon_get_instance_private (BatteryIcon* self)
{
	return G_STRUCT_MEMBER_P (self, BatteryIcon_private_offset);
}

static void
_battery_icon_on_battery_change_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 56 "../src/applets/status/PowerIndicator.vala"
	battery_icon_on_battery_change ((BatteryIcon*) self, _sender, pspec);
#line 139 "PowerIndicator.c"
}

BatteryIcon*
battery_icon_construct (GType object_type,
                        UpDevice* battery)
{
	BatteryIcon * self = NULL;
	GtkStyleContext* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	GtkImage* _tmp11_;
#line 35 "../src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 36 "../src/applets/status/PowerIndicator.vala"
	self = (BatteryIcon*) g_object_new (object_type, "orientation", GTK_ORIENTATION_HORIZONTAL, "spacing", 0, NULL);
#line 38 "../src/applets/status/PowerIndicator.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 38 "../src/applets/status/PowerIndicator.vala"
	gtk_style_context_add_class (_tmp0_, "battery-icon");
#line 41 "../src/applets/status/PowerIndicator.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new ("");
#line 41 "../src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp1_);
#line 41 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->percent_label);
#line 41 "../src/applets/status/PowerIndicator.vala"
	self->priv->percent_label = _tmp1_;
#line 42 "../src/applets/status/PowerIndicator.vala"
	_tmp2_ = self->priv->percent_label;
#line 42 "../src/applets/status/PowerIndicator.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 42 "../src/applets/status/PowerIndicator.vala"
	gtk_style_context_add_class (_tmp3_, "percent-label");
#line 44 "../src/applets/status/PowerIndicator.vala"
	_tmp4_ = self->priv->percent_label;
#line 44 "../src/applets/status/PowerIndicator.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
#line 45 "../src/applets/status/PowerIndicator.vala"
	_tmp5_ = self->priv->percent_label;
#line 45 "../src/applets/status/PowerIndicator.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp5_, 4);
#line 46 "../src/applets/status/PowerIndicator.vala"
	_tmp6_ = self->priv->percent_label;
#line 46 "../src/applets/status/PowerIndicator.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp6_, FALSE, FALSE, (guint) 0);
#line 47 "../src/applets/status/PowerIndicator.vala"
	_tmp7_ = self->priv->percent_label;
#line 47 "../src/applets/status/PowerIndicator.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp7_, TRUE);
#line 49 "../src/applets/status/PowerIndicator.vala"
	_tmp8_ = (GtkImage*) gtk_image_new ();
#line 49 "../src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp8_);
#line 49 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->image);
#line 49 "../src/applets/status/PowerIndicator.vala"
	self->priv->image = _tmp8_;
#line 50 "../src/applets/status/PowerIndicator.vala"
	_tmp9_ = self->priv->image;
#line 50 "../src/applets/status/PowerIndicator.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp9_, GTK_ALIGN_CENTER);
#line 51 "../src/applets/status/PowerIndicator.vala"
	_tmp10_ = self->priv->image;
#line 51 "../src/applets/status/PowerIndicator.vala"
	gtk_image_set_pixel_size (_tmp10_, 0);
#line 52 "../src/applets/status/PowerIndicator.vala"
	_tmp11_ = self->priv->image;
#line 52 "../src/applets/status/PowerIndicator.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp11_, FALSE, FALSE, (guint) 0);
#line 54 "../src/applets/status/PowerIndicator.vala"
	battery_icon_update_ui (self, battery);
#line 56 "../src/applets/status/PowerIndicator.vala"
	g_signal_connect_object ((GObject*) battery, "notify", (GCallback) _battery_icon_on_battery_change_g_object_notify, self, 0);
#line 35 "../src/applets/status/PowerIndicator.vala"
	return self;
#line 223 "PowerIndicator.c"
}

BatteryIcon*
battery_icon_new (UpDevice* battery)
{
#line 35 "../src/applets/status/PowerIndicator.vala"
	return battery_icon_construct (TYPE_BATTERY_ICON, battery);
#line 231 "PowerIndicator.c"
}

static void
battery_icon_on_battery_change (BatteryIcon* self,
                                GObject* o,
                                GParamSpec* sp)
{
	UpDevice* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 59 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (o != NULL);
#line 59 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (sp != NULL);
#line 60 "../src/applets/status/PowerIndicator.vala"
	if (self->priv->changing) {
#line 61 "../src/applets/status/PowerIndicator.vala"
		return;
#line 251 "PowerIndicator.c"
	}
#line 63 "../src/applets/status/PowerIndicator.vala"
	self->priv->changing = TRUE;
#line 255 "PowerIndicator.c"
	{
		UpDevice* _tmp0_;
#line 65 "../src/applets/status/PowerIndicator.vala"
		_tmp0_ = self->priv->_battery;
#line 65 "../src/applets/status/PowerIndicator.vala"
		up_device_refresh_sync (_tmp0_, NULL, &_inner_error0_);
#line 65 "../src/applets/status/PowerIndicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 264 "PowerIndicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
#line 64 "../src/applets/status/PowerIndicator.vala"
		e = _inner_error0_;
#line 64 "../src/applets/status/PowerIndicator.vala"
		_inner_error0_ = NULL;
#line 67 "../src/applets/status/PowerIndicator.vala"
		if (!self->priv->emitted_warning) {
#line 278 "PowerIndicator.c"
			GError* _tmp1_;
			const gchar* _tmp2_;
#line 68 "../src/applets/status/PowerIndicator.vala"
			_tmp1_ = e;
#line 68 "../src/applets/status/PowerIndicator.vala"
			_tmp2_ = _tmp1_->message;
#line 68 "../src/applets/status/PowerIndicator.vala"
			g_warning ("PowerIndicator.vala:68: Failed to refresh battery: %s", _tmp2_);
#line 69 "../src/applets/status/PowerIndicator.vala"
			self->priv->emitted_warning = TRUE;
#line 289 "PowerIndicator.c"
		}
#line 64 "../src/applets/status/PowerIndicator.vala"
		_g_error_free0 (e);
#line 293 "PowerIndicator.c"
	}
	__finally0:
#line 64 "../src/applets/status/PowerIndicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../src/applets/status/PowerIndicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../src/applets/status/PowerIndicator.vala"
		g_clear_error (&_inner_error0_);
#line 64 "../src/applets/status/PowerIndicator.vala"
		return;
#line 304 "PowerIndicator.c"
	}
#line 73 "../src/applets/status/PowerIndicator.vala"
	_tmp3_ = self->priv->_battery;
#line 73 "../src/applets/status/PowerIndicator.vala"
	battery_icon_update_ui (self, _tmp3_);
#line 74 "../src/applets/status/PowerIndicator.vala"
	self->priv->changing = FALSE;
#line 312 "PowerIndicator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 136 "../src/applets/status/PowerIndicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 320 "PowerIndicator.c"
}

void
battery_icon_update_ui (BatteryIcon* self,
                        UpDevice* battery)
{
	gchar* tip = NULL;
	gchar* image_name = NULL;
	gint rounded = 0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gchar* image_fallback = NULL;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gchar* _tmp12_;
	guint _tmp13_;
	guint _tmp14_;
	gchar* labe = NULL;
	gdouble _tmp44_;
	gdouble _tmp45_;
	gchar* _tmp46_;
	gchar* old = NULL;
	GtkLabel* _tmp47_;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp54_;
	GtkIconTheme* theme = NULL;
	GtkIconTheme* _tmp55_;
	GtkIconTheme* _tmp56_;
	GtkIconInfo* _result_ = NULL;
	GtkIconTheme* _tmp57_;
	const gchar* _tmp58_;
	GtkIconInfo* _tmp59_;
	GtkIconInfo* _tmp60_;
#line 77 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (battery != NULL);
#line 80 "../src/applets/status/PowerIndicator.vala"
	battery_icon_set_battery (self, battery);
#line 86 "../src/applets/status/PowerIndicator.vala"
	g_object_get (battery, "percentage", &_tmp0_, NULL);
#line 86 "../src/applets/status/PowerIndicator.vala"
	_tmp1_ = _tmp0_;
#line 86 "../src/applets/status/PowerIndicator.vala"
	rounded = ((gint) round (_tmp1_ / 10)) * 10;
#line 90 "../src/applets/status/PowerIndicator.vala"
	g_object_get (battery, "percentage", &_tmp2_, NULL);
#line 90 "../src/applets/status/PowerIndicator.vala"
	_tmp3_ = _tmp2_;
#line 90 "../src/applets/status/PowerIndicator.vala"
	if (_tmp3_ <= ((gdouble) 10)) {
#line 375 "PowerIndicator.c"
		gchar* _tmp4_;
#line 91 "../src/applets/status/PowerIndicator.vala"
		_tmp4_ = g_strdup ("battery-empty");
#line 91 "../src/applets/status/PowerIndicator.vala"
		_g_free0 (image_fallback);
#line 91 "../src/applets/status/PowerIndicator.vala"
		image_fallback = _tmp4_;
#line 383 "PowerIndicator.c"
	} else {
		gdouble _tmp5_;
		gdouble _tmp6_;
#line 92 "../src/applets/status/PowerIndicator.vala"
		g_object_get (battery, "percentage", &_tmp5_, NULL);
#line 92 "../src/applets/status/PowerIndicator.vala"
		_tmp6_ = _tmp5_;
#line 92 "../src/applets/status/PowerIndicator.vala"
		if (_tmp6_ <= ((gdouble) 35)) {
#line 393 "PowerIndicator.c"
			gchar* _tmp7_;
#line 93 "../src/applets/status/PowerIndicator.vala"
			_tmp7_ = g_strdup ("battery-low");
#line 93 "../src/applets/status/PowerIndicator.vala"
			_g_free0 (image_fallback);
#line 93 "../src/applets/status/PowerIndicator.vala"
			image_fallback = _tmp7_;
#line 401 "PowerIndicator.c"
		} else {
			gdouble _tmp8_;
			gdouble _tmp9_;
#line 94 "../src/applets/status/PowerIndicator.vala"
			g_object_get (battery, "percentage", &_tmp8_, NULL);
#line 94 "../src/applets/status/PowerIndicator.vala"
			_tmp9_ = _tmp8_;
#line 94 "../src/applets/status/PowerIndicator.vala"
			if (_tmp9_ <= ((gdouble) 75)) {
#line 411 "PowerIndicator.c"
				gchar* _tmp10_;
#line 95 "../src/applets/status/PowerIndicator.vala"
				_tmp10_ = g_strdup ("battery-good");
#line 95 "../src/applets/status/PowerIndicator.vala"
				_g_free0 (image_fallback);
#line 95 "../src/applets/status/PowerIndicator.vala"
				image_fallback = _tmp10_;
#line 419 "PowerIndicator.c"
			} else {
				gchar* _tmp11_;
#line 97 "../src/applets/status/PowerIndicator.vala"
				_tmp11_ = g_strdup ("battery-full");
#line 97 "../src/applets/status/PowerIndicator.vala"
				_g_free0 (image_fallback);
#line 97 "../src/applets/status/PowerIndicator.vala"
				image_fallback = _tmp11_;
#line 428 "PowerIndicator.c"
			}
		}
	}
#line 100 "../src/applets/status/PowerIndicator.vala"
	_tmp12_ = g_strdup_printf ("battery-level-%d", rounded);
#line 100 "../src/applets/status/PowerIndicator.vala"
	_g_free0 (image_name);
#line 100 "../src/applets/status/PowerIndicator.vala"
	image_name = _tmp12_;
#line 103 "../src/applets/status/PowerIndicator.vala"
	g_object_get (battery, "state", &_tmp13_, NULL);
#line 103 "../src/applets/status/PowerIndicator.vala"
	_tmp14_ = _tmp13_;
#line 103 "../src/applets/status/PowerIndicator.vala"
	if (_tmp14_ == ((guint) 4)) {
#line 444 "PowerIndicator.c"
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 104 "../src/applets/status/PowerIndicator.vala"
		_tmp15_ = g_strdup ("battery-full-charged-symbolic");
#line 104 "../src/applets/status/PowerIndicator.vala"
		_g_free0 (image_name);
#line 104 "../src/applets/status/PowerIndicator.vala"
		image_name = _tmp15_;
#line 105 "../src/applets/status/PowerIndicator.vala"
		_tmp16_ = g_strdup (_ ("Battery fully charged."));
#line 105 "../src/applets/status/PowerIndicator.vala"
		_g_free0 (tip);
#line 105 "../src/applets/status/PowerIndicator.vala"
		tip = _tmp16_;
#line 459 "PowerIndicator.c"
	} else {
		guint _tmp17_;
		guint _tmp18_;
#line 106 "../src/applets/status/PowerIndicator.vala"
		g_object_get (battery, "state", &_tmp17_, NULL);
#line 106 "../src/applets/status/PowerIndicator.vala"
		_tmp18_ = _tmp17_;
#line 106 "../src/applets/status/PowerIndicator.vala"
		if (_tmp18_ == ((guint) 1)) {
#line 469 "PowerIndicator.c"
			const gchar* _tmp19_;
			gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* time_to_full_str = NULL;
			gchar* _tmp23_;
			gint time_to_full = 0;
			gint64 _tmp24_;
			gint64 _tmp25_;
			gdouble _tmp27_;
			gdouble _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
#line 107 "../src/applets/status/PowerIndicator.vala"
			_tmp19_ = image_name;
#line 107 "../src/applets/status/PowerIndicator.vala"
			_tmp20_ = g_strconcat (_tmp19_, "-charging-symbolic", NULL);
#line 107 "../src/applets/status/PowerIndicator.vala"
			_g_free0 (image_name);
#line 107 "../src/applets/status/PowerIndicator.vala"
			image_name = _tmp20_;
#line 108 "../src/applets/status/PowerIndicator.vala"
			_tmp21_ = image_fallback;
#line 108 "../src/applets/status/PowerIndicator.vala"
			_tmp22_ = g_strconcat (_tmp21_, "-charging-symbolic", NULL);
#line 108 "../src/applets/status/PowerIndicator.vala"
			_g_free0 (image_fallback);
#line 108 "../src/applets/status/PowerIndicator.vala"
			image_fallback = _tmp22_;
#line 109 "../src/applets/status/PowerIndicator.vala"
			_tmp23_ = g_strdup (_ ("Unknown"));
#line 109 "../src/applets/status/PowerIndicator.vala"
			time_to_full_str = _tmp23_;
#line 110 "../src/applets/status/PowerIndicator.vala"
			g_object_get (battery, "time-to-full", &_tmp24_, NULL);
#line 110 "../src/applets/status/PowerIndicator.vala"
			_tmp25_ = _tmp24_;
#line 110 "../src/applets/status/PowerIndicator.vala"
			time_to_full = (gint) _tmp25_;
#line 112 "../src/applets/status/PowerIndicator.vala"
			if (time_to_full > 0) {
#line 513 "PowerIndicator.c"
				gint hours = 0;
				gint minutes = 0;
				gchar* _tmp26_;
#line 113 "../src/applets/status/PowerIndicator.vala"
				hours = time_to_full / (60 * 60);
#line 114 "../src/applets/status/PowerIndicator.vala"
				minutes = (time_to_full / 60) - (hours * 60);
#line 115 "../src/applets/status/PowerIndicator.vala"
				_tmp26_ = g_strdup_printf ("%d:%02d", hours, minutes);
#line 115 "../src/applets/status/PowerIndicator.vala"
				_g_free0 (time_to_full_str);
#line 115 "../src/applets/status/PowerIndicator.vala"
				time_to_full_str = _tmp26_;
#line 527 "PowerIndicator.c"
			}
#line 118 "../src/applets/status/PowerIndicator.vala"
			g_object_get (battery, "percentage", &_tmp27_, NULL);
#line 118 "../src/applets/status/PowerIndicator.vala"
			_tmp28_ = _tmp27_;
#line 118 "../src/applets/status/PowerIndicator.vala"
			_tmp29_ = time_to_full_str;
#line 118 "../src/applets/status/PowerIndicator.vala"
			_tmp30_ = g_strdup_printf (": %d%% (%s)", (gint) _tmp28_, _tmp29_);
#line 118 "../src/applets/status/PowerIndicator.vala"
			_tmp31_ = _tmp30_;
#line 118 "../src/applets/status/PowerIndicator.vala"
			_tmp32_ = g_strconcat (_ ("Battery charging"), _tmp31_, NULL);
#line 118 "../src/applets/status/PowerIndicator.vala"
			_g_free0 (tip);
#line 118 "../src/applets/status/PowerIndicator.vala"
			tip = _tmp32_;
#line 118 "../src/applets/status/PowerIndicator.vala"
			_g_free0 (_tmp31_);
#line 106 "../src/applets/status/PowerIndicator.vala"
			_g_free0 (time_to_full_str);
#line 549 "PowerIndicator.c"
		} else {
			const gchar* _tmp33_;
			gchar* _tmp34_;
			gint hours = 0;
			gint64 _tmp35_;
			gint64 _tmp36_;
			gint minutes = 0;
			gint64 _tmp37_;
			gint64 _tmp38_;
			gdouble _tmp39_;
			gdouble _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
#line 120 "../src/applets/status/PowerIndicator.vala"
			_tmp33_ = image_name;
#line 120 "../src/applets/status/PowerIndicator.vala"
			_tmp34_ = g_strconcat (_tmp33_, "-symbolic", NULL);
#line 120 "../src/applets/status/PowerIndicator.vala"
			_g_free0 (image_name);
#line 120 "../src/applets/status/PowerIndicator.vala"
			image_name = _tmp34_;
#line 121 "../src/applets/status/PowerIndicator.vala"
			g_object_get (battery, "time-to-empty", &_tmp35_, NULL);
#line 121 "../src/applets/status/PowerIndicator.vala"
			_tmp36_ = _tmp35_;
#line 121 "../src/applets/status/PowerIndicator.vala"
			hours = ((gint) _tmp36_) / (60 * 60);
#line 122 "../src/applets/status/PowerIndicator.vala"
			g_object_get (battery, "time-to-empty", &_tmp37_, NULL);
#line 122 "../src/applets/status/PowerIndicator.vala"
			_tmp38_ = _tmp37_;
#line 122 "../src/applets/status/PowerIndicator.vala"
			minutes = (((gint) _tmp38_) / 60) - (hours * 60);
#line 123 "../src/applets/status/PowerIndicator.vala"
			g_object_get (battery, "percentage", &_tmp39_, NULL);
#line 123 "../src/applets/status/PowerIndicator.vala"
			_tmp40_ = _tmp39_;
#line 123 "../src/applets/status/PowerIndicator.vala"
			_tmp41_ = g_strdup_printf (": %d%% (%d:%02d)", (gint) _tmp40_, hours, minutes);
#line 123 "../src/applets/status/PowerIndicator.vala"
			_tmp42_ = _tmp41_;
#line 123 "../src/applets/status/PowerIndicator.vala"
			_tmp43_ = g_strconcat (_ ("Battery remaining"), _tmp42_, NULL);
#line 123 "../src/applets/status/PowerIndicator.vala"
			_g_free0 (tip);
#line 123 "../src/applets/status/PowerIndicator.vala"
			tip = _tmp43_;
#line 123 "../src/applets/status/PowerIndicator.vala"
			_g_free0 (_tmp42_);
#line 600 "PowerIndicator.c"
		}
	}
#line 127 "../src/applets/status/PowerIndicator.vala"
	g_object_get (battery, "percentage", &_tmp44_, NULL);
#line 127 "../src/applets/status/PowerIndicator.vala"
	_tmp45_ = _tmp44_;
#line 127 "../src/applets/status/PowerIndicator.vala"
	_tmp46_ = g_strdup_printf ("%d%%", (gint) _tmp45_);
#line 127 "../src/applets/status/PowerIndicator.vala"
	labe = _tmp46_;
#line 128 "../src/applets/status/PowerIndicator.vala"
	_tmp47_ = self->priv->percent_label;
#line 128 "../src/applets/status/PowerIndicator.vala"
	_tmp48_ = gtk_label_get_label (_tmp47_);
#line 128 "../src/applets/status/PowerIndicator.vala"
	_tmp49_ = g_strdup (_tmp48_);
#line 128 "../src/applets/status/PowerIndicator.vala"
	old = _tmp49_;
#line 129 "../src/applets/status/PowerIndicator.vala"
	_tmp50_ = old;
#line 129 "../src/applets/status/PowerIndicator.vala"
	_tmp51_ = labe;
#line 129 "../src/applets/status/PowerIndicator.vala"
	if (g_strcmp0 (_tmp50_, _tmp51_) != 0) {
#line 625 "PowerIndicator.c"
		GtkLabel* _tmp52_;
		const gchar* _tmp53_;
#line 130 "../src/applets/status/PowerIndicator.vala"
		_tmp52_ = self->priv->percent_label;
#line 130 "../src/applets/status/PowerIndicator.vala"
		_tmp53_ = labe;
#line 130 "../src/applets/status/PowerIndicator.vala"
		gtk_label_set_text (_tmp52_, _tmp53_);
#line 634 "PowerIndicator.c"
	}
#line 134 "../src/applets/status/PowerIndicator.vala"
	_tmp54_ = tip;
#line 134 "../src/applets/status/PowerIndicator.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp54_);
#line 136 "../src/applets/status/PowerIndicator.vala"
	_tmp55_ = gtk_icon_theme_get_default ();
#line 136 "../src/applets/status/PowerIndicator.vala"
	_tmp56_ = _g_object_ref0 (_tmp55_);
#line 136 "../src/applets/status/PowerIndicator.vala"
	theme = _tmp56_;
#line 137 "../src/applets/status/PowerIndicator.vala"
	_tmp57_ = theme;
#line 137 "../src/applets/status/PowerIndicator.vala"
	_tmp58_ = image_name;
#line 137 "../src/applets/status/PowerIndicator.vala"
	_tmp59_ = gtk_icon_theme_lookup_icon (_tmp57_, _tmp58_, (gint) GTK_ICON_SIZE_MENU, 0);
#line 137 "../src/applets/status/PowerIndicator.vala"
	_result_ = _tmp59_;
#line 139 "../src/applets/status/PowerIndicator.vala"
	_tmp60_ = _result_;
#line 139 "../src/applets/status/PowerIndicator.vala"
	if (_tmp60_ == NULL) {
#line 658 "PowerIndicator.c"
		GtkImage* _tmp61_;
		const gchar* _tmp62_;
#line 140 "../src/applets/status/PowerIndicator.vala"
		_tmp61_ = self->priv->image;
#line 140 "../src/applets/status/PowerIndicator.vala"
		_tmp62_ = image_fallback;
#line 140 "../src/applets/status/PowerIndicator.vala"
		gtk_image_set_from_icon_name (_tmp61_, _tmp62_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 667 "PowerIndicator.c"
	} else {
		GtkImage* _tmp63_;
		const gchar* _tmp64_;
#line 142 "../src/applets/status/PowerIndicator.vala"
		_tmp63_ = self->priv->image;
#line 142 "../src/applets/status/PowerIndicator.vala"
		_tmp64_ = image_name;
#line 142 "../src/applets/status/PowerIndicator.vala"
		gtk_image_set_from_icon_name (_tmp63_, _tmp64_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 677 "PowerIndicator.c"
	}
#line 145 "../src/applets/status/PowerIndicator.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 77 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (_result_);
#line 77 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (theme);
#line 77 "../src/applets/status/PowerIndicator.vala"
	_g_free0 (old);
#line 77 "../src/applets/status/PowerIndicator.vala"
	_g_free0 (labe);
#line 77 "../src/applets/status/PowerIndicator.vala"
	_g_free0 (image_fallback);
#line 77 "../src/applets/status/PowerIndicator.vala"
	_g_free0 (image_name);
#line 77 "../src/applets/status/PowerIndicator.vala"
	_g_free0 (tip);
#line 695 "PowerIndicator.c"
}

UpDevice*
battery_icon_get_battery (BatteryIcon* self)
{
	UpDevice* result;
	UpDevice* _tmp0_;
#line 14 "../src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 14 "../src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->_battery;
#line 14 "../src/applets/status/PowerIndicator.vala"
	result = _tmp0_;
#line 14 "../src/applets/status/PowerIndicator.vala"
	return result;
#line 711 "PowerIndicator.c"
}

void
battery_icon_set_battery (BatteryIcon* self,
                          UpDevice* value)
{
	UpDevice* old_value;
#line 14 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 14 "../src/applets/status/PowerIndicator.vala"
	old_value = battery_icon_get_battery (self);
#line 14 "../src/applets/status/PowerIndicator.vala"
	if (old_value != value) {
#line 14 "../src/applets/status/PowerIndicator.vala"
		self->priv->_battery = value;
#line 14 "../src/applets/status/PowerIndicator.vala"
		g_object_notify_by_pspec ((GObject *) self, battery_icon_properties[BATTERY_ICON_BATTERY_PROPERTY]);
#line 729 "PowerIndicator.c"
	}
}

gboolean
battery_icon_get_label_visible (BatteryIcon* self)
{
	gboolean result;
	GtkLabel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 30 "../src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->percent_label;
#line 31 "../src/applets/status/PowerIndicator.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 31 "../src/applets/status/PowerIndicator.vala"
	_tmp2_ = _tmp1_;
#line 31 "../src/applets/status/PowerIndicator.vala"
	result = _tmp2_;
#line 31 "../src/applets/status/PowerIndicator.vala"
	return result;
#line 752 "PowerIndicator.c"
}

void
battery_icon_set_label_visible (BatteryIcon* self,
                                gboolean value)
{
	GtkLabel* _tmp0_;
#line 27 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->percent_label;
#line 28 "../src/applets/status/PowerIndicator.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, value);
#line 27 "../src/applets/status/PowerIndicator.vala"
	g_object_notify_by_pspec ((GObject *) self, battery_icon_properties[BATTERY_ICON_LABEL_VISIBLE_PROPERTY]);
#line 768 "PowerIndicator.c"
}

static void
battery_icon_class_init (BatteryIconClass * klass,
                         gpointer klass_data)
{
#line 12 "../src/applets/status/PowerIndicator.vala"
	battery_icon_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/applets/status/PowerIndicator.vala"
	g_type_class_adjust_private_offset (klass, &BatteryIcon_private_offset);
#line 12 "../src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_battery_icon_get_property;
#line 12 "../src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_battery_icon_set_property;
#line 12 "../src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (klass)->finalize = battery_icon_finalize;
#line 785 "PowerIndicator.c"
	/** The battery associated with this icon */
#line 12 "../src/applets/status/PowerIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BATTERY_ICON_BATTERY_PROPERTY, battery_icon_properties[BATTERY_ICON_BATTERY_PROPERTY] = g_param_spec_object ("battery", "battery", "battery", up_device_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 789 "PowerIndicator.c"
	/**
	 * Expose a simple property so the UI can update whether we show
	 * labels or not
	 */
#line 12 "../src/applets/status/PowerIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BATTERY_ICON_LABEL_VISIBLE_PROPERTY, battery_icon_properties[BATTERY_ICON_LABEL_VISIBLE_PROPERTY] = g_param_spec_boolean ("label-visible", "label-visible", "label-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 796 "PowerIndicator.c"
}

static void
battery_icon_instance_init (BatteryIcon * self,
                            gpointer klass)
{
#line 12 "../src/applets/status/PowerIndicator.vala"
	self->priv = battery_icon_get_instance_private (self);
#line 15 "../src/applets/status/PowerIndicator.vala"
	self->priv->changing = FALSE;
#line 16 "../src/applets/status/PowerIndicator.vala"
	self->priv->emitted_warning = FALSE;
#line 809 "PowerIndicator.c"
}

static void
battery_icon_finalize (GObject * obj)
{
	BatteryIcon * self;
#line 12 "../src/applets/status/PowerIndicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BATTERY_ICON, BatteryIcon);
#line 18 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->image);
#line 20 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->percent_label);
#line 12 "../src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (battery_icon_parent_class)->finalize (obj);
#line 824 "PowerIndicator.c"
}

GType
battery_icon_get_type (void)
{
	return battery_icon_type_id;
}

GType
battery_icon_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (BatteryIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) battery_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BatteryIcon), 0, (GInstanceInitFunc) battery_icon_instance_init, NULL };
	battery_icon_type_id = g_type_module_register_type (module, gtk_box_get_type (), "BatteryIcon", &g_define_type_info, 0);
	BatteryIcon_private_offset = sizeof (BatteryIconPrivate);
	return battery_icon_type_id;
}

static void
_vala_battery_icon_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	BatteryIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BATTERY_ICON, BatteryIcon);
#line 12 "../src/applets/status/PowerIndicator.vala"
	switch (property_id) {
#line 12 "../src/applets/status/PowerIndicator.vala"
		case BATTERY_ICON_BATTERY_PROPERTY:
#line 12 "../src/applets/status/PowerIndicator.vala"
		g_value_set_object (value, battery_icon_get_battery (self));
#line 12 "../src/applets/status/PowerIndicator.vala"
		break;
#line 12 "../src/applets/status/PowerIndicator.vala"
		case BATTERY_ICON_LABEL_VISIBLE_PROPERTY:
#line 12 "../src/applets/status/PowerIndicator.vala"
		g_value_set_boolean (value, battery_icon_get_label_visible (self));
#line 12 "../src/applets/status/PowerIndicator.vala"
		break;
#line 864 "PowerIndicator.c"
		default:
#line 12 "../src/applets/status/PowerIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/applets/status/PowerIndicator.vala"
		break;
#line 870 "PowerIndicator.c"
	}
}

static void
_vala_battery_icon_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	BatteryIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BATTERY_ICON, BatteryIcon);
#line 12 "../src/applets/status/PowerIndicator.vala"
	switch (property_id) {
#line 12 "../src/applets/status/PowerIndicator.vala"
		case BATTERY_ICON_BATTERY_PROPERTY:
#line 12 "../src/applets/status/PowerIndicator.vala"
		battery_icon_set_battery (self, g_value_get_object (value));
#line 12 "../src/applets/status/PowerIndicator.vala"
		break;
#line 12 "../src/applets/status/PowerIndicator.vala"
		case BATTERY_ICON_LABEL_VISIBLE_PROPERTY:
#line 12 "../src/applets/status/PowerIndicator.vala"
		battery_icon_set_label_visible (self, g_value_get_boolean (value));
#line 12 "../src/applets/status/PowerIndicator.vala"
		break;
#line 896 "PowerIndicator.c"
		default:
#line 12 "../src/applets/status/PowerIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/applets/status/PowerIndicator.vala"
		break;
#line 902 "PowerIndicator.c"
	}
}

static inline gpointer
power_indicator_get_instance_private (PowerIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, PowerIndicator_private_offset);
}

static void
_g_free0_ (gpointer var)
{
#line 165 "../src/applets/status/PowerIndicator.vala"
	var = (g_free (var), NULL);
#line 917 "PowerIndicator.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 165 "../src/applets/status/PowerIndicator.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 925 "PowerIndicator.c"
}

static void
_power_indicator_update_labels_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 180 "../src/applets/status/PowerIndicator.vala"
	power_indicator_update_labels ((PowerIndicator*) self);
#line 935 "PowerIndicator.c"
}

static void
_power_indicator_open_power_settings_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
#line 192 "../src/applets/status/PowerIndicator.vala"
	power_indicator_open_power_settings ((PowerIndicator*) self);
#line 944 "PowerIndicator.c"
}

static void
_power_indicator_on_device_added_up__client_device_added (UpClient* _sender,
                                                          UpDevice* device,
                                                          gpointer self)
{
#line 200 "../src/applets/status/PowerIndicator.vala"
	power_indicator_on_device_added ((PowerIndicator*) self, device);
#line 954 "PowerIndicator.c"
}

static void
_power_indicator_on_device_removed_up__client_device_removed (UpClient* _sender,
                                                              const gchar* object_path,
                                                              gpointer self)
{
#line 201 "../src/applets/status/PowerIndicator.vala"
	power_indicator_on_device_removed ((PowerIndicator*) self, object_path);
#line 964 "PowerIndicator.c"
}

PowerIndicator*
power_indicator_construct (GType object_type)
{
	PowerIndicator * self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GtkEventBox* _tmp3_;
	GtkEventBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkEventBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkEventBox* _tmp8_;
	BudgiePopover* _tmp9_;
	GtkBox* box = NULL;
	GtkBox* _tmp10_;
	BudgiePopover* _tmp11_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	GtkCheckButton* _tmp14_;
	GtkCheckButton* _tmp15_;
	GtkWidget* _tmp16_;
	GValue _tmp17_ = {0};
	GtkCheckButton* _tmp18_;
	GSettings* _tmp19_;
	GtkCheckButton* _tmp20_;
	GtkSeparator* sep = NULL;
	GtkSeparator* _tmp21_;
	GtkButton* button = NULL;
	GtkButton* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkWidget* _tmp24_;
	UpClient* _tmp25_;
	UpClient* _tmp26_;
	UpClient* _tmp27_;
	UpClient* _tmp28_;
#line 164 "../src/applets/status/PowerIndicator.vala"
	self = (PowerIndicator*) g_object_new (object_type, NULL);
#line 165 "../src/applets/status/PowerIndicator.vala"
	_tmp0_ = g_str_hash;
#line 165 "../src/applets/status/PowerIndicator.vala"
	_tmp1_ = g_str_equal;
#line 165 "../src/applets/status/PowerIndicator.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 165 "../src/applets/status/PowerIndicator.vala"
	_g_hash_table_unref0 (self->priv->devices);
#line 165 "../src/applets/status/PowerIndicator.vala"
	self->priv->devices = _tmp2_;
#line 166 "../src/applets/status/PowerIndicator.vala"
	_tmp3_ = (GtkEventBox*) gtk_event_box_new ();
#line 166 "../src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp3_);
#line 166 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->ebox);
#line 166 "../src/applets/status/PowerIndicator.vala"
	self->ebox = _tmp3_;
#line 167 "../src/applets/status/PowerIndicator.vala"
	_tmp4_ = self->ebox;
#line 167 "../src/applets/status/PowerIndicator.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp4_);
#line 169 "../src/applets/status/PowerIndicator.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 2);
#line 169 "../src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp5_);
#line 169 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->widget);
#line 169 "../src/applets/status/PowerIndicator.vala"
	self->priv->widget = _tmp5_;
#line 170 "../src/applets/status/PowerIndicator.vala"
	_tmp6_ = self->ebox;
#line 170 "../src/applets/status/PowerIndicator.vala"
	_tmp7_ = self->priv->widget;
#line 170 "../src/applets/status/PowerIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 172 "../src/applets/status/PowerIndicator.vala"
	_tmp8_ = self->ebox;
#line 172 "../src/applets/status/PowerIndicator.vala"
	_tmp9_ = (BudgiePopover*) budgie_popover_new ((GtkWidget*) _tmp8_);
#line 172 "../src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp9_);
#line 172 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->popover);
#line 172 "../src/applets/status/PowerIndicator.vala"
	self->popover = _tmp9_;
#line 173 "../src/applets/status/PowerIndicator.vala"
	_tmp10_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 1);
#line 173 "../src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp10_);
#line 173 "../src/applets/status/PowerIndicator.vala"
	box = _tmp10_;
#line 174 "../src/applets/status/PowerIndicator.vala"
	gtk_container_set_border_width ((GtkContainer*) box, (guint) 6);
#line 175 "../src/applets/status/PowerIndicator.vala"
	_tmp11_ = self->popover;
#line 175 "../src/applets/status/PowerIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) box);
#line 178 "../src/applets/status/PowerIndicator.vala"
	_tmp12_ = g_settings_new ("org.gnome.desktop.interface");
#line 178 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->battery_settings);
#line 178 "../src/applets/status/PowerIndicator.vala"
	self->priv->battery_settings = _tmp12_;
#line 179 "../src/applets/status/PowerIndicator.vala"
	_tmp13_ = self->priv->battery_settings;
#line 179 "../src/applets/status/PowerIndicator.vala"
	g_settings_bind (_tmp13_, "show-battery-percentage", (GObject*) self, "label-visible", G_SETTINGS_BIND_GET);
#line 180 "../src/applets/status/PowerIndicator.vala"
	g_signal_connect_object ((GObject*) self, "notify::label-visible", (GCallback) _power_indicator_update_labels_g_object_notify, self, G_CONNECT_AFTER);
#line 182 "../src/applets/status/PowerIndicator.vala"
	_tmp14_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Show battery percentage"));
#line 182 "../src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp14_);
#line 182 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->check_percent);
#line 182 "../src/applets/status/PowerIndicator.vala"
	self->priv->check_percent = _tmp14_;
#line 183 "../src/applets/status/PowerIndicator.vala"
	_tmp15_ = self->priv->check_percent;
#line 183 "../src/applets/status/PowerIndicator.vala"
	_tmp16_ = gtk_bin_get_child ((GtkBin*) _tmp15_);
#line 183 "../src/applets/status/PowerIndicator.vala"
	g_value_init (&_tmp17_, G_TYPE_INT);
#line 183 "../src/applets/status/PowerIndicator.vala"
	g_value_set_int (&_tmp17_, 4);
#line 183 "../src/applets/status/PowerIndicator.vala"
	g_object_set_property ((GObject*) _tmp16_, "margin", &_tmp17_);
#line 183 "../src/applets/status/PowerIndicator.vala"
	G_IS_VALUE (&_tmp17_) ? (g_value_unset (&_tmp17_), NULL) : NULL;
#line 184 "../src/applets/status/PowerIndicator.vala"
	_tmp18_ = self->priv->check_percent;
#line 184 "../src/applets/status/PowerIndicator.vala"
	gtk_box_pack_start (box, (GtkWidget*) _tmp18_, FALSE, FALSE, (guint) 0);
#line 185 "../src/applets/status/PowerIndicator.vala"
	_tmp19_ = self->priv->battery_settings;
#line 185 "../src/applets/status/PowerIndicator.vala"
	_tmp20_ = self->priv->check_percent;
#line 185 "../src/applets/status/PowerIndicator.vala"
	g_settings_bind (_tmp19_, "show-battery-percentage", (GObject*) _tmp20_, "active", G_SETTINGS_BIND_DEFAULT);
#line 187 "../src/applets/status/PowerIndicator.vala"
	_tmp21_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 187 "../src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp21_);
#line 187 "../src/applets/status/PowerIndicator.vala"
	sep = _tmp21_;
#line 188 "../src/applets/status/PowerIndicator.vala"
	gtk_box_pack_start (box, (GtkWidget*) sep, FALSE, FALSE, (guint) 1);
#line 190 "../src/applets/status/PowerIndicator.vala"
	_tmp22_ = (GtkButton*) gtk_button_new_with_label (_ ("Power settings"));
#line 190 "../src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp22_);
#line 190 "../src/applets/status/PowerIndicator.vala"
	button = _tmp22_;
#line 191 "../src/applets/status/PowerIndicator.vala"
	_tmp23_ = gtk_widget_get_style_context ((GtkWidget*) button);
#line 191 "../src/applets/status/PowerIndicator.vala"
	gtk_style_context_add_class (_tmp23_, GTK_STYLE_CLASS_FLAT);
#line 192 "../src/applets/status/PowerIndicator.vala"
	g_signal_connect_object (button, "clicked", (GCallback) _power_indicator_open_power_settings_gtk_button_clicked, self, 0);
#line 193 "../src/applets/status/PowerIndicator.vala"
	_tmp24_ = gtk_bin_get_child ((GtkBin*) button);
#line 193 "../src/applets/status/PowerIndicator.vala"
	gtk_widget_set_halign (_tmp24_, GTK_ALIGN_START);
#line 194 "../src/applets/status/PowerIndicator.vala"
	gtk_box_pack_start (box, (GtkWidget*) button, FALSE, FALSE, (guint) 0);
#line 195 "../src/applets/status/PowerIndicator.vala"
	gtk_widget_show_all ((GtkWidget*) box);
#line 197 "../src/applets/status/PowerIndicator.vala"
	_tmp25_ = up_client_new ();
#line 197 "../src/applets/status/PowerIndicator.vala"
	_tmp26_ = _tmp25_;
#line 197 "../src/applets/status/PowerIndicator.vala"
	power_indicator_set_client (self, _tmp26_);
#line 197 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (_tmp26_);
#line 199 "../src/applets/status/PowerIndicator.vala"
	power_indicator_sync_devices (self);
#line 200 "../src/applets/status/PowerIndicator.vala"
	_tmp27_ = self->priv->_client;
#line 200 "../src/applets/status/PowerIndicator.vala"
	g_signal_connect_object (_tmp27_, "device-added", (GCallback) _power_indicator_on_device_added_up__client_device_added, self, 0);
#line 201 "../src/applets/status/PowerIndicator.vala"
	_tmp28_ = self->priv->_client;
#line 201 "../src/applets/status/PowerIndicator.vala"
	g_signal_connect_object (_tmp28_, "device-removed", (GCallback) _power_indicator_on_device_removed_up__client_device_removed, self, 0);
#line 202 "../src/applets/status/PowerIndicator.vala"
	power_indicator_toggle_show (self);
#line 164 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (button);
#line 164 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (sep);
#line 164 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (box);
#line 164 "../src/applets/status/PowerIndicator.vala"
	return self;
#line 1161 "PowerIndicator.c"
}

PowerIndicator*
power_indicator_new (void)
{
#line 164 "../src/applets/status/PowerIndicator.vala"
	return power_indicator_construct (TYPE_POWER_INDICATOR);
#line 1169 "PowerIndicator.c"
}

void
power_indicator_change_orientation (PowerIndicator* self,
                                    GtkOrientation orient)
{
	gint spacing = 0;
	BatteryIcon* icon = NULL;
	GHashTableIter iter = {0};
	GHashTable* _tmp0_;
#line 205 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/applets/status/PowerIndicator.vala"
	spacing = 0;
#line 207 "../src/applets/status/PowerIndicator.vala"
	if (orient == GTK_ORIENTATION_VERTICAL) {
#line 208 "../src/applets/status/PowerIndicator.vala"
		spacing = 5;
#line 1188 "PowerIndicator.c"
	}
#line 210 "../src/applets/status/PowerIndicator.vala"
	icon = NULL;
#line 211 "../src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->devices;
#line 211 "../src/applets/status/PowerIndicator.vala"
	g_hash_table_iter_init (&iter, _tmp0_);
#line 212 "../src/applets/status/PowerIndicator.vala"
	while (TRUE) {
#line 1198 "PowerIndicator.c"
		gconstpointer _tmp1_ = NULL;
		gboolean _tmp2_;
		BatteryIcon* _tmp3_;
		BatteryIcon* _tmp4_;
#line 212 "../src/applets/status/PowerIndicator.vala"
		_tmp2_ = g_hash_table_iter_next (&iter, (gpointer*) NULL, (gpointer*) (&_tmp1_));
#line 212 "../src/applets/status/PowerIndicator.vala"
		icon = _tmp1_;
#line 212 "../src/applets/status/PowerIndicator.vala"
		if (!_tmp2_) {
#line 212 "../src/applets/status/PowerIndicator.vala"
			break;
#line 1211 "PowerIndicator.c"
		}
#line 213 "../src/applets/status/PowerIndicator.vala"
		_tmp3_ = icon;
#line 213 "../src/applets/status/PowerIndicator.vala"
		gtk_box_set_spacing ((GtkBox*) _tmp3_, spacing);
#line 214 "../src/applets/status/PowerIndicator.vala"
		_tmp4_ = icon;
#line 214 "../src/applets/status/PowerIndicator.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp4_, orient);
#line 1221 "PowerIndicator.c"
	}
}

static void
power_indicator_update_labels (PowerIndicator* self)
{
	BatteryIcon* icon = NULL;
	GHashTableIter iter = {0};
	GHashTable* _tmp0_;
	GtkWidget* _tmp5_;
#line 218 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/applets/status/PowerIndicator.vala"
	icon = NULL;
#line 220 "../src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->devices;
#line 220 "../src/applets/status/PowerIndicator.vala"
	g_hash_table_iter_init (&iter, _tmp0_);
#line 221 "../src/applets/status/PowerIndicator.vala"
	while (TRUE) {
#line 1242 "PowerIndicator.c"
		gconstpointer _tmp1_ = NULL;
		gboolean _tmp2_;
		BatteryIcon* _tmp3_;
		gboolean _tmp4_;
#line 221 "../src/applets/status/PowerIndicator.vala"
		_tmp2_ = g_hash_table_iter_next (&iter, (gpointer*) NULL, (gpointer*) (&_tmp1_));
#line 221 "../src/applets/status/PowerIndicator.vala"
		icon = _tmp1_;
#line 221 "../src/applets/status/PowerIndicator.vala"
		if (!_tmp2_) {
#line 221 "../src/applets/status/PowerIndicator.vala"
			break;
#line 1255 "PowerIndicator.c"
		}
#line 222 "../src/applets/status/PowerIndicator.vala"
		_tmp3_ = icon;
#line 222 "../src/applets/status/PowerIndicator.vala"
		_tmp4_ = self->priv->_label_visible;
#line 222 "../src/applets/status/PowerIndicator.vala"
		battery_icon_set_label_visible (_tmp3_, _tmp4_);
#line 1263 "PowerIndicator.c"
	}
#line 225 "../src/applets/status/PowerIndicator.vala"
	_tmp5_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 225 "../src/applets/status/PowerIndicator.vala"
	gtk_widget_queue_draw (_tmp5_);
#line 1269 "PowerIndicator.c"
}

static gboolean
power_indicator_is_interesting (PowerIndicator* self,
                                UpDevice* device)
{
	guint _tmp0_;
	guint _tmp1_;
	gboolean result;
#line 228 "../src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 228 "../src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (device != NULL, FALSE);
#line 230 "../src/applets/status/PowerIndicator.vala"
	g_object_get (device, "kind", &_tmp0_, NULL);
#line 230 "../src/applets/status/PowerIndicator.vala"
	_tmp1_ = _tmp0_;
#line 230 "../src/applets/status/PowerIndicator.vala"
	if (_tmp1_ != ((guint) UP_DEVICE_KIND_BATTERY)) {
#line 231 "../src/applets/status/PowerIndicator.vala"
		result = FALSE;
#line 231 "../src/applets/status/PowerIndicator.vala"
		return result;
#line 1293 "PowerIndicator.c"
	}
#line 233 "../src/applets/status/PowerIndicator.vala"
	result = TRUE;
#line 233 "../src/applets/status/PowerIndicator.vala"
	return result;
#line 1299 "PowerIndicator.c"
}

static void
power_indicator_open_power_settings (PowerIndicator* self)
{
	BudgiePopover* _tmp0_;
	GDesktopAppInfo* app_info = NULL;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 236 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->popover;
#line 237 "../src/applets/status/PowerIndicator.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 239 "../src/applets/status/PowerIndicator.vala"
	_tmp1_ = g_desktop_app_info_new ("budgie-power-panel.desktop");
#line 239 "../src/applets/status/PowerIndicator.vala"
	app_info = _tmp1_;
#line 241 "../src/applets/status/PowerIndicator.vala"
	_tmp2_ = app_info;
#line 241 "../src/applets/status/PowerIndicator.vala"
	if (_tmp2_ == NULL) {
#line 242 "../src/applets/status/PowerIndicator.vala"
		_g_object_unref0 (app_info);
#line 242 "../src/applets/status/PowerIndicator.vala"
		return;
#line 1328 "PowerIndicator.c"
	}
	{
		GDesktopAppInfo* _tmp3_;
#line 246 "../src/applets/status/PowerIndicator.vala"
		_tmp3_ = app_info;
#line 246 "../src/applets/status/PowerIndicator.vala"
		g_app_info_launch ((GAppInfo*) _tmp3_, NULL, NULL, &_inner_error0_);
#line 246 "../src/applets/status/PowerIndicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1338 "PowerIndicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 245 "../src/applets/status/PowerIndicator.vala"
		e = _inner_error0_;
#line 245 "../src/applets/status/PowerIndicator.vala"
		_inner_error0_ = NULL;
#line 248 "../src/applets/status/PowerIndicator.vala"
		_tmp4_ = e;
#line 248 "../src/applets/status/PowerIndicator.vala"
		_tmp5_ = _tmp4_->message;
#line 248 "../src/applets/status/PowerIndicator.vala"
		g_message ("PowerIndicator.vala:248: Unable to launch gnome-power-panel.desktop: %" \
"s", _tmp5_);
#line 245 "../src/applets/status/PowerIndicator.vala"
		_g_error_free0 (e);
#line 1360 "PowerIndicator.c"
	}
	__finally0:
#line 245 "../src/applets/status/PowerIndicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 245 "../src/applets/status/PowerIndicator.vala"
		_g_object_unref0 (app_info);
#line 245 "../src/applets/status/PowerIndicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 245 "../src/applets/status/PowerIndicator.vala"
		g_clear_error (&_inner_error0_);
#line 245 "../src/applets/status/PowerIndicator.vala"
		return;
#line 1373 "PowerIndicator.c"
	}
#line 236 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (app_info);
#line 1377 "PowerIndicator.c"
}

/**
 * Add a new device to the tree
 */
static void
power_indicator_on_device_added (PowerIndicator* self,
                                 UpDevice* device)
{
	gchar* object_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
	BatteryIcon* icon = NULL;
	BatteryIcon* _tmp7_;
	BatteryIcon* _tmp8_;
	gboolean _tmp9_;
	GHashTable* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	BatteryIcon* _tmp13_;
	BatteryIcon* _tmp14_;
	GtkBox* _tmp15_;
	BatteryIcon* _tmp16_;
#line 255 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (device != NULL);
#line 256 "../src/applets/status/PowerIndicator.vala"
	_tmp0_ = up_device_get_object_path (device);
#line 256 "../src/applets/status/PowerIndicator.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 256 "../src/applets/status/PowerIndicator.vala"
	object_path = _tmp1_;
#line 257 "../src/applets/status/PowerIndicator.vala"
	_tmp2_ = self->priv->devices;
#line 257 "../src/applets/status/PowerIndicator.vala"
	_tmp3_ = object_path;
#line 257 "../src/applets/status/PowerIndicator.vala"
	if (g_hash_table_contains (_tmp2_, _tmp3_)) {
#line 1419 "PowerIndicator.c"
		GHashTable* _tmp4_;
		const gchar* _tmp5_;
		gconstpointer _tmp6_;
#line 259 "../src/applets/status/PowerIndicator.vala"
		_tmp4_ = self->priv->devices;
#line 259 "../src/applets/status/PowerIndicator.vala"
		_tmp5_ = object_path;
#line 259 "../src/applets/status/PowerIndicator.vala"
		_tmp6_ = g_hash_table_lookup (_tmp4_, _tmp5_);
#line 259 "../src/applets/status/PowerIndicator.vala"
		battery_icon_update_ui ((BatteryIcon*) _tmp6_, device);
#line 260 "../src/applets/status/PowerIndicator.vala"
		_g_free0 (object_path);
#line 260 "../src/applets/status/PowerIndicator.vala"
		return;
#line 1435 "PowerIndicator.c"
	}
#line 262 "../src/applets/status/PowerIndicator.vala"
	if (!power_indicator_is_interesting (self, device)) {
#line 263 "../src/applets/status/PowerIndicator.vala"
		_g_free0 (object_path);
#line 263 "../src/applets/status/PowerIndicator.vala"
		return;
#line 1443 "PowerIndicator.c"
	}
#line 265 "../src/applets/status/PowerIndicator.vala"
	_tmp7_ = battery_icon_new (device);
#line 265 "../src/applets/status/PowerIndicator.vala"
	g_object_ref_sink (_tmp7_);
#line 265 "../src/applets/status/PowerIndicator.vala"
	icon = _tmp7_;
#line 266 "../src/applets/status/PowerIndicator.vala"
	_tmp8_ = icon;
#line 266 "../src/applets/status/PowerIndicator.vala"
	_tmp9_ = self->priv->_label_visible;
#line 266 "../src/applets/status/PowerIndicator.vala"
	battery_icon_set_label_visible (_tmp8_, _tmp9_);
#line 267 "../src/applets/status/PowerIndicator.vala"
	_tmp10_ = self->priv->devices;
#line 267 "../src/applets/status/PowerIndicator.vala"
	_tmp11_ = object_path;
#line 267 "../src/applets/status/PowerIndicator.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 267 "../src/applets/status/PowerIndicator.vala"
	_tmp13_ = icon;
#line 267 "../src/applets/status/PowerIndicator.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 267 "../src/applets/status/PowerIndicator.vala"
	g_hash_table_insert (_tmp10_, _tmp12_, _tmp14_);
#line 268 "../src/applets/status/PowerIndicator.vala"
	_tmp15_ = self->priv->widget;
#line 268 "../src/applets/status/PowerIndicator.vala"
	_tmp16_ = icon;
#line 268 "../src/applets/status/PowerIndicator.vala"
	gtk_box_pack_start (_tmp15_, (GtkWidget*) _tmp16_, TRUE, TRUE, (guint) 0);
#line 269 "../src/applets/status/PowerIndicator.vala"
	power_indicator_toggle_show (self);
#line 255 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (icon);
#line 255 "../src/applets/status/PowerIndicator.vala"
	_g_free0 (object_path);
#line 1481 "PowerIndicator.c"
}

static void
power_indicator_toggle_show (PowerIndicator* self)
{
	GHashTable* _tmp0_;
#line 273 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->devices;
#line 274 "../src/applets/status/PowerIndicator.vala"
	if (g_hash_table_size (_tmp0_) < ((guint) 1)) {
#line 275 "../src/applets/status/PowerIndicator.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 1496 "PowerIndicator.c"
	} else {
#line 277 "../src/applets/status/PowerIndicator.vala"
		gtk_widget_show_all ((GtkWidget*) self);
#line 1500 "PowerIndicator.c"
	}
}

/**
 * Remove a device from our display
 */
static void
power_indicator_on_device_removed (PowerIndicator* self,
                                   const gchar* object_path)
{
	GHashTable* _tmp0_;
	BatteryIcon* icon = NULL;
	GHashTable* _tmp1_;
	gconstpointer _tmp2_;
	GtkBox* _tmp3_;
	BatteryIcon* _tmp4_;
	GHashTable* _tmp5_;
#line 284 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (object_path != NULL);
#line 285 "../src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->devices;
#line 285 "../src/applets/status/PowerIndicator.vala"
	if (!g_hash_table_contains (_tmp0_, object_path)) {
#line 286 "../src/applets/status/PowerIndicator.vala"
		return;
#line 1528 "PowerIndicator.c"
	}
#line 288 "../src/applets/status/PowerIndicator.vala"
	_tmp1_ = self->priv->devices;
#line 288 "../src/applets/status/PowerIndicator.vala"
	_tmp2_ = g_hash_table_lookup (_tmp1_, object_path);
#line 288 "../src/applets/status/PowerIndicator.vala"
	icon = (BatteryIcon*) _tmp2_;
#line 289 "../src/applets/status/PowerIndicator.vala"
	_tmp3_ = self->priv->widget;
#line 289 "../src/applets/status/PowerIndicator.vala"
	_tmp4_ = icon;
#line 289 "../src/applets/status/PowerIndicator.vala"
	gtk_container_remove ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 290 "../src/applets/status/PowerIndicator.vala"
	_tmp5_ = self->priv->devices;
#line 290 "../src/applets/status/PowerIndicator.vala"
	g_hash_table_remove (_tmp5_, object_path);
#line 291 "../src/applets/status/PowerIndicator.vala"
	power_indicator_toggle_show (self);
#line 1548 "PowerIndicator.c"
}

static void
__lambda10_ (PowerIndicator* self,
             UpDevice* device)
{
#line 298 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (device != NULL);
#line 299 "../src/applets/status/PowerIndicator.vala"
	power_indicator_on_device_added (self, device);
#line 1559 "PowerIndicator.c"
}

static void
___lambda10__gfunc (gconstpointer data,
                    gpointer self)
{
#line 298 "../src/applets/status/PowerIndicator.vala"
	__lambda10_ ((PowerIndicator*) self, (UpDevice*) data);
#line 1568 "PowerIndicator.c"
}

static void
power_indicator_sync_devices (PowerIndicator* self)
{
	GPtrArray* devices = NULL;
	UpClient* _tmp0_;
	GPtrArray* _tmp1_;
#line 294 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 296 "../src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->_client;
#line 296 "../src/applets/status/PowerIndicator.vala"
	_tmp1_ = up_client_get_devices (_tmp0_);
#line 296 "../src/applets/status/PowerIndicator.vala"
	devices = _tmp1_;
#line 298 "../src/applets/status/PowerIndicator.vala"
	g_ptr_array_foreach (devices, ___lambda10__gfunc, self);
#line 302 "../src/applets/status/PowerIndicator.vala"
	power_indicator_toggle_show (self);
#line 294 "../src/applets/status/PowerIndicator.vala"
	_g_ptr_array_unref0 (devices);
#line 1591 "PowerIndicator.c"
}

UpClient*
power_indicator_get_client (PowerIndicator* self)
{
	UpClient* result;
	UpClient* _tmp0_;
#line 156 "../src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 156 "../src/applets/status/PowerIndicator.vala"
	_tmp0_ = self->priv->_client;
#line 156 "../src/applets/status/PowerIndicator.vala"
	result = _tmp0_;
#line 156 "../src/applets/status/PowerIndicator.vala"
	return result;
#line 1607 "PowerIndicator.c"
}

void
power_indicator_set_client (PowerIndicator* self,
                            UpClient* value)
{
	UpClient* old_value;
#line 156 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/applets/status/PowerIndicator.vala"
	old_value = power_indicator_get_client (self);
#line 156 "../src/applets/status/PowerIndicator.vala"
	if (old_value != value) {
#line 1621 "PowerIndicator.c"
		UpClient* _tmp0_;
#line 156 "../src/applets/status/PowerIndicator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 156 "../src/applets/status/PowerIndicator.vala"
		_g_object_unref0 (self->priv->_client);
#line 156 "../src/applets/status/PowerIndicator.vala"
		self->priv->_client = _tmp0_;
#line 156 "../src/applets/status/PowerIndicator.vala"
		g_object_notify_by_pspec ((GObject *) self, power_indicator_properties[POWER_INDICATOR_CLIENT_PROPERTY]);
#line 1631 "PowerIndicator.c"
	}
}

gboolean
power_indicator_get_label_visible (PowerIndicator* self)
{
	gboolean result;
#line 160 "../src/applets/status/PowerIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 160 "../src/applets/status/PowerIndicator.vala"
	result = self->priv->_label_visible;
#line 160 "../src/applets/status/PowerIndicator.vala"
	return result;
#line 1645 "PowerIndicator.c"
}

void
power_indicator_set_label_visible (PowerIndicator* self,
                                   gboolean value)
{
	gboolean old_value;
#line 160 "../src/applets/status/PowerIndicator.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/applets/status/PowerIndicator.vala"
	old_value = power_indicator_get_label_visible (self);
#line 160 "../src/applets/status/PowerIndicator.vala"
	if (old_value != value) {
#line 160 "../src/applets/status/PowerIndicator.vala"
		self->priv->_label_visible = value;
#line 160 "../src/applets/status/PowerIndicator.vala"
		g_object_notify_by_pspec ((GObject *) self, power_indicator_properties[POWER_INDICATOR_LABEL_VISIBLE_PROPERTY]);
#line 1663 "PowerIndicator.c"
	}
}

static void
power_indicator_class_init (PowerIndicatorClass * klass,
                            gpointer klass_data)
{
#line 149 "../src/applets/status/PowerIndicator.vala"
	power_indicator_parent_class = g_type_class_peek_parent (klass);
#line 149 "../src/applets/status/PowerIndicator.vala"
	g_type_class_adjust_private_offset (klass, &PowerIndicator_private_offset);
#line 149 "../src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_power_indicator_get_property;
#line 149 "../src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_power_indicator_set_property;
#line 149 "../src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (klass)->finalize = power_indicator_finalize;
#line 1681 "PowerIndicator.c"
	/** Our upower client */
#line 149 "../src/applets/status/PowerIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_INDICATOR_CLIENT_PROPERTY, power_indicator_properties[POWER_INDICATOR_CLIENT_PROPERTY] = g_param_spec_object ("client", "client", "client", up_client_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 149 "../src/applets/status/PowerIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_INDICATOR_LABEL_VISIBLE_PROPERTY, power_indicator_properties[POWER_INDICATOR_LABEL_VISIBLE_PROPERTY] = g_param_spec_boolean ("label-visible", "label-visible", "label-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1687 "PowerIndicator.c"
}

static void
power_indicator_instance_init (PowerIndicator * self,
                               gpointer klass)
{
#line 149 "../src/applets/status/PowerIndicator.vala"
	self->priv = power_indicator_get_instance_private (self);
#line 151 "../src/applets/status/PowerIndicator.vala"
	self->ebox = NULL;
#line 152 "../src/applets/status/PowerIndicator.vala"
	self->popover = NULL;
#line 153 "../src/applets/status/PowerIndicator.vala"
	self->priv->widget = NULL;
#line 160 "../src/applets/status/PowerIndicator.vala"
	self->priv->_label_visible = FALSE;
#line 1704 "PowerIndicator.c"
}

static void
power_indicator_finalize (GObject * obj)
{
	PowerIndicator * self;
#line 149 "../src/applets/status/PowerIndicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_POWER_INDICATOR, PowerIndicator);
#line 151 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->ebox);
#line 152 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->popover);
#line 153 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->widget);
#line 156 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->_client);
#line 158 "../src/applets/status/PowerIndicator.vala"
	_g_hash_table_unref0 (self->priv->devices);
#line 161 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->check_percent);
#line 162 "../src/applets/status/PowerIndicator.vala"
	_g_object_unref0 (self->priv->battery_settings);
#line 149 "../src/applets/status/PowerIndicator.vala"
	G_OBJECT_CLASS (power_indicator_parent_class)->finalize (obj);
#line 1729 "PowerIndicator.c"
}

GType
power_indicator_get_type (void)
{
	return power_indicator_type_id;
}

GType
power_indicator_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerIndicator), 0, (GInstanceInitFunc) power_indicator_instance_init, NULL };
	power_indicator_type_id = g_type_module_register_type (module, gtk_bin_get_type (), "PowerIndicator", &g_define_type_info, 0);
	PowerIndicator_private_offset = sizeof (PowerIndicatorPrivate);
	return power_indicator_type_id;
}

static void
_vala_power_indicator_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	PowerIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_POWER_INDICATOR, PowerIndicator);
#line 149 "../src/applets/status/PowerIndicator.vala"
	switch (property_id) {
#line 149 "../src/applets/status/PowerIndicator.vala"
		case POWER_INDICATOR_CLIENT_PROPERTY:
#line 149 "../src/applets/status/PowerIndicator.vala"
		g_value_set_object (value, power_indicator_get_client (self));
#line 149 "../src/applets/status/PowerIndicator.vala"
		break;
#line 149 "../src/applets/status/PowerIndicator.vala"
		case POWER_INDICATOR_LABEL_VISIBLE_PROPERTY:
#line 149 "../src/applets/status/PowerIndicator.vala"
		g_value_set_boolean (value, power_indicator_get_label_visible (self));
#line 149 "../src/applets/status/PowerIndicator.vala"
		break;
#line 1769 "PowerIndicator.c"
		default:
#line 149 "../src/applets/status/PowerIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 149 "../src/applets/status/PowerIndicator.vala"
		break;
#line 1775 "PowerIndicator.c"
	}
}

static void
_vala_power_indicator_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	PowerIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_POWER_INDICATOR, PowerIndicator);
#line 149 "../src/applets/status/PowerIndicator.vala"
	switch (property_id) {
#line 149 "../src/applets/status/PowerIndicator.vala"
		case POWER_INDICATOR_CLIENT_PROPERTY:
#line 149 "../src/applets/status/PowerIndicator.vala"
		power_indicator_set_client (self, g_value_get_object (value));
#line 149 "../src/applets/status/PowerIndicator.vala"
		break;
#line 149 "../src/applets/status/PowerIndicator.vala"
		case POWER_INDICATOR_LABEL_VISIBLE_PROPERTY:
#line 149 "../src/applets/status/PowerIndicator.vala"
		power_indicator_set_label_visible (self, g_value_get_boolean (value));
#line 149 "../src/applets/status/PowerIndicator.vala"
		break;
#line 1801 "PowerIndicator.c"
		default:
#line 149 "../src/applets/status/PowerIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 149 "../src/applets/status/PowerIndicator.vala"
		break;
#line 1807 "PowerIndicator.c"
	}
}

