/* SoundIndicator.c generated by valac 0.56.3, the Vala compiler
 * generated from SoundIndicator.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2022 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "statusapplet.h"
#include <gtk/gtk.h>
#include <pulse/pulseaudio.h>
#include <gvc-mixer-control.h>
#include <gvc-mixer-stream.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include "plugin.h"
#include <gdk/gdk.h>
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>

#define MIXER_NAME "Budgie Volume Control"

enum  {
	SOUND_INDICATOR_0_PROPERTY,
	SOUND_INDICATOR_WIDGET_PROPERTY,
	SOUND_INDICATOR_MIXER_PROPERTY,
	SOUND_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* sound_indicator_properties[SOUND_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SoundIndicatorPrivate {
	GtkImage* _widget;
	GvcMixerControl* _mixer;
	GvcMixerStream* stream;
	GtkButtonBox* buttons;
	GtkButton* settings_button;
	GtkButton* mute_button;
	GtkButton* volume_down;
	GtkButton* volume_up;
	GtkScale* volume_scale;
	gdouble step_size;
	gulong notify_id;
	gulong scale_id;
};

static gint SoundIndicator_private_offset;
static gpointer sound_indicator_parent_class = NULL;
static GType sound_indicator_type_id = 0;

static void _sound_indicator_on_state_change_gvc_mixer_control_state_changed (GvcMixerControl* _sender,
                                                                       guint new_state,
                                                                       gpointer self);
static void sound_indicator_on_sink_changed (SoundIndicator* self,
                                      guint id);
static void _sound_indicator_on_sink_changed_gvc_mixer_control_default_sink_changed (GvcMixerControl* _sender,
                                                                              guint id,
                                                                              gpointer self);
static void sound_indicator_create_sound_popover (SoundIndicator* self);
static gboolean _sound_indicator_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                   GdkEventScroll* event,
                                                                   gpointer self);
static gboolean sound_indicator_on_button_release_event (SoundIndicator* self,
                                                  GdkEventButton* e);
static gboolean _sound_indicator_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                   GdkEventButton* event,
                                                                                   gpointer self);
static void sound_indicator_toggle_mute_state (SoundIndicator* self);
static void sound_indicator_on_scale_changed (SoundIndicator* self);
static void _sound_indicator_on_scale_changed_gtk_range_value_changed (GtkRange* _sender,
                                                                gpointer self);
static void _sound_indicator_toggle_mute_state_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void sound_indicator_open_sound_settings (SoundIndicator* self);
static void _sound_indicator_open_sound_settings_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void __lambda8_ (SoundIndicator* self);
static void sound_indicator_adjust_volume_increment (SoundIndicator* self,
                                              gdouble increment);
static void ___lambda8__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda9_ (SoundIndicator* self);
static void ___lambda9__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void sound_indicator_set_default_mixer (SoundIndicator* self);
static void sound_indicator_on_notify (SoundIndicator* self,
                                GObject* o,
                                GParamSpec* p);
static void _sound_indicator_on_notify_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self);
static void sound_indicator_finalize (GObject * obj);
static void _vala_sound_indicator_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_sound_indicator_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sound_indicator_get_instance_private (SoundIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, SoundIndicator_private_offset);
}

static void
_sound_indicator_on_state_change_gvc_mixer_control_state_changed (GvcMixerControl* _sender,
                                                                  guint new_state,
                                                                  gpointer self)
{
#line 54 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_on_state_change ((SoundIndicator*) self, new_state);
#line 134 "SoundIndicator.c"
}

static void
_sound_indicator_on_sink_changed_gvc_mixer_control_default_sink_changed (GvcMixerControl* _sender,
                                                                         guint id,
                                                                         gpointer self)
{
#line 55 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_on_sink_changed ((SoundIndicator*) self, id);
#line 144 "SoundIndicator.c"
}

static gboolean
_sound_indicator_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                          GdkEventScroll* event,
                                                          gpointer self)
{
	gboolean result;
	result = sound_indicator_on_scroll_event ((SoundIndicator*) self, event);
#line 67 "../src/applets/status/SoundIndicator.vala"
	return result;
#line 156 "SoundIndicator.c"
}

static gboolean
_sound_indicator_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                          GdkEventButton* event,
                                                                          gpointer self)
{
	gboolean result;
	result = sound_indicator_on_button_release_event ((SoundIndicator*) self, event);
#line 68 "../src/applets/status/SoundIndicator.vala"
	return result;
#line 168 "SoundIndicator.c"
}

SoundIndicator*
sound_indicator_construct (GType object_type)
{
	SoundIndicator * self = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkEventBox* _tmp2_;
	GtkEventBox* _tmp3_;
	GtkImage* _tmp4_;
	GtkEventBox* _tmp5_;
	GtkEventBox* _tmp6_;
	GtkEventBox* _tmp7_;
	GvcMixerControl* _tmp8_;
	GvcMixerControl* _tmp9_;
	GvcMixerControl* _tmp10_;
	GvcMixerControl* _tmp11_;
	GvcMixerControl* _tmp12_;
	GtkStyleContext* _tmp13_;
	BudgiePopover* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkEventBox* _tmp16_;
	GtkEventBox* _tmp17_;
	GtkEventBox* _tmp18_;
	GtkEventBox* _tmp19_;
#line 44 "../src/applets/status/SoundIndicator.vala"
	self = (SoundIndicator*) g_object_new (object_type, NULL);
#line 46 "../src/applets/status/SoundIndicator.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-muted-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 46 "../src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp0_);
#line 46 "../src/applets/status/SoundIndicator.vala"
	_tmp1_ = _tmp0_;
#line 46 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_set_widget (self, _tmp1_);
#line 46 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (_tmp1_);
#line 47 "../src/applets/status/SoundIndicator.vala"
	_tmp2_ = (GtkEventBox*) gtk_event_box_new ();
#line 47 "../src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp2_);
#line 47 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->ebox);
#line 47 "../src/applets/status/SoundIndicator.vala"
	self->ebox = _tmp2_;
#line 48 "../src/applets/status/SoundIndicator.vala"
	_tmp3_ = self->ebox;
#line 48 "../src/applets/status/SoundIndicator.vala"
	_tmp4_ = self->priv->_widget;
#line 48 "../src/applets/status/SoundIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 49 "../src/applets/status/SoundIndicator.vala"
	_tmp5_ = self->ebox;
#line 49 "../src/applets/status/SoundIndicator.vala"
	g_object_set ((GtkWidget*) _tmp5_, "margin", 0, NULL);
#line 50 "../src/applets/status/SoundIndicator.vala"
	_tmp6_ = self->ebox;
#line 50 "../src/applets/status/SoundIndicator.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp6_, (guint) 0);
#line 51 "../src/applets/status/SoundIndicator.vala"
	_tmp7_ = self->ebox;
#line 51 "../src/applets/status/SoundIndicator.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp7_);
#line 53 "../src/applets/status/SoundIndicator.vala"
	_tmp8_ = gvc_mixer_control_new (MIXER_NAME);
#line 53 "../src/applets/status/SoundIndicator.vala"
	_tmp9_ = _tmp8_;
#line 53 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_set_mixer (self, _tmp9_);
#line 53 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (_tmp9_);
#line 54 "../src/applets/status/SoundIndicator.vala"
	_tmp10_ = self->priv->_mixer;
#line 54 "../src/applets/status/SoundIndicator.vala"
	g_signal_connect_object (_tmp10_, "state-changed", (GCallback) _sound_indicator_on_state_change_gvc_mixer_control_state_changed, self, 0);
#line 55 "../src/applets/status/SoundIndicator.vala"
	_tmp11_ = self->priv->_mixer;
#line 55 "../src/applets/status/SoundIndicator.vala"
	g_signal_connect_object (_tmp11_, "default-sink-changed", (GCallback) _sound_indicator_on_sink_changed_gvc_mixer_control_default_sink_changed, self, 0);
#line 56 "../src/applets/status/SoundIndicator.vala"
	_tmp12_ = self->priv->_mixer;
#line 56 "../src/applets/status/SoundIndicator.vala"
	gvc_mixer_control_open (_tmp12_);
#line 59 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_create_sound_popover (self);
#line 61 "../src/applets/status/SoundIndicator.vala"
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 61 "../src/applets/status/SoundIndicator.vala"
	gtk_style_context_add_class (_tmp13_, "sound-applet");
#line 62 "../src/applets/status/SoundIndicator.vala"
	_tmp14_ = self->popover;
#line 62 "../src/applets/status/SoundIndicator.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 62 "../src/applets/status/SoundIndicator.vala"
	gtk_style_context_add_class (_tmp15_, "sound-popover");
#line 65 "../src/applets/status/SoundIndicator.vala"
	_tmp16_ = self->ebox;
#line 65 "../src/applets/status/SoundIndicator.vala"
	gtk_widget_add_events ((GtkWidget*) _tmp16_, (gint) GDK_SCROLL_MASK);
#line 66 "../src/applets/status/SoundIndicator.vala"
	_tmp17_ = self->ebox;
#line 66 "../src/applets/status/SoundIndicator.vala"
	gtk_widget_add_events ((GtkWidget*) _tmp17_, (gint) GDK_BUTTON_RELEASE_MASK);
#line 67 "../src/applets/status/SoundIndicator.vala"
	_tmp18_ = self->ebox;
#line 67 "../src/applets/status/SoundIndicator.vala"
	g_signal_connect_object ((GtkWidget*) _tmp18_, "scroll-event", (GCallback) _sound_indicator_on_scroll_event_gtk_widget_scroll_event, self, 0);
#line 68 "../src/applets/status/SoundIndicator.vala"
	_tmp19_ = self->ebox;
#line 68 "../src/applets/status/SoundIndicator.vala"
	g_signal_connect_object ((GtkWidget*) _tmp19_, "button-release-event", (GCallback) _sound_indicator_on_button_release_event_gtk_widget_button_release_event, self, 0);
#line 69 "../src/applets/status/SoundIndicator.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 44 "../src/applets/status/SoundIndicator.vala"
	return self;
#line 285 "SoundIndicator.c"
}

SoundIndicator*
sound_indicator_new (void)
{
#line 44 "../src/applets/status/SoundIndicator.vala"
	return sound_indicator_construct (TYPE_SOUND_INDICATOR);
#line 293 "SoundIndicator.c"
}

static gboolean
sound_indicator_on_button_release_event (SoundIndicator* self,
                                         GdkEventButton* e)
{
	gboolean result;
#line 72 "../src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 72 "../src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 73 "../src/applets/status/SoundIndicator.vala"
	if (e->button == ((guint) GDK_BUTTON_MIDDLE)) {
#line 74 "../src/applets/status/SoundIndicator.vala"
		sound_indicator_toggle_mute_state (self);
#line 309 "SoundIndicator.c"
	} else {
#line 76 "../src/applets/status/SoundIndicator.vala"
		result = GDK_EVENT_PROPAGATE;
#line 76 "../src/applets/status/SoundIndicator.vala"
		return result;
#line 315 "SoundIndicator.c"
	}
#line 79 "../src/applets/status/SoundIndicator.vala"
	result = GDK_EVENT_STOP;
#line 79 "../src/applets/status/SoundIndicator.vala"
	return result;
#line 321 "SoundIndicator.c"
}

/**
 * Create the GtkPopover to display on primary click action, with an adjustable
 * scale
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 107 "../src/applets/status/SoundIndicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 333 "SoundIndicator.c"
}

static void
_sound_indicator_on_scale_changed_gtk_range_value_changed (GtkRange* _sender,
                                                           gpointer self)
{
#line 134 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_on_scale_changed ((SoundIndicator*) self);
#line 342 "SoundIndicator.c"
}

static void
_sound_indicator_toggle_mute_state_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
#line 136 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_toggle_mute_state ((SoundIndicator*) self);
#line 351 "SoundIndicator.c"
}

static void
_sound_indicator_open_sound_settings_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
#line 138 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_open_sound_settings ((SoundIndicator*) self);
#line 360 "SoundIndicator.c"
}

static void
__lambda8_ (SoundIndicator* self)
{
#line 141 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_adjust_volume_increment (self, -self->priv->step_size);
#line 368 "SoundIndicator.c"
}

static void
___lambda8__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 140 "../src/applets/status/SoundIndicator.vala"
	__lambda8_ ((SoundIndicator*) self);
#line 377 "SoundIndicator.c"
}

static void
__lambda9_ (SoundIndicator* self)
{
#line 145 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_adjust_volume_increment (self, +self->priv->step_size);
#line 385 "SoundIndicator.c"
}

static void
___lambda9__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 144 "../src/applets/status/SoundIndicator.vala"
	__lambda9_ ((SoundIndicator*) self);
#line 394 "SoundIndicator.c"
}

static void
sound_indicator_create_sound_popover (SoundIndicator* self)
{
	GtkEventBox* _tmp0_;
	BudgiePopover* _tmp1_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* direct_volume_controls = NULL;
	GtkBox* _tmp4_;
	GtkScale* _tmp5_;
	GtkScale* _tmp6_;
	GtkScale* _tmp7_;
	GtkScale* _tmp8_;
	GtkScale* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton** b_list = NULL;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	GtkButton* _tmp16_;
	GtkButton* _tmp17_;
	GtkButton* _tmp18_;
	GtkButton* _tmp19_;
	GtkButton* _tmp20_;
	GtkButton* _tmp21_;
	GtkButton** _tmp22_;
	gint b_list_length1;
	gint _b_list_size_;
	GtkButtonBox* _tmp34_;
	GtkButtonBox* _tmp35_;
	GtkButtonBox* _tmp36_;
	GtkButton* _tmp37_;
	GtkButtonBox* _tmp38_;
	GtkButton* _tmp39_;
	GtkBox* _tmp40_;
	GtkButton* _tmp41_;
	GtkBox* _tmp42_;
	GtkScale* _tmp43_;
	GtkBox* _tmp44_;
	GtkButton* _tmp45_;
	GtkBox* _tmp46_;
	GtkBox* _tmp47_;
	GtkBox* _tmp48_;
	GtkButtonBox* _tmp49_;
	BudgiePopover* _tmp50_;
	GtkBox* _tmp51_;
	GtkScale* _tmp52_;
	gulong _tmp53_;
	GtkButton* _tmp54_;
	GtkButton* _tmp55_;
	GtkButton* _tmp56_;
	GtkButton* _tmp57_;
	BudgiePopover* _tmp58_;
	GtkWidget* _tmp59_;
#line 86 "../src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->ebox;
#line 87 "../src/applets/status/SoundIndicator.vala"
	_tmp1_ = (BudgiePopover*) budgie_popover_new ((GtkWidget*) _tmp0_);
#line 87 "../src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp1_);
#line 87 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->popover);
#line 87 "../src/applets/status/SoundIndicator.vala"
	self->popover = _tmp1_;
#line 89 "../src/applets/status/SoundIndicator.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 89 "../src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp2_);
#line 89 "../src/applets/status/SoundIndicator.vala"
	main_box = _tmp2_;
#line 90 "../src/applets/status/SoundIndicator.vala"
	_tmp3_ = main_box;
#line 90 "../src/applets/status/SoundIndicator.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp3_, (guint) 6);
#line 92 "../src/applets/status/SoundIndicator.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 92 "../src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp4_);
#line 92 "../src/applets/status/SoundIndicator.vala"
	direct_volume_controls = _tmp4_;
#line 96 "../src/applets/status/SoundIndicator.vala"
	_tmp5_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 100, (gdouble) 1);
#line 96 "../src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp5_);
#line 96 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 96 "../src/applets/status/SoundIndicator.vala"
	self->priv->volume_scale = _tmp5_;
#line 97 "../src/applets/status/SoundIndicator.vala"
	_tmp6_ = self->priv->volume_scale;
#line 97 "../src/applets/status/SoundIndicator.vala"
	gtk_scale_set_draw_value (_tmp6_, FALSE);
#line 98 "../src/applets/status/SoundIndicator.vala"
	_tmp7_ = self->priv->volume_scale;
#line 98 "../src/applets/status/SoundIndicator.vala"
	gtk_widget_set_can_focus ((GtkWidget*) _tmp7_, FALSE);
#line 99 "../src/applets/status/SoundIndicator.vala"
	_tmp8_ = self->priv->volume_scale;
#line 99 "../src/applets/status/SoundIndicator.vala"
	gtk_range_set_inverted ((GtkRange*) _tmp8_, FALSE);
#line 100 "../src/applets/status/SoundIndicator.vala"
	_tmp9_ = self->priv->volume_scale;
#line 100 "../src/applets/status/SoundIndicator.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp9_, 140, -1);
#line 102 "../src/applets/status/SoundIndicator.vala"
	_tmp10_ = (GtkButton*) gtk_button_new_from_icon_name ("preferences-system-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 102 "../src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp10_);
#line 102 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->settings_button);
#line 102 "../src/applets/status/SoundIndicator.vala"
	self->priv->settings_button = _tmp10_;
#line 103 "../src/applets/status/SoundIndicator.vala"
	_tmp11_ = (GtkButton*) gtk_button_new_from_icon_name ("audio-volume-high-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 103 "../src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp11_);
#line 103 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->mute_button);
#line 103 "../src/applets/status/SoundIndicator.vala"
	self->priv->mute_button = _tmp11_;
#line 104 "../src/applets/status/SoundIndicator.vala"
	_tmp12_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 104 "../src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp12_);
#line 104 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->volume_down);
#line 104 "../src/applets/status/SoundIndicator.vala"
	self->priv->volume_down = _tmp12_;
#line 105 "../src/applets/status/SoundIndicator.vala"
	_tmp13_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 105 "../src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp13_);
#line 105 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->volume_up);
#line 105 "../src/applets/status/SoundIndicator.vala"
	self->priv->volume_up = _tmp13_;
#line 107 "../src/applets/status/SoundIndicator.vala"
	_tmp14_ = self->priv->settings_button;
#line 107 "../src/applets/status/SoundIndicator.vala"
	_tmp15_ = _g_object_ref0 (_tmp14_);
#line 107 "../src/applets/status/SoundIndicator.vala"
	_tmp16_ = self->priv->mute_button;
#line 107 "../src/applets/status/SoundIndicator.vala"
	_tmp17_ = _g_object_ref0 (_tmp16_);
#line 107 "../src/applets/status/SoundIndicator.vala"
	_tmp18_ = self->priv->volume_down;
#line 107 "../src/applets/status/SoundIndicator.vala"
	_tmp19_ = _g_object_ref0 (_tmp18_);
#line 107 "../src/applets/status/SoundIndicator.vala"
	_tmp20_ = self->priv->volume_up;
#line 107 "../src/applets/status/SoundIndicator.vala"
	_tmp21_ = _g_object_ref0 (_tmp20_);
#line 107 "../src/applets/status/SoundIndicator.vala"
	_tmp22_ = g_new0 (GtkButton*, 4 + 1);
#line 107 "../src/applets/status/SoundIndicator.vala"
	_tmp22_[0] = _tmp15_;
#line 107 "../src/applets/status/SoundIndicator.vala"
	_tmp22_[1] = _tmp17_;
#line 107 "../src/applets/status/SoundIndicator.vala"
	_tmp22_[2] = _tmp19_;
#line 107 "../src/applets/status/SoundIndicator.vala"
	_tmp22_[3] = _tmp21_;
#line 107 "../src/applets/status/SoundIndicator.vala"
	b_list = _tmp22_;
#line 107 "../src/applets/status/SoundIndicator.vala"
	b_list_length1 = 4;
#line 107 "../src/applets/status/SoundIndicator.vala"
	_b_list_size_ = b_list_length1;
#line 570 "SoundIndicator.c"
	{
		gint i = 0;
#line 108 "../src/applets/status/SoundIndicator.vala"
		i = 0;
#line 575 "SoundIndicator.c"
		{
			gboolean _tmp23_ = FALSE;
#line 108 "../src/applets/status/SoundIndicator.vala"
			_tmp23_ = TRUE;
#line 108 "../src/applets/status/SoundIndicator.vala"
			while (TRUE) {
#line 582 "SoundIndicator.c"
				GtkButton** _tmp25_;
				gint _tmp25__length1;
				GtkButton* button = NULL;
				GtkButton** _tmp26_;
				gint _tmp26__length1;
				GtkButton* _tmp27_;
				GtkButton* _tmp28_;
				GtkButton* _tmp29_;
				GtkButton* _tmp30_;
				GtkStyleContext* _tmp31_;
				GtkButton* _tmp32_;
				GtkStyleContext* _tmp33_;
#line 108 "../src/applets/status/SoundIndicator.vala"
				if (!_tmp23_) {
#line 597 "SoundIndicator.c"
					gint _tmp24_;
#line 108 "../src/applets/status/SoundIndicator.vala"
					_tmp24_ = i;
#line 108 "../src/applets/status/SoundIndicator.vala"
					i = _tmp24_ + 1;
#line 603 "SoundIndicator.c"
				}
#line 108 "../src/applets/status/SoundIndicator.vala"
				_tmp23_ = FALSE;
#line 108 "../src/applets/status/SoundIndicator.vala"
				_tmp25_ = b_list;
#line 108 "../src/applets/status/SoundIndicator.vala"
				_tmp25__length1 = b_list_length1;
#line 108 "../src/applets/status/SoundIndicator.vala"
				if (!(i < _tmp25__length1)) {
#line 108 "../src/applets/status/SoundIndicator.vala"
					break;
#line 615 "SoundIndicator.c"
				}
#line 109 "../src/applets/status/SoundIndicator.vala"
				_tmp26_ = b_list;
#line 109 "../src/applets/status/SoundIndicator.vala"
				_tmp26__length1 = b_list_length1;
#line 109 "../src/applets/status/SoundIndicator.vala"
				_tmp27_ = _tmp26_[i];
#line 109 "../src/applets/status/SoundIndicator.vala"
				_tmp28_ = _g_object_ref0 (_tmp27_);
#line 109 "../src/applets/status/SoundIndicator.vala"
				button = _tmp28_;
#line 110 "../src/applets/status/SoundIndicator.vala"
				_tmp29_ = button;
#line 110 "../src/applets/status/SoundIndicator.vala"
				gtk_widget_set_can_focus ((GtkWidget*) _tmp29_, FALSE);
#line 111 "../src/applets/status/SoundIndicator.vala"
				_tmp30_ = button;
#line 111 "../src/applets/status/SoundIndicator.vala"
				_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) _tmp30_);
#line 111 "../src/applets/status/SoundIndicator.vala"
				gtk_style_context_add_class (_tmp31_, GTK_STYLE_CLASS_FLAT);
#line 112 "../src/applets/status/SoundIndicator.vala"
				_tmp32_ = button;
#line 112 "../src/applets/status/SoundIndicator.vala"
				_tmp33_ = gtk_widget_get_style_context ((GtkWidget*) _tmp32_);
#line 112 "../src/applets/status/SoundIndicator.vala"
				gtk_style_context_add_class (_tmp33_, "image-button");
#line 108 "../src/applets/status/SoundIndicator.vala"
				_g_object_unref0 (button);
#line 645 "SoundIndicator.c"
			}
		}
	}
#line 115 "../src/applets/status/SoundIndicator.vala"
	_tmp34_ = (GtkButtonBox*) gtk_button_box_new (GTK_ORIENTATION_HORIZONTAL);
#line 115 "../src/applets/status/SoundIndicator.vala"
	g_object_ref_sink (_tmp34_);
#line 115 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->buttons);
#line 115 "../src/applets/status/SoundIndicator.vala"
	self->priv->buttons = _tmp34_;
#line 116 "../src/applets/status/SoundIndicator.vala"
	_tmp35_ = self->priv->buttons;
#line 116 "../src/applets/status/SoundIndicator.vala"
	gtk_button_box_set_layout (_tmp35_, GTK_BUTTONBOX_EXPAND);
#line 120 "../src/applets/status/SoundIndicator.vala"
	_tmp36_ = self->priv->buttons;
#line 120 "../src/applets/status/SoundIndicator.vala"
	_tmp37_ = self->priv->mute_button;
#line 120 "../src/applets/status/SoundIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
#line 121 "../src/applets/status/SoundIndicator.vala"
	_tmp38_ = self->priv->buttons;
#line 121 "../src/applets/status/SoundIndicator.vala"
	_tmp39_ = self->priv->settings_button;
#line 121 "../src/applets/status/SoundIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
#line 123 "../src/applets/status/SoundIndicator.vala"
	_tmp40_ = direct_volume_controls;
#line 123 "../src/applets/status/SoundIndicator.vala"
	_tmp41_ = self->priv->volume_down;
#line 123 "../src/applets/status/SoundIndicator.vala"
	gtk_box_pack_start (_tmp40_, (GtkWidget*) _tmp41_, FALSE, FALSE, (guint) 1);
#line 124 "../src/applets/status/SoundIndicator.vala"
	_tmp42_ = direct_volume_controls;
#line 124 "../src/applets/status/SoundIndicator.vala"
	_tmp43_ = self->priv->volume_scale;
#line 124 "../src/applets/status/SoundIndicator.vala"
	gtk_box_pack_start (_tmp42_, (GtkWidget*) _tmp43_, FALSE, FALSE, (guint) 0);
#line 125 "../src/applets/status/SoundIndicator.vala"
	_tmp44_ = direct_volume_controls;
#line 125 "../src/applets/status/SoundIndicator.vala"
	_tmp45_ = self->priv->volume_up;
#line 125 "../src/applets/status/SoundIndicator.vala"
	gtk_box_pack_start (_tmp44_, (GtkWidget*) _tmp45_, FALSE, FALSE, (guint) 1);
#line 127 "../src/applets/status/SoundIndicator.vala"
	_tmp46_ = main_box;
#line 127 "../src/applets/status/SoundIndicator.vala"
	_tmp47_ = direct_volume_controls;
#line 127 "../src/applets/status/SoundIndicator.vala"
	gtk_box_pack_start (_tmp46_, (GtkWidget*) _tmp47_, FALSE, FALSE, (guint) 0);
#line 128 "../src/applets/status/SoundIndicator.vala"
	_tmp48_ = main_box;
#line 128 "../src/applets/status/SoundIndicator.vala"
	_tmp49_ = self->priv->buttons;
#line 128 "../src/applets/status/SoundIndicator.vala"
	gtk_box_pack_start (_tmp48_, (GtkWidget*) _tmp49_, FALSE, FALSE, (guint) 0);
#line 130 "../src/applets/status/SoundIndicator.vala"
	_tmp50_ = self->popover;
#line 130 "../src/applets/status/SoundIndicator.vala"
	_tmp51_ = main_box;
#line 130 "../src/applets/status/SoundIndicator.vala"
	gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
#line 134 "../src/applets/status/SoundIndicator.vala"
	_tmp52_ = self->priv->volume_scale;
#line 134 "../src/applets/status/SoundIndicator.vala"
	_tmp53_ = g_signal_connect_object ((GtkRange*) _tmp52_, "value-changed", (GCallback) _sound_indicator_on_scale_changed_gtk_range_value_changed, self, 0);
#line 134 "../src/applets/status/SoundIndicator.vala"
	self->priv->scale_id = _tmp53_;
#line 136 "../src/applets/status/SoundIndicator.vala"
	_tmp54_ = self->priv->mute_button;
#line 136 "../src/applets/status/SoundIndicator.vala"
	g_signal_connect_object (_tmp54_, "clicked", (GCallback) _sound_indicator_toggle_mute_state_gtk_button_clicked, self, 0);
#line 138 "../src/applets/status/SoundIndicator.vala"
	_tmp55_ = self->priv->settings_button;
#line 138 "../src/applets/status/SoundIndicator.vala"
	g_signal_connect_object (_tmp55_, "clicked", (GCallback) _sound_indicator_open_sound_settings_gtk_button_clicked, self, 0);
#line 140 "../src/applets/status/SoundIndicator.vala"
	_tmp56_ = self->priv->volume_down;
#line 140 "../src/applets/status/SoundIndicator.vala"
	g_signal_connect_object (_tmp56_, "clicked", (GCallback) ___lambda8__gtk_button_clicked, self, 0);
#line 144 "../src/applets/status/SoundIndicator.vala"
	_tmp57_ = self->priv->volume_up;
#line 144 "../src/applets/status/SoundIndicator.vala"
	g_signal_connect_object (_tmp57_, "clicked", (GCallback) ___lambda9__gtk_button_clicked, self, 0);
#line 150 "../src/applets/status/SoundIndicator.vala"
	_tmp58_ = self->popover;
#line 150 "../src/applets/status/SoundIndicator.vala"
	_tmp59_ = gtk_bin_get_child ((GtkBin*) _tmp58_);
#line 150 "../src/applets/status/SoundIndicator.vala"
	gtk_widget_show_all (_tmp59_);
#line 86 "../src/applets/status/SoundIndicator.vala"
	b_list = (_vala_array_free (b_list, b_list_length1, (GDestroyNotify) g_object_unref), NULL);
#line 86 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (direct_volume_controls);
#line 86 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (main_box);
#line 743 "SoundIndicator.c"
}

static void
sound_indicator_on_sink_changed (SoundIndicator* self,
                                 guint id)
{
#line 153 "../src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_set_default_mixer (self);
#line 754 "SoundIndicator.c"
}

static void
_sound_indicator_on_notify_g_object_notify (GObject* _sender,
                                            GParamSpec* pspec,
                                            gpointer self)
{
#line 163 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_on_notify ((SoundIndicator*) self, _sender, pspec);
#line 764 "SoundIndicator.c"
}

static void
sound_indicator_set_default_mixer (SoundIndicator* self)
{
	GvcMixerStream* _tmp0_;
	GvcMixerControl* _tmp2_;
	GvcMixerStream* _tmp3_;
	GvcMixerStream* _tmp4_;
	GvcMixerStream* _tmp5_;
	gulong _tmp6_;
#line 157 "../src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->priv->stream;
#line 158 "../src/applets/status/SoundIndicator.vala"
	if (_tmp0_ != NULL) {
#line 782 "SoundIndicator.c"
		GvcMixerStream* _tmp1_;
#line 159 "../src/applets/status/SoundIndicator.vala"
		_tmp1_ = self->priv->stream;
#line 159 "../src/applets/status/SoundIndicator.vala"
		g_signal_handler_disconnect (_tmp1_, self->priv->notify_id);
#line 788 "SoundIndicator.c"
	}
#line 162 "../src/applets/status/SoundIndicator.vala"
	_tmp2_ = self->priv->_mixer;
#line 162 "../src/applets/status/SoundIndicator.vala"
	_tmp3_ = gvc_mixer_control_get_default_sink (_tmp2_);
#line 162 "../src/applets/status/SoundIndicator.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 162 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->stream);
#line 162 "../src/applets/status/SoundIndicator.vala"
	self->priv->stream = _tmp4_;
#line 163 "../src/applets/status/SoundIndicator.vala"
	_tmp5_ = self->priv->stream;
#line 163 "../src/applets/status/SoundIndicator.vala"
	_tmp6_ = g_signal_connect_object ((GObject*) _tmp5_, "notify", (GCallback) _sound_indicator_on_notify_g_object_notify, self, 0);
#line 163 "../src/applets/status/SoundIndicator.vala"
	self->priv->notify_id = _tmp6_;
#line 164 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_update_volume (self);
#line 808 "SoundIndicator.c"
}

static void
sound_indicator_on_notify (SoundIndicator* self,
                           GObject* o,
                           GParamSpec* p)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 167 "../src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/applets/status/SoundIndicator.vala"
	_tmp1_ = p->name;
#line 168 "../src/applets/status/SoundIndicator.vala"
	if (g_strcmp0 (_tmp1_, "volume") == 0) {
#line 168 "../src/applets/status/SoundIndicator.vala"
		_tmp0_ = TRUE;
#line 826 "SoundIndicator.c"
	} else {
		const gchar* _tmp2_;
#line 168 "../src/applets/status/SoundIndicator.vala"
		_tmp2_ = p->name;
#line 168 "../src/applets/status/SoundIndicator.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "is-muted") == 0;
#line 833 "SoundIndicator.c"
	}
#line 168 "../src/applets/status/SoundIndicator.vala"
	if (_tmp0_) {
#line 169 "../src/applets/status/SoundIndicator.vala"
		sound_indicator_update_volume (self);
#line 839 "SoundIndicator.c"
	}
}

/**
 * Called when something changes on the mixer, i.e. we connected
 * This is where we hook into the stream for changes
 */
void
sound_indicator_on_state_change (SoundIndicator* self,
                                 guint new_state)
{
#line 177 "../src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 178 "../src/applets/status/SoundIndicator.vala"
	if (new_state == ((guint) GVC_STATE_READY)) {
#line 179 "../src/applets/status/SoundIndicator.vala"
		sound_indicator_set_default_mixer (self);
#line 857 "SoundIndicator.c"
	}
}

/**
 * Update from scroll events. turn volume up + down.
 */
gboolean
sound_indicator_on_scroll_event (SoundIndicator* self,
                                 GdkEventScroll* event)
{
	GvcMixerStream* _tmp0_;
	guint32 vol = 0U;
	GvcMixerStream* _tmp1_;
	guint32 orig_vol = 0U;
	gdouble max_amp = 0.0;
	GvcMixerControl* _tmp2_;
	gdouble norm = 0.0;
	GvcMixerControl* _tmp3_;
	GtkScale* _tmp4_;
	GvcMixerStream* _tmp5_;
	GtkScale* _tmp7_;
	gboolean result;
#line 186 "../src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 186 "../src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 187 "../src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->priv->stream;
#line 187 "../src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (_tmp0_ != NULL, FALSE);
#line 189 "../src/applets/status/SoundIndicator.vala"
	_tmp1_ = self->priv->stream;
#line 189 "../src/applets/status/SoundIndicator.vala"
	vol = gvc_mixer_stream_get_volume (_tmp1_);
#line 190 "../src/applets/status/SoundIndicator.vala"
	orig_vol = vol;
#line 192 "../src/applets/status/SoundIndicator.vala"
	switch (event->direction) {
#line 192 "../src/applets/status/SoundIndicator.vala"
		case GDK_SCROLL_UP:
#line 898 "SoundIndicator.c"
		{
#line 194 "../src/applets/status/SoundIndicator.vala"
			vol += (guint32) self->priv->step_size;
#line 195 "../src/applets/status/SoundIndicator.vala"
			break;
#line 904 "SoundIndicator.c"
		}
#line 192 "../src/applets/status/SoundIndicator.vala"
		case GDK_SCROLL_DOWN:
#line 908 "SoundIndicator.c"
		{
#line 197 "../src/applets/status/SoundIndicator.vala"
			vol -= (guint32) self->priv->step_size;
#line 199 "../src/applets/status/SoundIndicator.vala"
			if (vol > orig_vol) {
#line 200 "../src/applets/status/SoundIndicator.vala"
				vol = (guint32) 0;
#line 916 "SoundIndicator.c"
			}
#line 202 "../src/applets/status/SoundIndicator.vala"
			break;
#line 920 "SoundIndicator.c"
		}
		default:
		{
#line 205 "../src/applets/status/SoundIndicator.vala"
			result = FALSE;
#line 205 "../src/applets/status/SoundIndicator.vala"
			return result;
#line 928 "SoundIndicator.c"
		}
	}
#line 209 "../src/applets/status/SoundIndicator.vala"
	_tmp2_ = self->priv->_mixer;
#line 209 "../src/applets/status/SoundIndicator.vala"
	max_amp = gvc_mixer_control_get_vol_max_amplified (_tmp2_);
#line 210 "../src/applets/status/SoundIndicator.vala"
	_tmp3_ = self->priv->_mixer;
#line 210 "../src/applets/status/SoundIndicator.vala"
	norm = gvc_mixer_control_get_vol_max_norm (_tmp3_);
#line 211 "../src/applets/status/SoundIndicator.vala"
	if (max_amp < norm) {
#line 212 "../src/applets/status/SoundIndicator.vala"
		max_amp = norm;
#line 943 "SoundIndicator.c"
	}
#line 215 "../src/applets/status/SoundIndicator.vala"
	if (((gdouble) vol) > max_amp) {
#line 216 "../src/applets/status/SoundIndicator.vala"
		vol = (guint32) max_amp;
#line 949 "SoundIndicator.c"
	}
#line 220 "../src/applets/status/SoundIndicator.vala"
	if (((gdouble) vol) >= norm) {
#line 221 "../src/applets/status/SoundIndicator.vala"
		vol = (guint32) norm;
#line 955 "SoundIndicator.c"
	}
#line 224 "../src/applets/status/SoundIndicator.vala"
	_tmp4_ = self->priv->volume_scale;
#line 224 "../src/applets/status/SoundIndicator.vala"
	g_signal_handler_block (_tmp4_, self->priv->scale_id);
#line 225 "../src/applets/status/SoundIndicator.vala"
	_tmp5_ = self->priv->stream;
#line 225 "../src/applets/status/SoundIndicator.vala"
	if (gvc_mixer_stream_set_volume (_tmp5_, vol)) {
#line 965 "SoundIndicator.c"
		GvcMixerStream* _tmp6_;
#line 226 "../src/applets/status/SoundIndicator.vala"
		_tmp6_ = self->priv->stream;
#line 226 "../src/applets/status/SoundIndicator.vala"
		gvc_mixer_stream_push_volume (_tmp6_);
#line 971 "SoundIndicator.c"
	}
#line 228 "../src/applets/status/SoundIndicator.vala"
	_tmp7_ = self->priv->volume_scale;
#line 228 "../src/applets/status/SoundIndicator.vala"
	g_signal_handler_unblock (_tmp7_, self->priv->scale_id);
#line 230 "../src/applets/status/SoundIndicator.vala"
	result = TRUE;
#line 230 "../src/applets/status/SoundIndicator.vala"
	return result;
#line 981 "SoundIndicator.c"
}

static void
sound_indicator_toggle_mute_state (SoundIndicator* self)
{
	GvcMixerStream* _tmp0_;
	GvcMixerStream* _tmp1_;
#line 234 "../src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 235 "../src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->priv->stream;
#line 235 "../src/applets/status/SoundIndicator.vala"
	_tmp1_ = self->priv->stream;
#line 235 "../src/applets/status/SoundIndicator.vala"
	gvc_mixer_stream_change_is_muted (_tmp0_, !gvc_mixer_stream_get_is_muted (_tmp1_));
#line 997 "SoundIndicator.c"
}

/**
 * Update our icon when something changed (volume/mute)
 */
void
sound_indicator_update_volume (SoundIndicator* self)
{
	gdouble vol_norm = 0.0;
	GvcMixerControl* _tmp0_;
	guint32 vol = 0U;
	GvcMixerStream* _tmp1_;
	gint n = 0;
	gchar* image_name = NULL;
	gboolean _tmp2_ = FALSE;
	GvcMixerStream* _tmp3_;
	GtkImage* _tmp8_;
	const gchar* _tmp9_;
	GtkImage* mute_button_image = NULL;
	GtkButton* _tmp10_;
	GtkWidget* _tmp11_;
	GtkImage* _tmp12_;
	GtkImage* _tmp13_;
	gfloat pct = 0.0F;
	guint ipct = 0U;
	GtkImage* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GtkScale* _tmp21_;
	GtkScale* _tmp22_;
	GtkScale* _tmp25_;
	GtkAdjustment* _tmp26_;
	GtkScale* _tmp27_;
#line 241 "../src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->priv->_mixer;
#line 242 "../src/applets/status/SoundIndicator.vala"
	vol_norm = gvc_mixer_control_get_vol_max_norm (_tmp0_);
#line 243 "../src/applets/status/SoundIndicator.vala"
	_tmp1_ = self->priv->stream;
#line 243 "../src/applets/status/SoundIndicator.vala"
	vol = gvc_mixer_stream_get_volume (_tmp1_);
#line 247 "../src/applets/status/SoundIndicator.vala"
	n = ((gint) floor ((3 * vol) / vol_norm)) + 1;
#line 251 "../src/applets/status/SoundIndicator.vala"
	_tmp3_ = self->priv->stream;
#line 251 "../src/applets/status/SoundIndicator.vala"
	if (gvc_mixer_stream_get_is_muted (_tmp3_)) {
#line 251 "../src/applets/status/SoundIndicator.vala"
		_tmp2_ = TRUE;
#line 1051 "SoundIndicator.c"
	} else {
#line 251 "../src/applets/status/SoundIndicator.vala"
		_tmp2_ = vol <= ((guint32) 0);
#line 1055 "SoundIndicator.c"
	}
#line 251 "../src/applets/status/SoundIndicator.vala"
	if (_tmp2_) {
#line 1059 "SoundIndicator.c"
		gchar* _tmp4_;
#line 252 "../src/applets/status/SoundIndicator.vala"
		_tmp4_ = g_strdup ("audio-volume-muted-symbolic");
#line 252 "../src/applets/status/SoundIndicator.vala"
		_g_free0 (image_name);
#line 252 "../src/applets/status/SoundIndicator.vala"
		image_name = _tmp4_;
#line 1067 "SoundIndicator.c"
	} else {
#line 254 "../src/applets/status/SoundIndicator.vala"
		switch (n) {
#line 254 "../src/applets/status/SoundIndicator.vala"
			case 1:
#line 1073 "SoundIndicator.c"
			{
				gchar* _tmp5_;
#line 256 "../src/applets/status/SoundIndicator.vala"
				_tmp5_ = g_strdup ("audio-volume-low-symbolic");
#line 256 "../src/applets/status/SoundIndicator.vala"
				_g_free0 (image_name);
#line 256 "../src/applets/status/SoundIndicator.vala"
				image_name = _tmp5_;
#line 257 "../src/applets/status/SoundIndicator.vala"
				break;
#line 1084 "SoundIndicator.c"
			}
#line 254 "../src/applets/status/SoundIndicator.vala"
			case 2:
#line 1088 "SoundIndicator.c"
			{
				gchar* _tmp6_;
#line 259 "../src/applets/status/SoundIndicator.vala"
				_tmp6_ = g_strdup ("audio-volume-medium-symbolic");
#line 259 "../src/applets/status/SoundIndicator.vala"
				_g_free0 (image_name);
#line 259 "../src/applets/status/SoundIndicator.vala"
				image_name = _tmp6_;
#line 260 "../src/applets/status/SoundIndicator.vala"
				break;
#line 1099 "SoundIndicator.c"
			}
			default:
			{
				gchar* _tmp7_;
#line 262 "../src/applets/status/SoundIndicator.vala"
				_tmp7_ = g_strdup ("audio-volume-high-symbolic");
#line 262 "../src/applets/status/SoundIndicator.vala"
				_g_free0 (image_name);
#line 262 "../src/applets/status/SoundIndicator.vala"
				image_name = _tmp7_;
#line 263 "../src/applets/status/SoundIndicator.vala"
				break;
#line 1112 "SoundIndicator.c"
			}
		}
	}
#line 266 "../src/applets/status/SoundIndicator.vala"
	_tmp8_ = self->priv->_widget;
#line 266 "../src/applets/status/SoundIndicator.vala"
	_tmp9_ = image_name;
#line 266 "../src/applets/status/SoundIndicator.vala"
	gtk_image_set_from_icon_name (_tmp8_, _tmp9_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 268 "../src/applets/status/SoundIndicator.vala"
	_tmp10_ = self->priv->mute_button;
#line 268 "../src/applets/status/SoundIndicator.vala"
	_tmp11_ = gtk_button_get_image (_tmp10_);
#line 268 "../src/applets/status/SoundIndicator.vala"
	_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_image_get_type (), GtkImage));
#line 268 "../src/applets/status/SoundIndicator.vala"
	mute_button_image = _tmp12_;
#line 270 "../src/applets/status/SoundIndicator.vala"
	_tmp13_ = mute_button_image;
#line 270 "../src/applets/status/SoundIndicator.vala"
	if (_tmp13_ != NULL) {
#line 1134 "SoundIndicator.c"
		GtkImage* _tmp14_;
		const gchar* _tmp15_;
#line 271 "../src/applets/status/SoundIndicator.vala"
		_tmp14_ = mute_button_image;
#line 271 "../src/applets/status/SoundIndicator.vala"
		_tmp15_ = image_name;
#line 271 "../src/applets/status/SoundIndicator.vala"
		gtk_image_set_from_icon_name (_tmp14_, _tmp15_, (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 1143 "SoundIndicator.c"
	}
#line 275 "../src/applets/status/SoundIndicator.vala"
	self->priv->step_size = vol_norm / 20;
#line 278 "../src/applets/status/SoundIndicator.vala"
	pct = (((gfloat) vol) / ((gfloat) vol_norm)) * 100;
#line 279 "../src/applets/status/SoundIndicator.vala"
	ipct = (guint) round ((gdouble) pct);
#line 280 "../src/applets/status/SoundIndicator.vala"
	_tmp16_ = self->priv->_widget;
#line 280 "../src/applets/status/SoundIndicator.vala"
	_tmp17_ = g_strdup_printf ("%u", ipct);
#line 280 "../src/applets/status/SoundIndicator.vala"
	_tmp18_ = _tmp17_;
#line 280 "../src/applets/status/SoundIndicator.vala"
	_tmp19_ = g_strconcat (_tmp18_, "%", NULL);
#line 280 "../src/applets/status/SoundIndicator.vala"
	_tmp20_ = _tmp19_;
#line 280 "../src/applets/status/SoundIndicator.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp16_, _tmp20_);
#line 280 "../src/applets/status/SoundIndicator.vala"
	_g_free0 (_tmp20_);
#line 280 "../src/applets/status/SoundIndicator.vala"
	_g_free0 (_tmp18_);
#line 283 "../src/applets/status/SoundIndicator.vala"
	_tmp21_ = self->priv->volume_scale;
#line 283 "../src/applets/status/SoundIndicator.vala"
	g_signal_handler_block (_tmp21_, self->priv->scale_id);
#line 284 "../src/applets/status/SoundIndicator.vala"
	_tmp22_ = self->priv->volume_scale;
#line 284 "../src/applets/status/SoundIndicator.vala"
	gtk_range_set_range ((GtkRange*) _tmp22_, (gdouble) 0, vol_norm);
#line 285 "../src/applets/status/SoundIndicator.vala"
	if (((gdouble) vol) > vol_norm) {
#line 1177 "SoundIndicator.c"
		GtkScale* _tmp23_;
#line 286 "../src/applets/status/SoundIndicator.vala"
		_tmp23_ = self->priv->volume_scale;
#line 286 "../src/applets/status/SoundIndicator.vala"
		gtk_range_set_value ((GtkRange*) _tmp23_, (gdouble) vol);
#line 1183 "SoundIndicator.c"
	} else {
		GtkScale* _tmp24_;
#line 288 "../src/applets/status/SoundIndicator.vala"
		_tmp24_ = self->priv->volume_scale;
#line 288 "../src/applets/status/SoundIndicator.vala"
		gtk_range_set_value ((GtkRange*) _tmp24_, (gdouble) vol);
#line 1190 "SoundIndicator.c"
	}
#line 290 "../src/applets/status/SoundIndicator.vala"
	_tmp25_ = self->priv->volume_scale;
#line 290 "../src/applets/status/SoundIndicator.vala"
	_tmp26_ = gtk_range_get_adjustment ((GtkRange*) _tmp25_);
#line 290 "../src/applets/status/SoundIndicator.vala"
	gtk_adjustment_set_page_increment (_tmp26_, self->priv->step_size);
#line 291 "../src/applets/status/SoundIndicator.vala"
	_tmp27_ = self->priv->volume_scale;
#line 291 "../src/applets/status/SoundIndicator.vala"
	g_signal_handler_unblock (_tmp27_, self->priv->scale_id);
#line 293 "../src/applets/status/SoundIndicator.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 294 "../src/applets/status/SoundIndicator.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 241 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (mute_button_image);
#line 241 "../src/applets/status/SoundIndicator.vala"
	_g_free0 (image_name);
#line 1210 "SoundIndicator.c"
}

/**
 * The scale changed value - update the stream volume to match
 */
static void
sound_indicator_on_scale_changed (SoundIndicator* self)
{
	gboolean _tmp0_ = FALSE;
	GvcMixerStream* _tmp1_;
	gdouble scale_value = 0.0;
	GtkScale* _tmp3_;
	GtkScale* _tmp4_;
	GvcMixerStream* _tmp5_;
	GtkScale* _tmp7_;
#line 300 "../src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/applets/status/SoundIndicator.vala"
	_tmp1_ = self->priv->stream;
#line 301 "../src/applets/status/SoundIndicator.vala"
	if (_tmp1_ == NULL) {
#line 301 "../src/applets/status/SoundIndicator.vala"
		_tmp0_ = TRUE;
#line 1234 "SoundIndicator.c"
	} else {
		GvcMixerControl* _tmp2_;
#line 301 "../src/applets/status/SoundIndicator.vala"
		_tmp2_ = self->priv->_mixer;
#line 301 "../src/applets/status/SoundIndicator.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 1241 "SoundIndicator.c"
	}
#line 301 "../src/applets/status/SoundIndicator.vala"
	if (_tmp0_) {
#line 302 "../src/applets/status/SoundIndicator.vala"
		return;
#line 1247 "SoundIndicator.c"
	}
#line 304 "../src/applets/status/SoundIndicator.vala"
	_tmp3_ = self->priv->volume_scale;
#line 304 "../src/applets/status/SoundIndicator.vala"
	scale_value = gtk_range_get_value ((GtkRange*) _tmp3_);
#line 307 "../src/applets/status/SoundIndicator.vala"
	_tmp4_ = self->priv->volume_scale;
#line 307 "../src/applets/status/SoundIndicator.vala"
	g_signal_handler_block (_tmp4_, self->priv->scale_id);
#line 308 "../src/applets/status/SoundIndicator.vala"
	_tmp5_ = self->priv->stream;
#line 308 "../src/applets/status/SoundIndicator.vala"
	if (gvc_mixer_stream_set_volume (_tmp5_, (guint32) scale_value)) {
#line 1261 "SoundIndicator.c"
		GvcMixerStream* _tmp6_;
#line 309 "../src/applets/status/SoundIndicator.vala"
		_tmp6_ = self->priv->stream;
#line 309 "../src/applets/status/SoundIndicator.vala"
		gvc_mixer_stream_push_volume (_tmp6_);
#line 1267 "SoundIndicator.c"
	}
#line 311 "../src/applets/status/SoundIndicator.vala"
	_tmp7_ = self->priv->volume_scale;
#line 311 "../src/applets/status/SoundIndicator.vala"
	g_signal_handler_unblock (_tmp7_, self->priv->scale_id);
#line 1273 "SoundIndicator.c"
}

/**
 * Adjust the volume by a given +/- increment and bounds limit it
 */
static void
sound_indicator_adjust_volume_increment (SoundIndicator* self,
                                         gdouble increment)
{
	gboolean _tmp0_ = FALSE;
	GvcMixerStream* _tmp1_;
	gint32 vol = 0;
	GvcMixerStream* _tmp3_;
	gdouble max_norm = 0.0;
	GvcMixerControl* _tmp4_;
	GtkScale* _tmp5_;
	GvcMixerStream* _tmp6_;
	GtkScale* _tmp8_;
#line 317 "../src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 318 "../src/applets/status/SoundIndicator.vala"
	_tmp1_ = self->priv->stream;
#line 318 "../src/applets/status/SoundIndicator.vala"
	if (_tmp1_ == NULL) {
#line 318 "../src/applets/status/SoundIndicator.vala"
		_tmp0_ = TRUE;
#line 1300 "SoundIndicator.c"
	} else {
		GvcMixerControl* _tmp2_;
#line 318 "../src/applets/status/SoundIndicator.vala"
		_tmp2_ = self->priv->_mixer;
#line 318 "../src/applets/status/SoundIndicator.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 1307 "SoundIndicator.c"
	}
#line 318 "../src/applets/status/SoundIndicator.vala"
	if (_tmp0_) {
#line 319 "../src/applets/status/SoundIndicator.vala"
		return;
#line 1313 "SoundIndicator.c"
	}
#line 321 "../src/applets/status/SoundIndicator.vala"
	_tmp3_ = self->priv->stream;
#line 321 "../src/applets/status/SoundIndicator.vala"
	vol = (gint32) gvc_mixer_stream_get_volume (_tmp3_);
#line 322 "../src/applets/status/SoundIndicator.vala"
	_tmp4_ = self->priv->_mixer;
#line 322 "../src/applets/status/SoundIndicator.vala"
	max_norm = gvc_mixer_control_get_vol_max_norm (_tmp4_);
#line 323 "../src/applets/status/SoundIndicator.vala"
	vol += (gint32) increment;
#line 325 "../src/applets/status/SoundIndicator.vala"
	if (vol < ((gint32) 0)) {
#line 326 "../src/applets/status/SoundIndicator.vala"
		vol = (gint32) 0;
#line 1329 "SoundIndicator.c"
	} else {
#line 327 "../src/applets/status/SoundIndicator.vala"
		if (((gdouble) vol) > max_norm) {
#line 328 "../src/applets/status/SoundIndicator.vala"
			vol = (gint32) max_norm;
#line 1335 "SoundIndicator.c"
		}
	}
#line 331 "../src/applets/status/SoundIndicator.vala"
	_tmp5_ = self->priv->volume_scale;
#line 331 "../src/applets/status/SoundIndicator.vala"
	g_signal_handler_block (_tmp5_, self->priv->scale_id);
#line 332 "../src/applets/status/SoundIndicator.vala"
	_tmp6_ = self->priv->stream;
#line 332 "../src/applets/status/SoundIndicator.vala"
	if (gvc_mixer_stream_set_volume (_tmp6_, (guint32) vol)) {
#line 1346 "SoundIndicator.c"
		GvcMixerStream* _tmp7_;
#line 333 "../src/applets/status/SoundIndicator.vala"
		_tmp7_ = self->priv->stream;
#line 333 "../src/applets/status/SoundIndicator.vala"
		gvc_mixer_stream_push_volume (_tmp7_);
#line 1352 "SoundIndicator.c"
	}
#line 335 "../src/applets/status/SoundIndicator.vala"
	_tmp8_ = self->priv->volume_scale;
#line 335 "../src/applets/status/SoundIndicator.vala"
	g_signal_handler_unblock (_tmp8_, self->priv->scale_id);
#line 1358 "SoundIndicator.c"
}

static void
sound_indicator_open_sound_settings (SoundIndicator* self)
{
	BudgiePopover* _tmp0_;
	GDesktopAppInfo* app_info = NULL;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 339 "../src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 340 "../src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->popover;
#line 340 "../src/applets/status/SoundIndicator.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 342 "../src/applets/status/SoundIndicator.vala"
	_tmp1_ = g_desktop_app_info_new ("budgie-sound-panel.desktop");
#line 342 "../src/applets/status/SoundIndicator.vala"
	app_info = _tmp1_;
#line 344 "../src/applets/status/SoundIndicator.vala"
	_tmp2_ = app_info;
#line 344 "../src/applets/status/SoundIndicator.vala"
	if (_tmp2_ == NULL) {
#line 345 "../src/applets/status/SoundIndicator.vala"
		_g_object_unref0 (app_info);
#line 345 "../src/applets/status/SoundIndicator.vala"
		return;
#line 1387 "SoundIndicator.c"
	}
	{
		GDesktopAppInfo* _tmp3_;
#line 349 "../src/applets/status/SoundIndicator.vala"
		_tmp3_ = app_info;
#line 349 "../src/applets/status/SoundIndicator.vala"
		g_app_info_launch ((GAppInfo*) _tmp3_, NULL, NULL, &_inner_error0_);
#line 349 "../src/applets/status/SoundIndicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1397 "SoundIndicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 348 "../src/applets/status/SoundIndicator.vala"
		e = _inner_error0_;
#line 348 "../src/applets/status/SoundIndicator.vala"
		_inner_error0_ = NULL;
#line 351 "../src/applets/status/SoundIndicator.vala"
		_tmp4_ = e;
#line 351 "../src/applets/status/SoundIndicator.vala"
		_tmp5_ = _tmp4_->message;
#line 351 "../src/applets/status/SoundIndicator.vala"
		g_message ("SoundIndicator.vala:351: Unable to launch budgie-sound-panel.desktop: " \
"%s", _tmp5_);
#line 348 "../src/applets/status/SoundIndicator.vala"
		_g_error_free0 (e);
#line 1419 "SoundIndicator.c"
	}
	__finally0:
#line 348 "../src/applets/status/SoundIndicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 348 "../src/applets/status/SoundIndicator.vala"
		_g_object_unref0 (app_info);
#line 348 "../src/applets/status/SoundIndicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 348 "../src/applets/status/SoundIndicator.vala"
		g_clear_error (&_inner_error0_);
#line 348 "../src/applets/status/SoundIndicator.vala"
		return;
#line 1432 "SoundIndicator.c"
	}
#line 339 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (app_info);
#line 1436 "SoundIndicator.c"
}

GtkImage*
sound_indicator_get_widget (SoundIndicator* self)
{
	GtkImage* result;
	GtkImage* _tmp0_;
#line 16 "../src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 16 "../src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->priv->_widget;
#line 16 "../src/applets/status/SoundIndicator.vala"
	result = _tmp0_;
#line 16 "../src/applets/status/SoundIndicator.vala"
	return result;
#line 1452 "SoundIndicator.c"
}

void
sound_indicator_set_widget (SoundIndicator* self,
                            GtkImage* value)
{
	GtkImage* old_value;
#line 16 "../src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 16 "../src/applets/status/SoundIndicator.vala"
	old_value = sound_indicator_get_widget (self);
#line 16 "../src/applets/status/SoundIndicator.vala"
	if (old_value != value) {
#line 1466 "SoundIndicator.c"
		GtkImage* _tmp0_;
#line 16 "../src/applets/status/SoundIndicator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 16 "../src/applets/status/SoundIndicator.vala"
		_g_object_unref0 (self->priv->_widget);
#line 16 "../src/applets/status/SoundIndicator.vala"
		self->priv->_widget = _tmp0_;
#line 16 "../src/applets/status/SoundIndicator.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_WIDGET_PROPERTY]);
#line 1476 "SoundIndicator.c"
	}
}

GvcMixerControl*
sound_indicator_get_mixer (SoundIndicator* self)
{
	GvcMixerControl* result;
	GvcMixerControl* _tmp0_;
#line 19 "../src/applets/status/SoundIndicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../src/applets/status/SoundIndicator.vala"
	_tmp0_ = self->priv->_mixer;
#line 19 "../src/applets/status/SoundIndicator.vala"
	result = _tmp0_;
#line 19 "../src/applets/status/SoundIndicator.vala"
	return result;
#line 1493 "SoundIndicator.c"
}

void
sound_indicator_set_mixer (SoundIndicator* self,
                           GvcMixerControl* value)
{
	GvcMixerControl* old_value;
#line 19 "../src/applets/status/SoundIndicator.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/applets/status/SoundIndicator.vala"
	old_value = sound_indicator_get_mixer (self);
#line 19 "../src/applets/status/SoundIndicator.vala"
	if (old_value != value) {
#line 1507 "SoundIndicator.c"
		GvcMixerControl* _tmp0_;
#line 19 "../src/applets/status/SoundIndicator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../src/applets/status/SoundIndicator.vala"
		_g_object_unref0 (self->priv->_mixer);
#line 19 "../src/applets/status/SoundIndicator.vala"
		self->priv->_mixer = _tmp0_;
#line 19 "../src/applets/status/SoundIndicator.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_MIXER_PROPERTY]);
#line 1517 "SoundIndicator.c"
	}
}

static void
sound_indicator_class_init (SoundIndicatorClass * klass,
                            gpointer klass_data)
{
#line 14 "../src/applets/status/SoundIndicator.vala"
	sound_indicator_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/applets/status/SoundIndicator.vala"
	g_type_class_adjust_private_offset (klass, &SoundIndicator_private_offset);
#line 14 "../src/applets/status/SoundIndicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_indicator_get_property;
#line 14 "../src/applets/status/SoundIndicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_indicator_set_property;
#line 14 "../src/applets/status/SoundIndicator.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_indicator_finalize;
#line 1535 "SoundIndicator.c"
	/** Current image to display */
#line 14 "../src/applets/status/SoundIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_WIDGET_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_WIDGET_PROPERTY] = g_param_spec_object ("widget", "widget", "widget", gtk_image_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1539 "SoundIndicator.c"
	/** Our mixer */
#line 14 "../src/applets/status/SoundIndicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_MIXER_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_MIXER_PROPERTY] = g_param_spec_object ("mixer", "mixer", "mixer", gvc_mixer_control_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1543 "SoundIndicator.c"
}

static void
sound_indicator_instance_init (SoundIndicator * self,
                               gpointer klass)
{
#line 14 "../src/applets/status/SoundIndicator.vala"
	self->priv = sound_indicator_get_instance_private (self);
#line 1552 "SoundIndicator.c"
}

static void
sound_indicator_finalize (GObject * obj)
{
	SoundIndicator * self;
#line 14 "../src/applets/status/SoundIndicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOUND_INDICATOR, SoundIndicator);
#line 16 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->_widget);
#line 19 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->_mixer);
#line 22 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->stream);
#line 25 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->ebox);
#line 28 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->popover);
#line 30 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->buttons);
#line 31 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->settings_button);
#line 32 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->mute_button);
#line 33 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->volume_down);
#line 34 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->volume_up);
#line 36 "../src/applets/status/SoundIndicator.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 14 "../src/applets/status/SoundIndicator.vala"
	G_OBJECT_CLASS (sound_indicator_parent_class)->finalize (obj);
#line 1585 "SoundIndicator.c"
}

GType
sound_indicator_get_type (void)
{
	return sound_indicator_type_id;
}

GType
sound_indicator_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundIndicator), 0, (GInstanceInitFunc) sound_indicator_instance_init, NULL };
	sound_indicator_type_id = g_type_module_register_type (module, gtk_bin_get_type (), "SoundIndicator", &g_define_type_info, 0);
	SoundIndicator_private_offset = sizeof (SoundIndicatorPrivate);
	return sound_indicator_type_id;
}

static void
_vala_sound_indicator_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SOUND_INDICATOR, SoundIndicator);
#line 14 "../src/applets/status/SoundIndicator.vala"
	switch (property_id) {
#line 14 "../src/applets/status/SoundIndicator.vala"
		case SOUND_INDICATOR_WIDGET_PROPERTY:
#line 14 "../src/applets/status/SoundIndicator.vala"
		g_value_set_object (value, sound_indicator_get_widget (self));
#line 14 "../src/applets/status/SoundIndicator.vala"
		break;
#line 14 "../src/applets/status/SoundIndicator.vala"
		case SOUND_INDICATOR_MIXER_PROPERTY:
#line 14 "../src/applets/status/SoundIndicator.vala"
		g_value_set_object (value, sound_indicator_get_mixer (self));
#line 14 "../src/applets/status/SoundIndicator.vala"
		break;
#line 1625 "SoundIndicator.c"
		default:
#line 14 "../src/applets/status/SoundIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/applets/status/SoundIndicator.vala"
		break;
#line 1631 "SoundIndicator.c"
	}
}

static void
_vala_sound_indicator_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SOUND_INDICATOR, SoundIndicator);
#line 14 "../src/applets/status/SoundIndicator.vala"
	switch (property_id) {
#line 14 "../src/applets/status/SoundIndicator.vala"
		case SOUND_INDICATOR_WIDGET_PROPERTY:
#line 14 "../src/applets/status/SoundIndicator.vala"
		sound_indicator_set_widget (self, g_value_get_object (value));
#line 14 "../src/applets/status/SoundIndicator.vala"
		break;
#line 14 "../src/applets/status/SoundIndicator.vala"
		case SOUND_INDICATOR_MIXER_PROPERTY:
#line 14 "../src/applets/status/SoundIndicator.vala"
		sound_indicator_set_mixer (self, g_value_get_object (value));
#line 14 "../src/applets/status/SoundIndicator.vala"
		break;
#line 1657 "SoundIndicator.c"
		default:
#line 14 "../src/applets/status/SoundIndicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/applets/status/SoundIndicator.vala"
		break;
#line 1663 "SoundIndicator.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

