/* TrayApplet.c generated by valac 0.56.3, the Vala compiler
 * generated from TrayApplet.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2022 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "trayapplet.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "plugin.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>
#include "tray.h"
#include <gdk/gdkx.h>
#include <glib/gi18n-lib.h>
#include <libpeas/peas.h>

enum  {
	TRAY_PLUGIN_0_PROPERTY,
	TRAY_PLUGIN_NUM_PROPERTIES
};
static GParamSpec* tray_plugin_properties[TRAY_PLUGIN_NUM_PROPERTIES];
enum  {
	TRAY_SETTINGS_0_PROPERTY,
	TRAY_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* tray_settings_properties[TRAY_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_TRAY_ERROR_ICON (tray_error_icon_get_type ())
#define TRAY_ERROR_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRAY_ERROR_ICON, TrayErrorIcon))
#define TRAY_ERROR_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRAY_ERROR_ICON, TrayErrorIconClass))
#define IS_TRAY_ERROR_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRAY_ERROR_ICON))
#define IS_TRAY_ERROR_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRAY_ERROR_ICON))
#define TRAY_ERROR_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRAY_ERROR_ICON, TrayErrorIconClass))

typedef struct _TrayErrorIcon TrayErrorIcon;
typedef struct _TrayErrorIconClass TrayErrorIconClass;
typedef struct _TrayErrorIconPrivate TrayErrorIconPrivate;
typedef struct _ParamSpecTrayErrorIcon ParamSpecTrayErrorIcon;
enum  {
	TRAY_APPLET_0_PROPERTY,
	TRAY_APPLET_UUID_PROPERTY,
	TRAY_APPLET_NUM_PROPERTIES
};
static GParamSpec* tray_applet_properties[TRAY_APPLET_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _tray_error_icon_unref0(var) ((var == NULL) ? NULL : (var = (tray_error_icon_unref (var), NULL)))

struct _TraySettingsPrivate {
	GSettings* settings;
	GtkSpinButton* spinbutton_spacing;
};

struct _TrayErrorIcon {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TrayErrorIconPrivate * priv;
	BudgiePopoverManager* manager;
	BudgiePopover* popover;
};

struct _TrayErrorIconClass {
	GTypeClass parent_class;
	void (*finalize) (TrayErrorIcon *self);
};

struct _TrayErrorIconPrivate {
	GtkEventBox* parent;
};

struct _ParamSpecTrayErrorIcon {
	GParamSpec parent_instance;
};

struct _TrayAppletPrivate {
	gchar* _uuid;
	CarbonTray* tray;
	GtkEventBox* box;
	GSettings* settings;
	GtkOrientation orient;
	GdkX11Screen* screen;
	TrayErrorIcon* errorIcon;
};

static gpointer tray_plugin_parent_class = NULL;
static BudgiePluginIface * tray_plugin_budgie_plugin_parent_iface = NULL;
static GType tray_plugin_type_id = 0;
static gint TraySettings_private_offset;
static gpointer tray_settings_parent_class = NULL;
static GType tray_settings_type_id = 0;
static gint TrayErrorIcon_private_offset;
static gpointer tray_error_icon_parent_class = NULL;
static GType tray_error_icon_type_id = 0;
static gint TrayApplet_private_offset;
static gpointer tray_applet_parent_class = NULL;
static gchar* tray_applet_activeUuid;
static gchar* tray_applet_activeUuid = NULL;
static GType tray_applet_type_id = 0;

static BudgieApplet* tray_plugin_real_get_panel_widget (BudgiePlugin* base,
                                                 const gchar* uuid);
static void tray_settings_finalize (GObject * obj);
VALA_EXTERN gpointer tray_error_icon_ref (gpointer instance);
VALA_EXTERN void tray_error_icon_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_tray_error_icon (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_tray_error_icon (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_tray_error_icon (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_tray_error_icon (const GValue* value);
GType tray_error_icon_register_type (GTypeModule * module);
VALA_EXTERN GType tray_error_icon_get_type (void) G_GNUC_CONST ;
static gboolean tray_error_icon_on_button_press (TrayErrorIcon* self,
                                          GdkEventButton* event);
static gboolean _tray_error_icon_on_button_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                         GdkEventButton* event,
                                                                         gpointer self);
VALA_EXTERN TrayErrorIcon* tray_error_icon_new (GtkEventBox* parent,
                                    const gchar* text);
VALA_EXTERN TrayErrorIcon* tray_error_icon_construct (GType object_type,
                                          GtkEventBox* parent,
                                          const gchar* text);
VALA_EXTERN void tray_error_icon_register (TrayErrorIcon* self,
                               BudgiePopoverManager* newManager);
static void tray_error_icon_finalize (TrayErrorIcon * obj);
static void __lambda4_ (TrayApplet* self,
                 const gchar* key);
static void ___lambda4__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static void tray_applet_reintegrate_tray (TrayApplet* self);
static void _tray_applet_reintegrate_tray_gdk_screen_monitors_changed (GdkScreen* _sender,
                                                                gpointer self);
static void ___lambda5_ (TrayApplet* self,
                  GtkWidget* old_parent);
static void ____lambda5__gtk_widget_parent_set (GtkWidget* _sender,
                                         GtkWidget* previous_parent,
                                         gpointer self);
static void tray_applet_maybe_integrate_tray (TrayApplet* self);
static void tray_applet_real_panel_position_changed (BudgieApplet* base,
                                              BudgiePanelPosition position);
static void tray_applet_real_update_popovers (BudgieApplet* base,
                                       BudgiePopoverManager* manager);
static gboolean tray_applet_real_supports_settings (BudgieApplet* base);
static GtkWidget* tray_applet_real_get_settings_ui (BudgieApplet* base);
static void tray_applet_finalize (GObject * obj);
static void _vala_tray_applet_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_tray_applet_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static BudgieApplet*
tray_plugin_real_get_panel_widget (BudgiePlugin* base,
                                   const gchar* uuid)
{
	TrayPlugin * self;
	TrayApplet* _tmp0_;
	BudgieApplet* result;
#line 13 "../src/applets/tray/TrayApplet.vala"
	self = (TrayPlugin*) base;
#line 13 "../src/applets/tray/TrayApplet.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 14 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = tray_applet_new (uuid);
#line 14 "../src/applets/tray/TrayApplet.vala"
	g_object_ref_sink (_tmp0_);
#line 14 "../src/applets/tray/TrayApplet.vala"
	result = (BudgieApplet*) _tmp0_;
#line 14 "../src/applets/tray/TrayApplet.vala"
	return result;
#line 193 "TrayApplet.c"
}

TrayPlugin*
tray_plugin_construct (GType object_type)
{
	TrayPlugin * self = NULL;
#line 12 "../src/applets/tray/TrayApplet.vala"
	self = (TrayPlugin*) g_object_new (object_type, NULL);
#line 12 "../src/applets/tray/TrayApplet.vala"
	return self;
#line 204 "TrayApplet.c"
}

TrayPlugin*
tray_plugin_new (void)
{
#line 12 "../src/applets/tray/TrayApplet.vala"
	return tray_plugin_construct (TYPE_TRAY_PLUGIN);
#line 212 "TrayApplet.c"
}

static void
tray_plugin_class_init (TrayPluginClass * klass,
                        gpointer klass_data)
{
#line 12 "../src/applets/tray/TrayApplet.vala"
	tray_plugin_parent_class = g_type_class_peek_parent (klass);
#line 221 "TrayApplet.c"
}

static void
tray_plugin_budgie_plugin_interface_init (BudgiePluginIface * iface,
                                          gpointer iface_data)
{
#line 12 "../src/applets/tray/TrayApplet.vala"
	tray_plugin_budgie_plugin_parent_iface = g_type_interface_peek_parent (iface);
#line 12 "../src/applets/tray/TrayApplet.vala"
	iface->get_panel_widget = (BudgieApplet* (*) (BudgiePlugin*, const gchar*)) tray_plugin_real_get_panel_widget;
#line 232 "TrayApplet.c"
}

static void
tray_plugin_instance_init (TrayPlugin * self,
                           gpointer klass)
{
}

GType
tray_plugin_get_type (void)
{
	return tray_plugin_type_id;
}

GType
tray_plugin_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (TrayPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tray_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrayPlugin), 0, (GInstanceInitFunc) tray_plugin_instance_init, NULL };
	static const GInterfaceInfo budgie_plugin_info = { (GInterfaceInitFunc) tray_plugin_budgie_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	tray_plugin_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "TrayPlugin", &g_define_type_info, 0);
	g_type_module_add_interface (module, tray_plugin_type_id, budgie_plugin_get_type (), &budgie_plugin_info);
	return tray_plugin_type_id;
}

static inline gpointer
tray_settings_get_instance_private (TraySettings* self)
{
	return G_STRUCT_MEMBER_P (self, TraySettings_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../src/applets/tray/TrayApplet.vala"
	return self ? g_object_ref (self) : NULL;
#line 268 "TrayApplet.c"
}

TraySettings*
tray_settings_construct (GType object_type,
                         GSettings* settings)
{
	TraySettings * self = NULL;
	GSettings* _tmp0_;
	GtkSpinButton* _tmp1_;
#line 25 "../src/applets/tray/TrayApplet.vala"
	self = (TraySettings*) g_object_new (object_type, NULL);
#line 26 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 26 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->priv->settings);
#line 26 "../src/applets/tray/TrayApplet.vala"
	self->priv->settings = _tmp0_;
#line 27 "../src/applets/tray/TrayApplet.vala"
	_tmp1_ = self->priv->spinbutton_spacing;
#line 27 "../src/applets/tray/TrayApplet.vala"
	g_settings_bind (settings, "spacing", (GObject*) _tmp1_, "value", G_SETTINGS_BIND_DEFAULT);
#line 25 "../src/applets/tray/TrayApplet.vala"
	return self;
#line 292 "TrayApplet.c"
}

TraySettings*
tray_settings_new (GSettings* settings)
{
#line 25 "../src/applets/tray/TrayApplet.vala"
	return tray_settings_construct (TYPE_TRAY_SETTINGS, settings);
#line 300 "TrayApplet.c"
}

static void
tray_settings_class_init (TraySettingsClass * klass,
                          gpointer klass_data)
{
#line 19 "../src/applets/tray/TrayApplet.vala"
	tray_settings_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/applets/tray/TrayApplet.vala"
	g_type_class_adjust_private_offset (klass, &TraySettings_private_offset);
#line 19 "../src/applets/tray/TrayApplet.vala"
	G_OBJECT_CLASS (klass)->finalize = tray_settings_finalize;
#line 19 "../src/applets/tray/TrayApplet.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/solus-project/tray/settings.ui");
#line 19 "../src/applets/tray/TrayApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "spinbutton_spacing", FALSE, TraySettings_private_offset + G_STRUCT_OFFSET (TraySettingsPrivate, spinbutton_spacing));
#line 317 "TrayApplet.c"
}

static void
tray_settings_instance_init (TraySettings * self,
                             gpointer klass)
{
#line 19 "../src/applets/tray/TrayApplet.vala"
	self->priv = tray_settings_get_instance_private (self);
#line 20 "../src/applets/tray/TrayApplet.vala"
	self->priv->settings = NULL;
#line 19 "../src/applets/tray/TrayApplet.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 330 "TrayApplet.c"
}

static void
tray_settings_finalize (GObject * obj)
{
	TraySettings * self;
#line 19 "../src/applets/tray/TrayApplet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TRAY_SETTINGS, TraySettings);
#line 20 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->priv->settings);
#line 19 "../src/applets/tray/TrayApplet.vala"
	G_OBJECT_CLASS (tray_settings_parent_class)->finalize (obj);
#line 343 "TrayApplet.c"
}

GType
tray_settings_get_type (void)
{
	return tray_settings_type_id;
}

GType
tray_settings_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (TraySettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tray_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TraySettings), 0, (GInstanceInitFunc) tray_settings_instance_init, NULL };
	tray_settings_type_id = g_type_module_register_type (module, gtk_grid_get_type (), "TraySettings", &g_define_type_info, 0);
	TraySettings_private_offset = sizeof (TraySettingsPrivate);
	return tray_settings_type_id;
}

static inline gpointer
tray_error_icon_get_instance_private (TrayErrorIcon* self)
{
	return G_STRUCT_MEMBER_P (self, TrayErrorIcon_private_offset);
}

static gboolean
_tray_error_icon_on_button_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                GdkEventButton* event,
                                                                gpointer self)
{
	gboolean result;
	result = tray_error_icon_on_button_press ((TrayErrorIcon*) self, event);
#line 53 "../src/applets/tray/TrayApplet.vala"
	return result;
#line 376 "TrayApplet.c"
}

TrayErrorIcon*
tray_error_icon_construct (GType object_type,
                           GtkEventBox* parent,
                           const gchar* text)
{
	TrayErrorIcon* self = NULL;
	GtkEventBox* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	BudgiePopover* _tmp3_;
	BudgiePopover* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkLabel* label = NULL;
	GtkLabel* _tmp6_;
	BudgiePopover* _tmp7_;
	BudgiePopover* _tmp8_;
#line 36 "../src/applets/tray/TrayApplet.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 36 "../src/applets/tray/TrayApplet.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 36 "../src/applets/tray/TrayApplet.vala"
	self = (TrayErrorIcon*) g_type_create_instance (object_type);
#line 37 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = _g_object_ref0 (parent);
#line 37 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->priv->parent);
#line 37 "../src/applets/tray/TrayApplet.vala"
	self->priv->parent = _tmp0_;
#line 39 "../src/applets/tray/TrayApplet.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("gtk-dialog-error", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 39 "../src/applets/tray/TrayApplet.vala"
	g_object_ref_sink (_tmp1_);
#line 39 "../src/applets/tray/TrayApplet.vala"
	_tmp2_ = _tmp1_;
#line 39 "../src/applets/tray/TrayApplet.vala"
	gtk_container_add ((GtkContainer*) parent, (GtkWidget*) _tmp2_);
#line 39 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (_tmp2_);
#line 41 "../src/applets/tray/TrayApplet.vala"
	_tmp3_ = (BudgiePopover*) budgie_popover_new ((GtkWidget*) parent);
#line 41 "../src/applets/tray/TrayApplet.vala"
	g_object_ref_sink (_tmp3_);
#line 41 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->popover);
#line 41 "../src/applets/tray/TrayApplet.vala"
	self->popover = _tmp3_;
#line 42 "../src/applets/tray/TrayApplet.vala"
	_tmp4_ = self->popover;
#line 42 "../src/applets/tray/TrayApplet.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 42 "../src/applets/tray/TrayApplet.vala"
	gtk_style_context_add_class (_tmp5_, "system-tray-popover");
#line 44 "../src/applets/tray/TrayApplet.vala"
	_tmp6_ = (GtkLabel*) gtk_label_new (text);
#line 44 "../src/applets/tray/TrayApplet.vala"
	g_object_ref_sink (_tmp6_);
#line 44 "../src/applets/tray/TrayApplet.vala"
	label = _tmp6_;
#line 45 "../src/applets/tray/TrayApplet.vala"
	gtk_widget_show ((GtkWidget*) label);
#line 46 "../src/applets/tray/TrayApplet.vala"
	_tmp7_ = self->popover;
#line 46 "../src/applets/tray/TrayApplet.vala"
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) label);
#line 47 "../src/applets/tray/TrayApplet.vala"
	_tmp8_ = self->popover;
#line 47 "../src/applets/tray/TrayApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp8_);
#line 49 "../src/applets/tray/TrayApplet.vala"
	g_signal_connect ((GtkWidget*) parent, "button-press-event", (GCallback) _tray_error_icon_on_button_press_gtk_widget_button_press_event, self);
#line 36 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (label);
#line 36 "../src/applets/tray/TrayApplet.vala"
	return self;
#line 453 "TrayApplet.c"
}

TrayErrorIcon*
tray_error_icon_new (GtkEventBox* parent,
                     const gchar* text)
{
#line 36 "../src/applets/tray/TrayApplet.vala"
	return tray_error_icon_construct (TYPE_TRAY_ERROR_ICON, parent, text);
#line 462 "TrayApplet.c"
}

void
tray_error_icon_register (TrayErrorIcon* self,
                          BudgiePopoverManager* newManager)
{
	BudgiePopoverManager* _tmp0_;
	BudgiePopoverManager* _tmp1_;
	GtkEventBox* _tmp2_;
	BudgiePopover* _tmp3_;
#line 56 "../src/applets/tray/TrayApplet.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/applets/tray/TrayApplet.vala"
	g_return_if_fail (newManager != NULL);
#line 57 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = _g_object_ref0 (newManager);
#line 57 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->manager);
#line 57 "../src/applets/tray/TrayApplet.vala"
	self->manager = _tmp0_;
#line 58 "../src/applets/tray/TrayApplet.vala"
	_tmp1_ = self->manager;
#line 58 "../src/applets/tray/TrayApplet.vala"
	_tmp2_ = self->priv->parent;
#line 58 "../src/applets/tray/TrayApplet.vala"
	_tmp3_ = self->popover;
#line 58 "../src/applets/tray/TrayApplet.vala"
	budgie_popover_manager_register_popover (_tmp1_, (GtkWidget*) _tmp2_, _tmp3_);
#line 491 "TrayApplet.c"
}

static gboolean
tray_error_icon_on_button_press (TrayErrorIcon* self,
                                 GdkEventButton* event)
{
	BudgiePopover* _tmp0_;
	gboolean result;
#line 61 "../src/applets/tray/TrayApplet.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "../src/applets/tray/TrayApplet.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 62 "../src/applets/tray/TrayApplet.vala"
	if (event->button != ((guint) 1)) {
#line 63 "../src/applets/tray/TrayApplet.vala"
		result = GDK_EVENT_PROPAGATE;
#line 63 "../src/applets/tray/TrayApplet.vala"
		return result;
#line 510 "TrayApplet.c"
	}
#line 65 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = self->popover;
#line 65 "../src/applets/tray/TrayApplet.vala"
	if (gtk_widget_get_visible ((GtkWidget*) _tmp0_)) {
#line 516 "TrayApplet.c"
		BudgiePopover* _tmp1_;
#line 66 "../src/applets/tray/TrayApplet.vala"
		_tmp1_ = self->popover;
#line 66 "../src/applets/tray/TrayApplet.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 522 "TrayApplet.c"
	} else {
		BudgiePopoverManager* _tmp2_;
		GtkEventBox* _tmp3_;
#line 68 "../src/applets/tray/TrayApplet.vala"
		_tmp2_ = self->manager;
#line 68 "../src/applets/tray/TrayApplet.vala"
		_tmp3_ = self->priv->parent;
#line 68 "../src/applets/tray/TrayApplet.vala"
		budgie_popover_manager_show_popover (_tmp2_, (GtkWidget*) _tmp3_);
#line 532 "TrayApplet.c"
	}
#line 70 "../src/applets/tray/TrayApplet.vala"
	result = GDK_EVENT_STOP;
#line 70 "../src/applets/tray/TrayApplet.vala"
	return result;
#line 538 "TrayApplet.c"
}

static void
value_tray_error_icon_init (GValue* value)
{
#line 31 "../src/applets/tray/TrayApplet.vala"
	value->data[0].v_pointer = NULL;
#line 546 "TrayApplet.c"
}

static void
value_tray_error_icon_free_value (GValue* value)
{
#line 31 "../src/applets/tray/TrayApplet.vala"
	if (value->data[0].v_pointer) {
#line 31 "../src/applets/tray/TrayApplet.vala"
		tray_error_icon_unref (value->data[0].v_pointer);
#line 556 "TrayApplet.c"
	}
}

static void
value_tray_error_icon_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 31 "../src/applets/tray/TrayApplet.vala"
	if (src_value->data[0].v_pointer) {
#line 31 "../src/applets/tray/TrayApplet.vala"
		dest_value->data[0].v_pointer = tray_error_icon_ref (src_value->data[0].v_pointer);
#line 568 "TrayApplet.c"
	} else {
#line 31 "../src/applets/tray/TrayApplet.vala"
		dest_value->data[0].v_pointer = NULL;
#line 572 "TrayApplet.c"
	}
}

static gpointer
value_tray_error_icon_peek_pointer (const GValue* value)
{
#line 31 "../src/applets/tray/TrayApplet.vala"
	return value->data[0].v_pointer;
#line 581 "TrayApplet.c"
}

static gchar*
value_tray_error_icon_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 31 "../src/applets/tray/TrayApplet.vala"
	if (collect_values[0].v_pointer) {
#line 592 "TrayApplet.c"
		TrayErrorIcon * object;
		object = collect_values[0].v_pointer;
#line 31 "../src/applets/tray/TrayApplet.vala"
		if (object->parent_instance.g_class == NULL) {
#line 31 "../src/applets/tray/TrayApplet.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 599 "TrayApplet.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 31 "../src/applets/tray/TrayApplet.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 603 "TrayApplet.c"
		}
#line 31 "../src/applets/tray/TrayApplet.vala"
		value->data[0].v_pointer = tray_error_icon_ref (object);
#line 607 "TrayApplet.c"
	} else {
#line 31 "../src/applets/tray/TrayApplet.vala"
		value->data[0].v_pointer = NULL;
#line 611 "TrayApplet.c"
	}
#line 31 "../src/applets/tray/TrayApplet.vala"
	return NULL;
#line 615 "TrayApplet.c"
}

static gchar*
value_tray_error_icon_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	TrayErrorIcon ** object_p;
	object_p = collect_values[0].v_pointer;
#line 31 "../src/applets/tray/TrayApplet.vala"
	if (!object_p) {
#line 31 "../src/applets/tray/TrayApplet.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 630 "TrayApplet.c"
	}
#line 31 "../src/applets/tray/TrayApplet.vala"
	if (!value->data[0].v_pointer) {
#line 31 "../src/applets/tray/TrayApplet.vala"
		*object_p = NULL;
#line 636 "TrayApplet.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 31 "../src/applets/tray/TrayApplet.vala"
		*object_p = value->data[0].v_pointer;
#line 640 "TrayApplet.c"
	} else {
#line 31 "../src/applets/tray/TrayApplet.vala"
		*object_p = tray_error_icon_ref (value->data[0].v_pointer);
#line 644 "TrayApplet.c"
	}
#line 31 "../src/applets/tray/TrayApplet.vala"
	return NULL;
#line 648 "TrayApplet.c"
}

GParamSpec*
param_spec_tray_error_icon (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	ParamSpecTrayErrorIcon* spec;
#line 31 "../src/applets/tray/TrayApplet.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TRAY_ERROR_ICON), NULL);
#line 31 "../src/applets/tray/TrayApplet.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 31 "../src/applets/tray/TrayApplet.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 31 "../src/applets/tray/TrayApplet.vala"
	return G_PARAM_SPEC (spec);
#line 667 "TrayApplet.c"
}

gpointer
value_get_tray_error_icon (const GValue* value)
{
#line 31 "../src/applets/tray/TrayApplet.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRAY_ERROR_ICON), NULL);
#line 31 "../src/applets/tray/TrayApplet.vala"
	return value->data[0].v_pointer;
#line 677 "TrayApplet.c"
}

void
value_set_tray_error_icon (GValue* value,
                           gpointer v_object)
{
	TrayErrorIcon * old;
#line 31 "../src/applets/tray/TrayApplet.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRAY_ERROR_ICON));
#line 31 "../src/applets/tray/TrayApplet.vala"
	old = value->data[0].v_pointer;
#line 31 "../src/applets/tray/TrayApplet.vala"
	if (v_object) {
#line 31 "../src/applets/tray/TrayApplet.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TRAY_ERROR_ICON));
#line 31 "../src/applets/tray/TrayApplet.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 31 "../src/applets/tray/TrayApplet.vala"
		value->data[0].v_pointer = v_object;
#line 31 "../src/applets/tray/TrayApplet.vala"
		tray_error_icon_ref (value->data[0].v_pointer);
#line 699 "TrayApplet.c"
	} else {
#line 31 "../src/applets/tray/TrayApplet.vala"
		value->data[0].v_pointer = NULL;
#line 703 "TrayApplet.c"
	}
#line 31 "../src/applets/tray/TrayApplet.vala"
	if (old) {
#line 31 "../src/applets/tray/TrayApplet.vala"
		tray_error_icon_unref (old);
#line 709 "TrayApplet.c"
	}
}

void
value_take_tray_error_icon (GValue* value,
                            gpointer v_object)
{
	TrayErrorIcon * old;
#line 31 "../src/applets/tray/TrayApplet.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRAY_ERROR_ICON));
#line 31 "../src/applets/tray/TrayApplet.vala"
	old = value->data[0].v_pointer;
#line 31 "../src/applets/tray/TrayApplet.vala"
	if (v_object) {
#line 31 "../src/applets/tray/TrayApplet.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TRAY_ERROR_ICON));
#line 31 "../src/applets/tray/TrayApplet.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 31 "../src/applets/tray/TrayApplet.vala"
		value->data[0].v_pointer = v_object;
#line 730 "TrayApplet.c"
	} else {
#line 31 "../src/applets/tray/TrayApplet.vala"
		value->data[0].v_pointer = NULL;
#line 734 "TrayApplet.c"
	}
#line 31 "../src/applets/tray/TrayApplet.vala"
	if (old) {
#line 31 "../src/applets/tray/TrayApplet.vala"
		tray_error_icon_unref (old);
#line 740 "TrayApplet.c"
	}
}

static void
tray_error_icon_class_init (TrayErrorIconClass * klass,
                            gpointer klass_data)
{
#line 31 "../src/applets/tray/TrayApplet.vala"
	tray_error_icon_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/applets/tray/TrayApplet.vala"
	((TrayErrorIconClass *) klass)->finalize = tray_error_icon_finalize;
#line 31 "../src/applets/tray/TrayApplet.vala"
	g_type_class_adjust_private_offset (klass, &TrayErrorIcon_private_offset);
#line 754 "TrayApplet.c"
}

static void
tray_error_icon_instance_init (TrayErrorIcon * self,
                               gpointer klass)
{
#line 31 "../src/applets/tray/TrayApplet.vala"
	self->priv = tray_error_icon_get_instance_private (self);
#line 31 "../src/applets/tray/TrayApplet.vala"
	self->ref_count = 1;
#line 765 "TrayApplet.c"
}

static void
tray_error_icon_finalize (TrayErrorIcon * obj)
{
	TrayErrorIcon * self;
	GtkEventBox* _tmp0_;
	guint _tmp1_;
#line 31 "../src/applets/tray/TrayApplet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TRAY_ERROR_ICON, TrayErrorIcon);
#line 31 "../src/applets/tray/TrayApplet.vala"
	g_signal_handlers_destroy (self);
#line 53 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = self->priv->parent;
#line 53 "../src/applets/tray/TrayApplet.vala"
	g_signal_parse_name ("button-press-event", gtk_widget_get_type (), &_tmp1_, NULL, FALSE);
#line 53 "../src/applets/tray/TrayApplet.vala"
	g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _tray_error_icon_on_button_press_gtk_widget_button_press_event, self);
#line 32 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->manager);
#line 33 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->popover);
#line 34 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->priv->parent);
#line 790 "TrayApplet.c"
}

GType
tray_error_icon_get_type (void)
{
	return tray_error_icon_type_id;
}

GType
tray_error_icon_register_type (GTypeModule * module)
{
	static const GTypeValueTable g_define_type_value_table = { value_tray_error_icon_init, value_tray_error_icon_free_value, value_tray_error_icon_copy_value, value_tray_error_icon_peek_pointer, "p", value_tray_error_icon_collect_value, "p", value_tray_error_icon_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TrayErrorIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tray_error_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrayErrorIcon), 0, (GInstanceInitFunc) tray_error_icon_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	tray_error_icon_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TrayErrorIcon", &g_define_type_info, &g_define_type_fundamental_info, 0);
	TrayErrorIcon_private_offset = sizeof (TrayErrorIconPrivate);
	return tray_error_icon_type_id;
}

gpointer
tray_error_icon_ref (gpointer instance)
{
	TrayErrorIcon * self;
	self = instance;
#line 31 "../src/applets/tray/TrayApplet.vala"
	g_atomic_int_inc (&self->ref_count);
#line 31 "../src/applets/tray/TrayApplet.vala"
	return instance;
#line 819 "TrayApplet.c"
}

void
tray_error_icon_unref (gpointer instance)
{
	TrayErrorIcon * self;
	self = instance;
#line 31 "../src/applets/tray/TrayApplet.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 31 "../src/applets/tray/TrayApplet.vala"
		TRAY_ERROR_ICON_GET_CLASS (self)->finalize (self);
#line 31 "../src/applets/tray/TrayApplet.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 833 "TrayApplet.c"
	}
}

static inline gpointer
tray_applet_get_instance_private (TrayApplet* self)
{
	return G_STRUCT_MEMBER_P (self, TrayApplet_private_offset);
}

static void
__lambda4_ (TrayApplet* self,
            const gchar* key)
{
	CarbonTray* _tmp0_;
#line 98 "../src/applets/tray/TrayApplet.vala"
	g_return_if_fail (key != NULL);
#line 99 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = self->priv->tray;
#line 99 "../src/applets/tray/TrayApplet.vala"
	if (_tmp0_ != NULL) {
#line 854 "TrayApplet.c"
		CarbonTray* _tmp1_;
		GSettings* _tmp2_;
#line 99 "../src/applets/tray/TrayApplet.vala"
		_tmp1_ = self->priv->tray;
#line 99 "../src/applets/tray/TrayApplet.vala"
		_tmp2_ = self->priv->settings;
#line 99 "../src/applets/tray/TrayApplet.vala"
		carbon_tray_set_spacing (_tmp1_, g_settings_get_int (_tmp2_, "spacing"));
#line 863 "TrayApplet.c"
	}
}

static void
___lambda4__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
#line 98 "../src/applets/tray/TrayApplet.vala"
	__lambda4_ ((TrayApplet*) self, key);
#line 874 "TrayApplet.c"
}

static void
_tray_applet_reintegrate_tray_gdk_screen_monitors_changed (GdkScreen* _sender,
                                                           gpointer self)
{
#line 106 "../src/applets/tray/TrayApplet.vala"
	tray_applet_reintegrate_tray ((TrayApplet*) self);
#line 883 "TrayApplet.c"
}

static void
___lambda5_ (TrayApplet* self,
             GtkWidget* old_parent)
{
#line 108 "../src/applets/tray/TrayApplet.vala"
	tray_applet_reintegrate_tray (self);
#line 892 "TrayApplet.c"
}

static void
____lambda5__gtk_widget_parent_set (GtkWidget* _sender,
                                    GtkWidget* previous_parent,
                                    gpointer self)
{
#line 107 "../src/applets/tray/TrayApplet.vala"
	___lambda5_ ((TrayApplet*) self, previous_parent);
#line 902 "TrayApplet.c"
}

TrayApplet*
tray_applet_construct (GType object_type,
                       const gchar* uuid)
{
	TrayApplet * self = NULL;
	GtkStyleContext* _tmp0_;
	GtkEventBox* _tmp1_;
	GtkEventBox* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	const gchar* _tmp5_;
#line 86 "../src/applets/tray/TrayApplet.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 87 "../src/applets/tray/TrayApplet.vala"
	self = (TrayApplet*) g_object_new (object_type, "uuid", uuid, NULL);
#line 89 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 89 "../src/applets/tray/TrayApplet.vala"
	gtk_style_context_add_class (_tmp0_, "system-tray-applet");
#line 91 "../src/applets/tray/TrayApplet.vala"
	_tmp1_ = (GtkEventBox*) gtk_event_box_new ();
#line 91 "../src/applets/tray/TrayApplet.vala"
	g_object_ref_sink (_tmp1_);
#line 91 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->priv->box);
#line 91 "../src/applets/tray/TrayApplet.vala"
	self->priv->box = _tmp1_;
#line 92 "../src/applets/tray/TrayApplet.vala"
	_tmp2_ = self->priv->box;
#line 92 "../src/applets/tray/TrayApplet.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp2_);
#line 94 "../src/applets/tray/TrayApplet.vala"
	budgie_applet_set_settings_schema ((BudgieApplet*) self, "com.solus-project.tray");
#line 95 "../src/applets/tray/TrayApplet.vala"
	budgie_applet_set_settings_prefix ((BudgieApplet*) self, "/com/solus-project/budgie-panel/instance/tray");
#line 97 "../src/applets/tray/TrayApplet.vala"
	_tmp3_ = budgie_applet_get_applet_settings ((BudgieApplet*) self, uuid);
#line 97 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->priv->settings);
#line 97 "../src/applets/tray/TrayApplet.vala"
	self->priv->settings = _tmp3_;
#line 98 "../src/applets/tray/TrayApplet.vala"
	_tmp4_ = self->priv->settings;
#line 98 "../src/applets/tray/TrayApplet.vala"
	g_signal_connect_object (_tmp4_, "changed::spacing", (GCallback) ___lambda4__g_settings_changed, self, 0);
#line 102 "../src/applets/tray/TrayApplet.vala"
	_tmp5_ = tray_applet_activeUuid;
#line 102 "../src/applets/tray/TrayApplet.vala"
	if (_tmp5_ == NULL) {
#line 954 "TrayApplet.c"
		gchar* _tmp6_;
		GdkScreen* _tmp7_;
		GdkX11Screen* _tmp8_;
		GdkX11Screen* _tmp9_;
#line 103 "../src/applets/tray/TrayApplet.vala"
		_tmp6_ = g_strdup (uuid);
#line 103 "../src/applets/tray/TrayApplet.vala"
		_g_free0 (tray_applet_activeUuid);
#line 103 "../src/applets/tray/TrayApplet.vala"
		tray_applet_activeUuid = _tmp6_;
#line 104 "../src/applets/tray/TrayApplet.vala"
		_tmp7_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 104 "../src/applets/tray/TrayApplet.vala"
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gdk_x11_screen_get_type (), GdkX11Screen));
#line 104 "../src/applets/tray/TrayApplet.vala"
		_g_object_unref0 (self->priv->screen);
#line 104 "../src/applets/tray/TrayApplet.vala"
		self->priv->screen = _tmp8_;
#line 106 "../src/applets/tray/TrayApplet.vala"
		_tmp9_ = self->priv->screen;
#line 106 "../src/applets/tray/TrayApplet.vala"
		g_signal_connect_object ((GdkScreen*) _tmp9_, "monitors-changed", (GCallback) _tray_applet_reintegrate_tray_gdk_screen_monitors_changed, self, 0);
#line 107 "../src/applets/tray/TrayApplet.vala"
		g_signal_connect_object ((GtkWidget*) self, "parent-set", (GCallback) ____lambda5__gtk_widget_parent_set, self, 0);
#line 111 "../src/applets/tray/TrayApplet.vala"
		tray_applet_maybe_integrate_tray (self);
#line 981 "TrayApplet.c"
	} else {
		GtkEventBox* _tmp10_;
		TrayErrorIcon* _tmp11_;
#line 114 "../src/applets/tray/TrayApplet.vala"
		_tmp10_ = self->priv->box;
#line 114 "../src/applets/tray/TrayApplet.vala"
		_tmp11_ = tray_error_icon_new (_tmp10_, _ ("Only one instance of the System Tray can be active at a time."));
#line 114 "../src/applets/tray/TrayApplet.vala"
		_tray_error_icon_unref0 (self->priv->errorIcon);
#line 114 "../src/applets/tray/TrayApplet.vala"
		self->priv->errorIcon = _tmp11_;
#line 115 "../src/applets/tray/TrayApplet.vala"
		gtk_widget_show_all ((GtkWidget*) self);
#line 995 "TrayApplet.c"
	}
#line 86 "../src/applets/tray/TrayApplet.vala"
	return self;
#line 999 "TrayApplet.c"
}

TrayApplet*
tray_applet_new (const gchar* uuid)
{
#line 86 "../src/applets/tray/TrayApplet.vala"
	return tray_applet_construct (TYPE_TRAY_APPLET, uuid);
#line 1007 "TrayApplet.c"
}

static void
tray_applet_reintegrate_tray (TrayApplet* self)
{
	CarbonTray* _tmp0_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
#line 123 "../src/applets/tray/TrayApplet.vala"
	g_return_if_fail (self != NULL);
#line 124 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = self->priv->tray;
#line 124 "../src/applets/tray/TrayApplet.vala"
	if (_tmp0_ != NULL) {
#line 1022 "TrayApplet.c"
		CarbonTray* _tmp1_;
		GtkEventBox* _tmp2_;
		CarbonTray* _tmp3_;
#line 125 "../src/applets/tray/TrayApplet.vala"
		_tmp1_ = self->priv->tray;
#line 125 "../src/applets/tray/TrayApplet.vala"
		_tmp2_ = self->priv->box;
#line 125 "../src/applets/tray/TrayApplet.vala"
		carbon_tray_remove_from_container (_tmp1_, (GtkContainer*) _tmp2_);
#line 126 "../src/applets/tray/TrayApplet.vala"
		_tmp3_ = self->priv->tray;
#line 126 "../src/applets/tray/TrayApplet.vala"
		g_object_run_dispose ((GObject*) _tmp3_);
#line 127 "../src/applets/tray/TrayApplet.vala"
		_g_object_unref0 (self->priv->tray);
#line 127 "../src/applets/tray/TrayApplet.vala"
		self->priv->tray = NULL;
#line 1040 "TrayApplet.c"
	}
#line 130 "../src/applets/tray/TrayApplet.vala"
	_tmp5_ = tray_applet_activeUuid;
#line 130 "../src/applets/tray/TrayApplet.vala"
	if (_tmp5_ == NULL) {
#line 130 "../src/applets/tray/TrayApplet.vala"
		_tmp4_ = TRUE;
#line 1048 "TrayApplet.c"
	} else {
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 130 "../src/applets/tray/TrayApplet.vala"
		_tmp6_ = tray_applet_activeUuid;
#line 130 "../src/applets/tray/TrayApplet.vala"
		_tmp7_ = self->priv->_uuid;
#line 130 "../src/applets/tray/TrayApplet.vala"
		_tmp4_ = g_strcmp0 (_tmp6_, _tmp7_) == 0;
#line 1058 "TrayApplet.c"
	}
#line 130 "../src/applets/tray/TrayApplet.vala"
	if (_tmp4_) {
#line 131 "../src/applets/tray/TrayApplet.vala"
		tray_applet_maybe_integrate_tray (self);
#line 1064 "TrayApplet.c"
	}
}

static void
tray_applet_maybe_integrate_tray (TrayApplet* self)
{
	GSettings* _tmp0_;
	CarbonTray* _tmp1_;
	CarbonTray* _tmp2_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	CarbonTray* _tmp11_;
	GtkEventBox* _tmp12_;
	CarbonTray* _tmp13_;
	GdkX11Screen* _tmp14_;
#line 135 "../src/applets/tray/TrayApplet.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = self->priv->settings;
#line 136 "../src/applets/tray/TrayApplet.vala"
	_tmp1_ = (CarbonTray*) carbon_tray_new (self->priv->orient, 24, g_settings_get_int (_tmp0_, "spacing"));
#line 136 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->priv->tray);
#line 136 "../src/applets/tray/TrayApplet.vala"
	self->priv->tray = _tmp1_;
#line 138 "../src/applets/tray/TrayApplet.vala"
	_tmp2_ = self->priv->tray;
#line 138 "../src/applets/tray/TrayApplet.vala"
	if (_tmp2_ == NULL) {
#line 1094 "TrayApplet.c"
		GtkEventBox* _tmp3_;
		TrayErrorIcon* _tmp4_;
#line 139 "../src/applets/tray/TrayApplet.vala"
		_g_free0 (tray_applet_activeUuid);
#line 139 "../src/applets/tray/TrayApplet.vala"
		tray_applet_activeUuid = NULL;
#line 140 "../src/applets/tray/TrayApplet.vala"
		_tmp3_ = self->priv->box;
#line 140 "../src/applets/tray/TrayApplet.vala"
		_tmp4_ = tray_error_icon_new (_tmp3_, _ ("The System Tray failed to initialize."));
#line 140 "../src/applets/tray/TrayApplet.vala"
		_tray_error_icon_unref0 (self->priv->errorIcon);
#line 140 "../src/applets/tray/TrayApplet.vala"
		self->priv->errorIcon = _tmp4_;
#line 141 "../src/applets/tray/TrayApplet.vala"
		gtk_widget_show_all ((GtkWidget*) self);
#line 142 "../src/applets/tray/TrayApplet.vala"
		return;
#line 1113 "TrayApplet.c"
	}
#line 145 "../src/applets/tray/TrayApplet.vala"
	_tmp5_ = self->priv->_uuid;
#line 145 "../src/applets/tray/TrayApplet.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 145 "../src/applets/tray/TrayApplet.vala"
	_g_free0 (tray_applet_activeUuid);
#line 145 "../src/applets/tray/TrayApplet.vala"
	tray_applet_activeUuid = _tmp6_;
#line 147 "../src/applets/tray/TrayApplet.vala"
	switch (self->priv->orient) {
#line 147 "../src/applets/tray/TrayApplet.vala"
		case GTK_ORIENTATION_HORIZONTAL:
#line 1127 "TrayApplet.c"
		{
			GtkEventBox* _tmp7_;
			GtkEventBox* _tmp8_;
#line 149 "../src/applets/tray/TrayApplet.vala"
			gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_START);
#line 150 "../src/applets/tray/TrayApplet.vala"
			gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 151 "../src/applets/tray/TrayApplet.vala"
			_tmp7_ = self->priv->box;
#line 151 "../src/applets/tray/TrayApplet.vala"
			gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
#line 152 "../src/applets/tray/TrayApplet.vala"
			_tmp8_ = self->priv->box;
#line 152 "../src/applets/tray/TrayApplet.vala"
			gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_FILL);
#line 153 "../src/applets/tray/TrayApplet.vala"
			break;
#line 1145 "TrayApplet.c"
		}
#line 147 "../src/applets/tray/TrayApplet.vala"
		case GTK_ORIENTATION_VERTICAL:
#line 1149 "TrayApplet.c"
		{
			GtkEventBox* _tmp9_;
			GtkEventBox* _tmp10_;
#line 155 "../src/applets/tray/TrayApplet.vala"
			gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 156 "../src/applets/tray/TrayApplet.vala"
			gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_START);
#line 157 "../src/applets/tray/TrayApplet.vala"
			_tmp9_ = self->priv->box;
#line 157 "../src/applets/tray/TrayApplet.vala"
			gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_FILL);
#line 158 "../src/applets/tray/TrayApplet.vala"
			_tmp10_ = self->priv->box;
#line 158 "../src/applets/tray/TrayApplet.vala"
			gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_START);
#line 159 "../src/applets/tray/TrayApplet.vala"
			break;
#line 1167 "TrayApplet.c"
		}
		default:
#line 147 "../src/applets/tray/TrayApplet.vala"
		break;
#line 1172 "TrayApplet.c"
	}
#line 162 "../src/applets/tray/TrayApplet.vala"
	_tmp11_ = self->priv->tray;
#line 162 "../src/applets/tray/TrayApplet.vala"
	_tmp12_ = self->priv->box;
#line 162 "../src/applets/tray/TrayApplet.vala"
	carbon_tray_add_to_container (_tmp11_, (GtkContainer*) _tmp12_);
#line 163 "../src/applets/tray/TrayApplet.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 164 "../src/applets/tray/TrayApplet.vala"
	_tmp13_ = self->priv->tray;
#line 164 "../src/applets/tray/TrayApplet.vala"
	_tmp14_ = self->priv->screen;
#line 164 "../src/applets/tray/TrayApplet.vala"
	carbon_tray_register (_tmp13_, _tmp14_);
#line 1188 "TrayApplet.c"
}

static void
tray_applet_real_panel_position_changed (BudgieApplet* base,
                                         BudgiePanelPosition position)
{
	TrayApplet * self;
	gboolean _tmp0_ = FALSE;
#line 167 "../src/applets/tray/TrayApplet.vala"
	self = (TrayApplet*) base;
#line 168 "../src/applets/tray/TrayApplet.vala"
	if (position == BUDGIE_PANEL_POSITION_LEFT) {
#line 168 "../src/applets/tray/TrayApplet.vala"
		_tmp0_ = TRUE;
#line 1203 "TrayApplet.c"
	} else {
#line 168 "../src/applets/tray/TrayApplet.vala"
		_tmp0_ = position == BUDGIE_PANEL_POSITION_RIGHT;
#line 1207 "TrayApplet.c"
	}
#line 168 "../src/applets/tray/TrayApplet.vala"
	if (_tmp0_) {
#line 169 "../src/applets/tray/TrayApplet.vala"
		self->priv->orient = GTK_ORIENTATION_VERTICAL;
#line 1213 "TrayApplet.c"
	} else {
#line 171 "../src/applets/tray/TrayApplet.vala"
		self->priv->orient = GTK_ORIENTATION_HORIZONTAL;
#line 1217 "TrayApplet.c"
	}
#line 174 "../src/applets/tray/TrayApplet.vala"
	tray_applet_reintegrate_tray (self);
#line 1221 "TrayApplet.c"
}

static void
tray_applet_real_update_popovers (BudgieApplet* base,
                                  BudgiePopoverManager* manager)
{
	TrayApplet * self;
	TrayErrorIcon* _tmp0_;
#line 177 "../src/applets/tray/TrayApplet.vala"
	self = (TrayApplet*) base;
#line 178 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = self->priv->errorIcon;
#line 178 "../src/applets/tray/TrayApplet.vala"
	if (_tmp0_ != NULL) {
#line 1236 "TrayApplet.c"
		TrayErrorIcon* _tmp1_;
#line 178 "../src/applets/tray/TrayApplet.vala"
		_tmp1_ = self->priv->errorIcon;
#line 178 "../src/applets/tray/TrayApplet.vala"
		tray_error_icon_register (_tmp1_, manager);
#line 1242 "TrayApplet.c"
	}
}

static gboolean
tray_applet_real_supports_settings (BudgieApplet* base)
{
	TrayApplet * self;
	gboolean result;
#line 181 "../src/applets/tray/TrayApplet.vala"
	self = (TrayApplet*) base;
#line 182 "../src/applets/tray/TrayApplet.vala"
	result = TRUE;
#line 182 "../src/applets/tray/TrayApplet.vala"
	return result;
#line 1257 "TrayApplet.c"
}

static GtkWidget*
tray_applet_real_get_settings_ui (BudgieApplet* base)
{
	TrayApplet * self;
	const gchar* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	TraySettings* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* result;
#line 185 "../src/applets/tray/TrayApplet.vala"
	self = (TrayApplet*) base;
#line 186 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = self->priv->_uuid;
#line 186 "../src/applets/tray/TrayApplet.vala"
	_tmp1_ = budgie_applet_get_applet_settings ((BudgieApplet*) self, _tmp0_);
#line 186 "../src/applets/tray/TrayApplet.vala"
	_tmp2_ = _tmp1_;
#line 186 "../src/applets/tray/TrayApplet.vala"
	_tmp3_ = tray_settings_new (_tmp2_);
#line 186 "../src/applets/tray/TrayApplet.vala"
	g_object_ref_sink (_tmp3_);
#line 186 "../src/applets/tray/TrayApplet.vala"
	_tmp4_ = (GtkWidget*) _tmp3_;
#line 186 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (_tmp2_);
#line 186 "../src/applets/tray/TrayApplet.vala"
	result = _tmp4_;
#line 186 "../src/applets/tray/TrayApplet.vala"
	return result;
#line 1290 "TrayApplet.c"
}

const gchar*
tray_applet_get_uuid (TrayApplet* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 75 "../src/applets/tray/TrayApplet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = self->priv->_uuid;
#line 75 "../src/applets/tray/TrayApplet.vala"
	result = _tmp0_;
#line 75 "../src/applets/tray/TrayApplet.vala"
	return result;
#line 1306 "TrayApplet.c"
}

void
tray_applet_set_uuid (TrayApplet* self,
                      const gchar* value)
{
	gchar* old_value;
#line 75 "../src/applets/tray/TrayApplet.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/applets/tray/TrayApplet.vala"
	old_value = tray_applet_get_uuid (self);
#line 75 "../src/applets/tray/TrayApplet.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1320 "TrayApplet.c"
		gchar* _tmp0_;
#line 75 "../src/applets/tray/TrayApplet.vala"
		_tmp0_ = g_strdup (value);
#line 75 "../src/applets/tray/TrayApplet.vala"
		_g_free0 (self->priv->_uuid);
#line 75 "../src/applets/tray/TrayApplet.vala"
		self->priv->_uuid = _tmp0_;
#line 75 "../src/applets/tray/TrayApplet.vala"
		g_object_notify_by_pspec ((GObject *) self, tray_applet_properties[TRAY_APPLET_UUID_PROPERTY]);
#line 1330 "TrayApplet.c"
	}
}

static void
tray_applet_class_init (TrayAppletClass * klass,
                        gpointer klass_data)
{
#line 74 "../src/applets/tray/TrayApplet.vala"
	tray_applet_parent_class = g_type_class_peek_parent (klass);
#line 74 "../src/applets/tray/TrayApplet.vala"
	g_type_class_adjust_private_offset (klass, &TrayApplet_private_offset);
#line 74 "../src/applets/tray/TrayApplet.vala"
	((BudgieAppletClass *) klass)->panel_position_changed = (void (*) (BudgieApplet*, BudgiePanelPosition)) tray_applet_real_panel_position_changed;
#line 74 "../src/applets/tray/TrayApplet.vala"
	((BudgieAppletClass *) klass)->update_popovers = (void (*) (BudgieApplet*, BudgiePopoverManager*)) tray_applet_real_update_popovers;
#line 74 "../src/applets/tray/TrayApplet.vala"
	((BudgieAppletClass *) klass)->supports_settings = (gboolean (*) (BudgieApplet*)) tray_applet_real_supports_settings;
#line 74 "../src/applets/tray/TrayApplet.vala"
	((BudgieAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (BudgieApplet*)) tray_applet_real_get_settings_ui;
#line 74 "../src/applets/tray/TrayApplet.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tray_applet_get_property;
#line 74 "../src/applets/tray/TrayApplet.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tray_applet_set_property;
#line 74 "../src/applets/tray/TrayApplet.vala"
	G_OBJECT_CLASS (klass)->finalize = tray_applet_finalize;
#line 74 "../src/applets/tray/TrayApplet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRAY_APPLET_UUID_PROPERTY, tray_applet_properties[TRAY_APPLET_UUID_PROPERTY] = g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1358 "TrayApplet.c"
}

static void
tray_applet_instance_init (TrayApplet * self,
                           gpointer klass)
{
#line 74 "../src/applets/tray/TrayApplet.vala"
	self->priv = tray_applet_get_instance_private (self);
#line 1367 "TrayApplet.c"
}

static void
tray_applet_finalize (GObject * obj)
{
	TrayApplet * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 74 "../src/applets/tray/TrayApplet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TRAY_APPLET, TrayApplet);
#line 120 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = tray_applet_activeUuid;
#line 120 "../src/applets/tray/TrayApplet.vala"
	_tmp1_ = self->priv->_uuid;
#line 120 "../src/applets/tray/TrayApplet.vala"
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
#line 120 "../src/applets/tray/TrayApplet.vala"
		_g_free0 (tray_applet_activeUuid);
#line 120 "../src/applets/tray/TrayApplet.vala"
		tray_applet_activeUuid = NULL;
#line 1388 "TrayApplet.c"
	}
#line 75 "../src/applets/tray/TrayApplet.vala"
	_g_free0 (self->priv->_uuid);
#line 76 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->priv->tray);
#line 77 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->priv->box);
#line 78 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->priv->settings);
#line 80 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (self->priv->screen);
#line 84 "../src/applets/tray/TrayApplet.vala"
	_tray_error_icon_unref0 (self->priv->errorIcon);
#line 74 "../src/applets/tray/TrayApplet.vala"
	G_OBJECT_CLASS (tray_applet_parent_class)->finalize (obj);
#line 1404 "TrayApplet.c"
}

GType
tray_applet_get_type (void)
{
	return tray_applet_type_id;
}

GType
tray_applet_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (TrayAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tray_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrayApplet), 0, (GInstanceInitFunc) tray_applet_instance_init, NULL };
	tray_applet_type_id = g_type_module_register_type (module, budgie_applet_get_type (), "TrayApplet", &g_define_type_info, 0);
	TrayApplet_private_offset = sizeof (TrayAppletPrivate);
	return tray_applet_type_id;
}

static void
_vala_tray_applet_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	TrayApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TRAY_APPLET, TrayApplet);
#line 74 "../src/applets/tray/TrayApplet.vala"
	switch (property_id) {
#line 74 "../src/applets/tray/TrayApplet.vala"
		case TRAY_APPLET_UUID_PROPERTY:
#line 74 "../src/applets/tray/TrayApplet.vala"
		g_value_set_string (value, tray_applet_get_uuid (self));
#line 74 "../src/applets/tray/TrayApplet.vala"
		break;
#line 1438 "TrayApplet.c"
		default:
#line 74 "../src/applets/tray/TrayApplet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 74 "../src/applets/tray/TrayApplet.vala"
		break;
#line 1444 "TrayApplet.c"
	}
}

static void
_vala_tray_applet_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	TrayApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TRAY_APPLET, TrayApplet);
#line 74 "../src/applets/tray/TrayApplet.vala"
	switch (property_id) {
#line 74 "../src/applets/tray/TrayApplet.vala"
		case TRAY_APPLET_UUID_PROPERTY:
#line 74 "../src/applets/tray/TrayApplet.vala"
		tray_applet_set_uuid (self, g_value_get_string (value));
#line 74 "../src/applets/tray/TrayApplet.vala"
		break;
#line 1464 "TrayApplet.c"
		default:
#line 74 "../src/applets/tray/TrayApplet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 74 "../src/applets/tray/TrayApplet.vala"
		break;
#line 1470 "TrayApplet.c"
	}
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* objmodule = NULL;
	PeasObjectModule* _tmp0_;
#line 191 "../src/applets/tray/TrayApplet.vala"
	g_return_if_fail (module != NULL);
#line 191 "../src/applets/tray/TrayApplet.vala"
	tray_plugin_register_type (module);
#line 191 "../src/applets/tray/TrayApplet.vala"
	tray_settings_register_type (module);
#line 191 "../src/applets/tray/TrayApplet.vala"
	tray_error_icon_register_type (module);
#line 191 "../src/applets/tray/TrayApplet.vala"
	tray_applet_register_type (module);
#line 193 "../src/applets/tray/TrayApplet.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
#line 193 "../src/applets/tray/TrayApplet.vala"
	objmodule = _tmp0_;
#line 194 "../src/applets/tray/TrayApplet.vala"
	peas_object_module_register_extension_type (objmodule, budgie_plugin_get_type (), TYPE_TRAY_PLUGIN);
#line 191 "../src/applets/tray/TrayApplet.vala"
	_g_object_unref0 (objmodule);
#line 1497 "TrayApplet.c"
}

