/* UserIndicatorWindow.c generated by valac 0.56.3, the Vala compiler
 * generated from UserIndicatorWindow.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2022 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "userindicator.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define TYPE_ACCOUNTS_INTERFACE (accounts_interface_get_type ())
#define ACCOUNTS_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNTS_INTERFACE, AccountsInterface))
#define IS_ACCOUNTS_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNTS_INTERFACE))
#define ACCOUNTS_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ACCOUNTS_INTERFACE, AccountsInterfaceIface))

typedef struct _AccountsInterface AccountsInterface;
typedef struct _AccountsInterfaceIface AccountsInterfaceIface;

#define TYPE_ACCOUNTS_INTERFACE_PROXY (accounts_interface_proxy_get_type ())

#define TYPE_ACCOUNT_USER_INTERFACE (account_user_interface_get_type ())
#define ACCOUNT_USER_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT_USER_INTERFACE, AccountUserInterface))
#define IS_ACCOUNT_USER_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT_USER_INTERFACE))
#define ACCOUNT_USER_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ACCOUNT_USER_INTERFACE, AccountUserInterfaceIface))

typedef struct _AccountUserInterface AccountUserInterface;
typedef struct _AccountUserInterfaceIface AccountUserInterfaceIface;

#define TYPE_ACCOUNT_USER_INTERFACE_PROXY (account_user_interface_proxy_get_type ())

#define TYPE_PROPERTIES_INTERFACE (properties_interface_get_type ())
#define PROPERTIES_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTIES_INTERFACE, PropertiesInterface))
#define IS_PROPERTIES_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTIES_INTERFACE))
#define PROPERTIES_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_PROPERTIES_INTERFACE, PropertiesInterfaceIface))

typedef struct _PropertiesInterface PropertiesInterface;
typedef struct _PropertiesInterfaceIface PropertiesInterfaceIface;

#define TYPE_PROPERTIES_INTERFACE_PROXY (properties_interface_proxy_get_type ())
enum  {
	USER_INDICATOR_WINDOW_0_PROPERTY,
	USER_INDICATOR_WINDOW_NUM_PROPERTIES
};
static GParamSpec* user_indicator_window_properties[USER_INDICATOR_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _UserIndicatorWindowSetupDbusData UserIndicatorWindowSetupDbusData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	INDICATOR_ITEM_0_PROPERTY,
	INDICATOR_ITEM_IMAGE_SOURCE_PROPERTY,
	INDICATOR_ITEM_LABEL_TEXT_PROPERTY,
	INDICATOR_ITEM_NUM_PROPERTIES
};
static GParamSpec* indicator_item_properties[INDICATOR_ITEM_NUM_PROPERTIES];

struct _AccountsInterfaceIface {
	GTypeInterface parent_iface;
	gchar* (*find_user_by_name) (AccountsInterface* self, const gchar* username, GError** error);
};

struct _AccountUserInterfaceIface {
	GTypeInterface parent_iface;
};

struct _PropertiesInterfaceIface {
	GTypeInterface parent_iface;
	GVariant* (*get) (PropertiesInterface* self, const gchar* interface, const gchar* property, GError** error);
};

struct _UserIndicatorWindowPrivate {
	ScreenSaver* saver;
	SessionManager* session;
	LogindInterface* logind_interface;
	AccountsInterface* user_manager;
	AccountUserInterface* current_user;
	gchar* current_username;
	PropertiesInterface* current_user_props;
	IndicatorItem* user_item;
	IndicatorItem* lock_menu;
	IndicatorItem* suspend_menu;
	IndicatorItem* hibernate_menu;
	IndicatorItem* reboot_menu;
	IndicatorItem* shutdown_menu;
	IndicatorItem* logout_menu;
};

struct _UserIndicatorWindowSetupDbusData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	UserIndicatorWindow* self;
	AccountsInterface* _tmp0_;
	AccountsInterface* _tmp1_;
	AccountsInterface* _tmp2_;
	gchar* uid;
	AccountsInterface* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	PropertiesInterface* _tmp6_;
	const gchar* _tmp7_;
	PropertiesInterface* _tmp8_;
	PropertiesInterface* _tmp9_;
	GError* e;
	GError* _tmp10_;
	const gchar* _tmp11_;
	AccountUserInterface* _tmp12_;
	const gchar* _tmp13_;
	AccountUserInterface* _tmp14_;
	AccountUserInterface* _tmp15_;
	AccountUserInterface* _tmp16_;
	GError* _vala1_e;
	GError* _tmp17_;
	const gchar* _tmp18_;
	GError* _vala2_e;
	GError* _tmp19_;
	const gchar* _tmp20_;
	LogindInterface* _tmp21_;
	LogindInterface* _tmp22_;
	LogindInterface* _tmp23_;
	GError* _vala3_e;
	GError* _tmp24_;
	const gchar* _tmp25_;
	ScreenSaver* _tmp26_;
	ScreenSaver* _tmp27_;
	ScreenSaver* _tmp28_;
	GError* _vala4_e;
	GError* _tmp29_;
	const gchar* _tmp30_;
	SessionManager* _tmp31_;
	SessionManager* _tmp32_;
	SessionManager* _tmp33_;
	GError* _vala5_e;
	GError* _tmp34_;
	const gchar* _tmp35_;
	GError* _inner_error0_;
};

struct _IndicatorItemPrivate {
	GtkBox* menu_item;
	GtkImage* arrow;
	GtkImage* button_image;
	GtkLabel* button_label;
	gchar* _image_source;
	gchar* _label_text;
};

static gint UserIndicatorWindow_private_offset;
static gpointer user_indicator_window_parent_class = NULL;
static GType user_indicator_window_type_id = 0;
static gint IndicatorItem_private_offset;
static gpointer indicator_item_parent_class = NULL;
static GType indicator_item_type_id = 0;

VALA_EXTERN GType accounts_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void accounts_interface_proxy_register_dynamic_type (GTypeModule* module);
VALA_EXTERN guint accounts_interface_register_object (void* object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error);
GType accounts_interface_register_type (GTypeModule * module);
VALA_EXTERN GType accounts_interface_get_type (void) G_GNUC_CONST ;
GType account_user_interface_register_type (GTypeModule * module);
VALA_EXTERN GType account_user_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType account_user_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void account_user_interface_proxy_register_dynamic_type (GTypeModule* module);
VALA_EXTERN guint account_user_interface_register_object (void* object,
                                              GDBusConnection* connection,
                                              const gchar* path,
                                              GError** error);
VALA_EXTERN GType properties_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void properties_interface_proxy_register_dynamic_type (GTypeModule* module);
VALA_EXTERN guint properties_interface_register_object (void* object,
                                            GDBusConnection* connection,
                                            const gchar* path,
                                            GError** error);
GType properties_interface_register_type (GTypeModule * module);
VALA_EXTERN GType properties_interface_get_type (void) G_GNUC_CONST ;
static void user_indicator_window_setup_dbus_data_free (gpointer _data);
static void user_indicator_window_setup_dbus (UserIndicatorWindow* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
static void user_indicator_window_setup_dbus_finish (UserIndicatorWindow* self,
                                              GAsyncResult* _res_);
static gboolean user_indicator_window_setup_dbus_co (UserIndicatorWindowSetupDbusData* _data_);
static void user_indicator_window_setup_dbus_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
VALA_EXTERN gchar* accounts_interface_find_user_by_name (AccountsInterface* self,
                                             const gchar* username,
                                             GError** error);
static void user_indicator_window_update_userinfo (UserIndicatorWindow* self);
static void _user_indicator_window_update_userinfo_account_user_interface_changed (AccountUserInterface* _sender,
                                                                            gpointer self);
static GtkRevealer* user_indicator_window_create_usersection (UserIndicatorWindow* self);
static gboolean __lambda6_ (UserIndicatorWindow* self,
                     GdkEventButton* e);
static gboolean ___lambda6__gtk_widget_button_release_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static gboolean __lambda7_ (UserIndicatorWindow* self,
                     GdkEventButton* e);
static void user_indicator_window_lock_screen (UserIndicatorWindow* self);
static gboolean ___lambda7__gtk_widget_button_release_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static gboolean __lambda9_ (UserIndicatorWindow* self,
                     GdkEventButton* e);
static void user_indicator_window_suspend (UserIndicatorWindow* self);
static gboolean ___lambda9__gtk_widget_button_release_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static gboolean __lambda11_ (UserIndicatorWindow* self,
                      GdkEventButton* e);
static void user_indicator_window_reboot (UserIndicatorWindow* self);
static gboolean ___lambda11__gtk_widget_button_release_event (GtkWidget* _sender,
                                                       GdkEventButton* event,
                                                       gpointer self);
static gboolean __lambda13_ (UserIndicatorWindow* self,
                      GdkEventButton* e);
static void user_indicator_window_hibernate (UserIndicatorWindow* self);
static gboolean ___lambda13__gtk_widget_button_release_event (GtkWidget* _sender,
                                                       GdkEventButton* event,
                                                       gpointer self);
static gboolean __lambda15_ (UserIndicatorWindow* self,
                      GdkEventButton* e);
static void user_indicator_window_shutdown (UserIndicatorWindow* self);
static gboolean ___lambda15__gtk_widget_button_release_event (GtkWidget* _sender,
                                                       GdkEventButton* event,
                                                       gpointer self);
static void user_indicator_window_hide_usersection (UserIndicatorWindow* self);
static void _user_indicator_window_hide_usersection_gtk_widget_unmap (GtkWidget* _sender,
                                                               gpointer self);
static void user_indicator_window_real_hide (GtkWidget* base);
static gboolean __lambda4_ (UserIndicatorWindow* self,
                     GdkEventButton* e);
static void user_indicator_window_logout (UserIndicatorWindow* self);
static gboolean ___lambda4__gtk_widget_button_release_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static void user_indicator_window_show_usersection (UserIndicatorWindow* self);
static gchar* user_indicator_window_get_user_image (UserIndicatorWindow* self);
static gchar* user_indicator_window_get_user_name (UserIndicatorWindow* self);
VALA_EXTERN GVariant* properties_interface_get (PropertiesInterface* self,
                                    const gchar* interface,
                                    const gchar* property,
                                    GError** error);
static gboolean __lambda5_ (UserIndicatorWindow* self);
static gboolean ___lambda5__gsource_func (gpointer self);
static gboolean __lambda14_ (UserIndicatorWindow* self);
static gboolean ___lambda14__gsource_func (gpointer self);
static gboolean __lambda12_ (UserIndicatorWindow* self);
static gboolean ___lambda12__gsource_func (gpointer self);
static gboolean __lambda16_ (UserIndicatorWindow* self);
static gboolean ___lambda16__gsource_func (gpointer self);
static gboolean __lambda10_ (UserIndicatorWindow* self);
static gboolean ___lambda10__gsource_func (gpointer self);
static gboolean __lambda8_ (UserIndicatorWindow* self);
static gboolean ___lambda8__gsource_func (gpointer self);
static void user_indicator_window_finalize (GObject * obj);
static void indicator_item_finalize (GObject * obj);
static void _vala_indicator_item_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_indicator_item_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
user_indicator_window_get_instance_private (UserIndicatorWindow* self)
{
	return G_STRUCT_MEMBER_P (self, UserIndicatorWindow_private_offset);
}

static void
user_indicator_window_setup_dbus_data_free (gpointer _data)
{
	UserIndicatorWindowSetupDbusData* _data_;
	_data_ = _data;
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_slice_free (UserIndicatorWindowSetupDbusData, _data_);
#line 310 "UserIndicatorWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 318 "UserIndicatorWindow.c"
}

static void
user_indicator_window_setup_dbus (UserIndicatorWindow* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	UserIndicatorWindowSetupDbusData* _data_;
	UserIndicatorWindow* _tmp0_;
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_data_ = g_slice_new0 (UserIndicatorWindowSetupDbusData);
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, user_indicator_window_setup_dbus_data_free);
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_data_->self = _tmp0_;
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_indicator_window_setup_dbus_co (_data_);
#line 342 "UserIndicatorWindow.c"
}

static void
user_indicator_window_setup_dbus_finish (UserIndicatorWindow* self,
                                         GAsyncResult* _res_)
{
	UserIndicatorWindowSetupDbusData* _data_;
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 352 "UserIndicatorWindow.c"
}

static void
user_indicator_window_setup_dbus_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	UserIndicatorWindowSetupDbusData* _data_;
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_data_ = _user_data_;
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_data_->_source_object_ = source_object;
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_data_->_res_ = _res_;
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_indicator_window_setup_dbus_co (_data_);
#line 369 "UserIndicatorWindow.c"
}

static void
_user_indicator_window_update_userinfo_account_user_interface_changed (AccountUserInterface* _sender,
                                                                       gpointer self)
{
#line 55 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_indicator_window_update_userinfo ((UserIndicatorWindow*) self);
#line 378 "UserIndicatorWindow.c"
}

static gboolean
user_indicator_window_setup_dbus_co (UserIndicatorWindowSetupDbusData* _data_)
{
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	switch (_data_->_state_) {
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		case 0:
#line 388 "UserIndicatorWindow.c"
		goto _state_0;
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		case 1:
#line 392 "UserIndicatorWindow.c"
		goto _state_1;
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		case 2:
#line 396 "UserIndicatorWindow.c"
		goto _state_2;
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		case 3:
#line 400 "UserIndicatorWindow.c"
		goto _state_3;
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		case 4:
#line 404 "UserIndicatorWindow.c"
		goto _state_4;
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		case 5:
#line 408 "UserIndicatorWindow.c"
		goto _state_5;
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		case 6:
#line 412 "UserIndicatorWindow.c"
		goto _state_6;
		default:
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_assert_not_reached ();
#line 417 "UserIndicatorWindow.c"
	}
	_state_0:
	{
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_state_ = 1;
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_async_initable_new_async (TYPE_ACCOUNTS_INTERFACE_PROXY, 0, NULL, user_indicator_window_setup_dbus_ready, _data_, "g-flags", 0, "g-name", ACCOUNTSSERVICE_ACC, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/org/freedesktop/Accounts", "g-interface-name", "org.freedesktop.Accounts", NULL);
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return FALSE;
#line 427 "UserIndicatorWindow.c"
		_state_1:
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp1_ = (AccountsInterface*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp0_ = (AccountsInterface*) _data_->_tmp1_;
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 435 "UserIndicatorWindow.c"
			goto __catch0_g_error;
		}
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp2_ = _data_->_tmp0_;
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp0_ = NULL;
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_object_unref0 (_data_->self->priv->user_manager);
#line 42 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->self->priv->user_manager = _data_->_tmp2_;
#line 44 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp3_ = _data_->self->priv->user_manager;
#line 44 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp4_ = _data_->self->priv->current_username;
#line 44 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp5_ = accounts_interface_find_user_by_name (_data_->_tmp3_, _data_->_tmp4_, &_data_->_inner_error0_);
#line 44 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->uid = _data_->_tmp5_;
#line 44 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 44 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_object_unref0 (_data_->_tmp0_);
#line 458 "UserIndicatorWindow.c"
			goto __catch0_g_error;
		}
		{
#line 47 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp7_ = _data_->uid;
#line 47 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_state_ = 2;
#line 47 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_async_initable_new_async (TYPE_PROPERTIES_INTERFACE_PROXY, 0, NULL, user_indicator_window_setup_dbus_ready, _data_, "g-flags", 0, "g-name", ACCOUNTSSERVICE_ACC, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", _data_->_tmp7_, "g-interface-name", "org.freedesktop.DBus.Properties", NULL);
#line 47 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			return FALSE;
#line 470 "UserIndicatorWindow.c"
			_state_2:
#line 47 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp8_ = (PropertiesInterface*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 47 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp6_ = (PropertiesInterface*) _data_->_tmp8_;
#line 47 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 478 "UserIndicatorWindow.c"
				goto __catch1_g_error;
			}
#line 47 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp9_ = _data_->_tmp6_;
#line 47 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp6_ = NULL;
#line 47 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_object_unref0 (_data_->self->priv->current_user_props);
#line 47 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->self->priv->current_user_props = _data_->_tmp9_;
#line 48 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			user_indicator_window_update_userinfo (_data_->self);
#line 46 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_object_unref0 (_data_->_tmp6_);
#line 493 "UserIndicatorWindow.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 46 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->e = _data_->_inner_error0_;
#line 46 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_inner_error0_ = NULL;
#line 50 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp10_ = _data_->e;
#line 50 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp11_ = _data_->_tmp10_->message;
#line 50 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_warning (UNABLE_CONTACT "Account User Service: %s", _data_->_tmp11_);
#line 46 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_error_free0 (_data_->e);
#line 510 "UserIndicatorWindow.c"
		}
		__finally1:
#line 46 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 46 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_free0 (_data_->uid);
#line 46 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_object_unref0 (_data_->_tmp0_);
#line 519 "UserIndicatorWindow.c"
			goto __catch0_g_error;
		}
		{
#line 54 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp13_ = _data_->uid;
#line 54 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_state_ = 3;
#line 54 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_async_initable_new_async (TYPE_ACCOUNT_USER_INTERFACE_PROXY, 0, NULL, user_indicator_window_setup_dbus_ready, _data_, "g-flags", 0, "g-name", ACCOUNTSSERVICE_ACC, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", _data_->_tmp13_, "g-interface-name", "org.freedesktop.Accounts.User", NULL);
#line 54 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			return FALSE;
#line 531 "UserIndicatorWindow.c"
			_state_3:
#line 54 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp14_ = (AccountUserInterface*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 54 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp12_ = (AccountUserInterface*) _data_->_tmp14_;
#line 54 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 539 "UserIndicatorWindow.c"
				goto __catch2_g_error;
			}
#line 54 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp15_ = _data_->_tmp12_;
#line 54 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp12_ = NULL;
#line 54 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_object_unref0 (_data_->self->priv->current_user);
#line 54 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->self->priv->current_user = _data_->_tmp15_;
#line 55 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp16_ = _data_->self->priv->current_user;
#line 55 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_signal_connect_object (_data_->_tmp16_, "changed", (GCallback) _user_indicator_window_update_userinfo_account_user_interface_changed, _data_->self, 0);
#line 53 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_object_unref0 (_data_->_tmp12_);
#line 556 "UserIndicatorWindow.c"
		}
		goto __finally2;
		__catch2_g_error:
		{
#line 53 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_vala1_e = _data_->_inner_error0_;
#line 53 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_inner_error0_ = NULL;
#line 57 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp17_ = _data_->_vala1_e;
#line 57 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_data_->_tmp18_ = _data_->_tmp17_->message;
#line 57 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_warning (UNABLE_CONTACT "Account User Service: %s", _data_->_tmp18_);
#line 53 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_error_free0 (_data_->_vala1_e);
#line 573 "UserIndicatorWindow.c"
		}
		__finally2:
#line 53 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 53 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_free0 (_data_->uid);
#line 53 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_object_unref0 (_data_->_tmp0_);
#line 582 "UserIndicatorWindow.c"
			goto __catch0_g_error;
		}
#line 41 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_free0 (_data_->uid);
#line 41 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 589 "UserIndicatorWindow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 41 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_vala2_e = _data_->_inner_error0_;
#line 41 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_inner_error0_ = NULL;
#line 60 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp19_ = _data_->_vala2_e;
#line 60 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp20_ = _data_->_tmp19_->message;
#line 60 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_warning (UNABLE_CONTACT "Accounts Service: %s", _data_->_tmp20_);
#line 41 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_error_free0 (_data_->_vala2_e);
#line 606 "UserIndicatorWindow.c"
	}
	__finally0:
#line 41 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 41 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 41 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 41 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_object_unref (_data_->_async_result);
#line 41 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return FALSE;
#line 619 "UserIndicatorWindow.c"
	}
	{
#line 64 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_state_ = 4;
#line 64 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_async_initable_new_async (TYPE_LOGIND_INTERFACE_PROXY, 0, NULL, user_indicator_window_setup_dbus_ready, _data_, "g-flags", 0, "g-name", LOGIND_LOGIN, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/org/freedesktop/login1", "g-interface-name", "org.freedesktop.login1.Manager", NULL);
#line 64 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return FALSE;
#line 628 "UserIndicatorWindow.c"
		_state_4:
#line 64 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp22_ = (LogindInterface*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 64 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp21_ = (LogindInterface*) _data_->_tmp22_;
#line 64 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 636 "UserIndicatorWindow.c"
			goto __catch3_g_error;
		}
#line 64 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp23_ = _data_->_tmp21_;
#line 64 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp21_ = NULL;
#line 64 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_object_unref0 (_data_->self->priv->logind_interface);
#line 64 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->self->priv->logind_interface = _data_->_tmp23_;
#line 63 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_object_unref0 (_data_->_tmp21_);
#line 649 "UserIndicatorWindow.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
#line 63 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_vala3_e = _data_->_inner_error0_;
#line 63 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_inner_error0_ = NULL;
#line 66 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp24_ = _data_->_vala3_e;
#line 66 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp25_ = _data_->_tmp24_->message;
#line 66 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_warning (UNABLE_CONTACT "logind: %s", _data_->_tmp25_);
#line 63 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_error_free0 (_data_->_vala3_e);
#line 666 "UserIndicatorWindow.c"
	}
	__finally3:
#line 63 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 63 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 63 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 63 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_object_unref (_data_->_async_result);
#line 63 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return FALSE;
#line 679 "UserIndicatorWindow.c"
	}
	{
#line 70 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_state_ = 5;
#line 70 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_async_initable_new_async (TYPE_SCREEN_SAVER_PROXY, 0, NULL, user_indicator_window_setup_dbus_ready, _data_, "g-flags", 0, "g-name", "org.gnome.ScreenSaver", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/ScreenSaver", "g-interface-name", "org.gnome.ScreenSaver", NULL);
#line 70 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return FALSE;
#line 688 "UserIndicatorWindow.c"
		_state_5:
#line 70 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp27_ = (ScreenSaver*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 70 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp26_ = (ScreenSaver*) _data_->_tmp27_;
#line 70 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 696 "UserIndicatorWindow.c"
			goto __catch4_g_error;
		}
#line 70 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp28_ = _data_->_tmp26_;
#line 70 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp26_ = NULL;
#line 70 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_object_unref0 (_data_->self->priv->saver);
#line 70 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->self->priv->saver = _data_->_tmp28_;
#line 69 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_object_unref0 (_data_->_tmp26_);
#line 709 "UserIndicatorWindow.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
#line 69 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_vala4_e = _data_->_inner_error0_;
#line 69 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_inner_error0_ = NULL;
#line 75 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp29_ = _data_->_vala4_e;
#line 75 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp30_ = _data_->_tmp29_->message;
#line 75 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_warning (UNABLE_CONTACT "budgie-screensaver: %s", _data_->_tmp30_);
#line 77 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_error_free0 (_data_->_vala4_e);
#line 77 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 77 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (_data_->_state_ != 0) {
#line 77 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 77 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 734 "UserIndicatorWindow.c"
			}
		}
#line 77 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_object_unref (_data_->_async_result);
#line 77 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return FALSE;
#line 741 "UserIndicatorWindow.c"
	}
	__finally4:
#line 69 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 69 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 69 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 69 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_object_unref (_data_->_async_result);
#line 69 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return FALSE;
#line 754 "UserIndicatorWindow.c"
	}
	{
#line 81 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_state_ = 6;
#line 81 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_async_initable_new_async (TYPE_SESSION_MANAGER_PROXY, 0, NULL, user_indicator_window_setup_dbus_ready, _data_, "g-flags", 0, "g-name", G_SESSION, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/SessionManager", "g-interface-name", "org.gnome.SessionManager", NULL);
#line 81 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return FALSE;
#line 763 "UserIndicatorWindow.c"
		_state_6:
#line 81 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp32_ = (SessionManager*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 81 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp31_ = (SessionManager*) _data_->_tmp32_;
#line 81 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 771 "UserIndicatorWindow.c"
			goto __catch5_g_error;
		}
#line 81 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp33_ = _data_->_tmp31_;
#line 81 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp31_ = NULL;
#line 81 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_object_unref0 (_data_->self->priv->session);
#line 81 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->self->priv->session = _data_->_tmp33_;
#line 80 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_object_unref0 (_data_->_tmp31_);
#line 784 "UserIndicatorWindow.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
#line 80 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_vala5_e = _data_->_inner_error0_;
#line 80 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_inner_error0_ = NULL;
#line 83 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp34_ = _data_->_vala5_e;
#line 83 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_data_->_tmp35_ = _data_->_tmp34_->message;
#line 83 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_warning (UNABLE_CONTACT "GNOME Session: %s", _data_->_tmp35_);
#line 80 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_error_free0 (_data_->_vala5_e);
#line 801 "UserIndicatorWindow.c"
	}
	__finally5:
#line 80 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 80 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 80 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 80 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_object_unref (_data_->_async_result);
#line 80 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return FALSE;
#line 814 "UserIndicatorWindow.c"
	}
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_data_->_state_ != 0) {
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 824 "UserIndicatorWindow.c"
		}
	}
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_unref (_data_->_async_result);
#line 40 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return FALSE;
#line 831 "UserIndicatorWindow.c"
}

static gboolean
__lambda6_ (UserIndicatorWindow* self,
            GdkEventButton* e)
{
	gboolean result;
#line 132 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 133 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (e->button != ((guint) 1)) {
#line 134 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		result = GDK_EVENT_PROPAGATE;
#line 134 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return result;
#line 847 "UserIndicatorWindow.c"
	}
#line 136 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_indicator_window_toggle_usersection (self);
#line 137 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = GDK_EVENT_STOP;
#line 137 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 855 "UserIndicatorWindow.c"
}

static gboolean
___lambda6__gtk_widget_button_release_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = __lambda6_ ((UserIndicatorWindow*) self, event);
#line 132 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 867 "UserIndicatorWindow.c"
}

static gboolean
__lambda7_ (UserIndicatorWindow* self,
            GdkEventButton* e)
{
	gboolean result;
#line 140 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 141 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (e->button != ((guint) 1)) {
#line 142 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		result = GDK_EVENT_PROPAGATE;
#line 142 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return result;
#line 883 "UserIndicatorWindow.c"
	}
#line 144 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_indicator_window_lock_screen (self);
#line 145 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = GDK_EVENT_STOP;
#line 145 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 891 "UserIndicatorWindow.c"
}

static gboolean
___lambda7__gtk_widget_button_release_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = __lambda7_ ((UserIndicatorWindow*) self, event);
#line 140 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 903 "UserIndicatorWindow.c"
}

static gboolean
__lambda9_ (UserIndicatorWindow* self,
            GdkEventButton* e)
{
	gboolean result;
#line 148 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 149 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (e->button != ((guint) 1)) {
#line 150 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		result = GDK_EVENT_PROPAGATE;
#line 150 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return result;
#line 919 "UserIndicatorWindow.c"
	}
#line 152 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_indicator_window_suspend (self);
#line 153 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = GDK_EVENT_STOP;
#line 153 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 927 "UserIndicatorWindow.c"
}

static gboolean
___lambda9__gtk_widget_button_release_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = __lambda9_ ((UserIndicatorWindow*) self, event);
#line 148 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 939 "UserIndicatorWindow.c"
}

static gboolean
__lambda11_ (UserIndicatorWindow* self,
             GdkEventButton* e)
{
	gboolean result;
#line 156 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 157 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (e->button != ((guint) 1)) {
#line 158 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		result = GDK_EVENT_PROPAGATE;
#line 158 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return result;
#line 955 "UserIndicatorWindow.c"
	}
#line 160 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_indicator_window_reboot (self);
#line 161 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = GDK_EVENT_STOP;
#line 161 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 963 "UserIndicatorWindow.c"
}

static gboolean
___lambda11__gtk_widget_button_release_event (GtkWidget* _sender,
                                              GdkEventButton* event,
                                              gpointer self)
{
	gboolean result;
	result = __lambda11_ ((UserIndicatorWindow*) self, event);
#line 156 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 975 "UserIndicatorWindow.c"
}

static gboolean
__lambda13_ (UserIndicatorWindow* self,
             GdkEventButton* e)
{
	gboolean result;
#line 164 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 165 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (e->button != ((guint) 1)) {
#line 166 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		result = GDK_EVENT_PROPAGATE;
#line 166 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return result;
#line 991 "UserIndicatorWindow.c"
	}
#line 168 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_indicator_window_hibernate (self);
#line 169 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = GDK_EVENT_STOP;
#line 169 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 999 "UserIndicatorWindow.c"
}

static gboolean
___lambda13__gtk_widget_button_release_event (GtkWidget* _sender,
                                              GdkEventButton* event,
                                              gpointer self)
{
	gboolean result;
	result = __lambda13_ ((UserIndicatorWindow*) self, event);
#line 164 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 1011 "UserIndicatorWindow.c"
}

static gboolean
__lambda15_ (UserIndicatorWindow* self,
             GdkEventButton* e)
{
	gboolean result;
#line 172 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 173 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (e->button != ((guint) 1)) {
#line 174 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		result = GDK_EVENT_PROPAGATE;
#line 174 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return result;
#line 1027 "UserIndicatorWindow.c"
	}
#line 176 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_indicator_window_shutdown (self);
#line 177 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = GDK_EVENT_STOP;
#line 177 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 1035 "UserIndicatorWindow.c"
}

static gboolean
___lambda15__gtk_widget_button_release_event (GtkWidget* _sender,
                                              GdkEventButton* event,
                                              gpointer self)
{
	gboolean result;
	result = __lambda15_ ((UserIndicatorWindow*) self, event);
#line 172 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 1047 "UserIndicatorWindow.c"
}

static void
_user_indicator_window_hide_usersection_gtk_widget_unmap (GtkWidget* _sender,
                                                          gpointer self)
{
#line 180 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_indicator_window_hide_usersection ((UserIndicatorWindow*) self);
#line 1056 "UserIndicatorWindow.c"
}

UserIndicatorWindow*
user_indicator_window_construct (GType object_type,
                                 GtkWidget* window_parent)
{
	UserIndicatorWindow * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GtkBox* _tmp2_;
	GtkListBox* items = NULL;
	GtkListBox* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkStyleContext* _tmp5_;
	gboolean _tmp6_;
	IndicatorItem* _tmp7_;
	GtkRevealer* _tmp8_;
	GtkSeparator* separator = NULL;
	GtkSeparator* _tmp9_;
	gboolean _tmp10_;
	IndicatorItem* _tmp11_;
	gboolean _tmp12_;
	IndicatorItem* _tmp13_;
	gboolean _tmp14_;
	IndicatorItem* _tmp15_;
	gboolean _tmp16_;
	IndicatorItem* _tmp17_;
	gboolean _tmp18_;
	IndicatorItem* _tmp19_;
	IndicatorItem* _tmp20_;
	GtkRevealer* _tmp21_;
	IndicatorItem* _tmp22_;
	IndicatorItem* _tmp23_;
	IndicatorItem* _tmp24_;
	IndicatorItem* _tmp25_;
	IndicatorItem* _tmp26_;
	GtkBox* _tmp27_;
	GtkBox* _tmp28_;
	IndicatorItem* _tmp29_;
	IndicatorItem* _tmp30_;
	IndicatorItem* _tmp31_;
	IndicatorItem* _tmp32_;
	IndicatorItem* _tmp33_;
	IndicatorItem* _tmp34_;
#line 88 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self = (UserIndicatorWindow*) g_object_new (object_type, "relative-to", window_parent, NULL);
#line 89 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = g_get_user_name ();
#line 89 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 89 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_free0 (self->priv->current_username);
#line 89 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->current_username = _tmp1_;
#line 91 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_indicator_window_setup_dbus (self, NULL, NULL);
#line 94 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 94 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 94 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->menu);
#line 94 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->menu = _tmp2_;
#line 95 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp3_ = (GtkListBox*) gtk_list_box_new ();
#line 95 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 95 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	items = _tmp3_;
#line 97 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 97 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_style_context_add_class (_tmp4_, "user-menu");
#line 98 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) items);
#line 98 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_style_context_add_class (_tmp5_, "content-box");
#line 99 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_list_box_set_selection_mode (items, GTK_SELECTION_NONE);
#line 103 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp6_ = TRUE;
#line 103 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp7_ = indicator_item_new (_ ("User"), USER_SYMBOLIC_ICON, &_tmp6_);
#line 103 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_ref_sink (_tmp7_);
#line 103 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->user_item);
#line 103 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->user_item = _tmp7_;
#line 104 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp8_ = user_indicator_window_create_usersection (self);
#line 104 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->user_section);
#line 104 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->user_section = _tmp8_;
#line 107 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp9_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 107 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_ref_sink (_tmp9_);
#line 107 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	separator = _tmp9_;
#line 109 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp10_ = FALSE;
#line 109 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp11_ = indicator_item_new (_ ("Lock"), "system-lock-screen-symbolic", &_tmp10_);
#line 109 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_ref_sink (_tmp11_);
#line 109 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->lock_menu);
#line 109 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->lock_menu = _tmp11_;
#line 110 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp12_ = FALSE;
#line 110 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp13_ = indicator_item_new (_ ("Suspend"), "system-suspend-symbolic", &_tmp12_);
#line 110 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_ref_sink (_tmp13_);
#line 110 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->suspend_menu);
#line 110 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->suspend_menu = _tmp13_;
#line 111 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp14_ = FALSE;
#line 111 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp15_ = indicator_item_new (_ ("Hibernate"), "system-hibernate-symbolic", &_tmp14_);
#line 111 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_ref_sink (_tmp15_);
#line 111 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->hibernate_menu);
#line 111 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->hibernate_menu = _tmp15_;
#line 112 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp16_ = FALSE;
#line 112 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp17_ = indicator_item_new (_ ("Restart"), "system-restart-symbolic", &_tmp16_);
#line 112 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_ref_sink (_tmp17_);
#line 112 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->reboot_menu);
#line 112 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->reboot_menu = _tmp17_;
#line 113 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp18_ = FALSE;
#line 113 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp19_ = indicator_item_new (_ ("Shutdown"), "system-shutdown-symbolic", &_tmp18_);
#line 113 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_ref_sink (_tmp19_);
#line 113 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->shutdown_menu);
#line 113 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->shutdown_menu = _tmp19_;
#line 116 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp20_ = self->priv->user_item;
#line 116 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_container_add ((GtkContainer*) items, (GtkWidget*) _tmp20_);
#line 117 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp21_ = self->user_section;
#line 117 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_container_add ((GtkContainer*) items, (GtkWidget*) _tmp21_);
#line 118 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_container_add ((GtkContainer*) items, (GtkWidget*) separator);
#line 119 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp22_ = self->priv->lock_menu;
#line 119 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_container_add ((GtkContainer*) items, (GtkWidget*) _tmp22_);
#line 120 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp23_ = self->priv->suspend_menu;
#line 120 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_container_add ((GtkContainer*) items, (GtkWidget*) _tmp23_);
#line 121 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp24_ = self->priv->hibernate_menu;
#line 121 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_container_add ((GtkContainer*) items, (GtkWidget*) _tmp24_);
#line 122 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp25_ = self->priv->reboot_menu;
#line 122 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_container_add ((GtkContainer*) items, (GtkWidget*) _tmp25_);
#line 123 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp26_ = self->priv->shutdown_menu;
#line 123 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_container_add ((GtkContainer*) items, (GtkWidget*) _tmp26_);
#line 125 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp27_ = self->menu;
#line 125 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_box_pack_start (_tmp27_, (GtkWidget*) items, FALSE, FALSE, (guint) 0);
#line 126 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp28_ = self->menu;
#line 126 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp28_);
#line 128 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 250, 0);
#line 132 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp29_ = self->priv->user_item;
#line 132 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp29_, "button-release-event", (GCallback) ___lambda6__gtk_widget_button_release_event, self, 0);
#line 140 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp30_ = self->priv->lock_menu;
#line 140 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp30_, "button-release-event", (GCallback) ___lambda7__gtk_widget_button_release_event, self, 0);
#line 148 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp31_ = self->priv->suspend_menu;
#line 148 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp31_, "button-release-event", (GCallback) ___lambda9__gtk_widget_button_release_event, self, 0);
#line 156 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp32_ = self->priv->reboot_menu;
#line 156 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp32_, "button-release-event", (GCallback) ___lambda11__gtk_widget_button_release_event, self, 0);
#line 164 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp33_ = self->priv->hibernate_menu;
#line 164 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp33_, "button-release-event", (GCallback) ___lambda13__gtk_widget_button_release_event, self, 0);
#line 172 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp34_ = self->priv->shutdown_menu;
#line 172 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp34_, "button-release-event", (GCallback) ___lambda15__gtk_widget_button_release_event, self, 0);
#line 180 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_signal_connect_object ((GtkWidget*) self, "unmap", (GCallback) _user_indicator_window_hide_usersection_gtk_widget_unmap, self, 0);
#line 87 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (separator);
#line 87 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (items);
#line 87 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return self;
#line 1281 "UserIndicatorWindow.c"
}

UserIndicatorWindow*
user_indicator_window_new (GtkWidget* window_parent)
{
#line 87 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return user_indicator_window_construct (TYPE_USER_INDICATOR_WINDOW, window_parent);
#line 1289 "UserIndicatorWindow.c"
}

static void
user_indicator_window_real_hide (GtkWidget* base)
{
	UserIndicatorWindow * self;
	GtkButton** buttons = NULL;
	IndicatorItem* _tmp0_;
	GtkButton* _tmp1_;
	IndicatorItem* _tmp2_;
	GtkButton* _tmp3_;
	IndicatorItem* _tmp4_;
	GtkButton* _tmp5_;
	IndicatorItem* _tmp6_;
	GtkButton* _tmp7_;
	IndicatorItem* _tmp8_;
	GtkButton* _tmp9_;
	IndicatorItem* _tmp10_;
	GtkButton* _tmp11_;
	IndicatorItem* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton** _tmp14_;
	gint buttons_length1;
	gint _buttons_size_;
#line 184 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self = (UserIndicatorWindow*) base;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->priv->user_item;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp1_ = _g_object_ref0 ((GtkButton*) _tmp0_);
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp2_ = self->priv->logout_menu;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp3_ = _g_object_ref0 ((GtkButton*) _tmp2_);
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp4_ = self->priv->lock_menu;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp5_ = _g_object_ref0 ((GtkButton*) _tmp4_);
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp6_ = self->priv->suspend_menu;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp7_ = _g_object_ref0 ((GtkButton*) _tmp6_);
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp8_ = self->priv->reboot_menu;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp9_ = _g_object_ref0 ((GtkButton*) _tmp8_);
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp10_ = self->priv->hibernate_menu;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp11_ = _g_object_ref0 ((GtkButton*) _tmp10_);
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp12_ = self->priv->shutdown_menu;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp13_ = _g_object_ref0 ((GtkButton*) _tmp12_);
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp14_ = g_new0 (GtkButton*, 7 + 1);
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp14_[0] = _tmp1_;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp14_[1] = _tmp3_;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp14_[2] = _tmp5_;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp14_[3] = _tmp7_;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp14_[4] = _tmp9_;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp14_[5] = _tmp11_;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp14_[6] = _tmp13_;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	buttons = _tmp14_;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	buttons_length1 = 7;
#line 185 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_buttons_size_ = buttons_length1;
#line 1366 "UserIndicatorWindow.c"
	{
		gint i = 0;
#line 195 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		i = 0;
#line 1371 "UserIndicatorWindow.c"
		{
			gboolean _tmp15_ = FALSE;
#line 195 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp15_ = TRUE;
#line 195 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			while (TRUE) {
#line 1378 "UserIndicatorWindow.c"
				GtkButton** _tmp17_;
				gint _tmp17__length1;
				GtkButton* button = NULL;
				GtkButton** _tmp18_;
				gint _tmp18__length1;
				GtkButton* _tmp19_;
				GtkButton* _tmp20_;
				GtkButton* _tmp21_;
				GtkButton* _tmp22_;
				GtkButton* _tmp23_;
#line 195 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				if (!_tmp15_) {
#line 1391 "UserIndicatorWindow.c"
					gint _tmp16_;
#line 195 "../src/applets/user-indicator/UserIndicatorWindow.vala"
					_tmp16_ = i;
#line 195 "../src/applets/user-indicator/UserIndicatorWindow.vala"
					i = _tmp16_ + 1;
#line 1397 "UserIndicatorWindow.c"
				}
#line 195 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp15_ = FALSE;
#line 195 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp17_ = buttons;
#line 195 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp17__length1 = buttons_length1;
#line 195 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				if (!(i < _tmp17__length1)) {
#line 195 "../src/applets/user-indicator/UserIndicatorWindow.vala"
					break;
#line 1409 "UserIndicatorWindow.c"
				}
#line 196 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp18_ = buttons;
#line 196 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp18__length1 = buttons_length1;
#line 196 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp19_ = _tmp18_[0];
#line 196 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp20_ = _g_object_ref0 (_tmp19_);
#line 196 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				button = _tmp20_;
#line 198 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp21_ = button;
#line 198 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				if (_tmp21_ == NULL) {
#line 199 "../src/applets/user-indicator/UserIndicatorWindow.vala"
					_g_object_unref0 (button);
#line 199 "../src/applets/user-indicator/UserIndicatorWindow.vala"
					continue;
#line 1429 "UserIndicatorWindow.c"
				}
#line 202 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp22_ = button;
#line 202 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				g_object_set ((GtkWidget*) _tmp22_, "has-focus", FALSE, NULL);
#line 203 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp23_ = button;
#line 203 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				g_object_set ((GtkWidget*) _tmp23_, "is-focus", FALSE, NULL);
#line 195 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_g_object_unref0 (button);
#line 1441 "UserIndicatorWindow.c"
			}
		}
	}
#line 206 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	GTK_WIDGET_CLASS (user_indicator_window_parent_class)->hide ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, budgie_popover_get_type (), BudgiePopover));
#line 184 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	buttons = (_vala_array_free (buttons, buttons_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1449 "UserIndicatorWindow.c"
}

static gboolean
__lambda4_ (UserIndicatorWindow* self,
            GdkEventButton* e)
{
	gboolean result;
#line 216 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 217 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (e->button != ((guint) 1)) {
#line 218 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		result = GDK_EVENT_PROPAGATE;
#line 218 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return result;
#line 1465 "UserIndicatorWindow.c"
	}
#line 220 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_indicator_window_logout (self);
#line 221 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = GDK_EVENT_STOP;
#line 221 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 1473 "UserIndicatorWindow.c"
}

static gboolean
___lambda4__gtk_widget_button_release_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = __lambda4_ ((UserIndicatorWindow*) self, event);
#line 216 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 1485 "UserIndicatorWindow.c"
}

static GtkRevealer*
user_indicator_window_create_usersection (UserIndicatorWindow* self)
{
	GtkRevealer* user_section = NULL;
	GtkRevealer* _tmp0_;
	GtkBox* user_section_box = NULL;
	GtkBox* _tmp1_;
	gboolean _tmp2_;
	IndicatorItem* _tmp3_;
	IndicatorItem* _tmp4_;
	IndicatorItem* _tmp5_;
	GtkRevealer* result;
#line 209 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 210 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = (GtkRevealer*) gtk_revealer_new ();
#line 210 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 210 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_section = _tmp0_;
#line 211 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 211 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_ref_sink (_tmp1_);
#line 211 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_section_box = _tmp1_;
#line 212 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp2_ = FALSE;
#line 212 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp3_ = indicator_item_new (_ ("Logout"), "system-log-out-symbolic", &_tmp2_);
#line 212 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 212 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->logout_menu);
#line 212 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->logout_menu = _tmp3_;
#line 213 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp4_ = self->priv->logout_menu;
#line 213 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_box_pack_start (user_section_box, (GtkWidget*) _tmp4_, FALSE, FALSE, (guint) 0);
#line 214 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_container_add ((GtkContainer*) user_section, (GtkWidget*) user_section_box);
#line 216 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp5_ = self->priv->logout_menu;
#line 216 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp5_, "button-release-event", (GCallback) ___lambda4__gtk_widget_button_release_event, self, 0);
#line 224 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = user_section;
#line 224 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (user_section_box);
#line 224 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 1540 "UserIndicatorWindow.c"
}

void
user_indicator_window_toggle_usersection (UserIndicatorWindow* self)
{
	GtkRevealer* _tmp0_;
#line 227 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 228 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->user_section;
#line 228 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_tmp0_ != NULL) {
#line 1553 "UserIndicatorWindow.c"
		GtkRevealer* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 229 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp1_ = self->user_section;
#line 229 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp2_ = gtk_revealer_get_child_revealed (_tmp1_);
#line 229 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp3_ = _tmp2_;
#line 229 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (!_tmp3_) {
#line 230 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			user_indicator_window_show_usersection (self);
#line 1567 "UserIndicatorWindow.c"
		} else {
#line 232 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			user_indicator_window_hide_usersection (self);
#line 1571 "UserIndicatorWindow.c"
		}
	}
}

static void
user_indicator_window_show_usersection (UserIndicatorWindow* self)
{
	GtkRevealer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 237 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->user_section;
#line 238 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp1_ = gtk_revealer_get_child_revealed (_tmp0_);
#line 238 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp2_ = _tmp1_;
#line 238 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (!_tmp2_) {
#line 1592 "UserIndicatorWindow.c"
		GtkRevealer* _tmp3_;
		GtkRevealer* _tmp4_;
		IndicatorItem* _tmp5_;
#line 239 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp3_ = self->user_section;
#line 239 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		gtk_revealer_set_transition_type (_tmp3_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 240 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp4_ = self->user_section;
#line 240 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		gtk_revealer_set_reveal_child (_tmp4_, TRUE);
#line 241 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp5_ = self->priv->user_item;
#line 241 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		indicator_item_set_arrow (_tmp5_, "up");
#line 1608 "UserIndicatorWindow.c"
	}
}

static void
user_indicator_window_hide_usersection (UserIndicatorWindow* self)
{
	GtkRevealer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 245 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 246 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->user_section;
#line 246 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp1_ = gtk_revealer_get_child_revealed (_tmp0_);
#line 246 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp2_ = _tmp1_;
#line 246 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_tmp2_) {
#line 1628 "UserIndicatorWindow.c"
		GtkRevealer* _tmp3_;
		GtkRevealer* _tmp4_;
		IndicatorItem* _tmp5_;
#line 247 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp3_ = self->user_section;
#line 247 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		gtk_revealer_set_transition_type (_tmp3_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP);
#line 248 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp4_ = self->user_section;
#line 248 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		gtk_revealer_set_reveal_child (_tmp4_, FALSE);
#line 249 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp5_ = self->priv->user_item;
#line 249 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		indicator_item_set_arrow (_tmp5_, "down");
#line 1644 "UserIndicatorWindow.c"
	}
}

static void
user_indicator_window_update_userinfo (UserIndicatorWindow* self)
{
	gchar* user_image = NULL;
	gchar* _tmp0_;
	gchar* user_name = NULL;
	gchar* _tmp1_;
	IndicatorItem* _tmp2_;
	IndicatorItem* _tmp3_;
#line 254 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = user_indicator_window_get_user_image (self);
#line 255 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_image = _tmp0_;
#line 256 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp1_ = user_indicator_window_get_user_name (self);
#line 256 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_name = _tmp1_;
#line 258 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp2_ = self->priv->user_item;
#line 258 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	indicator_item_set_image (_tmp2_, user_image);
#line 259 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp3_ = self->priv->user_item;
#line 259 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	indicator_item_set_label (_tmp3_, user_name);
#line 254 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_free0 (user_name);
#line 254 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_free0 (user_image);
#line 1679 "UserIndicatorWindow.c"
}

static gchar*
user_indicator_window_get_user_image (UserIndicatorWindow* self)
{
	gchar* image = NULL;
	gchar* _tmp0_;
	PropertiesInterface* _tmp1_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 263 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 264 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = g_strdup (USER_SYMBOLIC_ICON);
#line 264 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	image = _tmp0_;
#line 266 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp1_ = self->priv->current_user_props;
#line 266 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_tmp1_ != NULL) {
#line 1700 "UserIndicatorWindow.c"
		{
			GVariant* _tmp2_ = NULL;
			PropertiesInterface* _tmp3_;
			GVariant* _tmp4_;
			gchar* icon_file = NULL;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			const gchar* _tmp7_ = NULL;
			const gchar* _tmp8_;
			gchar* _tmp11_;
#line 268 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp3_ = self->priv->current_user_props;
#line 268 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp4_ = properties_interface_get (_tmp3_, ACCOUNTSSERVICE_USER, "IconFile", &_inner_error0_);
#line 268 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp2_ = _tmp4_;
#line 268 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1719 "UserIndicatorWindow.c"
				goto __catch0_g_error;
			}
#line 268 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp5_ = g_variant_get_string (_tmp2_, NULL);
#line 268 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp6_ = g_strdup (_tmp5_);
#line 268 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			icon_file = _tmp6_;
#line 269 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp8_ = icon_file;
#line 269 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			if (g_strcmp0 (_tmp8_, "") != 0) {
#line 1732 "UserIndicatorWindow.c"
				const gchar* _tmp9_;
#line 269 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp9_ = icon_file;
#line 269 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp7_ = _tmp9_;
#line 1738 "UserIndicatorWindow.c"
			} else {
				const gchar* _tmp10_;
#line 269 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp10_ = image;
#line 269 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp7_ = _tmp10_;
#line 1745 "UserIndicatorWindow.c"
			}
#line 269 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp11_ = g_strdup (_tmp7_);
#line 269 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_free0 (image);
#line 269 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			image = _tmp11_;
#line 267 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_free0 (icon_file);
#line 267 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_variant_unref0 (_tmp2_);
#line 1757 "UserIndicatorWindow.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp12_;
			const gchar* _tmp13_;
#line 267 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			e = _inner_error0_;
#line 267 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_inner_error0_ = NULL;
#line 271 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp12_ = e;
#line 271 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp13_ = _tmp12_->message;
#line 271 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_warning ("UserIndicatorWindow.vala:271: Failed to fetch IconFile: %s", _tmp13_);
#line 267 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_error_free0 (e);
#line 1777 "UserIndicatorWindow.c"
		}
		__finally0:
#line 267 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 267 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_free0 (image);
#line 267 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 267 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_clear_error (&_inner_error0_);
#line 267 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			return NULL;
#line 1790 "UserIndicatorWindow.c"
		}
	}
#line 275 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = image;
#line 275 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 1797 "UserIndicatorWindow.c"
}

static gchar*
user_indicator_window_get_user_name (UserIndicatorWindow* self)
{
	gchar* user_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	PropertiesInterface* _tmp2_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 279 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 280 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->priv->current_username;
#line 280 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 280 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_name = _tmp1_;
#line 282 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp2_ = self->priv->current_user_props;
#line 282 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_tmp2_ != NULL) {
#line 1821 "UserIndicatorWindow.c"
		{
			GVariant* _tmp3_ = NULL;
			PropertiesInterface* _tmp4_;
			GVariant* _tmp5_;
			gchar* real_name = NULL;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_ = NULL;
			const gchar* _tmp9_;
			gchar* _tmp12_;
#line 284 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp4_ = self->priv->current_user_props;
#line 284 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp5_ = properties_interface_get (_tmp4_, ACCOUNTSSERVICE_USER, "RealName", &_inner_error0_);
#line 284 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp3_ = _tmp5_;
#line 284 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1840 "UserIndicatorWindow.c"
				goto __catch0_g_error;
			}
#line 284 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp6_ = g_variant_get_string (_tmp3_, NULL);
#line 284 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp7_ = g_strdup (_tmp6_);
#line 284 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			real_name = _tmp7_;
#line 285 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp9_ = real_name;
#line 285 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			if (g_strcmp0 (_tmp9_, "") != 0) {
#line 1853 "UserIndicatorWindow.c"
				const gchar* _tmp10_;
#line 285 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp10_ = real_name;
#line 285 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp8_ = _tmp10_;
#line 1859 "UserIndicatorWindow.c"
			} else {
				const gchar* _tmp11_;
#line 285 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp11_ = user_name;
#line 285 "../src/applets/user-indicator/UserIndicatorWindow.vala"
				_tmp8_ = _tmp11_;
#line 1866 "UserIndicatorWindow.c"
			}
#line 285 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp12_ = g_strdup (_tmp8_);
#line 285 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_free0 (user_name);
#line 285 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			user_name = _tmp12_;
#line 283 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_free0 (real_name);
#line 283 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_variant_unref0 (_tmp3_);
#line 1878 "UserIndicatorWindow.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
#line 283 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			e = _inner_error0_;
#line 283 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_inner_error0_ = NULL;
#line 287 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp13_ = e;
#line 287 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp14_ = _tmp13_->message;
#line 287 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_warning ("UserIndicatorWindow.vala:287: Failed to fetch RealName: %s", _tmp14_);
#line 283 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_error_free0 (e);
#line 1898 "UserIndicatorWindow.c"
		}
		__finally0:
#line 283 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 283 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_free0 (user_name);
#line 283 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 283 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_clear_error (&_inner_error0_);
#line 283 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			return NULL;
#line 1911 "UserIndicatorWindow.c"
		}
	}
#line 291 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = user_name;
#line 291 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 1918 "UserIndicatorWindow.c"
}

static gboolean
__lambda5_ (UserIndicatorWindow* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	{
		SessionManager* _tmp0_;
#line 302 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp0_ = self->priv->session;
#line 302 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		session_manager_Logout (_tmp0_, (guint) 0, &_inner_error0_);
#line 302 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1934 "UserIndicatorWindow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 301 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		e = _inner_error0_;
#line 301 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_inner_error0_ = NULL;
#line 304 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp1_ = e;
#line 304 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp2_ = _tmp1_->message;
#line 304 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_warning ("UserIndicatorWindow.vala:304: Failed to logout: %s", _tmp2_);
#line 301 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_error_free0 (e);
#line 1956 "UserIndicatorWindow.c"
	}
	__finally0:
#line 301 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1961 "UserIndicatorWindow.c"
		gboolean _tmp3_ = FALSE;
#line 301 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 301 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_clear_error (&_inner_error0_);
#line 301 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return _tmp3_;
#line 1969 "UserIndicatorWindow.c"
	}
#line 306 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = FALSE;
#line 306 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 1975 "UserIndicatorWindow.c"
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ ((UserIndicatorWindow*) self);
#line 300 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 1985 "UserIndicatorWindow.c"
}

static void
user_indicator_window_logout (UserIndicatorWindow* self)
{
	SessionManager* _tmp0_;
#line 294 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 295 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 296 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->priv->session;
#line 296 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_tmp0_ == NULL) {
#line 297 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return;
#line 2002 "UserIndicatorWindow.c"
	}
#line 300 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 2006 "UserIndicatorWindow.c"
}

static gboolean
__lambda14_ (UserIndicatorWindow* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	{
		LogindInterface* _tmp0_;
#line 318 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		user_indicator_window_lock_screen (self);
#line 319 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp0_ = self->priv->logind_interface;
#line 319 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		logind_interface_hibernate (_tmp0_, FALSE, &_inner_error0_);
#line 319 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2024 "UserIndicatorWindow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 317 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		e = _inner_error0_;
#line 317 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_inner_error0_ = NULL;
#line 321 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp1_ = e;
#line 321 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp2_ = _tmp1_->message;
#line 321 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_warning ("UserIndicatorWindow.vala:321: Cannot hibernate: %s", _tmp2_);
#line 317 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_error_free0 (e);
#line 2046 "UserIndicatorWindow.c"
	}
	__finally0:
#line 317 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2051 "UserIndicatorWindow.c"
		gboolean _tmp3_ = FALSE;
#line 317 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 317 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_clear_error (&_inner_error0_);
#line 317 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return _tmp3_;
#line 2059 "UserIndicatorWindow.c"
	}
#line 323 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = FALSE;
#line 323 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 2065 "UserIndicatorWindow.c"
}

static gboolean
___lambda14__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda14_ ((UserIndicatorWindow*) self);
#line 316 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 2075 "UserIndicatorWindow.c"
}

static void
user_indicator_window_hibernate (UserIndicatorWindow* self)
{
	LogindInterface* _tmp0_;
#line 310 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 312 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->priv->logind_interface;
#line 312 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_tmp0_ == NULL) {
#line 313 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return;
#line 2092 "UserIndicatorWindow.c"
	}
#line 316 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda14__gsource_func, g_object_ref (self), g_object_unref);
#line 2096 "UserIndicatorWindow.c"
}

static gboolean
__lambda12_ (UserIndicatorWindow* self)
{
	SessionManager* _tmp0_;
	gboolean result;
#line 334 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->priv->session;
#line 334 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	session_manager_Reboot (_tmp0_, NULL, NULL);
#line 335 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = FALSE;
#line 335 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 2112 "UserIndicatorWindow.c"
}

static gboolean
___lambda12__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda12_ ((UserIndicatorWindow*) self);
#line 333 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 2122 "UserIndicatorWindow.c"
}

static void
user_indicator_window_reboot (UserIndicatorWindow* self)
{
	SessionManager* _tmp0_;
#line 327 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 328 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 329 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->priv->session;
#line 329 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_tmp0_ == NULL) {
#line 330 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return;
#line 2139 "UserIndicatorWindow.c"
	}
#line 333 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda12__gsource_func, g_object_ref (self), g_object_unref);
#line 2143 "UserIndicatorWindow.c"
}

static gboolean
__lambda16_ (UserIndicatorWindow* self)
{
	SessionManager* _tmp0_;
	gboolean result;
#line 346 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->priv->session;
#line 346 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	session_manager_Shutdown (_tmp0_, NULL, NULL);
#line 347 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = FALSE;
#line 347 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 2159 "UserIndicatorWindow.c"
}

static gboolean
___lambda16__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda16_ ((UserIndicatorWindow*) self);
#line 345 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 2169 "UserIndicatorWindow.c"
}

static void
user_indicator_window_shutdown (UserIndicatorWindow* self)
{
	SessionManager* _tmp0_;
#line 339 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 340 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 341 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->priv->session;
#line 341 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_tmp0_ == NULL) {
#line 342 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return;
#line 2186 "UserIndicatorWindow.c"
	}
#line 345 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda16__gsource_func, g_object_ref (self), g_object_unref);
#line 2190 "UserIndicatorWindow.c"
}

static gboolean
__lambda10_ (UserIndicatorWindow* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	{
		LogindInterface* _tmp0_;
#line 359 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		user_indicator_window_lock_screen (self);
#line 360 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp0_ = self->priv->logind_interface;
#line 360 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		logind_interface_suspend (_tmp0_, FALSE, &_inner_error0_);
#line 360 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2208 "UserIndicatorWindow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 358 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		e = _inner_error0_;
#line 358 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_inner_error0_ = NULL;
#line 362 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp1_ = e;
#line 362 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp2_ = _tmp1_->message;
#line 362 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_warning ("UserIndicatorWindow.vala:362: Cannot suspend: %s", _tmp2_);
#line 358 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_error_free0 (e);
#line 2230 "UserIndicatorWindow.c"
	}
	__finally0:
#line 358 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2235 "UserIndicatorWindow.c"
		gboolean _tmp3_ = FALSE;
#line 358 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 358 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_clear_error (&_inner_error0_);
#line 358 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return _tmp3_;
#line 2243 "UserIndicatorWindow.c"
	}
#line 364 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = FALSE;
#line 364 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 2249 "UserIndicatorWindow.c"
}

static gboolean
___lambda10__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda10_ ((UserIndicatorWindow*) self);
#line 357 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 2259 "UserIndicatorWindow.c"
}

static void
user_indicator_window_suspend (UserIndicatorWindow* self)
{
	LogindInterface* _tmp0_;
#line 351 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 352 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 353 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->priv->logind_interface;
#line 353 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_tmp0_ == NULL) {
#line 354 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return;
#line 2276 "UserIndicatorWindow.c"
	}
#line 357 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda10__gsource_func, g_object_ref (self), g_object_unref);
#line 2280 "UserIndicatorWindow.c"
}

static gboolean
__lambda8_ (UserIndicatorWindow* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	{
		ScreenSaver* _tmp0_;
#line 377 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp0_ = self->priv->saver;
#line 377 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		screen_saver_lock (_tmp0_, &_inner_error0_);
#line 377 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2296 "UserIndicatorWindow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 371 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		e = _inner_error0_;
#line 371 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_inner_error0_ = NULL;
#line 379 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp1_ = e;
#line 379 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp2_ = _tmp1_->message;
#line 379 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_warning ("UserIndicatorWindow.vala:379: Cannot lock screen: %s", _tmp2_);
#line 371 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_error_free0 (e);
#line 2318 "UserIndicatorWindow.c"
	}
	__finally0:
#line 371 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2323 "UserIndicatorWindow.c"
		gboolean _tmp3_ = FALSE;
#line 371 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 371 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_clear_error (&_inner_error0_);
#line 371 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return _tmp3_;
#line 2331 "UserIndicatorWindow.c"
	}
#line 384 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = FALSE;
#line 384 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 2337 "UserIndicatorWindow.c"
}

static gboolean
___lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda8_ ((UserIndicatorWindow*) self);
#line 370 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 2347 "UserIndicatorWindow.c"
}

static void
user_indicator_window_lock_screen (UserIndicatorWindow* self)
{
#line 368 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 369 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 370 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda8__gsource_func, g_object_ref (self), g_object_unref);
#line 2359 "UserIndicatorWindow.c"
}

static void
user_indicator_window_class_init (UserIndicatorWindowClass * klass,
                                  gpointer klass_data)
{
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	user_indicator_window_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_type_class_adjust_private_offset (klass, &UserIndicatorWindow_private_offset);
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	((GtkWidgetClass *) klass)->hide = (void (*) (GtkWidget*)) user_indicator_window_real_hide;
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = user_indicator_window_finalize;
#line 2374 "UserIndicatorWindow.c"
}

static void
user_indicator_window_instance_init (UserIndicatorWindow * self,
                                     gpointer klass)
{
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv = user_indicator_window_get_instance_private (self);
#line 20 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->menu = NULL;
#line 21 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->user_section = NULL;
#line 23 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->saver = NULL;
#line 24 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->session = NULL;
#line 25 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->logind_interface = NULL;
#line 27 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->user_manager = NULL;
#line 28 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->current_user = NULL;
#line 29 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->current_username = NULL;
#line 30 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->current_user_props = NULL;
#line 32 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->user_item = NULL;
#line 33 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->lock_menu = NULL;
#line 34 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->suspend_menu = NULL;
#line 35 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->hibernate_menu = NULL;
#line 36 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->reboot_menu = NULL;
#line 37 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->shutdown_menu = NULL;
#line 38 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->logout_menu = NULL;
#line 2415 "UserIndicatorWindow.c"
}

static void
user_indicator_window_finalize (GObject * obj)
{
	UserIndicatorWindow * self;
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_INDICATOR_WINDOW, UserIndicatorWindow);
#line 20 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->menu);
#line 21 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->user_section);
#line 23 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->saver);
#line 24 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->session);
#line 25 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->logind_interface);
#line 27 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->user_manager);
#line 28 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->current_user);
#line 29 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_free0 (self->priv->current_username);
#line 30 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->current_user_props);
#line 32 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->user_item);
#line 33 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->lock_menu);
#line 34 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->suspend_menu);
#line 35 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->hibernate_menu);
#line 36 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->reboot_menu);
#line 37 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->shutdown_menu);
#line 38 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->logout_menu);
#line 19 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	G_OBJECT_CLASS (user_indicator_window_parent_class)->finalize (obj);
#line 2458 "UserIndicatorWindow.c"
}

GType
user_indicator_window_get_type (void)
{
	return user_indicator_window_type_id;
}

GType
user_indicator_window_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (UserIndicatorWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_indicator_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserIndicatorWindow), 0, (GInstanceInitFunc) user_indicator_window_instance_init, NULL };
	user_indicator_window_type_id = g_type_module_register_type (module, budgie_popover_get_type (), "UserIndicatorWindow", &g_define_type_info, 0);
	UserIndicatorWindow_private_offset = sizeof (UserIndicatorWindowPrivate);
	return user_indicator_window_type_id;
}

static inline gpointer
indicator_item_get_instance_private (IndicatorItem* self)
{
	return G_STRUCT_MEMBER_P (self, IndicatorItem_private_offset);
}

IndicatorItem*
indicator_item_construct (GType object_type,
                          const gchar* label_string,
                          const gchar* image_source,
                          gboolean* add_arrow)
{
	IndicatorItem * self = NULL;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkImage* _tmp2_;
	GtkBox* _tmp3_;
	GtkLabel* _tmp4_;
	GtkBox* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkStyleContext* _tmp11_;
#line 414 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (label_string != NULL, NULL);
#line 414 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (image_source != NULL, NULL);
#line 414 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self = (IndicatorItem*) g_object_new (object_type, NULL);
#line 415 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 10);
#line 415 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 415 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->menu_item);
#line 415 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->menu_item = _tmp0_;
#line 417 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	indicator_item_set_image (self, image_source);
#line 418 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	indicator_item_set_label (self, label_string);
#line 419 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, FALSE);
#line 421 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp1_ = self->priv->menu_item;
#line 421 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp2_ = self->priv->button_image;
#line 421 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_box_pack_start (_tmp1_, (GtkWidget*) _tmp2_, FALSE, FALSE, (guint) 0);
#line 422 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp3_ = self->priv->menu_item;
#line 422 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp4_ = self->priv->button_label;
#line 422 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_box_pack_start (_tmp3_, (GtkWidget*) _tmp4_, FALSE, FALSE, (guint) 0);
#line 424 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (*add_arrow) {
#line 2532 "UserIndicatorWindow.c"
		GtkImage* _tmp5_;
		GtkBox* _tmp6_;
		GtkImage* _tmp7_;
#line 425 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("pan-down-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 425 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_object_ref_sink (_tmp5_);
#line 425 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_object_unref0 (self->priv->arrow);
#line 425 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		self->priv->arrow = _tmp5_;
#line 426 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp6_ = self->priv->menu_item;
#line 426 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp7_ = self->priv->arrow;
#line 426 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		gtk_box_pack_end (_tmp6_, (GtkWidget*) _tmp7_, FALSE, FALSE, (guint) 0);
#line 2550 "UserIndicatorWindow.c"
	}
#line 429 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp8_ = self->priv->menu_item;
#line 429 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp8_);
#line 430 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 430 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_style_context_add_class (_tmp9_, "indicator-item");
#line 431 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 431 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_style_context_add_class (_tmp10_, "flat");
#line 432 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 432 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_style_context_add_class (_tmp11_, "menuitem");
#line 414 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return self;
#line 2570 "UserIndicatorWindow.c"
}

IndicatorItem*
indicator_item_new (const gchar* label_string,
                    const gchar* image_source,
                    gboolean* add_arrow)
{
#line 414 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return indicator_item_construct (TYPE_INDICATOR_ITEM, label_string, image_source, add_arrow);
#line 2580 "UserIndicatorWindow.c"
}

void
indicator_item_set_arrow (IndicatorItem* self,
                          const gchar* direction)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 435 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 435 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (direction != NULL);
#line 436 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->priv->arrow;
#line 436 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_tmp0_ == NULL) {
#line 437 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		return;
#line 2603 "UserIndicatorWindow.c"
	}
#line 440 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp1_ = self->priv->arrow;
#line 440 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp2_ = g_strconcat ("pan-", direction, NULL);
#line 440 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp3_ = _tmp2_;
#line 440 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp4_ = g_strconcat (_tmp3_, "-symbolic", NULL);
#line 440 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp5_ = _tmp4_;
#line 440 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	gtk_image_set_from_icon_name (_tmp1_, _tmp5_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 440 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_free0 (_tmp5_);
#line 440 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_free0 (_tmp3_);
#line 2621 "UserIndicatorWindow.c"
}

void
indicator_item_set_image (IndicatorItem* self,
                          const gchar* source)
{
	GdkPixbuf* pixbuf = NULL;
	gboolean has_slash_prefix = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean is_user_image = FALSE;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GtkImage* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 443 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 443 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (source != NULL);
#line 444 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	pixbuf = NULL;
#line 445 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	has_slash_prefix = g_str_has_prefix (source, "/");
#line 446 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (has_slash_prefix) {
#line 446 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp0_ = !g_str_has_suffix (source, ".face");
#line 2648 "UserIndicatorWindow.c"
	} else {
#line 446 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp0_ = FALSE;
#line 2652 "UserIndicatorWindow.c"
	}
#line 446 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	is_user_image = _tmp0_;
#line 448 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (has_slash_prefix) {
#line 448 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp2_ = !is_user_image;
#line 2660 "UserIndicatorWindow.c"
	} else {
#line 448 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp2_ = FALSE;
#line 2664 "UserIndicatorWindow.c"
	}
#line 448 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_tmp2_) {
#line 448 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp1_ = USER_SYMBOLIC_ICON;
#line 2670 "UserIndicatorWindow.c"
	} else {
#line 448 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp1_ = source;
#line 2674 "UserIndicatorWindow.c"
	}
#line 448 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	source = _tmp1_;
#line 450 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp3_ = self->priv->button_image;
#line 450 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_tmp3_ == NULL) {
#line 2682 "UserIndicatorWindow.c"
		GtkImage* _tmp4_;
#line 451 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp4_ = (GtkImage*) gtk_image_new ();
#line 451 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_object_ref_sink (_tmp4_);
#line 451 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_object_unref0 (self->priv->button_image);
#line 451 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		self->priv->button_image = _tmp4_;
#line 2692 "UserIndicatorWindow.c"
	}
#line 454 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (is_user_image) {
#line 2696 "UserIndicatorWindow.c"
		{
			GdkPixbuf* _tmp5_ = NULL;
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
			GtkImage* _tmp8_;
			GdkPixbuf* _tmp9_;
#line 456 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp6_ = gdk_pixbuf_new_from_file_at_size (source, 24, 24, &_inner_error0_);
#line 456 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp5_ = _tmp6_;
#line 456 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2709 "UserIndicatorWindow.c"
				goto __catch0_g_error;
			}
#line 456 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp7_ = _tmp5_;
#line 456 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp5_ = NULL;
#line 456 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_object_unref0 (pixbuf);
#line 456 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			pixbuf = _tmp7_;
#line 457 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp8_ = self->priv->button_image;
#line 457 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp9_ = pixbuf;
#line 457 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			gtk_image_set_from_pixbuf (_tmp8_, _tmp9_);
#line 455 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_object_unref0 (_tmp5_);
#line 2728 "UserIndicatorWindow.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp10_;
			const gchar* _tmp11_;
#line 455 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			e = _inner_error0_;
#line 455 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_inner_error0_ = NULL;
#line 459 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp10_ = e;
#line 459 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_tmp11_ = _tmp10_->message;
#line 459 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_message ("UserIndicatorWindow.vala:459: File does not exist: %s", _tmp11_);
#line 455 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_error_free0 (e);
#line 2748 "UserIndicatorWindow.c"
		}
		__finally0:
#line 455 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 455 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			_g_object_unref0 (pixbuf);
#line 455 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 455 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			g_clear_error (&_inner_error0_);
#line 455 "../src/applets/user-indicator/UserIndicatorWindow.vala"
			return;
#line 2761 "UserIndicatorWindow.c"
		}
	} else {
		GtkImage* _tmp12_;
#line 462 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp12_ = self->priv->button_image;
#line 462 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		gtk_image_set_from_icon_name (_tmp12_, source, (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 2769 "UserIndicatorWindow.c"
	}
#line 443 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (pixbuf);
#line 2773 "UserIndicatorWindow.c"
}

void
indicator_item_set_label (IndicatorItem* self,
                          const gchar* text)
{
	GtkLabel* _tmp0_;
#line 466 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 466 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (text != NULL);
#line 467 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->priv->button_label;
#line 467 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	if (_tmp0_ == NULL) {
#line 2789 "UserIndicatorWindow.c"
		GtkLabel* _tmp1_;
		GtkLabel* _tmp2_;
#line 468 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp1_ = (GtkLabel*) gtk_label_new (text);
#line 468 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_object_ref_sink (_tmp1_);
#line 468 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_g_object_unref0 (self->priv->button_label);
#line 468 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		self->priv->button_label = _tmp1_;
#line 469 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp2_ = self->priv->button_label;
#line 469 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		gtk_label_set_use_markup (_tmp2_, TRUE);
#line 2804 "UserIndicatorWindow.c"
	} else {
		GtkLabel* _tmp3_;
#line 471 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		_tmp3_ = self->priv->button_label;
#line 471 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		gtk_label_set_label (_tmp3_, text);
#line 2811 "UserIndicatorWindow.c"
	}
}

const gchar*
indicator_item_get_image_source (IndicatorItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 398 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 398 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->priv->_image_source;
#line 398 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = _tmp0_;
#line 398 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 2828 "UserIndicatorWindow.c"
}

void
indicator_item_set_image_source (IndicatorItem* self,
                                 const gchar* value)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 399 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 400 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = indicator_item_get_image_source (self);
#line 400 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp1_ = _tmp0_;
#line 400 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 400 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_free0 (self->priv->_image_source);
#line 400 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->_image_source = _tmp2_;
#line 401 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp3_ = indicator_item_get_image_source (self);
#line 401 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp4_ = _tmp3_;
#line 401 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	indicator_item_set_image (self, _tmp4_);
#line 399 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, indicator_item_properties[INDICATOR_ITEM_IMAGE_SOURCE_PROPERTY]);
#line 2860 "UserIndicatorWindow.c"
}

const gchar*
indicator_item_get_label_text (IndicatorItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 407 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 407 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = self->priv->_label_text;
#line 407 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	result = _tmp0_;
#line 407 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	return result;
#line 2876 "UserIndicatorWindow.c"
}

void
indicator_item_set_label_text (IndicatorItem* self,
                               const gchar* value)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 408 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_return_if_fail (self != NULL);
#line 409 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp0_ = indicator_item_get_label_text (self);
#line 409 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp1_ = _tmp0_;
#line 409 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 409 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_free0 (self->priv->_label_text);
#line 409 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->_label_text = _tmp2_;
#line 410 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp3_ = indicator_item_get_label_text (self);
#line 410 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_tmp4_ = _tmp3_;
#line 410 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	indicator_item_set_label (self, _tmp4_);
#line 408 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, indicator_item_properties[INDICATOR_ITEM_LABEL_TEXT_PROPERTY]);
#line 2908 "UserIndicatorWindow.c"
}

static void
indicator_item_class_init (IndicatorItemClass * klass,
                           gpointer klass_data)
{
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	indicator_item_parent_class = g_type_class_peek_parent (klass);
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_type_class_adjust_private_offset (klass, &IndicatorItem_private_offset);
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_indicator_item_get_property;
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_indicator_item_set_property;
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = indicator_item_finalize;
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ITEM_IMAGE_SOURCE_PROPERTY, indicator_item_properties[INDICATOR_ITEM_IMAGE_SOURCE_PROPERTY] = g_param_spec_string ("image-source", "image-source", "image-source", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INDICATOR_ITEM_LABEL_TEXT_PROPERTY, indicator_item_properties[INDICATOR_ITEM_LABEL_TEXT_PROPERTY] = g_param_spec_string ("label-text", "label-text", "label-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2929 "UserIndicatorWindow.c"
}

static void
indicator_item_instance_init (IndicatorItem * self,
                              gpointer klass)
{
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv = indicator_item_get_instance_private (self);
#line 391 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->menu_item = NULL;
#line 392 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->arrow = NULL;
#line 393 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->button_image = NULL;
#line 394 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->button_label = NULL;
#line 396 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->_image_source = NULL;
#line 405 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self->priv->_label_text = NULL;
#line 2950 "UserIndicatorWindow.c"
}

static void
indicator_item_finalize (GObject * obj)
{
	IndicatorItem * self;
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INDICATOR_ITEM, IndicatorItem);
#line 391 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->menu_item);
#line 392 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->arrow);
#line 393 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->button_image);
#line 394 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_object_unref0 (self->priv->button_label);
#line 396 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_free0 (self->priv->_image_source);
#line 405 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	_g_free0 (self->priv->_label_text);
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	G_OBJECT_CLASS (indicator_item_parent_class)->finalize (obj);
#line 2973 "UserIndicatorWindow.c"
}

GType
indicator_item_get_type (void)
{
	return indicator_item_type_id;
}

GType
indicator_item_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (IndicatorItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) indicator_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IndicatorItem), 0, (GInstanceInitFunc) indicator_item_instance_init, NULL };
	indicator_item_type_id = g_type_module_register_type (module, gtk_button_get_type (), "IndicatorItem", &g_define_type_info, 0);
	IndicatorItem_private_offset = sizeof (IndicatorItemPrivate);
	return indicator_item_type_id;
}

static void
_vala_indicator_item_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	IndicatorItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_INDICATOR_ITEM, IndicatorItem);
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	switch (property_id) {
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		case INDICATOR_ITEM_IMAGE_SOURCE_PROPERTY:
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_value_set_string (value, indicator_item_get_image_source (self));
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		break;
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		case INDICATOR_ITEM_LABEL_TEXT_PROPERTY:
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		g_value_set_string (value, indicator_item_get_label_text (self));
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		break;
#line 3013 "UserIndicatorWindow.c"
		default:
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		break;
#line 3019 "UserIndicatorWindow.c"
	}
}

static void
_vala_indicator_item_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	IndicatorItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_INDICATOR_ITEM, IndicatorItem);
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
	switch (property_id) {
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		case INDICATOR_ITEM_IMAGE_SOURCE_PROPERTY:
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		indicator_item_set_image_source (self, g_value_get_string (value));
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		break;
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		case INDICATOR_ITEM_LABEL_TEXT_PROPERTY:
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		indicator_item_set_label_text (self, g_value_get_string (value));
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		break;
#line 3045 "UserIndicatorWindow.c"
		default:
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 390 "../src/applets/user-indicator/UserIndicatorWindow.vala"
		break;
#line 3051 "UserIndicatorWindow.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

