/* notification.c generated by valac 0.56.3, the Vala compiler
 * generated from notification.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2018-2022 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "budgie-private.h"
#include <gio/gdesktopappinfo.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>

enum  {
	BUDGIE_NOTIFICATION_0_PROPERTY,
	BUDGIE_NOTIFICATION_APP_INFO_PROPERTY,
	BUDGIE_NOTIFICATION_APP_ID_PROPERTY,
	BUDGIE_NOTIFICATION_URGENCY_PROPERTY,
	BUDGIE_NOTIFICATION_ID_PROPERTY,
	BUDGIE_NOTIFICATION_APP_NAME_PROPERTY,
	BUDGIE_NOTIFICATION_HINTS_PROPERTY,
	BUDGIE_NOTIFICATION_ACTIONS_PROPERTY,
	BUDGIE_NOTIFICATION_APP_ICON_PROPERTY,
	BUDGIE_NOTIFICATION_BODY_PROPERTY,
	BUDGIE_NOTIFICATION_SUMMARY_PROPERTY,
	BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY,
	BUDGIE_NOTIFICATION_CATEGORY_PROPERTY,
	BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY,
	BUDGIE_NOTIFICATION_IMAGE_PROPERTY,
	BUDGIE_NOTIFICATION_NUM_PROPERTIES
};
static GParamSpec* budgie_notification_properties[BUDGIE_NOTIFICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _BudgieNotificationPrivate {
	GDesktopAppInfo* _app_info;
	gchar* _app_id;
	BudgieNotificationUrgency _urgency;
	guint32 _id;
	gchar* _app_name;
	GHashTable* _hints;
	gchar** _actions;
	gint _actions_length1;
	gint __actions_size_;
	gchar* _app_icon;
	gchar* _body;
	gchar* _summary;
	guint _expire_timeout;
	gchar* _category;
	gint64 _timestamp;
	GtkImage* _image;
};

static gint BudgieNotification_private_offset;
static gpointer budgie_notification_parent_class = NULL;
static GRegex* budgie_notification_entity_regex;
static GRegex* budgie_notification_entity_regex = NULL;
static GRegex* budgie_notification_tag_regex;
static GRegex* budgie_notification_tag_regex = NULL;

static GdkPixbuf* budgie_notification_decode_image (BudgieNotification* self,
                                             GVariant* img);
static gchar* budgie_notification_fix_markup (BudgieNotification* self,
                                       const gchar* markup);
static void budgie_notification_set_app_info (BudgieNotification* self,
                                       GDesktopAppInfo* value);
static void budgie_notification_set_app_id (BudgieNotification* self,
                                     const gchar* value);
static void budgie_notification_set_urgency (BudgieNotification* self,
                                      BudgieNotificationUrgency value);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static GObject * budgie_notification_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void budgie_notification_finalize (GObject * obj);
static GType budgie_notification_get_type_once (void);
static void _vala_budgie_notification_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_budgie_notification_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

/**
 * Enumeration of why a notification was closed.
 */
static GType
budgie_notification_close_reason_get_type_once (void)
{
	static const GEnumValue values[] = {{BUDGIE_NOTIFICATION_CLOSE_REASON_EXPIRED, "BUDGIE_NOTIFICATION_CLOSE_REASON_EXPIRED", "expired"}, {BUDGIE_NOTIFICATION_CLOSE_REASON_DISMISSED, "BUDGIE_NOTIFICATION_CLOSE_REASON_DISMISSED", "dismissed"}, {BUDGIE_NOTIFICATION_CLOSE_REASON_CLOSED, "BUDGIE_NOTIFICATION_CLOSE_REASON_CLOSED", "closed"}, {BUDGIE_NOTIFICATION_CLOSE_REASON_UNDEFINED, "BUDGIE_NOTIFICATION_CLOSE_REASON_UNDEFINED", "undefined"}, {0, NULL, NULL}};
	GType budgie_notification_close_reason_type_id;
	budgie_notification_close_reason_type_id = g_enum_register_static ("BudgieNotificationCloseReason", values);
	return budgie_notification_close_reason_type_id;
}

GType
budgie_notification_close_reason_get_type (void)
{
	static volatile gsize budgie_notification_close_reason_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_close_reason_type_id__once)) {
		GType budgie_notification_close_reason_type_id;
		budgie_notification_close_reason_type_id = budgie_notification_close_reason_get_type_once ();
		g_once_init_leave (&budgie_notification_close_reason_type_id__once, budgie_notification_close_reason_type_id);
	}
	return budgie_notification_close_reason_type_id__once;
}

/**
 * Enumeration of where notification popups will be shown.
 */
static GType
budgie_notification_position_get_type_once (void)
{
	static const GEnumValue values[] = {{BUDGIE_NOTIFICATION_POSITION_TOP_LEFT, "BUDGIE_NOTIFICATION_POSITION_TOP_LEFT", "top-left"}, {BUDGIE_NOTIFICATION_POSITION_TOP_RIGHT, "BUDGIE_NOTIFICATION_POSITION_TOP_RIGHT", "top-right"}, {BUDGIE_NOTIFICATION_POSITION_BOTTOM_LEFT, "BUDGIE_NOTIFICATION_POSITION_BOTTOM_LEFT", "bottom-left"}, {BUDGIE_NOTIFICATION_POSITION_BOTTOM_RIGHT, "BUDGIE_NOTIFICATION_POSITION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
	GType budgie_notification_position_type_id;
	budgie_notification_position_type_id = g_enum_register_static ("BudgieNotificationPosition", values);
	return budgie_notification_position_type_id;
}

GType
budgie_notification_position_get_type (void)
{
	static volatile gsize budgie_notification_position_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_position_type_id__once)) {
		GType budgie_notification_position_type_id;
		budgie_notification_position_type_id = budgie_notification_position_get_type_once ();
		g_once_init_leave (&budgie_notification_position_type_id__once, budgie_notification_position_type_id);
	}
	return budgie_notification_position_type_id__once;
}

/**
 * Enumeration of notification priorities.
 */
static GType
budgie_notification_urgency_get_type_once (void)
{
	static const GEnumValue values[] = {{BUDGIE_NOTIFICATION_URGENCY_LOW, "BUDGIE_NOTIFICATION_URGENCY_LOW", "low"}, {BUDGIE_NOTIFICATION_URGENCY_NORMAL, "BUDGIE_NOTIFICATION_URGENCY_NORMAL", "normal"}, {BUDGIE_NOTIFICATION_URGENCY_CRITICAL, "BUDGIE_NOTIFICATION_URGENCY_CRITICAL", "critical"}, {0, NULL, NULL}};
	GType budgie_notification_urgency_type_id;
	budgie_notification_urgency_type_id = g_enum_register_static ("BudgieNotificationUrgency", values);
	return budgie_notification_urgency_type_id;
}

GType
budgie_notification_urgency_get_type (void)
{
	static volatile gsize budgie_notification_urgency_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_urgency_type_id__once)) {
		GType budgie_notification_urgency_type_id;
		budgie_notification_urgency_type_id = budgie_notification_urgency_get_type_once ();
		g_once_init_leave (&budgie_notification_urgency_type_id__once, budgie_notification_urgency_type_id);
	}
	return budgie_notification_urgency_type_id__once;
}

static inline gpointer
budgie_notification_get_instance_private (BudgieNotification* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieNotification_private_offset);
}

BudgieNotification*
budgie_notification_construct (GType object_type,
                               guint32 id,
                               const gchar* app_name,
                               const gchar* app_icon,
                               const gchar* summary,
                               const gchar* body,
                               gchar** actions,
                               gint actions_length1,
                               GHashTable* hints,
                               guint expire_timeout)
{
	BudgieNotification * self = NULL;
#line 75 "../src/lib/notification.vala"
	g_return_val_if_fail (app_name != NULL, NULL);
#line 75 "../src/lib/notification.vala"
	g_return_val_if_fail (app_icon != NULL, NULL);
#line 75 "../src/lib/notification.vala"
	g_return_val_if_fail (summary != NULL, NULL);
#line 75 "../src/lib/notification.vala"
	g_return_val_if_fail (body != NULL, NULL);
#line 75 "../src/lib/notification.vala"
	g_return_val_if_fail (hints != NULL, NULL);
#line 85 "../src/lib/notification.vala"
	self = (BudgieNotification*) g_object_new (object_type, "id", id, "app-name", app_name, "app-icon", app_icon, "summary", summary, "body", body, "actions", actions, "hints", hints, "expire-timeout", expire_timeout, NULL);
#line 75 "../src/lib/notification.vala"
	return self;
#line 217 "notification.c"
}

BudgieNotification*
budgie_notification_new (guint32 id,
                         const gchar* app_name,
                         const gchar* app_icon,
                         const gchar* summary,
                         const gchar* body,
                         gchar** actions,
                         gint actions_length1,
                         GHashTable* hints,
                         guint expire_timeout)
{
#line 75 "../src/lib/notification.vala"
	return budgie_notification_construct (BUDGIE_TYPE_NOTIFICATION, id, app_name, app_icon, summary, body, actions, actions_length1, hints, expire_timeout);
#line 233 "notification.c"
}

static GdkPixbuf*
budgie_notification_decode_image (BudgieNotification* self,
                                  GVariant* img)
{
	gint width = 0;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	gint _tmp2_;
	gint height = 0;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	gint _tmp5_;
	gint rowstride = 0;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	gint _tmp8_;
	gboolean has_alpha = FALSE;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	gboolean _tmp11_;
	gint bits_per_sample = 0;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	gint _tmp14_;
	guint8* raw = NULL;
	GVariant* _tmp15_;
	GVariant* _tmp16_;
	void* _tmp17_;
	guint8* _tmp18_;
	gint _tmp18__length1;
	gint raw_length1;
	gint _raw_size_;
	GdkPixbuf* pixbuf = NULL;
	guint8* _tmp19_;
	gint _tmp19__length1;
	GdkPixbuf* _tmp20_;
	GdkPixbuf* _tmp23_;
	GdkPixbuf* _tmp24_;
	GdkPixbuf* result;
#line 208 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "../src/lib/notification.vala"
	g_return_val_if_fail (img != NULL, NULL);
#line 210 "../src/lib/notification.vala"
	_tmp0_ = g_variant_get_child_value (img, (gsize) 0);
#line 210 "../src/lib/notification.vala"
	_tmp1_ = _tmp0_;
#line 210 "../src/lib/notification.vala"
	_tmp2_ = (gint) g_variant_get_int32 (_tmp1_);
#line 210 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp1_);
#line 210 "../src/lib/notification.vala"
	width = _tmp2_;
#line 211 "../src/lib/notification.vala"
	_tmp3_ = g_variant_get_child_value (img, (gsize) 1);
#line 211 "../src/lib/notification.vala"
	_tmp4_ = _tmp3_;
#line 211 "../src/lib/notification.vala"
	_tmp5_ = (gint) g_variant_get_int32 (_tmp4_);
#line 211 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp4_);
#line 211 "../src/lib/notification.vala"
	height = _tmp5_;
#line 212 "../src/lib/notification.vala"
	_tmp6_ = g_variant_get_child_value (img, (gsize) 2);
#line 212 "../src/lib/notification.vala"
	_tmp7_ = _tmp6_;
#line 212 "../src/lib/notification.vala"
	_tmp8_ = (gint) g_variant_get_int32 (_tmp7_);
#line 212 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp7_);
#line 212 "../src/lib/notification.vala"
	rowstride = _tmp8_;
#line 213 "../src/lib/notification.vala"
	_tmp9_ = g_variant_get_child_value (img, (gsize) 3);
#line 213 "../src/lib/notification.vala"
	_tmp10_ = _tmp9_;
#line 213 "../src/lib/notification.vala"
	_tmp11_ = g_variant_get_boolean (_tmp10_);
#line 213 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp10_);
#line 213 "../src/lib/notification.vala"
	has_alpha = _tmp11_;
#line 214 "../src/lib/notification.vala"
	_tmp12_ = g_variant_get_child_value (img, (gsize) 4);
#line 214 "../src/lib/notification.vala"
	_tmp13_ = _tmp12_;
#line 214 "../src/lib/notification.vala"
	_tmp14_ = (gint) g_variant_get_int32 (_tmp13_);
#line 214 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp13_);
#line 214 "../src/lib/notification.vala"
	bits_per_sample = _tmp14_;
#line 216 "../src/lib/notification.vala"
	_tmp15_ = g_variant_get_child_value (img, (gsize) 6);
#line 216 "../src/lib/notification.vala"
	_tmp16_ = _tmp15_;
#line 216 "../src/lib/notification.vala"
	_tmp17_ = g_variant_get_data (_tmp16_);
#line 216 "../src/lib/notification.vala"
	_tmp18_ = (guint8*) _tmp17_;
#line 216 "../src/lib/notification.vala"
	_tmp18__length1 = -1;
#line 216 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp16_);
#line 216 "../src/lib/notification.vala"
	raw = _tmp18_;
#line 216 "../src/lib/notification.vala"
	raw_length1 = _tmp18__length1;
#line 216 "../src/lib/notification.vala"
	_raw_size_ = raw_length1;
#line 219 "../src/lib/notification.vala"
	_tmp19_ = raw;
#line 219 "../src/lib/notification.vala"
	_tmp19__length1 = raw_length1;
#line 219 "../src/lib/notification.vala"
	_tmp20_ = gdk_pixbuf_new_from_data (_tmp19_, GDK_COLORSPACE_RGB, has_alpha, bits_per_sample, width, height, rowstride, (GdkPixbufDestroyNotify) NULL, NULL);
#line 219 "../src/lib/notification.vala"
	pixbuf = _tmp20_;
#line 230 "../src/lib/notification.vala"
	if (height != 48) {
#line 357 "notification.c"
		GdkPixbuf* _tmp21_;
		GdkPixbuf* _tmp22_;
#line 231 "../src/lib/notification.vala"
		_tmp21_ = pixbuf;
#line 231 "../src/lib/notification.vala"
		_tmp22_ = gdk_pixbuf_scale_simple (_tmp21_, 48, 48, GDK_INTERP_BILINEAR);
#line 231 "../src/lib/notification.vala"
		_g_object_unref0 (pixbuf);
#line 231 "../src/lib/notification.vala"
		pixbuf = _tmp22_;
#line 368 "notification.c"
	}
#line 234 "../src/lib/notification.vala"
	_tmp23_ = pixbuf;
#line 234 "../src/lib/notification.vala"
	_tmp24_ = gdk_pixbuf_copy (_tmp23_);
#line 234 "../src/lib/notification.vala"
	result = _tmp24_;
#line 234 "../src/lib/notification.vala"
	_g_object_unref0 (pixbuf);
#line 234 "../src/lib/notification.vala"
	return result;
#line 380 "notification.c"
}

/**
 * Taken from gnome-shell. Notification markup is always a mess, and this is cleaner
 * than our previous solution.
 */
static gchar*
budgie_notification_fix_markup (BudgieNotification* self,
                                const gchar* markup)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 241 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 241 "../src/lib/notification.vala"
	g_return_val_if_fail (markup != NULL, NULL);
#line 242 "../src/lib/notification.vala"
	_tmp0_ = g_strdup (markup);
#line 242 "../src/lib/notification.vala"
	text = _tmp0_;
#line 403 "notification.c"
	{
		gchar* _tmp1_ = NULL;
		GRegex* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 245 "../src/lib/notification.vala"
		_tmp2_ = budgie_notification_entity_regex;
#line 245 "../src/lib/notification.vala"
		_tmp3_ = strlen (markup);
#line 245 "../src/lib/notification.vala"
		_tmp4_ = _tmp3_;
#line 245 "../src/lib/notification.vala"
		_tmp5_ = g_regex_replace (_tmp2_, markup, (gssize) _tmp4_, 0, "&amp;", 0, &_inner_error0_);
#line 245 "../src/lib/notification.vala"
		_tmp1_ = _tmp5_;
#line 245 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 431 "notification.c"
			goto __catch0_g_error;
		}
#line 245 "../src/lib/notification.vala"
		_tmp6_ = _tmp1_;
#line 245 "../src/lib/notification.vala"
		_tmp1_ = NULL;
#line 245 "../src/lib/notification.vala"
		_g_free0 (text);
#line 245 "../src/lib/notification.vala"
		text = _tmp6_;
#line 246 "../src/lib/notification.vala"
		_tmp8_ = budgie_notification_tag_regex;
#line 246 "../src/lib/notification.vala"
		_tmp9_ = text;
#line 246 "../src/lib/notification.vala"
		_tmp10_ = text;
#line 246 "../src/lib/notification.vala"
		_tmp11_ = strlen (_tmp10_);
#line 246 "../src/lib/notification.vala"
		_tmp12_ = _tmp11_;
#line 246 "../src/lib/notification.vala"
		_tmp13_ = g_regex_replace (_tmp8_, _tmp9_, (gssize) _tmp12_, 0, "&lt;", 0, &_inner_error0_);
#line 246 "../src/lib/notification.vala"
		_tmp7_ = _tmp13_;
#line 246 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 246 "../src/lib/notification.vala"
			_g_free0 (_tmp1_);
#line 460 "notification.c"
			goto __catch0_g_error;
		}
#line 246 "../src/lib/notification.vala"
		_tmp14_ = _tmp7_;
#line 246 "../src/lib/notification.vala"
		_tmp7_ = NULL;
#line 246 "../src/lib/notification.vala"
		_g_free0 (text);
#line 246 "../src/lib/notification.vala"
		text = _tmp14_;
#line 244 "../src/lib/notification.vala"
		_g_free0 (_tmp7_);
#line 244 "../src/lib/notification.vala"
		_g_free0 (_tmp1_);
#line 475 "notification.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 244 "../src/lib/notification.vala"
		e = _inner_error0_;
#line 244 "../src/lib/notification.vala"
		_inner_error0_ = NULL;
#line 248 "../src/lib/notification.vala"
		_tmp15_ = e;
#line 248 "../src/lib/notification.vala"
		_tmp16_ = _tmp15_->message;
#line 248 "../src/lib/notification.vala"
		g_warning ("notification.vala:248: Invalid regex: %s", _tmp16_);
#line 244 "../src/lib/notification.vala"
		_g_error_free0 (e);
#line 495 "notification.c"
	}
	__finally0:
#line 244 "../src/lib/notification.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 244 "../src/lib/notification.vala"
		_g_free0 (text);
#line 244 "../src/lib/notification.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 244 "../src/lib/notification.vala"
		g_clear_error (&_inner_error0_);
#line 244 "../src/lib/notification.vala"
		return NULL;
#line 508 "notification.c"
	}
#line 251 "../src/lib/notification.vala"
	result = text;
#line 251 "../src/lib/notification.vala"
	return result;
#line 514 "notification.c"
}

GDesktopAppInfo*
budgie_notification_get_app_info (BudgieNotification* self)
{
	GDesktopAppInfo* result;
	GDesktopAppInfo* _tmp0_;
#line 51 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_info;
#line 51 "../src/lib/notification.vala"
	result = _tmp0_;
#line 51 "../src/lib/notification.vala"
	return result;
#line 530 "notification.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 51 "../src/lib/notification.vala"
	return self ? g_object_ref (self) : NULL;
#line 538 "notification.c"
}

static void
budgie_notification_set_app_info (BudgieNotification* self,
                                  GDesktopAppInfo* value)
{
	GDesktopAppInfo* old_value;
#line 51 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_info (self);
#line 51 "../src/lib/notification.vala"
	if (old_value != value) {
#line 552 "notification.c"
		GDesktopAppInfo* _tmp0_;
#line 51 "../src/lib/notification.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 51 "../src/lib/notification.vala"
		_g_object_unref0 (self->priv->_app_info);
#line 51 "../src/lib/notification.vala"
		self->priv->_app_info = _tmp0_;
#line 51 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_INFO_PROPERTY]);
#line 562 "notification.c"
	}
}

const gchar*
budgie_notification_get_app_id (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 52 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_id;
#line 52 "../src/lib/notification.vala"
	result = _tmp0_;
#line 52 "../src/lib/notification.vala"
	return result;
#line 579 "notification.c"
}

static void
budgie_notification_set_app_id (BudgieNotification* self,
                                const gchar* value)
{
	gchar* old_value;
#line 52 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_id (self);
#line 52 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 593 "notification.c"
		gchar* _tmp0_;
#line 52 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 52 "../src/lib/notification.vala"
		_g_free0 (self->priv->_app_id);
#line 52 "../src/lib/notification.vala"
		self->priv->_app_id = _tmp0_;
#line 52 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_ID_PROPERTY]);
#line 603 "notification.c"
	}
}

BudgieNotificationUrgency
budgie_notification_get_urgency (BudgieNotification* self)
{
	BudgieNotificationUrgency result;
#line 53 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 53 "../src/lib/notification.vala"
	result = self->priv->_urgency;
#line 53 "../src/lib/notification.vala"
	return result;
#line 617 "notification.c"
}

static void
budgie_notification_set_urgency (BudgieNotification* self,
                                 BudgieNotificationUrgency value)
{
	BudgieNotificationUrgency old_value;
#line 53 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/lib/notification.vala"
	old_value = budgie_notification_get_urgency (self);
#line 53 "../src/lib/notification.vala"
	if (old_value != value) {
#line 53 "../src/lib/notification.vala"
		self->priv->_urgency = value;
#line 53 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_URGENCY_PROPERTY]);
#line 635 "notification.c"
	}
}

guint32
budgie_notification_get_id (BudgieNotification* self)
{
	guint32 result;
#line 55 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 55 "../src/lib/notification.vala"
	result = self->priv->_id;
#line 55 "../src/lib/notification.vala"
	return result;
#line 649 "notification.c"
}

static void
budgie_notification_set_id (BudgieNotification* self,
                            guint32 value)
{
	guint32 old_value;
#line 55 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/lib/notification.vala"
	old_value = budgie_notification_get_id (self);
#line 55 "../src/lib/notification.vala"
	if (old_value != value) {
#line 55 "../src/lib/notification.vala"
		self->priv->_id = value;
#line 55 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_ID_PROPERTY]);
#line 667 "notification.c"
	}
}

const gchar*
budgie_notification_get_app_name (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 58 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_name;
#line 58 "../src/lib/notification.vala"
	result = _tmp0_;
#line 58 "../src/lib/notification.vala"
	return result;
#line 684 "notification.c"
}

static void
budgie_notification_set_app_name (BudgieNotification* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 58 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_name (self);
#line 58 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 698 "notification.c"
		gchar* _tmp0_;
#line 58 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 58 "../src/lib/notification.vala"
		_g_free0 (self->priv->_app_name);
#line 58 "../src/lib/notification.vala"
		self->priv->_app_name = _tmp0_;
#line 58 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_NAME_PROPERTY]);
#line 708 "notification.c"
	}
}

GHashTable*
budgie_notification_get_hints (BudgieNotification* self)
{
	GHashTable* result;
	GHashTable* _tmp0_;
#line 59 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_hints;
#line 59 "../src/lib/notification.vala"
	result = _tmp0_;
#line 59 "../src/lib/notification.vala"
	return result;
#line 725 "notification.c"
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 59 "../src/lib/notification.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 733 "notification.c"
}

static void
budgie_notification_set_hints (BudgieNotification* self,
                               GHashTable* value)
{
	GHashTable* old_value;
#line 59 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/lib/notification.vala"
	old_value = budgie_notification_get_hints (self);
#line 59 "../src/lib/notification.vala"
	if (old_value != value) {
#line 747 "notification.c"
		GHashTable* _tmp0_;
#line 59 "../src/lib/notification.vala"
		_tmp0_ = _g_hash_table_ref0 (value);
#line 59 "../src/lib/notification.vala"
		_g_hash_table_unref0 (self->priv->_hints);
#line 59 "../src/lib/notification.vala"
		self->priv->_hints = _tmp0_;
#line 59 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_HINTS_PROPERTY]);
#line 757 "notification.c"
	}
}

gchar**
budgie_notification_get_actions (BudgieNotification* self,
                                 gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 60 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_actions;
#line 60 "../src/lib/notification.vala"
	_tmp0__length1 = self->priv->_actions_length1;
#line 60 "../src/lib/notification.vala"
	_tmp1_ = _tmp0_;
#line 60 "../src/lib/notification.vala"
	_tmp1__length1 = _tmp0__length1;
#line 60 "../src/lib/notification.vala"
	if (result_length1) {
#line 60 "../src/lib/notification.vala"
		*result_length1 = _tmp1__length1;
#line 784 "notification.c"
	}
#line 60 "../src/lib/notification.vala"
	result = _tmp1_;
#line 60 "../src/lib/notification.vala"
	return result;
#line 790 "notification.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 60 "../src/lib/notification.vala"
	if (length >= 0) {
#line 799 "notification.c"
		gchar** result;
		gssize i;
#line 60 "../src/lib/notification.vala"
		result = g_new0 (gchar*, length + 1);
#line 60 "../src/lib/notification.vala"
		for (i = 0; i < length; i++) {
#line 806 "notification.c"
			gchar* _tmp0_;
#line 60 "../src/lib/notification.vala"
			_tmp0_ = g_strdup (self[i]);
#line 60 "../src/lib/notification.vala"
			result[i] = _tmp0_;
#line 812 "notification.c"
		}
#line 60 "../src/lib/notification.vala"
		return result;
#line 816 "notification.c"
	}
#line 60 "../src/lib/notification.vala"
	return NULL;
#line 820 "notification.c"
}

static void
budgie_notification_set_actions (BudgieNotification* self,
                                 gchar** value,
                                 gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
#line 60 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/lib/notification.vala"
	old_value = budgie_notification_get_actions (self, &old_value_length);
#line 60 "../src/lib/notification.vala"
	if (old_value != value) {
#line 836 "notification.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 60 "../src/lib/notification.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup1 (value, value_length1) : value;
#line 60 "../src/lib/notification.vala"
		_tmp0__length1 = value_length1;
#line 60 "../src/lib/notification.vala"
		self->priv->_actions = (_vala_array_free (self->priv->_actions, self->priv->_actions_length1, (GDestroyNotify) g_free), NULL);
#line 60 "../src/lib/notification.vala"
		self->priv->_actions = _tmp0_;
#line 60 "../src/lib/notification.vala"
		self->priv->_actions_length1 = _tmp0__length1;
#line 60 "../src/lib/notification.vala"
		self->priv->__actions_size_ = self->priv->_actions_length1;
#line 60 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_ACTIONS_PROPERTY]);
#line 853 "notification.c"
	}
}

const gchar*
budgie_notification_get_app_icon (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 61 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_icon;
#line 61 "../src/lib/notification.vala"
	result = _tmp0_;
#line 61 "../src/lib/notification.vala"
	return result;
#line 870 "notification.c"
}

static void
budgie_notification_set_app_icon (BudgieNotification* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 61 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_icon (self);
#line 61 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 884 "notification.c"
		gchar* _tmp0_;
#line 61 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 61 "../src/lib/notification.vala"
		_g_free0 (self->priv->_app_icon);
#line 61 "../src/lib/notification.vala"
		self->priv->_app_icon = _tmp0_;
#line 61 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_ICON_PROPERTY]);
#line 894 "notification.c"
	}
}

const gchar*
budgie_notification_get_body (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 62 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_body;
#line 62 "../src/lib/notification.vala"
	result = _tmp0_;
#line 62 "../src/lib/notification.vala"
	return result;
#line 911 "notification.c"
}

void
budgie_notification_set_body (BudgieNotification* self,
                              const gchar* value)
{
	gchar* old_value;
#line 62 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/lib/notification.vala"
	old_value = budgie_notification_get_body (self);
#line 62 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 925 "notification.c"
		gchar* _tmp0_;
#line 62 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 62 "../src/lib/notification.vala"
		_g_free0 (self->priv->_body);
#line 62 "../src/lib/notification.vala"
		self->priv->_body = _tmp0_;
#line 62 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_BODY_PROPERTY]);
#line 935 "notification.c"
	}
}

const gchar*
budgie_notification_get_summary (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 63 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_summary;
#line 63 "../src/lib/notification.vala"
	result = _tmp0_;
#line 63 "../src/lib/notification.vala"
	return result;
#line 952 "notification.c"
}

void
budgie_notification_set_summary (BudgieNotification* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 63 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/lib/notification.vala"
	old_value = budgie_notification_get_summary (self);
#line 63 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 966 "notification.c"
		gchar* _tmp0_;
#line 63 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 63 "../src/lib/notification.vala"
		_g_free0 (self->priv->_summary);
#line 63 "../src/lib/notification.vala"
		self->priv->_summary = _tmp0_;
#line 63 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_SUMMARY_PROPERTY]);
#line 976 "notification.c"
	}
}

guint
budgie_notification_get_expire_timeout (BudgieNotification* self)
{
	guint result;
#line 64 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 64 "../src/lib/notification.vala"
	result = self->priv->_expire_timeout;
#line 64 "../src/lib/notification.vala"
	return result;
#line 990 "notification.c"
}

void
budgie_notification_set_expire_timeout (BudgieNotification* self,
                                        guint value)
{
	guint old_value;
#line 64 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/lib/notification.vala"
	old_value = budgie_notification_get_expire_timeout (self);
#line 64 "../src/lib/notification.vala"
	if (old_value != value) {
#line 64 "../src/lib/notification.vala"
		self->priv->_expire_timeout = value;
#line 64 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY]);
#line 1008 "notification.c"
	}
}

const gchar*
budgie_notification_get_category (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 66 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_category;
#line 66 "../src/lib/notification.vala"
	result = _tmp0_;
#line 66 "../src/lib/notification.vala"
	return result;
#line 1025 "notification.c"
}

void
budgie_notification_set_category (BudgieNotification* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 66 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/lib/notification.vala"
	old_value = budgie_notification_get_category (self);
#line 66 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1039 "notification.c"
		gchar* _tmp0_;
#line 66 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 66 "../src/lib/notification.vala"
		_g_free0 (self->priv->_category);
#line 66 "../src/lib/notification.vala"
		self->priv->_category = _tmp0_;
#line 66 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_CATEGORY_PROPERTY]);
#line 1049 "notification.c"
	}
}

gint64
budgie_notification_get_timestamp (BudgieNotification* self)
{
	gint64 result;
#line 67 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 67 "../src/lib/notification.vala"
	result = self->priv->_timestamp;
#line 67 "../src/lib/notification.vala"
	return result;
#line 1063 "notification.c"
}

void
budgie_notification_set_timestamp (BudgieNotification* self,
                                   gint64 value)
{
	gint64 old_value;
#line 67 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/lib/notification.vala"
	old_value = budgie_notification_get_timestamp (self);
#line 67 "../src/lib/notification.vala"
	if (old_value != value) {
#line 67 "../src/lib/notification.vala"
		self->priv->_timestamp = value;
#line 67 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY]);
#line 1081 "notification.c"
	}
}

GtkImage*
budgie_notification_get_image (BudgieNotification* self)
{
	GtkImage* result;
	GtkImage* _tmp0_;
#line 70 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_image;
#line 70 "../src/lib/notification.vala"
	result = _tmp0_;
#line 70 "../src/lib/notification.vala"
	return result;
#line 1098 "notification.c"
}

void
budgie_notification_set_image (BudgieNotification* self,
                               GtkImage* value)
{
	GtkImage* old_value;
#line 70 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/lib/notification.vala"
	old_value = budgie_notification_get_image (self);
#line 70 "../src/lib/notification.vala"
	if (old_value != value) {
#line 1112 "notification.c"
		GtkImage* _tmp0_;
#line 70 "../src/lib/notification.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 70 "../src/lib/notification.vala"
		_g_object_unref0 (self->priv->_image);
#line 70 "../src/lib/notification.vala"
		self->priv->_image = _tmp0_;
#line 70 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_IMAGE_PROPERTY]);
#line 1122 "notification.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1145 "notification.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1149 "notification.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1155 "notification.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1159 "notification.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1163 "notification.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 1171 "notification.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1199 "notification.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 1208 "notification.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1222 "notification.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 1231 "notification.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 1245 "notification.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1254 "notification.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 1263 "notification.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 1282 "notification.c"
}

static GObject *
budgie_notification_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BudgieNotification * self;
	GVariant* variant = NULL;
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GHashTable* _tmp5_;
	gconstpointer _tmp6_;
	GVariant* _tmp7_;
	gboolean _tmp11_ = FALSE;
	GHashTable* _tmp12_;
	gconstpointer _tmp13_;
	GVariant* _tmp14_;
	gboolean _tmp19_ = FALSE;
	GHashTable* _tmp20_;
	gconstpointer _tmp21_;
	GVariant* _tmp22_;
	gboolean image_found = FALSE;
	gboolean _tmp35_ = FALSE;
	GHashTable* _tmp36_;
	gconstpointer _tmp37_;
	GVariant* _tmp38_;
	gboolean _tmp100_ = FALSE;
	const gchar* _tmp112_;
	GError* _inner_error0_ = NULL;
#line 106 "../src/lib/notification.vala"
	parent_class = G_OBJECT_CLASS (budgie_notification_parent_class);
#line 106 "../src/lib/notification.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 106 "../src/lib/notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 107 "../src/lib/notification.vala"
	variant = NULL;
#line 108 "../src/lib/notification.vala"
	_tmp0_ = g_time_zone_new_local ();
#line 108 "../src/lib/notification.vala"
	_tmp1_ = _tmp0_;
#line 108 "../src/lib/notification.vala"
	_tmp2_ = g_date_time_new_now (_tmp1_);
#line 108 "../src/lib/notification.vala"
	_tmp3_ = _tmp2_;
#line 108 "../src/lib/notification.vala"
	budgie_notification_set_timestamp (self, g_date_time_to_unix (_tmp3_));
#line 108 "../src/lib/notification.vala"
	_g_date_time_unref0 (_tmp3_);
#line 108 "../src/lib/notification.vala"
	_g_time_zone_unref0 (_tmp1_);
#line 111 "../src/lib/notification.vala"
	_tmp5_ = self->priv->_hints;
#line 111 "../src/lib/notification.vala"
	_tmp6_ = g_hash_table_lookup (_tmp5_, "urgency");
#line 111 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp6_;
#line 111 "../src/lib/notification.vala"
	_tmp7_ = variant;
#line 111 "../src/lib/notification.vala"
	if (_tmp7_ != NULL) {
#line 1350 "notification.c"
		GVariant* _tmp8_;
		const GVariantType* _tmp9_;
#line 111 "../src/lib/notification.vala"
		_tmp8_ = variant;
#line 111 "../src/lib/notification.vala"
		_tmp9_ = G_VARIANT_TYPE_BYTE;
#line 111 "../src/lib/notification.vala"
		_tmp4_ = g_variant_is_of_type (_tmp8_, _tmp9_);
#line 1359 "notification.c"
	} else {
#line 111 "../src/lib/notification.vala"
		_tmp4_ = FALSE;
#line 1363 "notification.c"
	}
#line 111 "../src/lib/notification.vala"
	if (_tmp4_) {
#line 1367 "notification.c"
		GVariant* _tmp10_;
#line 112 "../src/lib/notification.vala"
		_tmp10_ = variant;
#line 112 "../src/lib/notification.vala"
		budgie_notification_set_urgency (self, (BudgieNotificationUrgency) g_variant_get_byte (_tmp10_));
#line 1373 "notification.c"
	}
#line 116 "../src/lib/notification.vala"
	_tmp12_ = self->priv->_hints;
#line 116 "../src/lib/notification.vala"
	_tmp13_ = g_hash_table_lookup (_tmp12_, "category");
#line 116 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp13_;
#line 116 "../src/lib/notification.vala"
	_tmp14_ = variant;
#line 116 "../src/lib/notification.vala"
	if (_tmp14_ != NULL) {
#line 1385 "notification.c"
		GVariant* _tmp15_;
		const GVariantType* _tmp16_;
#line 116 "../src/lib/notification.vala"
		_tmp15_ = variant;
#line 116 "../src/lib/notification.vala"
		_tmp16_ = G_VARIANT_TYPE_STRING;
#line 116 "../src/lib/notification.vala"
		_tmp11_ = g_variant_is_of_type (_tmp15_, _tmp16_);
#line 1394 "notification.c"
	} else {
#line 116 "../src/lib/notification.vala"
		_tmp11_ = FALSE;
#line 1398 "notification.c"
	}
#line 116 "../src/lib/notification.vala"
	if (_tmp11_) {
#line 1402 "notification.c"
		GVariant* _tmp17_;
		const gchar* _tmp18_;
#line 117 "../src/lib/notification.vala"
		_tmp17_ = variant;
#line 117 "../src/lib/notification.vala"
		_tmp18_ = g_variant_get_string (_tmp17_, NULL);
#line 117 "../src/lib/notification.vala"
		budgie_notification_set_category (self, _tmp18_);
#line 1411 "notification.c"
	}
#line 121 "../src/lib/notification.vala"
	_tmp20_ = self->priv->_hints;
#line 121 "../src/lib/notification.vala"
	_tmp21_ = g_hash_table_lookup (_tmp20_, "desktop-entry");
#line 121 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp21_;
#line 121 "../src/lib/notification.vala"
	_tmp22_ = variant;
#line 121 "../src/lib/notification.vala"
	if (_tmp22_ != NULL) {
#line 1423 "notification.c"
		GVariant* _tmp23_;
		const GVariantType* _tmp24_;
#line 121 "../src/lib/notification.vala"
		_tmp23_ = variant;
#line 121 "../src/lib/notification.vala"
		_tmp24_ = G_VARIANT_TYPE_STRING;
#line 121 "../src/lib/notification.vala"
		_tmp19_ = g_variant_is_of_type (_tmp23_, _tmp24_);
#line 1432 "notification.c"
	} else {
#line 121 "../src/lib/notification.vala"
		_tmp19_ = FALSE;
#line 1436 "notification.c"
	}
#line 121 "../src/lib/notification.vala"
	if (_tmp19_) {
#line 1440 "notification.c"
		GVariant* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		GDesktopAppInfo* _tmp33_;
		GDesktopAppInfo* _tmp34_;
#line 122 "../src/lib/notification.vala"
		_tmp25_ = variant;
#line 122 "../src/lib/notification.vala"
		_tmp26_ = g_variant_get_string (_tmp25_, NULL);
#line 122 "../src/lib/notification.vala"
		budgie_notification_set_app_id (self, _tmp26_);
#line 123 "../src/lib/notification.vala"
		_tmp27_ = self->priv->_app_id;
#line 123 "../src/lib/notification.vala"
		_tmp28_ = string_replace (_tmp27_, ".desktop", "");
#line 123 "../src/lib/notification.vala"
		_tmp29_ = _tmp28_;
#line 123 "../src/lib/notification.vala"
		_g_free0 (_tmp29_);
#line 124 "../src/lib/notification.vala"
		_tmp30_ = self->priv->_app_id;
#line 124 "../src/lib/notification.vala"
		_tmp31_ = g_strdup_printf ("%s.desktop", _tmp30_);
#line 124 "../src/lib/notification.vala"
		_tmp32_ = _tmp31_;
#line 124 "../src/lib/notification.vala"
		_tmp33_ = g_desktop_app_info_new (_tmp32_);
#line 124 "../src/lib/notification.vala"
		_tmp34_ = _tmp33_;
#line 124 "../src/lib/notification.vala"
		budgie_notification_set_app_info (self, _tmp34_);
#line 124 "../src/lib/notification.vala"
		_g_object_unref0 (_tmp34_);
#line 124 "../src/lib/notification.vala"
		_g_free0 (_tmp32_);
#line 1481 "notification.c"
	}
#line 127 "../src/lib/notification.vala"
	image_found = FALSE;
#line 131 "../src/lib/notification.vala"
	_tmp36_ = self->priv->_hints;
#line 131 "../src/lib/notification.vala"
	_tmp37_ = g_hash_table_lookup (_tmp36_, "image-data");
#line 131 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp37_;
#line 131 "../src/lib/notification.vala"
	_tmp38_ = variant;
#line 131 "../src/lib/notification.vala"
	if (_tmp38_ != NULL) {
#line 131 "../src/lib/notification.vala"
		_tmp35_ = TRUE;
#line 1497 "notification.c"
	} else {
		GHashTable* _tmp39_;
		gconstpointer _tmp40_;
		GVariant* _tmp41_;
#line 132 "../src/lib/notification.vala"
		_tmp39_ = self->priv->_hints;
#line 132 "../src/lib/notification.vala"
		_tmp40_ = g_hash_table_lookup (_tmp39_, "image_data");
#line 132 "../src/lib/notification.vala"
		variant = (GVariant*) _tmp40_;
#line 132 "../src/lib/notification.vala"
		_tmp41_ = variant;
#line 132 "../src/lib/notification.vala"
		_tmp35_ = _tmp41_ != NULL;
#line 1512 "notification.c"
	}
#line 130 "../src/lib/notification.vala"
	if (_tmp35_) {
#line 1516 "notification.c"
		GdkPixbuf* pixbuf = NULL;
		GVariant* _tmp42_;
		GdkPixbuf* _tmp43_;
		GdkPixbuf* _tmp44_;
#line 134 "../src/lib/notification.vala"
		_tmp42_ = variant;
#line 134 "../src/lib/notification.vala"
		_tmp43_ = budgie_notification_decode_image (self, _tmp42_);
#line 134 "../src/lib/notification.vala"
		pixbuf = _tmp43_;
#line 135 "../src/lib/notification.vala"
		_tmp44_ = pixbuf;
#line 135 "../src/lib/notification.vala"
		if (_tmp44_ != NULL) {
#line 1531 "notification.c"
			GdkPixbuf* _tmp45_;
			GtkImage* _tmp46_;
			GtkImage* _tmp47_;
#line 136 "../src/lib/notification.vala"
			_tmp45_ = pixbuf;
#line 136 "../src/lib/notification.vala"
			_tmp46_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp45_);
#line 136 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp46_);
#line 136 "../src/lib/notification.vala"
			_tmp47_ = _tmp46_;
#line 136 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp47_);
#line 136 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp47_);
#line 137 "../src/lib/notification.vala"
			image_found = TRUE;
#line 1549 "notification.c"
		}
#line 130 "../src/lib/notification.vala"
		_g_object_unref0 (pixbuf);
#line 1553 "notification.c"
	}
#line 142 "../src/lib/notification.vala"
	if (!image_found) {
#line 1557 "notification.c"
		gboolean _tmp48_ = FALSE;
		GHashTable* _tmp49_;
		gconstpointer _tmp50_;
		GVariant* _tmp51_;
#line 144 "../src/lib/notification.vala"
		_tmp49_ = self->priv->_hints;
#line 144 "../src/lib/notification.vala"
		_tmp50_ = g_hash_table_lookup (_tmp49_, "image-path");
#line 144 "../src/lib/notification.vala"
		variant = (GVariant*) _tmp50_;
#line 144 "../src/lib/notification.vala"
		_tmp51_ = variant;
#line 144 "../src/lib/notification.vala"
		if (_tmp51_ != NULL) {
#line 144 "../src/lib/notification.vala"
			_tmp48_ = TRUE;
#line 1574 "notification.c"
		} else {
			GHashTable* _tmp52_;
			gconstpointer _tmp53_;
			GVariant* _tmp54_;
#line 145 "../src/lib/notification.vala"
			_tmp52_ = self->priv->_hints;
#line 145 "../src/lib/notification.vala"
			_tmp53_ = g_hash_table_lookup (_tmp52_, "image_path");
#line 145 "../src/lib/notification.vala"
			variant = (GVariant*) _tmp53_;
#line 145 "../src/lib/notification.vala"
			_tmp54_ = variant;
#line 145 "../src/lib/notification.vala"
			_tmp48_ = _tmp54_ != NULL;
#line 1589 "notification.c"
		}
#line 143 "../src/lib/notification.vala"
		if (_tmp48_) {
#line 1593 "notification.c"
			gchar* path = NULL;
			GVariant* _tmp55_;
			const gchar* _tmp56_;
			gchar* _tmp57_;
			gboolean _tmp58_ = FALSE;
			GtkIconTheme* _tmp59_;
			const gchar* _tmp60_;
#line 147 "../src/lib/notification.vala"
			_tmp55_ = variant;
#line 147 "../src/lib/notification.vala"
			_tmp56_ = g_variant_get_string (_tmp55_, NULL);
#line 147 "../src/lib/notification.vala"
			_tmp57_ = g_strdup (_tmp56_);
#line 147 "../src/lib/notification.vala"
			path = _tmp57_;
#line 149 "../src/lib/notification.vala"
			_tmp59_ = gtk_icon_theme_get_default ();
#line 149 "../src/lib/notification.vala"
			_tmp60_ = path;
#line 149 "../src/lib/notification.vala"
			if (gtk_icon_theme_has_icon (_tmp59_, _tmp60_)) {
#line 1615 "notification.c"
				const gchar* _tmp61_;
				const gchar* _tmp62_;
#line 149 "../src/lib/notification.vala"
				_tmp61_ = path;
#line 149 "../src/lib/notification.vala"
				_tmp62_ = self->priv->_app_icon;
#line 149 "../src/lib/notification.vala"
				_tmp58_ = g_strcmp0 (_tmp61_, _tmp62_) != 0;
#line 1624 "notification.c"
			} else {
#line 149 "../src/lib/notification.vala"
				_tmp58_ = FALSE;
#line 1628 "notification.c"
			}
#line 149 "../src/lib/notification.vala"
			if (_tmp58_) {
#line 1632 "notification.c"
				GThemedIcon* icon = NULL;
				const gchar* _tmp63_;
				GThemedIcon* _tmp64_;
				GThemedIcon* _tmp65_;
				GtkImage* _tmp66_;
				GtkImage* _tmp67_;
#line 150 "../src/lib/notification.vala"
				_tmp63_ = path;
#line 150 "../src/lib/notification.vala"
				_tmp64_ = (GThemedIcon*) g_themed_icon_new (_tmp63_);
#line 150 "../src/lib/notification.vala"
				icon = _tmp64_;
#line 151 "../src/lib/notification.vala"
				_tmp65_ = icon;
#line 151 "../src/lib/notification.vala"
				_tmp66_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp65_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 151 "../src/lib/notification.vala"
				g_object_ref_sink (_tmp66_);
#line 151 "../src/lib/notification.vala"
				_tmp67_ = _tmp66_;
#line 151 "../src/lib/notification.vala"
				budgie_notification_set_image (self, _tmp67_);
#line 151 "../src/lib/notification.vala"
				_g_object_unref0 (_tmp67_);
#line 152 "../src/lib/notification.vala"
				image_found = TRUE;
#line 149 "../src/lib/notification.vala"
				_g_object_unref0 (icon);
#line 1661 "notification.c"
			} else {
				gboolean _tmp68_ = FALSE;
				const gchar* _tmp69_;
#line 153 "../src/lib/notification.vala"
				_tmp69_ = path;
#line 153 "../src/lib/notification.vala"
				if (g_str_has_prefix (_tmp69_, "/")) {
#line 153 "../src/lib/notification.vala"
					_tmp68_ = TRUE;
#line 1671 "notification.c"
				} else {
					const gchar* _tmp70_;
#line 153 "../src/lib/notification.vala"
					_tmp70_ = path;
#line 153 "../src/lib/notification.vala"
					_tmp68_ = g_str_has_prefix (_tmp70_, "file://");
#line 1678 "notification.c"
				}
#line 153 "../src/lib/notification.vala"
				if (_tmp68_) {
#line 1682 "notification.c"
					{
						GdkPixbuf* pixbuf = NULL;
						const gchar* _tmp71_;
						GdkPixbuf* _tmp72_;
						GdkPixbuf* _tmp73_;
						GtkImage* _tmp74_;
						GtkImage* _tmp75_;
#line 155 "../src/lib/notification.vala"
						_tmp71_ = path;
#line 155 "../src/lib/notification.vala"
						_tmp72_ = gdk_pixbuf_new_from_file_at_size (_tmp71_, 48, 48, &_inner_error0_);
#line 155 "../src/lib/notification.vala"
						pixbuf = _tmp72_;
#line 155 "../src/lib/notification.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1698 "notification.c"
							goto __catch0_g_error;
						}
#line 156 "../src/lib/notification.vala"
						_tmp73_ = pixbuf;
#line 156 "../src/lib/notification.vala"
						_tmp74_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp73_);
#line 156 "../src/lib/notification.vala"
						g_object_ref_sink (_tmp74_);
#line 156 "../src/lib/notification.vala"
						_tmp75_ = _tmp74_;
#line 156 "../src/lib/notification.vala"
						budgie_notification_set_image (self, _tmp75_);
#line 156 "../src/lib/notification.vala"
						_g_object_unref0 (_tmp75_);
#line 157 "../src/lib/notification.vala"
						image_found = TRUE;
#line 154 "../src/lib/notification.vala"
						_g_object_unref0 (pixbuf);
#line 1717 "notification.c"
					}
					goto __finally0;
					__catch0_g_error:
					{
						GError* e = NULL;
						GError* _tmp76_;
						const gchar* _tmp77_;
#line 154 "../src/lib/notification.vala"
						e = _inner_error0_;
#line 154 "../src/lib/notification.vala"
						_inner_error0_ = NULL;
#line 159 "../src/lib/notification.vala"
						_tmp76_ = e;
#line 159 "../src/lib/notification.vala"
						_tmp77_ = _tmp76_->message;
#line 159 "../src/lib/notification.vala"
						g_critical ("notification.vala:159: Unable to get pixbuf from path: %s", _tmp77_);
#line 154 "../src/lib/notification.vala"
						_g_error_free0 (e);
#line 1737 "notification.c"
					}
					__finally0:
#line 154 "../src/lib/notification.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/lib/notification.vala"
						_g_free0 (path);
#line 154 "../src/lib/notification.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 154 "../src/lib/notification.vala"
						g_clear_error (&_inner_error0_);
#line 1748 "notification.c"
					}
				}
			}
#line 143 "../src/lib/notification.vala"
			_g_free0 (path);
#line 1754 "notification.c"
		}
	}
#line 166 "../src/lib/notification.vala"
	if (!image_found) {
#line 1759 "notification.c"
		gboolean _tmp78_ = FALSE;
		const gchar* _tmp79_;
#line 167 "../src/lib/notification.vala"
		_tmp79_ = self->priv->_app_icon;
#line 167 "../src/lib/notification.vala"
		if (g_strcmp0 (_tmp79_, "") != 0) {
#line 1766 "notification.c"
			const gchar* _tmp80_;
#line 167 "../src/lib/notification.vala"
			_tmp80_ = self->priv->_app_icon;
#line 167 "../src/lib/notification.vala"
			_tmp78_ = !string_contains (_tmp80_, "/");
#line 1772 "notification.c"
		} else {
#line 167 "../src/lib/notification.vala"
			_tmp78_ = FALSE;
#line 1776 "notification.c"
		}
#line 167 "../src/lib/notification.vala"
		if (_tmp78_) {
#line 1780 "notification.c"
			const gchar* _tmp81_;
			GtkImage* _tmp82_;
			GtkImage* _tmp83_;
#line 168 "../src/lib/notification.vala"
			_tmp81_ = self->priv->_app_icon;
#line 168 "../src/lib/notification.vala"
			_tmp82_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp81_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 168 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp82_);
#line 168 "../src/lib/notification.vala"
			_tmp83_ = _tmp82_;
#line 168 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp83_);
#line 168 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp83_);
#line 169 "../src/lib/notification.vala"
			image_found = TRUE;
#line 1798 "notification.c"
		} else {
			gboolean _tmp84_ = FALSE;
			const gchar* _tmp85_;
#line 170 "../src/lib/notification.vala"
			_tmp85_ = self->priv->_app_icon;
#line 170 "../src/lib/notification.vala"
			if (g_strcmp0 (_tmp85_, "") == 0) {
#line 1806 "notification.c"
				GDesktopAppInfo* _tmp86_;
#line 170 "../src/lib/notification.vala"
				_tmp86_ = self->priv->_app_info;
#line 170 "../src/lib/notification.vala"
				_tmp84_ = _tmp86_ != NULL;
#line 1812 "notification.c"
			} else {
#line 170 "../src/lib/notification.vala"
				_tmp84_ = FALSE;
#line 1816 "notification.c"
			}
#line 170 "../src/lib/notification.vala"
			if (_tmp84_) {
#line 1820 "notification.c"
				GDesktopAppInfo* _tmp87_;
				GIcon* _tmp88_;
				GtkImage* _tmp89_;
				GtkImage* _tmp90_;
#line 171 "../src/lib/notification.vala"
				_tmp87_ = self->priv->_app_info;
#line 171 "../src/lib/notification.vala"
				_tmp88_ = g_app_info_get_icon ((GAppInfo*) _tmp87_);
#line 171 "../src/lib/notification.vala"
				_tmp89_ = (GtkImage*) gtk_image_new_from_gicon (_tmp88_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 171 "../src/lib/notification.vala"
				g_object_ref_sink (_tmp89_);
#line 171 "../src/lib/notification.vala"
				_tmp90_ = _tmp89_;
#line 171 "../src/lib/notification.vala"
				budgie_notification_set_image (self, _tmp90_);
#line 171 "../src/lib/notification.vala"
				_g_object_unref0 (_tmp90_);
#line 172 "../src/lib/notification.vala"
				image_found = TRUE;
#line 1841 "notification.c"
			} else {
				const gchar* _tmp91_;
#line 173 "../src/lib/notification.vala"
				_tmp91_ = self->priv->_app_icon;
#line 173 "../src/lib/notification.vala"
				if (string_contains (_tmp91_, "/")) {
#line 1848 "notification.c"
					GFile* file = NULL;
					const gchar* _tmp92_;
					GFile* _tmp93_;
					GFile* _tmp94_;
#line 174 "../src/lib/notification.vala"
					_tmp92_ = self->priv->_app_icon;
#line 174 "../src/lib/notification.vala"
					_tmp93_ = g_file_new_for_uri (_tmp92_);
#line 174 "../src/lib/notification.vala"
					file = _tmp93_;
#line 175 "../src/lib/notification.vala"
					_tmp94_ = file;
#line 175 "../src/lib/notification.vala"
					if (g_file_query_exists (_tmp94_, NULL)) {
#line 1863 "notification.c"
						GFileIcon* icon = NULL;
						GFile* _tmp95_;
						GFileIcon* _tmp96_;
						GFileIcon* _tmp97_;
						GtkImage* _tmp98_;
						GtkImage* _tmp99_;
#line 176 "../src/lib/notification.vala"
						_tmp95_ = file;
#line 176 "../src/lib/notification.vala"
						_tmp96_ = (GFileIcon*) g_file_icon_new (_tmp95_);
#line 176 "../src/lib/notification.vala"
						icon = _tmp96_;
#line 177 "../src/lib/notification.vala"
						_tmp97_ = icon;
#line 177 "../src/lib/notification.vala"
						_tmp98_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp97_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 177 "../src/lib/notification.vala"
						g_object_ref_sink (_tmp98_);
#line 177 "../src/lib/notification.vala"
						_tmp99_ = _tmp98_;
#line 177 "../src/lib/notification.vala"
						budgie_notification_set_image (self, _tmp99_);
#line 177 "../src/lib/notification.vala"
						_g_object_unref0 (_tmp99_);
#line 178 "../src/lib/notification.vala"
						image_found = TRUE;
#line 175 "../src/lib/notification.vala"
						_g_object_unref0 (icon);
#line 1892 "notification.c"
					}
#line 173 "../src/lib/notification.vala"
					_g_object_unref0 (file);
#line 1896 "notification.c"
				}
			}
		}
	}
#line 184 "../src/lib/notification.vala"
	if (!image_found) {
#line 1903 "notification.c"
		GHashTable* _tmp101_;
		gconstpointer _tmp102_;
		GVariant* _tmp103_;
#line 184 "../src/lib/notification.vala"
		_tmp101_ = self->priv->_hints;
#line 184 "../src/lib/notification.vala"
		_tmp102_ = g_hash_table_lookup (_tmp101_, "icon_data");
#line 184 "../src/lib/notification.vala"
		variant = (GVariant*) _tmp102_;
#line 184 "../src/lib/notification.vala"
		_tmp103_ = variant;
#line 184 "../src/lib/notification.vala"
		_tmp100_ = _tmp103_ != NULL;
#line 1917 "notification.c"
	} else {
#line 184 "../src/lib/notification.vala"
		_tmp100_ = FALSE;
#line 1921 "notification.c"
	}
#line 184 "../src/lib/notification.vala"
	if (_tmp100_) {
#line 1925 "notification.c"
		GdkPixbuf* pixbuf = NULL;
		GVariant* _tmp104_;
		GdkPixbuf* _tmp105_;
		GdkPixbuf* _tmp106_;
#line 185 "../src/lib/notification.vala"
		_tmp104_ = variant;
#line 185 "../src/lib/notification.vala"
		_tmp105_ = budgie_notification_decode_image (self, _tmp104_);
#line 185 "../src/lib/notification.vala"
		pixbuf = _tmp105_;
#line 186 "../src/lib/notification.vala"
		_tmp106_ = pixbuf;
#line 186 "../src/lib/notification.vala"
		if (_tmp106_ != NULL) {
#line 1940 "notification.c"
			GdkPixbuf* _tmp107_;
			GtkImage* _tmp108_;
			GtkImage* _tmp109_;
#line 187 "../src/lib/notification.vala"
			_tmp107_ = pixbuf;
#line 187 "../src/lib/notification.vala"
			_tmp108_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp107_);
#line 187 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp108_);
#line 187 "../src/lib/notification.vala"
			_tmp109_ = _tmp108_;
#line 187 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp109_);
#line 187 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp109_);
#line 188 "../src/lib/notification.vala"
			image_found = TRUE;
#line 1958 "notification.c"
		}
#line 184 "../src/lib/notification.vala"
		_g_object_unref0 (pixbuf);
#line 1962 "notification.c"
	}
#line 193 "../src/lib/notification.vala"
	if (!image_found) {
#line 1966 "notification.c"
		GtkImage* _tmp110_;
		GtkImage* _tmp111_;
#line 194 "../src/lib/notification.vala"
		_tmp110_ = (GtkImage*) gtk_image_new_from_icon_name ("mail-unread-symbolic", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 194 "../src/lib/notification.vala"
		g_object_ref_sink (_tmp110_);
#line 194 "../src/lib/notification.vala"
		_tmp111_ = _tmp110_;
#line 194 "../src/lib/notification.vala"
		budgie_notification_set_image (self, _tmp111_);
#line 194 "../src/lib/notification.vala"
		_g_object_unref0 (_tmp111_);
#line 1979 "notification.c"
	}
#line 199 "../src/lib/notification.vala"
	_tmp112_ = self->priv->_body;
#line 199 "../src/lib/notification.vala"
	if (g_strcmp0 (_tmp112_, "") == 0) {
#line 1985 "notification.c"
		const gchar* _tmp113_;
		gchar* _tmp114_;
		gchar* _tmp115_;
		const gchar* _tmp116_;
#line 200 "../src/lib/notification.vala"
		_tmp113_ = self->priv->_summary;
#line 200 "../src/lib/notification.vala"
		_tmp114_ = budgie_notification_fix_markup (self, _tmp113_);
#line 200 "../src/lib/notification.vala"
		_tmp115_ = _tmp114_;
#line 200 "../src/lib/notification.vala"
		budgie_notification_set_body (self, _tmp115_);
#line 200 "../src/lib/notification.vala"
		_g_free0 (_tmp115_);
#line 201 "../src/lib/notification.vala"
		_tmp116_ = self->priv->_app_name;
#line 201 "../src/lib/notification.vala"
		budgie_notification_set_summary (self, _tmp116_);
#line 2004 "notification.c"
	} else {
		const gchar* _tmp117_;
		gchar* _tmp118_;
		gchar* _tmp119_;
		const gchar* _tmp120_;
		gchar* _tmp121_;
		gchar* _tmp122_;
#line 203 "../src/lib/notification.vala"
		_tmp117_ = self->priv->_body;
#line 203 "../src/lib/notification.vala"
		_tmp118_ = budgie_notification_fix_markup (self, _tmp117_);
#line 203 "../src/lib/notification.vala"
		_tmp119_ = _tmp118_;
#line 203 "../src/lib/notification.vala"
		budgie_notification_set_body (self, _tmp119_);
#line 203 "../src/lib/notification.vala"
		_g_free0 (_tmp119_);
#line 204 "../src/lib/notification.vala"
		_tmp120_ = self->priv->_summary;
#line 204 "../src/lib/notification.vala"
		_tmp121_ = budgie_notification_fix_markup (self, _tmp120_);
#line 204 "../src/lib/notification.vala"
		_tmp122_ = _tmp121_;
#line 204 "../src/lib/notification.vala"
		budgie_notification_set_summary (self, _tmp122_);
#line 204 "../src/lib/notification.vala"
		_g_free0 (_tmp122_);
#line 2032 "notification.c"
	}
#line 106 "../src/lib/notification.vala"
	return obj;
#line 2036 "notification.c"
}

static void
budgie_notification_class_init (BudgieNotificationClass * klass,
                                gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 50 "../src/lib/notification.vala"
	budgie_notification_parent_class = g_type_class_peek_parent (klass);
#line 50 "../src/lib/notification.vala"
	g_type_class_adjust_private_offset (klass, &BudgieNotification_private_offset);
#line 50 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_budgie_notification_get_property;
#line 50 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_budgie_notification_set_property;
#line 50 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->constructor = budgie_notification_constructor;
#line 50 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_notification_finalize;
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_INFO_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_INFO_PROPERTY] = g_param_spec_object ("app-info", "app-info", "app-info", G_TYPE_DESKTOP_APP_INFO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_ID_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_URGENCY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_URGENCY_PROPERTY] = g_param_spec_enum ("urgency", "urgency", "urgency", BUDGIE_TYPE_NOTIFICATION_URGENCY, BUDGIE_NOTIFICATION_URGENCY_NORMAL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_ID_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_ID_PROPERTY] = g_param_spec_uint ("id", "id", "id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_NAME_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_NAME_PROPERTY] = g_param_spec_string ("app-name", "app-name", "app-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_HINTS_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_HINTS_PROPERTY] = g_param_spec_boxed ("hints", "hints", "hints", G_TYPE_HASH_TABLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_ACTIONS_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_ACTIONS_PROPERTY] = g_param_spec_boxed ("actions", "actions", "actions", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_ICON_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_ICON_PROPERTY] = g_param_spec_string ("app-icon", "app-icon", "app-icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_BODY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_BODY_PROPERTY] = g_param_spec_string ("body", "body", "body", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_SUMMARY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_SUMMARY_PROPERTY] = g_param_spec_string ("summary", "summary", "summary", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY] = g_param_spec_uint ("expire-timeout", "expire-timeout", "expire-timeout", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_CATEGORY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_CATEGORY_PROPERTY] = g_param_spec_string ("category", "category", "category", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY] = g_param_spec_int64 ("timestamp", "timestamp", "timestamp", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 50 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_IMAGE_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_IMAGE_PROPERTY] = g_param_spec_object ("image", "image", "image", gtk_image_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2084 "notification.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_;
		GRegex* _tmp5_;
#line 99 "../src/lib/notification.vala"
		_tmp1_ = g_regex_new ("&(?!amp;|quot;|apos;|lt;|gt;|#39;|nbsp;)", 0, 0, &_inner_error0_);
#line 99 "../src/lib/notification.vala"
		_tmp0_ = _tmp1_;
#line 99 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2098 "notification.c"
			goto __catch0_g_error;
		}
#line 99 "../src/lib/notification.vala"
		_tmp2_ = _tmp0_;
#line 99 "../src/lib/notification.vala"
		_tmp0_ = NULL;
#line 99 "../src/lib/notification.vala"
		_g_regex_unref0 (budgie_notification_entity_regex);
#line 99 "../src/lib/notification.vala"
		budgie_notification_entity_regex = _tmp2_;
#line 100 "../src/lib/notification.vala"
		_tmp4_ = g_regex_new ("<(?!\\/?[biu]>)", 0, 0, &_inner_error0_);
#line 100 "../src/lib/notification.vala"
		_tmp3_ = _tmp4_;
#line 100 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../src/lib/notification.vala"
			_g_regex_unref0 (_tmp0_);
#line 2117 "notification.c"
			goto __catch0_g_error;
		}
#line 100 "../src/lib/notification.vala"
		_tmp5_ = _tmp3_;
#line 100 "../src/lib/notification.vala"
		_tmp3_ = NULL;
#line 100 "../src/lib/notification.vala"
		_g_regex_unref0 (budgie_notification_tag_regex);
#line 100 "../src/lib/notification.vala"
		budgie_notification_tag_regex = _tmp5_;
#line 98 "../src/lib/notification.vala"
		_g_regex_unref0 (_tmp3_);
#line 98 "../src/lib/notification.vala"
		_g_regex_unref0 (_tmp0_);
#line 2132 "notification.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 98 "../src/lib/notification.vala"
		e = _inner_error0_;
#line 98 "../src/lib/notification.vala"
		_inner_error0_ = NULL;
#line 102 "../src/lib/notification.vala"
		_tmp6_ = e;
#line 102 "../src/lib/notification.vala"
		_tmp7_ = _tmp6_->message;
#line 102 "../src/lib/notification.vala"
		g_warning ("notification.vala:102: Invalid notificiation regex: %s", _tmp7_);
#line 98 "../src/lib/notification.vala"
		_g_error_free0 (e);
#line 2152 "notification.c"
	}
	__finally0:
#line 98 "../src/lib/notification.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "../src/lib/notification.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "../src/lib/notification.vala"
		g_clear_error (&_inner_error0_);
#line 2161 "notification.c"
	}
}

static void
budgie_notification_instance_init (BudgieNotification * self,
                                   gpointer klass)
{
#line 50 "../src/lib/notification.vala"
	self->priv = budgie_notification_get_instance_private (self);
#line 51 "../src/lib/notification.vala"
	self->priv->_app_info = NULL;
#line 53 "../src/lib/notification.vala"
	self->priv->_urgency = BUDGIE_NOTIFICATION_URGENCY_NORMAL;
#line 70 "../src/lib/notification.vala"
	self->priv->_image = NULL;
#line 2177 "notification.c"
}

static void
budgie_notification_finalize (GObject * obj)
{
	BudgieNotification * self;
#line 50 "../src/lib/notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 51 "../src/lib/notification.vala"
	_g_object_unref0 (self->priv->_app_info);
#line 52 "../src/lib/notification.vala"
	_g_free0 (self->priv->_app_id);
#line 58 "../src/lib/notification.vala"
	_g_free0 (self->priv->_app_name);
#line 59 "../src/lib/notification.vala"
	_g_hash_table_unref0 (self->priv->_hints);
#line 60 "../src/lib/notification.vala"
	self->priv->_actions = (_vala_array_free (self->priv->_actions, self->priv->_actions_length1, (GDestroyNotify) g_free), NULL);
#line 61 "../src/lib/notification.vala"
	_g_free0 (self->priv->_app_icon);
#line 62 "../src/lib/notification.vala"
	_g_free0 (self->priv->_body);
#line 63 "../src/lib/notification.vala"
	_g_free0 (self->priv->_summary);
#line 66 "../src/lib/notification.vala"
	_g_free0 (self->priv->_category);
#line 70 "../src/lib/notification.vala"
	_g_object_unref0 (self->priv->_image);
#line 50 "../src/lib/notification.vala"
	G_OBJECT_CLASS (budgie_notification_parent_class)->finalize (obj);
#line 2208 "notification.c"
}

/**
 * This is our wrapper class for a FreeDesktop notification.
 */
static GType
budgie_notification_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieNotification), 0, (GInstanceInitFunc) budgie_notification_instance_init, NULL };
	GType budgie_notification_type_id;
	budgie_notification_type_id = g_type_register_static (G_TYPE_OBJECT, "BudgieNotification", &g_define_type_info, 0);
	BudgieNotification_private_offset = g_type_add_instance_private (budgie_notification_type_id, sizeof (BudgieNotificationPrivate));
	return budgie_notification_type_id;
}

GType
budgie_notification_get_type (void)
{
	static volatile gsize budgie_notification_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_type_id__once)) {
		GType budgie_notification_type_id;
		budgie_notification_type_id = budgie_notification_get_type_once ();
		g_once_init_leave (&budgie_notification_type_id__once, budgie_notification_type_id);
	}
	return budgie_notification_type_id__once;
}

static void
_vala_budgie_notification_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	BudgieNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 50 "../src/lib/notification.vala"
	switch (property_id) {
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_INFO_PROPERTY:
#line 50 "../src/lib/notification.vala"
		g_value_set_object (value, budgie_notification_get_app_info (self));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_ID_PROPERTY:
#line 50 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_app_id (self));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_URGENCY_PROPERTY:
#line 50 "../src/lib/notification.vala"
		g_value_set_enum (value, budgie_notification_get_urgency (self));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ID_PROPERTY:
#line 50 "../src/lib/notification.vala"
		g_value_set_uint (value, budgie_notification_get_id (self));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_NAME_PROPERTY:
#line 50 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_app_name (self));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_HINTS_PROPERTY:
#line 50 "../src/lib/notification.vala"
		g_value_set_boxed (value, budgie_notification_get_hints (self));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ACTIONS_PROPERTY:
#line 2284 "notification.c"
		{
			int length;
#line 50 "../src/lib/notification.vala"
			g_value_set_boxed (value, budgie_notification_get_actions (self, &length));
#line 2289 "notification.c"
		}
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_ICON_PROPERTY:
#line 50 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_app_icon (self));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_BODY_PROPERTY:
#line 50 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_body (self));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_SUMMARY_PROPERTY:
#line 50 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_summary (self));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY:
#line 50 "../src/lib/notification.vala"
		g_value_set_uint (value, budgie_notification_get_expire_timeout (self));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_CATEGORY_PROPERTY:
#line 50 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_category (self));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY:
#line 50 "../src/lib/notification.vala"
		g_value_set_int64 (value, budgie_notification_get_timestamp (self));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_IMAGE_PROPERTY:
#line 50 "../src/lib/notification.vala"
		g_value_set_object (value, budgie_notification_get_image (self));
#line 50 "../src/lib/notification.vala"
		break;
#line 2335 "notification.c"
		default:
#line 50 "../src/lib/notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 50 "../src/lib/notification.vala"
		break;
#line 2341 "notification.c"
	}
}

static void
_vala_budgie_notification_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	BudgieNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 50 "../src/lib/notification.vala"
	switch (property_id) {
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_INFO_PROPERTY:
#line 50 "../src/lib/notification.vala"
		budgie_notification_set_app_info (self, g_value_get_object (value));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_ID_PROPERTY:
#line 50 "../src/lib/notification.vala"
		budgie_notification_set_app_id (self, g_value_get_string (value));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_URGENCY_PROPERTY:
#line 50 "../src/lib/notification.vala"
		budgie_notification_set_urgency (self, g_value_get_enum (value));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ID_PROPERTY:
#line 50 "../src/lib/notification.vala"
		budgie_notification_set_id (self, g_value_get_uint (value));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_NAME_PROPERTY:
#line 50 "../src/lib/notification.vala"
		budgie_notification_set_app_name (self, g_value_get_string (value));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_HINTS_PROPERTY:
#line 50 "../src/lib/notification.vala"
		budgie_notification_set_hints (self, g_value_get_boxed (value));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ACTIONS_PROPERTY:
#line 2393 "notification.c"
		{
			gpointer boxed;
#line 50 "../src/lib/notification.vala"
			boxed = g_value_get_boxed (value);
#line 50 "../src/lib/notification.vala"
			budgie_notification_set_actions (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 2400 "notification.c"
		}
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_ICON_PROPERTY:
#line 50 "../src/lib/notification.vala"
		budgie_notification_set_app_icon (self, g_value_get_string (value));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_BODY_PROPERTY:
#line 50 "../src/lib/notification.vala"
		budgie_notification_set_body (self, g_value_get_string (value));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_SUMMARY_PROPERTY:
#line 50 "../src/lib/notification.vala"
		budgie_notification_set_summary (self, g_value_get_string (value));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY:
#line 50 "../src/lib/notification.vala"
		budgie_notification_set_expire_timeout (self, g_value_get_uint (value));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_CATEGORY_PROPERTY:
#line 50 "../src/lib/notification.vala"
		budgie_notification_set_category (self, g_value_get_string (value));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY:
#line 50 "../src/lib/notification.vala"
		budgie_notification_set_timestamp (self, g_value_get_int64 (value));
#line 50 "../src/lib/notification.vala"
		break;
#line 50 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_IMAGE_PROPERTY:
#line 50 "../src/lib/notification.vala"
		budgie_notification_set_image (self, g_value_get_object (value));
#line 50 "../src/lib/notification.vala"
		break;
#line 2446 "notification.c"
		default:
#line 50 "../src/lib/notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 50 "../src/lib/notification.vala"
		break;
#line 2452 "notification.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

