/* main_view.c generated by valac 0.56.3, the Vala compiler
 * generated from main_view.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2022 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "raven.h"
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

enum  {
	BUDGIE_MAIN_VIEW_0_PROPERTY,
	BUDGIE_MAIN_VIEW_NUM_PROPERTIES
};
static GParamSpec* budgie_main_view_properties[BUDGIE_MAIN_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	BUDGIE_MAIN_VIEW_REQUESTED_DRAW_SIGNAL,
	BUDGIE_MAIN_VIEW_NUM_SIGNALS
};
static guint budgie_main_view_signals[BUDGIE_MAIN_VIEW_NUM_SIGNALS] = {0};

struct _BudgieMainViewPrivate {
	GtkBox* box;
	MprisWidget* mpris;
	CalendarWidget* cal;
	BudgieSoundWidget* audio_input_widget;
	BudgieSoundWidget* audio_output_widget;
	GSettings* raven_settings;
	GtkStack* main_stack;
	GtkStackSwitcher* switcher;
	gchar* SHOW_SOUND_OUTPUT_WIDGET;
	gchar* SHOW_MIC_INPUT_WIDGET;
};

static gint BudgieMainView_private_offset;
static gpointer budgie_main_view_parent_class = NULL;

static void budgie_main_view_on_raven_settings_changed (BudgieMainView* self,
                                                 const gchar* key);
static void _budgie_main_view_on_raven_settings_changed_g_settings_changed (GSettings* _sender,
                                                                     const gchar* key,
                                                                     gpointer self);
static void budgie_main_view_on_name_change (BudgieMainView* self);
static void _budgie_main_view_on_name_change_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void budgie_main_view_set_sound_widget_events (BudgieMainView* self);
static void __lambda45_ (BudgieMainView* self);
static void ___lambda45__budgie_sound_widget_devices_state_changed (BudgieSoundWidget* _sender,
                                                             gpointer self);
static void __lambda46_ (BudgieMainView* self);
static void ___lambda46__budgie_sound_widget_devices_state_changed (BudgieSoundWidget* _sender,
                                                             gpointer self);
static void budgie_main_view_finalize (GObject * obj);
static GType budgie_main_view_get_type_once (void);

static inline gpointer
budgie_main_view_get_instance_private (BudgieMainView* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieMainView_private_offset);
}

void
budgie_main_view_expose_notification (BudgieMainView* self)
{
	GtkStack* _tmp0_;
#line 28 "../src/raven/main_view.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/raven/main_view.vala"
	_tmp0_ = self->priv->main_stack;
#line 29 "../src/raven/main_view.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "notifications");
#line 89 "main_view.c"
}

static void
_budgie_main_view_on_raven_settings_changed_g_settings_changed (GSettings* _sender,
                                                                const gchar* key,
                                                                gpointer self)
{
#line 35 "../src/raven/main_view.vala"
	budgie_main_view_on_raven_settings_changed ((BudgieMainView*) self, key);
#line 99 "main_view.c"
}

static void
_budgie_main_view_on_name_change_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 84 "../src/raven/main_view.vala"
	budgie_main_view_on_name_change ((BudgieMainView*) self);
#line 109 "main_view.c"
}

BudgieMainView*
budgie_main_view_construct (GType object_type)
{
	BudgieMainView * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkBox* header = NULL;
	GtkBox* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkStack* _tmp5_;
	GtkStack* _tmp6_;
	GtkStackSwitcher* _tmp7_;
	GtkStackSwitcher* _tmp8_;
	GtkStackSwitcher* _tmp9_;
	GtkStackSwitcher* _tmp10_;
	GtkStackSwitcher* _tmp11_;
	GtkStackSwitcher* _tmp12_;
	GtkStack* _tmp13_;
	GtkStackSwitcher* _tmp14_;
	GtkStack* _tmp15_;
	GtkScrolledWindow* scroll = NULL;
	GtkScrolledWindow* _tmp16_;
	GtkStack* _tmp17_;
	BudgieNotificationsView* not = NULL;
	BudgieNotificationsView* _tmp18_;
	GtkStack* _tmp19_;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	GSettings* _tmp22_;
	CalendarWidget* _tmp23_;
	GtkBox* _tmp24_;
	CalendarWidget* _tmp25_;
	BudgieSoundWidget* _tmp26_;
	GtkBox* _tmp27_;
	BudgieSoundWidget* _tmp28_;
	BudgieSoundWidget* _tmp29_;
	GtkBox* _tmp30_;
	BudgieSoundWidget* _tmp31_;
	MprisWidget* _tmp32_;
	GtkBox* _tmp33_;
	MprisWidget* _tmp34_;
	GtkStack* _tmp35_;
#line 33 "../src/raven/main_view.vala"
	self = (BudgieMainView*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, "spacing", 0, NULL);
#line 34 "../src/raven/main_view.vala"
	_tmp0_ = g_settings_new ("com.solus-project.budgie-raven");
#line 34 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->raven_settings);
#line 34 "../src/raven/main_view.vala"
	self->priv->raven_settings = _tmp0_;
#line 35 "../src/raven/main_view.vala"
	_tmp1_ = self->priv->raven_settings;
#line 35 "../src/raven/main_view.vala"
	g_signal_connect_object (_tmp1_, "changed", (GCallback) _budgie_main_view_on_raven_settings_changed_g_settings_changed, self, 0);
#line 37 "../src/raven/main_view.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 37 "../src/raven/main_view.vala"
	g_object_ref_sink (_tmp2_);
#line 37 "../src/raven/main_view.vala"
	header = _tmp2_;
#line 38 "../src/raven/main_view.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) header);
#line 38 "../src/raven/main_view.vala"
	gtk_style_context_add_class (_tmp3_, "raven-header");
#line 39 "../src/raven/main_view.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) header);
#line 39 "../src/raven/main_view.vala"
	gtk_style_context_add_class (_tmp4_, "top");
#line 40 "../src/raven/main_view.vala"
	_tmp5_ = (GtkStack*) gtk_stack_new ();
#line 40 "../src/raven/main_view.vala"
	g_object_ref_sink (_tmp5_);
#line 40 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->main_stack);
#line 40 "../src/raven/main_view.vala"
	self->priv->main_stack = _tmp5_;
#line 41 "../src/raven/main_view.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) header, FALSE, FALSE, (guint) 0);
#line 44 "../src/raven/main_view.vala"
	_tmp6_ = self->priv->main_stack;
#line 44 "../src/raven/main_view.vala"
	gtk_stack_set_transition_type (_tmp6_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
#line 45 "../src/raven/main_view.vala"
	_tmp7_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
#line 45 "../src/raven/main_view.vala"
	g_object_ref_sink (_tmp7_);
#line 45 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->switcher);
#line 45 "../src/raven/main_view.vala"
	self->priv->switcher = _tmp7_;
#line 47 "../src/raven/main_view.vala"
	_tmp8_ = self->priv->switcher;
#line 47 "../src/raven/main_view.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_CENTER);
#line 48 "../src/raven/main_view.vala"
	_tmp9_ = self->priv->switcher;
#line 48 "../src/raven/main_view.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp9_, 4);
#line 49 "../src/raven/main_view.vala"
	_tmp10_ = self->priv->switcher;
#line 49 "../src/raven/main_view.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp10_, 4);
#line 50 "../src/raven/main_view.vala"
	_tmp11_ = self->priv->switcher;
#line 50 "../src/raven/main_view.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp11_, GTK_ALIGN_CENTER);
#line 51 "../src/raven/main_view.vala"
	_tmp12_ = self->priv->switcher;
#line 51 "../src/raven/main_view.vala"
	_tmp13_ = self->priv->main_stack;
#line 51 "../src/raven/main_view.vala"
	gtk_stack_switcher_set_stack (_tmp12_, _tmp13_);
#line 52 "../src/raven/main_view.vala"
	_tmp14_ = self->priv->switcher;
#line 52 "../src/raven/main_view.vala"
	gtk_box_pack_start (header, (GtkWidget*) _tmp14_, TRUE, TRUE, (guint) 0);
#line 54 "../src/raven/main_view.vala"
	_tmp15_ = self->priv->main_stack;
#line 54 "../src/raven/main_view.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp15_, TRUE, TRUE, (guint) 0);
#line 56 "../src/raven/main_view.vala"
	_tmp16_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 56 "../src/raven/main_view.vala"
	g_object_ref_sink (_tmp16_);
#line 56 "../src/raven/main_view.vala"
	scroll = _tmp16_;
#line 57 "../src/raven/main_view.vala"
	_tmp17_ = self->priv->main_stack;
#line 57 "../src/raven/main_view.vala"
	gtk_stack_add_titled (_tmp17_, (GtkWidget*) scroll, "applets", _ ("Applets"));
#line 59 "../src/raven/main_view.vala"
	_tmp18_ = budgie_notifications_view_new ();
#line 59 "../src/raven/main_view.vala"
	g_object_ref_sink (_tmp18_);
#line 59 "../src/raven/main_view.vala"
	not = _tmp18_;
#line 60 "../src/raven/main_view.vala"
	_tmp19_ = self->priv->main_stack;
#line 60 "../src/raven/main_view.vala"
	gtk_stack_add_titled (_tmp19_, (GtkWidget*) not, "notifications", _ ("Notifications"));
#line 62 "../src/raven/main_view.vala"
	gtk_scrolled_window_set_policy (scroll, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
#line 65 "../src/raven/main_view.vala"
	_tmp20_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 65 "../src/raven/main_view.vala"
	g_object_ref_sink (_tmp20_);
#line 65 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->box);
#line 65 "../src/raven/main_view.vala"
	self->priv->box = _tmp20_;
#line 66 "../src/raven/main_view.vala"
	_tmp21_ = self->priv->box;
#line 66 "../src/raven/main_view.vala"
	gtk_container_add ((GtkContainer*) scroll, (GtkWidget*) _tmp21_);
#line 68 "../src/raven/main_view.vala"
	_tmp22_ = self->priv->raven_settings;
#line 68 "../src/raven/main_view.vala"
	_tmp23_ = calendar_widget_new (_tmp22_);
#line 68 "../src/raven/main_view.vala"
	g_object_ref_sink (_tmp23_);
#line 68 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->cal);
#line 68 "../src/raven/main_view.vala"
	self->priv->cal = _tmp23_;
#line 69 "../src/raven/main_view.vala"
	_tmp24_ = self->priv->box;
#line 69 "../src/raven/main_view.vala"
	_tmp25_ = self->priv->cal;
#line 69 "../src/raven/main_view.vala"
	gtk_box_pack_start (_tmp24_, (GtkWidget*) _tmp25_, FALSE, FALSE, (guint) 0);
#line 71 "../src/raven/main_view.vala"
	_tmp26_ = budgie_sound_widget_new ("output");
#line 71 "../src/raven/main_view.vala"
	g_object_ref_sink (_tmp26_);
#line 71 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->audio_output_widget);
#line 71 "../src/raven/main_view.vala"
	self->priv->audio_output_widget = _tmp26_;
#line 72 "../src/raven/main_view.vala"
	_tmp27_ = self->priv->box;
#line 72 "../src/raven/main_view.vala"
	_tmp28_ = self->priv->audio_output_widget;
#line 72 "../src/raven/main_view.vala"
	gtk_box_pack_start (_tmp27_, (GtkWidget*) _tmp28_, FALSE, FALSE, (guint) 0);
#line 74 "../src/raven/main_view.vala"
	_tmp29_ = budgie_sound_widget_new ("input");
#line 74 "../src/raven/main_view.vala"
	g_object_ref_sink (_tmp29_);
#line 74 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->audio_input_widget);
#line 74 "../src/raven/main_view.vala"
	self->priv->audio_input_widget = _tmp29_;
#line 75 "../src/raven/main_view.vala"
	_tmp30_ = self->priv->box;
#line 75 "../src/raven/main_view.vala"
	_tmp31_ = self->priv->audio_input_widget;
#line 75 "../src/raven/main_view.vala"
	gtk_box_pack_start (_tmp30_, (GtkWidget*) _tmp31_, FALSE, FALSE, (guint) 0);
#line 77 "../src/raven/main_view.vala"
	_tmp32_ = mpris_widget_new ();
#line 77 "../src/raven/main_view.vala"
	g_object_ref_sink (_tmp32_);
#line 77 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->mpris);
#line 77 "../src/raven/main_view.vala"
	self->priv->mpris = _tmp32_;
#line 78 "../src/raven/main_view.vala"
	_tmp33_ = self->priv->box;
#line 78 "../src/raven/main_view.vala"
	_tmp34_ = self->priv->mpris;
#line 78 "../src/raven/main_view.vala"
	gtk_box_pack_start (_tmp33_, (GtkWidget*) _tmp34_, FALSE, FALSE, (guint) 0);
#line 82 "../src/raven/main_view.vala"
	gtk_widget_show_all ((GtkWidget*) scroll);
#line 84 "../src/raven/main_view.vala"
	_tmp35_ = self->priv->main_stack;
#line 84 "../src/raven/main_view.vala"
	g_signal_connect_object ((GObject*) _tmp35_, "notify::visible-child-name", (GCallback) _budgie_main_view_on_name_change_g_object_notify, self, 0);
#line 85 "../src/raven/main_view.vala"
	budgie_main_view_set_clean (self);
#line 86 "../src/raven/main_view.vala"
	budgie_main_view_set_sound_widget_events (self);
#line 32 "../src/raven/main_view.vala"
	_g_object_unref0 (not);
#line 32 "../src/raven/main_view.vala"
	_g_object_unref0 (scroll);
#line 32 "../src/raven/main_view.vala"
	_g_object_unref0 (header);
#line 32 "../src/raven/main_view.vala"
	return self;
#line 343 "main_view.c"
}

BudgieMainView*
budgie_main_view_new (void)
{
#line 32 "../src/raven/main_view.vala"
	return budgie_main_view_construct (BUDGIE_TYPE_MAIN_VIEW);
#line 351 "main_view.c"
}

static void
__lambda45_ (BudgieMainView* self)
{
	const gchar* _tmp0_;
#line 91 "../src/raven/main_view.vala"
	_tmp0_ = self->priv->SHOW_SOUND_OUTPUT_WIDGET;
#line 91 "../src/raven/main_view.vala"
	budgie_main_view_on_raven_settings_changed (self, _tmp0_);
#line 362 "main_view.c"
}

static void
___lambda45__budgie_sound_widget_devices_state_changed (BudgieSoundWidget* _sender,
                                                        gpointer self)
{
#line 90 "../src/raven/main_view.vala"
	__lambda45_ ((BudgieMainView*) self);
#line 371 "main_view.c"
}

static void
__lambda46_ (BudgieMainView* self)
{
	const gchar* _tmp0_;
#line 95 "../src/raven/main_view.vala"
	_tmp0_ = self->priv->SHOW_MIC_INPUT_WIDGET;
#line 95 "../src/raven/main_view.vala"
	budgie_main_view_on_raven_settings_changed (self, _tmp0_);
#line 382 "main_view.c"
}

static void
___lambda46__budgie_sound_widget_devices_state_changed (BudgieSoundWidget* _sender,
                                                        gpointer self)
{
#line 94 "../src/raven/main_view.vala"
	__lambda46_ ((BudgieMainView*) self);
#line 391 "main_view.c"
}

static void
budgie_main_view_set_sound_widget_events (BudgieMainView* self)
{
	BudgieSoundWidget* _tmp0_;
	BudgieSoundWidget* _tmp1_;
#line 89 "../src/raven/main_view.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/raven/main_view.vala"
	_tmp0_ = self->priv->audio_output_widget;
#line 90 "../src/raven/main_view.vala"
	g_signal_connect_object (_tmp0_, "devices-state-changed", (GCallback) ___lambda45__budgie_sound_widget_devices_state_changed, self, 0);
#line 94 "../src/raven/main_view.vala"
	_tmp1_ = self->priv->audio_input_widget;
#line 94 "../src/raven/main_view.vala"
	g_signal_connect_object (_tmp1_, "devices-state-changed", (GCallback) ___lambda46__budgie_sound_widget_devices_state_changed, self, 0);
#line 409 "main_view.c"
}

static void
budgie_main_view_on_name_change (BudgieMainView* self)
{
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
#line 99 "../src/raven/main_view.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/raven/main_view.vala"
	_tmp0_ = self->priv->main_stack;
#line 100 "../src/raven/main_view.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 100 "../src/raven/main_view.vala"
	if (g_strcmp0 (_tmp1_, "notifications") == 0) {
#line 425 "main_view.c"
		BudgieRaven* _tmp2_;
#line 101 "../src/raven/main_view.vala"
		_tmp2_ = budgie_raven_get_instance ();
#line 101 "../src/raven/main_view.vala"
		budgie_raven_ReadNotifications (_tmp2_);
#line 431 "main_view.c"
	}
}

/**
* on_raven_settings_changed will handle when the settings for Raven widgets have changed
*/
static void
budgie_main_view_on_raven_settings_changed (BudgieMainView* self,
                                            const gchar* key)
{
	gboolean show_widget = FALSE;
	GSettings* _tmp0_;
#line 108 "../src/raven/main_view.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/raven/main_view.vala"
	g_return_if_fail (key != NULL);
#line 111 "../src/raven/main_view.vala"
	if (g_strcmp0 (key, "raven-position") == 0) {
#line 112 "../src/raven/main_view.vala"
		return;
#line 452 "main_view.c"
	}
#line 115 "../src/raven/main_view.vala"
	_tmp0_ = self->priv->raven_settings;
#line 115 "../src/raven/main_view.vala"
	show_widget = g_settings_get_boolean (_tmp0_, key);
#line 121 "../src/raven/main_view.vala"
	if (g_strcmp0 (key, "show-calendar-widget") == 0) {
#line 460 "main_view.c"
		CalendarWidget* _tmp1_;
#line 122 "../src/raven/main_view.vala"
		_tmp1_ = self->priv->cal;
#line 122 "../src/raven/main_view.vala"
		raven_widget_set_show ((RavenWidget*) _tmp1_, show_widget);
#line 466 "main_view.c"
	} else {
		const gchar* _tmp2_;
#line 123 "../src/raven/main_view.vala"
		_tmp2_ = self->priv->SHOW_SOUND_OUTPUT_WIDGET;
#line 123 "../src/raven/main_view.vala"
		if (g_strcmp0 (key, _tmp2_) == 0) {
#line 473 "main_view.c"
			BudgieSoundWidget* _tmp3_;
#line 124 "../src/raven/main_view.vala"
			_tmp3_ = self->priv->audio_output_widget;
#line 124 "../src/raven/main_view.vala"
			if (budgie_sound_widget_has_devices (_tmp3_)) {
#line 479 "main_view.c"
				BudgieSoundWidget* _tmp4_;
#line 125 "../src/raven/main_view.vala"
				_tmp4_ = self->priv->audio_output_widget;
#line 125 "../src/raven/main_view.vala"
				raven_widget_set_show ((RavenWidget*) _tmp4_, show_widget);
#line 485 "main_view.c"
			} else {
				BudgieSoundWidget* _tmp5_;
#line 127 "../src/raven/main_view.vala"
				_tmp5_ = self->priv->audio_output_widget;
#line 127 "../src/raven/main_view.vala"
				raven_widget_set_show ((RavenWidget*) _tmp5_, FALSE);
#line 492 "main_view.c"
			}
		} else {
			const gchar* _tmp6_;
#line 129 "../src/raven/main_view.vala"
			_tmp6_ = self->priv->SHOW_MIC_INPUT_WIDGET;
#line 129 "../src/raven/main_view.vala"
			if (g_strcmp0 (key, _tmp6_) == 0) {
#line 500 "main_view.c"
				BudgieSoundWidget* _tmp7_;
#line 130 "../src/raven/main_view.vala"
				_tmp7_ = self->priv->audio_input_widget;
#line 130 "../src/raven/main_view.vala"
				if (budgie_sound_widget_has_devices (_tmp7_)) {
#line 506 "main_view.c"
					BudgieSoundWidget* _tmp8_;
#line 131 "../src/raven/main_view.vala"
					_tmp8_ = self->priv->audio_input_widget;
#line 131 "../src/raven/main_view.vala"
					raven_widget_set_show ((RavenWidget*) _tmp8_, show_widget);
#line 512 "main_view.c"
				} else {
					BudgieSoundWidget* _tmp9_;
#line 133 "../src/raven/main_view.vala"
					_tmp9_ = self->priv->audio_input_widget;
#line 133 "../src/raven/main_view.vala"
					raven_widget_set_show ((RavenWidget*) _tmp9_, FALSE);
#line 519 "main_view.c"
				}
			} else {
#line 135 "../src/raven/main_view.vala"
				if (g_strcmp0 (key, "show-mpris-widget") == 0) {
#line 524 "main_view.c"
					MprisWidget* _tmp10_;
#line 136 "../src/raven/main_view.vala"
					_tmp10_ = self->priv->mpris;
#line 136 "../src/raven/main_view.vala"
					raven_widget_set_show ((RavenWidget*) _tmp10_, show_widget);
#line 530 "main_view.c"
				}
			}
		}
	}
#line 139 "../src/raven/main_view.vala"
	g_signal_emit (self, budgie_main_view_signals[BUDGIE_MAIN_VIEW_REQUESTED_DRAW_SIGNAL], 0);
#line 537 "main_view.c"
}

void
budgie_main_view_set_clean (BudgieMainView* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GtkStack* _tmp2_;
#line 142 "../src/raven/main_view.vala"
	g_return_if_fail (self != NULL);
#line 143 "../src/raven/main_view.vala"
	budgie_main_view_on_raven_settings_changed (self, "show-calendar-widget");
#line 144 "../src/raven/main_view.vala"
	_tmp0_ = self->priv->SHOW_SOUND_OUTPUT_WIDGET;
#line 144 "../src/raven/main_view.vala"
	budgie_main_view_on_raven_settings_changed (self, _tmp0_);
#line 145 "../src/raven/main_view.vala"
	_tmp1_ = self->priv->SHOW_MIC_INPUT_WIDGET;
#line 145 "../src/raven/main_view.vala"
	budgie_main_view_on_raven_settings_changed (self, _tmp1_);
#line 146 "../src/raven/main_view.vala"
	budgie_main_view_on_raven_settings_changed (self, "show-mpris-widget");
#line 147 "../src/raven/main_view.vala"
	_tmp2_ = self->priv->main_stack;
#line 147 "../src/raven/main_view.vala"
	gtk_stack_set_visible_child_name (_tmp2_, "applets");
#line 564 "main_view.c"
}

static void
budgie_main_view_class_init (BudgieMainViewClass * klass,
                             gpointer klass_data)
{
#line 13 "../src/raven/main_view.vala"
	budgie_main_view_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/raven/main_view.vala"
	g_type_class_adjust_private_offset (klass, &BudgieMainView_private_offset);
#line 13 "../src/raven/main_view.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_main_view_finalize;
#line 13 "../src/raven/main_view.vala"
	budgie_main_view_signals[BUDGIE_MAIN_VIEW_REQUESTED_DRAW_SIGNAL] = g_signal_new ("requested-draw", BUDGIE_TYPE_MAIN_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 579 "main_view.c"
}

static void
budgie_main_view_instance_init (BudgieMainView * self,
                                gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 13 "../src/raven/main_view.vala"
	self->priv = budgie_main_view_get_instance_private (self);
#line 14 "../src/raven/main_view.vala"
	self->priv->box = NULL;
#line 15 "../src/raven/main_view.vala"
	self->priv->mpris = NULL;
#line 16 "../src/raven/main_view.vala"
	self->priv->cal = NULL;
#line 17 "../src/raven/main_view.vala"
	self->priv->audio_input_widget = NULL;
#line 18 "../src/raven/main_view.vala"
	self->priv->audio_output_widget = NULL;
#line 19 "../src/raven/main_view.vala"
	self->priv->raven_settings = NULL;
#line 21 "../src/raven/main_view.vala"
	self->priv->main_stack = NULL;
#line 22 "../src/raven/main_view.vala"
	self->priv->switcher = NULL;
#line 23 "../src/raven/main_view.vala"
	_tmp0_ = g_strdup ("show-sound-output-widget");
#line 23 "../src/raven/main_view.vala"
	self->priv->SHOW_SOUND_OUTPUT_WIDGET = _tmp0_;
#line 24 "../src/raven/main_view.vala"
	_tmp1_ = g_strdup ("show-mic-input-widget");
#line 24 "../src/raven/main_view.vala"
	self->priv->SHOW_MIC_INPUT_WIDGET = _tmp1_;
#line 614 "main_view.c"
}

static void
budgie_main_view_finalize (GObject * obj)
{
	BudgieMainView * self;
#line 13 "../src/raven/main_view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_MAIN_VIEW, BudgieMainView);
#line 14 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->box);
#line 15 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->mpris);
#line 16 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->cal);
#line 17 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->audio_input_widget);
#line 18 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->audio_output_widget);
#line 19 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->raven_settings);
#line 21 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->main_stack);
#line 22 "../src/raven/main_view.vala"
	_g_object_unref0 (self->priv->switcher);
#line 23 "../src/raven/main_view.vala"
	_g_free0 (self->priv->SHOW_SOUND_OUTPUT_WIDGET);
#line 24 "../src/raven/main_view.vala"
	_g_free0 (self->priv->SHOW_MIC_INPUT_WIDGET);
#line 13 "../src/raven/main_view.vala"
	G_OBJECT_CLASS (budgie_main_view_parent_class)->finalize (obj);
#line 645 "main_view.c"
}

static GType
budgie_main_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieMainViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_main_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieMainView), 0, (GInstanceInitFunc) budgie_main_view_instance_init, NULL };
	GType budgie_main_view_type_id;
	budgie_main_view_type_id = g_type_register_static (gtk_box_get_type (), "BudgieMainView", &g_define_type_info, 0);
	BudgieMainView_private_offset = g_type_add_instance_private (budgie_main_view_type_id, sizeof (BudgieMainViewPrivate));
	return budgie_main_view_type_id;
}

GType
budgie_main_view_get_type (void)
{
	static volatile gsize budgie_main_view_type_id__once = 0;
	if (g_once_init_enter (&budgie_main_view_type_id__once)) {
		GType budgie_main_view_type_id;
		budgie_main_view_type_id = budgie_main_view_get_type_once ();
		g_once_init_leave (&budgie_main_view_type_id__once, budgie_main_view_type_id);
	}
	return budgie_main_view_type_id__once;
}

