/* sound.c generated by valac 0.56.3, the Vala compiler
 * generated from sound.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2022 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "raven.h"
#include <gio/gio.h>
#include <glib.h>
#include <pulse/pulseaudio.h>
#include <gvc-mixer-control.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gvc-mixer-stream.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gvc-mixer-card.h>
#include <gvc-mixer-ui-device.h>
#include <pango/pango.h>
#include <gvc-channel-map.h>

#define BUDGIE_SOUND_WIDGET_MAX_KEY "allow-volume-overdrive"

enum  {
	BUDGIE_SOUND_WIDGET_0_PROPERTY,
	BUDGIE_SOUND_WIDGET_NUM_PROPERTIES
};
static GParamSpec* budgie_sound_widget_properties[BUDGIE_SOUND_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block7Data Block7Data;
enum  {
	BUDGIE_SOUND_WIDGET_DEVICES_STATE_CHANGED_SIGNAL,
	BUDGIE_SOUND_WIDGET_NUM_SIGNALS
};
static guint budgie_sound_widget_signals[BUDGIE_SOUND_WIDGET_NUM_SIGNALS] = {0};

struct _BudgieSoundWidgetPrivate {
	GSettings* budgie_settings;
	GSettings* gnome_desktop_settings;
	GSettings* raven_settings;
	gulong scale_id;
	GvcMixerControl* mixer;
	GHashTable* apps;
	GHashTable* derpers;
	GHashTable* devices;
	gulong primary_notify_id;
	GvcMixerStream* primary_stream;
	GSettings* settings;
	gchar* widget_type;
	BudgieHeaderWidget* header;
	GtkBox* apps_area;
	GtkListBox* apps_listbox;
	GtkRevealer* apps_list_revealer;
	GtkListBox* devices_list;
	BudgieStartListening* listening_box;
	GtkRevealer* listening_box_revealer;
	GtkBox* main_layout;
	GtkStack* widget_area;
	GtkStackSwitcher* widget_area_switch;
	GtkScale* volume_slider;
};

struct _Block7Data {
	int _ref_count_;
	BudgieSoundWidget* self;
	BudgieAppSoundControl* control;
};

static gint BudgieSoundWidget_private_offset;
static gpointer budgie_sound_widget_parent_class = NULL;

static void __lambda23_ (BudgieSoundWidget* self,
                  guint id);
static void ___lambda23__gvc_mixer_control_card_added (GvcMixerControl* _sender,
                                                guint id,
                                                gpointer self);
static void __lambda24_ (BudgieSoundWidget* self,
                  guint id);
static void ___lambda24__gvc_mixer_control_card_removed (GvcMixerControl* _sender,
                                                  guint id,
                                                  gpointer self);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void budgie_sound_widget_on_device_selected (BudgieSoundWidget* self,
                                             GtkListBoxRow* list_item);
static void _budgie_sound_widget_on_device_selected_gtk_list_box_row_selected (GtkListBox* _sender,
                                                                        GtkListBoxRow* row,
                                                                        gpointer self);
static void budgie_sound_widget_on_scale_change (BudgieSoundWidget* self);
static void _budgie_sound_widget_on_scale_change_gtk_range_value_changed (GtkRange* _sender,
                                                                   gpointer self);
static void budgie_sound_widget_on_device_changed (BudgieSoundWidget* self,
                                            guint id);
static void _budgie_sound_widget_on_device_changed_gvc_mixer_control_default_source_changed (GvcMixerControl* _sender,
                                                                                      guint id,
                                                                                      gpointer self);
static void budgie_sound_widget_on_state_changed (BudgieSoundWidget* self,
                                           guint id);
static void _budgie_sound_widget_on_state_changed_gvc_mixer_control_state_changed (GvcMixerControl* _sender,
                                                                            guint new_state,
                                                                            gpointer self);
static void budgie_sound_widget_on_device_added (BudgieSoundWidget* self,
                                          guint id);
static void _budgie_sound_widget_on_device_added_gvc_mixer_control_input_added (GvcMixerControl* _sender,
                                                                         guint id,
                                                                         gpointer self);
static void budgie_sound_widget_on_device_removed (BudgieSoundWidget* self,
                                            guint id);
static void _budgie_sound_widget_on_device_removed_gvc_mixer_control_input_removed (GvcMixerControl* _sender,
                                                                             guint id,
                                                                             gpointer self);
static void _budgie_sound_widget_on_device_changed_gvc_mixer_control_default_sink_changed (GvcMixerControl* _sender,
                                                                                    guint id,
                                                                                    gpointer self);
static void _budgie_sound_widget_on_device_added_gvc_mixer_control_output_added (GvcMixerControl* _sender,
                                                                          guint id,
                                                                          gpointer self);
static void _budgie_sound_widget_on_device_removed_gvc_mixer_control_output_removed (GvcMixerControl* _sender,
                                                                              guint id,
                                                                              gpointer self);
static void budgie_sound_widget_on_stream_added (BudgieSoundWidget* self,
                                          guint id);
static void _budgie_sound_widget_on_stream_added_gvc_mixer_control_stream_added (GvcMixerControl* _sender,
                                                                          guint id,
                                                                          gpointer self);
static void budgie_sound_widget_on_stream_removed (BudgieSoundWidget* self,
                                            guint id);
static void _budgie_sound_widget_on_stream_removed_gvc_mixer_control_stream_removed (GvcMixerControl* _sender,
                                                                              guint id,
                                                                              gpointer self);
static void budgie_sound_widget_on_volume_safety_changed (BudgieSoundWidget* self);
static void _budgie_sound_widget_on_volume_safety_changed_g_settings_changed (GSettings* _sender,
                                                                       const gchar* key,
                                                                       gpointer self);
static void budgie_sound_widget_update_input_draw_markers (BudgieSoundWidget* self);
static void _budgie_sound_widget_update_input_draw_markers_g_settings_changed (GSettings* _sender,
                                                                        const gchar* key,
                                                                        gpointer self);
static gint ___lambda27_ (BudgieSoundWidget* self,
                   GtkListBoxRow* row1,
                   GtkListBoxRow* row2);
static gint ____lambda27__gtk_list_box_sort_func (GtkListBoxRow* row1,
                                           GtkListBoxRow* row2,
                                           gpointer self);
static void budgie_sound_widget_set_slider_range_on_max (BudgieSoundWidget* self,
                                                  gboolean allow_overdrive);
static void budgie_sound_widget_toggle_start_listening (BudgieSoundWidget* self);
static void __lambda25_ (BudgieSoundWidget* self,
                  GObject* n,
                  GParamSpec* p);
static void budgie_sound_widget_update_volume (BudgieSoundWidget* self);
static void ___lambda25__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static BudgieAppSoundControl* budgie_sound_widget_get_control_for_app (BudgieSoundWidget* self,
                                                                guint id);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _____lambda26_ (Block7Data* _data7_);
static void ______lambda26__gvc_channel_map_volume_changed (GvcChannelMap* _sender,
                                                     gboolean set,
                                                     gpointer self);
static void budgie_sound_widget_finalize (GObject * obj);
static GType budgie_sound_widget_get_type_once (void);

static inline gpointer
budgie_sound_widget_get_instance_private (BudgieSoundWidget* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieSoundWidget_private_offset);
}

static void
__lambda23_ (BudgieSoundWidget* self,
             guint id)
{
#line 62 "../src/raven/sound.vala"
	g_signal_emit (self, budgie_sound_widget_signals[BUDGIE_SOUND_WIDGET_DEVICES_STATE_CHANGED_SIGNAL], 0);
#line 192 "sound.c"
}

static void
___lambda23__gvc_mixer_control_card_added (GvcMixerControl* _sender,
                                           guint id,
                                           gpointer self)
{
#line 61 "../src/raven/sound.vala"
	__lambda23_ ((BudgieSoundWidget*) self, id);
#line 202 "sound.c"
}

static void
__lambda24_ (BudgieSoundWidget* self,
             guint id)
{
#line 66 "../src/raven/sound.vala"
	g_signal_emit (self, budgie_sound_widget_signals[BUDGIE_SOUND_WIDGET_DEVICES_STATE_CHANGED_SIGNAL], 0);
#line 211 "sound.c"
}

static void
___lambda24__gvc_mixer_control_card_removed (GvcMixerControl* _sender,
                                             guint id,
                                             gpointer self)
{
#line 65 "../src/raven/sound.vala"
	__lambda24_ ((BudgieSoundWidget*) self, id);
#line 221 "sound.c"
}

static void
_g_free0_ (gpointer var)
{
#line 69 "../src/raven/sound.vala"
	var = (g_free (var), NULL);
#line 229 "sound.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 72 "../src/raven/sound.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 237 "sound.c"
}

static void
_budgie_sound_widget_on_device_selected_gtk_list_box_row_selected (GtkListBox* _sender,
                                                                   GtkListBoxRow* row,
                                                                   gpointer self)
{
#line 81 "../src/raven/sound.vala"
	budgie_sound_widget_on_device_selected ((BudgieSoundWidget*) self, row);
#line 247 "sound.c"
}

static void
_budgie_sound_widget_on_scale_change_gtk_range_value_changed (GtkRange* _sender,
                                                              gpointer self)
{
#line 86 "../src/raven/sound.vala"
	budgie_sound_widget_on_scale_change ((BudgieSoundWidget*) self);
#line 256 "sound.c"
}

static void
_budgie_sound_widget_on_device_changed_gvc_mixer_control_default_source_changed (GvcMixerControl* _sender,
                                                                                 guint id,
                                                                                 gpointer self)
{
#line 92 "../src/raven/sound.vala"
	budgie_sound_widget_on_device_changed ((BudgieSoundWidget*) self, id);
#line 266 "sound.c"
}

static void
_budgie_sound_widget_on_state_changed_gvc_mixer_control_state_changed (GvcMixerControl* _sender,
                                                                       guint new_state,
                                                                       gpointer self)
{
#line 93 "../src/raven/sound.vala"
	budgie_sound_widget_on_state_changed ((BudgieSoundWidget*) self, new_state);
#line 276 "sound.c"
}

static void
_budgie_sound_widget_on_device_added_gvc_mixer_control_input_added (GvcMixerControl* _sender,
                                                                    guint id,
                                                                    gpointer self)
{
#line 94 "../src/raven/sound.vala"
	budgie_sound_widget_on_device_added ((BudgieSoundWidget*) self, id);
#line 286 "sound.c"
}

static void
_budgie_sound_widget_on_device_removed_gvc_mixer_control_input_removed (GvcMixerControl* _sender,
                                                                        guint id,
                                                                        gpointer self)
{
#line 95 "../src/raven/sound.vala"
	budgie_sound_widget_on_device_removed ((BudgieSoundWidget*) self, id);
#line 296 "sound.c"
}

static void
_budgie_sound_widget_on_device_changed_gvc_mixer_control_default_sink_changed (GvcMixerControl* _sender,
                                                                               guint id,
                                                                               gpointer self)
{
#line 111 "../src/raven/sound.vala"
	budgie_sound_widget_on_device_changed ((BudgieSoundWidget*) self, id);
#line 306 "sound.c"
}

static void
_budgie_sound_widget_on_device_added_gvc_mixer_control_output_added (GvcMixerControl* _sender,
                                                                     guint id,
                                                                     gpointer self)
{
#line 112 "../src/raven/sound.vala"
	budgie_sound_widget_on_device_added ((BudgieSoundWidget*) self, id);
#line 316 "sound.c"
}

static void
_budgie_sound_widget_on_device_removed_gvc_mixer_control_output_removed (GvcMixerControl* _sender,
                                                                         guint id,
                                                                         gpointer self)
{
#line 113 "../src/raven/sound.vala"
	budgie_sound_widget_on_device_removed ((BudgieSoundWidget*) self, id);
#line 326 "sound.c"
}

static void
_budgie_sound_widget_on_stream_added_gvc_mixer_control_stream_added (GvcMixerControl* _sender,
                                                                     guint id,
                                                                     gpointer self)
{
#line 115 "../src/raven/sound.vala"
	budgie_sound_widget_on_stream_added ((BudgieSoundWidget*) self, id);
#line 336 "sound.c"
}

static void
_budgie_sound_widget_on_stream_removed_gvc_mixer_control_stream_removed (GvcMixerControl* _sender,
                                                                         guint id,
                                                                         gpointer self)
{
#line 116 "../src/raven/sound.vala"
	budgie_sound_widget_on_stream_removed ((BudgieSoundWidget*) self, id);
#line 346 "sound.c"
}

static void
_budgie_sound_widget_on_volume_safety_changed_g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self)
{
#line 117 "../src/raven/sound.vala"
	budgie_sound_widget_on_volume_safety_changed ((BudgieSoundWidget*) self);
#line 356 "sound.c"
}

static void
_budgie_sound_widget_update_input_draw_markers_g_settings_changed (GSettings* _sender,
                                                                   const gchar* key,
                                                                   gpointer self)
{
#line 119 "../src/raven/sound.vala"
	budgie_sound_widget_update_input_draw_markers ((BudgieSoundWidget*) self);
#line 366 "sound.c"
}

static gint
___lambda27_ (BudgieSoundWidget* self,
              GtkListBoxRow* row1,
              GtkListBoxRow* row2)
{
	gchar* app_1 = NULL;
	GtkWidget* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* app_2 = NULL;
	GtkWidget* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp6_ = 0;
	GCompareFunc _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gint result;
#line 132 "../src/raven/sound.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 132 "../src/raven/sound.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 133 "../src/raven/sound.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row1);
#line 133 "../src/raven/sound.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, BUDGIE_TYPE_APP_SOUND_CONTROL, BudgieAppSoundControl)->app_name;
#line 133 "../src/raven/sound.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 133 "../src/raven/sound.vala"
	app_1 = _tmp2_;
#line 134 "../src/raven/sound.vala"
	_tmp3_ = gtk_bin_get_child ((GtkBin*) row2);
#line 134 "../src/raven/sound.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, BUDGIE_TYPE_APP_SOUND_CONTROL, BudgieAppSoundControl)->app_name;
#line 134 "../src/raven/sound.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 134 "../src/raven/sound.vala"
	app_2 = _tmp5_;
#line 135 "../src/raven/sound.vala"
	_tmp7_ = ((GCompareFunc) g_strcmp0);
#line 135 "../src/raven/sound.vala"
	_tmp8_ = app_1;
#line 135 "../src/raven/sound.vala"
	_tmp9_ = app_2;
#line 135 "../src/raven/sound.vala"
	if (_tmp7_ (_tmp8_, _tmp9_) <= 0) {
#line 135 "../src/raven/sound.vala"
		_tmp6_ = -1;
#line 417 "sound.c"
	} else {
#line 135 "../src/raven/sound.vala"
		_tmp6_ = 1;
#line 421 "sound.c"
	}
#line 135 "../src/raven/sound.vala"
	result = _tmp6_;
#line 135 "../src/raven/sound.vala"
	_g_free0 (app_2);
#line 135 "../src/raven/sound.vala"
	_g_free0 (app_1);
#line 135 "../src/raven/sound.vala"
	return result;
#line 431 "sound.c"
}

static gint
____lambda27__gtk_list_box_sort_func (GtkListBoxRow* row1,
                                      GtkListBoxRow* row2,
                                      gpointer self)
{
	gint result;
	result = ___lambda27_ ((BudgieSoundWidget*) self, row1, row2);
#line 132 "../src/raven/sound.vala"
	return result;
#line 443 "sound.c"
}

BudgieSoundWidget*
budgie_sound_widget_construct (GType object_type,
                               const gchar* c_widget_type)
{
	BudgieSoundWidget * self = NULL;
	GtkStyleContext* _tmp0_;
	gchar* _tmp1_;
	GvcMixerControl* _tmp2_;
	GvcMixerControl* _tmp3_;
	GvcMixerControl* _tmp4_;
	GHashFunc _tmp5_;
	GEqualFunc _tmp6_;
	GHashTable* _tmp7_;
	GHashTable* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GHashTable* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GHashFunc _tmp14_;
	GEqualFunc _tmp15_;
	GHashTable* _tmp16_;
	GtkListBox* _tmp17_;
	GtkListBox* _tmp18_;
	GtkStyleContext* _tmp19_;
	GtkListBox* _tmp20_;
	GtkStyleContext* _tmp21_;
	GtkListBox* _tmp22_;
	GtkListBox* _tmp23_;
	GtkBox* _tmp24_;
	GtkScale* _tmp25_;
	GtkScale* _tmp26_;
	GtkScale* _tmp27_;
	const gchar* _tmp28_;
	GvcMixerControl* _tmp101_;
	BudgieRavenExpander* expander = NULL;
	BudgieHeaderWidget* _tmp102_;
	BudgieRavenExpander* _tmp103_;
	BudgieRavenExpander* _tmp104_;
	const gchar* _tmp105_;
	BudgieRavenExpander* _tmp106_;
	GtkEventBox* ebox = NULL;
	GtkEventBox* _tmp107_;
	GtkEventBox* _tmp108_;
	GtkStyleContext* _tmp109_;
	BudgieRavenExpander* _tmp110_;
	GtkEventBox* _tmp111_;
	GtkEventBox* _tmp112_;
	GtkBox* _tmp113_;
	const gchar* _tmp114_;
#line 51 "../src/raven/sound.vala"
	g_return_val_if_fail (c_widget_type != NULL, NULL);
#line 52 "../src/raven/sound.vala"
	self = (BudgieSoundWidget*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, NULL);
#line 53 "../src/raven/sound.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 53 "../src/raven/sound.vala"
	gtk_style_context_add_class (_tmp0_, "audio-widget");
#line 54 "../src/raven/sound.vala"
	_tmp1_ = g_strdup (c_widget_type);
#line 54 "../src/raven/sound.vala"
	_g_free0 (self->priv->widget_type);
#line 54 "../src/raven/sound.vala"
	self->priv->widget_type = _tmp1_;
#line 59 "../src/raven/sound.vala"
	_tmp2_ = gvc_mixer_control_new ("Budgie Volume Control");
#line 59 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->mixer);
#line 59 "../src/raven/sound.vala"
	self->priv->mixer = _tmp2_;
#line 61 "../src/raven/sound.vala"
	_tmp3_ = self->priv->mixer;
#line 61 "../src/raven/sound.vala"
	g_signal_connect_object (_tmp3_, "card-added", (GCallback) ___lambda23__gvc_mixer_control_card_added, self, 0);
#line 65 "../src/raven/sound.vala"
	_tmp4_ = self->priv->mixer;
#line 65 "../src/raven/sound.vala"
	g_signal_connect_object (_tmp4_, "card-removed", (GCallback) ___lambda24__gvc_mixer_control_card_removed, self, 0);
#line 69 "../src/raven/sound.vala"
	_tmp5_ = g_str_hash;
#line 69 "../src/raven/sound.vala"
	_tmp6_ = g_str_equal;
#line 69 "../src/raven/sound.vala"
	_tmp7_ = g_hash_table_new_full (_tmp5_, _tmp6_, _g_free0_, _g_free0_);
#line 69 "../src/raven/sound.vala"
	_g_hash_table_unref0 (self->priv->derpers);
#line 69 "../src/raven/sound.vala"
	self->priv->derpers = _tmp7_;
#line 70 "../src/raven/sound.vala"
	_tmp8_ = self->priv->derpers;
#line 70 "../src/raven/sound.vala"
	_tmp9_ = g_strdup ("Vivaldi");
#line 70 "../src/raven/sound.vala"
	_tmp10_ = g_strdup ("vivaldi");
#line 70 "../src/raven/sound.vala"
	g_hash_table_insert (_tmp8_, _tmp9_, _tmp10_);
#line 71 "../src/raven/sound.vala"
	_tmp11_ = self->priv->derpers;
#line 71 "../src/raven/sound.vala"
	_tmp12_ = g_strdup ("Vivaldi Snapshot");
#line 71 "../src/raven/sound.vala"
	_tmp13_ = g_strdup ("vivaldi-snapshot");
#line 71 "../src/raven/sound.vala"
	g_hash_table_insert (_tmp11_, _tmp12_, _tmp13_);
#line 72 "../src/raven/sound.vala"
	_tmp14_ = g_direct_hash;
#line 72 "../src/raven/sound.vala"
	_tmp15_ = g_direct_equal;
#line 72 "../src/raven/sound.vala"
	_tmp16_ = g_hash_table_new_full (_tmp14_, _tmp15_, NULL, _g_object_unref0_);
#line 72 "../src/raven/sound.vala"
	_g_hash_table_unref0 (self->priv->devices);
#line 72 "../src/raven/sound.vala"
	self->priv->devices = _tmp16_;
#line 77 "../src/raven/sound.vala"
	_tmp17_ = (GtkListBox*) gtk_list_box_new ();
#line 77 "../src/raven/sound.vala"
	g_object_ref_sink (_tmp17_);
#line 77 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->devices_list);
#line 77 "../src/raven/sound.vala"
	self->priv->devices_list = _tmp17_;
#line 78 "../src/raven/sound.vala"
	_tmp18_ = self->priv->devices_list;
#line 78 "../src/raven/sound.vala"
	_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) _tmp18_);
#line 78 "../src/raven/sound.vala"
	gtk_style_context_add_class (_tmp19_, "devices-list");
#line 79 "../src/raven/sound.vala"
	_tmp20_ = self->priv->devices_list;
#line 79 "../src/raven/sound.vala"
	_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) _tmp20_);
#line 79 "../src/raven/sound.vala"
	gtk_style_context_add_class (_tmp21_, "sound-devices");
#line 80 "../src/raven/sound.vala"
	_tmp22_ = self->priv->devices_list;
#line 80 "../src/raven/sound.vala"
	gtk_list_box_set_selection_mode (_tmp22_, GTK_SELECTION_SINGLE);
#line 81 "../src/raven/sound.vala"
	_tmp23_ = self->priv->devices_list;
#line 81 "../src/raven/sound.vala"
	g_signal_connect_object (_tmp23_, "row-selected", (GCallback) _budgie_sound_widget_on_device_selected_gtk_list_box_row_selected, self, 0);
#line 83 "../src/raven/sound.vala"
	_tmp24_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 83 "../src/raven/sound.vala"
	g_object_ref_sink (_tmp24_);
#line 83 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->main_layout);
#line 83 "../src/raven/sound.vala"
	self->priv->main_layout = _tmp24_;
#line 84 "../src/raven/sound.vala"
	_tmp25_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 100, (gdouble) 10);
#line 84 "../src/raven/sound.vala"
	g_object_ref_sink (_tmp25_);
#line 84 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->volume_slider);
#line 84 "../src/raven/sound.vala"
	self->priv->volume_slider = _tmp25_;
#line 85 "../src/raven/sound.vala"
	_tmp26_ = self->priv->volume_slider;
#line 85 "../src/raven/sound.vala"
	gtk_scale_set_draw_value (_tmp26_, FALSE);
#line 86 "../src/raven/sound.vala"
	_tmp27_ = self->priv->volume_slider;
#line 86 "../src/raven/sound.vala"
	g_signal_connect_object ((GtkRange*) _tmp27_, "value-changed", (GCallback) _budgie_sound_widget_on_scale_change_gtk_range_value_changed, self, 0);
#line 91 "../src/raven/sound.vala"
	_tmp28_ = self->priv->widget_type;
#line 91 "../src/raven/sound.vala"
	if (g_strcmp0 (_tmp28_, "input") == 0) {
#line 616 "sound.c"
		GvcMixerControl* _tmp29_;
		GvcMixerControl* _tmp30_;
		GvcMixerControl* _tmp31_;
		GvcMixerControl* _tmp32_;
		GtkScale* _tmp33_;
		BudgieHeaderWidget* _tmp34_;
		GtkBox* _tmp35_;
		GtkListBox* _tmp36_;
		GtkListBox* _tmp37_;
		GtkListBox* _tmp38_;
#line 92 "../src/raven/sound.vala"
		_tmp29_ = self->priv->mixer;
#line 92 "../src/raven/sound.vala"
		g_signal_connect_object (_tmp29_, "default-source-changed", (GCallback) _budgie_sound_widget_on_device_changed_gvc_mixer_control_default_source_changed, self, 0);
#line 93 "../src/raven/sound.vala"
		_tmp30_ = self->priv->mixer;
#line 93 "../src/raven/sound.vala"
		g_signal_connect_object (_tmp30_, "state-changed", (GCallback) _budgie_sound_widget_on_state_changed_gvc_mixer_control_state_changed, self, 0);
#line 94 "../src/raven/sound.vala"
		_tmp31_ = self->priv->mixer;
#line 94 "../src/raven/sound.vala"
		g_signal_connect_object (_tmp31_, "input-added", (GCallback) _budgie_sound_widget_on_device_added_gvc_mixer_control_input_added, self, 0);
#line 95 "../src/raven/sound.vala"
		_tmp32_ = self->priv->mixer;
#line 95 "../src/raven/sound.vala"
		g_signal_connect_object (_tmp32_, "input-removed", (GCallback) _budgie_sound_widget_on_device_removed_gvc_mixer_control_input_removed, self, 0);
#line 100 "../src/raven/sound.vala"
		_tmp33_ = self->priv->volume_slider;
#line 100 "../src/raven/sound.vala"
		_tmp34_ = budgie_header_widget_new ("", "microphone-sensitivity-muted-symbolic", FALSE, (GtkWidget*) _tmp33_, NULL);
#line 100 "../src/raven/sound.vala"
		g_object_ref_sink (_tmp34_);
#line 100 "../src/raven/sound.vala"
		_g_object_unref0 (self->priv->header);
#line 100 "../src/raven/sound.vala"
		self->priv->header = _tmp34_;
#line 101 "../src/raven/sound.vala"
		_tmp35_ = self->priv->main_layout;
#line 101 "../src/raven/sound.vala"
		_tmp36_ = self->priv->devices_list;
#line 101 "../src/raven/sound.vala"
		gtk_box_pack_start (_tmp35_, (GtkWidget*) _tmp36_, FALSE, FALSE, (guint) 0);
#line 102 "../src/raven/sound.vala"
		_tmp37_ = self->priv->devices_list;
#line 102 "../src/raven/sound.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp37_, 10);
#line 103 "../src/raven/sound.vala"
		_tmp38_ = self->priv->devices_list;
#line 103 "../src/raven/sound.vala"
		gtk_widget_set_margin_bottom ((GtkWidget*) _tmp38_, 10);
#line 667 "sound.c"
	} else {
		GSettings* _tmp39_;
		GHashFunc _tmp40_;
		GEqualFunc _tmp41_;
		GHashTable* _tmp42_;
		GSettings* _tmp43_;
		GSettings* _tmp44_;
		GSettings* _tmp45_;
		GvcMixerControl* _tmp46_;
		GvcMixerControl* _tmp47_;
		GvcMixerControl* _tmp48_;
		GvcMixerControl* _tmp49_;
		GvcMixerControl* _tmp50_;
		GvcMixerControl* _tmp51_;
		GSettings* _tmp52_;
		gchar* _tmp53_;
		GSettings* _tmp54_;
		GSettings* _tmp55_;
		GtkBox* _tmp56_;
		GtkListBox* _tmp57_;
		GtkListBox* _tmp58_;
		GtkStyleContext* _tmp59_;
		GtkListBox* _tmp60_;
		GtkStyleContext* _tmp61_;
		GtkListBox* _tmp62_;
		GtkListBox* _tmp63_;
		GtkRevealer* _tmp64_;
		GtkRevealer* _tmp65_;
		GtkRevealer* _tmp66_;
		GtkRevealer* _tmp67_;
		GtkListBox* _tmp68_;
		GtkRevealer* _tmp69_;
		GtkRevealer* _tmp70_;
		GtkRevealer* _tmp71_;
		BudgieStartListening* _tmp72_;
		GtkRevealer* _tmp73_;
		BudgieStartListening* _tmp74_;
		GtkBox* _tmp75_;
		GtkRevealer* _tmp76_;
		GtkBox* _tmp77_;
		GtkRevealer* _tmp78_;
		GtkStack* _tmp79_;
		GtkStack* _tmp80_;
		GtkStack* _tmp81_;
		GtkStack* _tmp82_;
		GtkStack* _tmp83_;
		GtkStack* _tmp84_;
		GtkBox* _tmp85_;
		GtkStack* _tmp86_;
		GtkListBox* _tmp87_;
		GtkStackSwitcher* _tmp88_;
		GtkStackSwitcher* _tmp89_;
		GtkStack* _tmp90_;
		GtkStackSwitcher* _tmp91_;
		GSettings* _tmp92_;
		GtkScale* _tmp93_;
		BudgieHeaderWidget* _tmp94_;
		GtkBox* _tmp95_;
		GtkStack* _tmp96_;
		GtkBox* _tmp97_;
		GtkStackSwitcher* _tmp98_;
		GtkRevealer* _tmp99_;
		GtkRevealer* _tmp100_;
#line 105 "../src/raven/sound.vala"
		_tmp39_ = g_settings_new ("org.gnome.desktop.sound");
#line 105 "../src/raven/sound.vala"
		_g_object_unref0 (self->priv->settings);
#line 105 "../src/raven/sound.vala"
		self->priv->settings = _tmp39_;
#line 106 "../src/raven/sound.vala"
		_tmp40_ = g_direct_hash;
#line 106 "../src/raven/sound.vala"
		_tmp41_ = g_direct_equal;
#line 106 "../src/raven/sound.vala"
		_tmp42_ = g_hash_table_new_full (_tmp40_, _tmp41_, NULL, _g_object_unref0_);
#line 106 "../src/raven/sound.vala"
		_g_hash_table_unref0 (self->priv->apps);
#line 106 "../src/raven/sound.vala"
		self->priv->apps = _tmp42_;
#line 107 "../src/raven/sound.vala"
		_tmp43_ = g_settings_new ("com.solus-project.budgie-panel");
#line 107 "../src/raven/sound.vala"
		_g_object_unref0 (self->priv->budgie_settings);
#line 107 "../src/raven/sound.vala"
		self->priv->budgie_settings = _tmp43_;
#line 108 "../src/raven/sound.vala"
		_tmp44_ = g_settings_new ("com.solus-project.budgie-raven");
#line 108 "../src/raven/sound.vala"
		_g_object_unref0 (self->priv->raven_settings);
#line 108 "../src/raven/sound.vala"
		self->priv->raven_settings = _tmp44_;
#line 109 "../src/raven/sound.vala"
		_tmp45_ = g_settings_new ("org.gnome.desktop.interface");
#line 109 "../src/raven/sound.vala"
		_g_object_unref0 (self->priv->gnome_desktop_settings);
#line 109 "../src/raven/sound.vala"
		self->priv->gnome_desktop_settings = _tmp45_;
#line 111 "../src/raven/sound.vala"
		_tmp46_ = self->priv->mixer;
#line 111 "../src/raven/sound.vala"
		g_signal_connect_object (_tmp46_, "default-sink-changed", (GCallback) _budgie_sound_widget_on_device_changed_gvc_mixer_control_default_sink_changed, self, 0);
#line 112 "../src/raven/sound.vala"
		_tmp47_ = self->priv->mixer;
#line 112 "../src/raven/sound.vala"
		g_signal_connect_object (_tmp47_, "output-added", (GCallback) _budgie_sound_widget_on_device_added_gvc_mixer_control_output_added, self, 0);
#line 113 "../src/raven/sound.vala"
		_tmp48_ = self->priv->mixer;
#line 113 "../src/raven/sound.vala"
		g_signal_connect_object (_tmp48_, "output-removed", (GCallback) _budgie_sound_widget_on_device_removed_gvc_mixer_control_output_removed, self, 0);
#line 114 "../src/raven/sound.vala"
		_tmp49_ = self->priv->mixer;
#line 114 "../src/raven/sound.vala"
		g_signal_connect_object (_tmp49_, "state-changed", (GCallback) _budgie_sound_widget_on_state_changed_gvc_mixer_control_state_changed, self, 0);
#line 115 "../src/raven/sound.vala"
		_tmp50_ = self->priv->mixer;
#line 115 "../src/raven/sound.vala"
		g_signal_connect_object (_tmp50_, "stream-added", (GCallback) _budgie_sound_widget_on_stream_added_gvc_mixer_control_stream_added, self, 0);
#line 116 "../src/raven/sound.vala"
		_tmp51_ = self->priv->mixer;
#line 116 "../src/raven/sound.vala"
		g_signal_connect_object (_tmp51_, "stream-removed", (GCallback) _budgie_sound_widget_on_stream_removed_gvc_mixer_control_stream_removed, self, 0);
#line 117 "../src/raven/sound.vala"
		_tmp52_ = self->priv->raven_settings;
#line 117 "../src/raven/sound.vala"
		_tmp53_ = g_strconcat ("changed::", BUDGIE_SOUND_WIDGET_MAX_KEY, NULL);
#line 117 "../src/raven/sound.vala"
		g_signal_connect_object (_tmp52_, _tmp53_, (GCallback) _budgie_sound_widget_on_volume_safety_changed_g_settings_changed, self, 0);
#line 117 "../src/raven/sound.vala"
		_g_free0 (_tmp53_);
#line 119 "../src/raven/sound.vala"
		_tmp54_ = self->priv->budgie_settings;
#line 119 "../src/raven/sound.vala"
		g_signal_connect_object (_tmp54_, "changed::builtin-theme", (GCallback) _budgie_sound_widget_update_input_draw_markers_g_settings_changed, self, 0);
#line 120 "../src/raven/sound.vala"
		_tmp55_ = self->priv->gnome_desktop_settings;
#line 120 "../src/raven/sound.vala"
		g_signal_connect_object (_tmp55_, "changed::gtk-theme", (GCallback) _budgie_sound_widget_update_input_draw_markers_g_settings_changed, self, 0);
#line 126 "../src/raven/sound.vala"
		_tmp56_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 126 "../src/raven/sound.vala"
		g_object_ref_sink (_tmp56_);
#line 126 "../src/raven/sound.vala"
		_g_object_unref0 (self->priv->apps_area);
#line 126 "../src/raven/sound.vala"
		self->priv->apps_area = _tmp56_;
#line 127 "../src/raven/sound.vala"
		_tmp57_ = (GtkListBox*) gtk_list_box_new ();
#line 127 "../src/raven/sound.vala"
		g_object_ref_sink (_tmp57_);
#line 127 "../src/raven/sound.vala"
		_g_object_unref0 (self->priv->apps_listbox);
#line 127 "../src/raven/sound.vala"
		self->priv->apps_listbox = _tmp57_;
#line 128 "../src/raven/sound.vala"
		_tmp58_ = self->priv->apps_listbox;
#line 128 "../src/raven/sound.vala"
		_tmp59_ = gtk_widget_get_style_context ((GtkWidget*) _tmp58_);
#line 128 "../src/raven/sound.vala"
		gtk_style_context_add_class (_tmp59_, "apps-list");
#line 129 "../src/raven/sound.vala"
		_tmp60_ = self->priv->apps_listbox;
#line 129 "../src/raven/sound.vala"
		_tmp61_ = gtk_widget_get_style_context ((GtkWidget*) _tmp60_);
#line 129 "../src/raven/sound.vala"
		gtk_style_context_remove_class (_tmp61_, GTK_STYLE_CLASS_LIST);
#line 130 "../src/raven/sound.vala"
		_tmp62_ = self->priv->apps_listbox;
#line 130 "../src/raven/sound.vala"
		gtk_list_box_set_selection_mode (_tmp62_, GTK_SELECTION_NONE);
#line 132 "../src/raven/sound.vala"
		_tmp63_ = self->priv->apps_listbox;
#line 132 "../src/raven/sound.vala"
		gtk_list_box_set_sort_func (_tmp63_, ____lambda27__gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 138 "../src/raven/sound.vala"
		_tmp64_ = (GtkRevealer*) gtk_revealer_new ();
#line 138 "../src/raven/sound.vala"
		g_object_ref_sink (_tmp64_);
#line 138 "../src/raven/sound.vala"
		_g_object_unref0 (self->priv->apps_list_revealer);
#line 138 "../src/raven/sound.vala"
		self->priv->apps_list_revealer = _tmp64_;
#line 139 "../src/raven/sound.vala"
		_tmp65_ = self->priv->apps_list_revealer;
#line 139 "../src/raven/sound.vala"
		gtk_revealer_set_transition_duration (_tmp65_, (guint) 250);
#line 140 "../src/raven/sound.vala"
		_tmp66_ = self->priv->apps_list_revealer;
#line 140 "../src/raven/sound.vala"
		gtk_revealer_set_transition_type (_tmp66_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP);
#line 141 "../src/raven/sound.vala"
		_tmp67_ = self->priv->apps_list_revealer;
#line 141 "../src/raven/sound.vala"
		_tmp68_ = self->priv->apps_listbox;
#line 141 "../src/raven/sound.vala"
		gtk_container_add ((GtkContainer*) _tmp67_, (GtkWidget*) _tmp68_);
#line 143 "../src/raven/sound.vala"
		_tmp69_ = (GtkRevealer*) gtk_revealer_new ();
#line 143 "../src/raven/sound.vala"
		g_object_ref_sink (_tmp69_);
#line 143 "../src/raven/sound.vala"
		_g_object_unref0 (self->priv->listening_box_revealer);
#line 143 "../src/raven/sound.vala"
		self->priv->listening_box_revealer = _tmp69_;
#line 144 "../src/raven/sound.vala"
		_tmp70_ = self->priv->listening_box_revealer;
#line 144 "../src/raven/sound.vala"
		gtk_revealer_set_transition_duration (_tmp70_, (guint) 250);
#line 145 "../src/raven/sound.vala"
		_tmp71_ = self->priv->listening_box_revealer;
#line 145 "../src/raven/sound.vala"
		gtk_revealer_set_transition_type (_tmp71_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 146 "../src/raven/sound.vala"
		_tmp72_ = budgie_start_listening_new ();
#line 146 "../src/raven/sound.vala"
		g_object_ref_sink (_tmp72_);
#line 146 "../src/raven/sound.vala"
		_g_object_unref0 (self->priv->listening_box);
#line 146 "../src/raven/sound.vala"
		self->priv->listening_box = _tmp72_;
#line 147 "../src/raven/sound.vala"
		_tmp73_ = self->priv->listening_box_revealer;
#line 147 "../src/raven/sound.vala"
		_tmp74_ = self->priv->listening_box;
#line 147 "../src/raven/sound.vala"
		gtk_container_add ((GtkContainer*) _tmp73_, (GtkWidget*) _tmp74_);
#line 149 "../src/raven/sound.vala"
		_tmp75_ = self->priv->apps_area;
#line 149 "../src/raven/sound.vala"
		_tmp76_ = self->priv->listening_box_revealer;
#line 149 "../src/raven/sound.vala"
		gtk_box_pack_start (_tmp75_, (GtkWidget*) _tmp76_, TRUE, TRUE, (guint) 0);
#line 150 "../src/raven/sound.vala"
		_tmp77_ = self->priv->apps_area;
#line 150 "../src/raven/sound.vala"
		_tmp78_ = self->priv->apps_list_revealer;
#line 150 "../src/raven/sound.vala"
		gtk_box_pack_end (_tmp77_, (GtkWidget*) _tmp78_, TRUE, TRUE, (guint) 0);
#line 152 "../src/raven/sound.vala"
		_tmp79_ = (GtkStack*) gtk_stack_new ();
#line 152 "../src/raven/sound.vala"
		g_object_ref_sink (_tmp79_);
#line 152 "../src/raven/sound.vala"
		_g_object_unref0 (self->priv->widget_area);
#line 152 "../src/raven/sound.vala"
		self->priv->widget_area = _tmp79_;
#line 153 "../src/raven/sound.vala"
		_tmp80_ = self->priv->widget_area;
#line 153 "../src/raven/sound.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp80_, 10);
#line 154 "../src/raven/sound.vala"
		_tmp81_ = self->priv->widget_area;
#line 154 "../src/raven/sound.vala"
		gtk_widget_set_margin_bottom ((GtkWidget*) _tmp81_, 10);
#line 155 "../src/raven/sound.vala"
		_tmp82_ = self->priv->widget_area;
#line 155 "../src/raven/sound.vala"
		gtk_stack_set_transition_duration (_tmp82_, (guint) 125);
#line 156 "../src/raven/sound.vala"
		_tmp83_ = self->priv->widget_area;
#line 156 "../src/raven/sound.vala"
		gtk_stack_set_transition_type (_tmp83_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
#line 158 "../src/raven/sound.vala"
		_tmp84_ = self->priv->widget_area;
#line 158 "../src/raven/sound.vala"
		_tmp85_ = self->priv->apps_area;
#line 158 "../src/raven/sound.vala"
		gtk_stack_add_titled (_tmp84_, (GtkWidget*) _tmp85_, "apps", _ ("Apps"));
#line 159 "../src/raven/sound.vala"
		_tmp86_ = self->priv->widget_area;
#line 159 "../src/raven/sound.vala"
		_tmp87_ = self->priv->devices_list;
#line 159 "../src/raven/sound.vala"
		gtk_stack_add_titled (_tmp86_, (GtkWidget*) _tmp87_, "devices", _ ("Devices"));
#line 161 "../src/raven/sound.vala"
		_tmp88_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
#line 161 "../src/raven/sound.vala"
		g_object_ref_sink (_tmp88_);
#line 161 "../src/raven/sound.vala"
		_g_object_unref0 (self->priv->widget_area_switch);
#line 161 "../src/raven/sound.vala"
		self->priv->widget_area_switch = _tmp88_;
#line 162 "../src/raven/sound.vala"
		_tmp89_ = self->priv->widget_area_switch;
#line 162 "../src/raven/sound.vala"
		_tmp90_ = self->priv->widget_area;
#line 162 "../src/raven/sound.vala"
		gtk_stack_switcher_set_stack (_tmp89_, _tmp90_);
#line 163 "../src/raven/sound.vala"
		_tmp91_ = self->priv->widget_area_switch;
#line 163 "../src/raven/sound.vala"
		gtk_box_set_homogeneous ((GtkBox*) _tmp91_, TRUE);
#line 166 "../src/raven/sound.vala"
		_tmp92_ = self->priv->raven_settings;
#line 166 "../src/raven/sound.vala"
		budgie_sound_widget_set_slider_range_on_max (self, g_settings_get_boolean (_tmp92_, BUDGIE_SOUND_WIDGET_MAX_KEY));
#line 168 "../src/raven/sound.vala"
		_tmp93_ = self->priv->volume_slider;
#line 168 "../src/raven/sound.vala"
		_tmp94_ = budgie_header_widget_new ("", "audio-volume-muted-symbolic", FALSE, (GtkWidget*) _tmp93_, NULL);
#line 168 "../src/raven/sound.vala"
		g_object_ref_sink (_tmp94_);
#line 168 "../src/raven/sound.vala"
		_g_object_unref0 (self->priv->header);
#line 168 "../src/raven/sound.vala"
		self->priv->header = _tmp94_;
#line 169 "../src/raven/sound.vala"
		_tmp95_ = self->priv->main_layout;
#line 169 "../src/raven/sound.vala"
		_tmp96_ = self->priv->widget_area;
#line 169 "../src/raven/sound.vala"
		gtk_box_pack_start (_tmp95_, (GtkWidget*) _tmp96_, FALSE, FALSE, (guint) 0);
#line 170 "../src/raven/sound.vala"
		_tmp97_ = self->priv->main_layout;
#line 170 "../src/raven/sound.vala"
		_tmp98_ = self->priv->widget_area_switch;
#line 170 "../src/raven/sound.vala"
		gtk_box_pack_start (_tmp97_, (GtkWidget*) _tmp98_, TRUE, FALSE, (guint) 0);
#line 172 "../src/raven/sound.vala"
		_tmp99_ = self->priv->listening_box_revealer;
#line 172 "../src/raven/sound.vala"
		gtk_revealer_set_reveal_child (_tmp99_, FALSE);
#line 173 "../src/raven/sound.vala"
		_tmp100_ = self->priv->apps_list_revealer;
#line 173 "../src/raven/sound.vala"
		gtk_revealer_set_reveal_child (_tmp100_, FALSE);
#line 993 "sound.c"
	}
#line 176 "../src/raven/sound.vala"
	_tmp101_ = self->priv->mixer;
#line 176 "../src/raven/sound.vala"
	gvc_mixer_control_open (_tmp101_);
#line 182 "../src/raven/sound.vala"
	_tmp102_ = self->priv->header;
#line 182 "../src/raven/sound.vala"
	_tmp103_ = budgie_raven_expander_new (_tmp102_);
#line 182 "../src/raven/sound.vala"
	g_object_ref_sink (_tmp103_);
#line 182 "../src/raven/sound.vala"
	expander = _tmp103_;
#line 183 "../src/raven/sound.vala"
	_tmp104_ = expander;
#line 183 "../src/raven/sound.vala"
	_tmp105_ = self->priv->widget_type;
#line 183 "../src/raven/sound.vala"
	budgie_raven_expander_set_expanded (_tmp104_, g_strcmp0 (_tmp105_, "input") != 0);
#line 185 "../src/raven/sound.vala"
	_tmp106_ = expander;
#line 185 "../src/raven/sound.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp106_, TRUE, TRUE, (guint) 0);
#line 187 "../src/raven/sound.vala"
	_tmp107_ = (GtkEventBox*) gtk_event_box_new ();
#line 187 "../src/raven/sound.vala"
	g_object_ref_sink (_tmp107_);
#line 187 "../src/raven/sound.vala"
	ebox = _tmp107_;
#line 188 "../src/raven/sound.vala"
	_tmp108_ = ebox;
#line 188 "../src/raven/sound.vala"
	_tmp109_ = gtk_widget_get_style_context ((GtkWidget*) _tmp108_);
#line 188 "../src/raven/sound.vala"
	gtk_style_context_add_class (_tmp109_, "raven-background");
#line 189 "../src/raven/sound.vala"
	_tmp110_ = expander;
#line 189 "../src/raven/sound.vala"
	_tmp111_ = ebox;
#line 189 "../src/raven/sound.vala"
	gtk_container_add ((GtkContainer*) _tmp110_, (GtkWidget*) _tmp111_);
#line 190 "../src/raven/sound.vala"
	_tmp112_ = ebox;
#line 190 "../src/raven/sound.vala"
	_tmp113_ = self->priv->main_layout;
#line 190 "../src/raven/sound.vala"
	gtk_container_add ((GtkContainer*) _tmp112_, (GtkWidget*) _tmp113_);
#line 192 "../src/raven/sound.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 194 "../src/raven/sound.vala"
	_tmp114_ = self->priv->widget_type;
#line 194 "../src/raven/sound.vala"
	if (g_strcmp0 (_tmp114_, "output") == 0) {
#line 195 "../src/raven/sound.vala"
		budgie_sound_widget_on_volume_safety_changed (self);
#line 196 "../src/raven/sound.vala"
		budgie_sound_widget_toggle_start_listening (self);
#line 1051 "sound.c"
	}
#line 51 "../src/raven/sound.vala"
	_g_object_unref0 (ebox);
#line 51 "../src/raven/sound.vala"
	_g_object_unref0 (expander);
#line 51 "../src/raven/sound.vala"
	return self;
#line 1059 "sound.c"
}

BudgieSoundWidget*
budgie_sound_widget_new (const gchar* c_widget_type)
{
#line 51 "../src/raven/sound.vala"
	return budgie_sound_widget_construct (BUDGIE_TYPE_SOUND_WIDGET, c_widget_type);
#line 1067 "sound.c"
}

/**
 * has_devices will check if we have devices associated with this type
 */
gboolean
budgie_sound_widget_has_devices (BudgieSoundWidget* self)
{
	gboolean _tmp0_ = FALSE;
	GHashTable* _tmp1_;
	gboolean result;
#line 203 "../src/raven/sound.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 204 "../src/raven/sound.vala"
	_tmp1_ = self->priv->devices;
#line 204 "../src/raven/sound.vala"
	if (g_hash_table_size (_tmp1_) != ((guint) 0)) {
#line 1085 "sound.c"
		GvcMixerControl* _tmp2_;
		GSList* _tmp3_;
		GSList* _tmp4_;
#line 204 "../src/raven/sound.vala"
		_tmp2_ = self->priv->mixer;
#line 204 "../src/raven/sound.vala"
		_tmp3_ = gvc_mixer_control_get_cards (_tmp2_);
#line 204 "../src/raven/sound.vala"
		_tmp4_ = _tmp3_;
#line 204 "../src/raven/sound.vala"
		_tmp0_ = g_slist_length (_tmp4_) != ((guint) 0);
#line 204 "../src/raven/sound.vala"
		(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_slist_free (_tmp4_), NULL));
#line 1099 "sound.c"
	} else {
#line 204 "../src/raven/sound.vala"
		_tmp0_ = FALSE;
#line 1103 "sound.c"
	}
#line 204 "../src/raven/sound.vala"
	result = _tmp0_;
#line 204 "../src/raven/sound.vala"
	return result;
#line 1109 "sound.c"
}

/**
 * on_device_added will handle when an input or output device has been added
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 215 "../src/raven/sound.vala"
	return self ? g_object_ref (self) : NULL;
#line 1120 "sound.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 1139 "sound.c"
}

static void
budgie_sound_widget_on_device_added (BudgieSoundWidget* self,
                                     guint id)
{
	GHashTable* _tmp0_;
	GvcMixerUIDevice* _tmp1_ = NULL;
	const gchar* _tmp2_;
	GvcMixerUIDevice* device = NULL;
	GvcMixerUIDevice* _tmp7_;
	GvcMixerUIDevice* _tmp8_;
	GvcMixerUIDevice* _tmp9_;
	void* _tmp10_;
	void* _tmp11_;
	GvcMixerCard* card = NULL;
	GvcMixerUIDevice* _tmp12_;
	void* _tmp13_;
	void* _tmp14_;
	GvcMixerCard* _tmp15_;
	gboolean _tmp16_ = FALSE;
	const gchar* _tmp17_;
	GtkBox* box = NULL;
	GtkBox* _tmp22_;
	GtkLabel* label = NULL;
	GvcMixerUIDevice* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	GvcMixerCard* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* _tmp34_;
	GtkLabel* _tmp35_;
	GtkLabel* _tmp36_;
	GtkLabel* _tmp37_;
	GtkBox* _tmp38_;
	GtkLabel* _tmp39_;
	GtkListBoxRow* list_item = NULL;
	GtkListBoxRow* _tmp40_;
	GtkListBoxRow* _tmp41_;
	GtkListBoxRow* _tmp42_;
	GtkBox* _tmp43_;
	GtkListBoxRow* _tmp44_;
	GtkListBox* _tmp45_;
	GtkListBoxRow* _tmp46_;
	GHashTable* _tmp47_;
	GtkListBoxRow* _tmp48_;
	GtkListBoxRow* _tmp49_;
	GtkListBoxRow* _tmp50_;
	GtkListBox* _tmp51_;
#line 210 "../src/raven/sound.vala"
	g_return_if_fail (self != NULL);
#line 211 "../src/raven/sound.vala"
	_tmp0_ = self->priv->devices;
#line 211 "../src/raven/sound.vala"
	if (g_hash_table_contains (_tmp0_, (gpointer) ((guintptr) id))) {
#line 212 "../src/raven/sound.vala"
		return;
#line 1203 "sound.c"
	}
#line 215 "../src/raven/sound.vala"
	_tmp2_ = self->priv->widget_type;
#line 215 "../src/raven/sound.vala"
	if (g_strcmp0 (_tmp2_, "input") == 0) {
#line 1209 "sound.c"
		GvcMixerControl* _tmp3_;
		GvcMixerUIDevice* _tmp4_;
#line 215 "../src/raven/sound.vala"
		_tmp3_ = self->priv->mixer;
#line 215 "../src/raven/sound.vala"
		_tmp4_ = gvc_mixer_control_lookup_input_id (_tmp3_, id);
#line 215 "../src/raven/sound.vala"
		_tmp1_ = _tmp4_;
#line 1218 "sound.c"
	} else {
		GvcMixerControl* _tmp5_;
		GvcMixerUIDevice* _tmp6_;
#line 215 "../src/raven/sound.vala"
		_tmp5_ = self->priv->mixer;
#line 215 "../src/raven/sound.vala"
		_tmp6_ = gvc_mixer_control_lookup_output_id (_tmp5_, id);
#line 215 "../src/raven/sound.vala"
		_tmp1_ = _tmp6_;
#line 1228 "sound.c"
	}
#line 215 "../src/raven/sound.vala"
	_tmp7_ = _g_object_ref0 (_tmp1_);
#line 215 "../src/raven/sound.vala"
	device = _tmp7_;
#line 217 "../src/raven/sound.vala"
	_tmp8_ = device;
#line 217 "../src/raven/sound.vala"
	if (_tmp8_ == NULL) {
#line 218 "../src/raven/sound.vala"
		_g_object_unref0 (device);
#line 218 "../src/raven/sound.vala"
		return;
#line 1242 "sound.c"
	}
#line 221 "../src/raven/sound.vala"
	_tmp9_ = device;
#line 221 "../src/raven/sound.vala"
	g_object_get (_tmp9_, "card", &_tmp10_, NULL);
#line 221 "../src/raven/sound.vala"
	_tmp11_ = _tmp10_;
#line 221 "../src/raven/sound.vala"
	if (_tmp11_ == NULL) {
#line 222 "../src/raven/sound.vala"
		_g_object_unref0 (device);
#line 222 "../src/raven/sound.vala"
		return;
#line 1256 "sound.c"
	}
#line 225 "../src/raven/sound.vala"
	_tmp12_ = device;
#line 225 "../src/raven/sound.vala"
	g_object_get (_tmp12_, "card", &_tmp13_, NULL);
#line 225 "../src/raven/sound.vala"
	_tmp14_ = _tmp13_;
#line 225 "../src/raven/sound.vala"
	_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, gvc_mixer_card_get_type ()) ? ((GvcMixerCard*) _tmp14_) : NULL);
#line 225 "../src/raven/sound.vala"
	card = _tmp15_;
#line 227 "../src/raven/sound.vala"
	_tmp17_ = self->priv->widget_type;
#line 227 "../src/raven/sound.vala"
	if (g_strcmp0 (_tmp17_, "output") == 0) {
#line 1272 "sound.c"
		GvcMixerUIDevice* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 227 "../src/raven/sound.vala"
		_tmp18_ = device;
#line 227 "../src/raven/sound.vala"
		g_object_get (_tmp18_, "description", &_tmp19_, NULL);
#line 227 "../src/raven/sound.vala"
		_tmp20_ = _tmp19_;
#line 227 "../src/raven/sound.vala"
		_tmp21_ = _tmp20_;
#line 227 "../src/raven/sound.vala"
		_tmp16_ = string_contains (_tmp21_, "Digital Output");
#line 227 "../src/raven/sound.vala"
		_g_free0 (_tmp21_);
#line 1289 "sound.c"
	} else {
#line 227 "../src/raven/sound.vala"
		_tmp16_ = FALSE;
#line 1293 "sound.c"
	}
#line 227 "../src/raven/sound.vala"
	if (_tmp16_) {
#line 228 "../src/raven/sound.vala"
		_g_object_unref0 (card);
#line 228 "../src/raven/sound.vala"
		_g_object_unref0 (device);
#line 228 "../src/raven/sound.vala"
		return;
#line 1303 "sound.c"
	}
#line 231 "../src/raven/sound.vala"
	_tmp22_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 231 "../src/raven/sound.vala"
	g_object_ref_sink (_tmp22_);
#line 231 "../src/raven/sound.vala"
	box = _tmp22_;
#line 232 "../src/raven/sound.vala"
	_tmp23_ = device;
#line 232 "../src/raven/sound.vala"
	g_object_get (_tmp23_, "description", &_tmp24_, NULL);
#line 232 "../src/raven/sound.vala"
	_tmp25_ = _tmp24_;
#line 232 "../src/raven/sound.vala"
	_tmp26_ = _tmp25_;
#line 232 "../src/raven/sound.vala"
	_tmp27_ = card;
#line 232 "../src/raven/sound.vala"
	g_object_get (_tmp27_, "name", &_tmp28_, NULL);
#line 232 "../src/raven/sound.vala"
	_tmp29_ = _tmp28_;
#line 232 "../src/raven/sound.vala"
	_tmp30_ = _tmp29_;
#line 232 "../src/raven/sound.vala"
	_tmp31_ = g_strdup_printf ("%s - %s", _tmp26_, _tmp30_);
#line 232 "../src/raven/sound.vala"
	_tmp32_ = _tmp31_;
#line 232 "../src/raven/sound.vala"
	_tmp33_ = (GtkLabel*) gtk_label_new (_tmp32_);
#line 232 "../src/raven/sound.vala"
	g_object_ref_sink (_tmp33_);
#line 232 "../src/raven/sound.vala"
	_tmp34_ = _tmp33_;
#line 232 "../src/raven/sound.vala"
	_g_free0 (_tmp32_);
#line 232 "../src/raven/sound.vala"
	_g_free0 (_tmp30_);
#line 232 "../src/raven/sound.vala"
	_g_free0 (_tmp26_);
#line 232 "../src/raven/sound.vala"
	label = _tmp34_;
#line 233 "../src/raven/sound.vala"
	_tmp35_ = label;
#line 233 "../src/raven/sound.vala"
	gtk_label_set_justify (_tmp35_, GTK_JUSTIFY_LEFT);
#line 234 "../src/raven/sound.vala"
	_tmp36_ = label;
#line 234 "../src/raven/sound.vala"
	gtk_label_set_max_width_chars (_tmp36_, 30);
#line 235 "../src/raven/sound.vala"
	_tmp37_ = label;
#line 235 "../src/raven/sound.vala"
	gtk_label_set_ellipsize (_tmp37_, PANGO_ELLIPSIZE_END);
#line 236 "../src/raven/sound.vala"
	_tmp38_ = box;
#line 236 "../src/raven/sound.vala"
	_tmp39_ = label;
#line 236 "../src/raven/sound.vala"
	gtk_box_pack_start (_tmp38_, (GtkWidget*) _tmp39_, FALSE, TRUE, (guint) 0);
#line 238 "../src/raven/sound.vala"
	_tmp40_ = (GtkListBoxRow*) gtk_list_box_row_new ();
#line 238 "../src/raven/sound.vala"
	g_object_ref_sink (_tmp40_);
#line 238 "../src/raven/sound.vala"
	list_item = _tmp40_;
#line 239 "../src/raven/sound.vala"
	_tmp41_ = list_item;
#line 239 "../src/raven/sound.vala"
	g_object_set ((GtkWidget*) _tmp41_, "height-request", 32, NULL);
#line 240 "../src/raven/sound.vala"
	_tmp42_ = list_item;
#line 240 "../src/raven/sound.vala"
	_tmp43_ = box;
#line 240 "../src/raven/sound.vala"
	gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp43_);
#line 242 "../src/raven/sound.vala"
	_tmp44_ = list_item;
#line 242 "../src/raven/sound.vala"
	g_object_set_data_full ((GObject*) _tmp44_, "device_id", (gpointer) ((guintptr) id), NULL);
#line 243 "../src/raven/sound.vala"
	_tmp45_ = self->priv->devices_list;
#line 243 "../src/raven/sound.vala"
	_tmp46_ = list_item;
#line 243 "../src/raven/sound.vala"
	gtk_list_box_insert (_tmp45_, (GtkWidget*) _tmp46_, -1);
#line 245 "../src/raven/sound.vala"
	_tmp47_ = self->priv->devices;
#line 245 "../src/raven/sound.vala"
	_tmp48_ = list_item;
#line 245 "../src/raven/sound.vala"
	_tmp49_ = _g_object_ref0 (_tmp48_);
#line 245 "../src/raven/sound.vala"
	g_hash_table_insert (_tmp47_, (gpointer) ((guintptr) id), _tmp49_);
#line 246 "../src/raven/sound.vala"
	_tmp50_ = list_item;
#line 246 "../src/raven/sound.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp50_);
#line 247 "../src/raven/sound.vala"
	_tmp51_ = self->priv->devices_list;
#line 247 "../src/raven/sound.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp51_);
#line 249 "../src/raven/sound.vala"
	g_signal_emit (self, budgie_sound_widget_signals[BUDGIE_SOUND_WIDGET_DEVICES_STATE_CHANGED_SIGNAL], 0);
#line 210 "../src/raven/sound.vala"
	_g_object_unref0 (list_item);
#line 210 "../src/raven/sound.vala"
	_g_object_unref0 (label);
#line 210 "../src/raven/sound.vala"
	_g_object_unref0 (box);
#line 210 "../src/raven/sound.vala"
	_g_object_unref0 (card);
#line 210 "../src/raven/sound.vala"
	_g_object_unref0 (device);
#line 1417 "sound.c"
}

/**
 * on_device_changed will handle when a Gvc.MixerUIDevice has been changed
 */
static void
__lambda25_ (BudgieSoundWidget* self,
             GObject* n,
             GParamSpec* p)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 278 "../src/raven/sound.vala"
	g_return_if_fail (n != NULL);
#line 278 "../src/raven/sound.vala"
	g_return_if_fail (p != NULL);
#line 279 "../src/raven/sound.vala"
	_tmp1_ = p->name;
#line 279 "../src/raven/sound.vala"
	if (g_strcmp0 (_tmp1_, "volume") == 0) {
#line 279 "../src/raven/sound.vala"
		_tmp0_ = TRUE;
#line 1440 "sound.c"
	} else {
		const gchar* _tmp2_;
#line 279 "../src/raven/sound.vala"
		_tmp2_ = p->name;
#line 279 "../src/raven/sound.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "is-muted") == 0;
#line 1447 "sound.c"
	}
#line 279 "../src/raven/sound.vala"
	if (_tmp0_) {
#line 280 "../src/raven/sound.vala"
		budgie_sound_widget_update_volume (self);
#line 1453 "sound.c"
	}
}

static void
___lambda25__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 278 "../src/raven/sound.vala"
	__lambda25_ ((BudgieSoundWidget*) self, _sender, pspec);
#line 1464 "sound.c"
}

static void
budgie_sound_widget_on_device_changed (BudgieSoundWidget* self,
                                       guint id)
{
	GvcMixerStream* _tmp0_ = NULL;
	const gchar* _tmp1_;
	GvcMixerStream* stream = NULL;
	GvcMixerStream* _tmp6_;
	GvcMixerStream* _tmp7_;
	GvcMixerStream* _tmp8_;
	GvcMixerStream* _tmp9_;
	GvcMixerUIDevice* device = NULL;
	GvcMixerControl* _tmp10_;
	GvcMixerStream* _tmp11_;
	GvcMixerUIDevice* _tmp12_;
	GvcMixerUIDevice* _tmp13_;
	GtkListBoxRow* list_item = NULL;
	GHashTable* _tmp14_;
	GvcMixerUIDevice* _tmp15_;
	gconstpointer _tmp16_;
	GtkListBoxRow* _tmp17_;
	GtkListBoxRow* _tmp18_;
	GvcMixerStream* _tmp21_;
	GvcMixerStream* _tmp23_;
	gulong _tmp24_;
	GvcMixerStream* _tmp25_;
	GvcMixerStream* _tmp26_;
	GtkListBox* _tmp27_;
#line 255 "../src/raven/sound.vala"
	g_return_if_fail (self != NULL);
#line 256 "../src/raven/sound.vala"
	_tmp1_ = self->priv->widget_type;
#line 256 "../src/raven/sound.vala"
	if (g_strcmp0 (_tmp1_, "input") == 0) {
#line 1501 "sound.c"
		GvcMixerControl* _tmp2_;
		GvcMixerStream* _tmp3_;
#line 256 "../src/raven/sound.vala"
		_tmp2_ = self->priv->mixer;
#line 256 "../src/raven/sound.vala"
		_tmp3_ = gvc_mixer_control_get_default_source (_tmp2_);
#line 256 "../src/raven/sound.vala"
		_tmp0_ = _tmp3_;
#line 1510 "sound.c"
	} else {
		GvcMixerControl* _tmp4_;
		GvcMixerStream* _tmp5_;
#line 256 "../src/raven/sound.vala"
		_tmp4_ = self->priv->mixer;
#line 256 "../src/raven/sound.vala"
		_tmp5_ = gvc_mixer_control_get_default_sink (_tmp4_);
#line 256 "../src/raven/sound.vala"
		_tmp0_ = _tmp5_;
#line 1520 "sound.c"
	}
#line 256 "../src/raven/sound.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 256 "../src/raven/sound.vala"
	stream = _tmp6_;
#line 258 "../src/raven/sound.vala"
	_tmp7_ = stream;
#line 258 "../src/raven/sound.vala"
	if (_tmp7_ == NULL) {
#line 259 "../src/raven/sound.vala"
		_g_object_unref0 (stream);
#line 259 "../src/raven/sound.vala"
		return;
#line 1534 "sound.c"
	}
#line 262 "../src/raven/sound.vala"
	_tmp8_ = stream;
#line 262 "../src/raven/sound.vala"
	_tmp9_ = self->priv->primary_stream;
#line 262 "../src/raven/sound.vala"
	if (_tmp8_ == _tmp9_) {
#line 263 "../src/raven/sound.vala"
		_g_object_unref0 (stream);
#line 263 "../src/raven/sound.vala"
		return;
#line 1546 "sound.c"
	}
#line 266 "../src/raven/sound.vala"
	_tmp10_ = self->priv->mixer;
#line 266 "../src/raven/sound.vala"
	_tmp11_ = stream;
#line 266 "../src/raven/sound.vala"
	_tmp12_ = gvc_mixer_control_lookup_device_from_stream (_tmp10_, _tmp11_);
#line 266 "../src/raven/sound.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 266 "../src/raven/sound.vala"
	device = _tmp13_;
#line 267 "../src/raven/sound.vala"
	_tmp14_ = self->priv->devices;
#line 267 "../src/raven/sound.vala"
	_tmp15_ = device;
#line 267 "../src/raven/sound.vala"
	_tmp16_ = g_hash_table_lookup (_tmp14_, (gpointer) ((guintptr) gvc_mixer_ui_device_get_id (_tmp15_)));
#line 267 "../src/raven/sound.vala"
	_tmp17_ = _g_object_ref0 ((GtkListBoxRow*) _tmp16_);
#line 267 "../src/raven/sound.vala"
	list_item = _tmp17_;
#line 269 "../src/raven/sound.vala"
	_tmp18_ = list_item;
#line 269 "../src/raven/sound.vala"
	if (_tmp18_ != NULL) {
#line 1572 "sound.c"
		GtkListBox* _tmp19_;
		GtkListBoxRow* _tmp20_;
#line 270 "../src/raven/sound.vala"
		_tmp19_ = self->priv->devices_list;
#line 270 "../src/raven/sound.vala"
		_tmp20_ = list_item;
#line 270 "../src/raven/sound.vala"
		gtk_list_box_select_row (_tmp19_, _tmp20_);
#line 1581 "sound.c"
	}
#line 273 "../src/raven/sound.vala"
	_tmp21_ = self->priv->primary_stream;
#line 273 "../src/raven/sound.vala"
	if (_tmp21_ != NULL) {
#line 1587 "sound.c"
		GvcMixerStream* _tmp22_;
#line 274 "../src/raven/sound.vala"
		_tmp22_ = self->priv->primary_stream;
#line 274 "../src/raven/sound.vala"
		g_signal_handler_disconnect ((GObject*) _tmp22_, self->priv->primary_notify_id);
#line 275 "../src/raven/sound.vala"
		self->priv->primary_notify_id = (gulong) 0;
#line 1595 "sound.c"
	}
#line 278 "../src/raven/sound.vala"
	_tmp23_ = stream;
#line 278 "../src/raven/sound.vala"
	_tmp24_ = g_signal_connect_object ((GObject*) _tmp23_, "notify", (GCallback) ___lambda25__g_object_notify, self, 0);
#line 278 "../src/raven/sound.vala"
	self->priv->primary_notify_id = _tmp24_;
#line 284 "../src/raven/sound.vala"
	_tmp25_ = stream;
#line 284 "../src/raven/sound.vala"
	_tmp26_ = _g_object_ref0 (_tmp25_);
#line 284 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->primary_stream);
#line 284 "../src/raven/sound.vala"
	self->priv->primary_stream = _tmp26_;
#line 285 "../src/raven/sound.vala"
	budgie_sound_widget_update_volume (self);
#line 286 "../src/raven/sound.vala"
	_tmp27_ = self->priv->devices_list;
#line 286 "../src/raven/sound.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp27_);
#line 287 "../src/raven/sound.vala"
	g_signal_emit (self, budgie_sound_widget_signals[BUDGIE_SOUND_WIDGET_DEVICES_STATE_CHANGED_SIGNAL], 0);
#line 255 "../src/raven/sound.vala"
	_g_object_unref0 (list_item);
#line 255 "../src/raven/sound.vala"
	_g_object_unref0 (device);
#line 255 "../src/raven/sound.vala"
	_g_object_unref0 (stream);
#line 1625 "sound.c"
}

/**
 * on_device_removed will handle when a Gvc.MixerUIDevice has been removed
 */
static void
budgie_sound_widget_on_device_removed (BudgieSoundWidget* self,
                                       guint id)
{
	GtkListBoxRow* list_item = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GtkListBoxRow* _tmp2_;
	GtkListBoxRow* _tmp3_;
	GHashTable* _tmp4_;
	GtkListBoxRow* _tmp5_;
	GtkListBox* _tmp6_;
#line 293 "../src/raven/sound.vala"
	g_return_if_fail (self != NULL);
#line 294 "../src/raven/sound.vala"
	_tmp0_ = self->priv->devices;
#line 294 "../src/raven/sound.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((guintptr) id));
#line 294 "../src/raven/sound.vala"
	_tmp2_ = _g_object_ref0 ((GtkListBoxRow*) _tmp1_);
#line 294 "../src/raven/sound.vala"
	list_item = _tmp2_;
#line 296 "../src/raven/sound.vala"
	_tmp3_ = list_item;
#line 296 "../src/raven/sound.vala"
	if (_tmp3_ == NULL) {
#line 297 "../src/raven/sound.vala"
		_g_object_unref0 (list_item);
#line 297 "../src/raven/sound.vala"
		return;
#line 1661 "sound.c"
	}
#line 300 "../src/raven/sound.vala"
	_tmp4_ = self->priv->devices;
#line 300 "../src/raven/sound.vala"
	g_hash_table_steal (_tmp4_, (gpointer) ((guintptr) id));
#line 301 "../src/raven/sound.vala"
	_tmp5_ = list_item;
#line 301 "../src/raven/sound.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp5_);
#line 302 "../src/raven/sound.vala"
	_tmp6_ = self->priv->devices_list;
#line 302 "../src/raven/sound.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp6_);
#line 303 "../src/raven/sound.vala"
	g_signal_emit (self, budgie_sound_widget_signals[BUDGIE_SOUND_WIDGET_DEVICES_STATE_CHANGED_SIGNAL], 0);
#line 293 "../src/raven/sound.vala"
	_g_object_unref0 (list_item);
#line 1679 "sound.c"
}

/**
 * get_control_for_app will get the respective inner AppSoundControl of a ListBoxRow associated with the id
 */
static BudgieAppSoundControl*
budgie_sound_widget_get_control_for_app (BudgieSoundWidget* self,
                                         guint id)
{
	BudgieAppSoundControl* control = NULL;
	GHashTable* _tmp0_;
	BudgieAppSoundControl* result;
#line 309 "../src/raven/sound.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 310 "../src/raven/sound.vala"
	control = NULL;
#line 312 "../src/raven/sound.vala"
	_tmp0_ = self->priv->apps;
#line 312 "../src/raven/sound.vala"
	if (g_hash_table_contains (_tmp0_, (gpointer) ((guintptr) id))) {
#line 1700 "sound.c"
		GtkListBoxRow* row = NULL;
		GHashTable* _tmp1_;
		gconstpointer _tmp2_;
		GtkListBoxRow* _tmp3_;
		GtkListBoxRow* _tmp4_;
#line 313 "../src/raven/sound.vala"
		_tmp1_ = self->priv->apps;
#line 313 "../src/raven/sound.vala"
		_tmp2_ = g_hash_table_lookup (_tmp1_, (gpointer) ((guintptr) id));
#line 313 "../src/raven/sound.vala"
		_tmp3_ = _g_object_ref0 ((GtkListBoxRow*) _tmp2_);
#line 313 "../src/raven/sound.vala"
		row = _tmp3_;
#line 315 "../src/raven/sound.vala"
		_tmp4_ = row;
#line 315 "../src/raven/sound.vala"
		if (_tmp4_ != NULL) {
#line 1718 "sound.c"
			GtkListBoxRow* _tmp5_;
			GtkWidget* _tmp6_;
			BudgieAppSoundControl* _tmp7_;
#line 316 "../src/raven/sound.vala"
			_tmp5_ = row;
#line 316 "../src/raven/sound.vala"
			_tmp6_ = gtk_bin_get_child ((GtkBin*) _tmp5_);
#line 316 "../src/raven/sound.vala"
			_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, BUDGIE_TYPE_APP_SOUND_CONTROL, BudgieAppSoundControl));
#line 316 "../src/raven/sound.vala"
			_g_object_unref0 (control);
#line 316 "../src/raven/sound.vala"
			control = _tmp7_;
#line 1732 "sound.c"
		}
#line 312 "../src/raven/sound.vala"
		_g_object_unref0 (row);
#line 1736 "sound.c"
	}
#line 320 "../src/raven/sound.vala"
	result = control;
#line 320 "../src/raven/sound.vala"
	return result;
#line 1742 "sound.c"
}

/**
 * on_device_selected will handle when a checkbox related to an input or output device is selected
 */
static void
budgie_sound_widget_on_device_selected (BudgieSoundWidget* self,
                                        GtkListBoxRow* list_item)
{
	GtkListBox* _tmp0_;
	guint id = 0U;
	gconstpointer _tmp1_;
	GvcMixerUIDevice* _tmp2_ = NULL;
	const gchar* _tmp3_;
	GvcMixerUIDevice* device = NULL;
	GvcMixerUIDevice* _tmp8_;
	GvcMixerUIDevice* _tmp9_;
	GtkListBox* _tmp15_;
#line 326 "../src/raven/sound.vala"
	g_return_if_fail (self != NULL);
#line 327 "../src/raven/sound.vala"
	_tmp0_ = self->priv->devices_list;
#line 327 "../src/raven/sound.vala"
	g_signal_handlers_block_by_func ((void*) _tmp0_, (void*) budgie_sound_widget_on_device_selected, self);
#line 328 "../src/raven/sound.vala"
	_tmp1_ = g_object_get_data ((GObject*) list_item, "device_id");
#line 328 "../src/raven/sound.vala"
	id = (guint) ((guintptr) _tmp1_);
#line 329 "../src/raven/sound.vala"
	_tmp3_ = self->priv->widget_type;
#line 329 "../src/raven/sound.vala"
	if (g_strcmp0 (_tmp3_, "input") == 0) {
#line 1775 "sound.c"
		GvcMixerControl* _tmp4_;
		GvcMixerUIDevice* _tmp5_;
#line 329 "../src/raven/sound.vala"
		_tmp4_ = self->priv->mixer;
#line 329 "../src/raven/sound.vala"
		_tmp5_ = gvc_mixer_control_lookup_input_id (_tmp4_, id);
#line 329 "../src/raven/sound.vala"
		_tmp2_ = _tmp5_;
#line 1784 "sound.c"
	} else {
		GvcMixerControl* _tmp6_;
		GvcMixerUIDevice* _tmp7_;
#line 329 "../src/raven/sound.vala"
		_tmp6_ = self->priv->mixer;
#line 329 "../src/raven/sound.vala"
		_tmp7_ = gvc_mixer_control_lookup_output_id (_tmp6_, id);
#line 329 "../src/raven/sound.vala"
		_tmp2_ = _tmp7_;
#line 1794 "sound.c"
	}
#line 329 "../src/raven/sound.vala"
	_tmp8_ = _g_object_ref0 (_tmp2_);
#line 329 "../src/raven/sound.vala"
	device = _tmp8_;
#line 331 "../src/raven/sound.vala"
	_tmp9_ = device;
#line 331 "../src/raven/sound.vala"
	if (_tmp9_ != NULL) {
#line 1804 "sound.c"
		const gchar* _tmp10_;
#line 332 "../src/raven/sound.vala"
		_tmp10_ = self->priv->widget_type;
#line 332 "../src/raven/sound.vala"
		if (g_strcmp0 (_tmp10_, "input") == 0) {
#line 1810 "sound.c"
			GvcMixerControl* _tmp11_;
			GvcMixerUIDevice* _tmp12_;
#line 333 "../src/raven/sound.vala"
			_tmp11_ = self->priv->mixer;
#line 333 "../src/raven/sound.vala"
			_tmp12_ = device;
#line 333 "../src/raven/sound.vala"
			gvc_mixer_control_change_input (_tmp11_, _tmp12_);
#line 1819 "sound.c"
		} else {
			GvcMixerControl* _tmp13_;
			GvcMixerUIDevice* _tmp14_;
#line 335 "../src/raven/sound.vala"
			_tmp13_ = self->priv->mixer;
#line 335 "../src/raven/sound.vala"
			_tmp14_ = device;
#line 335 "../src/raven/sound.vala"
			gvc_mixer_control_change_output (_tmp13_, _tmp14_);
#line 1829 "sound.c"
		}
	}
#line 338 "../src/raven/sound.vala"
	_tmp15_ = self->priv->devices_list;
#line 338 "../src/raven/sound.vala"
	g_signal_handlers_unblock_by_func ((void*) _tmp15_, (void*) budgie_sound_widget_on_device_selected, self);
#line 326 "../src/raven/sound.vala"
	_g_object_unref0 (device);
#line 1838 "sound.c"
}

/**
 * When our volume slider has changed
 */
static void
budgie_sound_widget_on_scale_change (BudgieSoundWidget* self)
{
	GvcMixerStream* _tmp0_;
	GvcMixerStream* _tmp1_;
	GtkScale* _tmp2_;
#line 344 "../src/raven/sound.vala"
	g_return_if_fail (self != NULL);
#line 345 "../src/raven/sound.vala"
	_tmp0_ = self->priv->primary_stream;
#line 345 "../src/raven/sound.vala"
	if (_tmp0_ == NULL) {
#line 346 "../src/raven/sound.vala"
		return;
#line 1858 "sound.c"
	}
#line 349 "../src/raven/sound.vala"
	_tmp1_ = self->priv->primary_stream;
#line 349 "../src/raven/sound.vala"
	_tmp2_ = self->priv->volume_slider;
#line 349 "../src/raven/sound.vala"
	if (gvc_mixer_stream_set_volume (_tmp1_, (guint32) gtk_range_get_value ((GtkRange*) _tmp2_))) {
#line 1866 "sound.c"
		GvcMixerStream* _tmp3_;
#line 350 "../src/raven/sound.vala"
		_tmp3_ = self->priv->primary_stream;
#line 350 "../src/raven/sound.vala"
		gvc_mixer_stream_push_volume (_tmp3_);
#line 1872 "sound.c"
	}
}

/**
 * on_state_changed will handle when the state of our Mixer or its streams have changed
 */
static void
budgie_sound_widget_on_state_changed (BudgieSoundWidget* self,
                                      guint id)
{
	const gchar* _tmp0_;
#line 357 "../src/raven/sound.vala"
	g_return_if_fail (self != NULL);
#line 358 "../src/raven/sound.vala"
	_tmp0_ = self->priv->widget_type;
#line 358 "../src/raven/sound.vala"
	if (g_strcmp0 (_tmp0_, "output") == 0) {
#line 1890 "sound.c"
		GvcMixerStream* stream = NULL;
		GvcMixerControl* _tmp1_;
		GvcMixerStream* _tmp2_;
		GvcMixerStream* _tmp3_;
		gboolean _tmp4_ = FALSE;
		GvcMixerStream* _tmp5_;
#line 359 "../src/raven/sound.vala"
		_tmp1_ = self->priv->mixer;
#line 359 "../src/raven/sound.vala"
		_tmp2_ = gvc_mixer_control_lookup_stream_id (_tmp1_, id);
#line 359 "../src/raven/sound.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 359 "../src/raven/sound.vala"
		stream = _tmp3_;
#line 361 "../src/raven/sound.vala"
		_tmp5_ = stream;
#line 361 "../src/raven/sound.vala"
		if (_tmp5_ != NULL) {
#line 1909 "sound.c"
			GvcMixerStream* _tmp6_;
#line 361 "../src/raven/sound.vala"
			_tmp6_ = stream;
#line 361 "../src/raven/sound.vala"
			_tmp4_ = gvc_mixer_stream_get_card_index (_tmp6_) == -1;
#line 1915 "sound.c"
		} else {
#line 361 "../src/raven/sound.vala"
			_tmp4_ = FALSE;
#line 1919 "sound.c"
		}
#line 361 "../src/raven/sound.vala"
		if (_tmp4_) {
#line 1923 "sound.c"
			GHashTable* _tmp7_;
#line 362 "../src/raven/sound.vala"
			_tmp7_ = self->priv->apps;
#line 362 "../src/raven/sound.vala"
			if (g_hash_table_contains (_tmp7_, (gpointer) ((guintptr) id))) {
#line 1929 "sound.c"
				BudgieAppSoundControl* control = NULL;
				BudgieAppSoundControl* _tmp8_;
				BudgieAppSoundControl* _tmp9_;
#line 363 "../src/raven/sound.vala"
				_tmp8_ = budgie_sound_widget_get_control_for_app (self, id);
#line 363 "../src/raven/sound.vala"
				control = _tmp8_;
#line 365 "../src/raven/sound.vala"
				_tmp9_ = control;
#line 365 "../src/raven/sound.vala"
				if (_tmp9_ != NULL) {
#line 1941 "sound.c"
					GvcMixerStream* _tmp10_;
#line 366 "../src/raven/sound.vala"
					_tmp10_ = stream;
#line 366 "../src/raven/sound.vala"
					if (gvc_mixer_stream_is_running (_tmp10_)) {
#line 1947 "sound.c"
						BudgieAppSoundControl* _tmp11_;
#line 367 "../src/raven/sound.vala"
						_tmp11_ = control;
#line 367 "../src/raven/sound.vala"
						budgie_app_sound_control_refresh (_tmp11_);
#line 1953 "sound.c"
					} else {
						BudgieAppSoundControl* _tmp12_;
						GHashTable* _tmp13_;
#line 369 "../src/raven/sound.vala"
						_tmp12_ = control;
#line 369 "../src/raven/sound.vala"
						gtk_widget_destroy ((GtkWidget*) _tmp12_);
#line 370 "../src/raven/sound.vala"
						_tmp13_ = self->priv->apps;
#line 370 "../src/raven/sound.vala"
						g_hash_table_steal (_tmp13_, (gpointer) ((guintptr) id));
#line 1965 "sound.c"
					}
				}
#line 374 "../src/raven/sound.vala"
				budgie_sound_widget_toggle_start_listening (self);
#line 362 "../src/raven/sound.vala"
				_g_object_unref0 (control);
#line 1972 "sound.c"
			}
		}
#line 358 "../src/raven/sound.vala"
		_g_object_unref0 (stream);
#line 1977 "sound.c"
	}
#line 379 "../src/raven/sound.vala"
	g_signal_emit (self, budgie_sound_widget_signals[BUDGIE_SOUND_WIDGET_DEVICES_STATE_CHANGED_SIGNAL], 0);
#line 1981 "sound.c"
}

/**
 * on_stream_added will handle when a stream (like an application) has been added
 */
static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 388 "../src/raven/sound.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 388 "../src/raven/sound.vala"
	return _data7_;
#line 1994 "sound.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 388 "../src/raven/sound.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 2004 "sound.c"
		BudgieSoundWidget* self;
#line 388 "../src/raven/sound.vala"
		self = _data7_->self;
#line 388 "../src/raven/sound.vala"
		_g_object_unref0 (_data7_->control);
#line 388 "../src/raven/sound.vala"
		_g_object_unref0 (self);
#line 388 "../src/raven/sound.vala"
		g_slice_free (Block7Data, _data7_);
#line 2014 "sound.c"
	}
}

static void
_____lambda26_ (Block7Data* _data7_)
{
	BudgieSoundWidget* self;
	BudgieAppSoundControl* _tmp0_;
#line 444 "../src/raven/sound.vala"
	self = _data7_->self;
#line 445 "../src/raven/sound.vala"
	_tmp0_ = _data7_->control;
#line 445 "../src/raven/sound.vala"
	budgie_app_sound_control_refresh_volume (_tmp0_);
#line 2029 "sound.c"
}

static void
______lambda26__gvc_channel_map_volume_changed (GvcChannelMap* _sender,
                                                gboolean set,
                                                gpointer self)
{
#line 444 "../src/raven/sound.vala"
	_____lambda26_ (self);
#line 2039 "sound.c"
}

static void
budgie_sound_widget_on_stream_added (BudgieSoundWidget* self,
                                     guint id)
{
	GvcMixerStream* stream = NULL;
	GvcMixerControl* _tmp0_;
	GvcMixerStream* _tmp1_;
	GvcMixerStream* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GvcMixerStream* _tmp4_;
#line 385 "../src/raven/sound.vala"
	g_return_if_fail (self != NULL);
#line 386 "../src/raven/sound.vala"
	_tmp0_ = self->priv->mixer;
#line 386 "../src/raven/sound.vala"
	_tmp1_ = gvc_mixer_control_lookup_stream_id (_tmp0_, id);
#line 386 "../src/raven/sound.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 386 "../src/raven/sound.vala"
	stream = _tmp2_;
#line 388 "../src/raven/sound.vala"
	_tmp4_ = stream;
#line 388 "../src/raven/sound.vala"
	if (_tmp4_ != NULL) {
#line 2066 "sound.c"
		GvcMixerStream* _tmp5_;
#line 388 "../src/raven/sound.vala"
		_tmp5_ = stream;
#line 388 "../src/raven/sound.vala"
		_tmp3_ = gvc_mixer_stream_get_card_index (_tmp5_) == -1;
#line 2072 "sound.c"
	} else {
#line 388 "../src/raven/sound.vala"
		_tmp3_ = FALSE;
#line 2076 "sound.c"
	}
#line 388 "../src/raven/sound.vala"
	if (_tmp3_) {
#line 2080 "sound.c"
		Block7Data* _data7_;
		gchar* name = NULL;
		GvcMixerStream* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* icon = NULL;
		GvcMixerStream* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		GvcMixerStream* _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_;
		GvcMixerStream* _tmp16_;
		gboolean _tmp17_ = FALSE;
		const gchar* _tmp18_;
		const gchar* _tmp20_;
		GvcMixerUIDevice* device = NULL;
		GvcMixerControl* _tmp21_;
		GvcMixerStream* _tmp22_;
		GvcMixerUIDevice* _tmp23_;
		GvcMixerUIDevice* _tmp24_;
		gboolean _tmp25_ = FALSE;
		GvcMixerUIDevice* _tmp26_;
		GHashTable* _tmp28_;
		const gchar* _tmp29_;
		const gchar* _tmp34_;
		GvcMixerControl* _tmp40_;
		GvcMixerStream* _tmp41_;
		GvcMixerStream* _tmp42_;
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		BudgieAppSoundControl* _tmp45_;
		BudgieAppSoundControl* _tmp46_;
#line 388 "../src/raven/sound.vala"
		_data7_ = g_slice_new0 (Block7Data);
#line 388 "../src/raven/sound.vala"
		_data7_->_ref_count_ = 1;
#line 388 "../src/raven/sound.vala"
		_data7_->self = g_object_ref (self);
#line 389 "../src/raven/sound.vala"
		_tmp6_ = stream;
#line 389 "../src/raven/sound.vala"
		_tmp7_ = gvc_mixer_stream_get_name (_tmp6_);
#line 389 "../src/raven/sound.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 389 "../src/raven/sound.vala"
		name = _tmp8_;
#line 390 "../src/raven/sound.vala"
		_tmp9_ = stream;
#line 390 "../src/raven/sound.vala"
		_tmp10_ = gvc_mixer_stream_get_icon_name (_tmp9_);
#line 390 "../src/raven/sound.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 390 "../src/raven/sound.vala"
		icon = _tmp11_;
#line 392 "../src/raven/sound.vala"
		_tmp12_ = name;
#line 392 "../src/raven/sound.vala"
		if (_tmp12_ == NULL) {
#line 393 "../src/raven/sound.vala"
			_g_free0 (icon);
#line 393 "../src/raven/sound.vala"
			_g_free0 (name);
#line 393 "../src/raven/sound.vala"
			block7_data_unref (_data7_);
#line 393 "../src/raven/sound.vala"
			_data7_ = NULL;
#line 393 "../src/raven/sound.vala"
			_g_object_unref0 (stream);
#line 393 "../src/raven/sound.vala"
			return;
#line 2153 "sound.c"
		}
#line 396 "../src/raven/sound.vala"
		_tmp13_ = stream;
#line 396 "../src/raven/sound.vala"
		g_object_get (_tmp13_, "is-event-stream", &_tmp14_, NULL);
#line 396 "../src/raven/sound.vala"
		_tmp15_ = _tmp14_;
#line 396 "../src/raven/sound.vala"
		if (_tmp15_) {
#line 397 "../src/raven/sound.vala"
			_g_free0 (icon);
#line 397 "../src/raven/sound.vala"
			_g_free0 (name);
#line 397 "../src/raven/sound.vala"
			block7_data_unref (_data7_);
#line 397 "../src/raven/sound.vala"
			_data7_ = NULL;
#line 397 "../src/raven/sound.vala"
			_g_object_unref0 (stream);
#line 397 "../src/raven/sound.vala"
			return;
#line 2175 "sound.c"
		}
#line 400 "../src/raven/sound.vala"
		_tmp16_ = stream;
#line 400 "../src/raven/sound.vala"
		if (gvc_mixer_stream_get_volume (_tmp16_) == ((guint32) 100)) {
#line 401 "../src/raven/sound.vala"
			_g_free0 (icon);
#line 401 "../src/raven/sound.vala"
			_g_free0 (name);
#line 401 "../src/raven/sound.vala"
			block7_data_unref (_data7_);
#line 401 "../src/raven/sound.vala"
			_data7_ = NULL;
#line 401 "../src/raven/sound.vala"
			_g_object_unref0 (stream);
#line 401 "../src/raven/sound.vala"
			return;
#line 2193 "sound.c"
		}
#line 404 "../src/raven/sound.vala"
		_tmp18_ = icon;
#line 404 "../src/raven/sound.vala"
		if (g_strcmp0 (_tmp18_, "") != 0) {
#line 2199 "sound.c"
			const gchar* _tmp19_;
#line 404 "../src/raven/sound.vala"
			_tmp19_ = icon;
#line 404 "../src/raven/sound.vala"
			_tmp17_ = string_contains (_tmp19_, "audio-input-");
#line 2205 "sound.c"
		} else {
#line 404 "../src/raven/sound.vala"
			_tmp17_ = FALSE;
#line 2209 "sound.c"
		}
#line 404 "../src/raven/sound.vala"
		if (_tmp17_) {
#line 405 "../src/raven/sound.vala"
			_g_free0 (icon);
#line 405 "../src/raven/sound.vala"
			_g_free0 (name);
#line 405 "../src/raven/sound.vala"
			block7_data_unref (_data7_);
#line 405 "../src/raven/sound.vala"
			_data7_ = NULL;
#line 405 "../src/raven/sound.vala"
			_g_object_unref0 (stream);
#line 405 "../src/raven/sound.vala"
			return;
#line 2225 "sound.c"
		}
#line 408 "../src/raven/sound.vala"
		_tmp20_ = name;
#line 408 "../src/raven/sound.vala"
		if (g_strcmp0 (_tmp20_, "System Sounds") == 0) {
#line 409 "../src/raven/sound.vala"
			_g_free0 (icon);
#line 409 "../src/raven/sound.vala"
			_g_free0 (name);
#line 409 "../src/raven/sound.vala"
			block7_data_unref (_data7_);
#line 409 "../src/raven/sound.vala"
			_data7_ = NULL;
#line 409 "../src/raven/sound.vala"
			_g_object_unref0 (stream);
#line 409 "../src/raven/sound.vala"
			return;
#line 2243 "sound.c"
		}
#line 412 "../src/raven/sound.vala"
		_tmp21_ = self->priv->mixer;
#line 412 "../src/raven/sound.vala"
		_tmp22_ = stream;
#line 412 "../src/raven/sound.vala"
		_tmp23_ = gvc_mixer_control_lookup_device_from_stream (_tmp21_, _tmp22_);
#line 412 "../src/raven/sound.vala"
		_tmp24_ = _g_object_ref0 (_tmp23_);
#line 412 "../src/raven/sound.vala"
		device = _tmp24_;
#line 414 "../src/raven/sound.vala"
		_tmp26_ = device;
#line 414 "../src/raven/sound.vala"
		if (_tmp26_ != NULL) {
#line 2259 "sound.c"
			GvcMixerUIDevice* _tmp27_;
#line 414 "../src/raven/sound.vala"
			_tmp27_ = device;
#line 414 "../src/raven/sound.vala"
			_tmp25_ = !gvc_mixer_ui_device_is_output (_tmp27_);
#line 2265 "sound.c"
		} else {
#line 414 "../src/raven/sound.vala"
			_tmp25_ = FALSE;
#line 2269 "sound.c"
		}
#line 414 "../src/raven/sound.vala"
		if (_tmp25_) {
#line 415 "../src/raven/sound.vala"
			_g_object_unref0 (device);
#line 415 "../src/raven/sound.vala"
			_g_free0 (icon);
#line 415 "../src/raven/sound.vala"
			_g_free0 (name);
#line 415 "../src/raven/sound.vala"
			block7_data_unref (_data7_);
#line 415 "../src/raven/sound.vala"
			_data7_ = NULL;
#line 415 "../src/raven/sound.vala"
			_g_object_unref0 (stream);
#line 415 "../src/raven/sound.vala"
			return;
#line 2287 "sound.c"
		}
#line 418 "../src/raven/sound.vala"
		_tmp28_ = self->priv->derpers;
#line 418 "../src/raven/sound.vala"
		_tmp29_ = name;
#line 418 "../src/raven/sound.vala"
		if (g_hash_table_contains (_tmp28_, _tmp29_)) {
#line 2295 "sound.c"
			GHashTable* _tmp30_;
			const gchar* _tmp31_;
			gconstpointer _tmp32_;
			gchar* _tmp33_;
#line 419 "../src/raven/sound.vala"
			_tmp30_ = self->priv->derpers;
#line 419 "../src/raven/sound.vala"
			_tmp31_ = name;
#line 419 "../src/raven/sound.vala"
			_tmp32_ = g_hash_table_lookup (_tmp30_, _tmp31_);
#line 419 "../src/raven/sound.vala"
			_tmp33_ = g_strdup ((const gchar*) _tmp32_);
#line 419 "../src/raven/sound.vala"
			_g_free0 (icon);
#line 419 "../src/raven/sound.vala"
			icon = _tmp33_;
#line 2312 "sound.c"
		}
#line 422 "../src/raven/sound.vala"
		_tmp34_ = name;
#line 422 "../src/raven/sound.vala"
		if (g_strcmp0 (_tmp34_, "AudioIPC Server") == 0) {
#line 2318 "sound.c"
			gchar* _tmp35_;
			gchar* _tmp36_;
#line 423 "../src/raven/sound.vala"
			_tmp35_ = g_strdup ("firefox");
#line 423 "../src/raven/sound.vala"
			_g_free0 (icon);
#line 423 "../src/raven/sound.vala"
			icon = _tmp35_;
#line 424 "../src/raven/sound.vala"
			_tmp36_ = g_strdup ("Firefox");
#line 424 "../src/raven/sound.vala"
			_g_free0 (name);
#line 424 "../src/raven/sound.vala"
			name = _tmp36_;
#line 2333 "sound.c"
		} else {
			const gchar* _tmp37_;
#line 425 "../src/raven/sound.vala"
			_tmp37_ = name;
#line 425 "../src/raven/sound.vala"
			if (g_strcmp0 (_tmp37_, "WEBRTC VoiceEngine") == 0) {
#line 2340 "sound.c"
				gchar* _tmp38_;
				gchar* _tmp39_;
#line 426 "../src/raven/sound.vala"
				_tmp38_ = g_strdup ("discord");
#line 426 "../src/raven/sound.vala"
				_g_free0 (icon);
#line 426 "../src/raven/sound.vala"
				icon = _tmp38_;
#line 427 "../src/raven/sound.vala"
				_tmp39_ = g_strdup ("Discord");
#line 427 "../src/raven/sound.vala"
				_g_free0 (name);
#line 427 "../src/raven/sound.vala"
				name = _tmp39_;
#line 2355 "sound.c"
			}
		}
#line 430 "../src/raven/sound.vala"
		_tmp40_ = self->priv->mixer;
#line 430 "../src/raven/sound.vala"
		_tmp41_ = self->priv->primary_stream;
#line 430 "../src/raven/sound.vala"
		_tmp42_ = stream;
#line 430 "../src/raven/sound.vala"
		_tmp43_ = icon;
#line 430 "../src/raven/sound.vala"
		_tmp44_ = name;
#line 430 "../src/raven/sound.vala"
		_tmp45_ = budgie_app_sound_control_new (_tmp40_, _tmp41_, _tmp42_, _tmp43_, _tmp44_);
#line 430 "../src/raven/sound.vala"
		g_object_ref_sink (_tmp45_);
#line 430 "../src/raven/sound.vala"
		_data7_->control = _tmp45_;
#line 432 "../src/raven/sound.vala"
		_tmp46_ = _data7_->control;
#line 432 "../src/raven/sound.vala"
		if (_tmp46_ != NULL) {
#line 2378 "sound.c"
			GtkListBoxRow* list_row = NULL;
			GtkListBoxRow* _tmp47_;
			GtkListBoxRow* _tmp48_;
			BudgieAppSoundControl* _tmp49_;
			GtkListBox* _tmp50_;
			GtkListBoxRow* _tmp51_;
			GHashTable* _tmp52_;
			GtkListBoxRow* _tmp53_;
			GtkListBoxRow* _tmp54_;
			GtkListBox* _tmp55_;
			GvcChannelMap* channel_map = NULL;
			GvcMixerStream* _tmp56_;
			GvcChannelMap* _tmp57_;
			GvcChannelMap* _tmp58_;
			GvcChannelMap* _tmp59_;
#line 433 "../src/raven/sound.vala"
			_tmp47_ = (GtkListBoxRow*) gtk_list_box_row_new ();
#line 433 "../src/raven/sound.vala"
			g_object_ref_sink (_tmp47_);
#line 433 "../src/raven/sound.vala"
			list_row = _tmp47_;
#line 434 "../src/raven/sound.vala"
			_tmp48_ = list_row;
#line 434 "../src/raven/sound.vala"
			_tmp49_ = _data7_->control;
#line 434 "../src/raven/sound.vala"
			gtk_container_add ((GtkContainer*) _tmp48_, (GtkWidget*) _tmp49_);
#line 436 "../src/raven/sound.vala"
			_tmp50_ = self->priv->apps_listbox;
#line 436 "../src/raven/sound.vala"
			_tmp51_ = list_row;
#line 436 "../src/raven/sound.vala"
			gtk_list_box_insert (_tmp50_, (GtkWidget*) _tmp51_, -1);
#line 437 "../src/raven/sound.vala"
			_tmp52_ = self->priv->apps;
#line 437 "../src/raven/sound.vala"
			_tmp53_ = list_row;
#line 437 "../src/raven/sound.vala"
			_tmp54_ = _g_object_ref0 (_tmp53_);
#line 437 "../src/raven/sound.vala"
			g_hash_table_insert (_tmp52_, (gpointer) ((guintptr) id), _tmp54_);
#line 438 "../src/raven/sound.vala"
			_tmp55_ = self->priv->apps_listbox;
#line 438 "../src/raven/sound.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp55_);
#line 439 "../src/raven/sound.vala"
			budgie_sound_widget_toggle_start_listening (self);
#line 441 "../src/raven/sound.vala"
			_tmp56_ = stream;
#line 441 "../src/raven/sound.vala"
			_tmp57_ = gvc_mixer_stream_get_channel_map (_tmp56_);
#line 441 "../src/raven/sound.vala"
			_tmp58_ = _g_object_ref0 (_tmp57_);
#line 441 "../src/raven/sound.vala"
			channel_map = _tmp58_;
#line 443 "../src/raven/sound.vala"
			_tmp59_ = channel_map;
#line 443 "../src/raven/sound.vala"
			if (_tmp59_ != NULL) {
#line 2438 "sound.c"
				GvcChannelMap* _tmp60_;
#line 444 "../src/raven/sound.vala"
				_tmp60_ = channel_map;
#line 444 "../src/raven/sound.vala"
				g_signal_connect_data (_tmp60_, "volume-changed", (GCallback) ______lambda26__gvc_channel_map_volume_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 2444 "sound.c"
			}
#line 432 "../src/raven/sound.vala"
			_g_object_unref0 (channel_map);
#line 432 "../src/raven/sound.vala"
			_g_object_unref0 (list_row);
#line 2450 "sound.c"
		}
#line 388 "../src/raven/sound.vala"
		_g_object_unref0 (device);
#line 388 "../src/raven/sound.vala"
		_g_free0 (icon);
#line 388 "../src/raven/sound.vala"
		_g_free0 (name);
#line 388 "../src/raven/sound.vala"
		block7_data_unref (_data7_);
#line 388 "../src/raven/sound.vala"
		_data7_ = NULL;
#line 2462 "sound.c"
	}
#line 385 "../src/raven/sound.vala"
	_g_object_unref0 (stream);
#line 2466 "sound.c"
}

/**
 * on_stream_removed will handle when a stream (like an application) has been removed
 */
static void
budgie_sound_widget_on_stream_removed (BudgieSoundWidget* self,
                                       guint id)
{
	GHashTable* _tmp0_;
#line 455 "../src/raven/sound.vala"
	g_return_if_fail (self != NULL);
#line 456 "../src/raven/sound.vala"
	_tmp0_ = self->priv->apps;
#line 456 "../src/raven/sound.vala"
	if (g_hash_table_contains (_tmp0_, (gpointer) ((guintptr) id))) {
#line 2483 "sound.c"
		GtkListBoxRow* row = NULL;
		GHashTable* _tmp1_;
		gconstpointer _tmp2_;
		GtkListBoxRow* _tmp3_;
		GtkListBoxRow* _tmp4_;
		GHashTable* _tmp7_;
#line 457 "../src/raven/sound.vala"
		_tmp1_ = self->priv->apps;
#line 457 "../src/raven/sound.vala"
		_tmp2_ = g_hash_table_lookup (_tmp1_, (gpointer) ((guintptr) id));
#line 457 "../src/raven/sound.vala"
		_tmp3_ = _g_object_ref0 ((GtkListBoxRow*) _tmp2_);
#line 457 "../src/raven/sound.vala"
		row = _tmp3_;
#line 459 "../src/raven/sound.vala"
		_tmp4_ = row;
#line 459 "../src/raven/sound.vala"
		if (_tmp4_ != NULL) {
#line 2502 "sound.c"
			GtkListBox* _tmp5_;
			GtkListBoxRow* _tmp6_;
#line 460 "../src/raven/sound.vala"
			_tmp5_ = self->priv->apps_listbox;
#line 460 "../src/raven/sound.vala"
			_tmp6_ = row;
#line 460 "../src/raven/sound.vala"
			gtk_container_remove ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 2511 "sound.c"
		}
#line 463 "../src/raven/sound.vala"
		_tmp7_ = self->priv->apps;
#line 463 "../src/raven/sound.vala"
		g_hash_table_steal (_tmp7_, (gpointer) ((guintptr) id));
#line 464 "../src/raven/sound.vala"
		budgie_sound_widget_toggle_start_listening (self);
#line 456 "../src/raven/sound.vala"
		_g_object_unref0 (row);
#line 2521 "sound.c"
	}
}

/**
 * on_volume_safety_changed will listen to changes to our above 100 percent key
 * If the volume is allowed to go over 100%, we'll update the slider range. Otherwise, we'll change or keep it at 100%
 */
static void
budgie_sound_widget_on_volume_safety_changed (BudgieSoundWidget* self)
{
	GSettings* _tmp0_;
#line 472 "../src/raven/sound.vala"
	g_return_if_fail (self != NULL);
#line 473 "../src/raven/sound.vala"
	_tmp0_ = self->priv->raven_settings;
#line 473 "../src/raven/sound.vala"
	budgie_sound_widget_set_slider_range_on_max (self, g_settings_get_boolean (_tmp0_, BUDGIE_SOUND_WIDGET_MAX_KEY));
#line 2539 "sound.c"
}

static void
budgie_sound_widget_set_slider_range_on_max (BudgieSoundWidget* self,
                                             gboolean allow_overdrive)
{
	gdouble current_volume = 0.0;
	GtkScale* _tmp0_;
	gdouble vol_max = 0.0;
	GvcMixerControl* _tmp1_;
	gdouble vol_max_above = 0.0;
	GvcMixerControl* _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble step_size = 0.0;
	gint slider_start = 0;
	gint slider_end = 0;
	GtkScale* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gboolean _tmp7_ = FALSE;
#line 479 "../src/raven/sound.vala"
	g_return_if_fail (self != NULL);
#line 480 "../src/raven/sound.vala"
	_tmp0_ = self->priv->volume_slider;
#line 480 "../src/raven/sound.vala"
	current_volume = gtk_range_get_value ((GtkRange*) _tmp0_);
#line 481 "../src/raven/sound.vala"
	_tmp1_ = self->priv->mixer;
#line 481 "../src/raven/sound.vala"
	vol_max = gvc_mixer_control_get_vol_max_norm (_tmp1_);
#line 482 "../src/raven/sound.vala"
	_tmp2_ = self->priv->mixer;
#line 482 "../src/raven/sound.vala"
	vol_max_above = gvc_mixer_control_get_vol_max_amplified (_tmp2_);
#line 483 "../src/raven/sound.vala"
	if (allow_overdrive) {
#line 483 "../src/raven/sound.vala"
		_tmp3_ = vol_max_above / 20;
#line 2578 "sound.c"
	} else {
#line 483 "../src/raven/sound.vala"
		_tmp3_ = vol_max / 20;
#line 2582 "sound.c"
	}
#line 483 "../src/raven/sound.vala"
	step_size = _tmp3_;
#line 485 "../src/raven/sound.vala"
	slider_start = 0;
#line 486 "../src/raven/sound.vala"
	slider_end = 0;
#line 487 "../src/raven/sound.vala"
	_tmp4_ = self->priv->volume_slider;
#line 487 "../src/raven/sound.vala"
	gtk_range_get_slider_range ((GtkRange*) _tmp4_, &_tmp5_, &_tmp6_);
#line 487 "../src/raven/sound.vala"
	slider_start = _tmp5_;
#line 487 "../src/raven/sound.vala"
	slider_end = _tmp6_;
#line 489 "../src/raven/sound.vala"
	if (allow_overdrive) {
#line 489 "../src/raven/sound.vala"
		_tmp7_ = ((gdouble) slider_end) != vol_max_above;
#line 2602 "sound.c"
	} else {
#line 489 "../src/raven/sound.vala"
		_tmp7_ = FALSE;
#line 2606 "sound.c"
	}
#line 489 "../src/raven/sound.vala"
	if (_tmp7_) {
#line 2610 "sound.c"
		GtkScale* _tmp8_;
		GtkScale* _tmp9_;
		GtkScale* _tmp10_;
#line 490 "../src/raven/sound.vala"
		_tmp8_ = self->priv->volume_slider;
#line 490 "../src/raven/sound.vala"
		gtk_range_set_increments ((GtkRange*) _tmp8_, step_size, step_size);
#line 491 "../src/raven/sound.vala"
		_tmp9_ = self->priv->volume_slider;
#line 491 "../src/raven/sound.vala"
		gtk_range_set_range ((GtkRange*) _tmp9_, (gdouble) 0, vol_max_above);
#line 492 "../src/raven/sound.vala"
		_tmp10_ = self->priv->volume_slider;
#line 492 "../src/raven/sound.vala"
		gtk_range_set_value ((GtkRange*) _tmp10_, current_volume);
#line 2626 "sound.c"
	} else {
		gboolean _tmp11_ = FALSE;
#line 493 "../src/raven/sound.vala"
		if (!allow_overdrive) {
#line 493 "../src/raven/sound.vala"
			_tmp11_ = ((gdouble) slider_end) != vol_max;
#line 2633 "sound.c"
		} else {
#line 493 "../src/raven/sound.vala"
			_tmp11_ = FALSE;
#line 2637 "sound.c"
		}
#line 493 "../src/raven/sound.vala"
		if (_tmp11_) {
#line 2641 "sound.c"
			GtkScale* _tmp12_;
			GtkScale* _tmp13_;
			GtkScale* _tmp14_;
#line 494 "../src/raven/sound.vala"
			_tmp12_ = self->priv->volume_slider;
#line 494 "../src/raven/sound.vala"
			gtk_range_set_increments ((GtkRange*) _tmp12_, step_size, step_size);
#line 495 "../src/raven/sound.vala"
			_tmp13_ = self->priv->volume_slider;
#line 495 "../src/raven/sound.vala"
			gtk_range_set_range ((GtkRange*) _tmp13_, (gdouble) 0, vol_max);
#line 496 "../src/raven/sound.vala"
			_tmp14_ = self->priv->volume_slider;
#line 496 "../src/raven/sound.vala"
			gtk_range_set_value ((GtkRange*) _tmp14_, current_volume);
#line 2657 "sound.c"
		}
	}
#line 499 "../src/raven/sound.vala"
	budgie_sound_widget_update_input_draw_markers (self);
#line 2662 "sound.c"
}

/**
 * toggle_start_listening will handle showing or hiding our Start Listening box if needed
 */
static void
budgie_sound_widget_toggle_start_listening (BudgieSoundWidget* self)
{
	const gchar* _tmp0_;
#line 505 "../src/raven/sound.vala"
	g_return_if_fail (self != NULL);
#line 506 "../src/raven/sound.vala"
	_tmp0_ = self->priv->widget_type;
#line 506 "../src/raven/sound.vala"
	if (g_strcmp0 (_tmp0_, "output") == 0) {
#line 2678 "sound.c"
		gboolean apps_exist = FALSE;
		GHashTable* _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
		GtkRevealer* _tmp4_;
		GtkRevealer* _tmp5_;
#line 507 "../src/raven/sound.vala"
		_tmp1_ = self->priv->apps;
#line 507 "../src/raven/sound.vala"
		_tmp2_ = g_hash_table_size (_tmp1_);
#line 507 "../src/raven/sound.vala"
		_tmp3_ = _tmp2_;
#line 507 "../src/raven/sound.vala"
		apps_exist = _tmp3_ != ((guint) 0);
#line 508 "../src/raven/sound.vala"
		_tmp4_ = self->priv->listening_box_revealer;
#line 508 "../src/raven/sound.vala"
		gtk_revealer_set_reveal_child (_tmp4_, !apps_exist);
#line 509 "../src/raven/sound.vala"
		_tmp5_ = self->priv->apps_list_revealer;
#line 509 "../src/raven/sound.vala"
		gtk_revealer_set_reveal_child (_tmp5_, apps_exist);
#line 2701 "sound.c"
	}
}

/**
 * update_input_draw_markers will update our draw markers
 */
static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1133 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1133 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1134 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1134 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1136 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1136 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 2729 "sound.c"
		gchar* _tmp2_;
#line 1137 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1137 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1137 "glib-2.0.vapi"
		return result;
#line 2737 "sound.c"
	} else {
#line 1139 "glib-2.0.vapi"
		result = -1;
#line 1139 "glib-2.0.vapi"
		return result;
#line 2743 "sound.c"
	}
}

static void
budgie_sound_widget_update_input_draw_markers (BudgieSoundWidget* self)
{
	const gchar* _tmp0_;
	gboolean builtin_enabled = FALSE;
	GSettings* _tmp1_;
	gchar* current_theme = NULL;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	gboolean supported_theme = FALSE;
	const gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
#line 516 "../src/raven/sound.vala"
	g_return_if_fail (self != NULL);
#line 517 "../src/raven/sound.vala"
	_tmp0_ = self->priv->widget_type;
#line 517 "../src/raven/sound.vala"
	if (g_strcmp0 (_tmp0_, "input") == 0) {
#line 518 "../src/raven/sound.vala"
		return;
#line 2767 "sound.c"
	}
#line 521 "../src/raven/sound.vala"
	_tmp1_ = self->priv->budgie_settings;
#line 521 "../src/raven/sound.vala"
	builtin_enabled = g_settings_get_boolean (_tmp1_, "builtin-theme");
#line 522 "../src/raven/sound.vala"
	_tmp2_ = self->priv->gnome_desktop_settings;
#line 522 "../src/raven/sound.vala"
	_tmp3_ = g_settings_get_string (_tmp2_, "gtk-theme");
#line 522 "../src/raven/sound.vala"
	current_theme = _tmp3_;
#line 523 "../src/raven/sound.vala"
	_tmp4_ = current_theme;
#line 523 "../src/raven/sound.vala"
	supported_theme = string_index_of (_tmp4_, "Arc", 0) == -1;
#line 525 "../src/raven/sound.vala"
	if (!builtin_enabled) {
#line 525 "../src/raven/sound.vala"
		_tmp5_ = supported_theme;
#line 2787 "sound.c"
	} else {
#line 525 "../src/raven/sound.vala"
		_tmp5_ = FALSE;
#line 2791 "sound.c"
	}
#line 525 "../src/raven/sound.vala"
	if (_tmp5_) {
#line 2795 "sound.c"
		gboolean allow_higher_than_max = FALSE;
		GSettings* _tmp6_;
#line 526 "../src/raven/sound.vala"
		_tmp6_ = self->priv->raven_settings;
#line 526 "../src/raven/sound.vala"
		allow_higher_than_max = g_settings_get_boolean (_tmp6_, BUDGIE_SOUND_WIDGET_MAX_KEY);
#line 528 "../src/raven/sound.vala"
		if (allow_higher_than_max) {
#line 2804 "sound.c"
			gdouble vol_max = 0.0;
			GvcMixerControl* _tmp7_;
			GtkScale* _tmp8_;
#line 529 "../src/raven/sound.vala"
			_tmp7_ = self->priv->mixer;
#line 529 "../src/raven/sound.vala"
			vol_max = gvc_mixer_control_get_vol_max_norm (_tmp7_);
#line 530 "../src/raven/sound.vala"
			_tmp8_ = self->priv->volume_slider;
#line 530 "../src/raven/sound.vala"
			gtk_scale_add_mark (_tmp8_, vol_max, GTK_POS_BOTTOM, "");
#line 2816 "sound.c"
		} else {
			GtkScale* _tmp9_;
#line 532 "../src/raven/sound.vala"
			_tmp9_ = self->priv->volume_slider;
#line 532 "../src/raven/sound.vala"
			gtk_scale_clear_marks (_tmp9_);
#line 2823 "sound.c"
		}
	} else {
		GtkScale* _tmp10_;
#line 535 "../src/raven/sound.vala"
		_tmp10_ = self->priv->volume_slider;
#line 535 "../src/raven/sound.vala"
		gtk_scale_clear_marks (_tmp10_);
#line 2831 "sound.c"
	}
#line 516 "../src/raven/sound.vala"
	_g_free0 (current_theme);
#line 2835 "sound.c"
}

/**
 * update_volume will handle updating our volume slider and output header during device change
 */
static void
budgie_sound_widget_update_volume (BudgieSoundWidget* self)
{
	guint32 vol = 0U;
	GvcMixerStream* _tmp0_;
	gdouble vol_max = 0.0;
	GvcMixerControl* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gint n = 0;
	gchar* image_name = NULL;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_;
	gchar* icon_prefix = NULL;
	gchar* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GvcMixerStream* _tmp10_;
	BudgieHeaderWidget* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gdouble step_size = 0.0;
	GtkScale* _tmp21_;
	GtkScale* _tmp22_;
	GtkScale* _tmp23_;
#line 542 "../src/raven/sound.vala"
	g_return_if_fail (self != NULL);
#line 543 "../src/raven/sound.vala"
	_tmp0_ = self->priv->primary_stream;
#line 543 "../src/raven/sound.vala"
	vol = gvc_mixer_stream_get_volume (_tmp0_);
#line 544 "../src/raven/sound.vala"
	_tmp1_ = self->priv->mixer;
#line 544 "../src/raven/sound.vala"
	vol_max = gvc_mixer_control_get_vol_max_norm (_tmp1_);
#line 546 "../src/raven/sound.vala"
	_tmp3_ = self->priv->widget_type;
#line 546 "../src/raven/sound.vala"
	if (g_strcmp0 (_tmp3_, "output") == 0) {
#line 2881 "sound.c"
		GSettings* _tmp4_;
#line 546 "../src/raven/sound.vala"
		_tmp4_ = self->priv->raven_settings;
#line 546 "../src/raven/sound.vala"
		_tmp2_ = g_settings_get_boolean (_tmp4_, BUDGIE_SOUND_WIDGET_MAX_KEY);
#line 2887 "sound.c"
	} else {
#line 546 "../src/raven/sound.vala"
		_tmp2_ = FALSE;
#line 2891 "sound.c"
	}
#line 546 "../src/raven/sound.vala"
	if (_tmp2_) {
#line 2895 "sound.c"
		GvcMixerControl* _tmp5_;
#line 547 "../src/raven/sound.vala"
		_tmp5_ = self->priv->mixer;
#line 547 "../src/raven/sound.vala"
		vol_max = gvc_mixer_control_get_vol_max_amplified (_tmp5_);
#line 2901 "sound.c"
	}
#line 552 "../src/raven/sound.vala"
	n = ((gint) floor ((3 * vol) / vol_max)) + 1;
#line 556 "../src/raven/sound.vala"
	_tmp7_ = self->priv->widget_type;
#line 556 "../src/raven/sound.vala"
	if (g_strcmp0 (_tmp7_, "input") == 0) {
#line 556 "../src/raven/sound.vala"
		_tmp6_ = "microphone-sensitivity-";
#line 2911 "sound.c"
	} else {
#line 556 "../src/raven/sound.vala"
		_tmp6_ = "audio-volume-";
#line 2915 "sound.c"
	}
#line 556 "../src/raven/sound.vala"
	_tmp8_ = g_strdup (_tmp6_);
#line 556 "../src/raven/sound.vala"
	icon_prefix = _tmp8_;
#line 558 "../src/raven/sound.vala"
	_tmp10_ = self->priv->primary_stream;
#line 558 "../src/raven/sound.vala"
	if (gvc_mixer_stream_get_is_muted (_tmp10_)) {
#line 558 "../src/raven/sound.vala"
		_tmp9_ = TRUE;
#line 2927 "sound.c"
	} else {
#line 558 "../src/raven/sound.vala"
		_tmp9_ = vol <= ((guint32) 0);
#line 2931 "sound.c"
	}
#line 558 "../src/raven/sound.vala"
	if (_tmp9_) {
#line 2935 "sound.c"
		gchar* _tmp11_;
#line 559 "../src/raven/sound.vala"
		_tmp11_ = g_strdup ("muted-symbolic");
#line 559 "../src/raven/sound.vala"
		_g_free0 (image_name);
#line 559 "../src/raven/sound.vala"
		image_name = _tmp11_;
#line 2943 "sound.c"
	} else {
#line 561 "../src/raven/sound.vala"
		switch (n) {
#line 561 "../src/raven/sound.vala"
			case 1:
#line 2949 "sound.c"
			{
				gchar* _tmp12_;
#line 563 "../src/raven/sound.vala"
				_tmp12_ = g_strdup ("low-symbolic");
#line 563 "../src/raven/sound.vala"
				_g_free0 (image_name);
#line 563 "../src/raven/sound.vala"
				image_name = _tmp12_;
#line 564 "../src/raven/sound.vala"
				break;
#line 2960 "sound.c"
			}
#line 561 "../src/raven/sound.vala"
			case 2:
#line 2964 "sound.c"
			{
				gchar* _tmp13_;
#line 566 "../src/raven/sound.vala"
				_tmp13_ = g_strdup ("medium-symbolic");
#line 566 "../src/raven/sound.vala"
				_g_free0 (image_name);
#line 566 "../src/raven/sound.vala"
				image_name = _tmp13_;
#line 567 "../src/raven/sound.vala"
				break;
#line 2975 "sound.c"
			}
			default:
			{
				gchar* _tmp14_;
#line 569 "../src/raven/sound.vala"
				_tmp14_ = g_strdup ("high-symbolic");
#line 569 "../src/raven/sound.vala"
				_g_free0 (image_name);
#line 569 "../src/raven/sound.vala"
				image_name = _tmp14_;
#line 570 "../src/raven/sound.vala"
				break;
#line 2988 "sound.c"
			}
		}
	}
#line 574 "../src/raven/sound.vala"
	_tmp15_ = self->priv->header;
#line 574 "../src/raven/sound.vala"
	_tmp16_ = icon_prefix;
#line 574 "../src/raven/sound.vala"
	_tmp17_ = image_name;
#line 574 "../src/raven/sound.vala"
	_tmp18_ = g_strconcat (_tmp16_, _tmp17_, NULL);
#line 574 "../src/raven/sound.vala"
	_tmp19_ = _tmp18_;
#line 574 "../src/raven/sound.vala"
	budgie_header_widget_set_icon_name (_tmp15_, _tmp19_);
#line 574 "../src/raven/sound.vala"
	_g_free0 (_tmp19_);
#line 577 "../src/raven/sound.vala"
	step_size = vol_max / 20;
#line 579 "../src/raven/sound.vala"
	if (self->priv->scale_id > ((gulong) 0)) {
#line 3010 "sound.c"
		GtkScale* _tmp20_;
#line 580 "../src/raven/sound.vala"
		_tmp20_ = self->priv->volume_slider;
#line 580 "../src/raven/sound.vala"
		g_signal_handler_block (_tmp20_, self->priv->scale_id);
#line 3016 "sound.c"
	}
#line 583 "../src/raven/sound.vala"
	_tmp21_ = self->priv->volume_slider;
#line 583 "../src/raven/sound.vala"
	gtk_range_set_increments ((GtkRange*) _tmp21_, step_size, step_size);
#line 584 "../src/raven/sound.vala"
	_tmp22_ = self->priv->volume_slider;
#line 584 "../src/raven/sound.vala"
	gtk_range_set_range ((GtkRange*) _tmp22_, (gdouble) 0, vol_max);
#line 585 "../src/raven/sound.vala"
	_tmp23_ = self->priv->volume_slider;
#line 585 "../src/raven/sound.vala"
	gtk_range_set_value ((GtkRange*) _tmp23_, (gdouble) vol);
#line 587 "../src/raven/sound.vala"
	if (self->priv->scale_id > ((gulong) 0)) {
#line 3032 "sound.c"
		GtkScale* _tmp24_;
#line 588 "../src/raven/sound.vala"
		_tmp24_ = self->priv->volume_slider;
#line 588 "../src/raven/sound.vala"
		g_signal_handler_unblock (_tmp24_, self->priv->scale_id);
#line 3038 "sound.c"
	}
#line 542 "../src/raven/sound.vala"
	_g_free0 (icon_prefix);
#line 542 "../src/raven/sound.vala"
	_g_free0 (image_name);
#line 3044 "sound.c"
}

static void
budgie_sound_widget_class_init (BudgieSoundWidgetClass * klass,
                                gpointer klass_data)
{
#line 13 "../src/raven/sound.vala"
	budgie_sound_widget_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/raven/sound.vala"
	g_type_class_adjust_private_offset (klass, &BudgieSoundWidget_private_offset);
#line 13 "../src/raven/sound.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_sound_widget_finalize;
#line 3057 "sound.c"
	/**
	 * Signals
	 */
#line 13 "../src/raven/sound.vala"
	budgie_sound_widget_signals[BUDGIE_SOUND_WIDGET_DEVICES_STATE_CHANGED_SIGNAL] = g_signal_new ("devices-state-changed", BUDGIE_TYPE_SOUND_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3063 "sound.c"
}

static void
budgie_sound_widget_instance_init (BudgieSoundWidget * self,
                                   gpointer klass)
{
	gchar* _tmp0_;
#line 13 "../src/raven/sound.vala"
	self->priv = budgie_sound_widget_get_instance_private (self);
#line 21 "../src/raven/sound.vala"
	self->priv->scale_id = (gulong) 0;
#line 22 "../src/raven/sound.vala"
	self->priv->mixer = NULL;
#line 26 "../src/raven/sound.vala"
	self->priv->primary_notify_id = (gulong) 0;
#line 27 "../src/raven/sound.vala"
	self->priv->primary_stream = NULL;
#line 28 "../src/raven/sound.vala"
	self->priv->settings = NULL;
#line 29 "../src/raven/sound.vala"
	_tmp0_ = g_strdup ("");
#line 29 "../src/raven/sound.vala"
	self->priv->widget_type = _tmp0_;
#line 39 "../src/raven/sound.vala"
	self->priv->header = NULL;
#line 40 "../src/raven/sound.vala"
	self->priv->apps_area = NULL;
#line 41 "../src/raven/sound.vala"
	self->priv->apps_listbox = NULL;
#line 42 "../src/raven/sound.vala"
	self->priv->apps_list_revealer = NULL;
#line 43 "../src/raven/sound.vala"
	self->priv->devices_list = NULL;
#line 44 "../src/raven/sound.vala"
	self->priv->listening_box = NULL;
#line 45 "../src/raven/sound.vala"
	self->priv->listening_box_revealer = NULL;
#line 46 "../src/raven/sound.vala"
	self->priv->main_layout = NULL;
#line 47 "../src/raven/sound.vala"
	self->priv->widget_area = NULL;
#line 48 "../src/raven/sound.vala"
	self->priv->widget_area_switch = NULL;
#line 49 "../src/raven/sound.vala"
	self->priv->volume_slider = NULL;
#line 3109 "sound.c"
}

static void
budgie_sound_widget_finalize (GObject * obj)
{
	BudgieSoundWidget * self;
#line 13 "../src/raven/sound.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_SOUND_WIDGET, BudgieSoundWidget);
#line 18 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->budgie_settings);
#line 19 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->gnome_desktop_settings);
#line 20 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->raven_settings);
#line 22 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->mixer);
#line 23 "../src/raven/sound.vala"
	_g_hash_table_unref0 (self->priv->apps);
#line 24 "../src/raven/sound.vala"
	_g_hash_table_unref0 (self->priv->derpers);
#line 25 "../src/raven/sound.vala"
	_g_hash_table_unref0 (self->priv->devices);
#line 27 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->primary_stream);
#line 28 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->settings);
#line 29 "../src/raven/sound.vala"
	_g_free0 (self->priv->widget_type);
#line 39 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->header);
#line 40 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->apps_area);
#line 41 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->apps_listbox);
#line 42 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->apps_list_revealer);
#line 43 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->devices_list);
#line 44 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->listening_box);
#line 45 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->listening_box_revealer);
#line 46 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->main_layout);
#line 47 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->widget_area);
#line 48 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->widget_area_switch);
#line 49 "../src/raven/sound.vala"
	_g_object_unref0 (self->priv->volume_slider);
#line 13 "../src/raven/sound.vala"
	G_OBJECT_CLASS (budgie_sound_widget_parent_class)->finalize (obj);
#line 3162 "sound.c"
}

static GType
budgie_sound_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieSoundWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_sound_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieSoundWidget), 0, (GInstanceInitFunc) budgie_sound_widget_instance_init, NULL };
	GType budgie_sound_widget_type_id;
	budgie_sound_widget_type_id = g_type_register_static (TYPE_RAVEN_WIDGET, "BudgieSoundWidget", &g_define_type_info, 0);
	BudgieSoundWidget_private_offset = g_type_add_instance_private (budgie_sound_widget_type_id, sizeof (BudgieSoundWidgetPrivate));
	return budgie_sound_widget_type_id;
}

GType
budgie_sound_widget_get_type (void)
{
	static volatile gsize budgie_sound_widget_type_id__once = 0;
	if (g_once_init_enter (&budgie_sound_widget_type_id__once)) {
		GType budgie_sound_widget_type_id;
		budgie_sound_widget_type_id = budgie_sound_widget_get_type_once ();
		g_once_init_leave (&budgie_sound_widget_type_id__once, budgie_sound_widget_type_id);
	}
	return budgie_sound_widget_type_id__once;
}

