/* IconButton.c generated by valac 0.56.3, the Vala compiler
 * generated from IconButton.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2022 Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <glib.h>
#include <float.h>
#include <math.h>
#include "icontasklistapplet.h"
#include <libwnck/libwnck.h>
#include <gio/gio.h>
#include "abomination.h"
#include <gio/gdesktopappinfo.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "appsys.h"
#include "plugin.h"
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define DEFAULT_OPACITY 0.1
#define INDICATOR_SIZE 2
#define INDICATOR_SPACING 1
#define INACTIVE_INDICATOR_SPACING 2

enum  {
	ICON_BUTTON_0_PROPERTY,
	ICON_BUTTON_ABOMINATION_PROPERTY,
	ICON_BUTTON_APP_SYSTEM_PROPERTY,
	ICON_BUTTON_DESKTOP_HELPER_PROPERTY,
	ICON_BUTTON_POPOVER_MANAGER_PROPERTY,
	ICON_BUTTON_NUM_PROPERTIES
};
static GParamSpec* icon_button_properties[ICON_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
typedef struct _Block5Data Block5Data;
#define __vala_GdkEventButton_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventButton_free (var), NULL)))
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
enum  {
	ICON_BUTTON_BECAME_EMPTY_SIGNAL,
	ICON_BUTTON_PINNED_CHANGED_SIGNAL,
	ICON_BUTTON_NUM_SIGNALS
};
static guint icon_button_signals[ICON_BUTTON_NUM_SIGNALS] = {0};

struct _IconButtonPrivate {
	BudgieIconPopover* popover;
	WnckScreen* screen;
	GSettings* settings;
	WnckWindow* window;
	BudgieAbominationAppGroup* class_group;
	GDesktopAppInfo* app_info;
	gint window_count;
	GtkAllocation definite_allocation;
	gboolean originally_pinned;
	GdkAppLaunchContext* launch_context;
	gint64 last_scroll_time;
	gboolean needs_attention;
	BudgieAbominationAbomination* _abomination;
	BudgieAppSystem* _app_system;
	DesktopHelper* _desktop_helper;
	BudgiePopoverManager* _popover_manager;
};

struct _Block2Data {
	int _ref_count_;
	IconButton* self;
	BudgieAbominationRunningApp* app;
};

struct _Block3Data {
	int _ref_count_;
	IconButton* self;
	gulong xid;
};

struct _Block4Data {
	int _ref_count_;
	IconButton* self;
	WnckWindow* window;
};

struct _Block5Data {
	int _ref_count_;
	IconButton* self;
	WnckWindow* window;
};

struct _Block6Data {
	int _ref_count_;
	IconButton* self;
	GdkEventButton* event;
};

struct _Block7Data {
	int _ref_count_;
	Block6Data * _data6_;
	gboolean one_active;
};

static gint IconButton_private_offset;
static gpointer icon_button_parent_class = NULL;
static GType icon_button_type_id = 0;

static void icon_button_gobject_constructors_suck (IconButton* self);
static gboolean icon_button_has_valid_windows (IconButton* self,
                                        gint* num_windows);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda35_ (Block2Data* _data2_);
static void ___lambda35__wnck_window_state_changed (WnckWindow* _sender,
                                             WnckWindowState changed_mask,
                                             WnckWindowState new_state,
                                             gpointer self);
static gboolean __lambda19_ (IconButton* self);
static gboolean ___lambda19__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                     GdkEventCrossing* event,
                                                     gpointer self);
static gboolean __lambda20_ (IconButton* self);
static gboolean ___lambda20__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                     GdkEventCrossing* event,
                                                     gpointer self);
static void __lambda21_ (IconButton* self,
                  GdkDragContext* context);
static void ___lambda21__gtk_widget_drag_begin (GtkWidget* _sender,
                                         GdkDragContext* context,
                                         gpointer self);
static void __lambda22_ (IconButton* self,
                  GtkWidget* widget,
                  GdkDragContext* context,
                  GtkSelectionData* selection_data,
                  guint info,
                  guint time);
static void ___lambda22__gtk_widget_drag_data_get (GtkWidget* _sender,
                                            GdkDragContext* context,
                                            GtkSelectionData* selection_data,
                                            guint info,
                                            guint time_,
                                            gpointer self);
static void _icon_button_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                             GtkAllocation* allocation,
                                                             gpointer self);
static void icon_button_on_launched (IconButton* self,
                              GAppInfo* info,
                              GVariant* v);
static void _icon_button_on_launched_g_app_launch_context_launched (GAppLaunchContext* _sender,
                                                             GAppInfo* info,
                                                             GVariant* platform_data,
                                                             gpointer self);
static void icon_button_on_launch_failed (IconButton* self,
                                   const gchar* id);
static void _icon_button_on_launch_failed_g_app_launch_context_launch_failed (GAppLaunchContext* _sender,
                                                                       const gchar* startup_notify_id,
                                                                       gpointer self);
static void ___lambda23_ (IconButton* self);
static void ____lambda23__budgie_abomination_running_app_renamed_app (BudgieAbominationRunningApp* _sender,
                                                               const gchar* old_name,
                                                               const gchar* new_name,
                                                               gpointer self);
static void ___lambda24_ (IconButton* self,
                   GDesktopAppInfo* app_info);
static void ____lambda24__budgie_abomination_running_app_app_info_changed (BudgieAbominationRunningApp* _sender,
                                                                    GDesktopAppInfo* app_info,
                                                                    gpointer self);
static void ___lambda25_ (IconButton* self);
static void ____lambda25__budgie_abomination_running_app_icon_changed (BudgieAbominationRunningApp* _sender,
                                                                const gchar* icon_name,
                                                                gpointer self);
static void __lambda26_ (IconButton* self);
static void icon_button_launch_app (IconButton* self,
                             guint32 time);
static void ___lambda26__budgie_icon_popover_launch_new_instance (BudgieIconPopover* _sender,
                                                           gpointer self);
static void __lambda27_ (IconButton* self);
static void ___lambda27__budgie_icon_popover_added_window (BudgieIconPopover* _sender,
                                                    gpointer self);
static void __lambda28_ (IconButton* self);
static void ___lambda28__budgie_icon_popover_closed_all (BudgieIconPopover* _sender,
                                                  gpointer self);
static void __lambda29_ (IconButton* self);
static void ___lambda29__budgie_icon_popover_closed_window (BudgieIconPopover* _sender,
                                                     gpointer self);
static void __lambda30_ (IconButton* self,
                  gboolean new_pinned_state);
static void ___lambda30__budgie_icon_popover_changed_pin_state (BudgieIconPopover* _sender,
                                                         gboolean new_state,
                                                         gpointer self);
static void __lambda31_ (IconButton* self,
                  gulong xid,
                  gint wid);
static void ___lambda31__budgie_icon_popover_move_window_to_workspace (BudgieIconPopover* _sender,
                                                                gulong xid,
                                                                gint workspace_num,
                                                                gpointer self);
static void __lambda32_ (IconButton* self,
                  const gchar* action);
static void ___lambda32__budgie_icon_popover_perform_action (BudgieIconPopover* _sender,
                                                      const gchar* action,
                                                      gpointer self);
static void __lambda33_ (IconButton* self,
                  WnckWorkspace* workspace);
static void ___lambda33__wnck_screen_workspace_created (WnckScreen* _sender,
                                                 WnckWorkspace* space,
                                                 gpointer self);
static void __lambda34_ (IconButton* self,
                  WnckWorkspace* workspace);
static void ___lambda34__wnck_screen_workspace_destroyed (WnckScreen* _sender,
                                                   WnckWorkspace* space,
                                                   gpointer self);
static void __lambda38_ (IconButton* self);
static void ___lambda38__budgie_abomination_app_group_icon_changed (BudgieAbominationAppGroup* _sender,
                                                             gpointer self);
static void __lambda39_ (IconButton* self,
                  WnckWindow* new_window);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean icon_button_should_add_window (IconButton* self,
                                        WnckWindow* new_window);
static void __lambda40_ (Block3Data* _data3_);
static void ___lambda40__wnck_window_name_changed (WnckWindow* _sender,
                                            gpointer self);
static void ___lambda39__budgie_abomination_app_group_added_window (BudgieAbominationAppGroup* _sender,
                                                             WnckWindow* window,
                                                             gpointer self);
static void __lambda41_ (IconButton* self,
                  WnckWindow* old_window);
static void ___lambda41__budgie_abomination_app_group_removed_window (BudgieAbominationAppGroup* _sender,
                                                               WnckWindow* window,
                                                               gpointer self);
static void icon_button_setup_popover_with_class (IconButton* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda36_ (Block4Data* _data4_);
static void ___lambda36__wnck_window_name_changed (WnckWindow* _sender,
                                            gpointer self);
static void __lambda37_ (Block4Data* _data4_);
static void ___lambda37__wnck_window_state_changed (WnckWindow* _sender,
                                             WnckWindowState changed_mask,
                                             WnckWindowState new_state,
                                             gpointer self);
static gboolean icon_button_real_draw (GtkWidget* base,
                                cairo_t* cr);
static void _____lambda42_ (IconButton* self);
static void ______lambda42__budgie_abomination_running_app_renamed_app (BudgieAbominationRunningApp* _sender,
                                                                 const gchar* old_name,
                                                                 const gchar* new_name,
                                                                 gpointer self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _______lambda43_ (Block5Data* _data5_);
static void ________lambda43__wnck_window_name_changed (WnckWindow* _sender,
                                                 gpointer self);
static void _______lambda44_ (Block5Data* _data5_);
static void ________lambda44__wnck_window_state_changed (WnckWindow* _sender,
                                                  WnckWindowState changed_mask,
                                                  WnckWindowState new_state,
                                                  gpointer self);
static void icon_button_real_get_preferred_width (GtkWidget* base,
                                           gint* min,
                                           gint* nat);
static void icon_button_real_get_preferred_height (GtkWidget* base,
                                            gint* min,
                                            gint* nat);
static gboolean icon_button_real_button_press_event (GtkWidget* base,
                                              GdkEventButton* event);
static void icon_button_handle_launch_clicks (IconButton* self,
                                       GdkEventButton* event,
                                       gboolean was_double_click);
static gboolean icon_button_real_button_release_event (GtkWidget* base,
                                                GdkEventButton* event);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static GdkEventButton* _vala_GdkEventButton_copy (GdkEventButton* self);
static void _vala_GdkEventButton_free (GdkEventButton* self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void icon_button_toggle_window_minstate (IconButton* self,
                                         guint32 time,
                                         WnckWindow* win);
static void _____lambda45_ (Block7Data* _data7_,
                     WnckWindow* w);
static void ______lambda45__gfunc (gconstpointer data,
                            gpointer self);
static gboolean icon_button_real_scroll_event (GtkWidget* base,
                                        GdkEventScroll* event);
static void icon_button_finalize (GObject * obj);
static void _vala_icon_button_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_icon_button_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

VALA_EXTERN const GtkTargetEntry DESKTOP_HELPER_targets[3];

static inline gpointer
icon_button_get_instance_private (IconButton* self)
{
	return G_STRUCT_MEMBER_P (self, IconButton_private_offset);
}

/**
 * Bootstrap a button without window nor group, as it should be for pinned
 * buttons without any active apps.
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 59 "../src/applets/icon-tasklist/IconButton.vala"
	return self ? g_object_ref (self) : NULL;
#line 346 "IconButton.c"
}

IconButton*
icon_button_construct (GType object_type,
                       BudgieAbominationAbomination* ab,
                       BudgieAppSystem* appsys,
                       GSettings* c_settings,
                       DesktopHelper* helper,
                       BudgiePopoverManager* manager,
                       GDesktopAppInfo* info,
                       const gchar* button_id)
{
	IconButton * self = NULL;
	GSettings* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	gchar* _tmp2_;
#line 57 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 57 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (button_id != NULL, NULL);
#line 58 "../src/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) g_object_new (object_type, "abomination", ab, "app-system", appsys, "desktop-helper", helper, "popover-manager", manager, NULL);
#line 59 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _g_object_ref0 (c_settings);
#line 59 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->settings);
#line 59 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->settings = _tmp0_;
#line 60 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = _g_object_ref0 (info);
#line 60 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->app_info);
#line 60 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->app_info = _tmp1_;
#line 61 "../src/applets/icon-tasklist/IconButton.vala"
	self->pinned = TRUE;
#line 62 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->originally_pinned = TRUE;
#line 63 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = g_strdup (button_id);
#line 63 "../src/applets/icon-tasklist/IconButton.vala"
	_g_free0 (self->button_id);
#line 63 "../src/applets/icon-tasklist/IconButton.vala"
	self->button_id = _tmp2_;
#line 64 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_gobject_constructors_suck (self);
#line 65 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_create_popover (self);
#line 67 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_update_icon (self);
#line 69 "../src/applets/icon-tasklist/IconButton.vala"
	if (icon_button_has_valid_windows (self, NULL)) {
#line 399 "IconButton.c"
		GtkStyleContext* _tmp3_;
#line 70 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 70 "../src/applets/icon-tasklist/IconButton.vala"
		gtk_style_context_add_class (_tmp3_, "running");
#line 405 "IconButton.c"
	}
#line 57 "../src/applets/icon-tasklist/IconButton.vala"
	return self;
#line 409 "IconButton.c"
}

IconButton*
icon_button_new (BudgieAbominationAbomination* ab,
                 BudgieAppSystem* appsys,
                 GSettings* c_settings,
                 DesktopHelper* helper,
                 BudgiePopoverManager* manager,
                 GDesktopAppInfo* info,
                 const gchar* button_id)
{
#line 57 "../src/applets/icon-tasklist/IconButton.vala"
	return icon_button_construct (TYPE_ICON_BUTTON, ab, appsys, c_settings, helper, manager, info, button_id);
#line 423 "IconButton.c"
}

/**
 * Bootstrap our button to be ready to work with grouping DISABLED.
 */
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	return _data2_;
#line 436 "IconButton.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 446 "IconButton.c"
		IconButton* self;
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
		self = _data2_->self;
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (_data2_->app);
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (self);
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
		g_slice_free (Block2Data, _data2_);
#line 456 "IconButton.c"
	}
}

static void
__lambda35_ (Block2Data* _data2_)
{
	IconButton* self;
	WnckWindow* _tmp0_;
	WnckWindow* _tmp1_;
	gboolean _tmp2_;
#line 97 "../src/applets/icon-tasklist/IconButton.vala"
	self = _data2_->self;
#line 98 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = budgie_abomination_running_app_get_window (_data2_->app);
#line 98 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = _tmp0_;
#line 98 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = wnck_window_needs_attention (_tmp1_);
#line 98 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (_tmp1_);
#line 98 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp2_) {
#line 99 "../src/applets/icon-tasklist/IconButton.vala"
		icon_button_attention (self, TRUE);
#line 481 "IconButton.c"
	}
}

static void
___lambda35__wnck_window_state_changed (WnckWindow* _sender,
                                        WnckWindowState changed_mask,
                                        WnckWindowState new_state,
                                        gpointer self)
{
#line 97 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda35_ (self);
#line 493 "IconButton.c"
}

IconButton*
icon_button_construct_from_app (GType object_type,
                                BudgieAbominationAbomination* ab,
                                BudgieAppSystem* appsys,
                                GSettings* c_settings,
                                DesktopHelper* helper,
                                BudgiePopoverManager* manager,
                                BudgieAbominationRunningApp* app,
                                const gchar* button_id)
{
	IconButton * self = NULL;
	Block2Data* _data2_;
	BudgieAbominationRunningApp* _tmp0_;
	GSettings* _tmp1_;
	BudgieAbominationAbomination* _tmp2_;
	WnckWindow* _tmp3_;
	WnckWindow* _tmp4_;
	BudgieAbominationRunningApp* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
	BudgieAbominationRunningApp* _tmp8_;
	WnckWindow* _tmp17_;
	WnckWindow* _tmp18_;
	WnckWindow* _tmp19_;
	WnckWindow* _tmp20_;
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (button_id != NULL, NULL);
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	_data2_->_ref_count_ = 1;
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _g_object_ref0 (app);
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (_data2_->app);
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	_data2_->app = _tmp0_;
#line 78 "../src/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) g_object_new (object_type, "abomination", ab, "app-system", appsys, "desktop-helper", helper, "popover-manager", manager, NULL);
#line 78 "../src/applets/icon-tasklist/IconButton.vala"
	_data2_->self = g_object_ref (self);
#line 79 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = _g_object_ref0 (c_settings);
#line 79 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->settings);
#line 79 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->settings = _tmp1_;
#line 80 "../src/applets/icon-tasklist/IconButton.vala"
	self->pinned = FALSE;
#line 81 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->originally_pinned = FALSE;
#line 82 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = self->priv->_abomination;
#line 82 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = budgie_abomination_running_app_get_window (_data2_->app);
#line 82 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = _tmp3_;
#line 82 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp5_ = budgie_abomination_abomination_get_app_from_window_id (_tmp2_, wnck_window_get_xid (_tmp4_));
#line 82 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->first_app);
#line 82 "../src/applets/icon-tasklist/IconButton.vala"
	self->first_app = _tmp5_;
#line 82 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (_tmp4_);
#line 83 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp6_ = g_strdup (button_id);
#line 83 "../src/applets/icon-tasklist/IconButton.vala"
	_g_free0 (self->button_id);
#line 83 "../src/applets/icon-tasklist/IconButton.vala"
	self->button_id = _tmp6_;
#line 85 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp8_ = self->first_app;
#line 85 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp8_ != NULL) {
#line 573 "IconButton.c"
		BudgieAbominationRunningApp* _tmp9_;
		GDesktopAppInfo* _tmp10_;
		GDesktopAppInfo* _tmp11_;
#line 85 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = self->first_app;
#line 85 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = budgie_abomination_running_app_get_app_info (_tmp9_);
#line 85 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp11_ = _tmp10_;
#line 85 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = _tmp11_ != NULL;
#line 585 "IconButton.c"
	} else {
#line 85 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = FALSE;
#line 589 "IconButton.c"
	}
#line 85 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp7_) {
#line 593 "IconButton.c"
		BudgieAbominationRunningApp* _tmp12_;
		GDesktopAppInfo* _tmp13_;
		GDesktopAppInfo* _tmp14_;
		GDesktopAppInfo* _tmp15_;
#line 86 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp12_ = self->first_app;
#line 86 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp13_ = budgie_abomination_running_app_get_app_info (_tmp12_);
#line 86 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp14_ = _tmp13_;
#line 86 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp15_ = _g_object_ref0 (_tmp14_);
#line 86 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (self->priv->app_info);
#line 86 "../src/applets/icon-tasklist/IconButton.vala"
		self->priv->app_info = _tmp15_;
#line 610 "IconButton.c"
	}
#line 89 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_gobject_constructors_suck (self);
#line 90 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_update_icon (self);
#line 91 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_create_popover (self);
#line 93 "../src/applets/icon-tasklist/IconButton.vala"
	if (icon_button_has_valid_windows (self, NULL)) {
#line 620 "IconButton.c"
		GtkStyleContext* _tmp16_;
#line 94 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 94 "../src/applets/icon-tasklist/IconButton.vala"
		gtk_style_context_add_class (_tmp16_, "running");
#line 626 "IconButton.c"
	}
#line 97 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp17_ = budgie_abomination_running_app_get_window (_data2_->app);
#line 97 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp18_ = _tmp17_;
#line 97 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_data (_tmp18_, "state-changed", (GCallback) ___lambda35__wnck_window_state_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, G_CONNECT_AFTER);
#line 97 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (_tmp18_);
#line 103 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp19_ = budgie_abomination_running_app_get_window (_data2_->app);
#line 103 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp20_ = _tmp19_;
#line 103 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_set_wnck_window (self, _tmp20_);
#line 103 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (_tmp20_);
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	block2_data_unref (_data2_);
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	_data2_ = NULL;
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	return self;
#line 650 "IconButton.c"
}

IconButton*
icon_button_new_from_app (BudgieAbominationAbomination* ab,
                          BudgieAppSystem* appsys,
                          GSettings* c_settings,
                          DesktopHelper* helper,
                          BudgiePopoverManager* manager,
                          BudgieAbominationRunningApp* app,
                          const gchar* button_id)
{
#line 77 "../src/applets/icon-tasklist/IconButton.vala"
	return icon_button_construct_from_app (TYPE_ICON_BUTTON, ab, appsys, c_settings, helper, manager, app, button_id);
#line 664 "IconButton.c"
}

/**
 * Bootstrap our button to be ready to work with grouping ENABLED.
 */
IconButton*
icon_button_construct_from_group (GType object_type,
                                  BudgieAbominationAbomination* ab,
                                  BudgieAppSystem* appsys,
                                  GSettings* c_settings,
                                  DesktopHelper* helper,
                                  BudgiePopoverManager* manager,
                                  BudgieAbominationAppGroup* group,
                                  const gchar* button_id)
{
	IconButton * self = NULL;
	GSettings* _tmp0_;
	BudgieAbominationAbomination* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	BudgieAbominationRunningApp* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	BudgieAbominationRunningApp* _tmp7_;
#line 109 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 109 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (button_id != NULL, NULL);
#line 110 "../src/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) g_object_new (object_type, "abomination", ab, "app-system", appsys, "desktop-helper", helper, "popover-manager", manager, NULL);
#line 111 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _g_object_ref0 (c_settings);
#line 111 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->settings);
#line 111 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->settings = _tmp0_;
#line 112 "../src/applets/icon-tasklist/IconButton.vala"
	self->pinned = FALSE;
#line 113 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->originally_pinned = FALSE;
#line 114 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->_abomination;
#line 114 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = budgie_abomination_app_group_get_name (group);
#line 114 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = _tmp2_;
#line 114 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = budgie_abomination_abomination_get_first_app_of_group (_tmp1_, _tmp3_);
#line 114 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->first_app);
#line 114 "../src/applets/icon-tasklist/IconButton.vala"
	self->first_app = _tmp4_;
#line 114 "../src/applets/icon-tasklist/IconButton.vala"
	_g_free0 (_tmp3_);
#line 115 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp5_ = g_strdup (button_id);
#line 115 "../src/applets/icon-tasklist/IconButton.vala"
	_g_free0 (self->button_id);
#line 115 "../src/applets/icon-tasklist/IconButton.vala"
	self->button_id = _tmp5_;
#line 117 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp7_ = self->first_app;
#line 117 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp7_ != NULL) {
#line 729 "IconButton.c"
		BudgieAbominationRunningApp* _tmp8_;
		GDesktopAppInfo* _tmp9_;
		GDesktopAppInfo* _tmp10_;
#line 117 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = self->first_app;
#line 117 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = budgie_abomination_running_app_get_app_info (_tmp8_);
#line 117 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = _tmp9_;
#line 117 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = _tmp10_ != NULL;
#line 741 "IconButton.c"
	} else {
#line 117 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = FALSE;
#line 745 "IconButton.c"
	}
#line 117 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp6_) {
#line 749 "IconButton.c"
		BudgieAbominationRunningApp* _tmp11_;
		GDesktopAppInfo* _tmp12_;
		GDesktopAppInfo* _tmp13_;
		GDesktopAppInfo* _tmp14_;
#line 118 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp11_ = self->first_app;
#line 118 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp12_ = budgie_abomination_running_app_get_app_info (_tmp11_);
#line 118 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp13_ = _tmp12_;
#line 118 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp14_ = _g_object_ref0 (_tmp13_);
#line 118 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (self->priv->app_info);
#line 118 "../src/applets/icon-tasklist/IconButton.vala"
		self->priv->app_info = _tmp14_;
#line 766 "IconButton.c"
	}
#line 121 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_gobject_constructors_suck (self);
#line 122 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_update_icon (self);
#line 123 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_create_popover (self);
#line 125 "../src/applets/icon-tasklist/IconButton.vala"
	if (icon_button_has_valid_windows (self, NULL)) {
#line 776 "IconButton.c"
		GtkStyleContext* _tmp15_;
#line 126 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 126 "../src/applets/icon-tasklist/IconButton.vala"
		gtk_style_context_add_class (_tmp15_, "running");
#line 782 "IconButton.c"
	}
#line 109 "../src/applets/icon-tasklist/IconButton.vala"
	return self;
#line 786 "IconButton.c"
}

IconButton*
icon_button_new_from_group (BudgieAbominationAbomination* ab,
                            BudgieAppSystem* appsys,
                            GSettings* c_settings,
                            DesktopHelper* helper,
                            BudgiePopoverManager* manager,
                            BudgieAbominationAppGroup* group,
                            const gchar* button_id)
{
#line 109 "../src/applets/icon-tasklist/IconButton.vala"
	return icon_button_construct_from_group (TYPE_ICON_BUTTON, ab, appsys, c_settings, helper, manager, group, button_id);
#line 800 "IconButton.c"
}

/**
 * We have race conditions in glib between the desired properties..
 */
static gboolean
__lambda19_ (IconButton* self)
{
	gboolean result;
#line 139 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_set_tooltip (self);
#line 140 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 141 "../src/applets/icon-tasklist/IconButton.vala"
	result = FALSE;
#line 141 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 818 "IconButton.c"
}

static gboolean
___lambda19__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                            GdkEventCrossing* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda19_ ((IconButton*) self);
#line 138 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 830 "IconButton.c"
}

static gboolean
__lambda20_ (IconButton* self)
{
	gboolean result;
#line 145 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) self, "");
#line 146 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_widget_set_has_tooltip ((GtkWidget*) self, FALSE);
#line 147 "../src/applets/icon-tasklist/IconButton.vala"
	result = FALSE;
#line 147 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 845 "IconButton.c"
}

static gboolean
___lambda20__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                            GdkEventCrossing* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda20_ ((IconButton*) self);
#line 144 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 857 "IconButton.c"
}

static void
__lambda21_ (IconButton* self,
             GdkDragContext* context)
{
	Icon* _tmp0_;
#line 157 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (context != NULL);
#line 158 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->icon;
#line 158 "../src/applets/icon-tasklist/IconButton.vala"
	switch (gtk_image_get_storage_type ((GtkImage*) _tmp0_)) {
#line 158 "../src/applets/icon-tasklist/IconButton.vala"
		case GTK_IMAGE_PIXBUF:
#line 873 "IconButton.c"
		{
			Icon* _tmp1_;
			GdkPixbuf* _tmp2_;
			Icon* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			Icon* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
#line 160 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp1_ = self->icon;
#line 160 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp2_ = gtk_image_get_pixbuf ((GtkImage*) _tmp1_);
#line 160 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp3_ = self->icon;
#line 160 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp4_ = gtk_image_get_pixel_size ((GtkImage*) _tmp3_);
#line 160 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp5_ = _tmp4_;
#line 160 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp6_ = self->icon;
#line 160 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp7_ = gtk_image_get_pixel_size ((GtkImage*) _tmp6_);
#line 160 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp8_ = _tmp7_;
#line 160 "../src/applets/icon-tasklist/IconButton.vala"
			gtk_drag_set_icon_pixbuf (context, _tmp2_, _tmp5_ / 2, _tmp8_ / 2);
#line 161 "../src/applets/icon-tasklist/IconButton.vala"
			break;
#line 903 "IconButton.c"
		}
#line 158 "../src/applets/icon-tasklist/IconButton.vala"
		case GTK_IMAGE_ICON_NAME:
#line 907 "IconButton.c"
		{
			const gchar* icon_name = NULL;
			Icon* _tmp9_;
			const gchar* _tmp10_ = NULL;
			const gchar* _tmp11_;
			Icon* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			Icon* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
#line 163 "../src/applets/icon-tasklist/IconButton.vala"
			icon_name = NULL;
#line 164 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp9_ = self->icon;
#line 164 "../src/applets/icon-tasklist/IconButton.vala"
			gtk_image_get_icon_name ((GtkImage*) _tmp9_, &_tmp10_, (GtkIconSize*) NULL);
#line 164 "../src/applets/icon-tasklist/IconButton.vala"
			icon_name = _tmp10_;
#line 165 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp11_ = icon_name;
#line 165 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp12_ = self->icon;
#line 165 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp13_ = gtk_image_get_pixel_size ((GtkImage*) _tmp12_);
#line 165 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp14_ = _tmp13_;
#line 165 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp15_ = self->icon;
#line 165 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp16_ = gtk_image_get_pixel_size ((GtkImage*) _tmp15_);
#line 165 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp17_ = _tmp16_;
#line 165 "../src/applets/icon-tasklist/IconButton.vala"
			gtk_drag_set_icon_name (context, _tmp11_, _tmp14_ / 2, _tmp17_ / 2);
#line 166 "../src/applets/icon-tasklist/IconButton.vala"
			break;
#line 945 "IconButton.c"
		}
#line 158 "../src/applets/icon-tasklist/IconButton.vala"
		case GTK_IMAGE_GICON:
#line 949 "IconButton.c"
		{
			GIcon* gicon = NULL;
			Icon* _tmp18_;
			GIcon* _tmp19_ = NULL;
			GIcon* _tmp20_;
			Icon* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			Icon* _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
#line 168 "../src/applets/icon-tasklist/IconButton.vala"
			gicon = NULL;
#line 169 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp18_ = self->icon;
#line 169 "../src/applets/icon-tasklist/IconButton.vala"
			gtk_image_get_gicon ((GtkImage*) _tmp18_, &_tmp19_, (GtkIconSize*) NULL);
#line 169 "../src/applets/icon-tasklist/IconButton.vala"
			gicon = _tmp19_;
#line 170 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp20_ = gicon;
#line 170 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp21_ = self->icon;
#line 170 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp22_ = gtk_image_get_pixel_size ((GtkImage*) _tmp21_);
#line 170 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp23_ = _tmp22_;
#line 170 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp24_ = self->icon;
#line 170 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp25_ = gtk_image_get_pixel_size ((GtkImage*) _tmp24_);
#line 170 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp26_ = _tmp25_;
#line 170 "../src/applets/icon-tasklist/IconButton.vala"
			gtk_drag_set_icon_gicon (context, _tmp20_, _tmp23_ / 2, _tmp26_ / 2);
#line 171 "../src/applets/icon-tasklist/IconButton.vala"
			break;
#line 987 "IconButton.c"
		}
		default:
		{
#line 174 "../src/applets/icon-tasklist/IconButton.vala"
			gtk_drag_set_icon_default (context);
#line 175 "../src/applets/icon-tasklist/IconButton.vala"
			break;
#line 995 "IconButton.c"
		}
	}
}

static void
___lambda21__gtk_widget_drag_begin (GtkWidget* _sender,
                                    GdkDragContext* context,
                                    gpointer self)
{
#line 157 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda21_ ((IconButton*) self, context);
#line 1007 "IconButton.c"
}

static gchar*
string_to_utf8 (const gchar* self,
                gint* result_length1)
{
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* result;
#line 1570 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1571 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1571 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1571 "glib-2.0.vapi"
	string_length = _tmp1_;
#line 1572 "glib-2.0.vapi"
	_tmp2_ = g_new0 (gchar, string_length + 1);
#line 1572 "glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1572 "glib-2.0.vapi"
	_result__length1 = string_length + 1;
#line 1572 "glib-2.0.vapi"
	__result__size_ = _result__length1;
#line 1573 "glib-2.0.vapi"
	_tmp3_ = _result__length1;
#line 1573 "glib-2.0.vapi"
	_result__length1 = _tmp3_ - 1;
#line 1574 "glib-2.0.vapi"
	memcpy (_result_, self, (gsize) string_length);
#line 1575 "glib-2.0.vapi"
	_tmp4_ = _result_;
#line 1575 "glib-2.0.vapi"
	_tmp4__length1 = _result__length1;
#line 1575 "glib-2.0.vapi"
	if (result_length1) {
#line 1575 "glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 1055 "IconButton.c"
	}
#line 1575 "glib-2.0.vapi"
	result = _tmp4_;
#line 1575 "glib-2.0.vapi"
	return result;
#line 1061 "IconButton.c"
}

static void
__lambda22_ (IconButton* self,
             GtkWidget* widget,
             GdkDragContext* context,
             GtkSelectionData* selection_data,
             guint info,
             guint time)
{
	const gchar* _tmp0_;
	gint _tmp1_ = 0;
	gchar* _tmp2_;
	guchar* _tmp3_;
	gint _tmp3__length1;
#line 179 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (widget != NULL);
#line 179 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (context != NULL);
#line 179 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (selection_data != NULL);
#line 180 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->button_id;
#line 180 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = string_to_utf8 (_tmp0_, &_tmp1_);
#line 180 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = (guchar*) _tmp2_;
#line 180 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3__length1 = (_tmp1_ * sizeof (gchar)) / sizeof (guchar);
#line 180 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_selection_data_set (selection_data, gtk_selection_data_get_target (selection_data), 8, _tmp3_, (gint) ((_tmp1_ * sizeof (gchar)) / sizeof (guchar)));
#line 180 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = (g_free (_tmp3_), NULL);
#line 1095 "IconButton.c"
}

static void
___lambda22__gtk_widget_drag_data_get (GtkWidget* _sender,
                                       GdkDragContext* context,
                                       GtkSelectionData* selection_data,
                                       guint info,
                                       guint time_,
                                       gpointer self)
{
#line 179 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda22_ ((IconButton*) self, _sender, context, selection_data, info, time_);
#line 1108 "IconButton.c"
}

static void
_icon_button_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                        GtkAllocation* allocation,
                                                        gpointer self)
{
#line 189 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_on_size_allocate ((IconButton*) self, allocation);
#line 1118 "IconButton.c"
}

static void
_icon_button_on_launched_g_app_launch_context_launched (GAppLaunchContext* _sender,
                                                        GAppInfo* info,
                                                        GVariant* platform_data,
                                                        gpointer self)
{
#line 190 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_on_launched ((IconButton*) self, info, platform_data);
#line 1129 "IconButton.c"
}

static void
_icon_button_on_launch_failed_g_app_launch_context_launch_failed (GAppLaunchContext* _sender,
                                                                  const gchar* startup_notify_id,
                                                                  gpointer self)
{
#line 191 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_on_launch_failed ((IconButton*) self, startup_notify_id);
#line 1139 "IconButton.c"
}

static void
___lambda23_ (IconButton* self)
{
#line 195 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_set_tooltip (self);
#line 1147 "IconButton.c"
}

static void
____lambda23__budgie_abomination_running_app_renamed_app (BudgieAbominationRunningApp* _sender,
                                                          const gchar* old_name,
                                                          const gchar* new_name,
                                                          gpointer self)
{
#line 194 "../src/applets/icon-tasklist/IconButton.vala"
	___lambda23_ ((IconButton*) self);
#line 1158 "IconButton.c"
}

static void
___lambda24_ (IconButton* self,
              GDesktopAppInfo* app_info)
{
	GDesktopAppInfo* _tmp0_;
#line 199 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _g_object_ref0 (app_info);
#line 199 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->app_info);
#line 199 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->app_info = _tmp0_;
#line 1172 "IconButton.c"
}

static void
____lambda24__budgie_abomination_running_app_app_info_changed (BudgieAbominationRunningApp* _sender,
                                                               GDesktopAppInfo* app_info,
                                                               gpointer self)
{
#line 198 "../src/applets/icon-tasklist/IconButton.vala"
	___lambda24_ ((IconButton*) self, app_info);
#line 1182 "IconButton.c"
}

static void
___lambda25_ (IconButton* self)
{
#line 203 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_update_icon (self);
#line 1190 "IconButton.c"
}

static void
____lambda25__budgie_abomination_running_app_icon_changed (BudgieAbominationRunningApp* _sender,
                                                           const gchar* icon_name,
                                                           gpointer self)
{
#line 202 "../src/applets/icon-tasklist/IconButton.vala"
	___lambda25_ ((IconButton*) self);
#line 1200 "IconButton.c"
}

static void
icon_button_gobject_constructors_suck (IconButton* self)
{
	Icon* _tmp0_;
	Icon* _tmp1_;
	GtkStyleContext* _tmp2_;
	Icon* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkAppLaunchContext* _tmp5_;
	DesktopHelper* _tmp6_;
	GtkStyleContext* st = NULL;
	GtkStyleContext* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkStyleContext* _tmp11_;
	GdkAppLaunchContext* _tmp12_;
	GdkAppLaunchContext* _tmp13_;
	BudgieAbominationRunningApp* _tmp14_;
#line 133 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = icon_new ();
#line 134 "../src/applets/icon-tasklist/IconButton.vala"
	g_object_ref_sink (_tmp0_);
#line 134 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->icon);
#line 134 "../src/applets/icon-tasklist/IconButton.vala"
	self->icon = _tmp0_;
#line 135 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->icon;
#line 135 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 135 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_style_context_add_class (_tmp2_, "icon");
#line 136 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->icon;
#line 136 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp3_);
#line 138 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GtkWidget*) self, "enter-notify-event", (GCallback) ___lambda19__gtk_widget_enter_notify_event, self, 0);
#line 144 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GtkWidget*) self, "leave-notify-event", (GCallback) ___lambda20__gtk_widget_leave_notify_event, self, 0);
#line 150 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->definite_allocation.width = 0;
#line 151 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->definite_allocation.height = 0;
#line 153 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = gtk_widget_get_display ((GtkWidget*) self);
#line 153 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp5_ = gdk_display_get_app_launch_context (_tmp4_);
#line 153 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->launch_context);
#line 153 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->launch_context = _tmp5_;
#line 154 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) GDK_SCROLL_MASK);
#line 155 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp6_ = self->priv->_desktop_helper;
#line 155 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_set_draggable (self, !_tmp6_->lock_icons);
#line 157 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-begin", (GCallback) ___lambda21__gtk_widget_drag_begin, self, 0);
#line 179 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-data-get", (GCallback) ___lambda22__gtk_widget_drag_data_get, self, 0);
#line 183 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 183 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 183 "../src/applets/icon-tasklist/IconButton.vala"
	st = _tmp8_;
#line 184 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp9_ = st;
#line 184 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_style_context_remove_class (_tmp9_, GTK_STYLE_CLASS_BUTTON);
#line 185 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp10_ = st;
#line 185 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_style_context_remove_class (_tmp10_, "toggle");
#line 186 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp11_ = st;
#line 186 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_style_context_add_class (_tmp11_, "launcher");
#line 187 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_button_set_relief ((GtkButton*) self, GTK_RELIEF_NONE);
#line 189 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) _icon_button_on_size_allocate_gtk_widget_size_allocate, self, 0);
#line 190 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp12_ = self->priv->launch_context;
#line 190 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GAppLaunchContext*) _tmp12_, "launched", (GCallback) _icon_button_on_launched_g_app_launch_context_launched, self, 0);
#line 191 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp13_ = self->priv->launch_context;
#line 191 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object ((GAppLaunchContext*) _tmp13_, "launch-failed", (GCallback) _icon_button_on_launch_failed_g_app_launch_context_launch_failed, self, 0);
#line 193 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp14_ = self->first_app;
#line 193 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp14_ != NULL) {
#line 1302 "IconButton.c"
		BudgieAbominationRunningApp* _tmp15_;
		BudgieAbominationRunningApp* _tmp16_;
		BudgieAbominationRunningApp* _tmp17_;
#line 194 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp15_ = self->first_app;
#line 194 "../src/applets/icon-tasklist/IconButton.vala"
		g_signal_connect_object (_tmp15_, "renamed-app", (GCallback) ____lambda23__budgie_abomination_running_app_renamed_app, self, 0);
#line 198 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp16_ = self->first_app;
#line 198 "../src/applets/icon-tasklist/IconButton.vala"
		g_signal_connect_object (_tmp16_, "app-info-changed", (GCallback) ____lambda24__budgie_abomination_running_app_app_info_changed, self, 0);
#line 202 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp17_ = self->first_app;
#line 202 "../src/applets/icon-tasklist/IconButton.vala"
		g_signal_connect_object (_tmp17_, "icon-changed", (GCallback) ____lambda25__budgie_abomination_running_app_icon_changed, self, 0);
#line 1318 "IconButton.c"
	}
#line 133 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (st);
#line 1322 "IconButton.c"
}

/**
 * create_popover will create our popover
 */
static void
__lambda26_ (IconButton* self)
{
#line 217 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_launch_app (self, gtk_get_current_event_time ());
#line 1333 "IconButton.c"
}

static void
___lambda26__budgie_icon_popover_launch_new_instance (BudgieIconPopover* _sender,
                                                      gpointer self)
{
#line 216 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda26_ ((IconButton*) self);
#line 1342 "IconButton.c"
}

static void
__lambda27_ (IconButton* self)
{
	gint _tmp0_;
#line 221 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->window_count;
#line 221 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->window_count = _tmp0_ + 1;
#line 1353 "IconButton.c"
}

static void
___lambda27__budgie_icon_popover_added_window (BudgieIconPopover* _sender,
                                               gpointer self)
{
#line 220 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda27_ ((IconButton*) self);
#line 1362 "IconButton.c"
}

static void
__lambda28_ (IconButton* self)
{
	BudgieIconPopover* _tmp0_;
#line 225 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->window_count = 0;
#line 226 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->popover;
#line 226 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 227 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_emit (self, icon_button_signals[ICON_BUTTON_BECAME_EMPTY_SIGNAL], 0);
#line 1377 "IconButton.c"
}

static void
___lambda28__budgie_icon_popover_closed_all (BudgieIconPopover* _sender,
                                             gpointer self)
{
#line 224 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda28_ ((IconButton*) self);
#line 1386 "IconButton.c"
}

static void
__lambda29_ (IconButton* self)
{
	gint _tmp0_;
#line 231 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->window_count;
#line 231 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->window_count = _tmp0_ - 1;
#line 1397 "IconButton.c"
}

static void
___lambda29__budgie_icon_popover_closed_window (BudgieIconPopover* _sender,
                                                gpointer self)
{
#line 230 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda29_ ((IconButton*) self);
#line 1406 "IconButton.c"
}

static void
__lambda30_ (IconButton* self,
             gboolean new_pinned_state)
{
	DesktopHelper* _tmp0_;
#line 235 "../src/applets/icon-tasklist/IconButton.vala"
	self->pinned = new_pinned_state;
#line 236 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_desktop_helper;
#line 236 "../src/applets/icon-tasklist/IconButton.vala"
	desktop_helper_update_pinned (_tmp0_);
#line 237 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_emit (self, icon_button_signals[ICON_BUTTON_PINNED_CHANGED_SIGNAL], 0);
#line 239 "../src/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_has_valid_windows (self, NULL)) {
#line 240 "../src/applets/icon-tasklist/IconButton.vala"
		g_signal_emit (self, icon_button_signals[ICON_BUTTON_BECAME_EMPTY_SIGNAL], 0);
#line 1426 "IconButton.c"
	}
}

static void
___lambda30__budgie_icon_popover_changed_pin_state (BudgieIconPopover* _sender,
                                                    gboolean new_state,
                                                    gpointer self)
{
#line 234 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda30_ ((IconButton*) self, new_state);
#line 1437 "IconButton.c"
}

static void
__lambda31_ (IconButton* self,
             gulong xid,
             gint wid)
{
	WnckWindow* requested_window = NULL;
	WnckWindow* _tmp0_;
	WnckWindow* _tmp1_;
	WnckWorkspace* workspace = NULL;
	WnckScreen* _tmp2_;
	WnckWorkspace* _tmp3_;
	WnckWorkspace* _tmp4_;
	gboolean _tmp5_ = FALSE;
	WnckWindow* _tmp6_;
#line 245 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = wnck_window_get (xid);
#line 245 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 245 "../src/applets/icon-tasklist/IconButton.vala"
	requested_window = _tmp1_;
#line 246 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = self->priv->screen;
#line 246 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = wnck_screen_get_workspace (_tmp2_, wid - 1);
#line 246 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 246 "../src/applets/icon-tasklist/IconButton.vala"
	workspace = _tmp4_;
#line 248 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp6_ = requested_window;
#line 248 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp6_ != NULL) {
#line 1472 "IconButton.c"
		WnckWorkspace* _tmp7_;
#line 248 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = workspace;
#line 248 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = _tmp7_ != NULL;
#line 1478 "IconButton.c"
	} else {
#line 248 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = FALSE;
#line 1482 "IconButton.c"
	}
#line 248 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp5_) {
#line 1486 "IconButton.c"
		WnckWindow* _tmp8_;
		WnckWorkspace* _tmp9_;
#line 249 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = requested_window;
#line 249 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = workspace;
#line 249 "../src/applets/icon-tasklist/IconButton.vala"
		wnck_window_move_to_workspace (_tmp8_, _tmp9_);
#line 1495 "IconButton.c"
	}
#line 244 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (workspace);
#line 244 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (requested_window);
#line 1501 "IconButton.c"
}

static void
___lambda31__budgie_icon_popover_move_window_to_workspace (BudgieIconPopover* _sender,
                                                           gulong xid,
                                                           gint workspace_num,
                                                           gpointer self)
{
#line 244 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda31_ ((IconButton*) self, xid, workspace_num);
#line 1512 "IconButton.c"
}

static void
__lambda32_ (IconButton* self,
             const gchar* action)
{
	GDesktopAppInfo* _tmp0_;
#line 253 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (action != NULL);
#line 254 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->app_info;
#line 254 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ != NULL) {
#line 1526 "IconButton.c"
		GdkAppLaunchContext* _tmp1_;
		GdkScreen* _tmp2_;
		GdkAppLaunchContext* _tmp3_;
		GDesktopAppInfo* _tmp4_;
		GdkAppLaunchContext* _tmp5_;
		BudgieIconPopover* _tmp6_;
#line 255 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->launch_context;
#line 255 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 255 "../src/applets/icon-tasklist/IconButton.vala"
		gdk_app_launch_context_set_screen (_tmp1_, _tmp2_);
#line 256 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = self->priv->launch_context;
#line 256 "../src/applets/icon-tasklist/IconButton.vala"
		gdk_app_launch_context_set_timestamp (_tmp3_, (guint32) GDK_CURRENT_TIME);
#line 257 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = self->priv->app_info;
#line 257 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = self->priv->launch_context;
#line 257 "../src/applets/icon-tasklist/IconButton.vala"
		g_desktop_app_info_launch_action (_tmp4_, action, (GAppLaunchContext*) _tmp5_);
#line 258 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = self->priv->popover;
#line 258 "../src/applets/icon-tasklist/IconButton.vala"
		budgie_icon_popover_render (_tmp6_);
#line 1553 "IconButton.c"
	}
}

static void
___lambda32__budgie_icon_popover_perform_action (BudgieIconPopover* _sender,
                                                 const gchar* action,
                                                 gpointer self)
{
#line 253 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda32_ ((IconButton*) self, action);
#line 1564 "IconButton.c"
}

static void
__lambda33_ (IconButton* self,
             WnckWorkspace* workspace)
{
	BudgieIconPopover* _tmp0_;
	WnckScreen* _tmp1_;
#line 266 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (workspace != NULL);
#line 267 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->popover;
#line 267 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->screen;
#line 267 "../src/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_set_workspace_count (_tmp0_, wnck_screen_get_workspace_count (_tmp1_));
#line 1581 "IconButton.c"
}

static void
___lambda33__wnck_screen_workspace_created (WnckScreen* _sender,
                                            WnckWorkspace* space,
                                            gpointer self)
{
#line 266 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda33_ ((IconButton*) self, space);
#line 1591 "IconButton.c"
}

static void
__lambda34_ (IconButton* self,
             WnckWorkspace* workspace)
{
	BudgieIconPopover* _tmp0_;
	WnckScreen* _tmp1_;
#line 270 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (workspace != NULL);
#line 271 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->popover;
#line 271 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->screen;
#line 271 "../src/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_set_workspace_count (_tmp0_, wnck_screen_get_workspace_count (_tmp1_));
#line 1608 "IconButton.c"
}

static void
___lambda34__wnck_screen_workspace_destroyed (WnckScreen* _sender,
                                              WnckWorkspace* space,
                                              gpointer self)
{
#line 270 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda34_ ((IconButton*) self, space);
#line 1618 "IconButton.c"
}

void
icon_button_create_popover (IconButton* self)
{
	WnckScreen* _tmp0_;
	WnckScreen* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	WnckScreen* _tmp3_;
	BudgieIconPopover* _tmp4_;
	BudgieIconPopover* _tmp5_;
	BudgieIconPopover* _tmp6_;
	BudgieIconPopover* _tmp7_;
	BudgieIconPopover* _tmp8_;
	BudgieIconPopover* _tmp9_;
	BudgieIconPopover* _tmp10_;
	BudgieIconPopover* _tmp11_;
	BudgieIconPopover* _tmp12_;
	WnckScreen* _tmp13_;
	WnckScreen* _tmp14_;
	BudgiePopoverManager* _tmp15_;
	BudgieIconPopover* _tmp16_;
#line 211 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = wnck_screen_get_default ();
#line 212 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 212 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->screen);
#line 212 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->screen = _tmp1_;
#line 213 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = self->priv->app_info;
#line 213 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->priv->screen;
#line 213 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = budgie_icon_popover_new ((GtkWidget*) self, _tmp2_, wnck_screen_get_workspace_count (_tmp3_));
#line 213 "../src/applets/icon-tasklist/IconButton.vala"
	g_object_ref_sink (_tmp4_);
#line 213 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->popover);
#line 213 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->popover = _tmp4_;
#line 214 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp5_ = self->priv->popover;
#line 214 "../src/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_set_pinned_state (_tmp5_, self->pinned);
#line 216 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp6_ = self->priv->popover;
#line 216 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp6_, "launch-new-instance", (GCallback) ___lambda26__budgie_icon_popover_launch_new_instance, self, 0);
#line 220 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp7_ = self->priv->popover;
#line 220 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp7_, "added-window", (GCallback) ___lambda27__budgie_icon_popover_added_window, self, 0);
#line 224 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp8_ = self->priv->popover;
#line 224 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp8_, "closed-all", (GCallback) ___lambda28__budgie_icon_popover_closed_all, self, 0);
#line 230 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp9_ = self->priv->popover;
#line 230 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp9_, "closed-window", (GCallback) ___lambda29__budgie_icon_popover_closed_window, self, 0);
#line 234 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp10_ = self->priv->popover;
#line 234 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp10_, "changed-pin-state", (GCallback) ___lambda30__budgie_icon_popover_changed_pin_state, self, 0);
#line 244 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp11_ = self->priv->popover;
#line 244 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp11_, "move-window-to-workspace", (GCallback) ___lambda31__budgie_icon_popover_move_window_to_workspace, self, 0);
#line 253 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp12_ = self->priv->popover;
#line 253 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp12_, "perform-action", (GCallback) ___lambda32__budgie_icon_popover_perform_action, self, 0);
#line 266 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp13_ = self->priv->screen;
#line 266 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp13_, "workspace-created", (GCallback) ___lambda33__wnck_screen_workspace_created, self, 0);
#line 270 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp14_ = self->priv->screen;
#line 270 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp14_, "workspace-destroyed", (GCallback) ___lambda34__wnck_screen_workspace_destroyed, self, 0);
#line 274 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp15_ = self->priv->_popover_manager;
#line 274 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp16_ = self->priv->popover;
#line 274 "../src/applets/icon-tasklist/IconButton.vala"
	budgie_popover_manager_register_popover (_tmp15_, (GtkWidget*) self, (BudgiePopover*) _tmp16_);
#line 1709 "IconButton.c"
}

static void
__lambda38_ (IconButton* self)
{
#line 289 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_update_icon (self);
#line 1717 "IconButton.c"
}

static void
___lambda38__budgie_abomination_app_group_icon_changed (BudgieAbominationAppGroup* _sender,
                                                        gpointer self)
{
#line 288 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda38_ ((IconButton*) self);
#line 1726 "IconButton.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
	return _data3_;
#line 1736 "IconButton.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1746 "IconButton.c"
		IconButton* self;
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
		self = _data3_->self;
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (self);
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
		g_slice_free (Block3Data, _data3_);
#line 1754 "IconButton.c"
	}
}

static void
__lambda40_ (Block3Data* _data3_)
{
	IconButton* self;
	BudgieIconPopover* _tmp0_;
#line 301 "../src/applets/icon-tasklist/IconButton.vala"
	self = _data3_->self;
#line 302 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->popover;
#line 302 "../src/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_rename_window (_tmp0_, _data3_->xid);
#line 1769 "IconButton.c"
}

static void
___lambda40__wnck_window_name_changed (WnckWindow* _sender,
                                       gpointer self)
{
#line 301 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda40_ (self);
#line 1778 "IconButton.c"
}

static void
__lambda39_ (IconButton* self,
             WnckWindow* new_window)
{
	Block3Data* _data3_;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* name = NULL;
	gchar* _tmp2_;
	BudgieIconPopover* _tmp3_;
	const gchar* _tmp4_;
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (new_window != NULL);
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
	_data3_->_ref_count_ = 1;
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
	_data3_->self = g_object_ref (self);
#line 293 "../src/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_should_add_window (self, new_window)) {
#line 294 "../src/applets/icon-tasklist/IconButton.vala"
		block3_data_unref (_data3_);
#line 294 "../src/applets/icon-tasklist/IconButton.vala"
		_data3_ = NULL;
#line 294 "../src/applets/icon-tasklist/IconButton.vala"
		return;
#line 1808 "IconButton.c"
	}
#line 297 "../src/applets/icon-tasklist/IconButton.vala"
	_data3_->xid = wnck_window_get_xid (new_window);
#line 298 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = wnck_window_get_name (new_window);
#line 298 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _tmp1_;
#line 298 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ == NULL) {
#line 298 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = "Loading...";
#line 1820 "IconButton.c"
	}
#line 298 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 298 "../src/applets/icon-tasklist/IconButton.vala"
	name = _tmp2_;
#line 300 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->priv->popover;
#line 300 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = name;
#line 300 "../src/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_add_window (_tmp3_, _data3_->xid, _tmp4_);
#line 301 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_data (new_window, "name-changed", (GCallback) ___lambda40__wnck_window_name_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 304 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_update (self);
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
	_g_free0 (name);
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
	block3_data_unref (_data3_);
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
	_data3_ = NULL;
#line 1842 "IconButton.c"
}

static void
___lambda39__budgie_abomination_app_group_added_window (BudgieAbominationAppGroup* _sender,
                                                        WnckWindow* window,
                                                        gpointer self)
{
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda39_ ((IconButton*) self, window);
#line 1852 "IconButton.c"
}

static void
__lambda41_ (IconButton* self,
             WnckWindow* old_window)
{
	BudgieIconPopover* _tmp0_;
#line 307 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (old_window != NULL);
#line 308 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->popover;
#line 308 "../src/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_remove_window (_tmp0_, wnck_window_get_xid (old_window));
#line 309 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_update (self);
#line 1868 "IconButton.c"
}

static void
___lambda41__budgie_abomination_app_group_removed_window (BudgieAbominationAppGroup* _sender,
                                                          WnckWindow* window,
                                                          gpointer self)
{
#line 307 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda41_ ((IconButton*) self, window);
#line 1878 "IconButton.c"
}

void
icon_button_set_class_group (IconButton* self,
                             BudgieAbominationAppGroup* class_group)
{
	BudgieAbominationAppGroup* _tmp0_;
	BudgieAbominationAppGroup* _tmp1_;
	WnckWindow* _tmp2_;
	BudgieAbominationAppGroup* _tmp3_;
	BudgieAbominationAppGroup* _tmp4_;
	BudgieAbominationAppGroup* _tmp5_;
#line 277 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _g_object_ref0 (class_group);
#line 278 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->class_group);
#line 278 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->class_group = _tmp0_;
#line 280 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->class_group;
#line 280 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp1_ == NULL) {
#line 281 "../src/applets/icon-tasklist/IconButton.vala"
		return;
#line 1905 "IconButton.c"
	}
#line 284 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = self->priv->window;
#line 284 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp2_ != NULL) {
#line 285 "../src/applets/icon-tasklist/IconButton.vala"
		g_warning ("IconButton.vala:285: Button have both a group and a window defined");
#line 1913 "IconButton.c"
	}
#line 288 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->priv->class_group;
#line 288 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp3_, "icon-changed", (GCallback) ___lambda38__budgie_abomination_app_group_icon_changed, self, G_CONNECT_AFTER);
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = self->priv->class_group;
#line 292 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp4_, "added-window", (GCallback) ___lambda39__budgie_abomination_app_group_added_window, self, 0);
#line 307 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp5_ = self->priv->class_group;
#line 307 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_object (_tmp5_, "removed-window", (GCallback) ___lambda41__budgie_abomination_app_group_removed_window, self, 0);
#line 312 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_set_app_for_class_group (self);
#line 313 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_setup_popover_with_class (self);
#line 1931 "IconButton.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
	return _data4_;
#line 1941 "IconButton.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1951 "IconButton.c"
		IconButton* self;
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
		self = _data4_->self;
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (_data4_->window);
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (self);
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
		g_slice_free (Block4Data, _data4_);
#line 1961 "IconButton.c"
	}
}

static void
__lambda36_ (Block4Data* _data4_)
{
	IconButton* self;
	BudgieIconPopover* _tmp0_;
#line 331 "../src/applets/icon-tasklist/IconButton.vala"
	self = _data4_->self;
#line 332 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->popover;
#line 332 "../src/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_rename_window (_tmp0_, wnck_window_get_xid (_data4_->window));
#line 1976 "IconButton.c"
}

static void
___lambda36__wnck_window_name_changed (WnckWindow* _sender,
                                       gpointer self)
{
#line 331 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda36_ (self);
#line 1985 "IconButton.c"
}

static void
__lambda37_ (Block4Data* _data4_)
{
	IconButton* self;
#line 335 "../src/applets/icon-tasklist/IconButton.vala"
	self = _data4_->self;
#line 336 "../src/applets/icon-tasklist/IconButton.vala"
	if (wnck_window_needs_attention (_data4_->window)) {
#line 337 "../src/applets/icon-tasklist/IconButton.vala"
		icon_button_attention (self, TRUE);
#line 1998 "IconButton.c"
	}
}

static void
___lambda37__wnck_window_state_changed (WnckWindow* _sender,
                                        WnckWindowState changed_mask,
                                        WnckWindowState new_state,
                                        gpointer self)
{
#line 335 "../src/applets/icon-tasklist/IconButton.vala"
	__lambda37_ (self);
#line 2010 "IconButton.c"
}

void
icon_button_set_wnck_window (IconButton* self,
                             WnckWindow* window)
{
	Block4Data* _data4_;
	WnckWindow* _tmp0_;
	gboolean _tmp1_ = FALSE;
	WnckWindow* _tmp5_;
	BudgieAbominationAbomination* _tmp6_;
	BudgieIconPopover* _tmp7_;
	const gchar* _tmp8_;
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
	_data4_->_ref_count_ = 1;
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
	_data4_->self = g_object_ref (self);
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _g_object_ref0 (window);
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (_data4_->window);
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
	_data4_->window = _tmp0_;
#line 317 "../src/applets/icon-tasklist/IconButton.vala"
	if (_data4_->window == NULL) {
#line 2040 "IconButton.c"
		WnckWindow* _tmp2_;
#line 317 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = self->priv->window;
#line 317 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = _tmp2_ != NULL;
#line 2046 "IconButton.c"
	} else {
#line 317 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = FALSE;
#line 2050 "IconButton.c"
	}
#line 317 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp1_) {
#line 2054 "IconButton.c"
		BudgieIconPopover* _tmp3_;
		WnckWindow* _tmp4_;
#line 318 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = self->priv->popover;
#line 318 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = self->priv->window;
#line 318 "../src/applets/icon-tasklist/IconButton.vala"
		budgie_icon_popover_remove_window (_tmp3_, wnck_window_get_xid (_tmp4_));
#line 2063 "IconButton.c"
	}
#line 321 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp5_ = _g_object_ref0 (_data4_->window);
#line 321 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->window);
#line 321 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->window = _tmp5_;
#line 323 "../src/applets/icon-tasklist/IconButton.vala"
	if (_data4_->window == NULL) {
#line 324 "../src/applets/icon-tasklist/IconButton.vala"
		block4_data_unref (_data4_);
#line 324 "../src/applets/icon-tasklist/IconButton.vala"
		_data4_ = NULL;
#line 324 "../src/applets/icon-tasklist/IconButton.vala"
		return;
#line 2079 "IconButton.c"
	}
#line 327 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp6_ = self->priv->_abomination;
#line 327 "../src/applets/icon-tasklist/IconButton.vala"
	if (budgie_abomination_abomination_is_disallowed_window_type (_tmp6_, _data4_->window)) {
#line 328 "../src/applets/icon-tasklist/IconButton.vala"
		block4_data_unref (_data4_);
#line 328 "../src/applets/icon-tasklist/IconButton.vala"
		_data4_ = NULL;
#line 328 "../src/applets/icon-tasklist/IconButton.vala"
		return;
#line 2091 "IconButton.c"
	}
#line 331 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_data (_data4_->window, "name-changed", (GCallback) ___lambda36__wnck_window_name_changed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, G_CONNECT_AFTER);
#line 335 "../src/applets/icon-tasklist/IconButton.vala"
	g_signal_connect_data (_data4_->window, "state-changed", (GCallback) ___lambda37__wnck_window_state_changed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, G_CONNECT_AFTER);
#line 341 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp7_ = self->priv->popover;
#line 341 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp8_ = wnck_window_get_name (_data4_->window);
#line 341 "../src/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_add_window (_tmp7_, wnck_window_get_xid (_data4_->window), _tmp8_);
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
	block4_data_unref (_data4_);
#line 316 "../src/applets/icon-tasklist/IconButton.vala"
	_data4_ = NULL;
#line 2107 "IconButton.c"
}

void
icon_button_set_draggable (IconButton* self,
                           gboolean draggable)
{
#line 344 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 345 "../src/applets/icon-tasklist/IconButton.vala"
	if (draggable) {
#line 346 "../src/applets/icon-tasklist/IconButton.vala"
		gtk_drag_source_set ((GtkWidget*) self, GDK_BUTTON1_MASK, DESKTOP_HELPER_targets, (gint) G_N_ELEMENTS (DESKTOP_HELPER_targets), GDK_ACTION_COPY);
#line 2120 "IconButton.c"
	} else {
#line 348 "../src/applets/icon-tasklist/IconButton.vala"
		gtk_drag_source_unset ((GtkWidget*) self);
#line 2124 "IconButton.c"
	}
}

/**
 * should_add_window will return whether or not we should add this window to our popover
 */
static gboolean
icon_button_should_add_window (IconButton* self,
                               WnckWindow* new_window)
{
	gboolean add = FALSE;
	gboolean should_try_name_match = FALSE;
	gboolean is_matching_class_name = FALSE;
	BudgieAbominationRunningApp* _tmp0_;
	gboolean result;
#line 355 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 355 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (new_window != NULL, FALSE);
#line 356 "../src/applets/icon-tasklist/IconButton.vala"
	add = FALSE;
#line 357 "../src/applets/icon-tasklist/IconButton.vala"
	should_try_name_match = FALSE;
#line 358 "../src/applets/icon-tasklist/IconButton.vala"
	is_matching_class_name = FALSE;
#line 360 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->first_app;
#line 360 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ != NULL) {
#line 2154 "IconButton.c"
		BudgieAbominationRunningApp* app = NULL;
		BudgieAbominationAbomination* _tmp1_;
		BudgieAbominationRunningApp* _tmp2_;
		gboolean _tmp3_ = FALSE;
		BudgieAbominationRunningApp* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gboolean _tmp7_;
#line 361 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->_abomination;
#line 361 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = budgie_abomination_abomination_get_app_from_window_id (_tmp1_, wnck_window_get_xid (new_window));
#line 361 "../src/applets/icon-tasklist/IconButton.vala"
		app = _tmp2_;
#line 362 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = self->first_app;
#line 362 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = budgie_abomination_running_app_get_group_name (_tmp4_);
#line 362 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = _tmp5_;
#line 362 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = g_str_has_prefix (_tmp6_, "chrome-");
#line 362 "../src/applets/icon-tasklist/IconButton.vala"
		_g_free0 (_tmp6_);
#line 362 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp7_) {
#line 362 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp3_ = TRUE;
#line 2183 "IconButton.c"
		} else {
			BudgieAbominationRunningApp* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 362 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp8_ = self->first_app;
#line 362 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp9_ = budgie_abomination_running_app_get_group_name (_tmp8_);
#line 362 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp10_ = _tmp9_;
#line 362 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp3_ = g_str_has_prefix (_tmp10_, "google-chrome");
#line 362 "../src/applets/icon-tasklist/IconButton.vala"
			_g_free0 (_tmp10_);
#line 2198 "IconButton.c"
		}
#line 362 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp3_) {
#line 2202 "IconButton.c"
			BudgieAbominationRunningApp* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			BudgieAbominationRunningApp* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 363 "../src/applets/icon-tasklist/IconButton.vala"
			should_try_name_match = TRUE;
#line 364 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp11_ = self->first_app;
#line 364 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp12_ = budgie_abomination_running_app_get_group_name (_tmp11_);
#line 364 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp13_ = _tmp12_;
#line 364 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp14_ = app;
#line 364 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp15_ = budgie_abomination_running_app_get_group_name (_tmp14_);
#line 364 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp16_ = _tmp15_;
#line 364 "../src/applets/icon-tasklist/IconButton.vala"
			is_matching_class_name = g_strcmp0 (_tmp13_, _tmp16_) == 0;
#line 364 "../src/applets/icon-tasklist/IconButton.vala"
			_g_free0 (_tmp16_);
#line 364 "../src/applets/icon-tasklist/IconButton.vala"
			_g_free0 (_tmp13_);
#line 2229 "IconButton.c"
		} else {
			BudgieAbominationRunningApp* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gboolean _tmp20_;
#line 365 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp17_ = self->first_app;
#line 365 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp18_ = budgie_abomination_running_app_get_group_name (_tmp17_);
#line 365 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp19_ = _tmp18_;
#line 365 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp20_ = g_str_has_prefix (_tmp19_, "libreoffice");
#line 365 "../src/applets/icon-tasklist/IconButton.vala"
			_g_free0 (_tmp19_);
#line 365 "../src/applets/icon-tasklist/IconButton.vala"
			if (_tmp20_) {
#line 2247 "IconButton.c"
				BudgieAbominationRunningApp* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				BudgieAbominationRunningApp* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
#line 366 "../src/applets/icon-tasklist/IconButton.vala"
				should_try_name_match = TRUE;
#line 367 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp21_ = self->first_app;
#line 367 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp22_ = budgie_abomination_running_app_get_group_name (_tmp21_);
#line 367 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp23_ = _tmp22_;
#line 367 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp24_ = app;
#line 367 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp25_ = budgie_abomination_running_app_get_group_name (_tmp24_);
#line 367 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp26_ = _tmp25_;
#line 367 "../src/applets/icon-tasklist/IconButton.vala"
				is_matching_class_name = g_strcmp0 (_tmp23_, _tmp26_) == 0;
#line 367 "../src/applets/icon-tasklist/IconButton.vala"
				_g_free0 (_tmp26_);
#line 367 "../src/applets/icon-tasklist/IconButton.vala"
				_g_free0 (_tmp23_);
#line 2274 "IconButton.c"
			}
		}
#line 360 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (app);
#line 2279 "IconButton.c"
	}
#line 371 "../src/applets/icon-tasklist/IconButton.vala"
	if (should_try_name_match) {
#line 372 "../src/applets/icon-tasklist/IconButton.vala"
		add = is_matching_class_name;
#line 2285 "IconButton.c"
	} else {
		WnckWindow* old_window = NULL;
		BudgieAbominationAppGroup* _tmp27_;
		GList* _tmp28_;
		GList* _tmp29_;
		gconstpointer _tmp30_;
		WnckWindow* _tmp31_;
		WnckWindow* _tmp32_;
		const gchar* _tmp33_;
		WnckWindow* _tmp34_;
		const gchar* _tmp35_;
#line 374 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp27_ = self->priv->class_group;
#line 374 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp28_ = budgie_abomination_app_group_get_windows (_tmp27_);
#line 374 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp29_ = _tmp28_;
#line 374 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp30_ = g_list_nth_data (_tmp29_, (guint) 0);
#line 374 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp31_ = _g_object_ref0 ((WnckWindow*) _tmp30_);
#line 374 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp32_ = _tmp31_;
#line 374 "../src/applets/icon-tasklist/IconButton.vala"
		(_tmp29_ == NULL) ? NULL : (_tmp29_ = (g_list_free (_tmp29_), NULL));
#line 374 "../src/applets/icon-tasklist/IconButton.vala"
		old_window = _tmp32_;
#line 375 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp33_ = wnck_window_get_class_instance_name (new_window);
#line 375 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp34_ = old_window;
#line 375 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp35_ = wnck_window_get_class_instance_name (_tmp34_);
#line 375 "../src/applets/icon-tasklist/IconButton.vala"
		add = g_strcmp0 (_tmp33_, _tmp35_) == 0;
#line 371 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (old_window);
#line 2323 "IconButton.c"
	}
#line 378 "../src/applets/icon-tasklist/IconButton.vala"
	result = add;
#line 378 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 2329 "IconButton.c"
}

void
icon_button_update_icon (IconButton* self)
{
	GIcon* app_icon = NULL;
	GDesktopAppInfo* _tmp1_;
	GdkPixbuf* pixbuf_icon = NULL;
	WnckWindow* _tmp4_;
	BudgieAbominationAppGroup* _tmp8_;
	GIcon* _tmp11_;
	Icon* _tmp18_;
	DesktopHelper* _tmp19_;
#line 381 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 382 "../src/applets/icon-tasklist/IconButton.vala"
	if (icon_button_has_valid_windows (self, NULL)) {
#line 2347 "IconButton.c"
		Icon* _tmp0_;
#line 383 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = self->icon;
#line 383 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp0_->waiting = FALSE;
#line 2353 "IconButton.c"
	}
#line 386 "../src/applets/icon-tasklist/IconButton.vala"
	app_icon = NULL;
#line 387 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->app_info;
#line 387 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp1_ != NULL) {
#line 2361 "IconButton.c"
		GDesktopAppInfo* _tmp2_;
		GIcon* _tmp3_;
#line 388 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = self->priv->app_info;
#line 388 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = g_app_info_get_icon ((GAppInfo*) _tmp2_);
#line 388 "../src/applets/icon-tasklist/IconButton.vala"
		app_icon = _tmp3_;
#line 2370 "IconButton.c"
	}
#line 391 "../src/applets/icon-tasklist/IconButton.vala"
	pixbuf_icon = NULL;
#line 392 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = self->priv->window;
#line 392 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp4_ != NULL) {
#line 2378 "IconButton.c"
		WnckWindow* _tmp5_;
		GdkPixbuf* _tmp6_;
		GdkPixbuf* _tmp7_;
#line 393 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = self->priv->window;
#line 393 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = wnck_window_get_icon (_tmp5_);
#line 393 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = _g_object_ref0 (_tmp6_);
#line 393 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (pixbuf_icon);
#line 393 "../src/applets/icon-tasklist/IconButton.vala"
		pixbuf_icon = _tmp7_;
#line 2392 "IconButton.c"
	}
#line 395 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp8_ = self->priv->class_group;
#line 395 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp8_ != NULL) {
#line 2398 "IconButton.c"
		BudgieAbominationAppGroup* _tmp9_;
		GdkPixbuf* _tmp10_;
#line 396 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = self->priv->class_group;
#line 396 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = budgie_abomination_app_group_get_icon (_tmp9_);
#line 396 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (pixbuf_icon);
#line 396 "../src/applets/icon-tasklist/IconButton.vala"
		pixbuf_icon = _tmp10_;
#line 2409 "IconButton.c"
	}
#line 399 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp11_ = app_icon;
#line 399 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp11_ != NULL) {
#line 2415 "IconButton.c"
		Icon* _tmp12_;
		GIcon* _tmp13_;
#line 400 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp12_ = self->icon;
#line 400 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp13_ = app_icon;
#line 400 "../src/applets/icon-tasklist/IconButton.vala"
		gtk_image_set_from_gicon ((GtkImage*) _tmp12_, _tmp13_, (GtkIconSize) GTK_ICON_SIZE_INVALID);
#line 2424 "IconButton.c"
	} else {
		GdkPixbuf* _tmp14_;
#line 401 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp14_ = pixbuf_icon;
#line 401 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp14_ != NULL) {
#line 2431 "IconButton.c"
			Icon* _tmp15_;
			GdkPixbuf* _tmp16_;
#line 402 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp15_ = self->icon;
#line 402 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp16_ = pixbuf_icon;
#line 402 "../src/applets/icon-tasklist/IconButton.vala"
			gtk_image_set_from_pixbuf ((GtkImage*) _tmp15_, _tmp16_);
#line 2440 "IconButton.c"
		} else {
			Icon* _tmp17_;
#line 404 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp17_ = self->icon;
#line 404 "../src/applets/icon-tasklist/IconButton.vala"
			gtk_image_set_from_icon_name ((GtkImage*) _tmp17_, "image-missing", (GtkIconSize) GTK_ICON_SIZE_INVALID);
#line 2447 "IconButton.c"
		}
	}
#line 407 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp18_ = self->icon;
#line 407 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp19_ = self->priv->_desktop_helper;
#line 407 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_image_set_pixel_size ((GtkImage*) _tmp18_, _tmp19_->icon_size);
#line 381 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (pixbuf_icon);
#line 2458 "IconButton.c"
}

void
icon_button_update (IconButton* self)
{
	gboolean has_active = FALSE;
	BudgieAbominationAppGroup* _tmp2_;
	DesktopHelper* _tmp12_;
#line 410 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 411 "../src/applets/icon-tasklist/IconButton.vala"
	if (!icon_button_has_valid_windows (self, NULL)) {
#line 2471 "IconButton.c"
		GtkStyleContext* _tmp0_;
#line 412 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 412 "../src/applets/icon-tasklist/IconButton.vala"
		gtk_style_context_remove_class (_tmp0_, "running");
#line 413 "../src/applets/icon-tasklist/IconButton.vala"
		if (!self->pinned) {
#line 414 "../src/applets/icon-tasklist/IconButton.vala"
			return;
#line 2481 "IconButton.c"
		} else {
#line 416 "../src/applets/icon-tasklist/IconButton.vala"
			_g_object_unref0 (self->priv->class_group);
#line 416 "../src/applets/icon-tasklist/IconButton.vala"
			self->priv->class_group = NULL;
#line 2487 "IconButton.c"
		}
	} else {
		GtkStyleContext* _tmp1_;
#line 419 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 419 "../src/applets/icon-tasklist/IconButton.vala"
		gtk_style_context_add_class (_tmp1_, "running");
#line 2495 "IconButton.c"
	}
#line 422 "../src/applets/icon-tasklist/IconButton.vala"
	has_active = FALSE;
#line 423 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = self->priv->class_group;
#line 423 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp2_ != NULL) {
#line 2503 "IconButton.c"
		BudgieAbominationAppGroup* _tmp3_;
		GList* _tmp4_;
		GList* _tmp5_;
		DesktopHelper* _tmp6_;
		WnckWindow* _tmp7_;
		WnckWindow* _tmp8_;
		GList* _tmp9_;
#line 424 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = self->priv->class_group;
#line 424 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = budgie_abomination_app_group_get_windows (_tmp3_);
#line 424 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = _tmp4_;
#line 424 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = self->priv->_desktop_helper;
#line 424 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = desktop_helper_get_active_window (_tmp6_);
#line 424 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = _tmp7_;
#line 424 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = g_list_find (_tmp5_, _tmp8_);
#line 424 "../src/applets/icon-tasklist/IconButton.vala"
		has_active = _tmp9_ != NULL;
#line 424 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (_tmp8_);
#line 424 "../src/applets/icon-tasklist/IconButton.vala"
		(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_list_free (_tmp5_), NULL));
#line 2531 "IconButton.c"
	} else {
		WnckWindow* _tmp10_;
#line 425 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = self->priv->window;
#line 425 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp10_ != NULL) {
#line 2538 "IconButton.c"
			WnckWindow* _tmp11_;
#line 426 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp11_ = self->priv->window;
#line 426 "../src/applets/icon-tasklist/IconButton.vala"
			has_active = wnck_window_is_active (_tmp11_);
#line 2544 "IconButton.c"
		}
	}
#line 428 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) self, has_active);
#line 430 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_set_tooltip (self);
#line 432 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp12_ = self->priv->_desktop_helper;
#line 432 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_set_draggable (self, !_tmp12_->lock_icons);
#line 434 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_update_icon (self);
#line 435 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 436 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 2561 "IconButton.c"
}

static gboolean
icon_button_has_valid_windows (IconButton* self,
                               gint* num_windows)
{
	gint _vala_num_windows = 0;
	gboolean result;
#line 439 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 440 "../src/applets/icon-tasklist/IconButton.vala"
	_vala_num_windows = self->priv->window_count;
#line 441 "../src/applets/icon-tasklist/IconButton.vala"
	result = self->priv->window_count != 0;
#line 441 "../src/applets/icon-tasklist/IconButton.vala"
	if (num_windows) {
#line 441 "../src/applets/icon-tasklist/IconButton.vala"
		*num_windows = _vala_num_windows;
#line 2580 "IconButton.c"
	}
#line 441 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 2584 "IconButton.c"
}

gboolean
icon_button_has_window (IconButton* self,
                        WnckWindow* window)
{
	WnckWindow* _tmp0_;
	BudgieAbominationAppGroup* _tmp2_;
	BudgieAbominationAppGroup* _tmp3_;
	GList* _tmp4_;
	gboolean result;
#line 444 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 445 "../src/applets/icon-tasklist/IconButton.vala"
	if (window == NULL) {
#line 446 "../src/applets/icon-tasklist/IconButton.vala"
		result = FALSE;
#line 446 "../src/applets/icon-tasklist/IconButton.vala"
		return result;
#line 2604 "IconButton.c"
	}
#line 449 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->window;
#line 449 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ != NULL) {
#line 2610 "IconButton.c"
		WnckWindow* _tmp1_;
#line 450 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->window;
#line 450 "../src/applets/icon-tasklist/IconButton.vala"
		result = _tmp1_ == window;
#line 450 "../src/applets/icon-tasklist/IconButton.vala"
		return result;
#line 2618 "IconButton.c"
	}
#line 453 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = self->priv->class_group;
#line 453 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp2_ == NULL) {
#line 454 "../src/applets/icon-tasklist/IconButton.vala"
		result = FALSE;
#line 454 "../src/applets/icon-tasklist/IconButton.vala"
		return result;
#line 2628 "IconButton.c"
	}
#line 457 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->priv->class_group;
#line 457 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = budgie_abomination_app_group_get_windows (_tmp3_);
#line 2634 "IconButton.c"
	{
		GList* win_collection = NULL;
		GList* win_it = NULL;
#line 457 "../src/applets/icon-tasklist/IconButton.vala"
		win_collection = _tmp4_;
#line 457 "../src/applets/icon-tasklist/IconButton.vala"
		for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 2642 "IconButton.c"
			WnckWindow* _tmp5_;
			WnckWindow* win = NULL;
#line 457 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp5_ = _g_object_ref0 ((WnckWindow*) win_it->data);
#line 457 "../src/applets/icon-tasklist/IconButton.vala"
			win = _tmp5_;
#line 2649 "IconButton.c"
			{
				WnckWindow* _tmp6_;
#line 458 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp6_ = win;
#line 458 "../src/applets/icon-tasklist/IconButton.vala"
				if (_tmp6_ == window) {
#line 459 "../src/applets/icon-tasklist/IconButton.vala"
					result = TRUE;
#line 459 "../src/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (win);
#line 459 "../src/applets/icon-tasklist/IconButton.vala"
					(win_collection == NULL) ? NULL : (win_collection = (g_list_free (win_collection), NULL));
#line 459 "../src/applets/icon-tasklist/IconButton.vala"
					return result;
#line 2664 "IconButton.c"
				}
#line 457 "../src/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (win);
#line 2668 "IconButton.c"
			}
		}
#line 457 "../src/applets/icon-tasklist/IconButton.vala"
		(win_collection == NULL) ? NULL : (win_collection = (g_list_free (win_collection), NULL));
#line 2673 "IconButton.c"
	}
#line 463 "../src/applets/icon-tasklist/IconButton.vala"
	result = FALSE;
#line 463 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 2679 "IconButton.c"
}

gboolean
icon_button_has_window_on_workspace (IconButton* self,
                                     WnckWorkspace* workspace)
{
	BudgieAbominationAppGroup* _tmp0_;
	gboolean result;
#line 466 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 466 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (workspace != NULL, FALSE);
#line 467 "../src/applets/icon-tasklist/IconButton.vala"
	if (workspace == NULL) {
#line 468 "../src/applets/icon-tasklist/IconButton.vala"
		result = FALSE;
#line 468 "../src/applets/icon-tasklist/IconButton.vala"
		return result;
#line 2698 "IconButton.c"
	}
#line 471 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->class_group;
#line 471 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ != NULL) {
#line 2704 "IconButton.c"
		BudgieAbominationAppGroup* _tmp1_;
		GList* _tmp2_;
#line 472 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->class_group;
#line 472 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = budgie_abomination_app_group_get_windows (_tmp1_);
#line 2711 "IconButton.c"
		{
			GList* win_collection = NULL;
			GList* win_it = NULL;
#line 472 "../src/applets/icon-tasklist/IconButton.vala"
			win_collection = _tmp2_;
#line 472 "../src/applets/icon-tasklist/IconButton.vala"
			for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 2719 "IconButton.c"
				WnckWindow* _tmp3_;
				WnckWindow* win = NULL;
#line 472 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp3_ = _g_object_ref0 ((WnckWindow*) win_it->data);
#line 472 "../src/applets/icon-tasklist/IconButton.vala"
				win = _tmp3_;
#line 2726 "IconButton.c"
				{
					gboolean _tmp4_ = FALSE;
					gboolean _tmp5_ = FALSE;
					WnckWindow* _tmp6_;
#line 473 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp6_ = win;
#line 473 "../src/applets/icon-tasklist/IconButton.vala"
					if (!wnck_window_is_skip_pager (_tmp6_)) {
#line 2735 "IconButton.c"
						WnckWindow* _tmp7_;
#line 473 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp7_ = win;
#line 473 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp5_ = !wnck_window_is_skip_tasklist (_tmp7_);
#line 2741 "IconButton.c"
					} else {
#line 473 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp5_ = FALSE;
#line 2745 "IconButton.c"
					}
#line 473 "../src/applets/icon-tasklist/IconButton.vala"
					if (_tmp5_) {
#line 2749 "IconButton.c"
						WnckWindow* _tmp8_;
#line 473 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp8_ = win;
#line 473 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp4_ = wnck_window_is_on_workspace (_tmp8_, workspace);
#line 2755 "IconButton.c"
					} else {
#line 473 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp4_ = FALSE;
#line 2759 "IconButton.c"
					}
#line 473 "../src/applets/icon-tasklist/IconButton.vala"
					if (_tmp4_) {
#line 474 "../src/applets/icon-tasklist/IconButton.vala"
						result = TRUE;
#line 474 "../src/applets/icon-tasklist/IconButton.vala"
						_g_object_unref0 (win);
#line 474 "../src/applets/icon-tasklist/IconButton.vala"
						(win_collection == NULL) ? NULL : (win_collection = (g_list_free (win_collection), NULL));
#line 474 "../src/applets/icon-tasklist/IconButton.vala"
						return result;
#line 2771 "IconButton.c"
					}
#line 472 "../src/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (win);
#line 2775 "IconButton.c"
				}
			}
#line 472 "../src/applets/icon-tasklist/IconButton.vala"
			(win_collection == NULL) ? NULL : (win_collection = (g_list_free (win_collection), NULL));
#line 2780 "IconButton.c"
		}
	} else {
		WnckWindow* _tmp9_;
#line 477 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = self->priv->window;
#line 477 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp9_ != NULL) {
#line 2788 "IconButton.c"
			gboolean _tmp10_ = FALSE;
			WnckWindow* _tmp11_;
#line 478 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp11_ = self->priv->window;
#line 478 "../src/applets/icon-tasklist/IconButton.vala"
			if (!wnck_window_is_skip_tasklist (_tmp11_)) {
#line 2795 "IconButton.c"
				WnckWindow* _tmp12_;
#line 478 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp12_ = self->priv->window;
#line 478 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp10_ = wnck_window_is_on_workspace (_tmp12_, workspace);
#line 2801 "IconButton.c"
			} else {
#line 478 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp10_ = FALSE;
#line 2805 "IconButton.c"
			}
#line 478 "../src/applets/icon-tasklist/IconButton.vala"
			result = _tmp10_;
#line 478 "../src/applets/icon-tasklist/IconButton.vala"
			return result;
#line 2811 "IconButton.c"
		}
	}
#line 481 "../src/applets/icon-tasklist/IconButton.vala"
	result = FALSE;
#line 481 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 2818 "IconButton.c"
}

static void
icon_button_launch_app (IconButton* self,
                        guint32 time)
{
	GDesktopAppInfo* _tmp0_;
	GdkAppLaunchContext* _tmp1_;
	GdkScreen* _tmp2_;
	GdkAppLaunchContext* _tmp3_;
	Icon* _tmp4_;
	DesktopHelper* _tmp5_;
	Icon* _tmp6_;
	Icon* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 484 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 485 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->app_info;
#line 485 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ == NULL) {
#line 486 "../src/applets/icon-tasklist/IconButton.vala"
		return;
#line 2842 "IconButton.c"
	}
#line 489 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->launch_context;
#line 489 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 489 "../src/applets/icon-tasklist/IconButton.vala"
	gdk_app_launch_context_set_screen (_tmp1_, _tmp2_);
#line 490 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->priv->launch_context;
#line 490 "../src/applets/icon-tasklist/IconButton.vala"
	gdk_app_launch_context_set_timestamp (_tmp3_, time);
#line 492 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = self->icon;
#line 492 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp5_ = self->priv->_desktop_helper;
#line 492 "../src/applets/icon-tasklist/IconButton.vala"
	icon_animate_launch (_tmp4_, _tmp5_->panel_position);
#line 493 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp6_ = self->icon;
#line 493 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp6_->waiting = TRUE;
#line 494 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp7_ = self->icon;
#line 494 "../src/applets/icon-tasklist/IconButton.vala"
	icon_animate_wait (_tmp7_);
#line 2868 "IconButton.c"
	{
		GDesktopAppInfo* _tmp8_;
		GdkAppLaunchContext* _tmp9_;
#line 497 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = self->priv->app_info;
#line 497 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = self->priv->launch_context;
#line 497 "../src/applets/icon-tasklist/IconButton.vala"
		g_app_info_launch ((GAppInfo*) _tmp8_, NULL, (GAppLaunchContext*) _tmp9_, &_inner_error0_);
#line 497 "../src/applets/icon-tasklist/IconButton.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2880 "IconButton.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 496 "../src/applets/icon-tasklist/IconButton.vala"
		e = _inner_error0_;
#line 496 "../src/applets/icon-tasklist/IconButton.vala"
		_inner_error0_ = NULL;
#line 499 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = e;
#line 499 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp11_ = _tmp10_->message;
#line 499 "../src/applets/icon-tasklist/IconButton.vala"
		g_warning ("IconButton.vala:499: %s", _tmp11_);
#line 496 "../src/applets/icon-tasklist/IconButton.vala"
		_g_error_free0 (e);
#line 2902 "IconButton.c"
	}
	__finally0:
#line 496 "../src/applets/icon-tasklist/IconButton.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 496 "../src/applets/icon-tasklist/IconButton.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 496 "../src/applets/icon-tasklist/IconButton.vala"
		g_clear_error (&_inner_error0_);
#line 496 "../src/applets/icon-tasklist/IconButton.vala"
		return;
#line 2913 "IconButton.c"
	}
}

gboolean
icon_button_is_empty (IconButton* self)
{
	gboolean _tmp0_ = FALSE;
	WnckWindow* _tmp1_;
	gboolean result;
#line 503 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 504 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->window;
#line 504 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp1_ == NULL) {
#line 2929 "IconButton.c"
		BudgieAbominationAppGroup* _tmp2_;
#line 504 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = self->priv->class_group;
#line 504 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 2935 "IconButton.c"
	} else {
#line 504 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = FALSE;
#line 2939 "IconButton.c"
	}
#line 504 "../src/applets/icon-tasklist/IconButton.vala"
	result = _tmp0_;
#line 504 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 2945 "IconButton.c"
}

gboolean
icon_button_is_pinned (IconButton* self)
{
	gboolean result;
#line 507 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 508 "../src/applets/icon-tasklist/IconButton.vala"
	result = self->pinned;
#line 508 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 2958 "IconButton.c"
}

void
icon_button_attention (IconButton* self,
                       gboolean needs_it)
{
#line 511 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 512 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->needs_attention = needs_it;
#line 513 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 514 "../src/applets/icon-tasklist/IconButton.vala"
	if (needs_it) {
#line 2973 "IconButton.c"
		Icon* _tmp0_;
		DesktopHelper* _tmp1_;
#line 515 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = self->icon;
#line 515 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->_desktop_helper;
#line 515 "../src/applets/icon-tasklist/IconButton.vala"
		icon_animate_attention (_tmp0_, &_tmp1_->panel_position);
#line 2982 "IconButton.c"
	}
}

/**
 * set_tooltip will set the tooltip text for this IconButton
 */
void
icon_button_set_tooltip (IconButton* self)
{
#line 522 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 523 "../src/applets/icon-tasklist/IconButton.vala"
	if (self->priv->window_count != 0) {
#line 2996 "IconButton.c"
		gboolean _tmp0_ = FALSE;
#line 524 "../src/applets/icon-tasklist/IconButton.vala"
		if (self->priv->window_count == 1) {
#line 3000 "IconButton.c"
			BudgieAbominationRunningApp* _tmp1_;
#line 524 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp1_ = self->first_app;
#line 524 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp0_ = _tmp1_ != NULL;
#line 3006 "IconButton.c"
		} else {
#line 524 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp0_ = FALSE;
#line 3010 "IconButton.c"
		}
#line 524 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp0_) {
#line 3014 "IconButton.c"
			BudgieAbominationRunningApp* _tmp2_;
			const gchar* _tmp3_;
			const gchar* _tmp4_;
#line 525 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp2_ = self->first_app;
#line 525 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp3_ = budgie_abomination_running_app_get_name (_tmp2_);
#line 525 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp4_ = _tmp3_;
#line 525 "../src/applets/icon-tasklist/IconButton.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp4_);
#line 3026 "IconButton.c"
		} else {
			GDesktopAppInfo* _tmp5_;
#line 526 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp5_ = self->priv->app_info;
#line 526 "../src/applets/icon-tasklist/IconButton.vala"
			if (_tmp5_ != NULL) {
#line 3033 "IconButton.c"
				GDesktopAppInfo* _tmp6_;
				const gchar* _tmp7_;
#line 527 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp6_ = self->priv->app_info;
#line 527 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp7_ = g_app_info_get_display_name ((GAppInfo*) _tmp6_);
#line 527 "../src/applets/icon-tasklist/IconButton.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp7_);
#line 3042 "IconButton.c"
			} else {
				WnckWindow* _tmp8_;
#line 528 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp8_ = self->priv->window;
#line 528 "../src/applets/icon-tasklist/IconButton.vala"
				if (_tmp8_ != NULL) {
#line 3049 "IconButton.c"
					WnckWindow* _tmp9_;
					const gchar* _tmp10_;
#line 529 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp9_ = self->priv->window;
#line 529 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp10_ = wnck_window_get_name (_tmp9_);
#line 529 "../src/applets/icon-tasklist/IconButton.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp10_);
#line 3058 "IconButton.c"
				}
			}
		}
	} else {
		GDesktopAppInfo* _tmp11_;
#line 532 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp11_ = self->priv->app_info;
#line 532 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp11_ != NULL) {
#line 3068 "IconButton.c"
			GDesktopAppInfo* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 533 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp12_ = self->priv->app_info;
#line 533 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp13_ = g_app_info_get_display_name ((GAppInfo*) _tmp12_);
#line 533 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp14_ = g_strdup_printf ("Launch %s", _tmp13_);
#line 533 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp15_ = _tmp14_;
#line 533 "../src/applets/icon-tasklist/IconButton.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp15_);
#line 533 "../src/applets/icon-tasklist/IconButton.vala"
			_g_free0 (_tmp15_);
#line 3085 "IconButton.c"
		} else {
			BudgieAbominationAppGroup* _tmp16_;
#line 534 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp16_ = self->priv->class_group;
#line 534 "../src/applets/icon-tasklist/IconButton.vala"
			if (_tmp16_ != NULL) {
#line 3092 "IconButton.c"
				BudgieAbominationAppGroup* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
#line 535 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp17_ = self->priv->class_group;
#line 535 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp18_ = budgie_abomination_app_group_get_name (_tmp17_);
#line 535 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp19_ = _tmp18_;
#line 535 "../src/applets/icon-tasklist/IconButton.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp19_);
#line 535 "../src/applets/icon-tasklist/IconButton.vala"
				_g_free0 (_tmp19_);
#line 3106 "IconButton.c"
			}
		}
	}
}

/**
 * Handle startup notification, set our own ID to the ID selected
 */
static void
icon_button_on_launched (IconButton* self,
                         GAppInfo* info,
                         GVariant* v)
{
	GVariant* elem = NULL;
	GVariantIter* iter = NULL;
	GVariantIter* _tmp0_;
#line 543 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 543 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (info != NULL);
#line 543 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (v != NULL);
#line 546 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = g_variant_iter_new (v);
#line 546 "../src/applets/icon-tasklist/IconButton.vala"
	iter = _tmp0_;
#line 548 "../src/applets/icon-tasklist/IconButton.vala"
	while (TRUE) {
#line 3135 "IconButton.c"
		GVariantIter* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		gchar* key = NULL;
		GVariant* val = NULL;
		GVariant* _tmp4_;
		gchar* _tmp5_ = NULL;
		GVariant* _tmp6_ = NULL;
		const gchar* _tmp7_;
		GVariant* _tmp8_;
		const GVariantType* _tmp9_;
		const gchar* _tmp10_;
		GdkDisplay* _tmp11_;
		GVariant* _tmp12_;
		const gchar* _tmp13_;
#line 548 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = iter;
#line 548 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = g_variant_iter_next_value (_tmp1_);
#line 548 "../src/applets/icon-tasklist/IconButton.vala"
		_g_variant_unref0 (elem);
#line 548 "../src/applets/icon-tasklist/IconButton.vala"
		elem = _tmp2_;
#line 548 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = elem;
#line 548 "../src/applets/icon-tasklist/IconButton.vala"
		if (!(_tmp3_ != NULL)) {
#line 548 "../src/applets/icon-tasklist/IconButton.vala"
			break;
#line 3165 "IconButton.c"
		}
#line 549 "../src/applets/icon-tasklist/IconButton.vala"
		key = NULL;
#line 550 "../src/applets/icon-tasklist/IconButton.vala"
		val = NULL;
#line 552 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = elem;
#line 552 "../src/applets/icon-tasklist/IconButton.vala"
		g_variant_get (_tmp4_, "{sv}", &_tmp5_, &_tmp6_, NULL);
#line 552 "../src/applets/icon-tasklist/IconButton.vala"
		_g_free0 (key);
#line 552 "../src/applets/icon-tasklist/IconButton.vala"
		key = _tmp5_;
#line 552 "../src/applets/icon-tasklist/IconButton.vala"
		_g_variant_unref0 (val);
#line 552 "../src/applets/icon-tasklist/IconButton.vala"
		val = _tmp6_;
#line 554 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = key;
#line 554 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp7_ == NULL) {
#line 555 "../src/applets/icon-tasklist/IconButton.vala"
			_g_variant_unref0 (val);
#line 555 "../src/applets/icon-tasklist/IconButton.vala"
			_g_free0 (key);
#line 555 "../src/applets/icon-tasklist/IconButton.vala"
			continue;
#line 3193 "IconButton.c"
		}
#line 558 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = val;
#line 558 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = G_VARIANT_TYPE_STRING;
#line 558 "../src/applets/icon-tasklist/IconButton.vala"
		if (!g_variant_is_of_type (_tmp8_, _tmp9_)) {
#line 559 "../src/applets/icon-tasklist/IconButton.vala"
			_g_variant_unref0 (val);
#line 559 "../src/applets/icon-tasklist/IconButton.vala"
			_g_free0 (key);
#line 559 "../src/applets/icon-tasklist/IconButton.vala"
			continue;
#line 3207 "IconButton.c"
		}
#line 562 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = key;
#line 562 "../src/applets/icon-tasklist/IconButton.vala"
		if (g_strcmp0 (_tmp10_, "startup-notification-id") != 0) {
#line 563 "../src/applets/icon-tasklist/IconButton.vala"
			_g_variant_unref0 (val);
#line 563 "../src/applets/icon-tasklist/IconButton.vala"
			_g_free0 (key);
#line 563 "../src/applets/icon-tasklist/IconButton.vala"
			continue;
#line 3219 "IconButton.c"
		}
#line 566 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp11_ = gtk_widget_get_display ((GtkWidget*) self);
#line 566 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp12_ = val;
#line 566 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp13_ = g_variant_get_string (_tmp12_, NULL);
#line 566 "../src/applets/icon-tasklist/IconButton.vala"
		gdk_display_notify_startup_complete (_tmp11_, _tmp13_);
#line 548 "../src/applets/icon-tasklist/IconButton.vala"
		_g_variant_unref0 (val);
#line 548 "../src/applets/icon-tasklist/IconButton.vala"
		_g_free0 (key);
#line 3233 "IconButton.c"
	}
#line 543 "../src/applets/icon-tasklist/IconButton.vala"
	_g_variant_iter_free0 (iter);
#line 543 "../src/applets/icon-tasklist/IconButton.vala"
	_g_variant_unref0 (elem);
#line 3239 "IconButton.c"
}

static void
icon_button_on_launch_failed (IconButton* self,
                              const gchar* id)
{
	GdkDisplay* _tmp0_;
#line 570 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 570 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (id != NULL);
#line 571 "../src/applets/icon-tasklist/IconButton.vala"
	g_warning ("IconButton.vala:571: launch_failed");
#line 572 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 572 "../src/applets/icon-tasklist/IconButton.vala"
	gdk_display_notify_startup_complete (_tmp0_, id);
#line 3257 "IconButton.c"
}

void
icon_button_draw_inactive (IconButton* self,
                           cairo_t* cr,
                           GdkRGBA* col)
{
	gint x = 0;
	GtkAllocation _tmp0_;
	gint y = 0;
	GtkAllocation _tmp1_;
	gint width = 0;
	GtkAllocation _tmp2_;
	gint height = 0;
	GtkAllocation _tmp3_;
	GList* windows = NULL;
	BudgieAbominationAppGroup* _tmp4_;
	gint count = 0;
	gint _tmp8_ = 0;
	gboolean _tmp9_;
	gint _tmp10_ = 0;
	gint counter = 0;
	GList* _tmp11_;
#line 575 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 575 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (cr != NULL);
#line 575 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (col != NULL);
#line 576 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->definite_allocation;
#line 576 "../src/applets/icon-tasklist/IconButton.vala"
	x = _tmp0_.x;
#line 577 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->definite_allocation;
#line 577 "../src/applets/icon-tasklist/IconButton.vala"
	y = _tmp1_.y;
#line 578 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = self->priv->definite_allocation;
#line 578 "../src/applets/icon-tasklist/IconButton.vala"
	width = _tmp2_.width;
#line 579 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->priv->definite_allocation;
#line 579 "../src/applets/icon-tasklist/IconButton.vala"
	height = _tmp3_.height;
#line 582 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = self->priv->class_group;
#line 582 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp4_ != NULL) {
#line 3307 "IconButton.c"
		BudgieAbominationAppGroup* _tmp5_;
		GList* _tmp6_;
#line 583 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = self->priv->class_group;
#line 583 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = budgie_abomination_app_group_get_windows (_tmp5_);
#line 583 "../src/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 583 "../src/applets/icon-tasklist/IconButton.vala"
		windows = _tmp6_;
#line 3318 "IconButton.c"
	} else {
		WnckWindow* _tmp7_;
#line 585 "../src/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 585 "../src/applets/icon-tasklist/IconButton.vala"
		windows = NULL;
#line 586 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = self->priv->window;
#line 586 "../src/applets/icon-tasklist/IconButton.vala"
		windows = g_list_insert (windows, _tmp7_, 0);
#line 3329 "IconButton.c"
	}
#line 590 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp9_ = icon_button_has_valid_windows (self, &_tmp8_);
#line 590 "../src/applets/icon-tasklist/IconButton.vala"
	count = _tmp8_;
#line 590 "../src/applets/icon-tasklist/IconButton.vala"
	if (!_tmp9_) {
#line 591 "../src/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 591 "../src/applets/icon-tasklist/IconButton.vala"
		return;
#line 3341 "IconButton.c"
	}
#line 594 "../src/applets/icon-tasklist/IconButton.vala"
	if (count > 5) {
#line 594 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = 5;
#line 3347 "IconButton.c"
	} else {
#line 594 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = count;
#line 3351 "IconButton.c"
	}
#line 594 "../src/applets/icon-tasklist/IconButton.vala"
	count = _tmp10_;
#line 596 "../src/applets/icon-tasklist/IconButton.vala"
	counter = 0;
#line 597 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp11_ = windows;
#line 3359 "IconButton.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 597 "../src/applets/icon-tasklist/IconButton.vala"
		window_collection = _tmp11_;
#line 597 "../src/applets/icon-tasklist/IconButton.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 3367 "IconButton.c"
			WnckWindow* _tmp12_;
			WnckWindow* window = NULL;
#line 597 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp12_ = _g_object_ref0 ((WnckWindow*) window_it->data);
#line 597 "../src/applets/icon-tasklist/IconButton.vala"
			window = _tmp12_;
#line 3374 "IconButton.c"
			{
				gboolean _tmp13_ = FALSE;
				WnckWindow* _tmp14_;
#line 598 "../src/applets/icon-tasklist/IconButton.vala"
				if (counter == count) {
#line 599 "../src/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (window);
#line 599 "../src/applets/icon-tasklist/IconButton.vala"
					break;
#line 3384 "IconButton.c"
				}
#line 602 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp14_ = window;
#line 602 "../src/applets/icon-tasklist/IconButton.vala"
				if (!wnck_window_is_skip_pager (_tmp14_)) {
#line 3390 "IconButton.c"
					WnckWindow* _tmp15_;
#line 602 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp15_ = window;
#line 602 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp13_ = !wnck_window_is_skip_tasklist (_tmp15_);
#line 3396 "IconButton.c"
				} else {
#line 602 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp13_ = FALSE;
#line 3400 "IconButton.c"
				}
#line 602 "../src/applets/icon-tasklist/IconButton.vala"
				if (_tmp13_) {
#line 3404 "IconButton.c"
					gint indicator_x = 0;
					gint indicator_y = 0;
					DesktopHelper* _tmp16_;
					GdkRGBA _tmp17_;
					GdkRGBA _tmp18_;
					GdkRGBA _tmp19_;
					gint _tmp20_;
#line 603 "../src/applets/icon-tasklist/IconButton.vala"
					indicator_x = 0;
#line 604 "../src/applets/icon-tasklist/IconButton.vala"
					indicator_y = 0;
#line 605 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp16_ = self->priv->_desktop_helper;
#line 605 "../src/applets/icon-tasklist/IconButton.vala"
					switch (_tmp16_->panel_position) {
#line 605 "../src/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_TOP:
#line 3422 "IconButton.c"
						{
#line 607 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_x = x + (width / 2);
#line 608 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_x -= ((count * (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING)) / 2) - INACTIVE_INDICATOR_SPACING;
#line 609 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_x += (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING) * counter;
#line 610 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_y = y + (INDICATOR_SIZE / 2);
#line 611 "../src/applets/icon-tasklist/IconButton.vala"
							break;
#line 3434 "IconButton.c"
						}
#line 605 "../src/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_BOTTOM:
#line 3438 "IconButton.c"
						{
#line 613 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_x = x + (width / 2);
#line 614 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_x -= ((count * (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING)) / 2) - INACTIVE_INDICATOR_SPACING;
#line 615 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_x += (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING) * counter;
#line 616 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_y = (y + height) - (INDICATOR_SIZE / 2);
#line 617 "../src/applets/icon-tasklist/IconButton.vala"
							break;
#line 3450 "IconButton.c"
						}
#line 605 "../src/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_LEFT:
#line 3454 "IconButton.c"
						{
#line 619 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_y = x + (height / 2);
#line 620 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_y -= ((count * (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING)) / 2) - (INACTIVE_INDICATOR_SPACING * 2);
#line 621 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_y += (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING) * counter;
#line 622 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_x = y + (INDICATOR_SIZE / 2);
#line 623 "../src/applets/icon-tasklist/IconButton.vala"
							break;
#line 3466 "IconButton.c"
						}
#line 605 "../src/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_RIGHT:
#line 3470 "IconButton.c"
						{
#line 625 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_y = x + (height / 2);
#line 626 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_y -= ((count * (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING)) / 2) - INACTIVE_INDICATOR_SPACING;
#line 627 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_y += (INDICATOR_SIZE + INACTIVE_INDICATOR_SPACING) * counter;
#line 628 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_x = (y + width) - (INDICATOR_SIZE / 2);
#line 629 "../src/applets/icon-tasklist/IconButton.vala"
							break;
#line 3482 "IconButton.c"
						}
						default:
						{
#line 631 "../src/applets/icon-tasklist/IconButton.vala"
							break;
#line 3488 "IconButton.c"
						}
					}
#line 634 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp17_ = *col;
#line 634 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp18_ = *col;
#line 634 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp19_ = *col;
#line 634 "../src/applets/icon-tasklist/IconButton.vala"
					cairo_set_source_rgba (cr, _tmp17_.red, _tmp18_.green, _tmp19_.blue, (gdouble) 1);
#line 635 "../src/applets/icon-tasklist/IconButton.vala"
					cairo_arc (cr, (gdouble) indicator_x, (gdouble) indicator_y, (gdouble) INDICATOR_SIZE, (gdouble) 0, G_PI * 2);
#line 636 "../src/applets/icon-tasklist/IconButton.vala"
					cairo_fill (cr);
#line 637 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp20_ = counter;
#line 637 "../src/applets/icon-tasklist/IconButton.vala"
					counter = _tmp20_ + 1;
#line 3507 "IconButton.c"
				}
#line 597 "../src/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (window);
#line 3511 "IconButton.c"
			}
		}
	}
#line 575 "../src/applets/icon-tasklist/IconButton.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 3517 "IconButton.c"
}

static gboolean
icon_button_real_draw (GtkWidget* base,
                       cairo_t* cr)
{
	IconButton * self;
	gint x = 0;
	GtkAllocation _tmp0_;
	gint y = 0;
	GtkAllocation _tmp1_;
	gint width = 0;
	GtkAllocation _tmp2_;
	gint height = 0;
	GtkAllocation _tmp3_;
	GList* windows = NULL;
	BudgieAbominationAppGroup* _tmp4_;
	gint count = 0;
	gint _tmp8_ = 0;
	gboolean _tmp9_;
	gint _tmp10_ = 0;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp11_;
	GtkStyleContext* _tmp12_;
	GdkRGBA col = {0};
	GtkStyleContext* _tmp13_;
	GdkRGBA _tmp14_ = {0};
	gboolean _tmp15_;
	gint counter = 0;
	gint previous_x = 0;
	gint previous_y = 0;
	gint spacing = 0;
	gint _tmp23_ = 0;
	GList* _tmp24_;
	gboolean result;
#line 642 "../src/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) base;
#line 642 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 643 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->definite_allocation;
#line 643 "../src/applets/icon-tasklist/IconButton.vala"
	x = _tmp0_.x;
#line 644 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->definite_allocation;
#line 644 "../src/applets/icon-tasklist/IconButton.vala"
	y = _tmp1_.y;
#line 645 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = self->priv->definite_allocation;
#line 645 "../src/applets/icon-tasklist/IconButton.vala"
	width = _tmp2_.width;
#line 646 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = self->priv->definite_allocation;
#line 646 "../src/applets/icon-tasklist/IconButton.vala"
	height = _tmp3_.height;
#line 649 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = self->priv->class_group;
#line 649 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp4_ != NULL) {
#line 3577 "IconButton.c"
		BudgieAbominationAppGroup* _tmp5_;
		GList* _tmp6_;
#line 650 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = self->priv->class_group;
#line 650 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = budgie_abomination_app_group_get_windows (_tmp5_);
#line 650 "../src/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 650 "../src/applets/icon-tasklist/IconButton.vala"
		windows = _tmp6_;
#line 3588 "IconButton.c"
	} else {
		WnckWindow* _tmp7_;
#line 652 "../src/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 652 "../src/applets/icon-tasklist/IconButton.vala"
		windows = NULL;
#line 653 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = self->priv->window;
#line 653 "../src/applets/icon-tasklist/IconButton.vala"
		windows = g_list_insert (windows, _tmp7_, 0);
#line 3599 "IconButton.c"
	}
#line 657 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp9_ = icon_button_has_valid_windows (self, &_tmp8_);
#line 657 "../src/applets/icon-tasklist/IconButton.vala"
	count = _tmp8_;
#line 657 "../src/applets/icon-tasklist/IconButton.vala"
	if (!_tmp9_) {
#line 658 "../src/applets/icon-tasklist/IconButton.vala"
		result = GTK_WIDGET_CLASS (icon_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), cr);
#line 658 "../src/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 658 "../src/applets/icon-tasklist/IconButton.vala"
		return result;
#line 3613 "IconButton.c"
	}
#line 661 "../src/applets/icon-tasklist/IconButton.vala"
	if (count > 5) {
#line 661 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = 5;
#line 3619 "IconButton.c"
	} else {
#line 661 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = count;
#line 3623 "IconButton.c"
	}
#line 661 "../src/applets/icon-tasklist/IconButton.vala"
	count = _tmp10_;
#line 663 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 663 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 663 "../src/applets/icon-tasklist/IconButton.vala"
	context = _tmp12_;
#line 666 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp13_ = context;
#line 666 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp15_ = gtk_style_context_lookup_color (_tmp13_, "budgie_tasklist_indicator_color", &_tmp14_);
#line 666 "../src/applets/icon-tasklist/IconButton.vala"
	col = _tmp14_;
#line 666 "../src/applets/icon-tasklist/IconButton.vala"
	if (!_tmp15_) {
#line 667 "../src/applets/icon-tasklist/IconButton.vala"
		gdk_rgba_parse (&col, "#3C6DA6");
#line 3643 "IconButton.c"
	}
#line 670 "../src/applets/icon-tasklist/IconButton.vala"
	if (gtk_toggle_button_get_active ((GtkToggleButton*) self)) {
#line 3647 "IconButton.c"
		GtkStyleContext* _tmp16_;
		GdkRGBA _tmp17_ = {0};
		gboolean _tmp18_;
#line 671 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp16_ = context;
#line 671 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp18_ = gtk_style_context_lookup_color (_tmp16_, "budgie_tasklist_indicator_color_active", &_tmp17_);
#line 671 "../src/applets/icon-tasklist/IconButton.vala"
		col = _tmp17_;
#line 671 "../src/applets/icon-tasklist/IconButton.vala"
		if (!_tmp18_) {
#line 672 "../src/applets/icon-tasklist/IconButton.vala"
			gdk_rgba_parse (&col, "#5294E2");
#line 3661 "IconButton.c"
		}
	} else {
		GdkRGBA _tmp22_;
#line 675 "../src/applets/icon-tasklist/IconButton.vala"
		if (self->priv->needs_attention) {
#line 3667 "IconButton.c"
			GtkStyleContext* _tmp19_;
			GdkRGBA _tmp20_ = {0};
			gboolean _tmp21_;
#line 676 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp19_ = context;
#line 676 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp21_ = gtk_style_context_lookup_color (_tmp19_, "budgie_tasklist_indicator_color_attention", &_tmp20_);
#line 676 "../src/applets/icon-tasklist/IconButton.vala"
			col = _tmp20_;
#line 676 "../src/applets/icon-tasklist/IconButton.vala"
			if (!_tmp21_) {
#line 677 "../src/applets/icon-tasklist/IconButton.vala"
				gdk_rgba_parse (&col, "#D84E4E");
#line 3681 "IconButton.c"
			}
		}
#line 680 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp22_ = col;
#line 680 "../src/applets/icon-tasklist/IconButton.vala"
		icon_button_draw_inactive (self, cr, &_tmp22_);
#line 681 "../src/applets/icon-tasklist/IconButton.vala"
		result = GTK_WIDGET_CLASS (icon_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), cr);
#line 681 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (context);
#line 681 "../src/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 681 "../src/applets/icon-tasklist/IconButton.vala"
		return result;
#line 3696 "IconButton.c"
	}
#line 684 "../src/applets/icon-tasklist/IconButton.vala"
	counter = 0;
#line 685 "../src/applets/icon-tasklist/IconButton.vala"
	previous_x = 0;
#line 686 "../src/applets/icon-tasklist/IconButton.vala"
	previous_y = 0;
#line 687 "../src/applets/icon-tasklist/IconButton.vala"
	spacing = width % count;
#line 688 "../src/applets/icon-tasklist/IconButton.vala"
	if (spacing == 0) {
#line 688 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp23_ = 1;
#line 3710 "IconButton.c"
	} else {
#line 688 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp23_ = spacing;
#line 3714 "IconButton.c"
	}
#line 688 "../src/applets/icon-tasklist/IconButton.vala"
	spacing = _tmp23_;
#line 689 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp24_ = windows;
#line 3720 "IconButton.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 689 "../src/applets/icon-tasklist/IconButton.vala"
		window_collection = _tmp24_;
#line 689 "../src/applets/icon-tasklist/IconButton.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 3728 "IconButton.c"
			WnckWindow* _tmp25_;
			WnckWindow* window = NULL;
#line 689 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp25_ = _g_object_ref0 ((WnckWindow*) window_it->data);
#line 689 "../src/applets/icon-tasklist/IconButton.vala"
			window = _tmp25_;
#line 3735 "IconButton.c"
			{
				WnckWindow* _tmp26_;
#line 690 "../src/applets/icon-tasklist/IconButton.vala"
				if (counter == count) {
#line 691 "../src/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (window);
#line 691 "../src/applets/icon-tasklist/IconButton.vala"
					break;
#line 3744 "IconButton.c"
				}
#line 694 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp26_ = window;
#line 694 "../src/applets/icon-tasklist/IconButton.vala"
				if (!wnck_window_is_skip_tasklist (_tmp26_)) {
#line 3750 "IconButton.c"
					gint indicator_x = 0;
					gint indicator_y = 0;
					DesktopHelper* _tmp27_;
					gboolean _tmp28_ = FALSE;
					DesktopHelper* _tmp29_;
					WnckWindow* _tmp30_;
					WnckWindow* _tmp31_;
					WnckWindow* _tmp32_;
					gboolean _tmp33_;
					DesktopHelper* _tmp44_;
					gint _tmp45_;
#line 695 "../src/applets/icon-tasklist/IconButton.vala"
					indicator_x = 0;
#line 696 "../src/applets/icon-tasklist/IconButton.vala"
					indicator_y = 0;
#line 697 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp27_ = self->priv->_desktop_helper;
#line 697 "../src/applets/icon-tasklist/IconButton.vala"
					switch (_tmp27_->panel_position) {
#line 697 "../src/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_TOP:
#line 3772 "IconButton.c"
						{
#line 699 "../src/applets/icon-tasklist/IconButton.vala"
							if (counter == 0) {
#line 700 "../src/applets/icon-tasklist/IconButton.vala"
								indicator_x = x;
#line 3778 "IconButton.c"
							} else {
#line 702 "../src/applets/icon-tasklist/IconButton.vala"
								indicator_x = previous_x + (width / count);
#line 702 "../src/applets/icon-tasklist/IconButton.vala"
								previous_x = indicator_x;
#line 703 "../src/applets/icon-tasklist/IconButton.vala"
								indicator_x += spacing;
#line 3786 "IconButton.c"
							}
#line 705 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_y = y;
#line 706 "../src/applets/icon-tasklist/IconButton.vala"
							break;
#line 3792 "IconButton.c"
						}
#line 697 "../src/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_BOTTOM:
#line 3796 "IconButton.c"
						{
#line 708 "../src/applets/icon-tasklist/IconButton.vala"
							if (counter == 0) {
#line 709 "../src/applets/icon-tasklist/IconButton.vala"
								indicator_x = x;
#line 3802 "IconButton.c"
							} else {
#line 711 "../src/applets/icon-tasklist/IconButton.vala"
								indicator_x = previous_x + (width / count);
#line 711 "../src/applets/icon-tasklist/IconButton.vala"
								previous_x = indicator_x;
#line 712 "../src/applets/icon-tasklist/IconButton.vala"
								indicator_x += spacing;
#line 3810 "IconButton.c"
							}
#line 714 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_y = y + height;
#line 715 "../src/applets/icon-tasklist/IconButton.vala"
							break;
#line 3816 "IconButton.c"
						}
#line 697 "../src/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_LEFT:
#line 3820 "IconButton.c"
						{
#line 717 "../src/applets/icon-tasklist/IconButton.vala"
							if (counter == 0) {
#line 718 "../src/applets/icon-tasklist/IconButton.vala"
								indicator_y = y;
#line 3826 "IconButton.c"
							} else {
#line 720 "../src/applets/icon-tasklist/IconButton.vala"
								indicator_y = previous_y + (height / count);
#line 720 "../src/applets/icon-tasklist/IconButton.vala"
								previous_y = indicator_y;
#line 721 "../src/applets/icon-tasklist/IconButton.vala"
								indicator_y += spacing;
#line 3834 "IconButton.c"
							}
#line 723 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_x = x;
#line 724 "../src/applets/icon-tasklist/IconButton.vala"
							break;
#line 3840 "IconButton.c"
						}
#line 697 "../src/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_RIGHT:
#line 3844 "IconButton.c"
						{
#line 726 "../src/applets/icon-tasklist/IconButton.vala"
							if (counter == 0) {
#line 727 "../src/applets/icon-tasklist/IconButton.vala"
								indicator_y = y;
#line 3850 "IconButton.c"
							} else {
#line 729 "../src/applets/icon-tasklist/IconButton.vala"
								indicator_y = previous_y + (height / count);
#line 729 "../src/applets/icon-tasklist/IconButton.vala"
								previous_y = indicator_y;
#line 730 "../src/applets/icon-tasklist/IconButton.vala"
								indicator_y += spacing;
#line 3858 "IconButton.c"
							}
#line 732 "../src/applets/icon-tasklist/IconButton.vala"
							indicator_x = x + width;
#line 733 "../src/applets/icon-tasklist/IconButton.vala"
							break;
#line 3864 "IconButton.c"
						}
						default:
						{
#line 735 "../src/applets/icon-tasklist/IconButton.vala"
							break;
#line 3870 "IconButton.c"
						}
					}
#line 738 "../src/applets/icon-tasklist/IconButton.vala"
					cairo_set_line_width (cr, (gdouble) 6);
#line 739 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp29_ = self->priv->_desktop_helper;
#line 739 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp30_ = desktop_helper_get_active_window (_tmp29_);
#line 739 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp31_ = _tmp30_;
#line 739 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp32_ = window;
#line 739 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp33_ = _tmp31_ == _tmp32_;
#line 739 "../src/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (_tmp31_);
#line 739 "../src/applets/icon-tasklist/IconButton.vala"
					if (_tmp33_) {
#line 739 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp28_ = count > 1;
#line 3891 "IconButton.c"
					} else {
#line 739 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp28_ = FALSE;
#line 3895 "IconButton.c"
					}
#line 739 "../src/applets/icon-tasklist/IconButton.vala"
					if (_tmp28_) {
#line 3899 "IconButton.c"
						GdkRGBA col2 = {0};
						GdkRGBA _tmp34_;
						GtkStyleContext* _tmp35_;
						GdkRGBA _tmp36_ = {0};
						gboolean _tmp37_;
						GdkRGBA _tmp38_;
						GdkRGBA _tmp39_;
						GdkRGBA _tmp40_;
#line 740 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp34_ = col;
#line 740 "../src/applets/icon-tasklist/IconButton.vala"
						col2 = _tmp34_;
#line 741 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp35_ = context;
#line 741 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp37_ = gtk_style_context_lookup_color (_tmp35_, "budgie_tasklist_indicator_color_active_window", &_tmp36_);
#line 741 "../src/applets/icon-tasklist/IconButton.vala"
						col2 = _tmp36_;
#line 741 "../src/applets/icon-tasklist/IconButton.vala"
						if (!_tmp37_) {
#line 742 "../src/applets/icon-tasklist/IconButton.vala"
							gdk_rgba_parse (&col2, "#6BBFFF");
#line 3922 "IconButton.c"
						}
#line 744 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp38_ = col2;
#line 744 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp39_ = col2;
#line 744 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp40_ = col2;
#line 744 "../src/applets/icon-tasklist/IconButton.vala"
						cairo_set_source_rgba (cr, _tmp38_.red, _tmp39_.green, _tmp40_.blue, (gdouble) 1);
#line 3932 "IconButton.c"
					} else {
						GdkRGBA _tmp41_;
						GdkRGBA _tmp42_;
						GdkRGBA _tmp43_;
#line 746 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp41_ = col;
#line 746 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp42_ = col;
#line 746 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp43_ = col;
#line 746 "../src/applets/icon-tasklist/IconButton.vala"
						cairo_set_source_rgba (cr, _tmp41_.red, _tmp42_.green, _tmp43_.blue, (gdouble) 1);
#line 3945 "IconButton.c"
					}
#line 748 "../src/applets/icon-tasklist/IconButton.vala"
					cairo_move_to (cr, (gdouble) indicator_x, (gdouble) indicator_y);
#line 750 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp44_ = self->priv->_desktop_helper;
#line 750 "../src/applets/icon-tasklist/IconButton.vala"
					switch (_tmp44_->panel_position) {
#line 750 "../src/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_LEFT:
#line 750 "../src/applets/icon-tasklist/IconButton.vala"
						case BUDGIE_PANEL_POSITION_RIGHT:
#line 3957 "IconButton.c"
						{
							gint to = 0;
#line 753 "../src/applets/icon-tasklist/IconButton.vala"
							to = 0;
#line 754 "../src/applets/icon-tasklist/IconButton.vala"
							if (counter == (count - 1)) {
#line 755 "../src/applets/icon-tasklist/IconButton.vala"
								to = y + height;
#line 3966 "IconButton.c"
							} else {
#line 757 "../src/applets/icon-tasklist/IconButton.vala"
								to = previous_y + (height / count);
#line 3970 "IconButton.c"
							}
#line 759 "../src/applets/icon-tasklist/IconButton.vala"
							cairo_line_to (cr, (gdouble) indicator_x, (gdouble) to);
#line 760 "../src/applets/icon-tasklist/IconButton.vala"
							break;
#line 3976 "IconButton.c"
						}
						default:
						{
							gint to = 0;
#line 762 "../src/applets/icon-tasklist/IconButton.vala"
							to = 0;
#line 763 "../src/applets/icon-tasklist/IconButton.vala"
							if (counter == (count - 1)) {
#line 764 "../src/applets/icon-tasklist/IconButton.vala"
								to = x + width;
#line 3987 "IconButton.c"
							} else {
#line 766 "../src/applets/icon-tasklist/IconButton.vala"
								to = previous_x + (width / count);
#line 3991 "IconButton.c"
							}
#line 768 "../src/applets/icon-tasklist/IconButton.vala"
							cairo_line_to (cr, (gdouble) to, (gdouble) indicator_y);
#line 769 "../src/applets/icon-tasklist/IconButton.vala"
							break;
#line 3997 "IconButton.c"
						}
					}
#line 772 "../src/applets/icon-tasklist/IconButton.vala"
					cairo_stroke (cr);
#line 773 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp45_ = counter;
#line 773 "../src/applets/icon-tasklist/IconButton.vala"
					counter = _tmp45_ + 1;
#line 4006 "IconButton.c"
				}
#line 689 "../src/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (window);
#line 4010 "IconButton.c"
			}
		}
	}
#line 777 "../src/applets/icon-tasklist/IconButton.vala"
	result = GTK_WIDGET_CLASS (icon_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), cr);
#line 777 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (context);
#line 777 "../src/applets/icon-tasklist/IconButton.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 777 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 4022 "IconButton.c"
}

void
icon_button_on_size_allocate (IconButton* self,
                              GtkAllocation* allocation)
{
	GtkAllocation _tmp0_;
	GtkAllocation _tmp1_;
	gint x = 0;
	gint y = 0;
	GtkWidget* toplevel = NULL;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	GtkWidget* _tmp11_;
	GdkWindow* _tmp12_;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	BudgieAbominationAppGroup* _tmp15_;
#line 780 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 780 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (allocation != NULL);
#line 781 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = *allocation;
#line 781 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->definite_allocation = _tmp0_;
#line 783 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->definite_allocation;
#line 783 "../src/applets/icon-tasklist/IconButton.vala"
	GTK_WIDGET_CLASS (icon_button_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), &_tmp1_);
#line 786 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 786 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 786 "../src/applets/icon-tasklist/IconButton.vala"
	toplevel = _tmp3_;
#line 787 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp5_ = toplevel;
#line 787 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp5_ == NULL) {
#line 787 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = TRUE;
#line 4070 "IconButton.c"
	} else {
		GtkWidget* _tmp6_;
		GdkWindow* _tmp7_;
#line 787 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = toplevel;
#line 787 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = gtk_widget_get_window (_tmp6_);
#line 787 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = _tmp7_ == NULL;
#line 4080 "IconButton.c"
	}
#line 787 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp4_) {
#line 788 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (toplevel);
#line 788 "../src/applets/icon-tasklist/IconButton.vala"
		return;
#line 4088 "IconButton.c"
	}
#line 790 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp8_ = toplevel;
#line 790 "../src/applets/icon-tasklist/IconButton.vala"
	gtk_widget_translate_coordinates ((GtkWidget*) self, _tmp8_, 0, 0, &_tmp9_, &_tmp10_);
#line 790 "../src/applets/icon-tasklist/IconButton.vala"
	x = _tmp9_;
#line 790 "../src/applets/icon-tasklist/IconButton.vala"
	y = _tmp10_;
#line 791 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp11_ = toplevel;
#line 791 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp12_ = gtk_widget_get_window (_tmp11_);
#line 791 "../src/applets/icon-tasklist/IconButton.vala"
	gdk_window_get_root_coords (_tmp12_, x, y, &_tmp13_, &_tmp14_);
#line 791 "../src/applets/icon-tasklist/IconButton.vala"
	x = _tmp13_;
#line 791 "../src/applets/icon-tasklist/IconButton.vala"
	y = _tmp14_;
#line 793 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp15_ = self->priv->class_group;
#line 793 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp15_ != NULL) {
#line 4112 "IconButton.c"
		BudgieAbominationAppGroup* _tmp16_;
		GList* _tmp17_;
#line 794 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp16_ = self->priv->class_group;
#line 794 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp17_ = budgie_abomination_app_group_get_windows (_tmp16_);
#line 4119 "IconButton.c"
		{
			GList* win_collection = NULL;
			GList* win_it = NULL;
#line 794 "../src/applets/icon-tasklist/IconButton.vala"
			win_collection = _tmp17_;
#line 794 "../src/applets/icon-tasklist/IconButton.vala"
			for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 4127 "IconButton.c"
				WnckWindow* _tmp18_;
				WnckWindow* win = NULL;
#line 794 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp18_ = _g_object_ref0 ((WnckWindow*) win_it->data);
#line 794 "../src/applets/icon-tasklist/IconButton.vala"
				win = _tmp18_;
#line 4134 "IconButton.c"
				{
					WnckWindow* _tmp19_;
					GtkAllocation _tmp20_;
					GtkAllocation _tmp21_;
#line 795 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp19_ = win;
#line 795 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp20_ = self->priv->definite_allocation;
#line 795 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp21_ = self->priv->definite_allocation;
#line 795 "../src/applets/icon-tasklist/IconButton.vala"
					wnck_window_set_icon_geometry (_tmp19_, x, y, _tmp20_.width, _tmp21_.height);
#line 794 "../src/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (win);
#line 4149 "IconButton.c"
				}
			}
#line 794 "../src/applets/icon-tasklist/IconButton.vala"
			(win_collection == NULL) ? NULL : (win_collection = (g_list_free (win_collection), NULL));
#line 4154 "IconButton.c"
		}
	} else {
		WnckWindow* _tmp22_;
#line 797 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp22_ = self->priv->window;
#line 797 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp22_ != NULL) {
#line 4162 "IconButton.c"
			WnckWindow* _tmp23_;
			GtkAllocation _tmp24_;
			GtkAllocation _tmp25_;
#line 798 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp23_ = self->priv->window;
#line 798 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp24_ = self->priv->definite_allocation;
#line 798 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp25_ = self->priv->definite_allocation;
#line 798 "../src/applets/icon-tasklist/IconButton.vala"
			wnck_window_set_icon_geometry (_tmp23_, x, y, _tmp24_.width, _tmp25_.height);
#line 4174 "IconButton.c"
		}
	}
#line 780 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (toplevel);
#line 4179 "IconButton.c"
}

/**
 * set_app_for_class_group will set our AbominationApp for the first window in a given class group, if there is any
 */
static void
_____lambda42_ (IconButton* self)
{
#line 816 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_set_tooltip (self);
#line 4190 "IconButton.c"
}

static void
______lambda42__budgie_abomination_running_app_renamed_app (BudgieAbominationRunningApp* _sender,
                                                            const gchar* old_name,
                                                            const gchar* new_name,
                                                            gpointer self)
{
#line 815 "../src/applets/icon-tasklist/IconButton.vala"
	_____lambda42_ ((IconButton*) self);
#line 4201 "IconButton.c"
}

void
icon_button_set_app_for_class_group (IconButton* self)
{
	BudgieAbominationRunningApp* _tmp0_;
#line 805 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 806 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->first_app;
#line 806 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ == NULL) {
#line 4214 "IconButton.c"
		GList* class_windows = NULL;
		BudgieAbominationAppGroup* _tmp1_;
		GList* _tmp2_;
		GList* _tmp3_;
#line 807 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->class_group;
#line 807 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = budgie_abomination_app_group_get_windows (_tmp1_);
#line 807 "../src/applets/icon-tasklist/IconButton.vala"
		class_windows = _tmp2_;
#line 809 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = class_windows;
#line 809 "../src/applets/icon-tasklist/IconButton.vala"
		if (g_list_length (_tmp3_) != ((guint) 0)) {
#line 4229 "IconButton.c"
			WnckWindow* first_window = NULL;
			GList* _tmp4_;
			gconstpointer _tmp5_;
			WnckWindow* _tmp6_;
			WnckWindow* _tmp7_;
#line 810 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp4_ = class_windows;
#line 810 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp5_ = g_list_nth_data (_tmp4_, (guint) 0);
#line 810 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp6_ = _g_object_ref0 ((WnckWindow*) _tmp5_);
#line 810 "../src/applets/icon-tasklist/IconButton.vala"
			first_window = _tmp6_;
#line 812 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp7_ = first_window;
#line 812 "../src/applets/icon-tasklist/IconButton.vala"
			if (_tmp7_ != NULL) {
#line 4247 "IconButton.c"
				BudgieAbominationAbomination* _tmp8_;
				WnckWindow* _tmp9_;
				BudgieAbominationRunningApp* _tmp10_;
				BudgieAbominationRunningApp* _tmp11_;
				GDesktopAppInfo* _tmp12_;
#line 813 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp8_ = self->priv->_abomination;
#line 813 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp9_ = first_window;
#line 813 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp10_ = budgie_abomination_abomination_get_app_from_window_id (_tmp8_, wnck_window_get_xid (_tmp9_));
#line 813 "../src/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (self->first_app);
#line 813 "../src/applets/icon-tasklist/IconButton.vala"
				self->first_app = _tmp10_;
#line 815 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp11_ = self->first_app;
#line 815 "../src/applets/icon-tasklist/IconButton.vala"
				g_signal_connect_object (_tmp11_, "renamed-app", (GCallback) ______lambda42__budgie_abomination_running_app_renamed_app, self, 0);
#line 819 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp12_ = self->priv->app_info;
#line 819 "../src/applets/icon-tasklist/IconButton.vala"
				if (_tmp12_ == NULL) {
#line 4271 "IconButton.c"
					BudgieAbominationRunningApp* _tmp13_;
					GDesktopAppInfo* _tmp14_;
					GDesktopAppInfo* _tmp15_;
					GDesktopAppInfo* _tmp16_;
#line 820 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp13_ = self->first_app;
#line 820 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp14_ = budgie_abomination_running_app_get_app_info (_tmp13_);
#line 820 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp15_ = _tmp14_;
#line 820 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp16_ = _g_object_ref0 (_tmp15_);
#line 820 "../src/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (self->priv->app_info);
#line 820 "../src/applets/icon-tasklist/IconButton.vala"
					self->priv->app_info = _tmp16_;
#line 4288 "IconButton.c"
				}
			}
#line 809 "../src/applets/icon-tasklist/IconButton.vala"
			_g_object_unref0 (first_window);
#line 4293 "IconButton.c"
		}
#line 806 "../src/applets/icon-tasklist/IconButton.vala"
		(class_windows == NULL) ? NULL : (class_windows = (g_list_free (class_windows), NULL));
#line 4297 "IconButton.c"
	}
}

/**
 * setup_popover_with_class will set up our popover with windows from the class
 */
static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
	return _data5_;
#line 4311 "IconButton.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 4321 "IconButton.c"
		IconButton* self;
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
		self = _data5_->self;
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (self);
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
		g_slice_free (Block5Data, _data5_);
#line 4329 "IconButton.c"
	}
}

static void
_______lambda43_ (Block5Data* _data5_)
{
	IconButton* self;
	gulong win_xid = 0UL;
	WnckWindow* _tmp0_;
	BudgieIconPopover* _tmp1_;
#line 843 "../src/applets/icon-tasklist/IconButton.vala"
	self = _data5_->self;
#line 844 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _data5_->window;
#line 844 "../src/applets/icon-tasklist/IconButton.vala"
	win_xid = wnck_window_get_xid (_tmp0_);
#line 845 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->popover;
#line 845 "../src/applets/icon-tasklist/IconButton.vala"
	budgie_icon_popover_rename_window (_tmp1_, win_xid);
#line 4350 "IconButton.c"
}

static void
________lambda43__wnck_window_name_changed (WnckWindow* _sender,
                                            gpointer self)
{
#line 843 "../src/applets/icon-tasklist/IconButton.vala"
	_______lambda43_ (self);
#line 4359 "IconButton.c"
}

static void
_______lambda44_ (Block5Data* _data5_)
{
	IconButton* self;
	WnckWindow* _tmp0_;
#line 848 "../src/applets/icon-tasklist/IconButton.vala"
	self = _data5_->self;
#line 849 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = _data5_->window;
#line 849 "../src/applets/icon-tasklist/IconButton.vala"
	if (wnck_window_needs_attention (_tmp0_)) {
#line 850 "../src/applets/icon-tasklist/IconButton.vala"
		icon_button_attention (self, TRUE);
#line 4375 "IconButton.c"
	}
}

static void
________lambda44__wnck_window_state_changed (WnckWindow* _sender,
                                             WnckWindowState changed_mask,
                                             WnckWindowState new_state,
                                             gpointer self)
{
#line 848 "../src/applets/icon-tasklist/IconButton.vala"
	_______lambda44_ (self);
#line 4387 "IconButton.c"
}

static void
icon_button_setup_popover_with_class (IconButton* self)
{
	BudgieAbominationRunningApp* _tmp0_;
	BudgieAbominationAppGroup* _tmp1_;
	GList* _tmp2_;
#line 830 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 831 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->first_app;
#line 831 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_ == NULL) {
#line 832 "../src/applets/icon-tasklist/IconButton.vala"
		icon_button_set_app_for_class_group (self);
#line 4404 "IconButton.c"
	}
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->class_group;
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = budgie_abomination_app_group_get_windows (_tmp1_);
#line 4410 "IconButton.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
		window_collection = _tmp2_;
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 4418 "IconButton.c"
			WnckWindow* window = NULL;
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
			window = (WnckWindow*) window_it->data;
#line 4422 "IconButton.c"
			{
				Block5Data* _data5_;
				WnckWindow* _tmp3_;
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
				_data5_ = g_slice_new0 (Block5Data);
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
				_data5_->_ref_count_ = 1;
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
				_data5_->self = g_object_ref (self);
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
				_data5_->window = window;
#line 836 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp3_ = _data5_->window;
#line 836 "../src/applets/icon-tasklist/IconButton.vala"
				if (_tmp3_ != NULL) {
#line 4438 "IconButton.c"
					BudgieAbominationAbomination* _tmp4_;
					WnckWindow* _tmp5_;
#line 837 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp4_ = self->priv->_abomination;
#line 837 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp5_ = _data5_->window;
#line 837 "../src/applets/icon-tasklist/IconButton.vala"
					if (!budgie_abomination_abomination_is_disallowed_window_type (_tmp4_, _tmp5_)) {
#line 4447 "IconButton.c"
						WnckWindow* _tmp6_;
#line 838 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp6_ = _data5_->window;
#line 838 "../src/applets/icon-tasklist/IconButton.vala"
						if (icon_button_should_add_window (self, _tmp6_)) {
#line 4453 "IconButton.c"
							gulong xid = 0UL;
							WnckWindow* _tmp7_;
							gchar* name = NULL;
							WnckWindow* _tmp8_;
							const gchar* _tmp9_;
							gchar* _tmp10_;
							BudgieIconPopover* _tmp11_;
							const gchar* _tmp12_;
							WnckWindow* _tmp13_;
							WnckWindow* _tmp14_;
#line 839 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp7_ = _data5_->window;
#line 839 "../src/applets/icon-tasklist/IconButton.vala"
							xid = wnck_window_get_xid (_tmp7_);
#line 840 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp8_ = _data5_->window;
#line 840 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp9_ = wnck_window_get_name (_tmp8_);
#line 840 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp10_ = g_strdup (_tmp9_);
#line 840 "../src/applets/icon-tasklist/IconButton.vala"
							name = _tmp10_;
#line 842 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp11_ = self->priv->popover;
#line 842 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp12_ = name;
#line 842 "../src/applets/icon-tasklist/IconButton.vala"
							budgie_icon_popover_add_window (_tmp11_, xid, _tmp12_);
#line 843 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp13_ = _data5_->window;
#line 843 "../src/applets/icon-tasklist/IconButton.vala"
							g_signal_connect_data (_tmp13_, "name-changed", (GCallback) ________lambda43__wnck_window_name_changed, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, G_CONNECT_AFTER);
#line 848 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp14_ = _data5_->window;
#line 848 "../src/applets/icon-tasklist/IconButton.vala"
							g_signal_connect_data (_tmp14_, "state-changed", (GCallback) ________lambda44__wnck_window_state_changed, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, G_CONNECT_AFTER);
#line 838 "../src/applets/icon-tasklist/IconButton.vala"
							_g_free0 (name);
#line 4492 "IconButton.c"
						}
					}
				}
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
				block5_data_unref (_data5_);
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
				_data5_ = NULL;
#line 4500 "IconButton.c"
			}
		}
#line 835 "../src/applets/icon-tasklist/IconButton.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 4505 "IconButton.c"
	}
}

static void
icon_button_real_get_preferred_width (GtkWidget* base,
                                      gint* min,
                                      gint* nat)
{
	IconButton * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
	DesktopHelper* _tmp0_;
#line 859 "../src/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) base;
#line 860 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_desktop_helper;
#line 860 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_->orientation == GTK_ORIENTATION_HORIZONTAL) {
#line 4524 "IconButton.c"
		DesktopHelper* _tmp1_;
#line 861 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->_desktop_helper;
#line 861 "../src/applets/icon-tasklist/IconButton.vala"
		_vala_nat = _tmp1_->panel_size;
#line 861 "../src/applets/icon-tasklist/IconButton.vala"
		_vala_min = _vala_nat;
#line 862 "../src/applets/icon-tasklist/IconButton.vala"
		if (min) {
#line 862 "../src/applets/icon-tasklist/IconButton.vala"
			*min = _vala_min;
#line 4536 "IconButton.c"
		}
#line 862 "../src/applets/icon-tasklist/IconButton.vala"
		if (nat) {
#line 862 "../src/applets/icon-tasklist/IconButton.vala"
			*nat = _vala_nat;
#line 4542 "IconButton.c"
		}
#line 862 "../src/applets/icon-tasklist/IconButton.vala"
		return;
#line 4546 "IconButton.c"
	} else {
		gint m = 0;
		gint n = 0;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
#line 865 "../src/applets/icon-tasklist/IconButton.vala"
		GTK_WIDGET_CLASS (icon_button_parent_class)->get_preferred_width ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), &_tmp2_, &_tmp3_);
#line 865 "../src/applets/icon-tasklist/IconButton.vala"
		m = _tmp2_;
#line 865 "../src/applets/icon-tasklist/IconButton.vala"
		n = _tmp3_;
#line 866 "../src/applets/icon-tasklist/IconButton.vala"
		_vala_min = m;
#line 867 "../src/applets/icon-tasklist/IconButton.vala"
		_vala_nat = n;
#line 4562 "IconButton.c"
	}
#line 859 "../src/applets/icon-tasklist/IconButton.vala"
	if (min) {
#line 859 "../src/applets/icon-tasklist/IconButton.vala"
		*min = _vala_min;
#line 4568 "IconButton.c"
	}
#line 859 "../src/applets/icon-tasklist/IconButton.vala"
	if (nat) {
#line 859 "../src/applets/icon-tasklist/IconButton.vala"
		*nat = _vala_nat;
#line 4574 "IconButton.c"
	}
}

static void
icon_button_real_get_preferred_height (GtkWidget* base,
                                       gint* min,
                                       gint* nat)
{
	IconButton * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
	DesktopHelper* _tmp0_;
#line 871 "../src/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) base;
#line 872 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_desktop_helper;
#line 872 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_->orientation == GTK_ORIENTATION_VERTICAL) {
#line 4593 "IconButton.c"
		DesktopHelper* _tmp1_;
#line 873 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp1_ = self->priv->_desktop_helper;
#line 873 "../src/applets/icon-tasklist/IconButton.vala"
		_vala_nat = _tmp1_->panel_size;
#line 873 "../src/applets/icon-tasklist/IconButton.vala"
		_vala_min = _vala_nat;
#line 4601 "IconButton.c"
	} else {
		gint m = 0;
		gint n = 0;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
#line 876 "../src/applets/icon-tasklist/IconButton.vala"
		GTK_WIDGET_CLASS (icon_button_parent_class)->get_preferred_height ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), &_tmp2_, &_tmp3_);
#line 876 "../src/applets/icon-tasklist/IconButton.vala"
		m = _tmp2_;
#line 876 "../src/applets/icon-tasklist/IconButton.vala"
		n = _tmp3_;
#line 877 "../src/applets/icon-tasklist/IconButton.vala"
		_vala_min = m;
#line 878 "../src/applets/icon-tasklist/IconButton.vala"
		_vala_nat = n;
#line 4617 "IconButton.c"
	}
#line 871 "../src/applets/icon-tasklist/IconButton.vala"
	if (min) {
#line 871 "../src/applets/icon-tasklist/IconButton.vala"
		*min = _vala_min;
#line 4623 "IconButton.c"
	}
#line 871 "../src/applets/icon-tasklist/IconButton.vala"
	if (nat) {
#line 871 "../src/applets/icon-tasklist/IconButton.vala"
		*nat = _vala_nat;
#line 4629 "IconButton.c"
	}
}

static gboolean
icon_button_real_button_press_event (GtkWidget* base,
                                     GdkEventButton* event)
{
	IconButton * self;
	gboolean was_double_click = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 882 "../src/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) base;
#line 882 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 883 "../src/applets/icon-tasklist/IconButton.vala"
	was_double_click = event->type == GDK_DOUBLE_BUTTON_PRESS;
#line 885 "../src/applets/icon-tasklist/IconButton.vala"
	if (!was_double_click) {
#line 885 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = TRUE;
#line 4651 "IconButton.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 885 "../src/applets/icon-tasklist/IconButton.vala"
		if (was_double_click) {
#line 885 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp1_ = event->button != ((guint) 1);
#line 4658 "IconButton.c"
		} else {
#line 885 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp1_ = FALSE;
#line 4662 "IconButton.c"
		}
#line 885 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = _tmp1_;
#line 4666 "IconButton.c"
	}
#line 885 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_) {
#line 886 "../src/applets/icon-tasklist/IconButton.vala"
		result = GDK_EVENT_PROPAGATE;
#line 886 "../src/applets/icon-tasklist/IconButton.vala"
		return result;
#line 4674 "IconButton.c"
	}
#line 889 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_handle_launch_clicks (self, event, TRUE);
#line 891 "../src/applets/icon-tasklist/IconButton.vala"
	result = GTK_WIDGET_CLASS (icon_button_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), event);
#line 891 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 4682 "IconButton.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
	if (length >= 0) {
#line 4691 "IconButton.c"
		gchar** result;
		gssize i;
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
		result = g_new0 (gchar*, length + 1);
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
		for (i = 0; i < length; i++) {
#line 4698 "IconButton.c"
			gchar* _tmp0_;
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp0_ = g_strdup (self[i]);
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
			result[i] = _tmp0_;
#line 4704 "IconButton.c"
		}
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
		return result;
#line 4708 "IconButton.c"
	}
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
	return NULL;
#line 4712 "IconButton.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 926 "../src/applets/icon-tasklist/IconButton.vala"
	for (i = 0; i < stack_length; i++) {
#line 926 "../src/applets/icon-tasklist/IconButton.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 926 "../src/applets/icon-tasklist/IconButton.vala"
			return TRUE;
#line 4727 "IconButton.c"
		}
	}
#line 926 "../src/applets/icon-tasklist/IconButton.vala"
	return FALSE;
#line 4732 "IconButton.c"
}

static gboolean
icon_button_real_button_release_event (GtkWidget* base,
                                       GdkEventButton* event)
{
	IconButton * self;
	gboolean _tmp0_ = FALSE;
	BudgieAbominationAppGroup* _tmp1_;
	gboolean result;
#line 894 "../src/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) base;
#line 894 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->class_group;
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp1_ != NULL) {
#line 4751 "IconButton.c"
		gboolean _tmp2_ = FALSE;
		WnckWindow* _tmp3_;
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = self->last_active_window;
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp3_ == NULL) {
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp2_ = TRUE;
#line 4760 "IconButton.c"
		} else {
			BudgieAbominationAppGroup* _tmp4_;
			GList* _tmp5_;
			GList* _tmp6_;
			WnckWindow* _tmp7_;
			GList* _tmp8_;
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp4_ = self->priv->class_group;
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp5_ = budgie_abomination_app_group_get_windows (_tmp4_);
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp6_ = _tmp5_;
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp7_ = self->last_active_window;
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp8_ = g_list_find (_tmp6_, _tmp7_);
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp2_ = _tmp8_ == NULL;
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
			(_tmp6_ == NULL) ? NULL : (_tmp6_ = (g_list_free (_tmp6_), NULL));
#line 4781 "IconButton.c"
		}
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = _tmp2_;
#line 4785 "IconButton.c"
	} else {
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = FALSE;
#line 4789 "IconButton.c"
	}
#line 895 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_) {
#line 4793 "IconButton.c"
		BudgieAbominationAppGroup* _tmp9_;
		GList* _tmp10_;
		GList* _tmp11_;
		gconstpointer _tmp12_;
		WnckWindow* _tmp13_;
#line 896 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp9_ = self->priv->class_group;
#line 896 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp10_ = budgie_abomination_app_group_get_windows (_tmp9_);
#line 896 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp11_ = _tmp10_;
#line 896 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp12_ = g_list_nth_data (_tmp11_, (guint) 0);
#line 896 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp13_ = _g_object_ref0 ((WnckWindow*) _tmp12_);
#line 896 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (self->last_active_window);
#line 896 "../src/applets/icon-tasklist/IconButton.vala"
		self->last_active_window = _tmp13_;
#line 896 "../src/applets/icon-tasklist/IconButton.vala"
		(_tmp11_ == NULL) ? NULL : (_tmp11_ = (g_list_free (_tmp11_), NULL));
#line 4815 "IconButton.c"
	}
#line 899 "../src/applets/icon-tasklist/IconButton.vala"
	if (event->button == ((guint) 3)) {
#line 4819 "IconButton.c"
		BudgieIconPopover* _tmp14_;
		BudgiePopoverManager* _tmp15_;
#line 900 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp14_ = self->priv->popover;
#line 900 "../src/applets/icon-tasklist/IconButton.vala"
		budgie_icon_popover_render (_tmp14_);
#line 901 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp15_ = self->priv->_popover_manager;
#line 901 "../src/applets/icon-tasklist/IconButton.vala"
		budgie_popover_manager_show_popover (_tmp15_, (GtkWidget*) self);
#line 902 "../src/applets/icon-tasklist/IconButton.vala"
		result = GDK_EVENT_STOP;
#line 902 "../src/applets/icon-tasklist/IconButton.vala"
		return result;
#line 4834 "IconButton.c"
	} else {
#line 903 "../src/applets/icon-tasklist/IconButton.vala"
		if (event->button == ((guint) 1)) {
#line 904 "../src/applets/icon-tasklist/IconButton.vala"
			icon_button_handle_launch_clicks (self, event, FALSE);
#line 4840 "IconButton.c"
		} else {
#line 905 "../src/applets/icon-tasklist/IconButton.vala"
			if (event->button == ((guint) 2)) {
#line 4844 "IconButton.c"
				GList* windows = NULL;
				gboolean middle_click_create_new_instance = FALSE;
				GSettings* _tmp16_;
#line 907 "../src/applets/icon-tasklist/IconButton.vala"
				middle_click_create_new_instance = FALSE;
#line 909 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp16_ = self->priv->settings;
#line 909 "../src/applets/icon-tasklist/IconButton.vala"
				if (_tmp16_ != NULL) {
#line 4854 "IconButton.c"
					GSettings* _tmp17_;
#line 910 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp17_ = self->priv->settings;
#line 910 "../src/applets/icon-tasklist/IconButton.vala"
					middle_click_create_new_instance = g_settings_get_boolean (_tmp17_, "middle-click-launch-new-instance");
#line 4860 "IconButton.c"
				}
#line 913 "../src/applets/icon-tasklist/IconButton.vala"
				if (middle_click_create_new_instance) {
#line 4864 "IconButton.c"
					BudgieAbominationAppGroup* _tmp18_;
					GList* _tmp22_;
#line 914 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp18_ = self->priv->class_group;
#line 914 "../src/applets/icon-tasklist/IconButton.vala"
					if (_tmp18_ != NULL) {
#line 4871 "IconButton.c"
						BudgieAbominationAppGroup* _tmp19_;
						GList* _tmp20_;
#line 915 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp19_ = self->priv->class_group;
#line 915 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp20_ = budgie_abomination_app_group_get_windows (_tmp19_);
#line 915 "../src/applets/icon-tasklist/IconButton.vala"
						(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 915 "../src/applets/icon-tasklist/IconButton.vala"
						windows = _tmp20_;
#line 4882 "IconButton.c"
					} else {
						WnckWindow* _tmp21_;
#line 917 "../src/applets/icon-tasklist/IconButton.vala"
						(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 917 "../src/applets/icon-tasklist/IconButton.vala"
						windows = NULL;
#line 918 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp21_ = self->priv->window;
#line 918 "../src/applets/icon-tasklist/IconButton.vala"
						windows = g_list_insert (windows, _tmp21_, 0);
#line 4893 "IconButton.c"
					}
#line 921 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp22_ = windows;
#line 921 "../src/applets/icon-tasklist/IconButton.vala"
					if (g_list_length (_tmp22_) == ((guint) 0)) {
#line 922 "../src/applets/icon-tasklist/IconButton.vala"
						icon_button_launch_app (self, gtk_get_current_event_time ());
#line 4901 "IconButton.c"
					} else {
						GDesktopAppInfo* _tmp23_;
#line 923 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp23_ = self->priv->app_info;
#line 923 "../src/applets/icon-tasklist/IconButton.vala"
						if (_tmp23_ != NULL) {
#line 4908 "IconButton.c"
							gchar** actions = NULL;
							GDesktopAppInfo* _tmp24_;
							gchar** _tmp25_;
							gchar** _tmp26_;
							gchar** _tmp27_;
							gint _tmp27__length1;
							gint actions_length1;
							gint _actions_size_;
							gchar** _tmp28_;
							gint _tmp28__length1;
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp24_ = self->priv->app_info;
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp26_ = _tmp25_ = g_desktop_app_info_list_actions (_tmp24_);
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp27_ = (_tmp26_ != NULL) ? _vala_array_dup1 (_tmp26_, _vala_array_length (_tmp25_)) : _tmp26_;
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp27__length1 = _vala_array_length (_tmp25_);
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
							actions = _tmp27_;
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
							actions_length1 = _tmp27__length1;
#line 924 "../src/applets/icon-tasklist/IconButton.vala"
							_actions_size_ = actions_length1;
#line 926 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp28_ = actions;
#line 926 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp28__length1 = actions_length1;
#line 926 "../src/applets/icon-tasklist/IconButton.vala"
							if (_vala_string_array_contains (_tmp28_, _tmp28__length1, "new-window")) {
#line 4939 "IconButton.c"
								GdkAppLaunchContext* _tmp29_;
								GdkScreen* _tmp30_;
								GdkAppLaunchContext* _tmp31_;
								GDesktopAppInfo* _tmp32_;
								GdkAppLaunchContext* _tmp33_;
#line 927 "../src/applets/icon-tasklist/IconButton.vala"
								_tmp29_ = self->priv->launch_context;
#line 927 "../src/applets/icon-tasklist/IconButton.vala"
								_tmp30_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 927 "../src/applets/icon-tasklist/IconButton.vala"
								gdk_app_launch_context_set_screen (_tmp29_, _tmp30_);
#line 928 "../src/applets/icon-tasklist/IconButton.vala"
								_tmp31_ = self->priv->launch_context;
#line 928 "../src/applets/icon-tasklist/IconButton.vala"
								gdk_app_launch_context_set_timestamp (_tmp31_, (guint32) GDK_CURRENT_TIME);
#line 929 "../src/applets/icon-tasklist/IconButton.vala"
								_tmp32_ = self->priv->app_info;
#line 929 "../src/applets/icon-tasklist/IconButton.vala"
								_tmp33_ = self->priv->launch_context;
#line 929 "../src/applets/icon-tasklist/IconButton.vala"
								g_desktop_app_info_launch_action (_tmp32_, "new-window", (GAppLaunchContext*) _tmp33_);
#line 4961 "IconButton.c"
							} else {
#line 931 "../src/applets/icon-tasklist/IconButton.vala"
								icon_button_launch_app (self, gtk_get_current_event_time ());
#line 4965 "IconButton.c"
							}
#line 923 "../src/applets/icon-tasklist/IconButton.vala"
							actions = (_vala_array_free (actions, actions_length1, (GDestroyNotify) g_free), NULL);
#line 4969 "IconButton.c"
						}
					}
				}
#line 905 "../src/applets/icon-tasklist/IconButton.vala"
				(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 4975 "IconButton.c"
			}
		}
	}
#line 937 "../src/applets/icon-tasklist/IconButton.vala"
	result = GTK_WIDGET_CLASS (icon_button_parent_class)->button_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_toggle_button_get_type (), GtkToggleButton), event);
#line 937 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 4983 "IconButton.c"
}

static GdkEventButton*
_vala_GdkEventButton_copy (GdkEventButton* self)
{
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	return g_boxed_copy (gdk_event_get_type (), self);
#line 4991 "IconButton.c"
}

static gpointer
__vala_GdkEventButton_copy0 (gpointer self)
{
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	return self ? _vala_GdkEventButton_copy (self) : NULL;
#line 4999 "IconButton.c"
}

static void
_vala_GdkEventButton_free (GdkEventButton* self)
{
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	g_boxed_free (gdk_event_get_type (), self);
#line 5007 "IconButton.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	return _data6_;
#line 5017 "IconButton.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 5027 "IconButton.c"
		IconButton* self;
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
		self = _data6_->self;
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
		__vala_GdkEventButton_free0 (_data6_->event);
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (self);
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
		g_slice_free (Block6Data, _data6_);
#line 5037 "IconButton.c"
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
	return _data7_;
#line 5048 "IconButton.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 5058 "IconButton.c"
		IconButton* self;
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
		self = _data7_->_data6_->self;
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
		block6_data_unref (_data7_->_data6_);
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
		_data7_->_data6_ = NULL;
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
		g_slice_free (Block7Data, _data7_);
#line 5068 "IconButton.c"
	}
}

static void
_____lambda45_ (Block7Data* _data7_,
                WnckWindow* w)
{
	Block6Data* _data6_;
	IconButton* self;
#line 987 "../src/applets/icon-tasklist/IconButton.vala"
	_data6_ = _data7_->_data6_;
#line 987 "../src/applets/icon-tasklist/IconButton.vala"
	self = _data6_->self;
#line 987 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (w != NULL);
#line 988 "../src/applets/icon-tasklist/IconButton.vala"
	if (_data7_->one_active) {
#line 989 "../src/applets/icon-tasklist/IconButton.vala"
		wnck_window_minimize (w);
#line 5088 "IconButton.c"
	} else {
#line 991 "../src/applets/icon-tasklist/IconButton.vala"
		wnck_window_unminimize (w, _data6_->event->time);
#line 992 "../src/applets/icon-tasklist/IconButton.vala"
		wnck_window_activate (w, _data6_->event->time);
#line 5094 "IconButton.c"
	}
}

static void
______lambda45__gfunc (gconstpointer data,
                       gpointer self)
{
#line 987 "../src/applets/icon-tasklist/IconButton.vala"
	_____lambda45_ (self, (WnckWindow*) data);
#line 5104 "IconButton.c"
}

static void
icon_button_handle_launch_clicks (IconButton* self,
                                  GdkEventButton* event,
                                  gboolean was_double_click)
{
	Block6Data* _data6_;
	GdkEventButton* _tmp0_;
	gboolean should_launch_app = FALSE;
	BudgieAbominationAppGroup* _tmp1_;
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (event != NULL);
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	_data6_->_ref_count_ = 1;
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	_data6_->self = g_object_ref (self);
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = __vala_GdkEventButton_copy0 (event);
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	__vala_GdkEventButton_free0 (_data6_->event);
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	_data6_->event = _tmp0_;
#line 941 "../src/applets/icon-tasklist/IconButton.vala"
	should_launch_app = FALSE;
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->class_group;
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp1_ != NULL) {
#line 5138 "IconButton.c"
		Block7Data* _data7_;
		WnckWorkspace* active_workspace = NULL;
		WnckScreen* _tmp2_;
		WnckWorkspace* _tmp3_;
		WnckWorkspace* _tmp4_;
		GList* list = NULL;
		GList* win_ids = NULL;
		BudgieIconPopover* _tmp5_;
		GHashTable* _tmp6_;
		GList* _tmp7_;
		GList* _tmp8_;
		GList* _tmp13_;
		guint len = 0U;
		GList* _tmp16_;
		gboolean show_all_windows_on_click = FALSE;
		GSettings* _tmp17_;
		gboolean _tmp19_ = FALSE;
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
		_data7_ = g_slice_new0 (Block7Data);
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
		_data7_->_ref_count_ = 1;
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
		_data7_->_data6_ = block6_data_ref (_data6_);
#line 944 "../src/applets/icon-tasklist/IconButton.vala"
		_data7_->one_active = FALSE;
#line 945 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp2_ = self->priv->screen;
#line 945 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = wnck_screen_get_active_workspace (_tmp2_);
#line 945 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 945 "../src/applets/icon-tasklist/IconButton.vala"
		active_workspace = _tmp4_;
#line 947 "../src/applets/icon-tasklist/IconButton.vala"
		list = NULL;
#line 948 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = self->priv->popover;
#line 948 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = _tmp5_->window_id_to_name;
#line 948 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = g_hash_table_get_keys (_tmp6_);
#line 948 "../src/applets/icon-tasklist/IconButton.vala"
		win_ids = _tmp7_;
#line 950 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp8_ = win_ids;
#line 5184 "IconButton.c"
		{
			GList* id_collection = NULL;
			GList* id_it = NULL;
#line 950 "../src/applets/icon-tasklist/IconButton.vala"
			id_collection = _tmp8_;
#line 950 "../src/applets/icon-tasklist/IconButton.vala"
			for (id_it = id_collection; id_it != NULL; id_it = id_it->next) {
#line 5192 "IconButton.c"
				gulong id = 0UL;
#line 950 "../src/applets/icon-tasklist/IconButton.vala"
				id = *((gulong*) id_it->data);
#line 5196 "IconButton.c"
				{
					WnckWindow* win = NULL;
					WnckWindow* _tmp9_;
					WnckWindow* _tmp10_;
					WnckWindow* _tmp11_;
					WnckWindow* _tmp12_;
#line 951 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp9_ = wnck_window_get (id);
#line 951 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp10_ = _g_object_ref0 (_tmp9_);
#line 951 "../src/applets/icon-tasklist/IconButton.vala"
					win = _tmp10_;
#line 953 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp11_ = win;
#line 953 "../src/applets/icon-tasklist/IconButton.vala"
					if (_tmp11_ == NULL) {
#line 954 "../src/applets/icon-tasklist/IconButton.vala"
						_g_object_unref0 (win);
#line 954 "../src/applets/icon-tasklist/IconButton.vala"
						continue;
#line 5217 "IconButton.c"
					}
#line 957 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp12_ = win;
#line 957 "../src/applets/icon-tasklist/IconButton.vala"
					list = g_list_append (list, _tmp12_);
#line 950 "../src/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (win);
#line 5225 "IconButton.c"
				}
			}
		}
#line 960 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp13_ = list;
#line 5231 "IconButton.c"
		{
			GList* win_collection = NULL;
			GList* win_it = NULL;
#line 960 "../src/applets/icon-tasklist/IconButton.vala"
			win_collection = _tmp13_;
#line 960 "../src/applets/icon-tasklist/IconButton.vala"
			for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
#line 5239 "IconButton.c"
				WnckWindow* _tmp14_;
				WnckWindow* win = NULL;
#line 960 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp14_ = _g_object_ref0 ((WnckWindow*) win_it->data);
#line 960 "../src/applets/icon-tasklist/IconButton.vala"
				win = _tmp14_;
#line 5246 "IconButton.c"
				{
					WnckWindow* _tmp15_;
#line 961 "../src/applets/icon-tasklist/IconButton.vala"
					_tmp15_ = win;
#line 961 "../src/applets/icon-tasklist/IconButton.vala"
					if (wnck_window_is_active (_tmp15_)) {
#line 962 "../src/applets/icon-tasklist/IconButton.vala"
						_data7_->one_active = TRUE;
#line 963 "../src/applets/icon-tasklist/IconButton.vala"
						_g_object_unref0 (win);
#line 963 "../src/applets/icon-tasklist/IconButton.vala"
						break;
#line 5259 "IconButton.c"
					}
#line 960 "../src/applets/icon-tasklist/IconButton.vala"
					_g_object_unref0 (win);
#line 5263 "IconButton.c"
				}
			}
		}
#line 967 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp16_ = list;
#line 967 "../src/applets/icon-tasklist/IconButton.vala"
		len = g_list_length (_tmp16_);
#line 969 "../src/applets/icon-tasklist/IconButton.vala"
		show_all_windows_on_click = FALSE;
#line 971 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp17_ = self->priv->settings;
#line 971 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp17_ != NULL) {
#line 5277 "IconButton.c"
			GSettings* _tmp18_;
#line 972 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp18_ = self->priv->settings;
#line 972 "../src/applets/icon-tasklist/IconButton.vala"
			show_all_windows_on_click = g_settings_get_boolean (_tmp18_, "show-all-windows-on-click");
#line 5283 "IconButton.c"
		}
#line 975 "../src/applets/icon-tasklist/IconButton.vala"
		if (len == ((guint) 1)) {
#line 975 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp19_ = TRUE;
#line 5289 "IconButton.c"
		} else {
			gboolean _tmp20_ = FALSE;
#line 975 "../src/applets/icon-tasklist/IconButton.vala"
			if (len > ((guint) 1)) {
#line 975 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp20_ = !show_all_windows_on_click;
#line 5296 "IconButton.c"
			} else {
#line 975 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp20_ = FALSE;
#line 5300 "IconButton.c"
			}
#line 975 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp19_ = _tmp20_;
#line 5304 "IconButton.c"
		}
#line 975 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp19_) {
#line 5308 "IconButton.c"
			WnckWindow* only_window = NULL;
			GList* _tmp21_;
			gconstpointer _tmp22_;
			WnckWindow* _tmp23_;
			WnckWindow* _tmp24_;
			WnckWorkspace* _tmp25_;
#line 976 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp21_ = list;
#line 976 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp22_ = g_list_nth_data (_tmp21_, (guint) 0);
#line 976 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp23_ = _g_object_ref0 ((WnckWindow*) _tmp22_);
#line 976 "../src/applets/icon-tasklist/IconButton.vala"
			only_window = _tmp23_;
#line 978 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp24_ = only_window;
#line 978 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp25_ = active_workspace;
#line 978 "../src/applets/icon-tasklist/IconButton.vala"
			if (!wnck_window_is_on_workspace (_tmp24_, _tmp25_)) {
#line 5329 "IconButton.c"
				WnckWorkspace* winspace = NULL;
				WnckWindow* _tmp26_;
				WnckWorkspace* _tmp27_;
				WnckWorkspace* _tmp28_;
				WnckWorkspace* _tmp29_;
				WnckWindow* _tmp30_;
				WnckWindow* _tmp31_;
#line 979 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp26_ = only_window;
#line 979 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp27_ = wnck_window_get_workspace (_tmp26_);
#line 979 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp28_ = _g_object_ref0 (_tmp27_);
#line 979 "../src/applets/icon-tasklist/IconButton.vala"
				winspace = _tmp28_;
#line 980 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp29_ = winspace;
#line 980 "../src/applets/icon-tasklist/IconButton.vala"
				wnck_workspace_activate (_tmp29_, _data6_->event->time);
#line 981 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp30_ = only_window;
#line 981 "../src/applets/icon-tasklist/IconButton.vala"
				wnck_window_activate (_tmp30_, _data6_->event->time);
#line 982 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp31_ = only_window;
#line 982 "../src/applets/icon-tasklist/IconButton.vala"
				wnck_window_unminimize (_tmp31_, _data6_->event->time);
#line 978 "../src/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (winspace);
#line 5359 "IconButton.c"
			} else {
				GList* _tmp32_;
				gconstpointer _tmp33_;
#line 984 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp32_ = list;
#line 984 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp33_ = g_list_nth_data (_tmp32_, (guint) 0);
#line 984 "../src/applets/icon-tasklist/IconButton.vala"
				icon_button_toggle_window_minstate (self, _data6_->event->time, (WnckWindow*) _tmp33_);
#line 5369 "IconButton.c"
			}
#line 975 "../src/applets/icon-tasklist/IconButton.vala"
			_g_object_unref0 (only_window);
#line 5373 "IconButton.c"
		} else {
			gboolean _tmp34_ = FALSE;
#line 986 "../src/applets/icon-tasklist/IconButton.vala"
			if (len > ((guint) 1)) {
#line 986 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp34_ = show_all_windows_on_click;
#line 5380 "IconButton.c"
			} else {
#line 986 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp34_ = FALSE;
#line 5384 "IconButton.c"
			}
#line 986 "../src/applets/icon-tasklist/IconButton.vala"
			if (_tmp34_) {
#line 5388 "IconButton.c"
				GList* _tmp35_;
#line 987 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp35_ = list;
#line 987 "../src/applets/icon-tasklist/IconButton.vala"
				g_list_foreach (_tmp35_, ______lambda45__gfunc, _data7_);
#line 5394 "IconButton.c"
			} else {
#line 996 "../src/applets/icon-tasklist/IconButton.vala"
				should_launch_app = TRUE;
#line 5398 "IconButton.c"
			}
		}
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
		(win_ids == NULL) ? NULL : (win_ids = (g_list_free (win_ids), NULL));
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
		(list == NULL) ? NULL : (list = (g_list_free (list), NULL));
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
		_g_object_unref0 (active_workspace);
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
		block7_data_unref (_data7_);
#line 943 "../src/applets/icon-tasklist/IconButton.vala"
		_data7_ = NULL;
#line 5411 "IconButton.c"
	} else {
		WnckWindow* _tmp36_;
#line 998 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp36_ = self->priv->window;
#line 998 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp36_ != NULL) {
#line 5418 "IconButton.c"
			WnckWindow* _tmp37_;
#line 999 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp37_ = self->priv->window;
#line 999 "../src/applets/icon-tasklist/IconButton.vala"
			if (wnck_window_is_active (_tmp37_)) {
#line 5424 "IconButton.c"
				WnckWindow* _tmp38_;
#line 1000 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp38_ = self->priv->window;
#line 1000 "../src/applets/icon-tasklist/IconButton.vala"
				wnck_window_minimize (_tmp38_);
#line 5430 "IconButton.c"
			} else {
				WnckWindow* _tmp39_;
				WnckWindow* _tmp40_;
#line 1002 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp39_ = self->priv->window;
#line 1002 "../src/applets/icon-tasklist/IconButton.vala"
				wnck_window_unminimize (_tmp39_, _data6_->event->time);
#line 1003 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp40_ = self->priv->window;
#line 1003 "../src/applets/icon-tasklist/IconButton.vala"
				wnck_window_activate (_tmp40_, _data6_->event->time);
#line 5442 "IconButton.c"
			}
		} else {
#line 1006 "../src/applets/icon-tasklist/IconButton.vala"
			should_launch_app = TRUE;
#line 5447 "IconButton.c"
		}
	}
#line 1009 "../src/applets/icon-tasklist/IconButton.vala"
	if (should_launch_app) {
#line 5452 "IconButton.c"
		gboolean require_double_click = FALSE;
		GSettings* _tmp41_;
		gboolean _tmp42_ = FALSE;
		gboolean _tmp43_ = FALSE;
#line 1010 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp41_ = self->priv->settings;
#line 1010 "../src/applets/icon-tasklist/IconButton.vala"
		require_double_click = g_settings_get_boolean (_tmp41_, "require-double-click-to-launch");
#line 1012 "../src/applets/icon-tasklist/IconButton.vala"
		if (was_double_click) {
#line 1012 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp43_ = require_double_click;
#line 5465 "IconButton.c"
		} else {
#line 1012 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp43_ = FALSE;
#line 5469 "IconButton.c"
		}
#line 1012 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp43_) {
#line 1012 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp42_ = TRUE;
#line 5475 "IconButton.c"
		} else {
#line 1012 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp42_ = !require_double_click;
#line 5479 "IconButton.c"
		}
#line 1012 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp42_) {
#line 1013 "../src/applets/icon-tasklist/IconButton.vala"
			icon_button_launch_app (self, _data6_->event->time);
#line 5485 "IconButton.c"
		}
	}
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	block6_data_unref (_data6_);
#line 940 "../src/applets/icon-tasklist/IconButton.vala"
	_data6_ = NULL;
#line 5492 "IconButton.c"
}

static gboolean
icon_button_real_scroll_event (GtkWidget* base,
                               GdkEventScroll* event)
{
	IconButton * self;
	gboolean _tmp0_ = FALSE;
	WnckWindow* target_window = NULL;
	WnckWindow* current_window = NULL;
	DesktopHelper* _tmp1_;
	WnckWindow* _tmp2_;
	gboolean have_current_window = FALSE;
	WnckWindow* _tmp3_;
	BudgieAbominationAppGroup* _tmp4_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	BudgieAbominationAppGroup* _tmp31_;
	gboolean result;
#line 1018 "../src/applets/icon-tasklist/IconButton.vala"
	self = (IconButton*) base;
#line 1018 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1019 "../src/applets/icon-tasklist/IconButton.vala"
	if (event->direction >= 4) {
#line 1019 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = TRUE;
#line 5521 "IconButton.c"
	} else {
#line 1019 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp0_ = (g_get_monotonic_time () - self->priv->last_scroll_time) < ((gint64) 300000);
#line 5525 "IconButton.c"
	}
#line 1019 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp0_) {
#line 1020 "../src/applets/icon-tasklist/IconButton.vala"
		result = GDK_EVENT_STOP;
#line 1020 "../src/applets/icon-tasklist/IconButton.vala"
		return result;
#line 5533 "IconButton.c"
	}
#line 1023 "../src/applets/icon-tasklist/IconButton.vala"
	target_window = NULL;
#line 1025 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = self->priv->_desktop_helper;
#line 1025 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = desktop_helper_get_active_window (_tmp1_);
#line 1025 "../src/applets/icon-tasklist/IconButton.vala"
	current_window = _tmp2_;
#line 1026 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp3_ = current_window;
#line 1026 "../src/applets/icon-tasklist/IconButton.vala"
	have_current_window = _tmp3_ != NULL;
#line 1028 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = self->priv->class_group;
#line 1028 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp4_ != NULL) {
#line 5551 "IconButton.c"
		GList* windows = NULL;
		BudgieAbominationAppGroup* _tmp5_;
		GList* _tmp6_;
		guint windows_length = 0U;
		GList* _tmp7_;
#line 1029 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = self->priv->class_group;
#line 1029 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = budgie_abomination_app_group_get_windows (_tmp5_);
#line 1029 "../src/applets/icon-tasklist/IconButton.vala"
		windows = _tmp6_;
#line 1030 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp7_ = windows;
#line 1030 "../src/applets/icon-tasklist/IconButton.vala"
		windows_length = g_list_length (_tmp7_);
#line 1032 "../src/applets/icon-tasklist/IconButton.vala"
		if (windows_length > ((guint) 1)) {
#line 5569 "IconButton.c"
			gulong _tmp8_ = 0UL;
			gulong win_id = 0UL;
			gint current_window_position = 0;
			gint _tmp16_ = 0;
			gint incr_index = 0;
			gulong new_window_id = 0UL;
			GList* _tmp17_;
			gconstpointer _tmp18_;
#line 1033 "../src/applets/icon-tasklist/IconButton.vala"
			if (event->direction != GDK_SCROLL_UP) {
#line 1034 "../src/applets/icon-tasklist/IconButton.vala"
				windows = g_list_reverse (windows);
#line 5582 "IconButton.c"
			}
#line 1037 "../src/applets/icon-tasklist/IconButton.vala"
			if (have_current_window) {
#line 5586 "IconButton.c"
				WnckWindow* _tmp9_;
#line 1037 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp9_ = current_window;
#line 1037 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp8_ = wnck_window_get_xid (_tmp9_);
#line 5592 "IconButton.c"
			} else {
#line 1037 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp8_ = (gulong) 0;
#line 5596 "IconButton.c"
			}
#line 1037 "../src/applets/icon-tasklist/IconButton.vala"
			win_id = _tmp8_;
#line 1038 "../src/applets/icon-tasklist/IconButton.vala"
			current_window_position = 0;
#line 1040 "../src/applets/icon-tasklist/IconButton.vala"
			if (have_current_window) {
#line 5604 "IconButton.c"
				{
					gint current_id_index = 0;
#line 1041 "../src/applets/icon-tasklist/IconButton.vala"
					current_id_index = 0;
#line 5609 "IconButton.c"
					{
						gboolean _tmp10_ = FALSE;
#line 1041 "../src/applets/icon-tasklist/IconButton.vala"
						_tmp10_ = TRUE;
#line 1041 "../src/applets/icon-tasklist/IconButton.vala"
						while (TRUE) {
#line 5616 "IconButton.c"
							WnckWindow* window = NULL;
							GList* _tmp12_;
							gconstpointer _tmp13_;
							WnckWindow* _tmp14_;
							WnckWindow* _tmp15_;
#line 1041 "../src/applets/icon-tasklist/IconButton.vala"
							if (!_tmp10_) {
#line 5624 "IconButton.c"
								gint _tmp11_;
#line 1041 "../src/applets/icon-tasklist/IconButton.vala"
								_tmp11_ = current_id_index;
#line 1041 "../src/applets/icon-tasklist/IconButton.vala"
								current_id_index = _tmp11_ + 1;
#line 5630 "IconButton.c"
							}
#line 1041 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp10_ = FALSE;
#line 1041 "../src/applets/icon-tasklist/IconButton.vala"
							if (!(((guint) current_id_index) < windows_length)) {
#line 1041 "../src/applets/icon-tasklist/IconButton.vala"
								break;
#line 5638 "IconButton.c"
							}
#line 1042 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp12_ = windows;
#line 1042 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp13_ = g_list_nth_data (_tmp12_, (guint) current_id_index);
#line 1042 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp14_ = _g_object_ref0 ((WnckWindow*) _tmp13_);
#line 1042 "../src/applets/icon-tasklist/IconButton.vala"
							window = _tmp14_;
#line 1043 "../src/applets/icon-tasklist/IconButton.vala"
							_tmp15_ = window;
#line 1043 "../src/applets/icon-tasklist/IconButton.vala"
							if (win_id == wnck_window_get_xid (_tmp15_)) {
#line 1044 "../src/applets/icon-tasklist/IconButton.vala"
								current_window_position = current_id_index;
#line 1045 "../src/applets/icon-tasklist/IconButton.vala"
								_g_object_unref0 (window);
#line 1045 "../src/applets/icon-tasklist/IconButton.vala"
								break;
#line 5658 "IconButton.c"
							}
#line 1041 "../src/applets/icon-tasklist/IconButton.vala"
							_g_object_unref0 (window);
#line 5662 "IconButton.c"
						}
					}
				}
			}
#line 1050 "../src/applets/icon-tasklist/IconButton.vala"
			if (have_current_window) {
#line 1050 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp16_ = current_window_position + 1;
#line 5671 "IconButton.c"
			} else {
#line 1050 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp16_ = 0;
#line 5675 "IconButton.c"
			}
#line 1050 "../src/applets/icon-tasklist/IconButton.vala"
			incr_index = _tmp16_;
#line 1051 "../src/applets/icon-tasklist/IconButton.vala"
			if (((guint) incr_index) == windows_length) {
#line 1052 "../src/applets/icon-tasklist/IconButton.vala"
				incr_index = 0;
#line 5683 "IconButton.c"
			}
#line 1055 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp17_ = windows;
#line 1055 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp18_ = g_list_nth_data (_tmp17_, (guint) incr_index);
#line 1055 "../src/applets/icon-tasklist/IconButton.vala"
			new_window_id = wnck_window_get_xid ((WnckWindow*) _tmp18_);
#line 1056 "../src/applets/icon-tasklist/IconButton.vala"
			if (new_window_id >= ((gulong) 0)) {
#line 5693 "IconButton.c"
				WnckWindow* _tmp19_;
				WnckWindow* _tmp20_;
#line 1057 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp19_ = wnck_window_get (new_window_id);
#line 1057 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp20_ = _g_object_ref0 (_tmp19_);
#line 1057 "../src/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (target_window);
#line 1057 "../src/applets/icon-tasklist/IconButton.vala"
				target_window = _tmp20_;
#line 5704 "IconButton.c"
			}
		} else {
#line 1059 "../src/applets/icon-tasklist/IconButton.vala"
			if (windows_length == ((guint) 1)) {
#line 5709 "IconButton.c"
				gulong id = 0UL;
				GList* _tmp21_;
				gconstpointer _tmp22_;
				WnckWindow* _tmp23_;
				WnckWindow* _tmp24_;
#line 1060 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp21_ = windows;
#line 1060 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp22_ = g_list_nth_data (_tmp21_, (guint) 0);
#line 1060 "../src/applets/icon-tasklist/IconButton.vala"
				id = wnck_window_get_xid ((WnckWindow*) _tmp22_);
#line 1061 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp23_ = wnck_window_get (id);
#line 1061 "../src/applets/icon-tasklist/IconButton.vala"
				_tmp24_ = _g_object_ref0 (_tmp23_);
#line 1061 "../src/applets/icon-tasklist/IconButton.vala"
				_g_object_unref0 (target_window);
#line 1061 "../src/applets/icon-tasklist/IconButton.vala"
				target_window = _tmp24_;
#line 5729 "IconButton.c"
			}
		}
#line 1028 "../src/applets/icon-tasklist/IconButton.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 5734 "IconButton.c"
	} else {
		WnckWindow* _tmp25_;
#line 1063 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp25_ = self->priv->window;
#line 1063 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp25_ != NULL) {
#line 5741 "IconButton.c"
			WnckWindow* _tmp26_;
			WnckWindow* _tmp27_;
#line 1064 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp26_ = self->priv->window;
#line 1064 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp27_ = _g_object_ref0 (_tmp26_);
#line 1064 "../src/applets/icon-tasklist/IconButton.vala"
			_g_object_unref0 (target_window);
#line 1064 "../src/applets/icon-tasklist/IconButton.vala"
			target_window = _tmp27_;
#line 5752 "IconButton.c"
		}
	}
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp31_ = self->priv->class_group;
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp31_ == NULL) {
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp30_ = TRUE;
#line 5761 "IconButton.c"
	} else {
		BudgieAbominationAppGroup* _tmp32_;
		GList* _tmp33_;
		GList* _tmp34_;
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp32_ = self->priv->class_group;
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp33_ = budgie_abomination_app_group_get_windows (_tmp32_);
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp34_ = _tmp33_;
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp30_ = g_list_length (_tmp34_) == ((guint) 1);
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
		(_tmp34_ == NULL) ? NULL : (_tmp34_ = (g_list_free (_tmp34_), NULL));
#line 5776 "IconButton.c"
	}
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp30_) {
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp29_ = have_current_window;
#line 5782 "IconButton.c"
	} else {
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp29_ = FALSE;
#line 5786 "IconButton.c"
	}
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp29_) {
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp28_ = event->direction != GDK_SCROLL_UP;
#line 5792 "IconButton.c"
	} else {
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp28_ = FALSE;
#line 5796 "IconButton.c"
	}
#line 1067 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp28_) {
#line 5800 "IconButton.c"
		WnckWindow* _tmp35_;
#line 1068 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp35_ = target_window;
#line 1068 "../src/applets/icon-tasklist/IconButton.vala"
		wnck_window_minimize (_tmp35_);
#line 5806 "IconButton.c"
	} else {
		WnckWindow* _tmp36_;
#line 1069 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp36_ = target_window;
#line 1069 "../src/applets/icon-tasklist/IconButton.vala"
		if (_tmp36_ != NULL) {
#line 5813 "IconButton.c"
			WnckWindow* _tmp37_;
			WnckWindow* _tmp38_;
#line 1070 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp37_ = target_window;
#line 1070 "../src/applets/icon-tasklist/IconButton.vala"
			wnck_window_activate (_tmp37_, event->time);
#line 1071 "../src/applets/icon-tasklist/IconButton.vala"
			_tmp38_ = target_window;
#line 1071 "../src/applets/icon-tasklist/IconButton.vala"
			wnck_window_unminimize (_tmp38_, event->time);
#line 5824 "IconButton.c"
		}
	}
#line 1074 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->last_scroll_time = g_get_monotonic_time ();
#line 1076 "../src/applets/icon-tasklist/IconButton.vala"
	result = GDK_EVENT_STOP;
#line 1076 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (current_window);
#line 1076 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (target_window);
#line 1076 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 5837 "IconButton.c"
}

static void
icon_button_toggle_window_minstate (IconButton* self,
                                    guint32 time,
                                    WnckWindow* win)
{
	WnckWindow* current_active_window = NULL;
	WnckScreen* _tmp0_;
	WnckWindow* _tmp1_;
	WnckWindow* _tmp2_;
	gulong _tmp3_ = 0UL;
	WnckWindow* _tmp4_;
	gboolean is_current_active_window = FALSE;
	gboolean _tmp6_ = FALSE;
#line 1080 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 1080 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (win != NULL);
#line 1081 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = wnck_window_get_screen (win);
#line 1081 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = wnck_screen_get_active_window (_tmp0_);
#line 1081 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1081 "../src/applets/icon-tasklist/IconButton.vala"
	current_active_window = _tmp2_;
#line 1082 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp4_ = current_active_window;
#line 1082 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp4_ != NULL) {
#line 5869 "IconButton.c"
		WnckWindow* _tmp5_;
#line 1082 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp5_ = current_active_window;
#line 1082 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = wnck_window_get_xid (_tmp5_);
#line 5875 "IconButton.c"
	} else {
#line 1082 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp3_ = (gulong) 0;
#line 5879 "IconButton.c"
	}
#line 1082 "../src/applets/icon-tasklist/IconButton.vala"
	is_current_active_window = wnck_window_get_xid (win) == _tmp3_;
#line 1084 "../src/applets/icon-tasklist/IconButton.vala"
	if (wnck_window_is_minimized (win)) {
#line 1084 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = TRUE;
#line 5887 "IconButton.c"
	} else {
#line 1084 "../src/applets/icon-tasklist/IconButton.vala"
		_tmp6_ = !is_current_active_window;
#line 5891 "IconButton.c"
	}
#line 1084 "../src/applets/icon-tasklist/IconButton.vala"
	if (_tmp6_) {
#line 1085 "../src/applets/icon-tasklist/IconButton.vala"
		wnck_window_activate (win, time);
#line 1086 "../src/applets/icon-tasklist/IconButton.vala"
		wnck_window_unminimize (win, time);
#line 5899 "IconButton.c"
	} else {
#line 1088 "../src/applets/icon-tasklist/IconButton.vala"
		wnck_window_minimize (win);
#line 5903 "IconButton.c"
	}
#line 1080 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (current_active_window);
#line 5907 "IconButton.c"
}

GDesktopAppInfo*
icon_button_get_appinfo (IconButton* self)
{
	GDesktopAppInfo* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* result;
#line 1092 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1093 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->app_info;
#line 1093 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1093 "../src/applets/icon-tasklist/IconButton.vala"
	result = _tmp1_;
#line 1093 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 5926 "IconButton.c"
}

BudgieAbominationAppGroup*
icon_button_get_class_group (IconButton* self)
{
	BudgieAbominationAppGroup* _tmp0_;
	BudgieAbominationAppGroup* result;
#line 1096 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1097 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->class_group;
#line 1097 "../src/applets/icon-tasklist/IconButton.vala"
	result = _tmp0_;
#line 1097 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 5942 "IconButton.c"
}

BudgieAbominationAbomination*
icon_button_get_abomination (IconButton* self)
{
	BudgieAbominationAbomination* result;
	BudgieAbominationAbomination* _tmp0_;
#line 42 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_abomination;
#line 42 "../src/applets/icon-tasklist/IconButton.vala"
	result = _tmp0_;
#line 42 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 5958 "IconButton.c"
}

void
icon_button_set_abomination (IconButton* self,
                             BudgieAbominationAbomination* value)
{
	BudgieAbominationAbomination* old_value;
#line 42 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/applets/icon-tasklist/IconButton.vala"
	old_value = icon_button_get_abomination (self);
#line 42 "../src/applets/icon-tasklist/IconButton.vala"
	if (old_value != value) {
#line 42 "../src/applets/icon-tasklist/IconButton.vala"
		self->priv->_abomination = value;
#line 42 "../src/applets/icon-tasklist/IconButton.vala"
		g_object_notify_by_pspec ((GObject *) self, icon_button_properties[ICON_BUTTON_ABOMINATION_PROPERTY]);
#line 5976 "IconButton.c"
	}
}

BudgieAppSystem*
icon_button_get_app_system (IconButton* self)
{
	BudgieAppSystem* result;
	BudgieAppSystem* _tmp0_;
#line 43 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_app_system;
#line 43 "../src/applets/icon-tasklist/IconButton.vala"
	result = _tmp0_;
#line 43 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 5993 "IconButton.c"
}

void
icon_button_set_app_system (IconButton* self,
                            BudgieAppSystem* value)
{
	BudgieAppSystem* old_value;
#line 43 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/applets/icon-tasklist/IconButton.vala"
	old_value = icon_button_get_app_system (self);
#line 43 "../src/applets/icon-tasklist/IconButton.vala"
	if (old_value != value) {
#line 43 "../src/applets/icon-tasklist/IconButton.vala"
		self->priv->_app_system = value;
#line 43 "../src/applets/icon-tasklist/IconButton.vala"
		g_object_notify_by_pspec ((GObject *) self, icon_button_properties[ICON_BUTTON_APP_SYSTEM_PROPERTY]);
#line 6011 "IconButton.c"
	}
}

DesktopHelper*
icon_button_get_desktop_helper (IconButton* self)
{
	DesktopHelper* result;
	DesktopHelper* _tmp0_;
#line 44 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_desktop_helper;
#line 44 "../src/applets/icon-tasklist/IconButton.vala"
	result = _tmp0_;
#line 44 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 6028 "IconButton.c"
}

void
icon_button_set_desktop_helper (IconButton* self,
                                DesktopHelper* value)
{
	DesktopHelper* old_value;
#line 44 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/applets/icon-tasklist/IconButton.vala"
	old_value = icon_button_get_desktop_helper (self);
#line 44 "../src/applets/icon-tasklist/IconButton.vala"
	if (old_value != value) {
#line 44 "../src/applets/icon-tasklist/IconButton.vala"
		self->priv->_desktop_helper = value;
#line 44 "../src/applets/icon-tasklist/IconButton.vala"
		g_object_notify_by_pspec ((GObject *) self, icon_button_properties[ICON_BUTTON_DESKTOP_HELPER_PROPERTY]);
#line 6046 "IconButton.c"
	}
}

BudgiePopoverManager*
icon_button_get_popover_manager (IconButton* self)
{
	BudgiePopoverManager* result;
	BudgiePopoverManager* _tmp0_;
#line 45 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/applets/icon-tasklist/IconButton.vala"
	_tmp0_ = self->priv->_popover_manager;
#line 45 "../src/applets/icon-tasklist/IconButton.vala"
	result = _tmp0_;
#line 45 "../src/applets/icon-tasklist/IconButton.vala"
	return result;
#line 6063 "IconButton.c"
}

void
icon_button_set_popover_manager (IconButton* self,
                                 BudgiePopoverManager* value)
{
	BudgiePopoverManager* old_value;
#line 45 "../src/applets/icon-tasklist/IconButton.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/applets/icon-tasklist/IconButton.vala"
	old_value = icon_button_get_popover_manager (self);
#line 45 "../src/applets/icon-tasklist/IconButton.vala"
	if (old_value != value) {
#line 45 "../src/applets/icon-tasklist/IconButton.vala"
		self->priv->_popover_manager = value;
#line 45 "../src/applets/icon-tasklist/IconButton.vala"
		g_object_notify_by_pspec ((GObject *) self, icon_button_properties[ICON_BUTTON_POPOVER_MANAGER_PROPERTY]);
#line 6081 "IconButton.c"
	}
}

static void
icon_button_class_init (IconButtonClass * klass,
                        gpointer klass_data)
{
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	g_type_class_adjust_private_offset (klass, &IconButton_private_offset);
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) icon_button_real_draw;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) icon_button_real_get_preferred_width;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) icon_button_real_get_preferred_height;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) icon_button_real_button_press_event;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) icon_button_real_button_release_event;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	((GtkWidgetClass *) klass)->scroll_event = (gboolean (*) (GtkWidget*, GdkEventScroll*)) icon_button_real_scroll_event;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_icon_button_get_property;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_icon_button_set_property;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	G_OBJECT_CLASS (klass)->finalize = icon_button_finalize;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BUTTON_ABOMINATION_PROPERTY, icon_button_properties[ICON_BUTTON_ABOMINATION_PROPERTY] = g_param_spec_object ("abomination", "abomination", "abomination", BUDGIE_ABOMINATION_TYPE_ABOMINATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BUTTON_APP_SYSTEM_PROPERTY, icon_button_properties[ICON_BUTTON_APP_SYSTEM_PROPERTY] = g_param_spec_object ("app-system", "app-system", "app-system", BUDGIE_TYPE_APP_SYSTEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BUTTON_DESKTOP_HELPER_PROPERTY, icon_button_properties[ICON_BUTTON_DESKTOP_HELPER_PROPERTY] = g_param_spec_object ("desktop-helper", "desktop-helper", "desktop-helper", TYPE_DESKTOP_HELPER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_BUTTON_POPOVER_MANAGER_PROPERTY, icon_button_properties[ICON_BUTTON_POPOVER_MANAGER_PROPERTY] = g_param_spec_object ("popover-manager", "popover-manager", "popover-manager", budgie_popover_manager_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 6119 "IconButton.c"
	/**
	 * Signals
	 */
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_signals[ICON_BUTTON_BECAME_EMPTY_SIGNAL] = g_signal_new ("became-empty", TYPE_ICON_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	icon_button_signals[ICON_BUTTON_PINNED_CHANGED_SIGNAL] = g_signal_new ("pinned-changed", TYPE_ICON_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 6127 "IconButton.c"
}

static void
icon_button_instance_init (IconButton * self,
                           gpointer klass)
{
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv = icon_button_get_instance_private (self);
#line 23 "../src/applets/icon-tasklist/IconButton.vala"
	self->first_app = NULL;
#line 25 "../src/applets/icon-tasklist/IconButton.vala"
	self->pinned = FALSE;
#line 26 "../src/applets/icon-tasklist/IconButton.vala"
	self->last_active_window = NULL;
#line 29 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->popover = NULL;
#line 30 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->screen = NULL;
#line 31 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->settings = NULL;
#line 32 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->window = NULL;
#line 33 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->class_group = NULL;
#line 34 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->app_info = NULL;
#line 35 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->window_count = 0;
#line 37 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->originally_pinned = FALSE;
#line 39 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->last_scroll_time = (gint64) 0;
#line 40 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->needs_attention = FALSE;
#line 42 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->_abomination = NULL;
#line 43 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->_app_system = NULL;
#line 44 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->_desktop_helper = NULL;
#line 45 "../src/applets/icon-tasklist/IconButton.vala"
	self->priv->_popover_manager = NULL;
#line 6170 "IconButton.c"
}

static void
icon_button_finalize (GObject * obj)
{
	IconButton * self;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_BUTTON, IconButton);
#line 23 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->first_app);
#line 24 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->icon);
#line 26 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->last_active_window);
#line 27 "../src/applets/icon-tasklist/IconButton.vala"
	_g_free0 (self->button_id);
#line 29 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->popover);
#line 30 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->screen);
#line 31 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->settings);
#line 32 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->window);
#line 33 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->class_group);
#line 34 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->app_info);
#line 38 "../src/applets/icon-tasklist/IconButton.vala"
	_g_object_unref0 (self->priv->launch_context);
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	G_OBJECT_CLASS (icon_button_parent_class)->finalize (obj);
#line 6203 "IconButton.c"
}

/**
 * IconButton provides the pretty IconTasklist button to house one or more
 * windows in a group, as well as selection capabilities, interaction, animations
 * and rendering of "dots" for the renderable windows.
 */
GType
icon_button_get_type (void)
{
	return icon_button_type_id;
}

GType
icon_button_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (IconButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconButton), 0, (GInstanceInitFunc) icon_button_instance_init, NULL };
	icon_button_type_id = g_type_module_register_type (module, gtk_toggle_button_get_type (), "IconButton", &g_define_type_info, 0);
	IconButton_private_offset = sizeof (IconButtonPrivate);
	return icon_button_type_id;
}

static void
_vala_icon_button_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	IconButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON_BUTTON, IconButton);
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	switch (property_id) {
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_ABOMINATION_PROPERTY:
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		g_value_set_object (value, icon_button_get_abomination (self));
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		break;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_APP_SYSTEM_PROPERTY:
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		g_value_set_object (value, icon_button_get_app_system (self));
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		break;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_DESKTOP_HELPER_PROPERTY:
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		g_value_set_object (value, icon_button_get_desktop_helper (self));
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		break;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_POPOVER_MANAGER_PROPERTY:
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		g_value_set_object (value, icon_button_get_popover_manager (self));
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		break;
#line 6260 "IconButton.c"
		default:
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		break;
#line 6266 "IconButton.c"
	}
}

static void
_vala_icon_button_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	IconButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON_BUTTON, IconButton);
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
	switch (property_id) {
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_ABOMINATION_PROPERTY:
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		icon_button_set_abomination (self, g_value_get_object (value));
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		break;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_APP_SYSTEM_PROPERTY:
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		icon_button_set_app_system (self, g_value_get_object (value));
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		break;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_DESKTOP_HELPER_PROPERTY:
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		icon_button_set_desktop_helper (self, g_value_get_object (value));
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		break;
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		case ICON_BUTTON_POPOVER_MANAGER_PROPERTY:
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		icon_button_set_popover_manager (self, g_value_get_object (value));
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		break;
#line 6304 "IconButton.c"
		default:
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/applets/icon-tasklist/IconButton.vala"
		break;
#line 6310 "IconButton.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

